"use strict";


var visibleQuestions = {
    grade: true,
    assessement: false,
    assessementText: false,
    initialManagement: false,
    result1: false,
    management1: false,
    result2: false,
    management2: false
};
var visibleSections = {
    section1: true,
    additional: false,
    firstStep: false,
    resultSection1: false,
    resultSection2: false
};
var inputs = {
    grade: null,
    assessement: null
};
var isAdditionalVisible = function () {
    return helpers_1.isAnswered(inputs.grade);
};
var isAssessmentTextVisible = function () {
    return isAdditionalVisible() && helpers_1.answerMatches(inputs.assessement, 'close');
};
var isFirstStepVisible = function () {
    return isAdditionalVisible();
};
var isResultSection1Visible = function () {
    return (helpers_1.answerMatches(inputs.grade, 'mild') ||
        helpers_1.answerMatches(inputs.grade, 'moderate'));
};
var isResultSection2Visible = function () {
    return (helpers_1.answerMatches(inputs.grade, 'severe') ||
        helpers_1.answerMatches(inputs.grade, 'lifeThreatening'));
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.assessement = isAdditionalVisible();
    visibleQuestions.assessementText = isAssessmentTextVisible();
    visibleQuestions.initialManagement = isFirstStepVisible();
    visibleQuestions.result1 = isResultSection1Visible();
    visibleQuestions.management1 = isResultSection1Visible();
    visibleQuestions.result2 = isResultSection2Visible();
    visibleQuestions.management2 = isResultSection2Visible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.additional = isAdditionalVisible();
    visibleSections.firstStep = isFirstStepVisible();
    visibleSections.resultSection1 = isResultSection1Visible();
    visibleSections.resultSection2 = isResultSection2Visible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return isAdditionalVisible();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: { number: result, range: result },
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
