"use strict";


var visibleQuestions = {
    grade: true,
    assessment: false,
    assessmentText: false,
    resultMild: false,
    mildManagement: false,
    resultModerate: false,
    moderateManagement: false,
    resultSevere: false,
    severeManagement: false,
    resultLifeThreatening: false,
    lifeThreateningManagement: false,
    additionalConsiderations: false
};
var visibleSections = {
    section1: true,
    additional: false,
    resultSection1: false,
    resultSection2: false,
    resultRange3: false,
    considerations: false
};
var inputs = {
    grade: null,
    assessment: null
};
var isAdditionalVisible = function () {
    return helpers_1.isAnswered(inputs.grade);
};
var isAssesmentTextVisible = function () {
    return isAdditionalVisible() && helpers_1.answerMatches(inputs.assessment, 'close');
};
var isResultSection1Visible = function () {
    return (helpers_1.answerMatches(inputs.grade, 'mild') ||
        helpers_1.answerMatches(inputs.grade, 'moderate'));
};
var isResultMildVisible = function () {
    return helpers_1.answerMatches(inputs.grade, 'mild');
};
var isResultModerateVisible = function () {
    return helpers_1.answerMatches(inputs.grade, 'moderate');
};
var isResultSection2Visible = function () {
    return helpers_1.answerMatches(inputs.grade, 'severe');
};
var isResultRange3Visible = function () {
    return helpers_1.answerMatches(inputs.grade, 'lifeThreatening');
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.assessment = isAdditionalVisible();
    visibleQuestions.assessmentText = isAssesmentTextVisible();
    visibleQuestions.resultMild = isResultMildVisible();
    visibleQuestions.mildManagement = isResultMildVisible();
    visibleQuestions.resultModerate = isResultModerateVisible();
    visibleQuestions.moderateManagement = isResultModerateVisible();
    visibleQuestions.resultSevere = isResultSection2Visible();
    visibleQuestions.severeManagement = isResultSection2Visible();
    visibleQuestions.resultLifeThreatening = isResultRange3Visible();
    visibleQuestions.lifeThreateningManagement = isResultRange3Visible();
    visibleQuestions.additionalConsiderations = isAdditionalVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.additional = isAdditionalVisible();
    visibleSections.resultSection1 = isResultSection1Visible();
    visibleSections.resultSection2 = isResultSection2Visible();
    visibleSections.resultRange3 = isResultRange3Visible();
    visibleSections.considerations = isAdditionalVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return isAdditionalVisible();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: { number: result, range: result },
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
