"use strict";


var visibleQuestions = {
    grade: true,
    mild: false,
    mildManagement: false,
    result13: false,
    moderate: false,
    moderateManagement: false,
    moderateAssessment: false,
    severe: false,
    severeManagement: false,
    result33: false
};
var visibleSections = {
    section1: true,
    resultSection1: false,
    additionalMild: false,
    resultSection2: false,
    additionalModerate: false,
    resultSection3: false,
    additionalSevere: false
};
var inputs = {
    grade: null
};
var isResultSection1Visible = function () {
    return helpers_1.answerMatches(inputs.grade, 'mild');
};
var isResultSection2Visible = function () {
    return helpers_1.answerMatches(inputs.grade, 'moderate');
};
var isResultSection3Visible = function () {
    return helpers_1.answerMatches(inputs.grade, 'severe');
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.mild = isResultSection1Visible();
    visibleQuestions.mildManagement = isResultSection1Visible();
    visibleQuestions.result13 = isResultSection1Visible();
    visibleQuestions.moderate = isResultSection2Visible();
    visibleQuestions.moderateManagement = isResultSection2Visible();
    visibleQuestions.moderateAssessment = isResultSection2Visible();
    visibleQuestions.severe = isResultSection3Visible();
    visibleQuestions.severeManagement = isResultSection3Visible();
    visibleQuestions.result33 = isResultSection3Visible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.resultSection1 = isResultSection1Visible();
    visibleSections.additionalMild = isResultSection1Visible();
    visibleSections.resultSection2 = isResultSection2Visible();
    visibleSections.additionalModerate = isResultSection2Visible();
    visibleSections.resultSection3 = isResultSection3Visible();
    visibleSections.additionalSevere = isResultSection3Visible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return (isResultSection1Visible() ||
        isResultSection2Visible() ||
        isResultSection3Visible());
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: { number: result, range: result },
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
