"use strict";


var visibleQuestions = {
    grade: true,
    assessment: false,
    assessmentText: false,
    mild: false,
    mildManagement: false,
    moderate: false,
    moderateManagement: false,
    severe: false,
    severeManagement: false
};
var visibleSections = {
    section1: true,
    additional: false,
    resultSection: false
};
var inputs = {
    grade: null,
    assessment: null
};
var isAdditionalVisible = function () {
    return helpers_1.isAnswered(inputs.grade);
};
var isAssesmentTextVisible = function () {
    return isAdditionalVisible() && helpers_1.answerMatches(inputs.assessment, 'close');
};
var isMildVisible = function () {
    return helpers_1.answerMatches(inputs.grade, 'mild');
};
var isModerateVisible = function () {
    return helpers_1.answerMatches(inputs.grade, 'moderate');
};
var isSevereVisible = function () {
    return helpers_1.answerMatches(inputs.grade, 'severe');
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.assessment = isAdditionalVisible();
    visibleQuestions.assessmentText = isAssesmentTextVisible();
    visibleQuestions.mild = isMildVisible();
    visibleQuestions.mildManagement = isMildVisible();
    visibleQuestions.moderate = isModerateVisible();
    visibleQuestions.moderateManagement = isModerateVisible();
    visibleQuestions.severe = isSevereVisible();
    visibleQuestions.severeManagement = isSevereVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.additional = isAdditionalVisible();
    visibleSections.resultSection = isAdditionalVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return isAdditionalVisible();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: { number: result, range: result },
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
