"use strict";


var visibleQuestions = {
    grade: true,
    mild: false,
    mildManagement: false,
    assessmentMild: false,
    escalation1: false,
    moderate: false,
    moderateManagement: false,
    assessmentModerate: false,
    escalation2: false,
    result311: false,
    result312: false,
    result313: false,
    escalation3: false,
    notImproved: false,
    notImprovedManagement: false,
    severe: false,
    severeManagement: false,
    result414: false,
    result413: false,
    escalation4: false,
    result511: false,
    end: false
};
var visibleSections = {
    section1: true,
    resultSection1: false,
    additionalMild: false,
    resultSection12: false,
    resultSection21: false,
    additionalModerate: false,
    resultSection22: false,
    resultSection31: false,
    resultSection32: false,
    resultSectionEscalation: false,
    resultSectionSevere: false,
    additionalSevere: false,
    resultSection42: false,
    resultSection5: false,
    resultSection6: false
};
var inputs = {
    grade: null,
    escalation1: null,
    escalation2: null,
    escalation3: null,
    escalation4: null
};
var isResultSection1Visible = function () {
    return helpers_1.answerMatches(inputs.grade, 'mild');
};
var isResultSection21Visible = function () {
    return helpers_1.answerMatches(inputs.grade, 'moderate');
};
var isResultSection31Visible = function () {
    return (helpers_1.answerMatches(inputs.escalation1, 'yes') ||
        helpers_1.answerMatches(inputs.escalation2, 'yes'));
};
var isResultSection32Visible = function () {
    return (helpers_1.answerMatches(inputs.escalation1, 'yes') ||
        helpers_1.answerMatches(inputs.escalation2, 'yes'));
};
var isResultSectionEscalationVisible = function () {
    return helpers_1.answerMatches(inputs.escalation3, 'yes');
};
var isResultSectionSevereVisible = function () {
    return helpers_1.answerMatches(inputs.grade, 'severe');
};
var isAdditionalSevereVisible = function () {
    return (helpers_1.answerMatches(inputs.grade, 'severe') ||
        helpers_1.answerMatches(inputs.escalation3, 'yes'));
};
var isResultSection42Visible = function () {
    return (helpers_1.answerMatches(inputs.grade, 'severe') ||
        helpers_1.answerMatches(inputs.escalation3, 'yes'));
};
var isResultSection5Visible = function () {
    return helpers_1.answerMatches(inputs.escalation4, 'yes');
};
var isResultSection6Visible = function () {
    return (helpers_1.answerMatches(inputs.escalation1, 'no') ||
        helpers_1.answerMatches(inputs.escalation2, 'no') ||
        helpers_1.answerMatches(inputs.escalation3, 'no') ||
        helpers_1.answerMatches(inputs.escalation4, 'no'));
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.mild = isResultSection1Visible();
    visibleQuestions.mildManagement = isResultSection1Visible();
    visibleQuestions.assessmentMild = isResultSection1Visible();
    visibleQuestions.escalation1 = isResultSection1Visible();
    visibleQuestions.moderate = isResultSection21Visible();
    visibleQuestions.moderateManagement = isResultSection21Visible();
    visibleQuestions.assessmentModerate = isResultSection21Visible();
    visibleQuestions.escalation2 = isResultSection21Visible();
    visibleQuestions.result311 = isResultSection31Visible();
    visibleQuestions.result312 = isResultSection31Visible();
    visibleQuestions.result313 = isResultSection31Visible();
    visibleQuestions.escalation3 = isResultSection32Visible();
    visibleQuestions.notImproved = isResultSectionEscalationVisible();
    visibleQuestions.notImprovedManagement = isResultSectionEscalationVisible();
    visibleQuestions.severe = isResultSectionSevereVisible();
    visibleQuestions.severeManagement = isResultSectionSevereVisible();
    visibleQuestions.result414 = isAdditionalSevereVisible();
    visibleQuestions.result413 = isAdditionalSevereVisible();
    visibleQuestions.escalation4 = isResultSection42Visible();
    visibleQuestions.result511 = isResultSection5Visible();
    visibleQuestions.end = isResultSection6Visible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.resultSection1 = isResultSection1Visible();
    visibleSections.additionalMild = isResultSection1Visible();
    visibleSections.resultSection12 = isResultSection1Visible();
    visibleSections.resultSection21 = isResultSection21Visible();
    visibleSections.additionalModerate = isResultSection21Visible();
    visibleSections.resultSection22 = isResultSection21Visible();
    visibleSections.resultSection31 = isResultSection31Visible();
    visibleSections.resultSection32 = isResultSection32Visible();
    visibleSections.resultSectionEscalation = isResultSectionEscalationVisible();
    visibleSections.resultSectionSevere = isResultSectionSevereVisible();
    visibleSections.additionalSevere = isAdditionalSevereVisible();
    visibleSections.resultSection42 = isResultSection42Visible();
    visibleSections.resultSection5 = isResultSection5Visible();
    visibleSections.resultSection6 = isResultSection6Visible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return helpers_1.isAnswered(inputs.grade);
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: { number: result, range: result },
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
