"use strict";


var visibleQuestions = {
    grade: true,
    assessment: false,
    assessmentText: false,
    discontinue: false,
    management: false,
    additionalConsiderations: false
};
var visibleSections = {
    section1: true,
    additional: false,
    resultSection1: false,
    considerations: false
};
var inputs = {
    grade: null,
    assessment: null
};
var isAdditionalVisible = function () {
    return helpers_1.isAnswered(inputs.grade);
};
var isAssesmentTextVisible = function () {
    return isAdditionalVisible() && helpers_1.answerMatches(inputs.assessment, 'close');
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.assessment = isAdditionalVisible();
    visibleQuestions.assessmentText = isAssesmentTextVisible();
    visibleQuestions.discontinue = isAdditionalVisible();
    visibleQuestions.management = isAdditionalVisible();
    visibleQuestions.additionalConsiderations = isAdditionalVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.additional = isAdditionalVisible();
    visibleSections.resultSection1 = isAdditionalVisible();
    visibleSections.considerations = isAdditionalVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return helpers_1.isAnswered(inputs.grade);
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: { number: result, range: result },
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
