"use strict";


var visibleQuestions = {
    grade: true,
    mild: false,
    mildManagement: false,
    initialReplacement: false,
    mildAssessment: false,
    patientEducation1: false,
    moderate: false,
    moderateManagement: false,
    steroids1: false,
    result213: false,
    patientEducation2: false,
    escalation1: false,
    severe: false,
    severeManagement: false,
    steroids2: false,
    result313: false,
    patientEducation3: false,
    result421: false
};
var visibleSections = {
    section1: true,
    resultSectionMild: false,
    additionalMild: false,
    resultSectionModerate: false,
    additionalModerate: false,
    section22: false,
    resultSectionSevere: false,
    additionalSevere: false,
    end: false
};
var inputs = {
    grade: null,
    escalation1: null
};
var isResultSectionMildVisible = function () {
    return helpers_1.answerMatches(inputs.grade, 'mild');
};
var isResultSectionModerateVisible = function () {
    return helpers_1.answerMatches(inputs.grade, 'moderate');
};
var isResultSectionSevereVisible = function () {
    return (helpers_1.answerMatches(inputs.grade, 'severe') ||
        helpers_1.answerMatches(inputs.escalation1, 'noImprovement'));
};
var isEndVisible = function () {
    return helpers_1.answerMatches(inputs.escalation1, 'improvement');
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.mild = isResultSectionMildVisible();
    visibleQuestions.mildManagement = isResultSectionMildVisible();
    visibleQuestions.initialReplacement = isResultSectionMildVisible();
    visibleQuestions.mildAssessment = isResultSectionMildVisible();
    visibleQuestions.patientEducation1 = isResultSectionMildVisible();
    visibleQuestions.moderate = isResultSectionModerateVisible();
    visibleQuestions.moderateManagement = isResultSectionModerateVisible();
    visibleQuestions.steroids1 = isResultSectionModerateVisible();
    visibleQuestions.result213 = isResultSectionModerateVisible();
    visibleQuestions.patientEducation2 = isResultSectionModerateVisible();
    visibleQuestions.escalation1 = isResultSectionModerateVisible();
    visibleQuestions.severe = isResultSectionSevereVisible();
    visibleQuestions.severeManagement = isResultSectionSevereVisible();
    visibleQuestions.steroids2 = isResultSectionSevereVisible();
    visibleQuestions.result313 = isResultSectionSevereVisible();
    visibleQuestions.patientEducation3 = isResultSectionSevereVisible();
    visibleQuestions.result421 = isEndVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.resultSectionMild = isResultSectionMildVisible();
    visibleSections.additionalMild = isResultSectionMildVisible();
    visibleSections.resultSectionModerate = isResultSectionModerateVisible();
    visibleSections.additionalModerate = isResultSectionModerateVisible();
    visibleSections.section22 = isResultSectionModerateVisible();
    visibleSections.resultSectionSevere = isResultSectionSevereVisible();
    visibleSections.additionalSevere = isResultSectionSevereVisible();
    visibleSections.end = isEndVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return helpers_1.isAnswered(inputs.grade);
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: { number: result, range: result },
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
