"use strict";


var visibleQuestions = {
    grade: true,
    mild: false,
    mildManagement: false,
    result113: false,
    escalation1: false,
    moderate: false,
    moderateManagement: false,
    moderateAssessment: false,
    steroidWean1: false,
    severe: false,
    severeManagement: false,
    severeAssessment: false,
    steroidWean2: false,
    lifeThreatening: false,
    lifeThreateningManagement: false,
    lifeThreateningAssessment: false,
    result43: false,
    end: false
};
var visibleSections = {
    section1: true,
    resultSection1: false,
    additionalMild: false,
    resultSection12: false,
    resultSection2: false,
    additionalModerate: false,
    resultSection3: false,
    additionalSevere: false,
    resultSection4: false,
    additionalLifeThreatening: false,
    resultSection5: false
};
var inputs = {
    grade: null,
    escalation1: null
};
var isResultSection1Visible = function () {
    return helpers_1.answerMatches(inputs.grade, 'mild');
};
var isResultSection2Visible = function () {
    return (helpers_1.answerMatches(inputs.grade, 'moderate') ||
        helpers_1.answerMatches(inputs.escalation1, 'grade2'));
};
var isResultSection3Visible = function () {
    return (helpers_1.answerMatches(inputs.grade, 'severe') ||
        helpers_1.answerMatches(inputs.escalation1, 'grade3'));
};
var isResultSection4Visible = function () {
    return helpers_1.answerMatches(inputs.grade, 'lifeThreatening');
};
var isResultSection5Visible = function () {
    return helpers_1.answerMatches(inputs.escalation1, 'no');
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.mild = isResultSection1Visible();
    visibleQuestions.mildManagement = isResultSection1Visible();
    visibleQuestions.result113 = isResultSection1Visible();
    visibleQuestions.escalation1 = isResultSection1Visible();
    visibleQuestions.moderate = isResultSection2Visible();
    visibleQuestions.moderateManagement = isResultSection2Visible();
    visibleQuestions.moderateAssessment = isResultSection2Visible();
    visibleQuestions.steroidWean1 = isResultSection2Visible();
    visibleQuestions.severe = isResultSection3Visible();
    visibleQuestions.severeManagement = isResultSection3Visible();
    visibleQuestions.severeAssessment = isResultSection3Visible();
    visibleQuestions.steroidWean2 = isResultSection3Visible();
    visibleQuestions.lifeThreatening = isResultSection4Visible();
    visibleQuestions.lifeThreateningManagement = isResultSection4Visible();
    visibleQuestions.lifeThreateningAssessment = isResultSection4Visible();
    visibleQuestions.result43 = isResultSection4Visible();
    visibleQuestions.end = isResultSection5Visible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.resultSection1 = isResultSection1Visible();
    visibleSections.additionalMild = isResultSection1Visible();
    visibleSections.resultSection12 = isResultSection1Visible();
    visibleSections.resultSection2 = isResultSection2Visible();
    visibleSections.additionalModerate = isResultSection2Visible();
    visibleSections.resultSection3 = isResultSection3Visible();
    visibleSections.additionalSevere = isResultSection3Visible();
    visibleSections.resultSection4 = isResultSection4Visible();
    visibleSections.additionalLifeThreatening = isResultSection4Visible();
    visibleSections.resultSection5 = isResultSection5Visible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return helpers_1.isAnswered(inputs.grade);
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: { number: result, range: result },
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
