"use strict";


var visibleQuestions = {
    grade: true,
    mild: false,
    mildManagement: false,
    moderate: false,
    moderateManagement: false,
    severe: false,
    severeManagement: false,
    mildAssessment: false,
    moderateAssessment: false,
    severeAssessment: false
};
var visibleSections = {
    section1: true,
    resultSection: false,
    additional: false,
    additionalSevere: false
};
var inputs = {
    grade: null
};
var resultSectionVisible = function (section) {
    var _a;
    return (helpers_1.isAnswered(inputs.grade) && Number((_a = inputs.grade) === null || _a === void 0 ? void 0 : _a.currentPoints) === section);
};
var isResultSectionVisible = function () {
    return helpers_1.isAnswered(inputs.grade);
};
var isAdditionalVisible = function () {
    return (helpers_1.answerMatches(inputs.grade, 'mild') ||
        helpers_1.answerMatches(inputs.grade, 'moderate'));
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.mild = resultSectionVisible(1);
    visibleQuestions.mildManagement = resultSectionVisible(1);
    visibleQuestions.moderate = resultSectionVisible(2);
    visibleQuestions.moderateManagement = resultSectionVisible(2);
    visibleQuestions.severe = resultSectionVisible(3);
    visibleQuestions.severeManagement = resultSectionVisible(3);
    visibleQuestions.mildAssessment = resultSectionVisible(1);
    visibleQuestions.moderateAssessment = resultSectionVisible(2);
    visibleQuestions.severeAssessment = resultSectionVisible(3);
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.resultSection = isResultSectionVisible();
    visibleSections.additional = isAdditionalVisible();
    visibleSections.additionalSevere = resultSectionVisible(3);
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return helpers_1.isAnswered(inputs.grade);
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: { number: result, range: result },
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
