"use strict";


var visibleQuestions = {
    grade: true,
    history: false,
    historyText: false,
    mild: false,
    mildManagement: false,
    mildAssessment: false,
    escalation1: false,
    moderate: false,
    moderateManagement: false,
    result215: false,
    result213: false,
    result214: false,
    escalation2: false,
    severe: false,
    severeManagement: false,
    result315: false,
    result313: false,
    result314: false,
    escalation3: false,
    result411: false,
    result412: false,
    result421: false
};
var visibleSections = {
    section1: true,
    historyAndDifferentialDiagnosis: false,
    resultSectionMild: false,
    additionalMild: false,
    section13: false,
    resultSectionModerate: false,
    additionalModerate: false,
    section22: false,
    resultSectionSevere: false,
    additionalSevere: false,
    section32: false,
    section41: false,
    end: false
};
var inputs = {
    grade: null,
    history: null,
    escalation1: null,
    escalation2: null,
    escalation3: null
};
var isHistoryAndDifferentialDiagnosisVisible = function () {
    return helpers_1.isAnswered(inputs.grade);
};
var isHistoryTextVisible = function () {
    return (isHistoryAndDifferentialDiagnosisVisible() &&
        helpers_1.answerMatches(inputs.history, 'close'));
};
var isResultSectionMildVisible = function () {
    return helpers_1.answerMatches(inputs.grade, 'mild');
};
var isResultSectionModerateVisible = function () {
    return (helpers_1.answerMatches(inputs.escalation1, 'grade2') ||
        helpers_1.answerMatches(inputs.grade, 'moderate'));
};
var isResultSectionSevereVisible = function () {
    return (helpers_1.answerMatches(inputs.escalation2, 'noImprovement') ||
        helpers_1.answerMatches(inputs.grade, 'severe') ||
        helpers_1.answerMatches(inputs.escalation1, 'grade34'));
};
var isSection41Visible = function () {
    return helpers_1.answerMatches(inputs.escalation3, 'yes');
};
var isEndVisible = function () {
    return (helpers_1.answerMatches(inputs.escalation1, 'no') ||
        helpers_1.answerMatches(inputs.escalation2, 'improvement') ||
        helpers_1.answerMatches(inputs.escalation3, 'no'));
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.history = isHistoryAndDifferentialDiagnosisVisible();
    visibleQuestions.historyText = isHistoryTextVisible();
    visibleQuestions.mild = isResultSectionMildVisible();
    visibleQuestions.mildManagement = isResultSectionMildVisible();
    visibleQuestions.mildAssessment = isResultSectionMildVisible();
    visibleQuestions.escalation1 = isResultSectionMildVisible();
    visibleQuestions.moderate = isResultSectionModerateVisible();
    visibleQuestions.moderateManagement = isResultSectionModerateVisible();
    visibleQuestions.result215 = isResultSectionModerateVisible();
    visibleQuestions.result213 = isResultSectionModerateVisible();
    visibleQuestions.result214 = isResultSectionModerateVisible();
    visibleQuestions.escalation2 = isResultSectionModerateVisible();
    visibleQuestions.severe = isResultSectionSevereVisible();
    visibleQuestions.severeManagement = isResultSectionSevereVisible();
    visibleQuestions.result315 = isResultSectionSevereVisible();
    visibleQuestions.result313 = isResultSectionSevereVisible();
    visibleQuestions.result314 = isResultSectionSevereVisible();
    visibleQuestions.escalation3 = isResultSectionSevereVisible();
    visibleQuestions.result411 = isSection41Visible();
    visibleQuestions.result412 = isSection41Visible();
    visibleQuestions.result421 = isEndVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.historyAndDifferentialDiagnosis =
        isHistoryAndDifferentialDiagnosisVisible();
    visibleSections.resultSectionMild = isResultSectionMildVisible();
    visibleSections.additionalMild = isResultSectionMildVisible();
    visibleSections.section13 = isResultSectionMildVisible();
    visibleSections.resultSectionModerate = isResultSectionModerateVisible();
    visibleSections.additionalModerate = isResultSectionModerateVisible();
    visibleSections.section22 = isResultSectionModerateVisible();
    visibleSections.resultSectionSevere = isResultSectionSevereVisible();
    visibleSections.additionalSevere = isResultSectionSevereVisible();
    visibleSections.section32 = isResultSectionSevereVisible();
    visibleSections.section41 = isSection41Visible();
    visibleSections.end = isEndVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return helpers_1.isAnswered(inputs.grade);
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: { number: result, range: result },
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
