"use strict";


var visibleQuestions = {
    grade: true,
    mild: false,
    result12: false,
    moderate: false,
    moderateManagement: false,
    severe: false,
    severeManagement: false,
    assessment1: false,
    assessment2: false,
    monitoring1: false
};
var visibleSections = {
    section1: true,
    resultSection1: false,
    resultSection2: false,
    resultSection3: false,
    additional: false
};
var inputs = {
    grade: null
};
var resultSectionVisible = function (section) {
    var _a;
    return (helpers_1.isAnswered(inputs.grade) && Number((_a = inputs.grade) === null || _a === void 0 ? void 0 : _a.currentPoints) === section);
};
var isAdditionalVisible = function () {
    return helpers_1.isAnswered(inputs.grade);
};
var isAssessment2Visible = function () {
    return (helpers_1.answerMatches(inputs.grade, 'moderate') ||
        helpers_1.answerMatches(inputs.grade, 'severe'));
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.mild = resultSectionVisible(1);
    visibleQuestions.result12 = resultSectionVisible(1);
    visibleQuestions.moderate = resultSectionVisible(2);
    visibleQuestions.moderateManagement = resultSectionVisible(2);
    visibleQuestions.severe = resultSectionVisible(3);
    visibleQuestions.severeManagement = resultSectionVisible(3);
    visibleQuestions.assessment1 = resultSectionVisible(1);
    visibleQuestions.assessment2 = isAssessment2Visible();
    visibleQuestions.monitoring1 = isAdditionalVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.resultSection1 = resultSectionVisible(1);
    visibleSections.resultSection2 = resultSectionVisible(2);
    visibleSections.resultSection3 = resultSectionVisible(3);
    visibleSections.additional = isAdditionalVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return helpers_1.isAnswered(inputs.grade);
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: { number: result, range: result },
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
