"use strict";


var visibleQuestions = {
    pretreatmentConsiderations: true,
    pretreatmentConsiderationsText: false,
    opportunisticInfection: true,
    opportunisticInfectionText: false,
    patients: true,
    shortTerm: true,
    longTerm: true,
    prophylaxisGI: true,
    boneLoss: true,
    steroidsTapering: true,
    steroidsTaperingText: false
};
var visibleSections = {
    considerations: true,
    infection: true,
    monitoring: true,
    tapering: true
};
var inputs = {
    pretreatmentConsiderations: null,
    opportunisticInfection: null,
    steroidsTapering: null
};
var isPretreatmentConsiderationsTextVisible = function () {
    return helpers_1.answerMatches(inputs.pretreatmentConsiderations, 'close');
};
var isOportunisticInfectionTextVisible = function () {
    return helpers_1.answerMatches(inputs.opportunisticInfection, 'close');
};
var isSteroidsTaperingTextVisible = function () {
    return helpers_1.answerMatches(inputs.steroidsTapering, 'close');
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.pretreatmentConsiderationsText =
        isPretreatmentConsiderationsTextVisible();
    visibleQuestions.opportunisticInfectionText =
        isOportunisticInfectionTextVisible();
    visibleQuestions.steroidsTaperingText = isSteroidsTaperingTextVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return true;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: { number: result, range: result },
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
