"use strict";


var visibleQuestions = {
    grade: true,
    assessment: false,
    assessmentText: false,
    mild: false,
    mildManagement: false,
    moderate: false,
    moderateManagement: false,
    severeManagement: false
};
var visibleSections = {
    section1: true,
    additional: false,
    resultSection1: false,
    resultSection2: false
};
var inputs = {
    grade: null,
    assessment: null
};
var isAdditionalVisible = function () {
    return helpers_1.isAnswered(inputs.grade);
};
var isAssessmentTextVisible = function () {
    return isAdditionalVisible() && helpers_1.answerMatches(inputs.assessment, 'close');
};
var isResultSection1Visible = function () {
    return helpers_1.answerMatches(inputs.grade, 'mild');
};
var isResultSection2Visible = function () {
    return (helpers_1.answerMatches(inputs.grade, 'moderate') ||
        helpers_1.answerMatches(inputs.grade, 'severe') ||
        helpers_1.answerMatches(inputs.grade, 'lifeThreatening'));
};
var isModerateManagementVisible = function () {
    return helpers_1.answerMatches(inputs.grade, 'moderate');
};
var isSevereManagementVisible = function () {
    return (helpers_1.answerMatches(inputs.grade, 'severe') ||
        helpers_1.answerMatches(inputs.grade, 'lifeThreatening'));
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.assessment = isAdditionalVisible();
    visibleQuestions.assessmentText = isAssessmentTextVisible();
    visibleQuestions.mild = isResultSection1Visible();
    visibleQuestions.mildManagement = isResultSection1Visible();
    visibleQuestions.moderate = isResultSection2Visible();
    visibleQuestions.moderateManagement = isModerateManagementVisible();
    visibleQuestions.severeManagement = isSevereManagementVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.additional = isAdditionalVisible();
    visibleSections.resultSection1 = isResultSection1Visible();
    visibleSections.resultSection2 = isResultSection2Visible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return helpers_1.isAnswered(inputs.grade);
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: { number: result, range: result },
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
