"use strict";


var visibleQuestions = {
    baselinePanel: true,
    monitoring1: true,
    monitoring2: true,
    monitoring3: true,
    monitoring4: true,
    tshValue: true,
    ft4valueE: false,
    ft4valueNL: false,
    result11: false,
    result12: false,
    result13: false,
    result21: false,
    result31: false,
    result41: false,
    result51: false,
    result52: false,
    result53: false,
    result54: false
};
var visibleSections = {
    section1: true,
    section2: true,
    resultSection1: false,
    resultSection2: false,
    resultSection3: false,
    resultSection4: false,
    resultSection5: false
};
var inputs = {
    tshValue: null,
    ft4valueE: null,
    ft4valueNL: null
};
var isFt4valueEVisible = function () {
    return helpers_1.answerMatches(inputs.tshValue, 'elevated');
};
var isFt4valueNLVisible = function () {
    return (helpers_1.answerMatches(inputs.tshValue, 'normal') ||
        helpers_1.answerMatches(inputs.tshValue, 'low'));
};
var isResultSection1Visible = function () {
    return (helpers_1.answerMatches(inputs.tshValue, 'elevated') &&
        (helpers_1.answerMatches(inputs.ft4valueE, 'normal') ||
            helpers_1.answerMatches(inputs.ft4valueE, 'low')));
};
var isResult12Visible = function () {
    return isResultSection1Visible() && helpers_1.answerMatches(inputs.ft4valueE, 'low');
};
var isResult13Visible = function () {
    return isResultSection1Visible() && helpers_1.answerMatches(inputs.ft4valueE, 'normal');
};
var isResultSection2Visible = function () {
    return (helpers_1.answerMatches(inputs.tshValue, 'normal') &&
        helpers_1.answerMatches(inputs.ft4valueNL, 'elevated'));
};
var isResultSection3Visible = function () {
    return (helpers_1.answerMatches(inputs.tshValue, 'normal') &&
        helpers_1.answerMatches(inputs.ft4valueNL, 'low'));
};
var isResultSection4Visible = function () {
    return (helpers_1.answerMatches(inputs.tshValue, 'low') &&
        helpers_1.answerMatches(inputs.ft4valueNL, 'low'));
};
var isResultSection5Visible = function () {
    return (helpers_1.answerMatches(inputs.tshValue, 'low') &&
        helpers_1.answerMatches(inputs.ft4valueNL, 'elevated'));
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.ft4valueE = isFt4valueEVisible();
    visibleQuestions.ft4valueNL = isFt4valueNLVisible();
    visibleQuestions.result11 = isResultSection1Visible();
    visibleQuestions.result12 = isResult12Visible();
    visibleQuestions.result13 = isResult13Visible();
    visibleQuestions.result21 = isResultSection2Visible();
    visibleQuestions.result31 = isResultSection3Visible();
    visibleQuestions.result41 = isResultSection4Visible();
    visibleQuestions.result51 = isResultSection5Visible();
    visibleQuestions.result52 = isResultSection5Visible();
    visibleQuestions.result53 = isResultSection5Visible();
    visibleQuestions.result54 = isResultSection5Visible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.resultSection1 = isResultSection1Visible();
    visibleSections.resultSection2 = isResultSection2Visible();
    visibleSections.resultSection3 = isResultSection3Visible();
    visibleSections.resultSection4 = isResultSection4Visible();
    visibleSections.resultSection5 = isResultSection5Visible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return (helpers_1.isAnswered(inputs.tshValue) ||
        helpers_1.isAnswered(inputs.ft4valueE) ||
        helpers_1.isAnswered(inputs.ft4valueNL));
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: { number: result, range: result },
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
