"use strict";


var visibleQuestions = {
    grade: true,
    assessment: false,
    assessmentText: false,
    mild: false,
    mildManagement: false,
    moderate: false,
    moderateManagement: false,
    severe: false,
    severeManagement: false,
    lifeThreatening: false,
    lifeThreateningManagement: false,
    additionalConsiderations: false
};
var visibleSections = {
    section1: true,
    additional: false,
    resultSection1: false,
    resultSection2: false,
    resultSection3: false,
    resultSection4: false,
    considerations: false
};
var inputs = {
    grade: null,
    assessment: null
};
var resultSectionVisible = function (section) {
    var _a;
    return (helpers_1.isAnswered(inputs.grade) && Number((_a = inputs.grade) === null || _a === void 0 ? void 0 : _a.currentPoints) === section);
};
var isAdditionalVisible = function () {
    return helpers_1.isAnswered(inputs.grade);
};
var isAssessmentTextVisible = function () {
    return helpers_1.answerMatches(inputs.assessment, 'close');
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.assessment = isAdditionalVisible();
    visibleQuestions.assessmentText = isAssessmentTextVisible();
    visibleQuestions.mild = resultSectionVisible(1);
    visibleQuestions.mildManagement = resultSectionVisible(1);
    visibleQuestions.moderate = resultSectionVisible(2);
    visibleQuestions.moderateManagement = resultSectionVisible(2);
    visibleQuestions.severe = resultSectionVisible(3);
    visibleQuestions.severeManagement = resultSectionVisible(3);
    visibleQuestions.lifeThreatening = resultSectionVisible(4);
    visibleQuestions.lifeThreateningManagement = resultSectionVisible(4);
    visibleQuestions.additionalConsiderations = isAdditionalVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.additional = isAdditionalVisible();
    visibleSections.resultSection1 = resultSectionVisible(1);
    visibleSections.resultSection2 = resultSectionVisible(2);
    visibleSections.resultSection3 = resultSectionVisible(3);
    visibleSections.resultSection4 = resultSectionVisible(4);
    visibleSections.considerations = isAdditionalVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return helpers_1.isAnswered(inputs.grade);
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: { number: result, range: result },
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
