"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};


var visibleQuestions = {
    skinColor: true,
    pulseRate: true,
    grimace: true,
    activity: true,
    respiratoryEffort: true
};
var visibleSections = {
    main: true
};
var inputs = {
    skinColor: null,
    pulseRate: null,
    grimace: null,
    activity: null,
    respiratoryEffort: null
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_toolScore = function () {
    return calculatePoints();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return areAllAnswered();
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e;
    if (!areAllAnswered())
        return helpers_1.returnToolScoreObject({});
    var outputResult = helpers_1.formatCalculationResult(Number((_a = inputs.skinColor) === null || _a === void 0 ? void 0 : _a.currentPoints) +
        Number((_b = inputs.pulseRate) === null || _b === void 0 ? void 0 : _b.currentPoints) +
        Number((_c = inputs.grimace) === null || _c === void 0 ? void 0 : _c.currentPoints) +
        Number((_d = inputs.activity) === null || _d === void 0 ? void 0 : _d.currentPoints) +
        Number((_e = inputs.respiratoryEffort) === null || _e === void 0 ? void 0 : _e.currentPoints));
    return helpers_1.returnToolScoreObject({ number: outputResult, range: outputResult });
};
var areAllAnswered = function () {
    return (helpers_1.isAnswered(inputs.skinColor) &&
        helpers_1.isAnswered(inputs.pulseRate) &&
        helpers_1.isAnswered(inputs.grimace) &&
        helpers_1.isAnswered(inputs.activity) &&
        helpers_1.isAnswered(inputs.respiratoryEffort));
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return __assign(__assign({ exportResultsEnabled: isExportResultsEnabled() }, result), { visibleQuestions: ut_visibleQuestions(), visibleSections: ut_visibleSections() });
});