"use strict";


var visibleQuestions = {
    symptomatic: true,
    symptomaticText: false,
    whenToConsider: true,
    whenToConsiderText: false,
    adults: true,
    firstLine: false,
    fenoxymetylpenicilin: false,
    alternative: false,
    spiramycin: false,
    or: false,
    doxycyklin: false,
    alternative2: false,
    amoxicilin: false,
    alternative3: false,
    alternative3Text: false,
    fenoxymetylpenicilin2: false,
    plus: false,
    metronidazol: false,
    children: true,
    firstLineChildren: false,
    fenoxymetylpenicilinChildren: false,
    alternativeChildren: false,
    klaritromycin: false,
    orChildren: false,
    spiramycinChildren: false,
    alternativeChildren2: false,
    amoxicilinChildren: false,
    guidelines: true
};
var visibleSections = {
    symptomaticTreatment: true,
    antibiotics: true,
    choiceOfAntibiotic: true,
    link: true
};
var inputs = {
    symptomatic: null,
    whenToConsider: null,
    adults: null,
    children: null
};
var isSymptomaticClose = function () {
    return helpers_1.answerMatches(inputs.symptomatic, 'close');
};
var isWhenToConsiderClose = function () {
    return helpers_1.answerMatches(inputs.whenToConsider, 'close');
};
var isAdultsClose = function () {
    return helpers_1.answerMatches(inputs.adults, 'close');
};
var isChildrenClose = function () {
    return helpers_1.answerMatches(inputs.children, 'close');
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.symptomaticText = isSymptomaticClose();
    visibleQuestions.whenToConsiderText = isWhenToConsiderClose();
    visibleQuestions.firstLine = isAdultsClose();
    visibleQuestions.fenoxymetylpenicilin = isAdultsClose();
    visibleQuestions.alternative = isAdultsClose();
    visibleQuestions.spiramycin = isAdultsClose();
    visibleQuestions.or = isAdultsClose();
    visibleQuestions.doxycyklin = isAdultsClose();
    visibleQuestions.alternative2 = isAdultsClose();
    visibleQuestions.amoxicilin = isAdultsClose();
    visibleQuestions.alternative3 = isAdultsClose();
    visibleQuestions.alternative3Text = isAdultsClose();
    visibleQuestions.fenoxymetylpenicilin2 = isAdultsClose();
    visibleQuestions.plus = isAdultsClose();
    visibleQuestions.metronidazol = isAdultsClose();
    visibleQuestions.firstLineChildren = isChildrenClose();
    visibleQuestions.fenoxymetylpenicilinChildren = isChildrenClose();
    visibleQuestions.alternativeChildren = isChildrenClose();
    visibleQuestions.klaritromycin = isChildrenClose();
    visibleQuestions.orChildren = isChildrenClose();
    visibleQuestions.spiramycinChildren = isChildrenClose();
    visibleQuestions.alternativeChildren2 = isChildrenClose();
    visibleQuestions.amoxicilinChildren = isChildrenClose();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return (helpers_1.answerMatches(inputs.symptomatic, 'close') ||
        helpers_1.answerMatches(inputs.whenToConsider, 'close') ||
        helpers_1.answerMatches(inputs.adults, 'close') ||
        helpers_1.answerMatches(inputs.children, 'close'));
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
