"use strict";


var visibleQuestions = {
    whenToConsider: true,
    whenToConsiderText: false,
    antibioticsNotIndicated: true,
    antibioticsNotIndicatedText: false,
    pregnancy: true,
    firstLine: false,
    nitrofurantoin: false,
    alternative: false,
    amoxicilin1: false,
    or: false,
    trimetoprim: false,
    pregnancyCausativeAgent: true,
    firstLineCausativeAgent1: false,
    nitrofurantoinCausativeAgent: false,
    firstLineCausativeAgent2: false,
    amoxicilin2: false,
    firstLineCausativeAgent3: false,
    pivmecilinam: false,
    guidelines: true
};
var visibleSections = {
    whenToConsiderAntibiotics: true,
    antibioticsNot: true,
    choiceOfAntibiotic: true,
    link: true
};
var inputs = {
    whenToConsider: null,
    antibioticsNotIndicated: null,
    pregnancy: null,
    pregnancyCausativeAgent: null
};
var isWhenToConsiderClose = function () {
    return helpers_1.answerMatches(inputs.whenToConsider, 'close');
};
var isAntibioticsNotIndicatedClose = function () {
    return helpers_1.answerMatches(inputs.antibioticsNotIndicated, 'close');
};
var isPregnancyClose = function () {
    return helpers_1.answerMatches(inputs.pregnancy, 'close');
};
var isPregnancyCausativeAgentClose = function () {
    return helpers_1.answerMatches(inputs.pregnancyCausativeAgent, 'close');
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.whenToConsiderText = isWhenToConsiderClose();
    visibleQuestions.antibioticsNotIndicatedText =
        isAntibioticsNotIndicatedClose();
    visibleQuestions.firstLine = isPregnancyClose();
    visibleQuestions.nitrofurantoin = isPregnancyClose();
    visibleQuestions.alternative = isPregnancyClose();
    visibleQuestions.amoxicilin1 = isPregnancyClose();
    visibleQuestions.or = isPregnancyClose();
    visibleQuestions.trimetoprim = isPregnancyClose();
    visibleQuestions.firstLineCausativeAgent1 = isPregnancyCausativeAgentClose();
    visibleQuestions.nitrofurantoinCausativeAgent =
        isPregnancyCausativeAgentClose();
    visibleQuestions.firstLineCausativeAgent2 = isPregnancyCausativeAgentClose();
    visibleQuestions.amoxicilin2 = isPregnancyCausativeAgentClose();
    visibleQuestions.firstLineCausativeAgent3 = isPregnancyCausativeAgentClose();
    visibleQuestions.pivmecilinam = isPregnancyCausativeAgentClose();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return (helpers_1.answerMatches(inputs.whenToConsider, 'close') ||
        helpers_1.answerMatches(inputs.antibioticsNotIndicated, 'close') ||
        helpers_1.answerMatches(inputs.pregnancy, 'close') ||
        helpers_1.answerMatches(inputs.pregnancyCausativeAgent, 'close'));
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
