"use strict";


var visibleQuestions = {
    general: true,
    generalText: false,
    curb: false,
    whenToConsider: true,
    whenToConsiderText: false,
    noComorbidities: true,
    firstLine: false,
    amoxicilinNoComorbidities: false,
    alternative: false,
    doxycyklin: false,
    comorbidities: true,
    firstLineComorbidities: false,
    amoxicilinClavulanic: false,
    plus: false,
    doxycyklinComorbidities: false,
    alternativeComorbidities: false,
    doxycyklinComorbidities2: false,
    childrenMild: true,
    firstLineChildrenMild: false,
    amoxicilin: false,
    alternativeChildrenMild: false,
    doxycyklinChildrenMild: false,
    or0: false,
    klaritromycin: false,
    or: false,
    spiramycin: false,
    childrenModerateOver40: true,
    firstLineChildrenModerateOver40: false,
    amoxicilinChildrenModerateOver40: false,
    plus2: false,
    doxycyklinChildrenModerateOver40: false,
    alternativeChildrenModerateOver40: false,
    doxycyklinChildrenModerateOver40kg: false,
    childrenModerateUnder40: true,
    firstLineChildrenModerateUnder40: false,
    amoxicilinChildrenModerateUnder40: false,
    plus3: false,
    klaritromycinChildrenModerateUnder40: false,
    or2: false,
    spiramycinChildrenModerateUnder40: false,
    alternativeChildrenModerateUnder40: false,
    klaritromycinChildrenModerateUnder40kg: false,
    or3: false,
    spiramycinChildrenModerateUnder40kg: false,
    duration: true,
    durationText: false,
    guidelines: true
};
var visibleSections = {
    generalInformation: true,
    antibiotics: true,
    choiceOfAntibiotic: true,
    choiceOfAntibioticChildren: true,
    antibioticDuration: true,
    link: true
};
var inputs = {
    general: null,
    whenToConsider: null,
    noComorbidities: null,
    comorbidities: null,
    childrenMild: null,
    childrenModerateOver40: null,
    childrenModerateUnder40: null,
    duration: null
};
var isGeneralClose = function () {
    return helpers_1.answerMatches(inputs.general, 'close');
};
var isWhenToConsiderClose = function () {
    return helpers_1.answerMatches(inputs.whenToConsider, 'close');
};
var isNoComorbiditiesClose = function () {
    return helpers_1.answerMatches(inputs.noComorbidities, 'close');
};
var isComorbiditiesClose = function () {
    return helpers_1.answerMatches(inputs.comorbidities, 'close');
};
var isChildrenMildClose = function () {
    return helpers_1.answerMatches(inputs.childrenMild, 'close');
};
var isFirstLineChildrenModerateOver40Close = function () {
    return helpers_1.answerMatches(inputs.childrenModerateOver40, 'close');
};
var isFirstLineChildrenModerateUnder40Close = function () {
    return helpers_1.answerMatches(inputs.childrenModerateUnder40, 'close');
};
var isDurationClose = function () {
    return helpers_1.answerMatches(inputs.duration, 'close');
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.generalText = isGeneralClose();
    visibleQuestions.curb = isGeneralClose();
    visibleQuestions.whenToConsiderText = isWhenToConsiderClose();
    visibleQuestions.firstLine = isNoComorbiditiesClose();
    visibleQuestions.amoxicilinNoComorbidities = isNoComorbiditiesClose();
    visibleQuestions.alternative = isNoComorbiditiesClose();
    visibleQuestions.doxycyklin = isNoComorbiditiesClose();
    visibleQuestions.firstLineComorbidities = isComorbiditiesClose();
    visibleQuestions.amoxicilinClavulanic = isComorbiditiesClose();
    visibleQuestions.plus = isComorbiditiesClose();
    visibleQuestions.doxycyklinComorbidities = isComorbiditiesClose();
    visibleQuestions.alternativeComorbidities = isComorbiditiesClose();
    visibleQuestions.doxycyklinComorbidities2 = isComorbiditiesClose();
    visibleQuestions.firstLineChildrenMild = isChildrenMildClose();
    visibleQuestions.amoxicilin = isChildrenMildClose();
    visibleQuestions.alternativeChildrenMild = isChildrenMildClose();
    visibleQuestions.doxycyklinChildrenMild = isChildrenMildClose();
    visibleQuestions.or0 = isChildrenMildClose();
    visibleQuestions.klaritromycin = isChildrenMildClose();
    visibleQuestions.or = isChildrenMildClose();
    visibleQuestions.spiramycin = isChildrenMildClose();
    visibleQuestions.firstLineChildrenModerateOver40 =
        isFirstLineChildrenModerateOver40Close();
    visibleQuestions.amoxicilinChildrenModerateOver40 =
        isFirstLineChildrenModerateOver40Close();
    visibleQuestions.plus2 = isFirstLineChildrenModerateOver40Close();
    visibleQuestions.doxycyklinChildrenModerateOver40 =
        isFirstLineChildrenModerateOver40Close();
    visibleQuestions.alternativeChildrenModerateOver40 =
        isFirstLineChildrenModerateOver40Close();
    visibleQuestions.doxycyklinChildrenModerateOver40kg =
        isFirstLineChildrenModerateOver40Close();
    visibleQuestions.firstLineChildrenModerateUnder40 =
        isFirstLineChildrenModerateUnder40Close();
    visibleQuestions.amoxicilinChildrenModerateUnder40 =
        isFirstLineChildrenModerateUnder40Close();
    visibleQuestions.plus3 = isFirstLineChildrenModerateUnder40Close();
    visibleQuestions.klaritromycinChildrenModerateUnder40 =
        isFirstLineChildrenModerateUnder40Close();
    visibleQuestions.or2 = isFirstLineChildrenModerateUnder40Close();
    visibleQuestions.spiramycinChildrenModerateUnder40 =
        isFirstLineChildrenModerateUnder40Close();
    visibleQuestions.alternativeChildrenModerateUnder40 =
        isFirstLineChildrenModerateUnder40Close();
    visibleQuestions.klaritromycinChildrenModerateUnder40kg =
        isFirstLineChildrenModerateUnder40Close();
    visibleQuestions.or3 = isFirstLineChildrenModerateUnder40Close();
    visibleQuestions.spiramycinChildrenModerateUnder40kg =
        isFirstLineChildrenModerateUnder40Close();
    visibleQuestions.durationText = isDurationClose();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return (helpers_1.answerMatches(inputs.general, 'close') ||
        helpers_1.answerMatches(inputs.whenToConsider, 'close') ||
        helpers_1.answerMatches(inputs.noComorbidities, 'close') ||
        helpers_1.answerMatches(inputs.comorbidities, 'close') ||
        helpers_1.answerMatches(inputs.childrenMild, 'close') ||
        helpers_1.answerMatches(inputs.childrenModerateOver40, 'close') ||
        helpers_1.answerMatches(inputs.childrenModerateUnder40, 'close') ||
        helpers_1.answerMatches(inputs.duration, 'close'));
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
