"use strict";


var visibleQuestions = {
    symptomatic: true,
    symptomaticText: false,
    whenToConsider: true,
    whenToConsiderText: false,
    news2: false,
    qSOFA: false,
    cystitisPregnantWomen: true,
    firstLine: false,
    nitrofurantoin: false,
    alternative: false,
    trimetoprim: false,
    or: false,
    pivmecilinam: false,
    or2: false,
    amoxicilin: false,
    mildPyelonephritis: true,
    firstLinePyelonephritis: false,
    amoxClav: false,
    cystitisMen: true,
    firstLineCystitisMen: false,
    nitrofurantoin2: false,
    alternativeCystitisMen: false,
    trimetoprim2: false,
    or3: false,
    pivmecilinam2: false,
    pyelonephritisMen: true,
    firstLinePyelonephritisMen: false,
    trimetoprim3: false,
    alternativePyelonephritisMen: false,
    amoxClav2: false,
    or4: false,
    ciprofloxacin: false,
    noUpperInvolvement: true,
    firstLineNoUpperInvolvement: false,
    nitrofurantoin3: false,
    alternativeNoUpperInvolvement: false,
    trimetoprim4: false,
    or5: false,
    pivmecilinam3: false,
    or6: false,
    amoxicilin2: false,
    upperInvolvement: true,
    firstLineUpperInvolvement: false,
    amoxClav3: false,
    alternativeUpperInvolvement: false,
    trimetoprim5: false,
    or7: false,
    ciprofloxacin4: false,
    guidelines: true
};
var visibleSections = {
    symptomaticTreatment: true,
    antibiotics: true,
    choiceOfAntibiotic: true,
    link: true
};
var inputs = {
    symptomatic: null,
    whenToConsider: null,
    cystitisPregnantWomen: null,
    mildPyelonephritis: null,
    cystitisMen: null,
    pyelonephritisMen: null,
    noUpperInvolvement: null,
    upperInvolvement: null
};
var isSymptomaticClose = function () {
    return helpers_1.answerMatches(inputs.symptomatic, 'close');
};
var isWhenToConsiderClose = function () {
    return helpers_1.answerMatches(inputs.whenToConsider, 'close');
};
var isCystitisPregnantWomenClose = function () {
    return helpers_1.answerMatches(inputs.cystitisPregnantWomen, 'close');
};
var isMildPyelonephritisClose = function () {
    return helpers_1.answerMatches(inputs.mildPyelonephritis, 'close');
};
var isCystitisMenClose = function () {
    return helpers_1.answerMatches(inputs.cystitisMen, 'close');
};
var isPyelonephritisMenClose = function () {
    return helpers_1.answerMatches(inputs.pyelonephritisMen, 'close');
};
var isNoUpperInvolvementClose = function () {
    return helpers_1.answerMatches(inputs.noUpperInvolvement, 'close');
};
var isUpperInvolvementClose = function () {
    return helpers_1.answerMatches(inputs.upperInvolvement, 'close');
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.symptomaticText = isSymptomaticClose();
    visibleQuestions.whenToConsiderText = isWhenToConsiderClose();
    visibleQuestions.news2 = isWhenToConsiderClose();
    visibleQuestions.qSOFA = isWhenToConsiderClose();
    visibleQuestions.firstLine = isCystitisPregnantWomenClose();
    visibleQuestions.nitrofurantoin = isCystitisPregnantWomenClose();
    visibleQuestions.alternative = isCystitisPregnantWomenClose();
    visibleQuestions.trimetoprim = isCystitisPregnantWomenClose();
    visibleQuestions.or = isCystitisPregnantWomenClose();
    visibleQuestions.pivmecilinam = isCystitisPregnantWomenClose();
    visibleQuestions.or2 = isCystitisPregnantWomenClose();
    visibleQuestions.amoxicilin = isCystitisPregnantWomenClose();
    visibleQuestions.firstLinePyelonephritis = isMildPyelonephritisClose();
    visibleQuestions.amoxClav = isMildPyelonephritisClose();
    visibleQuestions.nitrofurantoin2 = isCystitisMenClose();
    visibleQuestions.alternativeCystitisMen = isCystitisMenClose();
    visibleQuestions.trimetoprim2 = isCystitisMenClose();
    visibleQuestions.or3 = isCystitisMenClose();
    visibleQuestions.pivmecilinam2 = isCystitisMenClose();
    visibleQuestions.firstLinePyelonephritisMen = isPyelonephritisMenClose();
    visibleQuestions.trimetoprim3 = isPyelonephritisMenClose();
    visibleQuestions.alternativePyelonephritisMen = isPyelonephritisMenClose();
    visibleQuestions.amoxClav2 = isPyelonephritisMenClose();
    visibleQuestions.firstLineCystitisMen = isCystitisMenClose();
    visibleQuestions.or4 = isPyelonephritisMenClose();
    visibleQuestions.ciprofloxacin = isPyelonephritisMenClose();
    visibleQuestions.firstLineNoUpperInvolvement = isNoUpperInvolvementClose();
    visibleQuestions.nitrofurantoin3 = isNoUpperInvolvementClose();
    visibleQuestions.alternativeNoUpperInvolvement = isNoUpperInvolvementClose();
    visibleQuestions.trimetoprim4 = isNoUpperInvolvementClose();
    visibleQuestions.or5 = isNoUpperInvolvementClose();
    visibleQuestions.pivmecilinam3 = isNoUpperInvolvementClose();
    visibleQuestions.or6 = isNoUpperInvolvementClose();
    visibleQuestions.amoxicilin2 = isNoUpperInvolvementClose();
    visibleQuestions.firstLineUpperInvolvement = isUpperInvolvementClose();
    visibleQuestions.amoxClav3 = isUpperInvolvementClose();
    visibleQuestions.alternativeUpperInvolvement = isUpperInvolvementClose();
    visibleQuestions.trimetoprim5 = isUpperInvolvementClose();
    visibleQuestions.or7 = isUpperInvolvementClose();
    visibleQuestions.ciprofloxacin4 = isUpperInvolvementClose();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return (helpers_1.answerMatches(inputs.symptomatic, 'close') ||
        helpers_1.answerMatches(inputs.whenToConsider, 'close') ||
        helpers_1.answerMatches(inputs.cystitisPregnantWomen, 'close') ||
        helpers_1.answerMatches(inputs.mildPyelonephritis, 'close') ||
        helpers_1.answerMatches(inputs.cystitisMen, 'close') ||
        helpers_1.answerMatches(inputs.pyelonephritisMen, 'close') ||
        helpers_1.answerMatches(inputs.noUpperInvolvement, 'close') ||
        helpers_1.answerMatches(inputs.upperInvolvement, 'close'));
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
