"use strict";


var visibleQuestions = {
    symptomatic: true,
    symptomaticText: false,
    whenToConsider: true,
    whenToConsiderText: false,
    over16: true,
    firstLine: false,
    nitrofurantoin: false,
    alternative: false,
    trimetoprim: false,
    or: false,
    pivmecilinam: false,
    recurrentCystitis: true,
    recurrentCystitisText: false,
    singleDose: false,
    singleDoseFirstLine: false,
    nitrofurantoin2: false,
    or2: false,
    trimetoprim2: false,
    longTerm: false,
    longTermFirstLine: false,
    nitrofurantoin3: false,
    or3: false,
    trimetoprim3: false,
    guidelines: true
};
var visibleSections = {
    symptomaticTreatment: true,
    antibiotics: true,
    choiceOfAntibiotic: true,
    link: true
};
var inputs = {
    symptomatic: null,
    whenToConsider: null,
    over16: null,
    recurrentCystitis: null,
    singleDose: null,
    longTerm: null
};
var isSymptomaticClose = function () {
    return helpers_1.answerMatches(inputs.symptomatic, 'close');
};
var isWhenToConsiderClose = function () {
    return helpers_1.answerMatches(inputs.whenToConsider, 'close');
};
var isOver16Close = function () {
    return helpers_1.answerMatches(inputs.over16, 'close');
};
var isRecurrentCystitisClose = function () {
    return helpers_1.answerMatches(inputs.recurrentCystitis, 'close');
};
var isSingleDoseClose = function () {
    return helpers_1.answerMatches(inputs.singleDose, 'close');
};
var isLongTermClose = function () {
    return helpers_1.answerMatches(inputs.longTerm, 'close');
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.symptomaticText = isSymptomaticClose();
    visibleQuestions.whenToConsiderText = isWhenToConsiderClose();
    visibleQuestions.firstLine = isOver16Close();
    visibleQuestions.nitrofurantoin = isOver16Close();
    visibleQuestions.alternative = isOver16Close();
    visibleQuestions.trimetoprim = isOver16Close();
    visibleQuestions.or = isOver16Close();
    visibleQuestions.pivmecilinam = isOver16Close();
    visibleQuestions.recurrentCystitisText = isRecurrentCystitisClose();
    visibleQuestions.singleDose = isRecurrentCystitisClose();
    visibleQuestions.singleDoseFirstLine = isSingleDoseClose();
    visibleQuestions.nitrofurantoin2 = isSingleDoseClose();
    visibleQuestions.or2 = isSingleDoseClose();
    visibleQuestions.trimetoprim2 = isSingleDoseClose();
    visibleQuestions.longTerm = isRecurrentCystitisClose();
    visibleQuestions.longTermFirstLine = isLongTermClose();
    visibleQuestions.nitrofurantoin3 = isLongTermClose();
    visibleQuestions.or3 = isLongTermClose();
    visibleQuestions.trimetoprim3 = isLongTermClose();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return (helpers_1.answerMatches(inputs.symptomatic, 'close') ||
        helpers_1.answerMatches(inputs.whenToConsider, 'close') ||
        helpers_1.answerMatches(inputs.over16, 'close') ||
        helpers_1.answerMatches(inputs.recurrentCystitis, 'close') ||
        helpers_1.answerMatches(inputs.singleDose, 'close') ||
        helpers_1.answerMatches(inputs.longTerm, 'close'));
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
