"use strict";


var visibleQuestions = {
    symptomatic: true,
    symptomaticText: false,
    whenToConsider: true,
    whenToConsiderText: false,
    redLegSyndrome: true,
    redLegSyndromeText: false,
    redLegSyndromeText2: false,
    redLegSyndromeText3: false,
    redLegSyndromeText4: false,
    adultsErysipelas: true,
    firstLine: false,
    fenoxymetylpenicilin: false,
    alternative: false,
    klindamycinAdultsErysipelas: false,
    childrenErysipelas: true,
    firstLineChildrenErysipelas: false,
    fenoxymetylpenicilinChildrenErysipelas: false,
    alternativeChildrenErysipelas: false,
    klindamycinChildrenErysipelas: false,
    recurrentErysipelas: true,
    firstLineRecurrentErysipelas: false,
    benzatin: false,
    alternativeRecurrentErysipelas: false,
    fenoxymetylpenicilinRecurrentErysipelas: false,
    adultsPhlegmon: true,
    firstLinePhlegmon: false,
    flukloxacilin: false,
    or: false,
    amoxicilinClavulanic: false,
    alternativeAdultsPhlegmon: false,
    klindamycinAdultsPhlegmon: false,
    or2: false,
    doxycyklin: false,
    childrenPhlegmon: true,
    firstLineChildrenPhlegmon: false,
    amoxicilinClavulanicChildrenPhlegmon: false,
    alternativeChildrenPhlegmon: false,
    klindamycin: false,
    guidelines: true
};
var visibleSections = {
    symptomaticTreatment: true,
    antibiotics: true,
    redLeg: true,
    choiceOfAntibioticErysipelas: true,
    choiceOfAntibioticPhlegmon: true,
    link: true
};
var inputs = {
    symptomatic: null,
    whenToConsider: null,
    redLegSyndrome: null,
    adultsErysipelas: null,
    childrenErysipelas: null,
    recurrentErysipelas: null,
    adultsPhlegmon: null,
    childrenPhlegmon: null
};
var isSymptomaticClose = function () {
    return helpers_1.answerMatches(inputs.symptomatic, 'close');
};
var isWhenToConsiderClose = function () {
    return helpers_1.answerMatches(inputs.whenToConsider, 'close');
};
var isRedLegSyndromeClose = function () {
    return helpers_1.answerMatches(inputs.redLegSyndrome, 'close');
};
var isAdultsErysipelasClose = function () {
    return helpers_1.answerMatches(inputs.adultsErysipelas, 'close');
};
var isChildrenErysipelasClose = function () {
    return helpers_1.answerMatches(inputs.childrenErysipelas, 'close');
};
var isRecurrentErysipelasClose = function () {
    return helpers_1.answerMatches(inputs.recurrentErysipelas, 'close');
};
var isAdultsPhlegmonClose = function () {
    return helpers_1.answerMatches(inputs.adultsPhlegmon, 'close');
};
var isChildrenPhlegmonClose = function () {
    return helpers_1.answerMatches(inputs.childrenPhlegmon, 'close');
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.symptomaticText = isSymptomaticClose();
    visibleQuestions.whenToConsiderText = isWhenToConsiderClose();
    visibleQuestions.redLegSyndromeText = isRedLegSyndromeClose();
    visibleQuestions.redLegSyndromeText2 = isRedLegSyndromeClose();
    visibleQuestions.redLegSyndromeText3 = isRedLegSyndromeClose();
    visibleQuestions.redLegSyndromeText4 = isRedLegSyndromeClose();
    visibleQuestions.firstLine = isAdultsErysipelasClose();
    visibleQuestions.fenoxymetylpenicilin = isAdultsErysipelasClose();
    visibleQuestions.alternative = isAdultsErysipelasClose();
    visibleQuestions.klindamycinAdultsErysipelas = isAdultsErysipelasClose();
    visibleQuestions.firstLineChildrenErysipelas = isChildrenErysipelasClose();
    visibleQuestions.fenoxymetylpenicilinChildrenErysipelas =
        isChildrenErysipelasClose();
    visibleQuestions.alternativeChildrenErysipelas = isChildrenErysipelasClose();
    visibleQuestions.klindamycinChildrenErysipelas = isChildrenErysipelasClose();
    visibleQuestions.firstLineRecurrentErysipelas = isRecurrentErysipelasClose();
    visibleQuestions.benzatin = isRecurrentErysipelasClose();
    visibleQuestions.alternativeRecurrentErysipelas =
        isRecurrentErysipelasClose();
    visibleQuestions.fenoxymetylpenicilinRecurrentErysipelas =
        isRecurrentErysipelasClose();
    visibleQuestions.firstLinePhlegmon = isAdultsPhlegmonClose();
    visibleQuestions.flukloxacilin = isAdultsPhlegmonClose();
    visibleQuestions.or = isAdultsPhlegmonClose();
    visibleQuestions.amoxicilinClavulanic = isAdultsPhlegmonClose();
    visibleQuestions.alternativeAdultsPhlegmon = isAdultsPhlegmonClose();
    visibleQuestions.klindamycinAdultsPhlegmon = isAdultsPhlegmonClose();
    visibleQuestions.or2 = isAdultsPhlegmonClose();
    visibleQuestions.doxycyklin = isAdultsPhlegmonClose();
    visibleQuestions.firstLineChildrenPhlegmon = isChildrenPhlegmonClose();
    visibleQuestions.amoxicilinClavulanicChildrenPhlegmon =
        isChildrenPhlegmonClose();
    visibleQuestions.alternativeChildrenPhlegmon = isChildrenPhlegmonClose();
    visibleQuestions.klindamycin = isChildrenPhlegmonClose();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return (helpers_1.answerMatches(inputs.symptomatic, 'close') ||
        helpers_1.answerMatches(inputs.whenToConsider, 'close') ||
        helpers_1.answerMatches(inputs.redLegSyndrome, 'close') ||
        helpers_1.answerMatches(inputs.adultsErysipelas, 'close') ||
        helpers_1.answerMatches(inputs.childrenErysipelas, 'close') ||
        helpers_1.answerMatches(inputs.recurrentErysipelas, 'close') ||
        helpers_1.answerMatches(inputs.adultsPhlegmon, 'close') ||
        helpers_1.answerMatches(inputs.childrenPhlegmon, 'close'));
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
