"use strict";


var visibleQuestions = {
    whenToConsider: true,
    whenToConsiderText: false,
    mild: true,
    mupirocin: false,
    or: false,
    fusidicAcid: false,
    or2: false,
    neomycin: false,
    adults: true,
    firstLineComorbidities: false,
    flukloxacilin: false,
    alternativeAdults: false,
    klindamycin: false,
    children: true,
    firstLineChildren: false,
    amoxicilinClavulanic: false,
    alternativeChildren: false,
    klindamycinChildren: false,
    adultsPyogenes: true,
    firstLineAdultsPyogenes: false,
    fenoxymetylpenicilin: false,
    alternativeAdultsPyogenes: false,
    klindamycinAdultsPyogenes: false,
    childrenPyogenes: true,
    firstLineChildrenPyogenes: false,
    fenoxymetylpenicilinChildrenPyogens: false,
    alternativeChildrenPyogenes: false,
    klindamycinChildrenPyogenes: false,
    guidelines: true
};
var visibleSections = {
    antibiotics: true,
    choiceOfAntibiotic: true,
    staphylococcusAureus: true,
    streptococcusPyogenes: true,
    link: true
};
var inputs = {
    whenToConsider: null,
    mild: null,
    adults: null,
    children: null,
    adultsPyogenes: null,
    childrenPyogenes: null
};
var isWhenToConsiderClose = function () {
    return helpers_1.answerMatches(inputs.whenToConsider, 'close');
};
var isMildClose = function () {
    return helpers_1.answerMatches(inputs.mild, 'close');
};
var isAdultsClose = function () {
    return helpers_1.answerMatches(inputs.adults, 'close');
};
var isChildrenClose = function () {
    return helpers_1.answerMatches(inputs.children, 'close');
};
var isAdultsPyogenesClose = function () {
    return helpers_1.answerMatches(inputs.adultsPyogenes, 'close');
};
var isChildrenPyogenesClose = function () {
    return helpers_1.answerMatches(inputs.childrenPyogenes, 'close');
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.whenToConsiderText = isWhenToConsiderClose();
    visibleQuestions.mupirocin = isMildClose();
    visibleQuestions.or = isMildClose();
    visibleQuestions.fusidicAcid = isMildClose();
    visibleQuestions.or2 = isMildClose();
    visibleQuestions.neomycin = isMildClose();
    visibleQuestions.firstLineComorbidities = isAdultsClose();
    visibleQuestions.flukloxacilin = isAdultsClose();
    visibleQuestions.alternativeAdults = isAdultsClose();
    visibleQuestions.klindamycin = isAdultsClose();
    visibleQuestions.firstLineChildren = isChildrenClose();
    visibleQuestions.amoxicilinClavulanic = isChildrenClose();
    visibleQuestions.alternativeChildren = isChildrenClose();
    visibleQuestions.klindamycinChildren = isChildrenClose();
    visibleQuestions.firstLineAdultsPyogenes = isAdultsPyogenesClose();
    visibleQuestions.fenoxymetylpenicilin = isAdultsPyogenesClose();
    visibleQuestions.alternativeAdultsPyogenes = isAdultsPyogenesClose();
    visibleQuestions.klindamycinAdultsPyogenes = isAdultsPyogenesClose();
    visibleQuestions.firstLineChildrenPyogenes = isChildrenPyogenesClose();
    visibleQuestions.fenoxymetylpenicilinChildrenPyogens =
        isChildrenPyogenesClose();
    visibleQuestions.alternativeChildrenPyogenes = isChildrenPyogenesClose();
    visibleQuestions.klindamycinChildrenPyogenes = isChildrenPyogenesClose();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return (helpers_1.answerMatches(inputs.whenToConsider, 'close') ||
        helpers_1.answerMatches(inputs.mild, 'close') ||
        helpers_1.answerMatches(inputs.adults, 'close') ||
        helpers_1.answerMatches(inputs.children, 'close') ||
        helpers_1.answerMatches(inputs.adultsPyogenes, 'close') ||
        helpers_1.answerMatches(inputs.childrenPyogenes, 'close'));
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
