"use strict";


var visibleQuestions = {
    symptomatic: true,
    symptomaticText: false,
    whenToConsider: true,
    whenToConsiderText: false,
    news2: false,
    qSOFA: false,
    over16: true,
    firstLine: false,
    amoxClav: false,
    alternative: false,
    trimetoprim: false,
    guidelines: true
};
var visibleSections = {
    symptomaticTreatment: true,
    antibiotics: true,
    choiceOfAntibiotic: true,
    link: true
};
var inputs = {
    symptomatic: null,
    whenToConsider: null,
    over16: null
};
var isSymptomaticClose = function () {
    return helpers_1.answerMatches(inputs.symptomatic, 'close');
};
var isWhenToConsiderClose = function () {
    return helpers_1.answerMatches(inputs.whenToConsider, 'close');
};
var isOver16Close = function () {
    return helpers_1.answerMatches(inputs.over16, 'close');
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.symptomaticText = isSymptomaticClose();
    visibleQuestions.whenToConsiderText = isWhenToConsiderClose();
    visibleQuestions.news2 = isWhenToConsiderClose();
    visibleQuestions.qSOFA = isWhenToConsiderClose();
    visibleQuestions.firstLine = isOver16Close();
    visibleQuestions.amoxClav = isOver16Close();
    visibleQuestions.alternative = isOver16Close();
    visibleQuestions.trimetoprim = isOver16Close();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return (helpers_1.answerMatches(inputs.symptomatic, 'close') ||
        helpers_1.answerMatches(inputs.whenToConsider, 'close') ||
        helpers_1.answerMatches(inputs.over16, 'close'));
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
