"use strict";


var visibleQuestions = {
    symptomatic: true,
    symptomaticText: false,
    whenToConsider: true,
    whenToConsiderText: false,
    acuteCystitis: true,
    firstLine: false,
    nitrofurantoin: false,
    alternative: false,
    pivmecilinam: false,
    or: false,
    trimetoprim: false,
    acutePyelonephritis: true,
    firstLinePyelonephritis: false,
    amoxClav: false,
    alternativePyelonephritis: false,
    trimetoprim2: false,
    guidelines: true
};
var visibleSections = {
    symptomaticTreatment: true,
    antibiotics: true,
    choiceOfAntibiotic: true,
    link: true
};
var inputs = {
    symptomatic: null,
    whenToConsider: null,
    acuteCystitis: null,
    acutePyelonephritis: null
};
var isSymptomaticClose = function () {
    return helpers_1.answerMatches(inputs.symptomatic, 'close');
};
var isWhenToConsiderClose = function () {
    return helpers_1.answerMatches(inputs.whenToConsider, 'close');
};
var isAcuteCystitisClose = function () {
    return helpers_1.answerMatches(inputs.acuteCystitis, 'close');
};
var isAcutePyelonephritisClose = function () {
    return helpers_1.answerMatches(inputs.acutePyelonephritis, 'close');
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.symptomaticText = isSymptomaticClose();
    visibleQuestions.whenToConsiderText = isWhenToConsiderClose();
    visibleQuestions.firstLine = isAcuteCystitisClose();
    visibleQuestions.nitrofurantoin = isAcuteCystitisClose();
    visibleQuestions.alternative = isAcuteCystitisClose();
    visibleQuestions.pivmecilinam = isAcuteCystitisClose();
    visibleQuestions.or = isAcuteCystitisClose();
    visibleQuestions.trimetoprim = isAcuteCystitisClose();
    visibleQuestions.firstLinePyelonephritis = isAcutePyelonephritisClose();
    visibleQuestions.amoxClav = isAcutePyelonephritisClose();
    visibleQuestions.alternativePyelonephritis = isAcutePyelonephritisClose();
    visibleQuestions.trimetoprim2 = isAcutePyelonephritisClose();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return (helpers_1.answerMatches(inputs.symptomatic, 'close') ||
        helpers_1.answerMatches(inputs.whenToConsider, 'close') ||
        helpers_1.answerMatches(inputs.acuteCystitis, 'close') ||
        helpers_1.answerMatches(inputs.acutePyelonephritis, 'close'));
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
