"use strict";


var visibleQuestions = {
    age: true,
    form: false,
    noAnswer1: true,
    warningKids1: true,
    doseTabletsAdults: true,
    durationTabletsAdults: true,
    warningTabletsAdults: true,
    dosePowderSPCWarning: true,
    kidneyDisease1: true
};
var visibleSections = {
    inputs: true,
    noAnswer: false,
    warningKids: false,
    dosingTabletsAdults: false,
    dosingPowderSPCWarning: false,
    kidneyDisease: false
};
var inputs = {
    age: null,
    type: null
};
var isFormVisible = function () {
    return helpers_1.isAnswered(inputs.age);
};
var areAllVisibleQuesionsAnswered = function () {
    return (helpers_1.isAnswered(inputs.age) &&
        ((isFormVisible() && helpers_1.isAnswered(inputs.form)) || !isFormVisible()));
};
var isWarningKidsSectionVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'kids') &&
        isFormVisible() &&
        helpers_1.answerMatches(inputs.form, 'tablets'));
};
var isDosingTabletsAdultsSectionVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'adults') &&
        isFormVisible() &&
        helpers_1.answerMatches(inputs.form, 'tablets'));
};
var isDosingPowderSPCWarningSectionVisible = function () {
    return (helpers_1.isAnswered(inputs.age) &&
        isFormVisible() &&
        helpers_1.answerMatches(inputs.form, 'powder'));
};
var isKidneyDiseaseSectionVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'adults') &&
        isFormVisible() &&
        helpers_1.answerMatches(inputs.form, 'tablets'));
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.form = isFormVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = !areAllVisibleQuesionsAnswered();
    visibleSections.warningKids = isWarningKidsSectionVisible();
    visibleSections.dosingTabletsAdults = isDosingTabletsAdultsSectionVisible();
    visibleSections.dosingPowderSPCWarning =
        isDosingPowderSPCWarningSectionVisible();
    visibleSections.kidneyDisease = isKidneyDiseaseSectionVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return areAllVisibleQuesionsAnswered();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
