"use strict";


var visibleQuestions = {
    age: true,
    type: false,
    recurrence: false,
    noAnswer1: true,
    doseKids: true,
    doseTabletsAdultsHealthyA: true,
    divider1: true,
    doseTabletsAdultsHealthyB: true,
    divider2: true,
    doseTabletsAdultsHealthyC: true,
    durationTabletsAdultsHealthy: true,
    doseTabletsAdultsRecurrent: true,
    durationTabletsAdultsRecurrent: true,
    doseTabletsAdultsCompromised: true,
    durationTabletsAdultsCompromised: true,
    warningAdultsCompromised: true,
    doseTabletsAdultsVeryCompromised: true,
    durationTabletsAdultsVeryCompromised: true,
    warningTabletsAdultsVeryCompromised: true,
    kidneyDisease1: true
};
var visibleSections = {
    typeA: true,
    noAnswer: false,
    warningKids: false,
    dosingTabletsAdultsHealthy: false,
    dosingTabletsAdultsRecurrent: false,
    dosingTabletsAdultsCompromised: false,
    dosingTabletsAdultsVeryCompromised: false,
    kidneyDisease: false
};
var inputs = {
    age: null,
    type: null,
    recurrence: null
};
var isTypeVisible = function () {
    return helpers_1.answerMatches(inputs.age, 'adults');
};
var isRecurrenceVisible = function () {
    return helpers_1.answerMatches(inputs.type, 'healthy');
};
var areAllVisibleQuesionsAnswered = function () {
    return (helpers_1.isAnswered(inputs.age) &&
        ((isTypeVisible() && helpers_1.isAnswered(inputs.type)) || !isTypeVisible()) &&
        ((isRecurrenceVisible() && helpers_1.isAnswered(inputs.recurrence)) ||
            !isRecurrenceVisible()));
};
var isWarningKidsSectionVisible = function () {
    return helpers_1.answerMatches(inputs.age, 'kids');
};
var isDosingTabletsAdultsHealthySectionVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'adults') &&
        helpers_1.answerMatches(inputs.type, 'healthy') &&
        helpers_1.answerMatches(inputs.recurrence, 'no'));
};
var isDosingTabletsAdultsRecurrentSectionVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'adults') &&
        helpers_1.answerMatches(inputs.type, 'healthy') &&
        helpers_1.answerMatches(inputs.recurrence, 'yes'));
};
var isDosingTabletsAdultsCompromisedSectionVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'adults') &&
        helpers_1.answerMatches(inputs.type, 'compromised'));
};
var isDosingTabletsAdultsVeryCompromisedSectionVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'adults') &&
        helpers_1.answerMatches(inputs.type, 'veryCompromised'));
};
var isKidneyDiseaseSectionVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'adults') &&
        helpers_1.isAnswered(inputs.type) &&
        areAllVisibleQuesionsAnswered());
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.type = isTypeVisible();
    visibleQuestions.recurrence = isRecurrenceVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = !areAllVisibleQuesionsAnswered();
    visibleSections.warningKids = isWarningKidsSectionVisible();
    visibleSections.dosingTabletsAdultsHealthy =
        isDosingTabletsAdultsHealthySectionVisible();
    visibleSections.dosingTabletsAdultsRecurrent =
        isDosingTabletsAdultsRecurrentSectionVisible();
    visibleSections.dosingTabletsAdultsCompromised =
        isDosingTabletsAdultsCompromisedSectionVisible();
    visibleSections.dosingTabletsAdultsVeryCompromised =
        isDosingTabletsAdultsVeryCompromisedSectionVisible();
    visibleSections.kidneyDisease = isKidneyDiseaseSectionVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return areAllVisibleQuesionsAnswered();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
