"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    type: true,
    age: false,
    form: false,
    height: false,
    weight: false,
    gfr: false,
    gfrChildren: false,
    noAnswer1: true,
    dosingBabiesSMPCwarning1: true,
    doseTabletsAdults: true,
    durationTabletsAdults: true,
    doseTabletsAdultsGFR2: true,
    durationTabletsAdultsGFR2: true,
    doseTabletsAdultsGFR1: true,
    durationTabletsAdultsGFR1: true,
    dosePowderKids: true,
    durationPowderKids: true,
    dosePowderKidsGFR3: true,
    durationPowderKidsGFR3: true,
    dosePowderKidsGFR2: true,
    durationPowderKidsGFR2: true,
    dosePowderKidsGFR1: true,
    durationPowderKidsGFR1: true,
    dosePowderKidsHigh: true,
    durationPowderKidsHigh: true,
    dosePowderKidsHighGFR3: true,
    durationPowderKidsHighGFR3: true,
    dosePowderKidsHighGFR2: true,
    durationPowderKidsHighGFR2: true,
    dosePowderKidsHighGFR1: true,
    durationPowderKidsHighGFR1: true,
    dosePowderOther: true,
    durationPowderOther: true,
    adiposeWarningPowderOther: false,
    dosePowderOtherGFR3: true,
    durationPowderOtherGFR3: true,
    adiposeWarningPowderAdultsGFR3: false,
    dosePowderOtherGFR2: true,
    durationPowderOtherGFR2: true,
    adiposeWarningPowderAdultsGFR2: false,
    dosePowderAdultsGFR1: true,
    durationPowderAdultsGFR1: true,
    adiposeWarningPowderAdultsGFR1: false,
    dosePowderAdultsHigh: true,
    durationPowderAdultsHigh: true,
    adiposeWarningPowderAdultsHigh: false,
    dosePowderAdultsHighGFR3: true,
    durationPowderAdultsHighGFR3: true,
    adiposeWarningPowderAdultsHighGFR3: false,
    dosePowderAdultsHighGFR2: true,
    durationPowderAdultsHighGFR2: true,
    adiposeWarningPowderAdultsHighGFR2: false,
    dosePowderAdultsHighGFR1: true,
    durationPowderAdultsHighGFR1: true,
    adiposeWarningPowderAdultsHighGFR1: false
};
var visibleSections = {
    inputs: true,
    noAnswer: false,
    dosingBabiesSMPCwarning: false,
    dosingTabletsAdults: false,
    dosingTabletsAdultsGFR2: false,
    dosingTabletsAdultsGFR1: false,
    dosingPowderKids: false,
    dosingPowderKidsGFR3: false,
    dosingPowderKidsGFR2: false,
    dosingPowderKidsGFR1: false,
    dosingPowderKidsHigh: false,
    dosingPowderKidsHighGFR3: false,
    dosingPowderKidsHighGFR2: false,
    dosingPowderKidsHighGFR1: false,
    dosingPowderAdults: false,
    dosingPowderAdultsGFR3: false,
    dosingPowderAdultsGFR2: false,
    dosingPowderAdultsGFR1: false,
    dosingPowderAdultsHigh: false,
    dosingPowderAdultsHighGFR3: false,
    dosingPowderAdultsHighGFR2: false,
    dosingPowderAdultsHighGFR1: false
};
var inputs = {
    type: null,
    age: null,
    form: null,
    height: null,
    weight: null,
    gfr: null,
    gfrChildren: null
};
var isHeightValid = function () {
    return helpers_1.numberInLimits({ input: inputs.height, min: 1, max: 180 });
};
var isWeightValid = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 200 });
};
var isWeightMoreOrEqual70 = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 70, max: 200 });
};
var isAgeVisible = function () {
    return helpers_1.isAnswered(inputs.type);
};
var isFormVisible = function () {
    return (helpers_1.answerMatches(inputs.type, 'zoster') &&
        isAgeVisible() &&
        helpers_1.answerMatches(inputs.age, 'adults'));
};
var isHeightVisible = function () {
    return (helpers_1.isAnswered(inputs.type) &&
        isAgeVisible() &&
        helpers_1.answerMatches(inputs.age, 'kids'));
};
var isWeightVisible = function () {
    return (helpers_1.isAnswered(inputs.type) &&
        isAgeVisible() &&
        (helpers_1.answerMatches(inputs.age, 'kids') ||
            helpers_1.answerMatches(inputs.age, 'adolescents') ||
            helpers_1.answerMatches(inputs.age, 'adults')) &&
        ((isFormVisible() && helpers_1.answerMatches(inputs.form, 'powder')) ||
            !isFormVisible()));
};
var isGfrVisible = function () {
    return (helpers_1.isAnswered(inputs.type) &&
        isAgeVisible() &&
        (helpers_1.answerMatches(inputs.age, 'adolescents') ||
            helpers_1.answerMatches(inputs.age, 'adults')) &&
        ((isFormVisible() && helpers_1.isAnswered(inputs.form)) || !isFormVisible()) &&
        ((isWeightVisible() && isWeightValid()) || !isWeightVisible()));
};
var isGfrChildrenVisible = function () {
    return (helpers_1.isAnswered(inputs.type) &&
        isAgeVisible() &&
        helpers_1.answerMatches(inputs.age, 'kids') &&
        isHeightVisible() &&
        isHeightValid() &&
        isWeightVisible() &&
        isWeightValid());
};
var areAllVisibleQuesionsAnswered = function () {
    return (helpers_1.isAnswered(inputs.type) &&
        ((isAgeVisible() && helpers_1.isAnswered(inputs.age)) || !isAgeVisible()) &&
        ((isFormVisible() && helpers_1.isAnswered(inputs.form)) || !isFormVisible()) &&
        ((isHeightVisible() && isHeightValid()) || !isHeightVisible()) &&
        ((isWeightVisible() && isWeightValid()) || !isWeightVisible()) &&
        ((isGfrVisible() && helpers_1.isAnswered(inputs.gfr)) || !isGfrVisible()) &&
        ((isGfrChildrenVisible() && helpers_1.isAnswered(inputs.gfrChildren)) ||
            !isGfrChildrenVisible()));
};
var isDosingBabiesSMPCwarningSectionVisible = function () {
    return (helpers_1.isAnswered(inputs.type) &&
        isAgeVisible() &&
        helpers_1.answerMatches(inputs.age, 'babies'));
};
var isDosingTabletsAdultsSectionVisible = function () {
    return (helpers_1.answerMatches(inputs.type, 'zoster') &&
        isAgeVisible() &&
        helpers_1.answerMatches(inputs.age, 'adults') &&
        isFormVisible() &&
        helpers_1.answerMatches(inputs.form, 'tablets') &&
        isGfrVisible() &&
        (helpers_1.answerMatches(inputs.gfr, 'gfr3') || helpers_1.answerMatches(inputs.gfr, 'gfr4')));
};
var isDosingTabletsAdultsGFR2SectionVisible = function () {
    return (helpers_1.answerMatches(inputs.type, 'zoster') &&
        isAgeVisible() &&
        helpers_1.answerMatches(inputs.age, 'adults') &&
        isFormVisible() &&
        helpers_1.answerMatches(inputs.form, 'tablets') &&
        isGfrVisible() &&
        helpers_1.answerMatches(inputs.gfr, 'gfr2'));
};
var isDosingTabletsAdultsGFR1SectionVisible = function () {
    return (helpers_1.answerMatches(inputs.type, 'zoster') &&
        isAgeVisible() &&
        helpers_1.answerMatches(inputs.age, 'adults') &&
        isFormVisible() &&
        helpers_1.answerMatches(inputs.form, 'tablets') &&
        isGfrVisible() &&
        helpers_1.answerMatches(inputs.gfr, 'gfr1'));
};
var isDosingPowderKidsSectionVisible = function () {
    return (helpers_1.answerMatches(inputs.type, 'zoster') &&
        isAgeVisible() &&
        helpers_1.answerMatches(inputs.age, 'kids') &&
        isHeightVisible() &&
        isHeightValid() &&
        isWeightVisible() &&
        isWeightValid() &&
        isGfrChildrenVisible() &&
        helpers_1.answerMatches(inputs.gfrChildren, 'gfrC4'));
};
var isDosingPowderKidsGFR3SectionVisible = function () {
    return (helpers_1.answerMatches(inputs.type, 'zoster') &&
        isAgeVisible() &&
        helpers_1.answerMatches(inputs.age, 'kids') &&
        isHeightVisible() &&
        isHeightValid() &&
        isWeightVisible() &&
        isWeightValid() &&
        isGfrChildrenVisible() &&
        helpers_1.answerMatches(inputs.gfrChildren, 'gfrC3'));
};
var isDosingPowderKidsGFR2SectionVisible = function () {
    return (helpers_1.answerMatches(inputs.type, 'zoster') &&
        isAgeVisible() &&
        helpers_1.answerMatches(inputs.age, 'kids') &&
        isHeightVisible() &&
        isHeightValid() &&
        isWeightVisible() &&
        isWeightValid() &&
        isGfrChildrenVisible() &&
        helpers_1.answerMatches(inputs.gfrChildren, 'gfrC2'));
};
var isDosingPowderKidsGFR1SectionVisible = function () {
    return (helpers_1.answerMatches(inputs.type, 'zoster') &&
        isAgeVisible() &&
        helpers_1.answerMatches(inputs.age, 'kids') &&
        isHeightVisible() &&
        isHeightValid() &&
        isWeightVisible() &&
        isWeightValid() &&
        isGfrChildrenVisible() &&
        helpers_1.answerMatches(inputs.gfrChildren, 'gfrC1'));
};
var isDosingPowderKidsHighSectionVisible = function () {
    return ((helpers_1.answerMatches(inputs.type, 'zosterCompromised') ||
        helpers_1.answerMatches(inputs.type, 'varicellaCompromised')) &&
        isAgeVisible() &&
        helpers_1.answerMatches(inputs.age, 'kids') &&
        isHeightVisible() &&
        isHeightValid() &&
        isWeightVisible() &&
        isWeightValid() &&
        isGfrChildrenVisible() &&
        helpers_1.answerMatches(inputs.gfrChildren, 'gfrC4'));
};
var isDosingPowderKidsHighGFR3SectionVisible = function () {
    return ((helpers_1.answerMatches(inputs.type, 'zosterCompromised') ||
        helpers_1.answerMatches(inputs.type, 'varicellaCompromised')) &&
        isAgeVisible() &&
        helpers_1.answerMatches(inputs.age, 'kids') &&
        isHeightVisible() &&
        isHeightValid() &&
        isWeightVisible() &&
        isWeightValid() &&
        isGfrChildrenVisible() &&
        helpers_1.answerMatches(inputs.gfrChildren, 'gfrC3'));
};
var isDosingPowderKidsHighGFR2SectionVisible = function () {
    return ((helpers_1.answerMatches(inputs.type, 'zosterCompromised') ||
        helpers_1.answerMatches(inputs.type, 'varicellaCompromised')) &&
        isAgeVisible() &&
        helpers_1.answerMatches(inputs.age, 'kids') &&
        isHeightVisible() &&
        isHeightValid() &&
        isWeightVisible() &&
        isWeightValid() &&
        isGfrChildrenVisible() &&
        helpers_1.answerMatches(inputs.gfrChildren, 'gfrC2'));
};
var isDosingPowderKidsHighGFR1SectionVisible = function () {
    return ((helpers_1.answerMatches(inputs.type, 'zosterCompromised') ||
        helpers_1.answerMatches(inputs.type, 'varicellaCompromised')) &&
        isAgeVisible() &&
        helpers_1.answerMatches(inputs.age, 'kids') &&
        isHeightVisible() &&
        isHeightValid() &&
        isWeightVisible() &&
        isWeightValid() &&
        isGfrChildrenVisible() &&
        helpers_1.answerMatches(inputs.gfrChildren, 'gfrC1'));
};
var isDosingPowderAdultsSectionVisible = function () {
    return (helpers_1.answerMatches(inputs.type, 'zoster') &&
        isAgeVisible() &&
        (helpers_1.answerMatches(inputs.age, 'adolescents') ||
            helpers_1.answerMatches(inputs.age, 'adults')) &&
        ((isFormVisible() && helpers_1.answerMatches(inputs.form, 'powder')) ||
            !isFormVisible()) &&
        isWeightVisible() &&
        isWeightValid() &&
        isGfrVisible() &&
        helpers_1.answerMatches(inputs.gfr, 'gfr4'));
};
var isDosingPowderAdultsGFR3SectionVisible = function () {
    return (helpers_1.answerMatches(inputs.type, 'zoster') &&
        isAgeVisible() &&
        (helpers_1.answerMatches(inputs.age, 'adolescents') ||
            helpers_1.answerMatches(inputs.age, 'adults')) &&
        ((isFormVisible() && helpers_1.answerMatches(inputs.form, 'powder')) ||
            !isFormVisible()) &&
        isWeightVisible() &&
        isWeightValid() &&
        isGfrVisible() &&
        helpers_1.answerMatches(inputs.gfr, 'gfr3'));
};
var isDosingPowderAdultsGFR2SectionVisible = function () {
    return (helpers_1.answerMatches(inputs.type, 'zoster') &&
        isAgeVisible() &&
        (helpers_1.answerMatches(inputs.age, 'adolescents') ||
            helpers_1.answerMatches(inputs.age, 'adults')) &&
        ((isFormVisible() && helpers_1.answerMatches(inputs.form, 'powder')) ||
            !isFormVisible()) &&
        isWeightVisible() &&
        isWeightValid() &&
        isGfrVisible() &&
        helpers_1.answerMatches(inputs.gfr, 'gfr2'));
};
var isDosingPowderAdultsGFR1SectionVisible = function () {
    return (helpers_1.answerMatches(inputs.type, 'zoster') &&
        isAgeVisible() &&
        (helpers_1.answerMatches(inputs.age, 'adolescents') ||
            helpers_1.answerMatches(inputs.age, 'adults')) &&
        ((isFormVisible() && helpers_1.answerMatches(inputs.form, 'powder')) ||
            !isFormVisible()) &&
        isWeightVisible() &&
        isWeightValid() &&
        isGfrVisible() &&
        helpers_1.answerMatches(inputs.gfr, 'gfr1'));
};
var isDosingPowderAdultsHighSectionVisible = function () {
    return ((helpers_1.answerMatches(inputs.type, 'zosterCompromised') ||
        helpers_1.answerMatches(inputs.type, 'varicellaCompromised')) &&
        isAgeVisible() &&
        (helpers_1.answerMatches(inputs.age, 'adolescents') ||
            helpers_1.answerMatches(inputs.age, 'adults')) &&
        isWeightVisible() &&
        isWeightValid() &&
        isGfrVisible() &&
        helpers_1.answerMatches(inputs.gfr, 'gfr4'));
};
var isDosingPowderAdultsHighGFR3SectionVisible = function () {
    return ((helpers_1.answerMatches(inputs.type, 'zosterCompromised') ||
        helpers_1.answerMatches(inputs.type, 'varicellaCompromised')) &&
        isAgeVisible() &&
        (helpers_1.answerMatches(inputs.age, 'adolescents') ||
            helpers_1.answerMatches(inputs.age, 'adults')) &&
        isWeightVisible() &&
        isWeightValid() &&
        isGfrVisible() &&
        helpers_1.answerMatches(inputs.gfr, 'gfr3'));
};
var isDosingPowderAdultsHighGFR2SectionVisible = function () {
    return ((helpers_1.answerMatches(inputs.type, 'zosterCompromised') ||
        helpers_1.answerMatches(inputs.type, 'varicellaCompromised')) &&
        isAgeVisible() &&
        (helpers_1.answerMatches(inputs.age, 'adolescents') ||
            helpers_1.answerMatches(inputs.age, 'adults')) &&
        isWeightVisible() &&
        isWeightValid() &&
        isGfrVisible() &&
        helpers_1.answerMatches(inputs.gfr, 'gfr2'));
};
var isDosingPowderAdultsHighGFR1SectionVisible = function () {
    return ((helpers_1.answerMatches(inputs.type, 'zosterCompromised') ||
        helpers_1.answerMatches(inputs.type, 'varicellaCompromised')) &&
        isAgeVisible() &&
        (helpers_1.answerMatches(inputs.age, 'adolescents') ||
            helpers_1.answerMatches(inputs.age, 'adults')) &&
        isWeightVisible() &&
        isWeightValid() &&
        isGfrVisible() &&
        helpers_1.answerMatches(inputs.gfr, 'gfr1'));
};
var calculateBsa = function () {
    var _a, _b;
    return Math.sqrt((((_a = inputs.height) === null || _a === void 0 ? void 0 : _a.currentPoints) * ((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints)) / 3600);
};
var calculateBsa500 = function () {
    return Math.round(500 * calculateBsa());
};
var calculateBsa250 = function () {
    return Math.round(250 * calculateBsa());
};
var calculateBsa125 = function () {
    return Math.round(125 * calculateBsa());
};
var calculateWeight5 = function () {
    var _a;
    return Math.round(5 * ((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints));
};
var calculateWeight2Point5 = function () {
    var _a;
    return Math.round(2.5 * ((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints));
};
var calculateWeight10 = function () {
    var _a;
    return Math.round(10 * ((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints));
};
var calculatePoints = function () {
    if (isDosingPowderKidsSectionVisible()) {
        return {
            dosePowderKids: {
                qID: 'dosePowderKids',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(calculateBsa250(), 0), 0, 0)),
                titleTexts: 'dosePowderKids1'
            }
        };
    }
    if (isDosingPowderKidsGFR3SectionVisible()) {
        return {
            dosePowderKidsGFR3: {
                qID: 'dosePowderKidsGFR3',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(calculateBsa250(), 0), 0, 0)),
                titleTexts: 'dosePowderKids1GFR3'
            }
        };
    }
    if (isDosingPowderKidsGFR2SectionVisible()) {
        return {
            dosePowderKidsGFR2: {
                qID: 'dosePowderKidsGFR2',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(calculateBsa250(), 0), 0, 0)),
                titleTexts: 'dosePowderKids1GFR2'
            }
        };
    }
    if (isDosingPowderKidsGFR1SectionVisible()) {
        return {
            dosePowderKidsGFR1: {
                qID: 'dosePowderKidsGFR1',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(calculateBsa125(), 0), 0, 0)),
                titleTexts: 'dosePowderKids1GFR1'
            }
        };
    }
    if (isDosingPowderKidsHighSectionVisible()) {
        return {
            dosePowderKidsHigh: {
                qID: 'dosePowderKidsHigh',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(calculateBsa500(), 0), 0, 0)),
                titleTexts: 'dosePowderKidsHigh2'
            }
        };
    }
    if (isDosingPowderKidsHighGFR3SectionVisible()) {
        return {
            dosePowderKidsHighGFR3: {
                qID: 'dosePowderKidsHighGFR3',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(calculateBsa500(), 0), 0, 0)),
                titleTexts: 'dosePowderKidsHigh2'
            }
        };
    }
    if (isDosingPowderKidsHighGFR2SectionVisible()) {
        return {
            dosePowderKidsHighGFR2: {
                qID: 'dosePowderKidsHighGFR2',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(calculateBsa500(), 0), 0, 0)),
                titleTexts: 'dosePowderKidsHigh2'
            }
        };
    }
    if (isDosingPowderKidsHighGFR1SectionVisible()) {
        return {
            dosePowderKidsHighGFR1: {
                qID: 'dosePowderKidsHighGFR1',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(calculateBsa250(), 0), 0, 0)),
                titleTexts: 'dosePowderKidsHigh2'
            }
        };
    }
    if (isDosingPowderAdultsSectionVisible()) {
        return {
            dosePowderOther: {
                qID: 'dosePowderOther',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(calculateWeight5(), 0), 0, 0)),
                titleTexts: 'dosePowderOther2'
            }
        };
    }
    if (isDosingPowderAdultsGFR3SectionVisible()) {
        return {
            dosePowderOtherGFR3: {
                qID: 'dosePowderOtherGFR3',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(calculateWeight5(), 0), 0, 0)),
                titleTexts: 'dosePowderOtherGFR32'
            }
        };
    }
    if (isDosingPowderAdultsGFR2SectionVisible()) {
        return {
            dosePowderOtherGFR2: {
                qID: 'dosePowderOtherGFR2',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(calculateWeight5(), 0), 0, 0)),
                titleTexts: 'dosePowderOtherGFR2'
            }
        };
    }
    if (isDosingPowderAdultsGFR1SectionVisible()) {
        return {
            dosePowderAdultsGFR1: {
                qID: 'dosePowderAdultsGFR1',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(calculateWeight2Point5(), 0), 0, 0)),
                titleTexts: 'dosePowderAdultsGFR1'
            }
        };
    }
    if (isDosingPowderAdultsHighSectionVisible()) {
        return {
            dosePowderAdultsHigh: {
                qID: 'dosePowderAdultsHigh',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(calculateWeight10(), 0), 0, 0)),
                titleTexts: 'dosePowderAdultsHigh'
            }
        };
    }
    if (isDosingPowderAdultsHighGFR3SectionVisible()) {
        return {
            dosePowderAdultsHighGFR3: {
                qID: 'dosePowderAdultsHighGFR3',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(calculateWeight10(), 0), 0, 0)),
                titleTexts: 'dosePowderAdultsHighGFR3'
            }
        };
    }
    if (isDosingPowderAdultsHighGFR2SectionVisible()) {
        return {
            dosePowderAdultsHighGFR2: {
                qID: 'dosePowderAdultsHighGFR2',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(calculateWeight10(), 0), 0, 0)),
                titleTexts: 'dosePowderAdultsHighGFR2'
            }
        };
    }
    if (isDosingPowderAdultsHighGFR1SectionVisible()) {
        return {
            dosePowderAdultsHighGFR1: {
                qID: 'dosePowderAdultsHighGFR1',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(calculateWeight5(), 0), 0, 0)),
                titleTexts: 'dosePowderAdultsHighGFR1'
            }
        };
    }
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.age = isAgeVisible();
    visibleQuestions.form = isFormVisible();
    visibleQuestions.height = isHeightVisible();
    visibleQuestions.weight = isWeightVisible();
    visibleQuestions.gfr = isGfrVisible();
    visibleQuestions.gfrChildren = isGfrChildrenVisible();
    visibleQuestions.adiposeWarningPowderOther = isWeightMoreOrEqual70();
    visibleQuestions.adiposeWarningPowderAdultsGFR3 = isWeightMoreOrEqual70();
    visibleQuestions.adiposeWarningPowderAdultsGFR2 = isWeightMoreOrEqual70();
    visibleQuestions.adiposeWarningPowderAdultsGFR1 = isWeightMoreOrEqual70();
    visibleQuestions.adiposeWarningPowderAdultsHigh = isWeightMoreOrEqual70();
    visibleQuestions.adiposeWarningPowderAdultsHighGFR3 = isWeightMoreOrEqual70();
    visibleQuestions.adiposeWarningPowderAdultsHighGFR2 = isWeightMoreOrEqual70();
    visibleQuestions.adiposeWarningPowderAdultsHighGFR1 = isWeightMoreOrEqual70();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = !areAllVisibleQuesionsAnswered();
    visibleSections.dosingBabiesSMPCwarning =
        isDosingBabiesSMPCwarningSectionVisible();
    visibleSections.dosingTabletsAdults = isDosingTabletsAdultsSectionVisible();
    visibleSections.dosingTabletsAdultsGFR2 =
        isDosingTabletsAdultsGFR2SectionVisible();
    visibleSections.dosingTabletsAdultsGFR1 =
        isDosingTabletsAdultsGFR1SectionVisible();
    visibleSections.dosingPowderKids = isDosingPowderKidsSectionVisible();
    visibleSections.dosingPowderKidsGFR3 = isDosingPowderKidsGFR3SectionVisible();
    visibleSections.dosingPowderKidsGFR2 = isDosingPowderKidsGFR2SectionVisible();
    visibleSections.dosingPowderKidsGFR1 = isDosingPowderKidsGFR1SectionVisible();
    visibleSections.dosingPowderKidsHigh = isDosingPowderKidsHighSectionVisible();
    visibleSections.dosingPowderKidsHighGFR3 =
        isDosingPowderKidsHighGFR3SectionVisible();
    visibleSections.dosingPowderKidsHighGFR2 =
        isDosingPowderKidsHighGFR2SectionVisible();
    visibleSections.dosingPowderKidsHighGFR1 =
        isDosingPowderKidsHighGFR1SectionVisible();
    visibleSections.dosingPowderAdults = isDosingPowderAdultsSectionVisible();
    visibleSections.dosingPowderAdultsGFR3 =
        isDosingPowderAdultsGFR3SectionVisible();
    visibleSections.dosingPowderAdultsGFR2 =
        isDosingPowderAdultsGFR2SectionVisible();
    visibleSections.dosingPowderAdultsGFR1 =
        isDosingPowderAdultsGFR1SectionVisible();
    visibleSections.dosingPowderAdultsHigh =
        isDosingPowderAdultsHighSectionVisible();
    visibleSections.dosingPowderAdultsHighGFR3 =
        isDosingPowderAdultsHighGFR3SectionVisible();
    visibleSections.dosingPowderAdultsHighGFR2 =
        isDosingPowderAdultsHighGFR2SectionVisible();
    visibleSections.dosingPowderAdultsHighGFR1 =
        isDosingPowderAdultsHighGFR1SectionVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return areAllVisibleQuesionsAnswered();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
