"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    weight: true,
    age: true,
    result11: true,
    resultEnterWeight: true,
    result311: true,
    result312: true,
    result411: true,
    result412: true,
    result413: true,
    resultConsideration42: true,
    suspensionAD1: true,
    suspensionAD2: true,
    suspensionAD3: true,
    suspensionAD4: true,
    kidneyFirst: true,
    kidneySecond: true
};
var visibleSections = {
    weightSection: true,
    result1: true,
    result2: true,
    result31: true,
    result41: true,
    result42: true,
    suspensionAD: true,
    kidneySection: true
};
var inputs = {
    weight: null,
    age: null
};
var isResultVisible = function (section) {
    var _a;
    if (section === 1) {
        return helpers_1.isAnswered(inputs.age) && ((_a = inputs.age) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === 'less2';
    }
    if (section === 2) {
        return !helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 300 });
    }
    if (section === 3) {
        return helpers_1.numberInLimits({ input: inputs.weight, min: 40, max: 300 });
    }
    if (section === 4) {
        return (helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 39.99 }) &&
            (!isAgeVisible() ||
                (isAgeVisible() && helpers_1.answerMatches(inputs.age, 'moreOrEquals2'))));
    }
    return false;
};
var isAgeVisible = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 9.99 });
};
var isKidneySectionVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 300 }) &&
        (!isAgeVisible() ||
            (isAgeVisible() && helpers_1.answerMatches(inputs.age, 'moreOrEquals2'))));
};
var isSuspensionADVisible = function () {
    var _a;
    return ((_a = inputs._countryCode) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === 'de' && isResultVisible(3);
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    var res4111 = 0;
    var res4112 = 0;
    var res4121 = 0;
    var res4122 = 0;
    var res4123 = 0;
    var res4124 = 0;
    var res4131 = 0;
    var res4132 = 0;
    var res4133 = 0;
    var res4134 = 0;
    if (helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 300 }) &&
        isResultVisible(4)) {
        res4111 = (25 * Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints)) / 160;
        res4112 = (45 * Number((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints)) / 160;
        res4121 = 12.5 * Number((_c = inputs.weight) === null || _c === void 0 ? void 0 : _c.currentPoints);
        res4122 = 22.5 * Number((_d = inputs.weight) === null || _d === void 0 ? void 0 : _d.currentPoints);
        res4123 = 25 * Number((_e = inputs.weight) === null || _e === void 0 ? void 0 : _e.currentPoints);
        res4124 = 45 * Number((_f = inputs.weight) === null || _f === void 0 ? void 0 : _f.currentPoints);
        res4131 = 1.8 * Number((_g = inputs.weight) === null || _g === void 0 ? void 0 : _g.currentPoints);
        res4132 = 3.2 * Number((_h = inputs.weight) === null || _h === void 0 ? void 0 : _h.currentPoints);
        res4133 = 3.6 * Number((_j = inputs.weight) === null || _j === void 0 ? void 0 : _j.currentPoints);
        res4134 = 6.4 * Number((_k = inputs.weight) === null || _k === void 0 ? void 0 : _k.currentPoints);
    }
    return {
        result: 0,
        range: 0,
        result11: {
            qID: 'result11',
            rParams: [],
            resultTexts: 'regular'
        },
        result311: {
            qID: 'result311',
            tParams: [],
            rParams: [],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        result312: {
            qID: 'result312',
            tParams: [],
            rParams: [],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        result411: {
            qID: 'result411',
            tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(res4111, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(res4112, 1), 0, 1)),
            titleTexts: 'result1'
        },
        kidneyFirst: {
            qID: 'kidneyFirst',
            tParams: [],
            titleTexts: 'result1'
        },
        kidneySecond: {
            qID: 'kidneySecond',
            tParams: [],
            titleTexts: 'result1'
        },
        suspensionAD1: {
            qID: 'suspensionAD1',
            tParams: [],
            rParams: [],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        suspensionAD2: {
            qID: 'suspensionAD2',
            tParams: [],
            rParams: [],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        suspensionAD3: {
            qID: 'suspensionAD3',
            tParams: [],
            rParams: [],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        suspensionAD4: {
            qID: 'suspensionAD4',
            tParams: [],
            rParams: [],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        result412: {
            qID: 'result412',
            tParams: [],
            rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(res4121, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(res4122, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(res4123, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(res4124, 1), 0, 1)),
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        result413: {
            qID: 'result413',
            tParams: [],
            rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(res4131, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(res4132, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(res4133, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(res4134, 1), 0, 1)),
            titleTexts: 'regular',
            resultTexts: 'regular'
        }
    };
};
var isExportResultsEnabled = function () {
    return !isResultVisible(2);
};
var returnVisibleQuestions = function () {
    visibleQuestions.age = isAgeVisible();
    visibleQuestions.result11 = isResultVisible(1);
    visibleQuestions.resultEnterWeight = isResultVisible(2);
    visibleQuestions.result311 = isResultVisible(3);
    visibleQuestions.result312 = isResultVisible(3);
    visibleQuestions.result411 = isResultVisible(4);
    visibleQuestions.result412 = isResultVisible(4);
    visibleQuestions.result413 = isResultVisible(4);
    visibleQuestions.resultConsideration42 = isKidneySectionVisible();
    visibleQuestions.suspensionAD1 = isSuspensionADVisible();
    visibleQuestions.suspensionAD2 = isSuspensionADVisible();
    visibleQuestions.suspensionAD3 = isSuspensionADVisible();
    visibleQuestions.suspensionAD4 = isSuspensionADVisible();
    visibleQuestions.kidneyFirst = isKidneySectionVisible();
    visibleQuestions.kidneySecond = isKidneySectionVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.result1 = isResultVisible(1);
    visibleSections.result2 = isResultVisible(2);
    visibleSections.result31 = isResultVisible(3);
    visibleSections.result41 = isResultVisible(4);
    visibleSections.result42 = isKidneySectionVisible();
    visibleSections.kidneySection = isKidneySectionVisible();
    visibleSections.suspensionAD = isSuspensionADVisible();
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: calculatePoints(),
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
