"use strict";


var visibleQuestions = {
    weight: true,
    kidney: false,
    dialysis: false,
    kind: false,
    noAnswer: true,
    dosing1: true,
    tabletsAdults1: true,
    tabletsAdults3: true,
    tabletsAdults1Middle: true,
    tabletsAdults3Middle: true,
    tabletsAdults1Low: true,
    tabletsAdults3Low: true,
    powderAdults1: true,
    powderAdults3: true,
    powderAdults1Middle: true,
    powderAdults3Middle: true,
    powderAdults1Low: true,
    powderAdults3Low: true,
    tblDialyHem1: true,
    tblDialyHem2: true,
    pwdDialyHem1: true,
    pwdDialyHem2: true,
    anti: true
};
var visibleSections = {
    inputSection: true,
    dosing: false,
    dosingKids: false,
    tabletsAdults: false,
    tabletsAdultsMiddle: false,
    tabletsAdultsLow: false,
    powderAdults: false,
    powderAdultsMiddle: false,
    powderAdultsLow: false,
    tblDialyHem: false,
    pwdDialyHem: false,
    warningAb: false
};
var inputs = {
    weight: null,
    kidney: null,
    dialysis: null,
    kind: null
};
var isKidneyVisible = function () {
    return helpers_1.answerMatches(inputs.weight, 'more40');
};
var isDialysisVisible = function () {
    return (helpers_1.answerMatches(inputs.weight, 'more40') &&
        isKidneyVisible() &&
        helpers_1.answerMatches(inputs.kidney, 'low'));
};
var isKindVisible = function () {
    return (helpers_1.answerMatches(inputs.weight, 'more40') &&
        isKidneyVisible() &&
        helpers_1.answerMatches(inputs.kidney, 'low') &&
        isDialysisVisible() &&
        helpers_1.answerMatches(inputs.dialysis, 'yes'));
};
var areAllVisibleQuesionsAnswered = function () {
    return (helpers_1.isAnswered(inputs.weight) &&
        ((isKidneyVisible() && helpers_1.isAnswered(inputs.kidney)) || !isKidneyVisible()) &&
        ((isDialysisVisible() && helpers_1.isAnswered(inputs.dialysis)) ||
            !isDialysisVisible()) &&
        ((isKindVisible() && helpers_1.isAnswered(inputs.kind)) || !isKindVisible()));
};
var isDosingKidsSectionVisible = function () {
    return helpers_1.answerMatches(inputs.weight, 'less40');
};
var isTabletsAdultsSectionVisible = function () {
    return (helpers_1.answerMatches(inputs.weight, 'more40') &&
        isKidneyVisible() &&
        helpers_1.answerMatches(inputs.kidney, 'high'));
};
var isTabletsAdultsMiddleSectionVisible = function () {
    return (helpers_1.answerMatches(inputs.weight, 'more40') &&
        isKidneyVisible() &&
        helpers_1.answerMatches(inputs.kidney, 'middle'));
};
var isTabletsAdultsLowSectionVisible = function () {
    return ((helpers_1.answerMatches(inputs.weight, 'more40') &&
        isKidneyVisible() &&
        helpers_1.answerMatches(inputs.kidney, 'low') &&
        isDialysisVisible() &&
        helpers_1.answerMatches(inputs.dialysis, 'no')) ||
        (helpers_1.answerMatches(inputs.weight, 'more40') &&
            isKidneyVisible() &&
            helpers_1.answerMatches(inputs.kidney, 'low') &&
            isDialysisVisible() &&
            helpers_1.answerMatches(inputs.dialysis, 'yes') &&
            isKindVisible() &&
            helpers_1.answerMatches(inputs.kind, 'perito')));
};
var isPowderAdultsSectionVisible = function () {
    return (helpers_1.answerMatches(inputs.weight, 'more40') &&
        isKidneyVisible() &&
        helpers_1.answerMatches(inputs.kidney, 'high'));
};
var isPowderAdultsMiddleSectionVisible = function () {
    return (helpers_1.answerMatches(inputs.weight, 'more40') &&
        isKidneyVisible() &&
        helpers_1.answerMatches(inputs.kidney, 'middle'));
};
var isPowderAdultsLowSectionVisible = function () {
    return ((helpers_1.answerMatches(inputs.weight, 'more40') &&
        isKidneyVisible() &&
        helpers_1.answerMatches(inputs.kidney, 'low') &&
        isDialysisVisible() &&
        helpers_1.answerMatches(inputs.dialysis, 'no')) ||
        (helpers_1.answerMatches(inputs.weight, 'more40') &&
            isKidneyVisible() &&
            helpers_1.answerMatches(inputs.kidney, 'low') &&
            isDialysisVisible() &&
            helpers_1.answerMatches(inputs.dialysis, 'yes') &&
            isKindVisible() &&
            helpers_1.answerMatches(inputs.kind, 'perito')));
};
var isTblDialyHemSectionVisible = function () {
    return (helpers_1.answerMatches(inputs.weight, 'more40') &&
        isKidneyVisible() &&
        helpers_1.answerMatches(inputs.kidney, 'low') &&
        isDialysisVisible() &&
        helpers_1.answerMatches(inputs.dialysis, 'yes') &&
        isKindVisible() &&
        helpers_1.answerMatches(inputs.kind, 'hemo'));
};
var isPwdDialyHemSectionVisible = function () {
    return (helpers_1.answerMatches(inputs.weight, 'more40') &&
        isKidneyVisible() &&
        helpers_1.answerMatches(inputs.kidney, 'low') &&
        isDialysisVisible() &&
        helpers_1.answerMatches(inputs.dialysis, 'yes') &&
        isKindVisible() &&
        helpers_1.answerMatches(inputs.kind, 'hemo'));
};
var isWarningAbSectionVisible = function () {
    return (helpers_1.answerMatches(inputs.weight, 'more40') && areAllVisibleQuesionsAnswered());
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.kidney = isKidneyVisible();
    visibleQuestions.dialysis = isDialysisVisible();
    visibleQuestions.kind = isKindVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.dosing = !areAllVisibleQuesionsAnswered();
    visibleSections.dosingKids = isDosingKidsSectionVisible();
    visibleSections.tabletsAdults = isTabletsAdultsSectionVisible();
    visibleSections.tabletsAdultsMiddle = isTabletsAdultsMiddleSectionVisible();
    visibleSections.tabletsAdultsLow = isTabletsAdultsLowSectionVisible();
    visibleSections.powderAdults = isPowderAdultsSectionVisible();
    visibleSections.powderAdultsMiddle = isPowderAdultsMiddleSectionVisible();
    visibleSections.powderAdultsLow = isPowderAdultsLowSectionVisible();
    visibleSections.tblDialyHem = isTblDialyHemSectionVisible();
    visibleSections.pwdDialyHem = isPwdDialyHemSectionVisible();
    visibleSections.warningAb = isWarningAbSectionVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return areAllVisibleQuesionsAnswered();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
