"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    weight: true,
    noAnswer: true,
    powderKids1: true,
    powderKids3: true,
    tabletsKids1: true,
    tabletsKids3: true,
    tabletsAdults1: true,
    tabletsAdults3: true,
    powderAdults1: true,
    powderAdults3: true,
    kidney: true,
    anti: true
};
var visibleSections = {
    inputSection: true,
    dosing: false,
    powderKids: false,
    tabletsKids: false,
    tabletsAdults: false,
    powderAdults: false,
    kidneyWarning: false,
    warningAb: false
};
var inputs = {
    weight: null
};
var isWeightValid = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 200 });
};
var areAllVisibleQuesionsAnswered = function () {
    return isWeightValid();
};
var isPowderKidsSectionVisible = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 39.999 });
};
var isTabletsKidsSectionVisible = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 10, max: 39.999 });
};
var isTabletsAdultsSectionVisible = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 40, max: 200 });
};
var isPowderAdultsSectionVisible = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 40, max: 200 });
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e;
    if (isPowderKidsSectionVisible()) {
        if (!helpers_1.numberInLimits({ input: inputs.weight, min: 10, max: 39.999 })) {
            return {
                powderKids1: {
                    qID: 'powderKids1',
                    tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult((50 * ((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints)) / 50, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(50 * ((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints), 1), 0, 1)),
                    titleTexts: 'result1'
                }
            };
        }
        return {
            tabletsKids1: {
                qID: 'tabletsKids1',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(50 * ((_c = inputs.weight) === null || _c === void 0 ? void 0 : _c.currentPoints), 1), 0, 1)),
                titleTexts: 'result1'
            },
            powderKids1: {
                qID: 'powderKids1',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult((50 * ((_d = inputs.weight) === null || _d === void 0 ? void 0 : _d.currentPoints)) / 50, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(50 * ((_e = inputs.weight) === null || _e === void 0 ? void 0 : _e.currentPoints), 1), 0, 1)),
                titleTexts: 'result1'
            }
        };
    }
    return null;
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.dosing = !areAllVisibleQuesionsAnswered();
    visibleSections.powderKids = isPowderKidsSectionVisible();
    visibleSections.tabletsKids = isTabletsKidsSectionVisible();
    visibleSections.tabletsAdults = isTabletsAdultsSectionVisible();
    visibleSections.powderAdults = isPowderAdultsSectionVisible();
    visibleSections.kidneyWarning = areAllVisibleQuesionsAnswered();
    visibleSections.warningAb = areAllVisibleQuesionsAnswered();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return areAllVisibleQuesionsAnswered();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
