"use strict";


var visibleQuestions = {
    consultationGeneral: true,
    generalRecommendations: false,
    consultationSpecific: true,
    specificRecommendations: false,
    stadium: true,
    result1a: false,
    result1b: false,
    result2b: false,
    result3a: false,
    result3b: false,
    "continue": false
};
var visibleSections = {
    beforeTreatment: true,
    acneiformRash: true,
    acneiformRashManagement: false
};
var inputs = {
    consultationGeneral: null,
    consultationSpecific: null,
    stadium: null
};
var isGeneralRecommendationsVisible = function () {
    return helpers_1.answerMatches(inputs.consultationGeneral, 'close');
};
var isSpecificRecommendationsVisible = function () {
    return helpers_1.answerMatches(inputs.consultationSpecific, 'close');
};
var isResult1bVisible = function () {
    return helpers_1.answerMatches(inputs.stadium, 'stadium1');
};
var isResult2bVisible = function () {
    return (helpers_1.answerMatches(inputs.stadium, 'stadium2') ||
        helpers_1.answerMatches(inputs.stadium, 'stadium3') ||
        helpers_1.answerMatches(inputs.stadium, 'stadium4'));
};
var isResult3aVisible = function () {
    return (helpers_1.answerMatches(inputs.stadium, 'stadium3') ||
        helpers_1.answerMatches(inputs.stadium, 'stadium4'));
};
var isAcneiformRashManagementVisible = function () {
    return helpers_1.isAnswered(inputs.stadium);
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.generalRecommendations = isGeneralRecommendationsVisible();
    visibleQuestions.specificRecommendations = isSpecificRecommendationsVisible();
    visibleQuestions.result1a = isAcneiformRashManagementVisible();
    visibleQuestions.result1b = isResult1bVisible();
    visibleQuestions.result2b = isResult2bVisible();
    visibleQuestions.result3a = isResult3aVisible();
    visibleQuestions.result3b = isResult3aVisible();
    visibleQuestions["continue"] = isAcneiformRashManagementVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.acneiformRashManagement = isAcneiformRashManagementVisible();
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var isExportResultsEnabled = function () {
    return (helpers_1.answerMatches(inputs.consultationGeneral, 'close') ||
        helpers_1.answerMatches(inputs.consultationGeneral, 'close') ||
        helpers_1.isAnswered(inputs.stadium));
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: { number: result, range: result },
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
