"use strict";


var visibleQuestions = {
    consultationGeneral: true,
    generalRecommendations: false,
    consultationSpecific: true,
    specificRecommendations: false,
    stadium: true,
    result1: false,
    result2: false
};
var visibleSections = {
    beforeTreatment: true,
    ragade: true,
    ragadeManagement: false
};
var inputs = {
    consultationGeneral: null,
    consultationSpecific: null,
    stadium: null
};
var isRagadeManagementVisible = function () {
    return helpers_1.isAnswered(inputs.stadium);
};
var isGeneralRecommendationsVisible = function () {
    return helpers_1.answerMatches(inputs.consultationGeneral, 'close');
};
var isSpecificRecommendationsVisible = function () {
    return helpers_1.answerMatches(inputs.consultationSpecific, 'close');
};
var isResult1Visible = function () {
    return helpers_1.answerMatches(inputs.stadium, 'stadium1');
};
var isResult2Visible = function () {
    return helpers_1.answerMatches(inputs.stadium, 'stadium2');
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.generalRecommendations = isGeneralRecommendationsVisible();
    visibleQuestions.specificRecommendations = isSpecificRecommendationsVisible();
    visibleQuestions.result1 = isResult1Visible();
    visibleQuestions.result2 = isResult2Visible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.ragadeManagement = isRagadeManagementVisible();
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var isExportResultsEnabled = function () {
    return (helpers_1.answerMatches(inputs.consultationGeneral, 'close') ||
        helpers_1.answerMatches(inputs.consultationSpecific, 'close') ||
        helpers_1.isAnswered(inputs.stadium));
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: { number: result, range: result },
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
