"use strict";


var visibleQuestions = {
    weight: true,
    answerAll: false,
    warningUnder45A: false,
    doseTabletsAdults: false,
    durationTabletsAdults: false,
    doseSuspensionAdults: false,
    durationSuspensionAdults: false,
    kidneyWarning: false,
    warning1: false
};
var visibleSections = {
    weightSection: true,
    dosing: false,
    warningUnder45: false,
    tabletsAdults: false,
    suspensionAdults: false,
    kidney: false,
    warningAntimicrobial: false
};
var inputs = {
    weight: null
};
var isDosingVisible = function () {
    return !helpers_1.isAnswered(inputs.weight);
};
var isWeightLess45 = function () {
    return helpers_1.answerMatches(inputs.weight, 'less45');
};
var isWeightMore45 = function () {
    return helpers_1.answerMatches(inputs.weight, 'more45');
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.answerAll = isDosingVisible();
    visibleQuestions.warningUnder45A = isWeightLess45();
    visibleQuestions.doseTabletsAdults = isWeightMore45();
    visibleQuestions.durationTabletsAdults = isWeightMore45();
    visibleQuestions.doseSuspensionAdults = isWeightMore45();
    visibleQuestions.durationSuspensionAdults = isWeightMore45();
    visibleQuestions.kidneyWarning = isWeightMore45();
    visibleQuestions.warning1 = isWeightMore45();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.dosing = isDosingVisible();
    visibleSections.warningUnder45 = isWeightLess45();
    visibleSections.tabletsAdults = isWeightMore45();
    visibleSections.suspensionAdults = isWeightMore45();
    visibleSections.kidney = isWeightMore45();
    visibleSections.warningAntimicrobial = isWeightMore45();
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return !isDosingVisible();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: { number: result, range: result },
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
