"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    weight: true,
    noAnswer1: false,
    powderKidsDoseA: false,
    powderKidsDurationA: false,
    dividerPowder: false,
    powderKidsDoseB: false,
    powderKidsDurationB: false,
    powderKidsHDoseA: false,
    powderKidsHDurationA: false,
    dividerPowderKidsH: false,
    powderKidsHDoseB: false,
    powderKidsHDurationB: false,
    tabletsAdultsDoseA: false,
    tabletsAdultsDurationA: false,
    dividerAdultsA: false,
    tabletsAdultsDoseB: false,
    tabletsAdultsDurationB: false,
    powderAdultsDoseA: false,
    powderAdultsDurationA: false,
    dividerAdultsB: false,
    powderAdultsDoseB: false,
    powderAdultsDurationB: false,
    kidneyWarning: false,
    warningAntimicrobial1: false
};
var visibleSections = {
    weightSection: true,
    noAnswer: false,
    powderKids: false,
    powderKidH: false,
    tabletsAdults: false,
    powderAdults: false,
    kidney: false,
    warningAntimicrobial: false
};
var inputs = {
    weight: null
};
var weightWithinLimits = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 300 });
};
var isNoAnswerVisible = function () {
    return !weightWithinLimits();
};
var isPowderKidsVisible = function () {
    var _a, _b;
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 9.99 }) &&
        ((_a = inputs._countryCode) === null || _a === void 0 ? void 0 : _a.currentIdentifier) !== 'it' &&
        ((_b = inputs._countryCode) === null || _b === void 0 ? void 0 : _b.currentIdentifier) !== 'de');
};
var isPowderKidHVisible = function () {
    var _a, _b;
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 10, max: 44.99 }) ||
        (((_a = inputs._countryCode) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === 'de' &&
            helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 44.99 })) ||
        (((_b = inputs._countryCode) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === 'it' &&
            helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 44.99 })));
};
var isTabletsAdultsVisible = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 45, max: 300 });
};
var calculatePoints = function () {
    var _a, _b;
    if (isPowderKidsVisible()) {
        var weight = Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints);
        var powderKidsDose1Ml = (weight * 10) / 20;
        var powderKidsDose1Mg = weight * 10;
        var powderKidsDose2Ml = (weight * 5) / 20;
        var powderKidsDose2Mg = weight * 5;
        return {
            powderKidsDoseA: {
                qID: 'powderKidsDoseA',
                resultTexts: 'powderKidsDoseA1',
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(powderKidsDose1Ml, 2), 0, 2), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(powderKidsDose1Mg, 1), 0, 1))
            },
            powderKidsDurationA: {
                qID: 'powderKidsDurationA',
                resultTexts: 'regular',
                rParams: []
            },
            powderKidsDoseB: {
                qID: 'powderKidsDoseB',
                resultTexts: 'powderKidsDoseA1',
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(powderKidsDose1Ml, 2), 0, 2), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(powderKidsDose1Mg, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(powderKidsDose2Ml, 2), 0, 2), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(powderKidsDose2Mg, 1), 0, 1))
            },
            powderKidsDurationB: {
                qID: 'powderKidsDurationB',
                resultTexts: 'regular',
                rParams: []
            }
        };
    }
    if (isPowderKidHVisible()) {
        var weight = Number((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints);
        var powderKidHDose1Ml = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 20,
            max: 44.99
        })
            ? helpers_1.formatCalculationResult((weight * 10) / 40, 1)
            : helpers_1.formatCalculationResult((weight * 10) / 40, 2);
        var powderKidHDose1Mg = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 20,
            max: 44.99
        })
            ? Math.round(weight * 10)
            : helpers_1.formatCalculationResult(weight * 10, 1);
        var powderKidHDose2Ml = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 20,
            max: 44.99
        })
            ? helpers_1.formatCalculationResult((weight * 5) / 40, 1)
            : helpers_1.formatCalculationResult((weight * 5) / 40, 2);
        var powderKidHDose2Mg = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 20,
            max: 44.99
        })
            ? Math.round(weight * 5)
            : helpers_1.formatCalculationResult(weight * 5, 1);
        return {
            powderKidsHDoseA: {
                qID: 'powderKidsHDoseA',
                resultTexts: 'powderKidsHDoseA1',
                rParams: __spreadArrays(helpers_1.returnNumberObject(powderKidHDose1Ml, 0, 2), helpers_1.returnNumberObject(powderKidHDose1Mg, 0, 1))
            },
            powderKidsHDurationA: {
                qID: 'powderKidsHDurationA',
                resultTexts: 'powderKidsHDurationA1',
                rParams: []
            },
            powderKidsHDoseB: {
                qID: 'powderKidsHDoseB',
                resultTexts: 'powderKidsHDoseB1',
                rParams: __spreadArrays(helpers_1.returnNumberObject(powderKidHDose1Ml, 0, 2), helpers_1.returnNumberObject(powderKidHDose1Mg, 0, 1), helpers_1.returnNumberObject(powderKidHDose2Ml, 0, 2), helpers_1.returnNumberObject(powderKidHDose2Mg, 0, 1))
            },
            powderKidsHDurationB: {
                qID: 'powderKidsHDurationB',
                resultTexts: 'powderKidsHDurationB1',
                rParams: []
            }
        };
    }
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.noAnswer1 = isNoAnswerVisible();
    visibleQuestions.powderKidsDoseA = isPowderKidsVisible();
    visibleQuestions.powderKidsDurationA = isPowderKidsVisible();
    visibleQuestions.dividerPowder = isPowderKidsVisible();
    visibleQuestions.powderKidsDoseB = isPowderKidsVisible();
    visibleQuestions.powderKidsDurationB = isPowderKidsVisible();
    visibleQuestions.powderKidsHDoseA = isPowderKidHVisible();
    visibleQuestions.powderKidsHDurationA = isPowderKidHVisible();
    visibleQuestions.dividerPowderKidsH = isPowderKidHVisible();
    visibleQuestions.powderKidsHDoseB = isPowderKidHVisible();
    visibleQuestions.powderKidsHDurationB = isPowderKidHVisible();
    visibleQuestions.tabletsAdultsDoseA = isTabletsAdultsVisible();
    visibleQuestions.tabletsAdultsDurationA = isTabletsAdultsVisible();
    visibleQuestions.dividerAdultsA = isTabletsAdultsVisible();
    visibleQuestions.tabletsAdultsDoseB = isTabletsAdultsVisible();
    visibleQuestions.tabletsAdultsDurationB = isTabletsAdultsVisible();
    visibleQuestions.powderAdultsDoseA = isTabletsAdultsVisible();
    visibleQuestions.powderAdultsDurationA = isTabletsAdultsVisible();
    visibleQuestions.dividerAdultsB = isTabletsAdultsVisible();
    visibleQuestions.powderAdultsDoseB = isTabletsAdultsVisible();
    visibleQuestions.powderAdultsDurationB = isTabletsAdultsVisible();
    visibleQuestions.kidneyWarning = weightWithinLimits();
    visibleQuestions.warningAntimicrobial1 = weightWithinLimits();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = isNoAnswerVisible();
    visibleSections.powderKids = isPowderKidsVisible();
    visibleSections.powderKidH = isPowderKidHVisible();
    visibleSections.tabletsAdults = isTabletsAdultsVisible();
    visibleSections.powderAdults = isTabletsAdultsVisible();
    visibleSections.kidney = weightWithinLimits();
    visibleSections.warningAntimicrobial = weightWithinLimits();
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return !isNoAnswerVisible();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
