"use strict";

var visibleQuestions = {
    microcalcifications: true,
    puncture: true,
    status: false,
    positiveVDIB: false,
    negativeVDIB: false,
    additionalVBID: false,
    operation: false,
    controls: false,
    vacuumPuncture: false
};
var visibleSections = {
    section1: true
};
var inputs = {
    puncture: null,
    status: null,
    positiveVDIB: null,
    negativeVDIB: null
};
var calculatePoints = function () {
    return null;
};
var isStatusVisible = function () {
    return inputs.puncture.currentIdentifier === 'yes';
};
var isAdditionalVBIDVisible = function () {
    return inputs.positiveVDIB.currentIdentifier === 'multipleGroups';
};
var isOperationVisible = function () {
    return (inputs.puncture.currentIdentifier === 'no' ||
        inputs.positiveVDIB.currentIdentifier === 'oneGroup' ||
        isAdditionalVBIDVisible());
};
var isPositiveVDIBVisible = function () {
    return inputs.status.currentIdentifier === 'positive';
};
var isNegativeVDIBVisible = function () {
    return inputs.status.currentIdentifier === 'negative';
};
var isControlsVisible = function () {
    return inputs.negativeVDIB.currentIdentifier === 'visibleColumn';
};
var isVacuumPunctureVisible = function () {
    return inputs.negativeVDIB.currentIdentifier === 'notVisibleColumn';
};
var returnVisibleQuestions = function () {
    visibleQuestions.status = isStatusVisible();
    visibleQuestions.operation = isOperationVisible();
    visibleQuestions.positiveVDIB = isPositiveVDIBVisible();
    visibleQuestions.additionalVBID = isAdditionalVBIDVisible();
    visibleQuestions.negativeVDIB = isNegativeVDIBVisible();
    visibleQuestions.controls = isControlsVisible();
    visibleQuestions.vacuumPuncture = isVacuumPunctureVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return false;
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
