"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};


var visibleQuestions = {
    age: true,
    size: true,
    gradus: true
};
var visibleSections = {
    sagaraIndex: true
};
var inputs = {
    age: null,
    size: null,
    gradus: null
};
var isAnswerAllVisible = function () {
    return (!helpers_1.isAnswered(inputs.age) ||
        !helpers_1.isAnswered(inputs.size) ||
        !helpers_1.isAnswered(inputs.gradus));
};
var calculatePoints = function () {
    return helpers_1.returnToolScoreObject({
        resultById: getResult()
    });
};
var getResult = function () {
    var _a, _b, _c;
    var result = Number((_a = inputs.age) === null || _a === void 0 ? void 0 : _a.currentPoints) +
        Number((_b = inputs.size) === null || _b === void 0 ? void 0 : _b.currentPoints) +
        Number((_c = inputs.gradus) === null || _c === void 0 ? void 0 : _c.currentPoints);
    if (isAnswerAllVisible()) {
        return 'answerAll';
    }
    if (result === 0) {
        return 'zero';
    }
    if (result === 1) {
        return 'one';
    }
    if (result === 2) {
        return 'two';
    }
    if (result === 3) {
        return 'three';
    }
    if (result === 4) {
        return 'four';
    }
    if (result === 5) {
        return 'five';
    }
    if (result === 6) {
        return 'six';
    }
    return 'answerAll';
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_toolScore = function () {
    return calculatePoints();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return !isAnswerAllVisible();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return __assign(__assign({ exportResultsEnabled: isExportResultsEnabled() }, result), { visibleQuestions: ut_visibleQuestions(), visibleSections: ut_visibleSections() });
});
