"use strict";


var visibleQuestions = {
    surgery: true,
    subtype: true,
    age1: false,
    age2: false,
    geneticSign: false,
    geneticSignResults: false,
    HT: false,
    KTHT: false,
    premeno: false
};
var visibleSections = {
    section1: true
};
var inputs = {
    subtype: null,
    age1: null,
    age2: null,
    geneticSignResults: null
};
var isGeneticSignVisible = function () {
    return (helpers_1.answerMatches(inputs.age1, 'less70') ||
        helpers_1.answerMatches(inputs.subtype, 'luminal3') ||
        helpers_1.answerMatches(inputs.age2, 'greater50'));
};
var isHTVisible = function () {
    return (helpers_1.answerMatches(inputs.subtype, 'luminal1') ||
        helpers_1.answerMatches(inputs.age1, 'greater70') ||
        helpers_1.answerMatches(inputs.geneticSignResults, 'favorable'));
};
var isKTHTVisible = function () {
    return (helpers_1.answerMatches(inputs.subtype, 'greater3') ||
        helpers_1.answerMatches(inputs.age2, 'less50') ||
        helpers_1.answerMatches(inputs.geneticSignResults, 'unfavorable'));
};
var isPremenoVisible = function () {
    return isKTHTVisible() || isHTVisible();
};
var returnVisibleQuestions = function () {
    visibleQuestions.age1 = helpers_1.answerMatches(inputs.subtype, 'luminal2');
    visibleQuestions.age2 = helpers_1.answerMatches(inputs.subtype, 'luminal4');
    visibleQuestions.geneticSign = isGeneticSignVisible();
    visibleQuestions.geneticSignResults = isGeneticSignVisible();
    visibleQuestions.HT = isHTVisible();
    visibleQuestions.KTHT = isKTHTVisible();
    visibleQuestions.premeno = isPremenoVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return isHTVisible() || isKTHTVisible();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
