"use strict";


var visibleQuestions = {
    treatment: true,
    result1: false,
    result2: false,
    result3: false,
    diseaseProgression: false,
    maintenance: false,
    diseaseProgression2: false,
    maintenance2: false,
    duration: false,
    TDM1: false,
    otherTherapies: false
};
var visibleSections = {
    section1: true
};
var inputs = {
    treatment: null,
    diseaseProgression: null,
    diseaseProgression2: null
};
var isDiseaseProgressionNegative = function () {
    return helpers_1.answerMatches(inputs.diseaseProgression, 'no');
};
var isDiseaseProgression2Negative = function () {
    return helpers_1.answerMatches(inputs.diseaseProgression2, 'no');
};
var isDiseaseProgressionOrDiseaseProgression2Positive = function () {
    return (helpers_1.answerMatches(inputs.diseaseProgression, 'yes') ||
        helpers_1.answerMatches(inputs.diseaseProgression2, 'yes'));
};
var returnVisibleQuestions = function () {
    visibleQuestions.result1 = helpers_1.answerMatches(inputs.treatment, 'noPrior');
    visibleQuestions.result2 = helpers_1.answerMatches(inputs.treatment, 'priorAdjuvant');
    visibleQuestions.result3 = helpers_1.answerMatches(inputs.treatment, 'unsuitable');
    visibleQuestions.diseaseProgression = helpers_1.isAnswered(inputs.treatment);
    visibleQuestions.maintenance = isDiseaseProgressionNegative();
    visibleQuestions.diseaseProgression2 = isDiseaseProgressionNegative();
    visibleQuestions.maintenance2 = isDiseaseProgression2Negative();
    visibleQuestions.duration = isDiseaseProgression2Negative();
    visibleQuestions.TDM1 = isDiseaseProgressionOrDiseaseProgression2Positive();
    visibleQuestions.otherTherapies =
        isDiseaseProgressionOrDiseaseProgression2Positive();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return (isDiseaseProgression2Negative() ||
        isDiseaseProgressionOrDiseaseProgression2Positive());
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
