"use strict";


var visibleQuestions = {
    infoText: true,
    visceral: true,
    meno: false,
    MOS: false,
    lowExtent: false,
    ZA: false,
    ZAPlus: false,
    PIK3CA: false,
    BRCA12: false,
    alpelizip: false,
    zPARP: false,
    everolimus: false,
    chemo: false,
    chemo2: false
};
var visibleSections = {
    section1: true,
    section2: true
};
var inputs = {
    visceral: null,
    meno: null,
    lowExtent: null,
    PIK3CA: null,
    BRCA12: null
};
var isZAVisible = function () {
    return helpers_1.answerMatches(inputs.lowExtent, 'yes');
};
var isZAPlusVisible = function () {
    return helpers_1.answerMatches(inputs.lowExtent, 'no') || isChemo2Visible();
};
var isAlpelizipVisible = function () {
    return ((helpers_1.answerMatches(inputs.PIK3CA, 'yes') &&
        helpers_1.answerMatches(inputs.BRCA12, 'yes')) ||
        (helpers_1.answerMatches(inputs.PIK3CA, 'yes') && helpers_1.answerMatches(inputs.BRCA12, 'no')));
};
var iszPARPVisible = function () {
    return ((helpers_1.answerMatches(inputs.PIK3CA, 'yes') &&
        helpers_1.answerMatches(inputs.BRCA12, 'yes')) ||
        (helpers_1.answerMatches(inputs.PIK3CA, 'no') && helpers_1.answerMatches(inputs.BRCA12, 'yes')));
};
var isEverolimusVisible = function () {
    return (helpers_1.answerMatches(inputs.PIK3CA, 'no') ||
        helpers_1.answerMatches(inputs.BRCA12, 'no') ||
        isAlpelizipVisible());
};
var isChemo2Visible = function () {
    return helpers_1.answerMatches(inputs.visceral, 'yes');
};
var returnVisibleQuestions = function () {
    visibleQuestions.meno = helpers_1.answerMatches(inputs.visceral, 'no');
    visibleQuestions.MOS = helpers_1.answerMatches(inputs.meno, 'preMeno');
    visibleQuestions.lowExtent = helpers_1.isAnswered(inputs.meno);
    visibleQuestions.ZA = isZAVisible();
    visibleQuestions.ZAPlus = isZAPlusVisible();
    visibleQuestions.PIK3CA = isZAPlusVisible();
    visibleQuestions.BRCA12 = isZAPlusVisible();
    visibleQuestions.alpelizip = isAlpelizipVisible();
    visibleQuestions.zPARP = iszPARPVisible();
    visibleQuestions.everolimus = isEverolimusVisible();
    visibleQuestions.chemo = isEverolimusVisible();
    visibleQuestions.chemo2 = isChemo2Visible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return isZAVisible() || isEverolimusVisible();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
