"use strict";


var visibleQuestions = {
    infoText: true,
    conditions: true,
    PDL1: true,
    BRCA: true,
    result1: false,
    result2: false,
    progressive: false,
    prior: false,
    result3: false,
    result4: false,
    result5: false,
    result6: false
};
var visibleSections = {
    section1: true,
    section2: true
};
var inputs = {
    PDL1: null,
    BRCA: null,
    progressive: null,
    prior: null
};
var isResult1Visible = function () {
    return helpers_1.answerMatches(inputs.PDL1, 'positive');
};
var isResult3Visible = function () {
    return helpers_1.answerMatches(inputs.prior, 'no');
};
var isProgressiveVisible = function () {
    return (helpers_1.answerMatches(inputs.PDL1, 'negative') ||
        helpers_1.answerMatches(inputs.BRCA, 'negative') ||
        isResult1Visible());
};
var isResult5Visible = function () {
    return (helpers_1.answerMatches(inputs.progressive, 'yes') ||
        isResult3Visible() ||
        helpers_1.answerMatches(inputs.prior, 'yes'));
};
var returnVisibleQuestions = function () {
    visibleQuestions.result1 = isResult1Visible();
    visibleQuestions.result2 = helpers_1.answerMatches(inputs.BRCA, 'positive');
    visibleQuestions.progressive = isProgressiveVisible();
    visibleQuestions.prior = helpers_1.answerMatches(inputs.progressive, 'no');
    visibleQuestions.result3 = isResult3Visible();
    visibleQuestions.result4 = helpers_1.answerMatches(inputs.progressive, 'yes');
    visibleQuestions.result5 = isResult5Visible();
    visibleQuestions.result6 = isResult5Visible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return isResult5Visible();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
