"use strict";


var visibleQuestions = {
    tumorSize: true,
    surgery: false,
    therapy: false,
    preparation: false,
    therapy2: false,
    surgery2: false,
    pCR: false,
    result1: false,
    result2: false
};
var visibleSections = {
    section1: true
};
var inputs = {
    tumorSize: null,
    pCR: null
};
var isSurgeryVisible = function () {
    return helpers_1.answerMatches(inputs.tumorSize, 'lessThan2');
};
var isPreparationVisible = function () {
    return helpers_1.answerMatches(inputs.tumorSize, 'greaterThan2');
};
var isResult1Visible = function () {
    return helpers_1.answerMatches(inputs.pCR, 'yes');
};
var isResult2Visible = function () {
    return helpers_1.answerMatches(inputs.pCR, 'no');
};
var returnVisibleQuestions = function () {
    visibleQuestions.surgery = isSurgeryVisible();
    visibleQuestions.therapy = isSurgeryVisible();
    visibleQuestions.preparation = isPreparationVisible();
    visibleQuestions.therapy2 = isPreparationVisible();
    visibleQuestions.surgery2 = isPreparationVisible();
    visibleQuestions.pCR = isPreparationVisible();
    visibleQuestions.result1 = isResult1Visible();
    visibleQuestions.result2 = isResult2Visible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return isSurgeryVisible() || isResult1Visible() || isResult2Visible();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
