"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};


var visibleQuestions = {
    weight: true,
    height: true
};
var visibleSections = {
    questions: true
};
var inputs = {
    weight: null,
    height: null
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_toolScore = function () {
    return calculatePoints();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return areAllAnswered();
};
var areAllAnswered = function () {
    var areAllNotAnswered = !helpers_1.isAnswered(inputs.weight) ||
        !helpers_1.isAnswered(inputs.height) ||
        inputs.weight.currentPoints < 1 ||
        inputs.weight.currentPoints > 300 ||
        inputs.height.currentPoints < 1 ||
        inputs.height.currentPoints > 250;
    return !areAllNotAnswered;
};
var calculatePoints = function () {
    if (!areAllAnswered())
        return helpers_1.returnToolScoreObject({});
    var outputResult = helpers_1.formatCalculationResult(Math.sqrt(inputs.height.currentPoints * inputs.weight.currentPoints) /
        60, 2);
    return helpers_1.returnToolScoreObject({ number: outputResult, range: outputResult });
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return __assign(__assign({ exportResultsEnabled: isExportResultsEnabled() }, result), { visibleQuestions: ut_visibleQuestions(), visibleSections: ut_visibleSections() });
});
