"use strict";


var visibleQuestions = {
    areas: true,
    anemia: true,
    thrombocytopenia: true,
    answerAll: true,
    lowRisk: false,
    intermediateRisk: false,
    highRisk: false
};
var visibleSections = {
    inputs: true,
    results: true
};
var inputs = {
    areas: null,
    anemia: null,
    thrombocytopenia: null
};
var isAnswerAllVisible = function () {
    return (!helpers_1.isAnswered(inputs.areas) ||
        !helpers_1.isAnswered(inputs.anemia) ||
        !helpers_1.isAnswered(inputs.thrombocytopenia));
};
var isResultRange2Visible = function () {
    var _a, _b, _c;
    return (helpers_1.isAnswered(inputs.areas) &&
        ((_a = inputs.areas) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "less3" &&
        helpers_1.isAnswered(inputs.anemia) &&
        ((_b = inputs.anemia) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "no" &&
        helpers_1.isAnswered(inputs.thrombocytopenia) &&
        ((_c = inputs.thrombocytopenia) === null || _c === void 0 ? void 0 : _c.currentIdentifier) === "no");
};
var isResultRange3Visible = function () {
    var _a, _b, _c;
    return (helpers_1.isAnswered(inputs.areas) &&
        ((_a = inputs.areas) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "more3" &&
        helpers_1.isAnswered(inputs.anemia) &&
        ((_b = inputs.anemia) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "no" &&
        helpers_1.isAnswered(inputs.thrombocytopenia) &&
        ((_c = inputs.thrombocytopenia) === null || _c === void 0 ? void 0 : _c.currentIdentifier) === "no");
};
var isResultRange4Visible = function () {
    var _a, _b;
    return (!isAnswerAllVisible() &&
        ((helpers_1.isAnswered(inputs.anemia) &&
            ((_a = inputs.anemia) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "yes") ||
            (helpers_1.isAnswered(inputs.thrombocytopenia) &&
                ((_b = inputs.thrombocytopenia) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "yes")));
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    visibleQuestions.answerAll = isAnswerAllVisible();
    visibleQuestions.lowRisk = isResultRange2Visible();
    visibleQuestions.intermediateRisk = isResultRange3Visible();
    visibleQuestions.highRisk = isResultRange4Visible();
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_toolScore = function () {
    return calculatePoints();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return !isAnswerAllVisible();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});