"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};


var visibleQuestions = {
    classificationType: true,
    primaryTumor: true,
    tiSubgroups: true,
    t1subgroups: true,
    t4subgroups: true,
    lymphNodes: true,
    lymphNodesP: true,
    N1subgroupsP: true,
    N2subgroups: true,
    N2subgroupsP: true,
    N3subgroups: true,
    N3subgroupsP: true,
    metastasis: true,
    rules: true
};
var visibleSections = {
    classification: true,
    rulesSection: true
};
var inputs = {
    classificationType: null,
    primaryTumor: null,
    tiSubgroups: null,
    t1subgroups: null,
    t4subgroups: null,
    lymphNodes: null,
    lymphNodesP: null,
    N1subgroupsP: null,
    N2subgroups: null,
    N2subgroupsP: null,
    N3subgroups: null,
    N3subgroupsP: null,
    metastasis: null
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21, _22, _23, _24, _25, _26, _27, _28, _29, _30, _31, _32, _33, _34, _35, _36, _37, _38, _39, _40, _41, _42, _43, _44, _45, _46, _47, _48, _49, _50, _51, _52, _53, _54, _55, _56, _57, _58;
    if (range0Result()) {
        return helpers_1.returnToolScoreObject({ resultById: 'range0' });
    }
    var range1 = helpers_1.returnToolScoreObject({
        resultById: 'range1',
        title: [
            ((_a = inputs.primaryTumor) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === 'tis'
                ? ((_b = inputs.tiSubgroups) === null || _b === void 0 ? void 0 : _b.currentIdentifier) !== 'paget'
                    ? "Tis" + ((_c = inputs.tiSubgroups) === null || _c === void 0 ? void 0 : _c.currentIdentifier.toUpperCase())
                    : 'TisMb. Paget'
                : ((_d = inputs.primaryTumor) === null || _d === void 0 ? void 0 : _d.currentIdentifier) === 't1'
                    ? capitalizeFirstLetter((_e = inputs.t1subgroups) === null || _e === void 0 ? void 0 : _e.currentIdentifier)
                    : ((_f = inputs.primaryTumor) === null || _f === void 0 ? void 0 : _f.currentIdentifier) === 't4'
                        ? capitalizeFirstLetter((_g = inputs.t4subgroups) === null || _g === void 0 ? void 0 : _g.currentIdentifier)
                        : (_h = inputs.primaryTumor) === null || _h === void 0 ? void 0 : _h.currentIdentifier.toUpperCase(),
            isElementVisibleAndHasValue(inputs.classificationType, 'clinical')
                ? isElementVisibleAndHasValue(inputs.lymphNodes, 'n2')
                    ? capitalizeFirstLetter((_j = inputs.N2subgroups) === null || _j === void 0 ? void 0 : _j.currentIdentifier)
                    : isElementVisibleAndHasValue(inputs.lymphNodes, 'n3')
                        ? capitalizeFirstLetter((_k = inputs.N3subgroups) === null || _k === void 0 ? void 0 : _k.currentIdentifier)
                        : (_l = inputs.lymphNodes) === null || _l === void 0 ? void 0 : _l.currentIdentifier.toUpperCase()
                : isElementVisibleAndHasValue(inputs.lymphNodesP, 'pN1')
                    ? (_m = inputs.N1subgroupsP) === null || _m === void 0 ? void 0 : _m.currentIdentifier
                    : isElementVisibleAndHasValue(inputs.lymphNodesP, 'pN2')
                        ? (_o = inputs.N2subgroupsP) === null || _o === void 0 ? void 0 : _o.currentIdentifier
                        : isElementVisibleAndHasValue(inputs.lymphNodesP, 'pN3')
                            ? (_p = inputs.N3subgroupsP) === null || _p === void 0 ? void 0 : _p.currentIdentifier
                            : (_q = inputs.lymphNodesP) === null || _q === void 0 ? void 0 : _q.currentIdentifier,
        ]
    });
    if (range2Result())
        return helpers_1.returnToolScoreObject({
            resultById: 'range2',
            title: [
                ((_r = inputs.tiSubgroups) === null || _r === void 0 ? void 0 : _r.currentIdentifier) !== 'paget'
                    ? (_s = inputs.tiSubgroups) === null || _s === void 0 ? void 0 : _s.currentIdentifier.toUpperCase() : 'Mb. Paget',
                isElementVisibleAndHasValue(inputs.classificationType, 'clinical')
                    ? capitalizeFirstLetter((_t = inputs.lymphNodes) === null || _t === void 0 ? void 0 : _t.currentIdentifier)
                    : (_u = inputs.lymphNodesP) === null || _u === void 0 ? void 0 : _u.currentIdentifier,
            ]
        });
    if (range3Result())
        return helpers_1.returnToolScoreObject({
            resultById: 'range3',
            title: [
                capitalizeFirstLetter((_v = inputs.t1subgroups) === null || _v === void 0 ? void 0 : _v.currentIdentifier),
                isElementVisibleAndHasValue(inputs.classificationType, 'clinical')
                    ? capitalizeFirstLetter((_w = inputs.lymphNodes) === null || _w === void 0 ? void 0 : _w.currentIdentifier)
                    : (_x = inputs.lymphNodesP) === null || _x === void 0 ? void 0 : _x.currentIdentifier,
            ]
        });
    if (range4Result()) {
        return helpers_1.returnToolScoreObject({
            resultById: 'range4',
            title: [
                ((_y = inputs.primaryTumor) === null || _y === void 0 ? void 0 : _y.currentIdentifier) === 't0'
                    ? capitalizeFirstLetter(inputs.primaryTumor.currentIdentifier)
                    : capitalizeFirstLetter((_z = inputs.t1subgroups) === null || _z === void 0 ? void 0 : _z.currentIdentifier),
            ]
        });
    }
    if (range5Result()) {
        return helpers_1.returnToolScoreObject({
            resultById: 'range5',
            title: ((_0 = inputs.primaryTumor) === null || _0 === void 0 ? void 0 : _0.currentIdentifier) === 't2'
                ? [
                    capitalizeFirstLetter((_1 = inputs.primaryTumor) === null || _1 === void 0 ? void 0 : _1.currentIdentifier),
                    isElementVisibleAndHasValue(inputs.classificationType, 'clinical')
                        ? capitalizeFirstLetter((_2 = inputs.lymphNodes) === null || _2 === void 0 ? void 0 : _2.currentIdentifier)
                        : (_3 = inputs.lymphNodesP) === null || _3 === void 0 ? void 0 : _3.currentIdentifier,
                ]
                : [
                    capitalizeFirstLetter(((_4 = inputs.primaryTumor) === null || _4 === void 0 ? void 0 : _4.currentIdentifier) === 't0'
                        ? (_5 = inputs.primaryTumor) === null || _5 === void 0 ? void 0 : _5.currentIdentifier
                        : (_6 = inputs.t1subgroups) === null || _6 === void 0 ? void 0 : _6.currentIdentifier),
                    isElementVisibleAndHasValue(inputs.classificationType, 'clinical')
                        ? capitalizeFirstLetter((_7 = inputs.lymphNodes) === null || _7 === void 0 ? void 0 : _7.currentIdentifier)
                        : (_8 = inputs.N1subgroupsP) === null || _8 === void 0 ? void 0 : _8.currentIdentifier,
                ]
        });
    }
    if (range6Results()) {
        return helpers_1.returnToolScoreObject({
            resultById: 'range6',
            title: ((_9 = inputs.primaryTumor) === null || _9 === void 0 ? void 0 : _9.currentIdentifier) === 't2'
                ? [
                    capitalizeFirstLetter((_10 = inputs.primaryTumor) === null || _10 === void 0 ? void 0 : _10.currentIdentifier),
                    isElementVisibleAndHasValue(inputs.classificationType, 'clinical')
                        ? capitalizeFirstLetter((_11 = inputs.lymphNodes) === null || _11 === void 0 ? void 0 : _11.currentIdentifier)
                        : (_12 = inputs.N1subgroupsP) === null || _12 === void 0 ? void 0 : _12.currentIdentifier,
                ]
                : [
                    capitalizeFirstLetter((_13 = inputs.primaryTumor) === null || _13 === void 0 ? void 0 : _13.currentIdentifier),
                    isElementVisibleAndHasValue(inputs.classificationType, 'clinical')
                        ? capitalizeFirstLetter((_14 = inputs.lymphNodes) === null || _14 === void 0 ? void 0 : _14.currentIdentifier)
                        : (_15 = inputs.lymphNodesP) === null || _15 === void 0 ? void 0 : _15.currentIdentifier,
                ]
        });
    }
    if (range7Results()) {
        return helpers_1.returnToolScoreObject({
            resultById: 'range7',
            title: [
                ((_16 = inputs.primaryTumor) === null || _16 === void 0 ? void 0 : _16.currentIdentifier) !== 't1'
                    ? capitalizeFirstLetter((_17 = inputs.primaryTumor) === null || _17 === void 0 ? void 0 : _17.currentIdentifier)
                    : capitalizeFirstLetter((_18 = inputs.t1subgroups) === null || _18 === void 0 ? void 0 : _18.currentIdentifier),
                isElementVisibleAndHasValue(inputs.classificationType, 'clinical')
                    ? capitalizeFirstLetter(((_19 = inputs.lymphNodes) === null || _19 === void 0 ? void 0 : _19.currentIdentifier) === 'n2'
                        ? (_20 = inputs.N2subgroups) === null || _20 === void 0 ? void 0 : _20.currentIdentifier
                        : (_21 = inputs.lymphNodes) === null || _21 === void 0 ? void 0 : _21.currentIdentifier)
                    : ((_22 = inputs.lymphNodesP) === null || _22 === void 0 ? void 0 : _22.currentIdentifier) === 'pN2'
                        ? (_23 = inputs.N2subgroupsP) === null || _23 === void 0 ? void 0 : _23.currentIdentifier
                        : ((_24 = inputs.lymphNodesP) === null || _24 === void 0 ? void 0 : _24.currentIdentifier) === 'pN1'
                            ? (_25 = inputs.N1subgroupsP) === null || _25 === void 0 ? void 0 : _25.currentIdentifier
                            : (_26 = inputs.lymphNodesP) === null || _26 === void 0 ? void 0 : _26.currentIdentifier,
            ]
        });
    }
    if (range8Results()) {
        return helpers_1.returnToolScoreObject({
            resultById: 'range8',
            title: [
                capitalizeFirstLetter((_27 = inputs.t4subgroups) === null || _27 === void 0 ? void 0 : _27.currentIdentifier),
                isElementVisibleAndHasValue(inputs.classificationType, 'clinical')
                    ? capitalizeFirstLetter(((_28 = inputs.lymphNodes) === null || _28 === void 0 ? void 0 : _28.currentIdentifier) === 'n2'
                        ? (_29 = inputs.N2subgroups) === null || _29 === void 0 ? void 0 : _29.currentIdentifier
                        : (_30 = inputs.lymphNodes) === null || _30 === void 0 ? void 0 : _30.currentIdentifier)
                    : ((_31 = inputs.lymphNodesP) === null || _31 === void 0 ? void 0 : _31.currentIdentifier) === 'pN0'
                        ? (_32 = inputs.lymphNodesP) === null || _32 === void 0 ? void 0 : _32.currentIdentifier
                        : ((_33 = inputs.lymphNodesP) === null || _33 === void 0 ? void 0 : _33.currentIdentifier) === 'pN1'
                            ? (_34 = inputs.N1subgroupsP) === null || _34 === void 0 ? void 0 : _34.currentIdentifier
                            : (_35 = inputs.N2subgroupsP) === null || _35 === void 0 ? void 0 : _35.currentIdentifier,
            ]
        });
    }
    if (range9Results()) {
        return helpers_1.returnToolScoreObject({
            resultById: 'range9',
            title: [
                capitalizeFirstLetter(((_36 = inputs.primaryTumor) === null || _36 === void 0 ? void 0 : _36.currentIdentifier) === 't1'
                    ? (_37 = inputs.t1subgroups) === null || _37 === void 0 ? void 0 : _37.currentIdentifier
                    : ((_38 = inputs.primaryTumor) === null || _38 === void 0 ? void 0 : _38.currentIdentifier) === 'tis'
                        ? ((_39 = inputs.tiSubgroups) === null || _39 === void 0 ? void 0 : _39.currentIdentifier) !== 'paget'
                            ? "Tis" + ((_40 = inputs.tiSubgroups) === null || _40 === void 0 ? void 0 : _40.currentIdentifier.toUpperCase())
                            : 'TisMb. Paget'
                        : ((_41 = inputs.primaryTumor) === null || _41 === void 0 ? void 0 : _41.currentIdentifier) === 't4'
                            ? (_42 = inputs.t4subgroups) === null || _42 === void 0 ? void 0 : _42.currentIdentifier
                            : inputs.primaryTumor.currentIdentifier.toUpperCase()),
                isElementVisibleAndHasValue(inputs.classificationType, 'clinical')
                    ? capitalizeFirstLetter((_43 = inputs.N3subgroups) === null || _43 === void 0 ? void 0 : _43.currentIdentifier)
                    : (_44 = inputs.N3subgroupsP) === null || _44 === void 0 ? void 0 : _44.currentIdentifier,
            ]
        });
    }
    if (range10Results()) {
        return helpers_1.returnToolScoreObject({
            resultById: 'range10',
            title: [
                ((_45 = inputs.primaryTumor) === null || _45 === void 0 ? void 0 : _45.currentIdentifier) === 't1'
                    ? capitalizeFirstLetter((_46 = inputs.t1subgroups) === null || _46 === void 0 ? void 0 : _46.currentIdentifier)
                    : ((_47 = inputs.primaryTumor) === null || _47 === void 0 ? void 0 : _47.currentIdentifier) === 'tis'
                        ? ((_48 = inputs.tiSubgroups) === null || _48 === void 0 ? void 0 : _48.currentIdentifier) !== 'paget'
                            ? inputs.tiSubgroups.currentIdentifier.toUpperCase()
                            : 'Mb. Paget'
                        : ((_49 = inputs.primaryTumor) === null || _49 === void 0 ? void 0 : _49.currentIdentifier) === 't4'
                            ? capitalizeFirstLetter((_50 = inputs.t4subgroups) === null || _50 === void 0 ? void 0 : _50.currentIdentifier)
                            : (_51 = inputs.primaryTumor) === null || _51 === void 0 ? void 0 : _51.currentIdentifier.toUpperCase(),
                isElementVisibleAndHasValue(inputs.classificationType, 'clinical')
                    ? isElementVisibleAndHasValue(inputs.lymphNodes, 'n2')
                        ? capitalizeFirstLetter((_52 = inputs.N2subgroups) === null || _52 === void 0 ? void 0 : _52.currentIdentifier)
                        : isElementVisibleAndHasValue(inputs.lymphNodes, 'n3')
                            ? capitalizeFirstLetter((_53 = inputs.N3subgroups) === null || _53 === void 0 ? void 0 : _53.currentIdentifier)
                            : (_54 = inputs.lymphNodes) === null || _54 === void 0 ? void 0 : _54.currentIdentifier.toUpperCase()
                    : isElementVisibleAndHasValue(inputs.lymphNodesP, 'pN1')
                        ? (_55 = inputs.N1subgroupsP) === null || _55 === void 0 ? void 0 : _55.currentIdentifier
                        : isElementVisibleAndHasValue(inputs.lymphNodesP, 'pN2')
                            ? (_56 = inputs.N2subgroupsP) === null || _56 === void 0 ? void 0 : _56.currentIdentifier
                            : isElementVisibleAndHasValue(inputs.lymphNodesP, 'pN3')
                                ? (_57 = inputs.N3subgroupsP) === null || _57 === void 0 ? void 0 : _57.currentIdentifier
                                : (_58 = inputs.lymphNodesP) === null || _58 === void 0 ? void 0 : _58.currentIdentifier,
            ]
        });
    }
    return range1;
};
var capitalizeFirstLetter = function (value) {
    return value.charAt(0).toUpperCase() + value.slice(1);
};
var range0Result = function () {
    var _a, _b, _c, _d, _e;
    if (!helpers_1.isAnswered(inputs.primaryTumor))
        return true;
    if (((_a = inputs.primaryTumor) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === 'tis') {
        if (!helpers_1.isAnswered(inputs.tiSubgroups))
            return true;
    }
    if (((_b = inputs.primaryTumor) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === 't1') {
        if (!helpers_1.isAnswered(inputs.t1subgroups))
            return true;
    }
    if (((_c = inputs.primaryTumor) === null || _c === void 0 ? void 0 : _c.currentIdentifier) === 't4') {
        if (!helpers_1.isAnswered(inputs.t4subgroups))
            return true;
    }
    if (((_d = inputs.classificationType) === null || _d === void 0 ? void 0 : _d.currentIdentifier) === 'clinical') {
        if (!helpers_1.isAnswered(inputs.lymphNodes))
            return true;
        if (isElementVisibleAndHasValue(inputs.lymphNodes, 'n2')) {
            if (!helpers_1.isAnswered(inputs.N2subgroups))
                return true;
        }
        if (isElementVisibleAndHasValue(inputs.lymphNodes, 'n3')) {
            if (!helpers_1.isAnswered(inputs.N3subgroups))
                return true;
        }
    }
    if (((_e = inputs.classificationType) === null || _e === void 0 ? void 0 : _e.currentIdentifier) === 'pathological') {
        if (!helpers_1.isAnswered(inputs.lymphNodesP))
            return true;
        if (isElementVisibleAndHasValue(inputs.lymphNodesP, 'pN1')) {
            if (!helpers_1.isAnswered(inputs.N1subgroupsP))
                return true;
        }
        if (isElementVisibleAndHasValue(inputs.lymphNodesP, 'pN2')) {
            if (!helpers_1.isAnswered(inputs.N2subgroupsP))
                return true;
        }
        if (isElementVisibleAndHasValue(inputs.lymphNodesP, 'pN3')) {
            if (!helpers_1.isAnswered(inputs.N3subgroupsP))
                return true;
        }
    }
    if (!helpers_1.isAnswered(inputs.metastasis))
        return true;
    return false;
};
var range2Result = function () {
    var _a, _b, _c, _d;
    return (helpers_1.isAnswered(inputs.primaryTumor) &&
        ((_a = inputs.primaryTumor) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === 'tis' &&
        helpers_1.isAnswered(inputs.tiSubgroups) &&
        ((helpers_1.isAnswered(inputs.lymphNodes) &&
            ((_b = inputs.lymphNodes) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === 'n0') ||
            (helpers_1.isAnswered(inputs.lymphNodesP) &&
                ((_c = inputs.lymphNodesP) === null || _c === void 0 ? void 0 : _c.currentIdentifier) === 'pN0')) &&
        helpers_1.isAnswered(inputs.metastasis) &&
        ((_d = inputs.metastasis) === null || _d === void 0 ? void 0 : _d.currentIdentifier) === 'm0');
};
var range3Result = function () {
    var _a, _b, _c, _d;
    return (helpers_1.isAnswered(inputs.primaryTumor) &&
        ((_a = inputs.primaryTumor) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === 't1' &&
        helpers_1.isAnswered(inputs.t1subgroups) &&
        ((helpers_1.isAnswered(inputs.lymphNodes) &&
            ((_b = inputs.lymphNodes) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === 'n0') ||
            (helpers_1.isAnswered(inputs.lymphNodesP) &&
                ((_c = inputs.lymphNodesP) === null || _c === void 0 ? void 0 : _c.currentIdentifier) === 'pN0')) &&
        helpers_1.isAnswered(inputs.metastasis) &&
        ((_d = inputs.metastasis) === null || _d === void 0 ? void 0 : _d.currentIdentifier) === 'm0');
};
var range4Result = function () {
    var _a, _b, _c, _d;
    return (helpers_1.isAnswered(inputs.primaryTumor) &&
        (((_a = inputs.primaryTumor) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === 't0' ||
            ((_b = inputs.primaryTumor) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === 't1') &&
        (((_c = inputs.primaryTumor) === null || _c === void 0 ? void 0 : _c.currentIdentifier) === 't1'
            ? helpers_1.isAnswered(inputs.t1subgroups)
            : true) &&
        isElementVisibleAndHasValue(inputs.lymphNodesP, 'pN1') &&
        isElementVisibleAndHasValue(inputs.N1subgroupsP, 'pN1mi') &&
        helpers_1.isAnswered(inputs.metastasis) &&
        ((_d = inputs.metastasis) === null || _d === void 0 ? void 0 : _d.currentIdentifier) === 'm0');
};
var range5Result = function () {
    var _a, _b, _c, _d, _e, _f;
    return ((helpers_1.isAnswered(inputs.primaryTumor) &&
        (((_a = inputs.primaryTumor) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === 't0' ||
            ((_b = inputs.primaryTumor) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === 't1') &&
        (((_c = inputs.primaryTumor) === null || _c === void 0 ? void 0 : _c.currentIdentifier) === 't1'
            ? helpers_1.isAnswered(inputs.t1subgroups)
            : true) &&
        (isElementVisibleAndHasValue(inputs.classificationType, 'clinical')
            ? isElementVisibleAndHasValue(inputs.lymphNodes, 'n1')
            : isElementVisibleAndHasValue(inputs.lymphNodesP, 'pN1')
                ? helpers_1.isAnswered(inputs.N1subgroupsP) &&
                    ((_d = inputs.N1subgroupsP) === null || _d === void 0 ? void 0 : _d.currentIdentifier) !== 'pN1mi'
                : false)) ||
        (helpers_1.isAnswered(inputs.primaryTumor) &&
            ((_e = inputs.primaryTumor) === null || _e === void 0 ? void 0 : _e.currentIdentifier) === 't2' &&
            (isElementVisibleAndHasValue(inputs.classificationType, 'clinical')
                ? isElementVisibleAndHasValue(inputs.lymphNodes, 'n0')
                : isElementVisibleAndHasValue(inputs.lymphNodesP, 'pN0')) &&
            helpers_1.isAnswered(inputs.metastasis) &&
            ((_f = inputs.metastasis) === null || _f === void 0 ? void 0 : _f.currentIdentifier) === 'm0'));
};
var range6Results = function () {
    var _a, _b, _c;
    return (((helpers_1.isAnswered(inputs.primaryTumor) &&
        ((_a = inputs.primaryTumor) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === 't2' &&
        (isElementVisibleAndHasValue(inputs.classificationType, 'clinical')
            ? isElementVisibleAndHasValue(inputs.lymphNodes, 'n1')
            : isElementVisibleAndHasValue(inputs.lymphNodesP, 'pN1'))) ||
        (helpers_1.isAnswered(inputs.primaryTumor) &&
            ((_b = inputs.primaryTumor) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === 't3' &&
            (isElementVisibleAndHasValue(inputs.classificationType, 'clinical')
                ? isElementVisibleAndHasValue(inputs.lymphNodes, 'n0')
                : isElementVisibleAndHasValue(inputs.lymphNodesP, 'pN0')))) &&
        helpers_1.isAnswered(inputs.metastasis) &&
        ((_c = inputs.metastasis) === null || _c === void 0 ? void 0 : _c.currentIdentifier) === 'm0');
};
var range7Results = function () {
    var _a, _b, _c, _d, _e, _f;
    return (((helpers_1.isAnswered(inputs.primaryTumor) &&
        (((_a = inputs.primaryTumor) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === 't0' ||
            ((_b = inputs.primaryTumor) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === 't1' ||
            ((_c = inputs.primaryTumor) === null || _c === void 0 ? void 0 : _c.currentIdentifier) === 't2') &&
        (((_d = inputs.primaryTumor) === null || _d === void 0 ? void 0 : _d.currentIdentifier) === 't1'
            ? helpers_1.isAnswered(inputs.t1subgroups)
            : true) &&
        (isElementVisibleAndHasValue(inputs.classificationType, 'clinical')
            ? isElementVisibleAndHasValue(inputs.lymphNodes, 'n2') &&
                helpers_1.isAnswered(inputs.N2subgroups)
            : isElementVisibleAndHasValue(inputs.lymphNodesP, 'pN2') &&
                helpers_1.isAnswered(inputs.N2subgroupsP))) ||
        (helpers_1.isAnswered(inputs.primaryTumor) &&
            ((_e = inputs.primaryTumor) === null || _e === void 0 ? void 0 : _e.currentIdentifier) === 't3' &&
            (isElementVisibleAndHasValue(inputs.classificationType, 'clinical')
                ? isElementVisibleAndHasValue(inputs.lymphNodes, 'n1') ||
                    (isElementVisibleAndHasValue(inputs.lymphNodes, 'n2') &&
                        helpers_1.isAnswered(inputs.N2subgroups))
                : isElementVisibleAndHasValue(inputs.lymphNodesP, 'pN1') ||
                    (isElementVisibleAndHasValue(inputs.lymphNodesP, 'pN2') &&
                        helpers_1.isAnswered(inputs.N2subgroupsP))))) &&
        helpers_1.isAnswered(inputs.metastasis) &&
        ((_f = inputs.metastasis) === null || _f === void 0 ? void 0 : _f.currentIdentifier) === 'm0');
};
var range8Results = function () {
    var _a;
    return (isElementVisibleAndHasValue(inputs.primaryTumor, 't4') &&
        (isElementVisibleAndHasValue(inputs.classificationType, 'clinical')
            ? isElementVisibleAndHasValue(inputs.lymphNodes, 'n0') ||
                isElementVisibleAndHasValue(inputs.lymphNodes, 'n1') ||
                (isElementVisibleAndHasValue(inputs.lymphNodes, 'n2') &&
                    helpers_1.isAnswered(inputs.N2subgroups))
            : isElementVisibleAndHasValue(inputs.lymphNodesP, 'pN0') ||
                (isElementVisibleAndHasValue(inputs.lymphNodesP, 'pN1') &&
                    helpers_1.isAnswered(inputs.N1subgroupsP)) ||
                (isElementVisibleAndHasValue(inputs.lymphNodesP, 'pN2') &&
                    helpers_1.isAnswered(inputs.N2subgroupsP))) &&
        helpers_1.isAnswered(inputs.metastasis) &&
        ((_a = inputs.metastasis) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === 'm0');
};
var range9Results = function () {
    var _a;
    return (helpers_1.isAnswered(inputs.primaryTumor) &&
        (isElementVisibleAndHasValue(inputs.classificationType, 'clinical')
            ? isElementVisibleAndHasValue(inputs.lymphNodes, 'n3') &&
                helpers_1.isAnswered(inputs.N3subgroups)
            : isElementVisibleAndHasValue(inputs.lymphNodesP, 'pN3') &&
                helpers_1.isAnswered(inputs.N3subgroupsP)) &&
        helpers_1.isAnswered(inputs.metastasis) &&
        ((_a = inputs.metastasis) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === 'm0');
};
var range10Results = function () {
    var _a;
    return (helpers_1.isAnswered(inputs.primaryTumor) &&
        (isElementVisibleAndHasValue(inputs.classificationType, 'clinical')
            ? helpers_1.isAnswered(inputs.lymphNodes) &&
                (isElementVisibleAndHasValue(inputs.lymphNodes, 'n2')
                    ? helpers_1.isAnswered(inputs.N2subgroups)
                    : true) &&
                (isElementVisibleAndHasValue(inputs.lymphNodes, 'n3')
                    ? helpers_1.isAnswered(inputs.N3subgroups)
                    : true)
            : helpers_1.isAnswered(inputs.lymphNodesP) &&
                (isElementVisibleAndHasValue(inputs.lymphNodesP, 'pN1')
                    ? helpers_1.isAnswered(inputs.N1subgroupsP)
                    : true) &&
                (isElementVisibleAndHasValue(inputs.lymphNodesP, 'pN2')
                    ? helpers_1.isAnswered(inputs.N2subgroupsP)
                    : true) &&
                (isElementVisibleAndHasValue(inputs.lymphNodesP, 'pN3')
                    ? helpers_1.isAnswered(inputs.N3subgroupsP)
                    : true)) &&
        helpers_1.isAnswered(inputs.metastasis) &&
        ((_a = inputs.metastasis) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === 'm1');
};
var isElementVisibleAndHasValue = function (element, value) {
    return helpers_1.isAnswered(element) && (element === null || element === void 0 ? void 0 : element.currentIdentifier) === value;
};
var returnVisibleQuestions = function () {
    visibleQuestions.primaryTumor = helpers_1.isAnswered(inputs.classificationType);
    visibleQuestions.tiSubgroups = isElementVisibleAndHasValue(inputs.primaryTumor, 'tis');
    visibleQuestions.t1subgroups = isElementVisibleAndHasValue(inputs.primaryTumor, 't1');
    visibleQuestions.t4subgroups = isElementVisibleAndHasValue(inputs.primaryTumor, 't4');
    visibleQuestions.lymphNodes = isElementVisibleAndHasValue(inputs.classificationType, 'clinical');
    visibleQuestions.lymphNodesP = isElementVisibleAndHasValue(inputs.classificationType, 'pathological');
    visibleQuestions.N1subgroupsP = isElementVisibleAndHasValue(inputs.lymphNodesP, 'pN1');
    visibleQuestions.N2subgroups = isElementVisibleAndHasValue(inputs.lymphNodes, 'n2');
    visibleQuestions.N2subgroupsP = isElementVisibleAndHasValue(inputs.lymphNodesP, 'pN2');
    visibleQuestions.N3subgroups = isElementVisibleAndHasValue(inputs.lymphNodes, 'n3');
    visibleQuestions.N3subgroupsP = isElementVisibleAndHasValue(inputs.lymphNodesP, 'pN3');
    visibleQuestions.metastasis = helpers_1.isAnswered(inputs.classificationType);
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_toolScore = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return __assign(__assign({}, result), { visibleQuestions: ut_visibleQuestions(), visibleSections: ut_visibleSections() });
});
