"use strict";


var visibleQuestions = {
    bleedingRisk: true,
    ischemicEventRisk: false,
    answerAll: false,
    dosingSectionResult1Result1: false,
    dosingSectionResult1Result2: false,
    dosingSectionResult1Result3: false,
    dosingSectionResult1Result4: false,
    dosingSectionResult2Result1: false,
    dosingSectionResult2Result2: false,
    dosingSectionResult2Result3: false,
    dosingSectionResult3Result1: false,
    dosingSectionResult3Result2: false
};
var visibleSections = {
    mainSection: true,
    dosingSectionAnswerAll: false,
    dosingSectionResult1: false,
    dosingSectionResult2: false,
    dosingSectionResult3: false
};
var inputs = {
    bleedingRisk: null,
    ischemicEventRisk: null
};
var isAnswerAllVisible = function () {
    var condition2 = helpers_1.answerMatches(inputs.bleedingRisk, 'no') &&
        !helpers_1.isAnswered(inputs.ischemicEventRisk);
    var condition1 = !helpers_1.isAnswered(inputs.bleedingRisk) && !helpers_1.isAnswered(inputs.ischemicEventRisk);
    return condition1 || condition2;
};
var isDosingSectionResult1Visible = function () {
    return helpers_1.answerMatches(inputs.bleedingRisk, 'yes');
};
var isDosingSectionResult2Visible = function () {
    return (helpers_1.answerMatches(inputs.bleedingRisk, 'no') &&
        helpers_1.answerMatches(inputs.ischemicEventRisk, 'yes'));
};
var isDosingSectionResult3Visible = function () {
    return (helpers_1.answerMatches(inputs.bleedingRisk, 'no') &&
        helpers_1.answerMatches(inputs.ischemicEventRisk, 'no'));
};
var isIschemicEventRiskVisible = function () {
    return helpers_1.answerMatches(inputs.bleedingRisk, 'no');
};
var returnVisibleQuestions = function () {
    visibleQuestions.answerAll = isAnswerAllVisible();
    visibleQuestions.ischemicEventRisk = isIschemicEventRiskVisible();
    visibleQuestions.dosingSectionResult1Result1 =
        isDosingSectionResult1Visible();
    visibleQuestions.dosingSectionResult1Result2 =
        isDosingSectionResult1Visible();
    visibleQuestions.dosingSectionResult1Result3 =
        isDosingSectionResult1Visible();
    visibleQuestions.dosingSectionResult1Result4 =
        isDosingSectionResult1Visible();
    visibleQuestions.dosingSectionResult2Result1 =
        isDosingSectionResult2Visible();
    visibleQuestions.dosingSectionResult2Result2 =
        isDosingSectionResult2Visible();
    visibleQuestions.dosingSectionResult2Result3 =
        isDosingSectionResult2Visible();
    visibleQuestions.dosingSectionResult3Result1 =
        isDosingSectionResult3Visible();
    visibleQuestions.dosingSectionResult3Result2 =
        isDosingSectionResult3Visible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.dosingSectionAnswerAll = isAnswerAllVisible();
    visibleSections.dosingSectionResult1 = isDosingSectionResult1Visible();
    visibleSections.dosingSectionResult2 = isDosingSectionResult2Visible();
    visibleSections.dosingSectionResult3 = isDosingSectionResult3Visible();
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var isExportResultsEnabled = function () {
    return !isAnswerAllVisible();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var calculatePoints = function () {
    return null;
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
