"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    bodyMass: true,
    answerAll: false,
    below5Result: false,
    singleDose: false,
    totalDailyDose: false,
    intervalDosingRange: false
};
var visibleSections = {
    section1: true,
    answerAllSection: false,
    below5Section: false,
    results: false
};
var inputs = {
    bodyMass: null
};
var isBodyMassValid = function () {
    return helpers_1.numberInLimits({
        input: inputs.bodyMass,
        min: 1,
        max: 300
    });
};
var returnVisibleQuestions = function () {
    visibleQuestions.answerAll = !isBodyMassValid();
    visibleQuestions.below5Result = isBodyMassLess5();
    visibleQuestions.singleDose = isBodyMassMore5();
    visibleQuestions.totalDailyDose = isBodyMassMore5();
    visibleQuestions.intervalDosingRange = isBodyMassMore5();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.answerAllSection = !isBodyMassValid();
    visibleSections.below5Section = isBodyMassLess5();
    visibleSections.results = isBodyMassMore5();
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var isExportResultsEnabled = function () {
    return isBodyMassValid();
};
var isBodyMassLess5 = function () {
    return helpers_1.numberInLimits({
        input: inputs.bodyMass,
        min: 1,
        max: 4
    });
};
var isBodyMassMore5 = function () {
    return helpers_1.numberInLimits({
        input: inputs.bodyMass,
        min: 5,
        max: 300
    });
};
var shouldMakeCalculations = function () {
    return helpers_1.numberInLimits({
        input: inputs.bodyMass,
        min: 5,
        max: 39
    });
};
var bodyMassAboveEquals40 = function () {
    return helpers_1.numberInLimits({
        input: inputs.bodyMass,
        min: 40
    });
};
var returnBodyMass = function () {
    return inputs.bodyMass.currentPoints;
};
var calculatePoints = function () {
    if (shouldMakeCalculations()) {
        var lowerMaxdose = Number(returnBodyMass() * 20);
        var upperMaxDose = Number(returnBodyMass() * 30);
        var singleDoseVolumeMin = lowerMaxdose / 3 / 20;
        var singleDoseVolumeMax = upperMaxDose / 3 / 20;
        var singleDoseMin = lowerMaxdose / 3;
        var singleDoseMax = upperMaxDose / 3;
        var totallyVolumeMin = lowerMaxdose / 20;
        var totallyVolumeMax = upperMaxDose / 20;
        return {
            singleDose: {
                qID: 'singleDose',
                rParams: __spreadArrays(helpers_1.returnNumberObject(singleDoseVolumeMin, 0, 2), helpers_1.returnNumberObject(singleDoseVolumeMax, 0, 2), helpers_1.returnNumberObject(singleDoseMin, 0, 1), helpers_1.returnNumberObject(singleDoseMax, 0, 1)),
                resultTexts: 'below40'
            },
            totalDailyDose: {
                qID: 'totalDailyDose',
                rParams: __spreadArrays(helpers_1.returnNumberObject(totallyVolumeMin, 0, 1), helpers_1.returnNumberObject(totallyVolumeMax, 0, 2), helpers_1.returnNumberObject(lowerMaxdose, 0, 1), helpers_1.returnNumberObject(upperMaxDose, 0, 1)),
                resultTexts: 'below40'
            },
            intervalDosingRange: {
                qID: 'intervalDosingRange',
                rParams: [],
                resultTexts: 'below40'
            }
        };
    }
    else if (bodyMassAboveEquals40()) {
        return {
            singleDose: {
                qID: 'singleDose',
                rParams: [],
                resultTexts: 'aboveEquals40'
            },
            totalDailyDose: {
                qID: 'totalDailyDose',
                rParams: [],
                resultTexts: 'aboveEquals40'
            },
            intervalDosingRange: {
                qID: 'intervalDosingRange',
                rParams: [],
                resultTexts: 'aboveEquals40'
            }
        };
    }
    return null;
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
