"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    bodyMass: true,
    answerAll: false,
    below10Result: false,
    singleDose: false,
    totalDailyDose: false,
    intervalRange: false
};
var visibleSections = {
    section1: true,
    answerAllSection: false,
    below10Section: false,
    results: false
};
var inputs = {
    bodyMass: null
};
var isBodyMassValid = function () {
    return helpers_1.numberInLimits({
        input: inputs.bodyMass,
        min: 1,
        max: 300
    });
};
var returnVisibleQuestions = function () {
    visibleQuestions.answerAll = !isBodyMassValid();
    visibleQuestions.below10Result = isBodyMassLess10();
    visibleQuestions.singleDose = isBodyMassMoreEqual10();
    visibleQuestions.totalDailyDose = isBodyMassMoreEqual10();
    visibleQuestions.intervalRange = isBodyMassMoreEqual10();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.answerAllSection = !isBodyMassValid();
    visibleSections.below10Section = isBodyMassLess10();
    visibleSections.results = isBodyMassMoreEqual10();
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return isBodyMassValid();
};
var isBodyMassLess10 = function () {
    return helpers_1.numberInLimits({
        input: inputs.bodyMass,
        min: 1,
        max: 9
    });
};
var isBodyMassMoreEqual10 = function () {
    return helpers_1.numberInLimits({
        input: inputs.bodyMass,
        min: 10,
        max: 300
    });
};
var returnBodyMass = function () {
    if (inputs.bodyMass.currentPoints > 40) {
        return 40;
    }
    return inputs.bodyMass.currentPoints;
};
var calculatePoints = function () {
    if (isBodyMassMoreEqual10()) {
        var singleDoseMlLow = Number(7 * returnBodyMass()) / 40;
        var singleDoseMlHigh = Number((returnBodyMass() * 10) / 40);
        var singleDoseMgLow = Number(returnBodyMass() * 7);
        var singleDoseMgHigh = Number(10 * returnBodyMass());
        var totallyDailyDoseMg = Number(returnBodyMass() * 30);
        var totallyDailyDoseMl = Number(returnBodyMass() * 30) / 40;
        return {
            singleDose: {
                qID: 'singleDose',
                rParams: __spreadArrays(helpers_1.returnNumberObject(singleDoseMlLow, 0, 1), helpers_1.returnNumberObject(singleDoseMlHigh, 0, 1), helpers_1.returnNumberObject(singleDoseMgLow, 0, 1), helpers_1.returnNumberObject(singleDoseMgHigh, 0, 1)),
                resultTexts: 'regular'
            },
            totalDailyDose: {
                qID: 'totalDailyDose',
                rParams: __spreadArrays(helpers_1.returnNumberObject(totallyDailyDoseMl, 0, 1), helpers_1.returnNumberObject(totallyDailyDoseMg, 0, 1)),
                resultTexts: 'regular'
            }
        };
    }
    else
        return null;
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
