"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};


var ileumQuestions = {
    ileumDeepUlcers: false,
    ileumSuperficialUlcers: false,
    ileumUlceratedStenosis: false,
    ileumNonUlceratedStenosis: false,
    ileumDiseaseSurface: false,
    ileumUlcerationsSurface: false
};
var rightColonQuestions = {
    rightColonDeepUlcers: false,
    rightColonSuperficialUlcers: false,
    rightColonUlceratedStenosis: false,
    rightColonNonUlceratedStenosis: false,
    rightColonDiseaseSurface: false,
    rightColonUlcerationsSurface: false
};
var transverseColonQuestions = {
    transverseColonDeepUlcers: false,
    transverseColonSuperficialUlcers: false,
    transverseColonUlceratedStenosis: false,
    transverseColonNonUlceratedStenosis: false,
    transverseColonDiseaseSurface: false,
    transverseColonUlcerationsSurface: false
};
var leftColonQuestions = {
    leftColonDeepUlcers: false,
    leftColonSuperficialUlcers: false,
    leftColonUlceratedStenosis: false,
    leftColonNonUlceratedStenosis: false,
    leftColonDiseaseSurface: false,
    leftColonUlcerationsSurface: false
};
var rectumQuestions = {
    rectumDeepUlcers: false,
    rectumSuperficialUlcers: false,
    rectumUlceratedStenosis: false,
    rectumNonUlceratedStenosis: false,
    rectumDiseaseSurface: false,
    rectumUlcerationsSurface: false
};
var visibleQuestions = __assign(__assign(__assign(__assign(__assign({ ileumExplored: true, rightColonExplored: true, transverseColonExplored: true, leftColonExplored: true, rectumExplored: true }, ileumQuestions), rightColonQuestions), transverseColonQuestions), leftColonQuestions), rectumQuestions);
var visibleSections = {
    ileum: true,
    rightColon: true,
    transverseColon: true,
    leftColon: true,
    rectum: true
};
var inputs = {
    ileumExplored: null,
    ileumDeepUlcers: null,
    ileumSuperficialUlcers: null,
    ileumUlceratedStenosis: null,
    ileumNonUlceratedStenosis: null,
    ileumDiseaseSurface: null,
    ileumUlcerationsSurface: null,
    rightColonExplored: null,
    rightColonDeepUlcers: null,
    rightColonSuperficialUlcers: null,
    rightColonUlceratedStenosis: null,
    rightColonNonUlceratedStenosis: null,
    rightColonDiseaseSurface: null,
    rightColonUlcerationsSurface: null,
    transverseColonExplored: null,
    transverseColonDeepUlcers: null,
    transverseColonSuperficialUlcers: null,
    transverseColonUlceratedStenosis: null,
    transverseColonNonUlceratedStenosis: null,
    transverseColonDiseaseSurface: null,
    transverseColonUlcerationsSurface: null,
    leftColonExplored: null,
    leftColonDeepUlcers: null,
    leftColonSuperficialUlcers: null,
    leftColonUlceratedStenosis: null,
    leftColonNonUlceratedStenosis: null,
    leftColonDiseaseSurface: null,
    leftColonUlcerationsSurface: null,
    rectumExplored: null,
    rectumDeepUlcers: null,
    rectumSuperficialUlcers: null,
    rectumUlceratedStenosis: null,
    rectumNonUlceratedStenosis: null,
    rectumDiseaseSurface: null,
    rectumUlcerationsSurface: null
};
var sectionQuestions = function (sectionName) {
    switch (sectionName) {
        case 'ileum': {
            return ileumQuestions;
        }
        case 'rightColon': {
            return rightColonQuestions;
        }
        case 'transverseColon': {
            return transverseColonQuestions;
        }
        case 'leftColon': {
            return leftColonQuestions;
        }
        case 'rectum': {
            return rectumQuestions;
        }
        default: {
            return null;
        }
    }
};
var updateVisiblity = function (section, isSectionExplored) {
    for (var _i = 0, _a = Object.keys(section); _i < _a.length; _i++) {
        var key = _a[_i];
        visibleQuestions[key] = isSectionExplored;
    }
};
var areDiseaseAndUlcerationRangesValid = function (sectionName) {
    var sectionDiseaseSurfaceId = sectionName + 'DiseaseSurface';
    var sectionUlcerationSurfaceId = sectionName + 'UlcerationsSurface';
    return (helpers_1.isAnswered(inputs[sectionDiseaseSurfaceId]) &&
        helpers_1.isAnswered(inputs[sectionUlcerationSurfaceId]) &&
        helpers_1.numberInLimits({
            input: inputs[sectionDiseaseSurfaceId],
            min: 0,
            max: 100
        }) &&
        helpers_1.numberInLimits({
            input: inputs[sectionUlcerationSurfaceId],
            min: 0,
            max: 100
        }));
};
var areAllInSectionAnswered = function (sectionQuestions) {
    for (var _i = 0, _a = Object.keys(sectionQuestions); _i < _a.length; _i++) {
        var key = _a[_i];
        if (!helpers_1.isAnswered(inputs[key]))
            return false;
    }
    return true;
};
var isAtLeastOneSegmentExplored = function () {
    for (var _i = 0, _a = Object.keys(visibleSections); _i < _a.length; _i++) {
        var key = _a[_i];
        var questionId = key + 'Explored';
        if (helpers_1.answerMatches(inputs[questionId], 'yes')) {
            return true;
        }
    }
    return false;
};
var areAllExploredAnswered = function () {
    if (!isAtLeastOneSegmentExplored())
        return false;
    var notAllAnswered = false;
    for (var _i = 0, _a = Object.keys(visibleSections); _i < _a.length; _i++) {
        var key = _a[_i];
        var questions = sectionQuestions(key);
        if (questions != null) {
            notAllAnswered =
                !areAllInSectionAnswered(questions) &&
                    helpers_1.answerMatches(inputs[key + 'Explored'], 'yes');
        }
        if (notAllAnswered)
            return false;
    }
    return true;
};
var isExportResultsEnabled = function () {
    return areAllExploredAnswered();
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0;
    if (!isAtLeastOneSegmentExplored())
        return helpers_1.returnToolScoreObject({ number: -2, range: -2 });
    var invalidRanges = false;
    for (var _i = 0, _1 = Object.keys(visibleSections); _i < _1.length; _i++) {
        var key = _1[_i];
        invalidRanges =
            !areDiseaseAndUlcerationRangesValid(key) &&
                helpers_1.answerMatches(inputs[key + 'Explored'], 'yes');
        if (invalidRanges)
            break;
    }
    if (!areAllExploredAnswered() || invalidRanges)
        return helpers_1.returnToolScoreObject({ number: -1, range: -1 });
    var ulcerationSum = 0;
    var surfaceSum = 0;
    var segmentsExplored = 0;
    if (helpers_1.answerMatches(inputs.ileumExplored, 'yes')) {
        ulcerationSum +=
            Number((_a = inputs.ileumDeepUlcers) === null || _a === void 0 ? void 0 : _a.currentPoints) +
                Number((_b = inputs.ileumSuperficialUlcers) === null || _b === void 0 ? void 0 : _b.currentPoints);
        surfaceSum +=
            Number((_c = inputs.ileumDiseaseSurface) === null || _c === void 0 ? void 0 : _c.currentPoints) +
                Number((_d = inputs.ileumUlcerationsSurface) === null || _d === void 0 ? void 0 : _d.currentPoints);
        segmentsExplored += Number((_e = inputs.ileumExplored) === null || _e === void 0 ? void 0 : _e.currentPoints);
    }
    if (helpers_1.answerMatches(inputs.rightColonExplored, 'yes')) {
        ulcerationSum +=
            Number((_f = inputs.rightColonDeepUlcers) === null || _f === void 0 ? void 0 : _f.currentPoints) +
                Number((_g = inputs.rightColonSuperficialUlcers) === null || _g === void 0 ? void 0 : _g.currentPoints);
        surfaceSum +=
            Number((_h = inputs.rightColonDiseaseSurface) === null || _h === void 0 ? void 0 : _h.currentPoints) +
                Number((_j = inputs.rightColonUlcerationsSurface) === null || _j === void 0 ? void 0 : _j.currentPoints);
        segmentsExplored += Number((_k = inputs.rightColonExplored) === null || _k === void 0 ? void 0 : _k.currentPoints);
    }
    if (helpers_1.answerMatches(inputs.transverseColonExplored, 'yes')) {
        ulcerationSum +=
            Number((_l = inputs.transverseColonDeepUlcers) === null || _l === void 0 ? void 0 : _l.currentPoints) +
                Number((_m = inputs.transverseColonSuperficialUlcers) === null || _m === void 0 ? void 0 : _m.currentPoints);
        surfaceSum +=
            Number((_o = inputs.transverseColonDiseaseSurface) === null || _o === void 0 ? void 0 : _o.currentPoints) +
                Number((_p = inputs.transverseColonUlcerationsSurface) === null || _p === void 0 ? void 0 : _p.currentPoints);
        segmentsExplored += Number((_q = inputs.transverseColonExplored) === null || _q === void 0 ? void 0 : _q.currentPoints);
    }
    if (helpers_1.answerMatches(inputs.leftColonExplored, 'yes')) {
        ulcerationSum +=
            Number((_r = inputs.leftColonDeepUlcers) === null || _r === void 0 ? void 0 : _r.currentPoints) +
                Number((_s = inputs.leftColonSuperficialUlcers) === null || _s === void 0 ? void 0 : _s.currentPoints);
        surfaceSum +=
            Number((_t = inputs.leftColonDiseaseSurface) === null || _t === void 0 ? void 0 : _t.currentPoints) +
                Number((_u = inputs.leftColonUlcerationsSurface) === null || _u === void 0 ? void 0 : _u.currentPoints);
        segmentsExplored += Number((_v = inputs.leftColonExplored) === null || _v === void 0 ? void 0 : _v.currentPoints);
    }
    if (helpers_1.answerMatches(inputs.rectumExplored, 'yes')) {
        ulcerationSum +=
            Number((_w = inputs.rectumDeepUlcers) === null || _w === void 0 ? void 0 : _w.currentPoints) +
                Number((_x = inputs.rectumSuperficialUlcers) === null || _x === void 0 ? void 0 : _x.currentPoints);
        surfaceSum +=
            Number((_y = inputs.rectumDiseaseSurface) === null || _y === void 0 ? void 0 : _y.currentPoints) +
                Number((_z = inputs.rectumUlcerationsSurface) === null || _z === void 0 ? void 0 : _z.currentPoints);
        segmentsExplored += Number((_0 = inputs.rectumExplored) === null || _0 === void 0 ? void 0 : _0.currentPoints);
    }
    surfaceSum /= 10;
    var ulceratedStenosis = helpers_1.answerMatches(inputs.ileumUlceratedStenosis, 'yes') ||
        helpers_1.answerMatches(inputs.rightColonUlceratedStenosis, 'yes') ||
        helpers_1.answerMatches(inputs.transverseColonUlceratedStenosis, 'yes') ||
        helpers_1.answerMatches(inputs.leftColonUlceratedStenosis, 'yes') ||
        helpers_1.answerMatches(inputs.rectumUlceratedStenosis, 'yes');
    var nonUlceratedStenosis = helpers_1.answerMatches(inputs.ileumNonUlceratedStenosis, 'yes') ||
        helpers_1.answerMatches(inputs.rightColonNonUlceratedStenosis, 'yes') ||
        helpers_1.answerMatches(inputs.transverseColonNonUlceratedStenosis, 'yes') ||
        helpers_1.answerMatches(inputs.leftColonNonUlceratedStenosis, 'yes') ||
        helpers_1.answerMatches(inputs.rectumNonUlceratedStenosis, 'yes');
    var outputResult = helpers_1.formatCalculationResult((ulcerationSum + surfaceSum) / segmentsExplored +
        (ulceratedStenosis ? 3 : 0) +
        (nonUlceratedStenosis ? 3 : 0), 2);
    return helpers_1.returnToolScoreObject({ number: outputResult, range: outputResult });
};
var returnVisibleQuestions = function () {
    for (var _i = 0, _a = Object.keys(visibleSections); _i < _a.length; _i++) {
        var key = _a[_i];
        var questionId = key + 'Explored';
        var questions = sectionQuestions(key);
        if (questions != null)
            updateVisiblity(questions, helpers_1.answerMatches(inputs[questionId], 'yes'));
    }
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_toolScore = function () {
    return calculatePoints();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return __assign(__assign({ exportResultsEnabled: isExportResultsEnabled() }, result), { visibleQuestions: ut_visibleQuestions(), visibleSections: ut_visibleSections() });
});
