"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

var visibleQuestions = {
    severity: true,
    improvement: true,
    therapeuticE: true,
    sideE: true,
    result1: true,
    result2: true,
    result3: true
};
var visibleSections = {
    severitySection: true,
    improvementSection: true,
    efficacySection: true,
    resultSection: true
};
var inputs = {
    severity: null,
    improvement: null,
    therapeuticE: null,
    sideE: null
};
var generateResultObject = function (name, tParams) {
    var _a;
    return _a = {},
        _a[name] = {
            qID: name,
            titleTexts: 'regular',
            tParams: tParams
        },
        _a;
};
var cgieScoreMatrix = [
    ['0 0', '0 1', '0 2', '0 3', '0 4'],
    ['1 0', '1 1', '1 2', '1 3', '1 4'],
    ['2 0', '2 1', '2 2', '2 3', '2 4'],
    ['3 0', '3 1', '3 2', '3 3', '3 4'],
    ['4 0', '4 1', '4 2', '4 3', '4 4'],
];
var calculatePoints = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
    var firstIndex = Number((_a = inputs.therapeuticE) === null || _a === void 0 ? void 0 : _a.currentPoints);
    var secondIndex = Number((_b = inputs.sideE) === null || _b === void 0 ? void 0 : _b.currentPoints);
    return __assign(__assign(__assign({}, generateResultObject('result1', [
        { type: 'number', value: Number(((_c = inputs.severity) === null || _c === void 0 ? void 0 : _c.currentPoints) || 0) },
        { type: 'string', value: ((_e = (_d = inputs.severity) === null || _d === void 0 ? void 0 : _d.data) === null || _e === void 0 ? void 0 : _e.title.slice(4)) || '' },
    ])), generateResultObject('result2', [
        {
            type: 'number',
            value: Number(((_f = inputs.improvement) === null || _f === void 0 ? void 0 : _f.currentPoints) || 0)
        },
        { type: 'string', value: ((_h = (_g = inputs.improvement) === null || _g === void 0 ? void 0 : _g.data) === null || _h === void 0 ? void 0 : _h.title.slice(4)) || '' },
    ])), generateResultObject('result3', [
        {
            type: 'string',
            value: cgieScoreMatrix[firstIndex][secondIndex]
        },
        {
            type: 'string',
            value: ((_k = (_j = inputs.therapeuticE) === null || _j === void 0 ? void 0 : _j.data) === null || _k === void 0 ? void 0 : _k.title.slice(4)) || ''
        },
        { type: 'string', value: ((_m = (_l = inputs.sideE) === null || _l === void 0 ? void 0 : _l.data) === null || _m === void 0 ? void 0 : _m.title.slice(4)) || '' },
    ]));
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return true;
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
