"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};


var visibleQuestions = {
    age: true,
    sex: true,
    heartFailure: true,
    hypertension: true,
    stroke: true,
    vascular: true,
    diabetes: true
};
var visibleSections = {
    patientInfo: true
};
var inputs = {
    age: null,
    sex: null,
    heartFailure: null,
    hypertension: null,
    stroke: null,
    vascular: null,
    diabetes: null
};
var calculatePoints = function () {
    var _a;
    if (!helpers_1.isAnswered(inputs.age) || !helpers_1.isAnswered(inputs.sex))
        return helpers_1.returnToolScoreObject({});
    var result = helpers_1.formatCalculationResult(Number(inputs.age.currentPoints) +
        Number(inputs.sex.currentPoints) +
        Number(inputs.heartFailure.currentPoints) +
        Number(inputs.hypertension.currentPoints) +
        Number(inputs.stroke.currentPoints) +
        Number(inputs.vascular.currentPoints) +
        Number(inputs.diabetes.currentPoints));
    var range = result === 1 && ((_a = inputs.sex) === null || _a === void 0 ? void 0 : _a.currentPoints) === 1 ? 0 : result;
    return helpers_1.returnToolScoreObject({ number: result, range: range });
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_toolScore = function () {
    return calculatePoints();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return true;
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return __assign(__assign({ exportResultsEnabled: isExportResultsEnabled() }, result), { visibleQuestions: ut_visibleQuestions(), visibleSections: ut_visibleSections() });
});
