"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};


var visibleQuestions = {
    bilirubinµmolL: true,
    bilirubinmgdL: false,
    albumingL: true,
    albumingdL: false,
    inr: true,
    ascites: true,
    encephalopathy: true,
    bilirubinSwitch: true,
    albuminSwitch: true
};
var visibleSections = {
    patientInfo: true,
    options: true
};
var inputs = {
    bilirubinµmolL: null,
    bilirubinmgdL: null,
    albumingL: null,
    albumingdL: null,
    inr: null,
    ascites: null,
    encephalopathy: null,
    bilirubinSwitch: null,
    albuminSwitch: null
};
var allQuestionsAnswered = function () {
    var allNotAnswered = !helpers_1.isAnswered(inputs.inr) ||
        !helpers_1.isAnswered(inputs.ascites) ||
        !helpers_1.isAnswered(inputs.encephalopathy) ||
        !(helpers_1.isAnswered(inputs.bilirubinµmolL) || helpers_1.isAnswered(inputs.bilirubinmgdL)) ||
        !(helpers_1.isAnswered(inputs.albumingL) || helpers_1.isAnswered(inputs.albumingdL));
    return !allNotAnswered;
};
var calculatePoints = function () {
    var _a;
    var result = 0;
    if (!allQuestionsAnswered()) {
        return helpers_1.returnToolScoreObject({});
    }
    if (inputs.bilirubinSwitch.currentIdentifier === "µmol/L") {
        if (!inputs.bilirubinµmolL.currentIdentifier) {
            return null;
        }
        result += inputs.bilirubinµmolL.currentPoints;
    }
    else {
        if (!inputs.bilirubinmgdL.currentIdentifier) {
            return null;
        }
        result += Number(inputs.bilirubinmgdL.currentPoints);
    }
    if (inputs.albuminSwitch.currentIdentifier === "g/L") {
        if (!inputs.albumingL.currentIdentifier) {
            return null;
        }
        result += Number(inputs.albumingL.currentPoints);
    }
    else {
        if (!inputs.albumingdL.currentIdentifier) {
            return null;
        }
        result += Number(inputs.albumingdL.currentPoints);
    }
    result +=
        Number(inputs.inr.currentPoints) +
            Number(inputs.ascites.currentPoints) +
            Number(inputs.encephalopathy.currentPoints);
    var range = result === 1 && ((_a = inputs.sex) === null || _a === void 0 ? void 0 : _a.currentPoints) === 1 ? 0 : result;
    return helpers_1.returnToolScoreObject({ number: result, range: range });
};
var returnVisibleQuestions = function () {
    if (inputs.bilirubinSwitch.currentIdentifier === "µmol/L") {
        visibleQuestions.bilirubinµmolL = true;
        visibleQuestions.bilirubinmgdL = false;
    }
    else {
        visibleQuestions.bilirubinµmolL = false;
        visibleQuestions.bilirubinmgdL = true;
    }
    if (inputs.albuminSwitch.currentIdentifier === "g/L") {
        visibleQuestions.albumingL = true;
        visibleQuestions.albumingdL = false;
    }
    else {
        visibleQuestions.albumingL = false;
        visibleQuestions.albumingdL = true;
    }
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_toolScore = function () {
    return calculatePoints();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return allQuestionsAnswered();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return __assign(__assign({ exportResultsEnabled: isExportResultsEnabled() }, result), { visibleQuestions: ut_visibleQuestions(), visibleSections: ut_visibleSections() });
});
