"use strict";


var visibleQuestions = {
    TC: true,
    HDL: true,
    TG: true,
    answerAll: false,
    result2: false,
    result3: false,
    result4: false,
    result5: false,
    result6: false,
    result7: false,
    result8: false,
    result9: false,
    result10: false,
    result11: false
};
var visibleSections = {
    inputs: true,
    results0: true,
    results1: false,
    results2: false
};
var inputs = {
    TC: null,
    HDL: null,
    TG: null
};
var calculationsNegative = function () {
    return (calculateFriedewald().mgdl < 0 ||
        calculateFriedewald().mmol < 0 ||
        calculateHattori().mgdl < 0 ||
        calculateHattori().mmol < 0 ||
        calculateAnandaraja().mgdl < 0 ||
        calculateAnandaraja().mmol < 0 ||
        calculateVujovic().mgdl < 0 ||
        calculateVujovic().mmol < 0 ||
        calculateChen().mgdl < 0 ||
        calculateChen().mmol < 0 ||
        calculateDeCordova().mgdl < 0 ||
        calculateDeCordova().mmol < 0);
};
var inputValuesValid = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t;
    if (((_a = inputs.TC) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "mg/dL") {
        if (Number((_b = inputs.TC) === null || _b === void 0 ? void 0 : _b.currentPoints) < 50 ||
            Number((_c = inputs.TC) === null || _c === void 0 ? void 0 : _c.currentPoints) > 2000)
            return false;
    }
    else if (((_d = inputs.TC) === null || _d === void 0 ? void 0 : _d.currentIdentifier) === "mmol/L") {
        if (Number((_e = inputs.TC) === null || _e === void 0 ? void 0 : _e.currentPoints) < 1 ||
            Number((_f = inputs.TC) === null || _f === void 0 ? void 0 : _f.currentPoints) > 50)
            return false;
    }
    if (((_g = inputs.HDL) === null || _g === void 0 ? void 0 : _g.currentIdentifier) === "mg/dL") {
        if (Number((_h = inputs.HDL) === null || _h === void 0 ? void 0 : _h.currentPoints) < 0.1 ||
            Number((_j = inputs.HDL) === null || _j === void 0 ? void 0 : _j.currentPoints) > 200)
            return false;
    }
    else if (((_k = inputs.HDL) === null || _k === void 0 ? void 0 : _k.currentIdentifier) === "mmol/L") {
        if (Number((_l = inputs.HDL) === null || _l === void 0 ? void 0 : _l.currentPoints) < 0.01 ||
            Number((_m = inputs.HDL) === null || _m === void 0 ? void 0 : _m.currentPoints) > 6)
            return false;
    }
    if (((_o = inputs.TG) === null || _o === void 0 ? void 0 : _o.currentIdentifier) === "mg/dL") {
        if (Number((_p = inputs.TG) === null || _p === void 0 ? void 0 : _p.currentPoints) < 0 ||
            Number((_q = inputs.TG) === null || _q === void 0 ? void 0 : _q.currentPoints) > 500)
            return false;
    }
    else if (((_r = inputs.TG) === null || _r === void 0 ? void 0 : _r.currentIdentifier) === "mmol/L") {
        if (Number((_s = inputs.TG) === null || _s === void 0 ? void 0 : _s.currentPoints) < 0 ||
            Number((_t = inputs.TG) === null || _t === void 0 ? void 0 : _t.currentPoints) > 30)
            return false;
    }
    return true;
};
var friedewaldVisibility = function () {
    var _a, _b, _c;
    return ((_a = inputs.TG) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "mg/dL"
        ? ((_b = inputs.TG) === null || _b === void 0 ? void 0 : _b.currentPoints) <= 400
        : ((_c = inputs.TG) === null || _c === void 0 ? void 0 : _c.currentPoints) <= 4.5;
};
var allInputsAnsweredAndValid = function () {
    return (helpers_1.isAnswered(inputs.TC) &&
        helpers_1.isAnswered(inputs.HDL) &&
        helpers_1.isAnswered(inputs.TG) &&
        inputValuesValid());
};
var answerAllVisibility = function () {
    return (!helpers_1.isAnswered(inputs.TC) ||
        !helpers_1.isAnswered(inputs.HDL) ||
        !helpers_1.isAnswered(inputs.TG) ||
        !inputValuesValid());
};
var result2Visibility = function () {
    var _a, _b;
    return (inputValuesValid() &&
        helpers_1.isAnswered(inputs.TC) &&
        helpers_1.isAnswered(inputs.HDL) &&
        Number((_a = inputs.HDL) === null || _a === void 0 ? void 0 : _a.currentPoints) >= Number((_b = inputs.TC) === null || _b === void 0 ? void 0 : _b.currentPoints));
};
var returnVisibleQuestions = function () {
    visibleQuestions.answerAll = answerAllVisibility() && !result2Visibility();
    visibleQuestions.result2 = result2Visibility();
    visibleQuestions.result3 =
        allInputsAnsweredAndValid() &&
            calculationsNegative() &&
            !visibleQuestions.result2;
    visibleQuestions.result4 =
        allInputsAnsweredAndValid() &&
            friedewaldVisibility() &&
            !calculationsNegative();
    visibleQuestions.result5 =
        allInputsAnsweredAndValid() &&
            friedewaldVisibility() &&
            !calculationsNegative();
    visibleQuestions.result6 =
        allInputsAnsweredAndValid() &&
            !friedewaldVisibility() &&
            !calculationsNegative();
    visibleQuestions.result7 =
        allInputsAnsweredAndValid() && !calculationsNegative();
    visibleQuestions.result8 =
        allInputsAnsweredAndValid() && !calculationsNegative();
    visibleQuestions.result9 =
        allInputsAnsweredAndValid() && !calculationsNegative();
    visibleQuestions.result10 =
        allInputsAnsweredAndValid() && !calculationsNegative();
    visibleQuestions.result11 =
        allInputsAnsweredAndValid() && !calculationsNegative();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    var _a, _b, _c, _d;
    visibleSections.results0 =
        !allInputsAnsweredAndValid() ||
            calculationsNegative() ||
            Number((_a = inputs.HDL) === null || _a === void 0 ? void 0 : _a.currentPoints) >= Number((_b = inputs.TC) === null || _b === void 0 ? void 0 : _b.currentPoints);
    visibleSections.results1 =
        allInputsAnsweredAndValid() &&
            Number((_c = inputs.HDL) === null || _c === void 0 ? void 0 : _c.currentPoints) < Number((_d = inputs.TC) === null || _d === void 0 ? void 0 : _d.currentPoints) &&
            !calculationsNegative();
    visibleSections.results2 =
        allInputsAnsweredAndValid() && !calculationsNegative();
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var calculatePoints = function () {
    var questionsAnswered = helpers_1.isAnswered(inputs.TC) &&
        helpers_1.isAnswered(inputs.HDL) &&
        helpers_1.isAnswered(inputs.TG) &&
        inputValuesValid() &&
        !calculationsNegative();
    return {
        number: 0,
        range: 0,
        result2: {
            qID: "result2",
            rParams: [],
            resultTexts: "default"
        },
        result3: {
            qID: "result3",
            rParams: [],
            resultTexts: "default"
        },
        result4: {
            qID: "result4",
            tParams: [
                {
                    type: "number",
                    value: questionsAnswered && friedewaldVisibility()
                        ? calculateFriedewald().mgdl
                        : 0
                },
                {
                    type: "number",
                    value: questionsAnswered && friedewaldVisibility()
                        ? calculateFriedewald().mmol
                        : 0
                },
            ],
            titleTexts: "default"
        },
        result6: {
            qID: "result6",
            rParams: [],
            resultTexts: "default"
        },
        result7: {
            qID: "result7",
            tParams: [
                {
                    type: "number",
                    value: questionsAnswered ? calculateHattori().mgdl : 0
                },
                {
                    type: "number",
                    value: questionsAnswered ? calculateHattori().mmol : 0
                },
            ],
            titleTexts: "default"
        },
        result8: {
            qID: "result8",
            tParams: [
                {
                    type: "number",
                    value: questionsAnswered ? calculateAnandaraja().mgdl : 0
                },
                {
                    type: "number",
                    value: questionsAnswered ? calculateAnandaraja().mmol : 0
                },
            ],
            titleTexts: "default"
        },
        result9: {
            qID: "result9",
            tParams: [
                {
                    type: "number",
                    value: questionsAnswered ? calculateVujovic().mgdl : 0
                },
                {
                    type: "number",
                    value: questionsAnswered ? calculateVujovic().mmol : 0
                },
            ],
            titleTexts: "default"
        },
        result10: {
            qID: "result10",
            tParams: [
                {
                    type: "number",
                    value: questionsAnswered ? calculateChen().mgdl : 0
                },
                {
                    type: "number",
                    value: questionsAnswered ? calculateChen().mmol : 0
                },
            ],
            titleTexts: "default"
        },
        result11: {
            qID: "result11",
            tParams: [
                {
                    type: "number",
                    value: questionsAnswered ? calculateDeCordova().mgdl : 0
                },
                {
                    type: "number",
                    value: questionsAnswered ? calculateDeCordova().mmol : 0
                },
            ],
            titleTexts: "default"
        }
    };
};
var getTCPoints = function () {
    var _a, _b, _c;
    return ((_a = inputs.TC) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "mg/dL"
        ? Number((_b = inputs.TC) === null || _b === void 0 ? void 0 : _b.currentPoints)
        : Number((_c = inputs.TC) === null || _c === void 0 ? void 0 : _c.currentPoints) * 38.67;
};
var getHDLPoints = function () {
    var _a, _b, _c;
    return ((_a = inputs.HDL) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "mg/dL"
        ? Number((_b = inputs.HDL) === null || _b === void 0 ? void 0 : _b.currentPoints)
        : Number((_c = inputs.HDL) === null || _c === void 0 ? void 0 : _c.currentPoints) * 38.67;
};
var getTGPoints = function () {
    var _a, _b, _c;
    return ((_a = inputs.TG) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "mg/dL"
        ? Number((_b = inputs.TG) === null || _b === void 0 ? void 0 : _b.currentPoints)
        : Number((_c = inputs.TG) === null || _c === void 0 ? void 0 : _c.currentPoints) * 88.57;
};
var calculateFriedewald = function () {
    if (!helpers_1.isAnswered(inputs.TC) ||
        !helpers_1.isAnswered(inputs.HDL) ||
        !helpers_1.isAnswered(inputs.TG))
        return {
            mgdl: 0,
            mmol: 0
        };
    var TC = getTCPoints();
    var HDL = getHDLPoints();
    var TG = getTGPoints();
    var mgdLResult = helpers_1.formatCalculationResult(TC - HDL - TG / 5, 1);
    var mmolResult = helpers_1.formatCalculationResult(mgdLResult * 0.02586, 1);
    return {
        mgdl: mgdLResult,
        mmol: mmolResult
    };
};
var calculateHattori = function () {
    if (!helpers_1.isAnswered(inputs.TC) ||
        !helpers_1.isAnswered(inputs.HDL) ||
        !helpers_1.isAnswered(inputs.TG))
        return {
            mgdl: 0,
            mmol: 0
        };
    var TC = getTCPoints();
    var HDL = getHDLPoints();
    var TG = getTGPoints();
    var mgdLResult = helpers_1.formatCalculationResult(0.94 * TC - 0.94 * HDL - 0.19 * TG, 1);
    var mmolResult = helpers_1.formatCalculationResult(mgdLResult * 0.02586, 1);
    return {
        mgdl: mgdLResult,
        mmol: mmolResult
    };
};
var calculateAnandaraja = function () {
    if (!helpers_1.isAnswered(inputs.TC) || !helpers_1.isAnswered(inputs.TG))
        return {
            mgdl: 0,
            mmol: 0
        };
    var TC = getTCPoints();
    var TG = getTGPoints();
    var mgdLResult = helpers_1.formatCalculationResult(0.9 * TC - (0.9 * TG) / 5 - 28, 1);
    var mmolResult = helpers_1.formatCalculationResult(mgdLResult * 0.02586, 1);
    return {
        mgdl: mgdLResult,
        mmol: mmolResult
    };
};
var calculateVujovic = function () {
    if (!helpers_1.isAnswered(inputs.TC) ||
        !helpers_1.isAnswered(inputs.HDL) ||
        !helpers_1.isAnswered(inputs.TG))
        return {
            mgdl: 0,
            mmol: 0
        };
    var TC = getTCPoints();
    var HDL = getHDLPoints();
    var TG = getTGPoints();
    var mgdLResult = helpers_1.formatCalculationResult(TC - HDL - TG / 6.58, 1);
    var mmolResult = helpers_1.formatCalculationResult(mgdLResult * 0.02586, 1);
    return {
        mgdl: mgdLResult,
        mmol: mmolResult
    };
};
var calculateChen = function () {
    if (!helpers_1.isAnswered(inputs.TC) ||
        !helpers_1.isAnswered(inputs.HDL) ||
        !helpers_1.isAnswered(inputs.TG))
        return {
            mgdl: 0,
            mmol: 0
        };
    var TC = getTCPoints();
    var HDL = getHDLPoints();
    var TG = getTGPoints();
    var mgdLResult = helpers_1.formatCalculationResult((TC - HDL) * 0.9 - TG * 0.1, 1);
    var mmolResult = helpers_1.formatCalculationResult(mgdLResult * 0.02586, 1);
    return {
        mgdl: mgdLResult,
        mmol: mmolResult
    };
};
var calculateDeCordova = function () {
    if (!helpers_1.isAnswered(inputs.TC) || !helpers_1.isAnswered(inputs.HDL))
        return {
            mgdl: 0,
            mmol: 0
        };
    var TC = getTCPoints();
    var HDL = getHDLPoints();
    var mgdLResult = helpers_1.formatCalculationResult(0.7516 * (TC - HDL), 1);
    var mmolResult = helpers_1.formatCalculationResult(mgdLResult * 0.02586, 1);
    return {
        mgdl: mgdLResult,
        mmol: mmolResult
    };
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});