"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    age: true,
    weight: true,
    dosing1: true,
    tablets1: true,
    suspension1: true,
    duration11: true,
    warning11: true,
    suspension21: true,
    suspension22: true,
    duration21: true,
    warning21: true
};
var visibleSections = {
    section1: true,
    dosing: true,
    tablets: false,
    suspension: false,
    duration1: false,
    warning1: false,
    suspension2: false,
    duration2: false,
    warning2: false
};
var inputs = {
    age: null,
    weight: null
};
var allAnswered = function () {
    var _a;
    if (((_a = inputs.age) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === 'less12') {
        return helpers_1.isAnswered(inputs.weight);
    }
    return helpers_1.isAnswered(inputs.age);
};
var returnVisibleQuestions = function () {
    var _a, _b;
    visibleQuestions.weight =
        helpers_1.isAnswered(inputs.age) && ((_a = inputs.age) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === 'less12';
    visibleQuestions.suspension22 =
        allAnswered() && ((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints) < 10;
    return visibleQuestions;
};
var returnVisibleSections = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    visibleSections.dosing = !allAnswered();
    visibleSections.tablets =
        helpers_1.isAnswered(inputs.age) && ((_a = inputs.age) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === 'more12';
    visibleSections.suspension =
        helpers_1.isAnswered(inputs.age) && ((_b = inputs.age) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === 'more12';
    visibleSections.duration1 =
        helpers_1.isAnswered(inputs.age) && ((_c = inputs.age) === null || _c === void 0 ? void 0 : _c.currentIdentifier) === 'more12';
    visibleSections.warning1 =
        helpers_1.isAnswered(inputs.age) && ((_d = inputs.age) === null || _d === void 0 ? void 0 : _d.currentIdentifier) === 'more12';
    if (((_e = inputs.age) === null || _e === void 0 ? void 0 : _e.currentIdentifier) === 'less12' && helpers_1.isAnswered(inputs.weight)) {
        visibleSections.suspension2 = ((_f = inputs.weight) === null || _f === void 0 ? void 0 : _f.currentPoints) !== null;
        visibleSections.duration2 = ((_g = inputs.weight) === null || _g === void 0 ? void 0 : _g.currentPoints) !== null;
        visibleSections.warning2 = ((_h = inputs.weight) === null || _h === void 0 ? void 0 : _h.currentPoints) !== null;
    }
    else {
        visibleSections.suspension2 = false;
        visibleSections.duration2 = false;
        visibleSections.warning2 = false;
    }
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var calculatePoints = function () {
    var _a, _b, _c, _d;
    if (!allAnswered()) {
        return {
            number: 0,
            range: 0
        };
    }
    if (((_a = inputs.age) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === 'more12') {
        return {
            number: 0,
            range: 0
        };
    }
    var dailyDose = (Number((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints) * 8 * 5) / 100;
    var bidailyDose = (Number((_c = inputs.weight) === null || _c === void 0 ? void 0 : _c.currentPoints) * 4 * 5) / 100;
    if (Number((_d = inputs.weight) === null || _d === void 0 ? void 0 : _d.currentPoints) >= 50) {
        dailyDose = 20;
        bidailyDose = 10;
    }
    return {
        number: 0,
        range: 0,
        suspension21: {
            qID: 'suspension21',
            tParams: __spreadArrays(helpers_1.returnNumberObject(dailyDose, 0, 1), helpers_1.returnNumberObject(bidailyDose, 0, 1)),
            titleTexts: 'regular'
        }
    };
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
