"use strict";


var visibleQuestions = {
    weight: true,
    warningKids: true,
    dosingAdults: true,
    durationAdults: true,
    kidneyGray: true,
    kidneyOrange: true,
    guidelines: true,
    noAnswer: true
};
var visibleSections = {
    weightSection: true,
    kidsSection: false,
    adultsSection: false,
    kidneySection: false,
    guidelinesSection: false,
    noAnswerSection: false
};
var inputs = {
    weight: null
};
var isKidsSectionVisible = function () {
    return helpers_1.answerMatches(inputs.weight, 'small');
};
var isAdultsSectionVisible = function () {
    return helpers_1.answerMatches(inputs.weight, 'big');
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.kidsSection = isKidsSectionVisible();
    visibleSections.adultsSection = isAdultsSectionVisible();
    visibleSections.kidneySection = isAdultsSectionVisible();
    visibleSections.guidelinesSection = isAdultsSectionVisible();
    visibleSections.noAnswerSection = !helpers_1.isAnswered(inputs.weight);
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return helpers_1.isAnswered(inputs.weight);
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
