"use strict";


var visibleQuestions = {
    warning: true,
    age: true,
    temperature: true,
    cough: true,
    adenopathy: true,
    tonsils: true,
    answerAll: false,
    scoreNegative1: false,
    score0: false,
    score1: false,
    managementGreen: false,
    score2: false,
    score3: false,
    managementOrange: false,
    score4: false,
    score5: false,
    managementRed: false,
    warningPenicillin: false
};
var visibleSections = {
    inputSection: true,
    resultSection: true,
    warningP: false
};
var inputs = {
    age: null,
    temperature: null,
    cough: null,
    adenopathy: null,
    tonsils: null
};
var calculateSumOfPoints = function () {
    var _a, _b, _c, _d, _e;
    return (Number((_a = inputs.age) === null || _a === void 0 ? void 0 : _a.currentPoints) +
        Number((_b = inputs.temperature) === null || _b === void 0 ? void 0 : _b.currentPoints) +
        Number((_c = inputs.cough) === null || _c === void 0 ? void 0 : _c.currentPoints) +
        Number((_d = inputs.adenopathy) === null || _d === void 0 ? void 0 : _d.currentPoints) +
        Number((_e = inputs.tonsils) === null || _e === void 0 ? void 0 : _e.currentPoints));
};
var areAllQuestionsAnswered = function () {
    return (helpers_1.isAnswered(inputs.age) &&
        helpers_1.isAnswered(inputs.temperature) &&
        helpers_1.isAnswered(inputs.cough) &&
        helpers_1.isAnswered(inputs.adenopathy) &&
        helpers_1.isAnswered(inputs.tonsils));
};
var isManagementGreenVisible = function () {
    var firstCondition = calculateSumOfPoints() === -1 && areAllQuestionsAnswered();
    var secondCondition = calculateSumOfPoints() === 0 && areAllQuestionsAnswered();
    var thirdCondition = calculateSumOfPoints() === 1 && areAllQuestionsAnswered();
    return firstCondition || secondCondition || thirdCondition;
};
var isManagementOrangeVisible = function () {
    var firstCondition = calculateSumOfPoints() === 2 && areAllQuestionsAnswered();
    var secondCondition = calculateSumOfPoints() === 3 && areAllQuestionsAnswered();
    return firstCondition || secondCondition;
};
var isManagementRedVisible = function () {
    var firstCondition = calculateSumOfPoints() === 4 && areAllQuestionsAnswered();
    var secondCondition = calculateSumOfPoints() === 5 && areAllQuestionsAnswered();
    return firstCondition || secondCondition;
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.answerAll = !areAllQuestionsAnswered();
    visibleQuestions.scoreNegative1 =
        calculateSumOfPoints() === -1 && areAllQuestionsAnswered();
    visibleQuestions.score0 =
        calculateSumOfPoints() === 0 && areAllQuestionsAnswered();
    visibleQuestions.score1 =
        calculateSumOfPoints() === 1 && areAllQuestionsAnswered();
    visibleQuestions.managementGreen = isManagementGreenVisible();
    visibleQuestions.score2 =
        calculateSumOfPoints() === 2 && areAllQuestionsAnswered();
    visibleQuestions.score3 =
        calculateSumOfPoints() === 3 && areAllQuestionsAnswered();
    visibleQuestions.managementOrange = isManagementOrangeVisible();
    visibleQuestions.score4 =
        calculateSumOfPoints() === 4 && areAllQuestionsAnswered();
    visibleQuestions.score5 =
        calculateSumOfPoints() === 5 && areAllQuestionsAnswered();
    visibleQuestions.managementRed = isManagementRedVisible();
    visibleQuestions.warningPenicillin = areAllQuestionsAnswered();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.warningP = areAllQuestionsAnswered();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return areAllQuestionsAnswered();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: { number: result, range: result },
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
