"use strict";


var visibleQuestions = {
    warning: true,
    age: true,
    temperature: true,
    cough: true,
    adenopathy: true,
    tonsils: true,
    answerAll: false,
    scoreNegative1: false,
    score0: false,
    managementGreenZeroNegative: false,
    score1: false,
    score2: false,
    managementGreen: false,
    score3: false,
    managementOrange: false,
    score4: false,
    score5: false,
    managementRed: false,
    warningPenicillin: false
};
var visibleSections = {
    inputSection: true,
    resultSection: true,
    warningP: false
};
var inputs = {
    age: null,
    temperature: null,
    cough: null,
    adenopathy: null,
    tonsils: null
};
var result = function () {
    var _a, _b, _c, _d, _e;
    return (Number((_a = inputs.age) === null || _a === void 0 ? void 0 : _a.currentPoints) +
        Number((_b = inputs.temperature) === null || _b === void 0 ? void 0 : _b.currentPoints) +
        Number((_c = inputs.cough) === null || _c === void 0 ? void 0 : _c.currentPoints) +
        Number((_d = inputs.adenopathy) === null || _d === void 0 ? void 0 : _d.currentPoints) +
        Number((_e = inputs.tonsils) === null || _e === void 0 ? void 0 : _e.currentPoints));
};
var isAnswerdAllVisible = function () {
    return !(helpers_1.isAnswered(inputs.age) &&
        helpers_1.isAnswered(inputs.temperature) &&
        helpers_1.isAnswered(inputs.cough) &&
        helpers_1.isAnswered(inputs.adenopathy) &&
        helpers_1.isAnswered(inputs.tonsils));
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.answerAll = isAnswerdAllVisible();
    visibleQuestions.scoreNegative1 =
        !isAnswerdAllVisible() && helpers_1.inLimits(result(), -1, -1);
    visibleQuestions.score0 = !isAnswerdAllVisible() && helpers_1.inLimits(result(), 0, 0);
    visibleQuestions.managementGreenZeroNegative =
        !isAnswerdAllVisible() && helpers_1.inLimits(result(), -1, 0);
    visibleQuestions.score1 = !isAnswerdAllVisible() && helpers_1.inLimits(result(), 1, 1);
    visibleQuestions.score2 = !isAnswerdAllVisible() && helpers_1.inLimits(result(), 2, 2);
    visibleQuestions.managementGreen =
        !isAnswerdAllVisible() && helpers_1.inLimits(result(), 1, 2);
    visibleQuestions.score3 = !isAnswerdAllVisible() && helpers_1.inLimits(result(), 3, 3);
    visibleQuestions.managementOrange =
        !isAnswerdAllVisible() && helpers_1.inLimits(result(), 3, 3);
    visibleQuestions.score4 = !isAnswerdAllVisible() && helpers_1.inLimits(result(), 4, 4);
    visibleQuestions.score5 = !isAnswerdAllVisible() && helpers_1.inLimits(result(), 5, 5);
    visibleQuestions.managementRed =
        !isAnswerdAllVisible() && helpers_1.inLimits(result(), 4, 5);
    visibleQuestions.warningPenicillin = !isAnswerdAllVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.warningP = !isAnswerdAllVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return !isAnswerdAllVisible();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
