"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    weight: true,
    result111: true,
    result211: true,
    durationText: true,
    kidneyText: true,
    result231: true
};
var visibleSections = {
    weightSection: true,
    result11: false,
    result21: false,
    kidneySection: false,
    result23: false
};
var inputs = {
    weight: null
};
var calculatePoints = function () {
    var _a, _b;
    if (!isWeightValid()) {
        return {
            number: null,
            range: null
        };
    }
    var x = Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints) * 20;
    if (Number((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints) >= 37.5) {
        x = 750;
    }
    return {
        number: null,
        range: null,
        result211: {
            qID: 'result211',
            tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(x, 1), 0, 1)),
            titleTexts: 'result1'
        }
    };
};
var isWeightValid = function () {
    return (helpers_1.isAnswered(inputs.weight) &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 150 }));
};
var isResult11Visible = function () {
    return !isWeightValid();
};
var isResult21Visible = function () {
    return isWeightValid();
};
var isKidneySectionVisible = function () {
    return isWeightValid();
};
var isResult23Visible = function () {
    return isWeightValid();
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.result11 = isResult11Visible();
    visibleSections.result21 = isResult21Visible();
    visibleSections.kidneySection = isKidneySectionVisible();
    visibleSections.result23 = isResult23Visible();
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return isWeightValid();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
