"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    weight: true,
    result111: true,
    result211: true,
    durationText: true,
    kidneyText: true,
    result232: true
};
var visibleSections = {
    weightSection: true,
    result11: false,
    result21: false,
    kidneySection: false,
    result23: false
};
var inputs = {
    weight: null
};
var calculatePoints = function () {
    var _a, _b, _c, _d;
    if (!isWeightValid()) {
        return {
            number: null,
            range: null
        };
    }
    var x = Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints) * 10;
    var y = Number((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints) * 15;
    var displayFixedDose = Number((_c = inputs.weight) === null || _c === void 0 ? void 0 : _c.currentPoints) >= 50;
    if (Number((_d = inputs.weight) === null || _d === void 0 ? void 0 : _d.currentPoints) >= 33.33) {
        y = 500;
    }
    var tParams = __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(x, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(y, 1), 0, 1));
    return {
        number: null,
        range: null,
        result211: __assign(__assign({ qID: 'result211' }, (!displayFixedDose && { tParams: tParams })), { titleTexts: displayFixedDose ? 'result2' : 'result1' })
    };
};
var isWeightValid = function () {
    return (helpers_1.isAnswered(inputs.weight) &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 150 }));
};
var isResult11Visible = function () {
    return !isWeightValid();
};
var isResult21Visible = function () {
    return isWeightValid();
};
var isKidneySectionVisible = function () {
    return isWeightValid();
};
var isResult23Visible = function () {
    return isWeightValid();
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.result11 = isResult11Visible();
    visibleSections.result21 = isResult21Visible();
    visibleSections.kidneySection = isKidneySectionVisible();
    visibleSections.result23 = isResult23Visible();
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return isWeightValid();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
