"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    group: true,
    weight: false,
    ageChildren: false,
    creatinine: false,
    noAnswerText: true,
    stopBabies: false,
    solutionChildrenSmall: false,
    durationChildrenSmall: false,
    durationStrepChildrenSmall: false,
    solutionChildrenBig: false,
    durationChildrenBig: false,
    durationStrepChildrenBig: false,
    dosingTablets: false,
    durationTablets: false,
    durationTabletsStrep: false,
    solutionAdultsSmall: false,
    durationAdultsSmall: false,
    durationStrepAdultsSmall: false,
    solutionAdultsBig: false,
    durationAdultsBig: false,
    durationStrepAdultsBig: false,
    resultInfusion: false,
    durationInfusion: false,
    solutionChildrenSmallLow: false,
    durationChildrenSmallLow: false,
    durationStrepChildrenSmallLow: false,
    warningChildrenSmall: false,
    solutionChildrenBigLow: false,
    durationChildrenBigLow: false,
    durationStrepChildrenBigLow: false,
    warningChildrenLow: false,
    dosingTabletsLow: false,
    durationTabletsLow: false,
    durationTabletsStrepLow: false,
    warningAdultsTablets: false,
    solutionAdultsSmallLow: false,
    durationAdultsSmallLow: false,
    durationStrepAdultsSmallLow: false,
    warningAdultsSmall: false,
    solutionAdultsBigLow: false,
    durationAdultsBigLow: false,
    durationStrepAdultsBigLow: false,
    warningAdultsBig: false,
    resultInfusionLow: false,
    resultInfusionLowSecond: false,
    warningDuration: false,
    durationInfusionlow: false,
    guidelinesText: false
};
var visibleSections = {
    inputSelection: true,
    noAnswer: true,
    babiesResults: false,
    childrenResultsSmall: false,
    childrenResultsBig: false,
    adultsTablets: false,
    adultsResultsSmall: false,
    adultsResultsBig: false,
    dosingInfusion: false,
    childrenResultsSmallLow: false,
    childrenResultsBigLow: false,
    adultsTabletsLow: false,
    adultsResultsSmallLow: false,
    adultsResultsBigLow: false,
    dosingInfusionLow: false,
    guidelinesSection: false
};
var inputs = {
    group: null,
    weight: null,
    ageChildren: null,
    creatinine: null
};
var isWeightVisible = function () {
    return helpers_1.answerMatches(inputs.group, 'children');
};
var isAgeChildrenVisible = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 14.9 });
};
var isCreatinineVisible = function () {
    return (helpers_1.answerMatches(inputs.group, 'adults') ||
        (helpers_1.answerMatches(inputs.group, 'children') &&
            helpers_1.isAnswered(inputs.weight) &&
            ((helpers_1.numberInLimits({ input: inputs.weight, min: 0, max: 14.9 }) &&
                isAgeChildrenVisible() &&
                helpers_1.answerMatches(inputs.ageChildren, 'bigBabies')) ||
                helpers_1.numberInLimits({ input: inputs.weight, min: 15, max: 70 }))));
};
var isNotAnswerAll = function () {
    return (helpers_1.answerMatches(inputs.group, 'adults') ||
        (helpers_1.answerMatches(inputs.group, 'children') &&
            helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 70 }) &&
            ((isAgeChildrenVisible() && helpers_1.isAnswered(inputs.ageChildren)) ||
                (helpers_1.numberInLimits({ input: inputs.weight, min: 15, max: 70 }) &&
                    helpers_1.isAnswered(inputs.creatinine)))));
};
var isBabiesResultsVisible = function () {
    return helpers_1.answerMatches(inputs.ageChildren, 'smallBabies');
};
var isChildrenResultsVisible = function () {
    return ((helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 29.9 }) &&
        helpers_1.answerMatches(inputs.creatinine, 'normal') &&
        !isAgeChildrenVisible()) ||
        (helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 29.9 }) &&
            helpers_1.answerMatches(inputs.creatinine, 'normal') &&
            isAgeChildrenVisible() &&
            helpers_1.answerMatches(inputs.ageChildren, 'bigBabies')));
};
var isAdultsResultsVisible = function () {
    return ((helpers_1.answerMatches(inputs.group, 'adults') &&
        helpers_1.answerMatches(inputs.creatinine, 'normal')) ||
        (helpers_1.answerMatches(inputs.group, 'children') &&
            helpers_1.numberInLimits({ input: inputs.weight, min: 30, max: 70 }) &&
            helpers_1.answerMatches(inputs.creatinine, 'normal')));
};
var isDosingInfusion = function () {
    return (helpers_1.answerMatches(inputs.group, 'adults') &&
        helpers_1.answerMatches(inputs.creatinine, 'normal'));
};
var isChildrenResultsSmallLow = function () {
    return ((helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 29.9 }) &&
        helpers_1.answerMatches(inputs.creatinine, 'low') &&
        !isAgeChildrenVisible()) ||
        (helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 29.9 }) &&
            helpers_1.answerMatches(inputs.creatinine, 'low') &&
            isAgeChildrenVisible() &&
            helpers_1.answerMatches(inputs.ageChildren, 'bigBabies')));
};
var isAdultsTabletsLow = function () {
    return ((helpers_1.answerMatches(inputs.group, 'adults') &&
        helpers_1.answerMatches(inputs.creatinine, 'low')) ||
        (helpers_1.answerMatches(inputs.group, 'children') &&
            helpers_1.numberInLimits({ input: inputs.weight, min: 30, max: 70 }) &&
            helpers_1.answerMatches(inputs.creatinine, 'low')));
};
var isDosingInfusionLow = function () {
    return (helpers_1.answerMatches(inputs.group, 'adults') &&
        helpers_1.answerMatches(inputs.creatinine, 'low'));
};
var isGuidelinesVisible = function () {
    return isNotAnswerAll() && !helpers_1.answerMatches(inputs.ageChildren, 'smallBabies');
};
var calculatePoints = function () {
    var _a;
    var weight = Number((_a = inputs === null || inputs === void 0 ? void 0 : inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints);
    if (isChildrenResultsVisible()) {
        var X1 = (weight * 7.5 * 5) / 125;
        var X2 = (weight * 7.5 * 5) / 250;
        var Y = weight * 7.5;
        return {
            solutionChildrenSmall: {
                qID: 'solutionChildrenSmall',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(X1, 2), 0, 2), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(Y, 2), 0, 2)),
                titleTexts: 'result1'
            },
            solutionChildrenBig: {
                qID: 'solutionChildrenBig',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(X2, 2), 0, 2), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(Y, 2), 0, 2)),
                titleTexts: 'result1'
            }
        };
    }
    if (isChildrenResultsSmallLow()) {
        var X1 = helpers_1.numberInLimits({ input: inputs.weight, min: 33.333, max: 69.9 })
            ? 10
            : (weight * 7.5 * 5) / 125;
        var X2 = helpers_1.numberInLimits({ input: inputs.weight, min: 33.333, max: 69.9 })
            ? 5
            : (weight * 7.5 * 5) / 250;
        var Y = helpers_1.numberInLimits({ input: inputs.weight, min: 33.333, max: 69.9 })
            ? 250
            : weight * 7.5;
        return {
            solutionChildrenSmallLow: {
                qID: 'solutionChildrenSmallLow',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(X1, 2), 0, 2), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(Y, 2), 0, 2)),
                titleTexts: 'result1'
            },
            solutionChildrenBigLow: {
                qID: 'solutionChildrenBigLow',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(X2, 2), 0, 2), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(Y, 2), 0, 2)),
                titleTexts: 'result1'
            }
        };
    }
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.weight = isWeightVisible();
    visibleQuestions.ageChildren = isAgeChildrenVisible();
    visibleQuestions.creatinine = isCreatinineVisible();
    visibleQuestions.noAnswerText = !isNotAnswerAll();
    visibleQuestions.stopBabies = isBabiesResultsVisible();
    visibleQuestions.solutionChildrenSmall = isChildrenResultsVisible();
    visibleQuestions.durationChildrenSmall = isChildrenResultsVisible();
    visibleQuestions.durationStrepChildrenSmall = isChildrenResultsVisible();
    visibleQuestions.solutionChildrenBig = isChildrenResultsVisible();
    visibleQuestions.durationChildrenBig = isChildrenResultsVisible();
    visibleQuestions.durationStrepChildrenBig = isChildrenResultsVisible();
    visibleQuestions.dosingTablets = isAdultsResultsVisible();
    visibleQuestions.durationTablets = isAdultsResultsVisible();
    visibleQuestions.durationTabletsStrep = isAdultsResultsVisible();
    visibleQuestions.solutionAdultsSmall = isAdultsResultsVisible();
    visibleQuestions.durationAdultsSmall = isAdultsResultsVisible();
    visibleQuestions.durationStrepAdultsSmall = isAdultsResultsVisible();
    visibleQuestions.solutionAdultsBig = isAdultsResultsVisible();
    visibleQuestions.durationAdultsBig = isAdultsResultsVisible();
    visibleQuestions.durationStrepAdultsBig = isAdultsResultsVisible();
    visibleQuestions.resultInfusion = isDosingInfusion();
    visibleQuestions.durationInfusion = isDosingInfusion();
    visibleQuestions.solutionChildrenSmallLow = isChildrenResultsSmallLow();
    visibleQuestions.durationChildrenSmallLow = isChildrenResultsSmallLow();
    visibleQuestions.durationStrepChildrenSmallLow = isChildrenResultsSmallLow();
    visibleQuestions.warningChildrenSmall = isChildrenResultsSmallLow();
    visibleQuestions.solutionChildrenBigLow = isChildrenResultsSmallLow();
    visibleQuestions.durationChildrenBigLow = isChildrenResultsSmallLow();
    visibleQuestions.durationStrepChildrenBigLow = isChildrenResultsSmallLow();
    visibleQuestions.warningChildrenLow = isChildrenResultsSmallLow();
    visibleQuestions.dosingTabletsLow = isAdultsTabletsLow();
    visibleQuestions.durationTabletsLow = isAdultsTabletsLow();
    visibleQuestions.durationTabletsStrepLow = isAdultsTabletsLow();
    visibleQuestions.warningAdultsTablets = isAdultsTabletsLow();
    visibleQuestions.solutionAdultsSmallLow = isAdultsTabletsLow();
    visibleQuestions.durationAdultsSmallLow = isAdultsTabletsLow();
    visibleQuestions.durationStrepAdultsSmallLow = isAdultsTabletsLow();
    visibleQuestions.warningAdultsSmall = isAdultsTabletsLow();
    visibleQuestions.solutionAdultsBigLow = isAdultsTabletsLow();
    visibleQuestions.durationAdultsBigLow = isAdultsTabletsLow();
    visibleQuestions.durationStrepAdultsBigLow = isAdultsTabletsLow();
    visibleQuestions.warningAdultsBig = isAdultsTabletsLow();
    visibleQuestions.resultInfusionLow = isDosingInfusionLow();
    visibleQuestions.resultInfusionLowSecond = isDosingInfusionLow();
    visibleQuestions.warningDuration = isDosingInfusionLow();
    visibleQuestions.durationInfusionlow = isDosingInfusionLow();
    visibleQuestions.guidelinesText = isGuidelinesVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = !isNotAnswerAll();
    visibleSections.babiesResults = isBabiesResultsVisible();
    visibleSections.childrenResultsSmall = isChildrenResultsVisible();
    visibleSections.childrenResultsBig = isChildrenResultsVisible();
    visibleSections.adultsTablets = isAdultsResultsVisible();
    visibleSections.adultsResultsSmall = isAdultsResultsVisible();
    visibleSections.adultsResultsBig = isAdultsResultsVisible();
    visibleSections.dosingInfusion = isDosingInfusion();
    visibleSections.childrenResultsSmallLow = isChildrenResultsSmallLow();
    visibleSections.childrenResultsBigLow = isChildrenResultsSmallLow();
    visibleSections.adultsTabletsLow = isAdultsTabletsLow();
    visibleSections.adultsResultsSmallLow = isAdultsTabletsLow();
    visibleSections.adultsResultsBigLow = isAdultsTabletsLow();
    visibleSections.dosingInfusionLow = isDosingInfusionLow();
    visibleSections.guidelinesSection = isGuidelinesVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return isNotAnswerAll();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
