"use strict";


var visibleQuestions = {
    weight: true,
    creatinine: false,
    noAnswerText: true,
    stopBabies: false,
    dosingTablets: false,
    duration: false,
    dosingTabletsLow: false,
    durationLow: false,
    warningCreatinine: false,
    guidelinesText: false
};
var visibleSections = {
    inputSelection: true,
    noAnswer: true,
    babiesResults: false,
    adultsTablets: false,
    adultsTabletsLow: false,
    guidelinesSection: false
};
var inputs = {
    weight: null,
    creatinine: null
};
var isCreatinineVisible = function () {
    return helpers_1.answerMatches(inputs.weight, 'big');
};
var isAnswerAllVisible = function () {
    return !(helpers_1.answerMatches(inputs.weight, 'small') ||
        (helpers_1.answerMatches(inputs.weight, 'big') && helpers_1.isAnswered(inputs.creatinine)));
};
var isBabiesResultVisible = function () {
    return helpers_1.answerMatches(inputs.weight, 'small');
};
var isAdultsTabletsVisible = function () {
    return (helpers_1.answerMatches(inputs.weight, 'big') &&
        helpers_1.answerMatches(inputs.creatinine, 'normal'));
};
var isAdultsTabletsLowVisible = function () {
    return (helpers_1.answerMatches(inputs.weight, 'big') &&
        helpers_1.answerMatches(inputs.creatinine, 'low'));
};
var isGuidelinesVisible = function () {
    return helpers_1.answerMatches(inputs.weight, 'big') && helpers_1.isAnswered(inputs.creatinine);
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.creatinine = isCreatinineVisible();
    visibleQuestions.noAnswerText = isAnswerAllVisible();
    visibleQuestions.stopBabies = isBabiesResultVisible();
    visibleQuestions.dosingTablets = isAdultsTabletsVisible();
    visibleQuestions.duration = isAdultsTabletsVisible();
    visibleQuestions.dosingTabletsLow = isAdultsTabletsLowVisible();
    visibleQuestions.durationLow = isAdultsTabletsLowVisible();
    visibleQuestions.warningCreatinine = isAdultsTabletsLowVisible();
    visibleQuestions.guidelinesText = isGuidelinesVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = isAnswerAllVisible();
    visibleSections.babiesResults = isBabiesResultVisible();
    visibleSections.adultsTablets = isAdultsTabletsVisible();
    visibleSections.adultsTabletsLow = isAdultsTabletsLowVisible();
    visibleSections.guidelinesSection = isGuidelinesVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return !isAnswerAllVisible();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
