"use strict";


var visibleQuestions = {
    suspicion: true,
    probability: false,
    wells: false,
    mDimer: false,
    mUS: false,
    strategy: false,
    proximalUS: false,
    vDimer: false,
    serialUS: false,
    tibialUS: false,
    tibialVT: false,
    serialUStibial: false
};
var visibleSections = {
    resultSection1: true,
    resultSection2: false,
    resultSection3a: false,
    resultSection3b: false
};
var inputs = {
    suspicion: null,
    probability: null,
    wells: null,
    mDimer: null,
    mUS: null,
    strategy: null,
    proximalUS: null,
    vDimer: null,
    serialUS: null,
    tibialUS: null,
    tibialVT: null,
    serialUStibial: null
};
var smallProbability = function () {
    if (!probabilityVisibility())
        return false;
    if (inputs.probability.currentIdentifier == "small")
        return true;
    if (!wellsVisibility())
        return false;
    return inputs.wells.currentIdentifier == "unlikely";
};
var bigProbability = function () {
    if (!probabilityVisibility())
        return false;
    if (inputs.probability.currentIdentifier == "big")
        return true;
    if (!wellsVisibility())
        return false;
    return inputs.wells.currentIdentifier == "likely";
};
var questionAffirmative = function (question) {
    return (question.currentIdentifier == "positive" ||
        question.currentIdentifier == "yes");
};
var questionNegative = function (question) {
    return helpers_1.isAnswered(question) && !questionAffirmative(question);
};
var probabilityVisibility = function () {
    return inputs.suspicion.currentIdentifier == "yes";
};
var wellsVisibility = function () {
    if (!probabilityVisibility())
        return false;
    return inputs.probability.currentIdentifier == "calculate";
};
var mDimerVisibility = function () {
    return smallProbability();
};
var mUSVisibility = function () {
    if (!smallProbability() || !mDimerVisibility())
        return false;
    return inputs.mDimer.currentIdentifier == "positive";
};
var strategyVisibility = function () {
    return bigProbability();
};
var proximalUSVisibility = function () {
    if (!bigProbability() || !strategyVisibility())
        return false;
    return inputs.strategy.currentIdentifier != null;
};
var vDimerVisibility = function () {
    if (!bigProbability() || !strategyVisibility() || !proximalUSVisibility())
        return false;
    return (inputs.strategy.currentIdentifier == "proximal" &&
        inputs.proximalUS.currentIdentifier == "negative");
};
var serialUSVisibility = function () {
    if (!vDimerVisibility())
        return false;
    return inputs.vDimer.currentIdentifier == "positive";
};
var tibialUSVisibility = function () {
    if (!bigProbability() || !strategyVisibility() || !proximalUSVisibility())
        return false;
    return (inputs.strategy.currentIdentifier == "tibial" &&
        inputs.proximalUS.currentIdentifier == "negative");
};
var tibialVTVisibility = function () {
    if (!tibialUSVisibility())
        return false;
    return inputs.tibialUS.currentIdentifier == "positive";
};
var serialUStibialVisibility = function () {
    if (!tibialUSVisibility() || !tibialVTVisibility())
        return false;
    return inputs.tibialVT.currentIdentifier == "no";
};
var resultSection1Visibility = function () {
    return inputs.suspicion.currentIdentifier == "no";
};
var resultSection2Visibility = function () {
    return (inputs.suspicion.currentIdentifier == null ||
        (probabilityVisibility() && !helpers_1.isAnswered(inputs.probability)) ||
        (wellsVisibility() && !helpers_1.isAnswered(inputs.wells)) ||
        (mDimerVisibility() && !helpers_1.isAnswered(inputs.mDimer)) ||
        (mUSVisibility() && !helpers_1.isAnswered(inputs.mUS)) ||
        (strategyVisibility() && !helpers_1.isAnswered(inputs.strategy)) ||
        (proximalUSVisibility() && !helpers_1.isAnswered(inputs.proximalUS)) ||
        (vDimerVisibility() && !helpers_1.isAnswered(inputs.vDimer)) ||
        (serialUSVisibility() && !helpers_1.isAnswered(inputs.serialUS)) ||
        (tibialUSVisibility() && !helpers_1.isAnswered(inputs.tibialUS)) ||
        (tibialVTVisibility() && !helpers_1.isAnswered(inputs.tibialVT)) ||
        (serialUStibialVisibility() && !helpers_1.isAnswered(inputs.serialUStibial)));
};
var resultSection3aVisibility = function () {
    return (inputs.suspicion.currentIdentifier == "yes" &&
        ((mUSVisibility() && questionAffirmative(inputs.mUS)) ||
            (proximalUSVisibility() && questionAffirmative(inputs.proximalUS)) ||
            (serialUSVisibility() && questionAffirmative(inputs.serialUS)) ||
            (tibialVTVisibility() && questionAffirmative(inputs.tibialVT)) ||
            (serialUStibialVisibility() &&
                questionAffirmative(inputs.serialUStibial))));
};
var resultSection3bVisibility = function () {
    return (inputs.suspicion.currentIdentifier == "yes" &&
        ((mDimerVisibility() && questionNegative(inputs.mDimer)) ||
            (mUSVisibility() && questionNegative(inputs.mUS)) ||
            (vDimerVisibility() && questionNegative(inputs.vDimer)) ||
            (tibialUSVisibility() && questionNegative(inputs.tibialUS)) ||
            (serialUSVisibility() && questionNegative(inputs.serialUS)) ||
            (serialUStibialVisibility() && questionNegative(inputs.serialUStibial))));
};
var returnVisibleQuestions = function () {
    visibleQuestions.probability = probabilityVisibility();
    visibleQuestions.wells = wellsVisibility();
    visibleQuestions.mDimer = mDimerVisibility();
    visibleQuestions.mUS = mUSVisibility();
    visibleQuestions.strategy = strategyVisibility();
    visibleQuestions.proximalUS = proximalUSVisibility();
    visibleQuestions.vDimer = vDimerVisibility();
    visibleQuestions.serialUS = serialUSVisibility();
    visibleQuestions.tibialUS = tibialUSVisibility();
    visibleQuestions.tibialVT = tibialVTVisibility();
    visibleQuestions.serialUStibial = serialUStibialVisibility();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.resultSection1 = resultSection1Visibility();
    visibleSections.resultSection2 = resultSection2Visibility();
    visibleSections.resultSection3a = resultSection3aVisibility();
    visibleSections.resultSection3b = resultSection3bVisibility();
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    return {
        result: {},
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
