"use strict";

var visibleQuestions = {
    efficacyGallery: true,
    efficacy: true,
    metformin: false,
    sulfonylureas: false,
    DPP4: false,
    SGLT2: false,
    GLP1: false,
    human: false,
    analogue: false,
    TZD: false,
    hypoglycemiaGallery: true,
    hypoglycemia: true,
    metforminH: false,
    sulfonylureasH: false,
    DPP4H: false,
    SGLT2H: false,
    GLP1H: false,
    humanH: false,
    analogueH: false,
    TZDH: false,
    weightGallery: true,
    weight: true,
    metforminW: false,
    sulfonylureasW: false,
    DPP4W: false,
    SGLT2W: false,
    GLP1W: false,
    humanW: false,
    analogueW: false,
    TZDw: false,
    ASCVDGallery: true,
    ASCVD: true,
    metforminACD: false,
    sulfonylureasACD: false,
    DPP4ACD: false,
    SGLT2ACD: false,
    GLP1ACD: false,
    humanACD: false,
    analogueACD: false,
    TZDacd: false,
    HFGallery: true,
    HF: true,
    metforminHF: false,
    sulfonylureasHF: false,
    DPP4HF: false,
    SGLT2iHF: false,
    GLP1HF: false,
    humanHF: false,
    analogueHF: false,
    TZDhf: false,
    formGallery: true,
    form: true,
    metforminR: false,
    sulfonylureasR: false,
    DPP4R: false,
    SGLT2R: false,
    GLP1R: false,
    humanR: false,
    analogueR: false,
    TZDr: false,
    CKDGallery: true,
    CKD: true,
    metforminCKD: false,
    sulfonylureasCKD: false,
    DPP4CKD: false,
    SGLT2CKD: false,
    GLP1CKD: false,
    humanCKD: false,
    analogueCKD: false,
    TZDckd: false,
    AEGallery: true,
    AE: true,
    metforminA: false,
    sulfonylureasA: false,
    DPP4A: false,
    SGLT2A: false,
    GLP1A: false,
    humanA: false,
    analogueA: false,
    TZDa: false,
    contraindicationsGallery: true,
    contraindications: true,
    metforminC: false,
    sulfonylureasC: false,
    DPP4C: false,
    SGLT2C: false,
    GLP1C: false,
    humanC: false,
    analogueC: false,
    TZDc: false
};
var visibleSections = {
    section1: true,
    section2: true,
    section3: true,
    section4: true,
    section5: true,
    section6: true,
    section7: true,
    section8: true,
    section9: true
};
var inputs = {
    efficacy: null,
    hypoglycemia: null,
    weight: null,
    ASCVD: null,
    HF: null,
    CKD: null,
    AE: null,
    contraindications: null
};
var returnVisibleQuestions = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21, _22, _23, _24, _25, _26, _27, _28, _29, _30, _31, _32, _33, _34, _35, _36, _37, _38, _39, _40, _41, _42, _43, _44, _45, _46, _47;
    visibleQuestions.metformin = ((_a = inputs.efficacy) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "hide";
    visibleQuestions.sulfonylureas =
        ((_b = inputs.efficacy) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "hide";
    visibleQuestions.DPP4 = ((_c = inputs.efficacy) === null || _c === void 0 ? void 0 : _c.currentIdentifier) === "hide";
    visibleQuestions.SGLT2 = ((_d = inputs.efficacy) === null || _d === void 0 ? void 0 : _d.currentIdentifier) === "hide";
    visibleQuestions.GLP1 = ((_e = inputs.efficacy) === null || _e === void 0 ? void 0 : _e.currentIdentifier) === "hide";
    visibleQuestions.human = ((_f = inputs.efficacy) === null || _f === void 0 ? void 0 : _f.currentIdentifier) === "hide";
    visibleQuestions.analogue = ((_g = inputs.efficacy) === null || _g === void 0 ? void 0 : _g.currentIdentifier) === "hide";
    visibleQuestions.TZD = ((_h = inputs.efficacy) === null || _h === void 0 ? void 0 : _h.currentIdentifier) === "hide";
    visibleQuestions.metforminH =
        ((_j = inputs.hypoglycemia) === null || _j === void 0 ? void 0 : _j.currentIdentifier) === "hide";
    visibleQuestions.sulfonylureasH =
        ((_k = inputs.hypoglycemia) === null || _k === void 0 ? void 0 : _k.currentIdentifier) === "hide";
    visibleQuestions.DPP4H = ((_l = inputs.hypoglycemia) === null || _l === void 0 ? void 0 : _l.currentIdentifier) === "hide";
    visibleQuestions.SGLT2H = ((_m = inputs.hypoglycemia) === null || _m === void 0 ? void 0 : _m.currentIdentifier) === "hide";
    visibleQuestions.GLP1H = ((_o = inputs.hypoglycemia) === null || _o === void 0 ? void 0 : _o.currentIdentifier) === "hide";
    visibleQuestions.humanH = ((_p = inputs.hypoglycemia) === null || _p === void 0 ? void 0 : _p.currentIdentifier) === "hide";
    visibleQuestions.analogueH =
        ((_q = inputs.hypoglycemia) === null || _q === void 0 ? void 0 : _q.currentIdentifier) === "hide";
    visibleQuestions.TZDH = ((_r = inputs.hypoglycemia) === null || _r === void 0 ? void 0 : _r.currentIdentifier) === "hide";
    visibleQuestions.metforminW = ((_s = inputs.weight) === null || _s === void 0 ? void 0 : _s.currentIdentifier) === "hide";
    visibleQuestions.sulfonylureasW = ((_t = inputs.weight) === null || _t === void 0 ? void 0 : _t.currentIdentifier) === "hide";
    visibleQuestions.DPP4W = ((_u = inputs.weight) === null || _u === void 0 ? void 0 : _u.currentIdentifier) === "hide";
    visibleQuestions.SGLT2W = ((_v = inputs.weight) === null || _v === void 0 ? void 0 : _v.currentIdentifier) === "hide";
    visibleQuestions.GLP1W = ((_w = inputs.weight) === null || _w === void 0 ? void 0 : _w.currentIdentifier) === "hide";
    visibleQuestions.humanW = ((_x = inputs.weight) === null || _x === void 0 ? void 0 : _x.currentIdentifier) === "hide";
    visibleQuestions.analogueW = ((_y = inputs.weight) === null || _y === void 0 ? void 0 : _y.currentIdentifier) === "hide";
    visibleQuestions.TZDw = ((_z = inputs.weight) === null || _z === void 0 ? void 0 : _z.currentIdentifier) === "hide";
    visibleQuestions.metforminACD = ((_0 = inputs.ASCVD) === null || _0 === void 0 ? void 0 : _0.currentIdentifier) === "hide";
    visibleQuestions.sulfonylureasACD =
        ((_1 = inputs.ASCVD) === null || _1 === void 0 ? void 0 : _1.currentIdentifier) === "hide";
    visibleQuestions.DPP4ACD = ((_2 = inputs.ASCVD) === null || _2 === void 0 ? void 0 : _2.currentIdentifier) === "hide";
    visibleQuestions.SGLT2ACD = ((_3 = inputs.ASCVD) === null || _3 === void 0 ? void 0 : _3.currentIdentifier) === "hide";
    visibleQuestions.GLP1ACD = ((_4 = inputs.ASCVD) === null || _4 === void 0 ? void 0 : _4.currentIdentifier) === "hide";
    visibleQuestions.humanACD = ((_5 = inputs.ASCVD) === null || _5 === void 0 ? void 0 : _5.currentIdentifier) === "hide";
    visibleQuestions.analogueACD = ((_6 = inputs.ASCVD) === null || _6 === void 0 ? void 0 : _6.currentIdentifier) === "hide";
    visibleQuestions.TZDacd = ((_7 = inputs.ASCVD) === null || _7 === void 0 ? void 0 : _7.currentIdentifier) === "hide";
    visibleQuestions.metforminHF = ((_8 = inputs.HF) === null || _8 === void 0 ? void 0 : _8.currentIdentifier) === "hide";
    visibleQuestions.sulfonylureasHF = ((_9 = inputs.HF) === null || _9 === void 0 ? void 0 : _9.currentIdentifier) === "hide";
    visibleQuestions.DPP4HF = ((_10 = inputs.HF) === null || _10 === void 0 ? void 0 : _10.currentIdentifier) === "hide";
    visibleQuestions.SGLT2iHF = ((_11 = inputs.HF) === null || _11 === void 0 ? void 0 : _11.currentIdentifier) === "hide";
    visibleQuestions.GLP1HF = ((_12 = inputs.HF) === null || _12 === void 0 ? void 0 : _12.currentIdentifier) === "hide";
    visibleQuestions.humanHF = ((_13 = inputs.HF) === null || _13 === void 0 ? void 0 : _13.currentIdentifier) === "hide";
    visibleQuestions.analogueHF = ((_14 = inputs.HF) === null || _14 === void 0 ? void 0 : _14.currentIdentifier) === "hide";
    visibleQuestions.TZDhf = ((_15 = inputs.HF) === null || _15 === void 0 ? void 0 : _15.currentIdentifier) === "hide";
    visibleQuestions.metforminR = ((_16 = inputs.form) === null || _16 === void 0 ? void 0 : _16.currentIdentifier) === "hide";
    visibleQuestions.sulfonylureasR = ((_17 = inputs.form) === null || _17 === void 0 ? void 0 : _17.currentIdentifier) === "hide";
    visibleQuestions.DPP4R = ((_18 = inputs.form) === null || _18 === void 0 ? void 0 : _18.currentIdentifier) === "hide";
    visibleQuestions.SGLT2R = ((_19 = inputs.form) === null || _19 === void 0 ? void 0 : _19.currentIdentifier) === "hide";
    visibleQuestions.GLP1R = ((_20 = inputs.form) === null || _20 === void 0 ? void 0 : _20.currentIdentifier) === "hide";
    visibleQuestions.humanR = ((_21 = inputs.form) === null || _21 === void 0 ? void 0 : _21.currentIdentifier) === "hide";
    visibleQuestions.analogueR = ((_22 = inputs.form) === null || _22 === void 0 ? void 0 : _22.currentIdentifier) === "hide";
    visibleQuestions.TZDr = ((_23 = inputs.form) === null || _23 === void 0 ? void 0 : _23.currentIdentifier) === "hide";
    visibleQuestions.metforminCKD = ((_24 = inputs.CKD) === null || _24 === void 0 ? void 0 : _24.currentIdentifier) === "hide";
    visibleQuestions.sulfonylureasCKD = ((_25 = inputs.CKD) === null || _25 === void 0 ? void 0 : _25.currentIdentifier) === "hide";
    visibleQuestions.DPP4CKD = ((_26 = inputs.CKD) === null || _26 === void 0 ? void 0 : _26.currentIdentifier) === "hide";
    visibleQuestions.SGLT2CKD = ((_27 = inputs.CKD) === null || _27 === void 0 ? void 0 : _27.currentIdentifier) === "hide";
    visibleQuestions.GLP1CKD = ((_28 = inputs.CKD) === null || _28 === void 0 ? void 0 : _28.currentIdentifier) === "hide";
    visibleQuestions.humanCKD = ((_29 = inputs.CKD) === null || _29 === void 0 ? void 0 : _29.currentIdentifier) === "hide";
    visibleQuestions.analogueCKD = ((_30 = inputs.CKD) === null || _30 === void 0 ? void 0 : _30.currentIdentifier) === "hide";
    visibleQuestions.TZDckd = ((_31 = inputs.CKD) === null || _31 === void 0 ? void 0 : _31.currentIdentifier) === "hide";
    visibleQuestions.metforminA = ((_32 = inputs.AE) === null || _32 === void 0 ? void 0 : _32.currentIdentifier) === "hide";
    visibleQuestions.sulfonylureasA = ((_33 = inputs.AE) === null || _33 === void 0 ? void 0 : _33.currentIdentifier) === "hide";
    visibleQuestions.DPP4A = ((_34 = inputs.AE) === null || _34 === void 0 ? void 0 : _34.currentIdentifier) === "hide";
    visibleQuestions.SGLT2A = ((_35 = inputs.AE) === null || _35 === void 0 ? void 0 : _35.currentIdentifier) === "hide";
    visibleQuestions.GLP1A = ((_36 = inputs.AE) === null || _36 === void 0 ? void 0 : _36.currentIdentifier) === "hide";
    visibleQuestions.humanA = ((_37 = inputs.AE) === null || _37 === void 0 ? void 0 : _37.currentIdentifier) === "hide";
    visibleQuestions.analogueA = ((_38 = inputs.AE) === null || _38 === void 0 ? void 0 : _38.currentIdentifier) === "hide";
    visibleQuestions.TZDa = ((_39 = inputs.AE) === null || _39 === void 0 ? void 0 : _39.currentIdentifier) === "hide";
    visibleQuestions.metforminC =
        ((_40 = inputs.contraindications) === null || _40 === void 0 ? void 0 : _40.currentIdentifier) === "hide";
    visibleQuestions.sulfonylureasC =
        ((_41 = inputs.contraindications) === null || _41 === void 0 ? void 0 : _41.currentIdentifier) === "hide";
    visibleQuestions.DPP4C =
        ((_42 = inputs.contraindications) === null || _42 === void 0 ? void 0 : _42.currentIdentifier) === "hide";
    visibleQuestions.SGLT2C =
        ((_43 = inputs.contraindications) === null || _43 === void 0 ? void 0 : _43.currentIdentifier) === "hide";
    visibleQuestions.GLP1C =
        ((_44 = inputs.contraindications) === null || _44 === void 0 ? void 0 : _44.currentIdentifier) === "hide";
    visibleQuestions.humanC =
        ((_45 = inputs.contraindications) === null || _45 === void 0 ? void 0 : _45.currentIdentifier) === "hide";
    visibleQuestions.analogueC =
        ((_46 = inputs.contraindications) === null || _46 === void 0 ? void 0 : _46.currentIdentifier) === "hide";
    visibleQuestions.TZDc =
        ((_47 = inputs.contraindications) === null || _47 === void 0 ? void 0 : _47.currentIdentifier) === "hide";
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return false;
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
