"use strict";


var visibleQuestions = {
    metformin: true,
    metforminOverview: true,
    ADAgents1: true,
    start: true,
    carolina: false,
    SUoverview1: false,
    TZD1: false,
    target1: false,
    additionTZD: false,
    TZD2: false,
    additionSU: false,
    carolina2: false,
    SUoverview2: false,
    target2: false,
    ADAgents2: false,
    addition: false,
    addInsulin: false,
    insulins: false,
    addDPP: false,
    DPP4i: false,
    addSGLT: false,
    SGLT2: false,
    end: false
};
var visibleSections = {
    section1: true,
    section2: true,
    section3: false,
    section4: false
};
var inputs = {
    start: null,
    target1: null,
    target2: null
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var section3Visible = function () {
    return (visibleQuestions.target1 ||
        visibleQuestions.additionTZD ||
        visibleQuestions.TZD2 ||
        visibleQuestions.additionSU ||
        visibleQuestions.carolina2 ||
        visibleQuestions.SUoverview2);
};
var section4Visible = function () {
    return (visibleQuestions.target2 ||
        visibleQuestions.ADAgents2 ||
        visibleQuestions.addition ||
        visibleQuestions.addInsulin ||
        visibleQuestions.insulins ||
        visibleQuestions.addDPP ||
        visibleQuestions.DPP4i ||
        visibleQuestions.addSGLT ||
        visibleQuestions.SGLT2 ||
        visibleQuestions.end);
};
var returnVisibleSections = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z;
    visibleQuestions.carolina = ((_a = inputs.start) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "SU";
    visibleQuestions.SUoverview1 = ((_b = inputs.start) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "SU";
    visibleQuestions.TZD1 = ((_c = inputs.start) === null || _c === void 0 ? void 0 : _c.currentIdentifier) === "TZD";
    visibleQuestions.target1 = helpers_1.isAnswered(inputs.start);
    visibleQuestions.additionTZD =
        ((_d = inputs.target1) === null || _d === void 0 ? void 0 : _d.currentIdentifier) === "yes" &&
            ((_e = inputs.start) === null || _e === void 0 ? void 0 : _e.currentIdentifier) === "SU";
    visibleQuestions.TZD2 =
        ((_f = inputs.target1) === null || _f === void 0 ? void 0 : _f.currentIdentifier) === "yes" &&
            ((_g = inputs.start) === null || _g === void 0 ? void 0 : _g.currentIdentifier) === "SU";
    visibleQuestions.additionSU =
        ((_h = inputs.target1) === null || _h === void 0 ? void 0 : _h.currentIdentifier) === "yes" &&
            ((_j = inputs.start) === null || _j === void 0 ? void 0 : _j.currentIdentifier) === "TZD";
    visibleQuestions.carolina2 =
        ((_k = inputs.target1) === null || _k === void 0 ? void 0 : _k.currentIdentifier) === "yes" &&
            ((_l = inputs.start) === null || _l === void 0 ? void 0 : _l.currentIdentifier) === "TZD";
    visibleQuestions.SUoverview2 =
        ((_m = inputs.target1) === null || _m === void 0 ? void 0 : _m.currentIdentifier) === "yes" &&
            ((_o = inputs.start) === null || _o === void 0 ? void 0 : _o.currentIdentifier) === "TZD";
    visibleQuestions.target2 = ((_p = inputs.target1) === null || _p === void 0 ? void 0 : _p.currentIdentifier) === "yes";
    visibleQuestions.ADAgents2 = ((_q = inputs.target2) === null || _q === void 0 ? void 0 : _q.currentIdentifier) === "yes";
    visibleQuestions.addition = ((_r = inputs.target2) === null || _r === void 0 ? void 0 : _r.currentIdentifier) === "yes";
    visibleQuestions.addInsulin = ((_s = inputs.target2) === null || _s === void 0 ? void 0 : _s.currentIdentifier) === "yes";
    visibleQuestions.insulins = ((_t = inputs.target2) === null || _t === void 0 ? void 0 : _t.currentIdentifier) === "yes";
    visibleQuestions.addDPP = ((_u = inputs.target2) === null || _u === void 0 ? void 0 : _u.currentIdentifier) === "yes";
    visibleQuestions.DPP4i = ((_v = inputs.target2) === null || _v === void 0 ? void 0 : _v.currentIdentifier) === "yes";
    visibleQuestions.addSGLT = ((_w = inputs.target2) === null || _w === void 0 ? void 0 : _w.currentIdentifier) === "yes";
    visibleQuestions.SGLT2 = ((_x = inputs.target2) === null || _x === void 0 ? void 0 : _x.currentIdentifier) === "yes";
    visibleQuestions.end =
        ((_y = inputs.target1) === null || _y === void 0 ? void 0 : _y.currentIdentifier) === "no" ||
            ((_z = inputs.target2) === null || _z === void 0 ? void 0 : _z.currentIdentifier) === "no";
    visibleSections.section3 = section3Visible();
    visibleSections.section4 = section4Visible();
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var calculatePoints = function () {
    return {
        number: 0,
        range: 0,
        metformin: {
            qID: "metformin",
            rParams: [],
            tParams: [],
            titleTexts: "regular",
            resultTexts: "regular"
        },
        additionSDG: {
            qID: "additionSDG",
            rParams: [],
            resultTexts: "regular"
        },
        additionST: {
            qID: "additionST",
            rParams: [],
            resultTexts: "regular"
        },
        additionGDT: {
            qID: "additionGDT",
            rParams: [],
            resultTexts: "regular"
        }
    };
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return false;
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: calculatePoints(),
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
