"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    notAllBelongs1: true,
    age: true,
    weight: false,
    stationary: false,
    noAnswerText: true,
    adultsTblAmb1: false,
    adultsTblAmb2: false,
    adultsTblAmb3: false,
    adultsTblAmb4: false,
    adultsTblAmb5: false,
    adultsTropfenAmbulantDose: false,
    adultsTropfenAmbulantWarning: false,
    adultsDurationTropfenAmbulant1: false,
    adultsDurationTropfenAmbulant2: false,
    adultsDurationTropfenAmbulant3: false,
    adultsTabletsStat1: false,
    adultsTabletsStat2: false,
    adultsTabletsStat3: false,
    adultsTabletsStat4: false,
    adultsTropfenStationary: false,
    adultsDurationTropfenStationary1: false,
    adultsDurationTropfenStationary2: false,
    adultsDurationTropfenStationary3: false,
    adultsDosingLosungResult: false,
    adultsDurationLosung: false,
    kidsTropfenAmbulantDose: false,
    kidsTropfenAmbulantWarning: false,
    kidsDurationTropfen1: false,
    kidsDurationTropfen2: false,
    kidsDurationTropfen3: false,
    kidsLosungDose: false,
    kidsDurationLosung: false,
    kidsWarning1: false,
    babyWarning1: false,
    kidney: false,
    infusion: false
};
var visibleSections = {
    notAllBelongs: true,
    patientSelection: true,
    noAnswerResult: true,
    adultsDosingTbl: false,
    adultsDosingTropfenAmbulant: false,
    adultsDosingTabletsStationary: false,
    adultsDosingTropfenStationary: false,
    adultsDosingLosung: false,
    kidsDosingTropfen: false,
    kidsDosingLosung: false,
    babyDosingLosung: false,
    warningKidney: false,
    warningInfusion: false
};
var inputs = {
    age: null,
    weight: null,
    stationary: null
};
var isAgeMatching = function (name) {
    return helpers_1.answerMatches(inputs.age, name);
};
var isWeightAnswered = function () {
    return (isAgeMatching('adults') &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 200 }));
};
var isAnsweredAllVisible = function () {
    return !(helpers_1.answerMatches(inputs.age, 'kids') ||
        helpers_1.answerMatches(inputs.age, 'baby') ||
        (isWeightAnswered() && helpers_1.isAnswered(inputs.stationary)));
};
var isStationaryAMB = function () {
    return isWeightAnswered() && helpers_1.answerMatches(inputs.stationary, 'amb');
};
var isStationarySTAT = function () {
    return isWeightAnswered() && helpers_1.answerMatches(inputs.stationary, 'stat');
};
var isStationaryIsAnswered = function () {
    return isWeightAnswered() && helpers_1.isAnswered(inputs.stationary);
};
var isAnswerdAllNotBaby = function () {
    return (helpers_1.answerMatches(inputs.age, 'kids') ||
        (isWeightAnswered() && helpers_1.isAnswered(inputs.stationary)));
};
var calculatePoints = function () {
    var _a;
    if (isStationaryIsAnswered()) {
        var weight = Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints);
        var T1 = (weight * 0.1) / 5;
        var T2 = (weight * 0.2) / 5;
        var T3 = weight * 0.1;
        var T4 = weight * 0.2;
        return {
            adultsDosingLosungResult: {
                qID: 'adultsDosingLosungResult',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T1, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T2, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T3, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T4, 1), 0, 1)),
                titleTexts: 'result1'
            }
        };
    }
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.weight = isAgeMatching('adults');
    visibleQuestions.stationary = isWeightAnswered();
    visibleQuestions.noAnswerText = isAnsweredAllVisible();
    visibleQuestions.adultsTblAmb1 = isStationaryAMB();
    visibleQuestions.adultsTblAmb2 = isStationaryAMB();
    visibleQuestions.adultsTblAmb3 = isStationaryAMB();
    visibleQuestions.adultsTblAmb4 = isStationaryAMB();
    visibleQuestions.adultsTblAmb5 = isStationaryAMB();
    visibleQuestions.adultsTropfenAmbulantDose = isStationaryAMB();
    visibleQuestions.adultsTropfenAmbulantWarning = isStationaryAMB();
    visibleQuestions.adultsDurationTropfenAmbulant1 = isStationaryAMB();
    visibleQuestions.adultsDurationTropfenAmbulant2 = isStationaryAMB();
    visibleQuestions.adultsDurationTropfenAmbulant3 = isStationaryAMB();
    visibleQuestions.adultsTabletsStat1 = isStationarySTAT();
    visibleQuestions.adultsTabletsStat2 = isStationarySTAT();
    visibleQuestions.adultsTabletsStat3 = isStationarySTAT();
    visibleQuestions.adultsTabletsStat4 = isStationarySTAT();
    visibleQuestions.adultsTropfenStationary = isStationarySTAT();
    visibleQuestions.adultsDurationTropfenStationary1 = isStationarySTAT();
    visibleQuestions.adultsDurationTropfenStationary2 = isStationarySTAT();
    visibleQuestions.adultsDurationTropfenStationary3 = isStationarySTAT();
    visibleQuestions.adultsDosingLosungResult = isStationaryIsAnswered();
    visibleQuestions.adultsDurationLosung = isStationaryIsAnswered();
    visibleQuestions.kidsTropfenAmbulantDose = isAgeMatching('kids');
    visibleQuestions.kidsTropfenAmbulantWarning = isAgeMatching('kids');
    visibleQuestions.kidsDurationTropfen1 = isAgeMatching('kids');
    visibleQuestions.kidsDurationTropfen2 = isAgeMatching('kids');
    visibleQuestions.kidsDurationTropfen3 = isAgeMatching('kids');
    visibleQuestions.kidsLosungDose = isAgeMatching('kids');
    visibleQuestions.kidsDurationLosung = isAgeMatching('kids');
    visibleQuestions.kidsWarning1 = isAgeMatching('kids');
    visibleQuestions.babyWarning1 = isAgeMatching('baby');
    visibleQuestions.kidney = isAnswerdAllNotBaby();
    visibleQuestions.infusion = isAnswerdAllNotBaby();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswerResult = isAnsweredAllVisible();
    visibleSections.adultsDosingTbl = isStationaryAMB();
    visibleSections.adultsDosingTropfenAmbulant = isStationaryAMB();
    visibleSections.adultsDosingTabletsStationary = isStationarySTAT();
    visibleSections.adultsDosingTropfenStationary = isStationarySTAT();
    visibleSections.adultsDosingLosung = isStationaryIsAnswered();
    visibleSections.kidsDosingTropfen = isAgeMatching('kids');
    visibleSections.kidsDosingLosung = isAgeMatching('kids');
    visibleSections.babyDosingLosung = isAgeMatching('baby');
    visibleSections.warningKidney = isAnswerdAllNotBaby();
    visibleSections.warningInfusion = isAnswerdAllNotBaby();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return !isAnsweredAllVisible();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
