"use strict";


var visibleQuestions = {
    age: true,
    noAnswerText: true,
    adultsTblDose1: false,
    adultsTblDose2: false,
    adultsDurationTbl: false,
    adultsTropfenDose: false,
    adultsTropfenDose2: false,
    adultsDurationTropfen: false,
    adultsDosingLosungResult: false,
    adultsDurationLosung: false,
    kidsTropfenDose: false,
    kidsTropfenDose2: false,
    kidsDurationTropfen1: false,
    kidsLosungDose: false,
    kidsDurationLosung: false,
    kidsWarning1: false,
    refer: false,
    kidney: false,
    infusionWarningPVC: false
};
var visibleSections = {
    patientSelection: true,
    noAnswer: true,
    adultsDosingTbl: false,
    adultsDosingTropfen: false,
    adultsDosingLosung: false,
    kidsDosingTropfen: false,
    kidsDosingLosung: false,
    babyDosingLosung: false,
    warningKidney: false,
    warningInfusion: false
};
var inputs = {
    age: null
};
var isAgeMatching = function (name) {
    return helpers_1.answerMatches(inputs.age, name);
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.noAnswerText = !helpers_1.isAnswered(inputs.age);
    visibleQuestions.adultsTblDose1 = isAgeMatching('adults');
    visibleQuestions.adultsTblDose2 = isAgeMatching('adults');
    visibleQuestions.adultsDurationTbl = isAgeMatching('adults');
    visibleQuestions.adultsTropfenDose = isAgeMatching('adults');
    visibleQuestions.adultsTropfenDose2 = isAgeMatching('adults');
    visibleQuestions.adultsDurationTropfen = isAgeMatching('adults');
    visibleQuestions.adultsDosingLosungResult = isAgeMatching('adults');
    visibleQuestions.adultsDurationLosung = isAgeMatching('adults');
    visibleQuestions.kidsTropfenDose = isAgeMatching('kids');
    visibleQuestions.kidsTropfenDose2 = isAgeMatching('kids');
    visibleQuestions.kidsDurationTropfen1 = isAgeMatching('kids');
    visibleQuestions.kidsLosungDose = isAgeMatching('kids');
    visibleQuestions.kidsDurationLosung = isAgeMatching('kids');
    visibleQuestions.kidsWarning1 = isAgeMatching('kids');
    visibleQuestions.refer = isAgeMatching('baby');
    visibleQuestions.kidney = isAgeMatching('adults') || isAgeMatching('kids');
    visibleQuestions.infusionWarningPVC =
        isAgeMatching('adults') || isAgeMatching('kids');
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = !helpers_1.isAnswered(inputs.age);
    visibleSections.adultsDosingTbl = isAgeMatching('adults');
    visibleSections.adultsDosingTropfen = isAgeMatching('adults');
    visibleSections.adultsDosingLosung = isAgeMatching('adults');
    visibleSections.kidsDosingTropfen = isAgeMatching('kids');
    visibleSections.kidsDosingLosung = isAgeMatching('kids');
    visibleSections.babyDosingLosung = isAgeMatching('baby');
    visibleSections.warningKidney =
        isAgeMatching('adults') || isAgeMatching('kids');
    visibleSections.warningInfusion =
        isAgeMatching('adults') || isAgeMatching('kids');
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return helpers_1.isAnswered(inputs.age);
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
