"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    age: true,
    selectionOP: false,
    weight: false,
    noAnswerText: true,
    dayBefore: false,
    titleTbl: false,
    adultsPreparationTbl: false,
    durationPrepTbl1: false,
    divider0: false,
    titleDrops: false,
    adultsPreparationTropfen1: false,
    durationPrepLos1: false,
    divider1: false,
    titleInfusion: false,
    adultsPreparationLosung: false,
    durationPrepLos1_copy: false,
    dayOf: false,
    title2: false,
    adultsPreparationLosung2: false,
    durationPrepLos2: false,
    divider2: false,
    title3: false,
    adultsPreparationLosung1: false,
    durationPrepLos3: false,
    adultsNarcoseLosung: false,
    warningNarcoseInjektion: false,
    adultAfterTbl1: false,
    adultsDurationAfterTbl2: false,
    adultAfterTropfen: false,
    adultsDurationAfterTropfen: false,
    adultsAfterLosung: false,
    adultsAfterDurationLosung: false,
    kidsPreparationLosung: false,
    kidsDurationPrepLos: false,
    kidsNarcoseLosung: false,
    warnindNarcose: false,
    kidsAfterOperationWarning: false,
    contraBabyPrepLosung: false,
    kidney: false,
    infusionWarningPVC: false
};
var visibleSections = {
    patientSelection: true,
    noAnswer: true,
    adultsPreparationBefore: false,
    adultsDosingPreparationDayOf: false,
    adultsDosingNarcoseLosung: false,
    adultsDosingAfterTablets: false,
    adultsDosingAfterTropfen: false,
    adultsDosingAfterLosung: false,
    kidsDosingPreparationLosung: false,
    kidsDosingNarcoseLosung: false,
    kidsDosingAfter: false,
    babyDosing: false,
    warningKidney: false,
    warningInfusion: false
};
var inputs = {
    age: null,
    selectionOP: null,
    weight: null
};
var isAgeKidsOrAdults = function () {
    return (helpers_1.answerMatches(inputs.age, 'kids') || helpers_1.answerMatches(inputs.age, 'adults'));
};
var isWeightVisible = function () {
    return helpers_1.isAnswered(inputs.age) && helpers_1.answerMatches(inputs.selectionOP, 'narcose');
};
var isAnsweredAllVisible = function () {
    return !(helpers_1.answerMatches(inputs.age, 'baby') ||
        (isAgeKidsOrAdults() &&
            (helpers_1.answerMatches(inputs.selectionOP, 'preparation') ||
                helpers_1.answerMatches(inputs.selectionOP, 'after') ||
                (helpers_1.answerMatches(inputs.selectionOP, 'narcose') &&
                    helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 200 })))));
};
var isAdultAndPreparation = function () {
    return (helpers_1.answerMatches(inputs.selectionOP, 'preparation') &&
        helpers_1.answerMatches(inputs.age, 'adults'));
};
var isAdultAndNarcose = function () {
    return (helpers_1.answerMatches(inputs.selectionOP, 'narcose') &&
        helpers_1.answerMatches(inputs.age, 'adults') &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 200 }));
};
var isAdultAndAfter = function () {
    return (helpers_1.answerMatches(inputs.selectionOP, 'after') &&
        helpers_1.answerMatches(inputs.age, 'adults'));
};
var isKidAndPreparation = function () {
    return (helpers_1.answerMatches(inputs.selectionOP, 'preparation') &&
        helpers_1.answerMatches(inputs.age, 'kids'));
};
var isKidAndNarcose = function () {
    return (helpers_1.answerMatches(inputs.selectionOP, 'narcose') &&
        helpers_1.answerMatches(inputs.age, 'kids') &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 200 }));
};
var isKidAndAfter = function () {
    return (helpers_1.answerMatches(inputs.selectionOP, 'after') &&
        helpers_1.answerMatches(inputs.age, 'kids'));
};
var isWarningVisible = function () {
    return (!isAnsweredAllVisible() &&
        !helpers_1.answerMatches(inputs.age, 'baby') &&
        !(helpers_1.answerMatches(inputs.age, 'kids') &&
            helpers_1.answerMatches(inputs.selectionOP, 'after')));
};
var calculatePoints = function () {
    var _a, _b;
    if (isAdultAndNarcose()) {
        var weight = Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints);
        var T1 = (weight * 0.2) / 5;
        var T2 = (weight * 0.35) / 5;
        var T3 = weight * 0.2;
        var T4 = weight * 0.35;
        return {
            adultsNarcoseLosung: {
                qID: 'adultsNarcoseLosung',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T1, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T2, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T3, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T4, 1), 0, 1)),
                titleTexts: 'result1'
            }
        };
    }
    if (isKidAndNarcose()) {
        var weight = Number((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints);
        var T1 = (weight * 0.1) / 5;
        var T2 = (weight * 0.2) / 5;
        var T3 = weight * 0.1;
        var T4 = weight * 0.2;
        return {
            kidsNarcoseLosung: {
                qID: 'kidsNarcoseLosung',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T1, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T2, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T3, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T4, 1), 0, 1)),
                titleTexts: 'result1'
            }
        };
    }
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.selectionOP = isAgeKidsOrAdults();
    visibleQuestions.weight = isWeightVisible();
    visibleQuestions.noAnswerText = isAnsweredAllVisible();
    visibleQuestions.dayBefore = isAdultAndPreparation();
    visibleQuestions.titleTbl = isAdultAndPreparation();
    visibleQuestions.adultsPreparationTbl = isAdultAndPreparation();
    visibleQuestions.durationPrepTbl1 = isAdultAndPreparation();
    visibleQuestions.divider0 = isAdultAndPreparation();
    visibleQuestions.titleDrops = isAdultAndPreparation();
    visibleQuestions.adultsPreparationTropfen1 = isAdultAndPreparation();
    visibleQuestions.durationPrepLos1 = isAdultAndPreparation();
    visibleQuestions.divider1 = isAdultAndPreparation();
    visibleQuestions.titleInfusion = isAdultAndPreparation();
    visibleQuestions.adultsPreparationLosung = isAdultAndPreparation();
    visibleQuestions.durationPrepLos1_copy = isAdultAndPreparation();
    visibleQuestions.dayOf = isAdultAndPreparation();
    visibleQuestions.title2 = isAdultAndPreparation();
    visibleQuestions.adultsPreparationLosung2 = isAdultAndPreparation();
    visibleQuestions.durationPrepLos2 = isAdultAndPreparation();
    visibleQuestions.divider2 = isAdultAndPreparation();
    visibleQuestions.title3 = isAdultAndPreparation();
    visibleQuestions.adultsPreparationLosung1 = isAdultAndPreparation();
    visibleQuestions.durationPrepLos3 = isAdultAndPreparation();
    visibleQuestions.adultsNarcoseLosung = isAdultAndNarcose();
    visibleQuestions.warningNarcoseInjektion = isAdultAndNarcose();
    visibleQuestions.adultAfterTbl1 = isAdultAndAfter();
    visibleQuestions.adultsDurationAfterTbl2 = isAdultAndAfter();
    visibleQuestions.adultAfterTropfen = isAdultAndAfter();
    visibleQuestions.adultsDurationAfterTropfen = isAdultAndAfter();
    visibleQuestions.adultsAfterLosung = isAdultAndAfter();
    visibleQuestions.adultsAfterDurationLosung = isAdultAndAfter();
    visibleQuestions.kidsPreparationLosung = isKidAndPreparation();
    visibleQuestions.kidsDurationPrepLos = isKidAndPreparation();
    visibleQuestions.kidsNarcoseLosung = isKidAndNarcose();
    visibleQuestions.warnindNarcose = isKidAndNarcose();
    visibleQuestions.kidsAfterOperationWarning = isKidAndAfter();
    visibleQuestions.contraBabyPrepLosung = helpers_1.answerMatches(inputs.age, 'baby');
    visibleQuestions.kidney = isWarningVisible();
    visibleQuestions.infusionWarningPVC = isWarningVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = isAnsweredAllVisible();
    visibleSections.adultsPreparationBefore = isAdultAndPreparation();
    visibleSections.adultsDosingPreparationDayOf = isAdultAndPreparation();
    visibleSections.adultsDosingNarcoseLosung = isAdultAndNarcose();
    visibleSections.adultsDosingAfterTablets = isAdultAndAfter();
    visibleSections.adultsDosingAfterTropfen = isAdultAndAfter();
    visibleSections.adultsDosingAfterLosung = isAdultAndAfter();
    visibleSections.kidsDosingPreparationLosung = isKidAndPreparation();
    visibleSections.kidsDosingNarcoseLosung = isKidAndNarcose();
    visibleSections.kidsDosingAfter = isKidAndAfter();
    visibleSections.babyDosing = helpers_1.answerMatches(inputs.age, 'baby');
    visibleSections.warningKidney = isWarningVisible();
    visibleSections.warningInfusion = isWarningVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return !isAnsweredAllVisible();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
