"use strict";


var visibleQuestions = {
    age: true,
    noAnswerText: true,
    adultsLosungDose: false,
    adultsLosungDose_copy: false,
    adultsDurationLosung: false,
    adolescentsLosungDose: false,
    adolescentsDurationLosung: false,
    kidsLosungDose: false,
    kidsDurationLosung: false,
    babyLosungDose: false,
    divider2: false,
    babyLosungDose2: false,
    babyDurationLosung: false,
    contraNewborn: false,
    kidney: false,
    infWarning: false
};
var visibleSections = {
    patientSelection: true,
    noAnswer: true,
    adultsDosingLosung: false,
    adolescentsDosingLosung: false,
    kidsDosingLosung: false,
    babyDosingLosung: false,
    warningKidney: false,
    warningInfusion: false
};
var inputs = {
    age: null
};
var isAgeMatching = function (name) {
    return helpers_1.answerMatches(inputs.age, name);
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.noAnswerText = !helpers_1.isAnswered(inputs.age);
    visibleQuestions.adultsLosungDose = isAgeMatching('adults');
    visibleQuestions.adultsLosungDose_copy = isAgeMatching('adults');
    visibleQuestions.adultsDurationLosung = isAgeMatching('adults');
    visibleQuestions.adolescentsLosungDose = isAgeMatching('adolescents');
    visibleQuestions.adolescentsDurationLosung = isAgeMatching('adolescents');
    visibleQuestions.kidsLosungDose = isAgeMatching('kids');
    visibleQuestions.kidsDurationLosung = isAgeMatching('kids');
    visibleQuestions.babyLosungDose = isAgeMatching('baby');
    visibleQuestions.divider2 = isAgeMatching('baby');
    visibleQuestions.babyLosungDose2 = isAgeMatching('baby');
    visibleQuestions.babyDurationLosung = isAgeMatching('baby');
    visibleQuestions.contraNewborn = isAgeMatching('baby');
    visibleQuestions.kidney = helpers_1.isAnswered(inputs.age);
    visibleQuestions.infWarning = helpers_1.isAnswered(inputs.age);
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = !helpers_1.isAnswered(inputs.age);
    visibleSections.adultsDosingLosung = isAgeMatching('adults');
    visibleSections.adolescentsDosingLosung = isAgeMatching('adolescents');
    visibleSections.kidsDosingLosung = isAgeMatching('kids');
    visibleSections.babyDosingLosung = isAgeMatching('baby');
    visibleSections.warningKidney = helpers_1.isAnswered(inputs.age);
    visibleSections.warningInfusion = helpers_1.isAnswered(inputs.age);
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return helpers_1.isAnswered(inputs.age);
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
