"use strict";


var visibleQuestions = {
    explanation: true,
    emergency: true,
    hospitalized: true,
    intensive: true,
    ogk: true,
    saba: true,
    medAdherence: true,
    associated: true,
    noReferral: false,
    referral: false
};
var visibleSections = {
    section1: true,
    section2: true,
    results: true
};
var inputs = {
    emergency: null,
    hospitalized: null,
    intensive: null,
    ogk: null,
    saba: null,
    medAdherence: null,
    associated: null
};
var isNoReferralVisible = function () {
    var _a, _b, _c, _d, _e, _f, _g;
    return (helpers_1.isAnswered(inputs.emergency) &&
        ((_a = inputs.emergency) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "no" &&
        helpers_1.isAnswered(inputs.hospitalized) &&
        ((_b = inputs.hospitalized) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "no" &&
        helpers_1.isAnswered(inputs.intensive) &&
        ((_c = inputs.intensive) === null || _c === void 0 ? void 0 : _c.currentIdentifier) === "no" &&
        helpers_1.isAnswered(inputs.ogk) &&
        ((_d = inputs.ogk) === null || _d === void 0 ? void 0 : _d.currentIdentifier) === "no" &&
        helpers_1.isAnswered(inputs.saba) &&
        ((_e = inputs.saba) === null || _e === void 0 ? void 0 : _e.currentIdentifier) === "no" &&
        helpers_1.isAnswered(inputs.medAdherence) &&
        ((_f = inputs.medAdherence) === null || _f === void 0 ? void 0 : _f.currentIdentifier) === "no" &&
        helpers_1.isAnswered(inputs.associated) &&
        ((_g = inputs.associated) === null || _g === void 0 ? void 0 : _g.currentIdentifier) === "no");
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.noReferral = isNoReferralVisible();
    visibleQuestions.referral = !isNoReferralVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_toolScore = function () {
    return calculatePoints();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return true;
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});