"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    age: true,
    weight: false,
    weight2: false,
    dosing1: true,
    babyDose1: false,
    kidsDose1: false,
    kidsDose2: false,
    kidsDose3: false,
    kidsDose4: false,
    kidsDose5: false,
    kidsDose6: false,
    kidsDose7: false,
    kidsDose8: false,
    kidsDose9: false,
    kidsDose10: false,
    adultsDose1: false,
    adultsDose2: false,
    adultsDose3: false,
    adultsDose4: false,
    adultsDose5: false,
    adultsDose6: false,
    adultsDose7: false,
    adultsDose8: false,
    adultsDose9: false,
    adultsDose10: false,
    renal: false,
    w1: false
};
var visibleSections = {
    section1: true,
    dosing: true,
    babyDose: false,
    kidsDose: false,
    kidsDose1002: false,
    kidsDose2002: false,
    adultsDose100: false,
    adultsDose200: false,
    adultsDose1002: false,
    adultsDose2002: false,
    warningAB: false,
    anti: false
};
var inputs = {
    age: null,
    weight: null,
    weight2: null
};
var isWeightVisible = function () {
    return helpers_1.answerMatches(inputs.age, 'kids');
};
var isWeight2Visible = function () {
    return helpers_1.answerMatches(inputs.age, 'adults');
};
var isAnswerAllVisible = function () {
    return !(helpers_1.answerMatches(inputs.age, 'babies') ||
        (helpers_1.isAnswered(inputs.age) &&
            (helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 300 }) ||
                helpers_1.isAnswered(inputs.weight2))));
};
var isBabyDoseVisible = function () {
    return helpers_1.answerMatches(inputs.age, 'babies');
};
var isKidsDoseVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'kids') &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 45 }));
};
var isKidsDose1002Visible = function () {
    return (helpers_1.answerMatches(inputs.age, 'kids') &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 45.1, max: 69.9 }));
};
var isAdultsDose100Visible = function () {
    return (helpers_1.answerMatches(inputs.age, 'adults') &&
        helpers_1.answerMatches(inputs.weight2, 'underS'));
};
var isAdultsDose1002Visible = function () {
    return ((helpers_1.answerMatches(inputs.age, 'adults') &&
        helpers_1.answerMatches(inputs.weight2, 'overS')) ||
        (helpers_1.answerMatches(inputs.age, 'kids') &&
            helpers_1.numberInLimits({ input: inputs.weight, min: 70, max: 300 })));
};
var isWeightOrWeight2Answered = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 300 }) ||
        helpers_1.isAnswered(inputs.weight2));
};
var calculatePoints = function () {
    var _a, _b, _c;
    if (!isKidsDoseVisible())
        return null;
    return {
        kidsDose1: {
            qID: 'kidsDose1',
            tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints) * 4.4, 1), 0, 1)),
            titleTexts: 'result1'
        },
        kidsDose2: {
            qID: 'kidsDose2',
            tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints) * 2.2, 1), 0, 1)),
            titleTexts: 'result1'
        },
        kidsDose3: {
            qID: 'kidsDose3',
            tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(((_c = inputs.weight) === null || _c === void 0 ? void 0 : _c.currentPoints) * 4.4, 1), 0, 1)),
            titleTexts: 'result1'
        }
    };
};
var returnVisibleQuestions = function () {
    visibleQuestions.weight = isWeightVisible();
    visibleQuestions.weight2 = isWeight2Visible();
    visibleQuestions.dosing1 = isAnswerAllVisible();
    visibleQuestions.babyDose1 = isBabyDoseVisible();
    visibleQuestions.kidsDose1 = isKidsDoseVisible();
    visibleQuestions.kidsDose2 = isKidsDoseVisible();
    visibleQuestions.kidsDose3 = isKidsDoseVisible();
    visibleQuestions.kidsDose4 = isKidsDoseVisible();
    visibleQuestions.kidsDose5 = isKidsDose1002Visible();
    visibleQuestions.kidsDose6 = isKidsDose1002Visible();
    visibleQuestions.kidsDose7 = isKidsDose1002Visible();
    visibleQuestions.kidsDose8 = isKidsDose1002Visible();
    visibleQuestions.kidsDose9 = isKidsDose1002Visible();
    visibleQuestions.kidsDose10 = isKidsDose1002Visible();
    visibleQuestions.adultsDose1 = isAdultsDose100Visible();
    visibleQuestions.adultsDose2 = isAdultsDose100Visible();
    visibleQuestions.adultsDose3 = isAdultsDose100Visible();
    visibleQuestions.adultsDose4 = isAdultsDose100Visible();
    visibleQuestions.adultsDose5 = isAdultsDose100Visible();
    visibleQuestions.adultsDose6 = isAdultsDose100Visible();
    visibleQuestions.adultsDose7 = isAdultsDose1002Visible();
    visibleQuestions.adultsDose8 = isAdultsDose1002Visible();
    visibleQuestions.adultsDose9 = isAdultsDose1002Visible();
    visibleQuestions.adultsDose10 = isAdultsDose1002Visible();
    visibleQuestions.renal = isWeightOrWeight2Answered();
    visibleQuestions.w1 = isWeightOrWeight2Answered();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.dosing = isAnswerAllVisible();
    visibleSections.babyDose = isBabyDoseVisible();
    visibleSections.kidsDose = isKidsDoseVisible();
    visibleSections.kidsDose1002 = isKidsDose1002Visible();
    visibleSections.kidsDose2002 = isKidsDose1002Visible();
    visibleSections.adultsDose100 = isAdultsDose100Visible();
    visibleSections.adultsDose200 = isAdultsDose100Visible();
    visibleSections.adultsDose1002 = isAdultsDose1002Visible();
    visibleSections.adultsDose2002 = isAdultsDose1002Visible();
    visibleSections.warningAB = isWeightOrWeight2Answered();
    visibleSections.anti = isWeightOrWeight2Answered();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return !isAnswerAllVisible();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
