"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    age: true,
    hArea: true,
    hErythema: true,
    hEdema: true,
    hExcoriation: true,
    hLichenification: true,
    ulArea: true,
    ulErythema: true,
    ulEdema: true,
    ulExcoriation: true,
    ulLichenification: true,
    tArea: true,
    tErythema: true,
    tEdema: true,
    tExcoriation: true,
    tLichenification: true,
    llArea: true,
    llErythema: true,
    llEdema: true,
    llExcoriation: true,
    llLichenification: true,
    answerAll: true,
    clear: false,
    almostClear: false,
    mild: false,
    moderate: false,
    severe: false,
    verySevere: false,
    easiLinkQuestion: true
};
var visibleSections = {
    ageSection: true,
    headAndNeck: true,
    upperLimbs: true,
    trunk: true,
    lowerLimbs: true,
    resultSection: true
};
var inputs = {
    age: null,
    hArea: null,
    hErythema: null,
    hEdema: null,
    hExcoriation: null,
    hLichenification: null,
    ulArea: null,
    ulErythema: null,
    ulEdema: null,
    ulExcoriation: null,
    ulLichenification: null,
    tArea: null,
    tErythema: null,
    tEdema: null,
    tExcoriation: null,
    tLichenification: null,
    llArea: null,
    llErythema: null,
    llEdema: null,
    llExcoriation: null,
    llLichenification: null
};
var returnVisibleQuestions = function () {
    visibleQuestions.hErythema = isHeadAreaVisible();
    visibleQuestions.hEdema = isHeadAreaVisible();
    visibleQuestions.hExcoriation = isHeadAreaVisible();
    visibleQuestions.hLichenification = isHeadAreaVisible();
    visibleQuestions.ulErythema = isULAreaVisible();
    visibleQuestions.ulEdema = isULAreaVisible();
    visibleQuestions.ulExcoriation = isULAreaVisible();
    visibleQuestions.ulLichenification = isULAreaVisible();
    visibleQuestions.tErythema = isTAreaVisible();
    visibleQuestions.tEdema = isTAreaVisible();
    visibleQuestions.tExcoriation = isTAreaVisible();
    visibleQuestions.tLichenification = isTAreaVisible();
    visibleQuestions.llErythema = isLLAreaVisible();
    visibleQuestions.llEdema = isLLAreaVisible();
    visibleQuestions.llExcoriation = isLLAreaVisible();
    visibleQuestions.llLichenification = isLLAreaVisible();
    visibleQuestions.answerAll = !helpers_1.isAnswered(inputs.age);
    visibleQuestions.clear = isClearVisible();
    visibleQuestions.almostClear = isAlmostClearVisible();
    visibleQuestions.mild = isMildVisible();
    visibleQuestions.moderate = isModerateVisible();
    visibleQuestions.severe = isSevereVisible();
    visibleQuestions.verySevere = isVerySevereVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var calculateSectionsPoints = function () {
    var headNeck = helpers_1.answerMatches(inputs.age, 'less8')
        ? calculateHeadNeckLess8()
        : calculateHeadNeckMore8();
    var uLimbs = helpers_1.answerMatches(inputs.age, 'less8')
        ? calculateULimbsLess8()
        : calculateULimbsMore8();
    var trunk = helpers_1.answerMatches(inputs.age, 'less8')
        ? calculateTrunkLess8()
        : calculateTrunkMore8();
    var lLimbs = helpers_1.answerMatches(inputs.age, 'less8')
        ? calculateLLimbsLess8()
        : calculateLLimbsMore8();
    return headNeck + uLimbs + trunk + lLimbs;
};
var isHeadAreaVisible = function () {
    var _a;
    return Number((_a = inputs.hArea) === null || _a === void 0 ? void 0 : _a.currentPoints) > 0;
};
var isULAreaVisible = function () {
    var _a;
    return Number((_a = inputs.ulArea) === null || _a === void 0 ? void 0 : _a.currentPoints) > 0;
};
var isTAreaVisible = function () {
    var _a;
    return Number((_a = inputs.tArea) === null || _a === void 0 ? void 0 : _a.currentPoints) > 0;
};
var isLLAreaVisible = function () {
    var _a;
    return Number((_a = inputs.llArea) === null || _a === void 0 ? void 0 : _a.currentPoints) > 0;
};
var isClearVisible = function () {
    var easi = calculateSectionsPoints();
    return helpers_1.isAnswered(inputs.age) && easi === 0;
};
var isAlmostClearVisible = function () {
    var easi = calculateSectionsPoints();
    return helpers_1.isAnswered(inputs.age) && easi > 0 && easi <= 1;
};
var isMildVisible = function () {
    var easi = calculateSectionsPoints();
    return helpers_1.isAnswered(inputs.age) && easi > 1 && easi <= 7;
};
var isModerateVisible = function () {
    var easi = calculateSectionsPoints();
    return helpers_1.isAnswered(inputs.age) && easi > 7 && easi <= 21;
};
var isSevereVisible = function () {
    var easi = calculateSectionsPoints();
    return helpers_1.isAnswered(inputs.age) && easi > 21 && easi <= 50;
};
var isVerySevereVisible = function () {
    var easi = calculateSectionsPoints();
    return helpers_1.isAnswered(inputs.age) && easi > 50 && easi <= 72;
};
var calculateHeadNeckLess8 = function () {
    var _a, _b, _c, _d, _e;
    var hErythema = Number((_a = inputs.hErythema) === null || _a === void 0 ? void 0 : _a.currentPoints);
    var hEdema = Number((_b = inputs.hEdema) === null || _b === void 0 ? void 0 : _b.currentPoints);
    var hExcoriation = Number((_c = inputs.hExcoriation) === null || _c === void 0 ? void 0 : _c.currentPoints);
    var hLichenification = Number((_d = inputs.hLichenification) === null || _d === void 0 ? void 0 : _d.currentPoints);
    var hArea = Number((_e = inputs.hArea) === null || _e === void 0 ? void 0 : _e.currentPoints);
    return (hErythema + hEdema + hExcoriation + hLichenification) * hArea * 0.2;
};
var calculateULimbsLess8 = function () {
    var _a, _b, _c, _d, _e;
    var ulErythema = Number((_a = inputs.ulErythema) === null || _a === void 0 ? void 0 : _a.currentPoints);
    var ulEdema = Number((_b = inputs.ulEdema) === null || _b === void 0 ? void 0 : _b.currentPoints);
    var ulExcoriation = Number((_c = inputs.ulExcoriation) === null || _c === void 0 ? void 0 : _c.currentPoints);
    var ulLichenification = Number((_d = inputs.ulLichenification) === null || _d === void 0 ? void 0 : _d.currentPoints);
    var ulArea = Number((_e = inputs.ulArea) === null || _e === void 0 ? void 0 : _e.currentPoints);
    return ((ulErythema + ulEdema + ulExcoriation + ulLichenification) * ulArea * 0.2);
};
var calculateTrunkLess8 = function () {
    var _a, _b, _c, _d, _e;
    var tErythema = Number((_a = inputs.tErythema) === null || _a === void 0 ? void 0 : _a.currentPoints);
    var tEdema = Number((_b = inputs.tEdema) === null || _b === void 0 ? void 0 : _b.currentPoints);
    var tExcoriation = Number((_c = inputs.tExcoriation) === null || _c === void 0 ? void 0 : _c.currentPoints);
    var tLichenification = Number((_d = inputs.tLichenification) === null || _d === void 0 ? void 0 : _d.currentPoints);
    var tArea = Number((_e = inputs.tArea) === null || _e === void 0 ? void 0 : _e.currentPoints);
    return (tErythema + tEdema + tExcoriation + tLichenification) * tArea * 0.3;
};
var calculateLLimbsLess8 = function () {
    var _a, _b, _c, _d, _e;
    var llErythema = Number((_a = inputs.llErythema) === null || _a === void 0 ? void 0 : _a.currentPoints);
    var llEdema = Number((_b = inputs.llEdema) === null || _b === void 0 ? void 0 : _b.currentPoints);
    var llExcoriation = Number((_c = inputs.llExcoriation) === null || _c === void 0 ? void 0 : _c.currentPoints);
    var llLichenification = Number((_d = inputs.llLichenification) === null || _d === void 0 ? void 0 : _d.currentPoints);
    var llArea = Number((_e = inputs.llArea) === null || _e === void 0 ? void 0 : _e.currentPoints);
    return ((llErythema + llEdema + llExcoriation + llLichenification) * llArea * 0.3);
};
var calculateHeadNeckMore8 = function () {
    var _a, _b, _c, _d, _e;
    var hErythema = Number((_a = inputs.hErythema) === null || _a === void 0 ? void 0 : _a.currentPoints);
    var hEdema = Number((_b = inputs.hEdema) === null || _b === void 0 ? void 0 : _b.currentPoints);
    var hExcoriation = Number((_c = inputs.hExcoriation) === null || _c === void 0 ? void 0 : _c.currentPoints);
    var hLichenification = Number((_d = inputs.hLichenification) === null || _d === void 0 ? void 0 : _d.currentPoints);
    var hArea = Number((_e = inputs.hArea) === null || _e === void 0 ? void 0 : _e.currentPoints);
    return (hErythema + hEdema + hExcoriation + hLichenification) * hArea * 0.1;
};
var calculateULimbsMore8 = function () {
    var _a, _b, _c, _d, _e;
    var ulErythema = Number((_a = inputs.ulErythema) === null || _a === void 0 ? void 0 : _a.currentPoints);
    var ulEdema = Number((_b = inputs.ulEdema) === null || _b === void 0 ? void 0 : _b.currentPoints);
    var ulExcoriation = Number((_c = inputs.ulExcoriation) === null || _c === void 0 ? void 0 : _c.currentPoints);
    var ulLichenification = Number((_d = inputs.ulLichenification) === null || _d === void 0 ? void 0 : _d.currentPoints);
    var ulArea = Number((_e = inputs.ulArea) === null || _e === void 0 ? void 0 : _e.currentPoints);
    return ((ulErythema + ulEdema + ulExcoriation + ulLichenification) * ulArea * 0.2);
};
var calculateTrunkMore8 = function () {
    var _a, _b, _c, _d, _e;
    var tErythema = Number((_a = inputs.tErythema) === null || _a === void 0 ? void 0 : _a.currentPoints);
    var tEdema = Number((_b = inputs.tEdema) === null || _b === void 0 ? void 0 : _b.currentPoints);
    var tExcoriation = Number((_c = inputs.tExcoriation) === null || _c === void 0 ? void 0 : _c.currentPoints);
    var tLichenification = Number((_d = inputs.tLichenification) === null || _d === void 0 ? void 0 : _d.currentPoints);
    var tArea = Number((_e = inputs.tArea) === null || _e === void 0 ? void 0 : _e.currentPoints);
    return (tErythema + tEdema + tExcoriation + tLichenification) * tArea * 0.3;
};
var calculateLLimbsMore8 = function () {
    var _a, _b, _c, _d, _e;
    var llErythema = Number((_a = inputs.llErythema) === null || _a === void 0 ? void 0 : _a.currentPoints);
    var llEdema = Number((_b = inputs.llEdema) === null || _b === void 0 ? void 0 : _b.currentPoints);
    var llExcoriation = Number((_c = inputs.llExcoriation) === null || _c === void 0 ? void 0 : _c.currentPoints);
    var llLichenification = Number((_d = inputs.llLichenification) === null || _d === void 0 ? void 0 : _d.currentPoints);
    var llArea = Number((_e = inputs.llArea) === null || _e === void 0 ? void 0 : _e.currentPoints);
    return ((llErythema + llEdema + llExcoriation + llLichenification) * llArea * 0.4);
};
var isExportResultsEnabled = function () {
    return helpers_1.isAnswered(inputs.age);
};
var calculatePoints = function () {
    if (!helpers_1.isAnswered(inputs.age))
        return {
            answerAll: {
                qID: 'answerAll'
            }
        };
    var EASIScore = helpers_1.formatCalculationResult(calculateSectionsPoints(), 1);
    if (EASIScore === 0) {
        return {
            clear: {
                qID: 'clear',
                rParams: __spreadArrays(helpers_1.returnNumberObject(EASIScore, 0, 1)),
                resultTexts: 'regular'
            }
        };
    }
    if (EASIScore > 0 && EASIScore <= 1) {
        return {
            almostClear: {
                qID: 'almostClear',
                rParams: __spreadArrays(helpers_1.returnNumberObject(EASIScore, 0, 1)),
                resultTexts: 'regular'
            }
        };
    }
    if (EASIScore > 1 && EASIScore <= 7) {
        return {
            mild: {
                qID: 'mild',
                rParams: __spreadArrays(helpers_1.returnNumberObject(EASIScore, 0, 1)),
                resultTexts: 'regular'
            }
        };
    }
    if (EASIScore > 7 && EASIScore <= 21) {
        return {
            moderate: {
                qID: 'moderate',
                rParams: __spreadArrays(helpers_1.returnNumberObject(EASIScore, 0, 1)),
                resultTexts: 'regular'
            }
        };
    }
    if (EASIScore > 21 && EASIScore <= 50) {
        return {
            severe: {
                qID: 'severe',
                rParams: __spreadArrays(helpers_1.returnNumberObject(EASIScore, 0, 1)),
                resultTexts: 'regular'
            }
        };
    }
    if (EASIScore > 50 && EASIScore <= 72) {
        return {
            verySevere: {
                qID: 'verySevere',
                rParams: __spreadArrays(helpers_1.returnNumberObject(EASIScore, 0, 1)),
                resultTexts: 'regular'
            }
        };
    }
    return {
        answerAll: {
            qID: 'answerAll'
        }
    };
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
