"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};


var visibleQuestions = {
    lastInjection: true,
    currentInterval: true,
    changeInterval: true,
    warning: true,
    answerAll: false,
    warning1: false,
    warning2: false,
    reduce4: false,
    reduce2: false,
    maintain: false,
    extend2: false,
    extend4: false,
    proceed: false
};
var visibleSections = {
    dateCalc: true,
    results: true
};
var inputs = {
    lastInjection: null,
    currentInterval: null,
    changeInterval: null
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e, _f;
    if (!helpers_1.isAnswered(inputs.lastInjection) || !helpers_1.isAnswered(inputs.currentInterval))
        return {};
    var currentIntervalDays = 0;
    switch ((_a = inputs.currentInterval) === null || _a === void 0 ? void 0 : _a.currentIdentifier) {
        case "four":
            currentIntervalDays = 28;
            break;
        case "six":
            currentIntervalDays = 42;
            break;
        case "eight":
            currentIntervalDays = 56;
            break;
        case "ten":
            currentIntervalDays = 70;
            break;
        case "twelve":
            currentIntervalDays = 84;
            break;
        case "fourteen":
            currentIntervalDays = 98;
            break;
        case "sixteen":
            currentIntervalDays = 112;
            break;
    }
    var reduce4 = helpers_1.addDaysToDate((_b = inputs.lastInjection) === null || _b === void 0 ? void 0 : _b.currentDate, currentIntervalDays - 28);
    var reduce2 = helpers_1.addDaysToDate((_c = inputs.lastInjection) === null || _c === void 0 ? void 0 : _c.currentDate, currentIntervalDays - 14);
    var maintain = helpers_1.addDaysToDate((_d = inputs.lastInjection) === null || _d === void 0 ? void 0 : _d.currentDate, currentIntervalDays);
    var extend2 = helpers_1.addDaysToDate((_e = inputs.lastInjection) === null || _e === void 0 ? void 0 : _e.currentDate, currentIntervalDays + 14);
    var extend4 = helpers_1.addDaysToDate((_f = inputs.lastInjection) === null || _f === void 0 ? void 0 : _f.currentDate, currentIntervalDays + 28);
    return __assign(__assign(__assign(__assign(__assign({}, generateResultObject("reduce4", reduce4)), generateResultObject("reduce2", reduce2)), generateResultObject("maintain", maintain)), generateResultObject("extend2", extend2)), generateResultObject("extend4", extend4));
};
var generateResultObject = function (name, value) {
    var _a;
    return _a = {},
        _a[name] = {
            qID: name,
            titleTexts: "regular",
            resultTexts: "regular",
            tParams: [
                {
                    type: "date",
                    value: value
                },
            ]
        },
        _a;
};
var allQuestionsAnswered = function () {
    return (helpers_1.isAnswered(inputs.lastInjection) &&
        helpers_1.isAnswered(inputs.currentInterval) &&
        helpers_1.isAnswered(inputs.changeInterval));
};
var resultRange2Visibility = function () {
    var _a, _b, _c, _d, _e;
    return (allQuestionsAnswered() &&
        ((((_a = inputs.currentInterval) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "four" &&
            (((_b = inputs.changeInterval) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "minusFour" ||
                ((_c = inputs.changeInterval) === null || _c === void 0 ? void 0 : _c.currentIdentifier) === "minusTwo")) ||
            (((_d = inputs.currentInterval) === null || _d === void 0 ? void 0 : _d.currentIdentifier) === "six" &&
                ((_e = inputs.changeInterval) === null || _e === void 0 ? void 0 : _e.currentIdentifier) === "minusFour")));
};
var resultRange3Visibility = function () {
    var _a, _b, _c, _d, _e;
    return (allQuestionsAnswered() &&
        ((((_a = inputs.currentInterval) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "fourteen" &&
            ((_b = inputs.changeInterval) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "plusFour") ||
            (((_c = inputs.currentInterval) === null || _c === void 0 ? void 0 : _c.currentIdentifier) === "sixteen" &&
                (((_d = inputs.changeInterval) === null || _d === void 0 ? void 0 : _d.currentIdentifier) === "plusFour" ||
                    ((_e = inputs.changeInterval) === null || _e === void 0 ? void 0 : _e.currentIdentifier) === "plusTwo"))));
};
var resultRange4Visibility = function () {
    var _a, _b, _c, _d;
    return (allQuestionsAnswered() &&
        ((_a = inputs.currentInterval) === null || _a === void 0 ? void 0 : _a.currentIdentifier) !== "placeholder" &&
        ((_b = inputs.currentInterval) === null || _b === void 0 ? void 0 : _b.currentIdentifier) !== "four" &&
        ((_c = inputs.currentInterval) === null || _c === void 0 ? void 0 : _c.currentIdentifier) !== "six" &&
        ((_d = inputs.changeInterval) === null || _d === void 0 ? void 0 : _d.currentIdentifier) === "minusFour");
};
var resultRange5Visibility = function () {
    var _a, _b, _c;
    return (allQuestionsAnswered() &&
        ((_a = inputs.currentInterval) === null || _a === void 0 ? void 0 : _a.currentIdentifier) !== "placeholder" &&
        ((_b = inputs.currentInterval) === null || _b === void 0 ? void 0 : _b.currentIdentifier) !== "four" &&
        ((_c = inputs.changeInterval) === null || _c === void 0 ? void 0 : _c.currentIdentifier) === "minusTwo");
};
var resultRange6Visibility = function () {
    var _a;
    return (((_a = inputs.changeInterval) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "maintain" &&
        helpers_1.isAnswered(inputs.currentInterval));
};
var resultRange7Visibility = function () {
    var _a, _b, _c;
    return (allQuestionsAnswered() &&
        ((_a = inputs.currentInterval) === null || _a === void 0 ? void 0 : _a.currentIdentifier) !== "placeholder" &&
        ((_b = inputs.currentInterval) === null || _b === void 0 ? void 0 : _b.currentIdentifier) !== "sixteen" &&
        ((_c = inputs.changeInterval) === null || _c === void 0 ? void 0 : _c.currentIdentifier) === "plusTwo");
};
var resultRange8Visibility = function () {
    var _a, _b, _c, _d;
    return (allQuestionsAnswered() &&
        ((_a = inputs.currentInterval) === null || _a === void 0 ? void 0 : _a.currentIdentifier) !== "placeholder" &&
        ((_b = inputs.currentInterval) === null || _b === void 0 ? void 0 : _b.currentIdentifier) !== "sixteen" &&
        ((_c = inputs.currentInterval) === null || _c === void 0 ? void 0 : _c.currentIdentifier) !== "fourteen" &&
        ((_d = inputs.changeInterval) === null || _d === void 0 ? void 0 : _d.currentIdentifier) === "plusFour");
};
var returnVisibleQuestions = function () {
    visibleQuestions.answerAll = !allQuestionsAnswered();
    visibleQuestions.warning1 = resultRange2Visibility();
    visibleQuestions.warning2 = resultRange3Visibility();
    visibleQuestions.reduce4 = resultRange4Visibility();
    visibleQuestions.reduce2 = resultRange5Visibility();
    visibleQuestions.maintain = resultRange6Visibility();
    visibleQuestions.extend2 = resultRange7Visibility();
    visibleQuestions.extend4 = resultRange8Visibility();
    visibleQuestions.proceed =
        resultRange4Visibility() ||
            resultRange5Visibility() ||
            resultRange6Visibility() ||
            resultRange7Visibility() ||
            resultRange8Visibility();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    return {
        result: calculatePoints(),
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});