"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};


var visibleQuestions = {
    startDate: true,
    dose0: true,
    dose4: true,
    dose8: true,
    dose16: true,
    criteria: true,
    furtherTreatment: true,
    dose20: false,
    dose22: false,
    dose24: false,
    extendedTwo26: false,
    extendedFour28: false,
    proceed: false,
    warning: false
};
var visibleSections = {
    section1: true,
    section2: true,
    section3: true,
    section4: true
};
var inputs = {
    startDate: null,
    furtherTreatment: null
};
var dose20Visibility = function () {
    var _a;
    return (helpers_1.isAnswered(inputs.furtherTreatment) &&
        ((_a = inputs.furtherTreatment) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "reduceFour");
};
var dose22Visibility = function () {
    var _a;
    return (helpers_1.isAnswered(inputs.furtherTreatment) &&
        ((_a = inputs.furtherTreatment) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "reduceTwo");
};
var dose24Visibility = function () {
    var _a;
    return (helpers_1.isAnswered(inputs.furtherTreatment) &&
        ((_a = inputs.furtherTreatment) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "maintain");
};
var extendedTwo26Visibility = function () {
    var _a;
    return (helpers_1.isAnswered(inputs.furtherTreatment) &&
        ((_a = inputs.furtherTreatment) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "two");
};
var extendedFour28Visibility = function () {
    var _a;
    return (helpers_1.isAnswered(inputs.furtherTreatment) &&
        ((_a = inputs.furtherTreatment) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "four");
};
var proceedVisibility = function () {
    return helpers_1.isAnswered(inputs.furtherTreatment);
};
var warningVisibility = function () {
    return helpers_1.isAnswered(inputs.furtherTreatment);
};
var calculatePoints = function () {
    var _a;
    var currentDate = (_a = inputs.startDate) === null || _a === void 0 ? void 0 : _a.currentDate;
    var formatObjects = __assign(__assign(__assign(__assign({}, generateResultObject("dose0", currentDate)), generateResultObject("dose4", helpers_1.addDaysToDate(currentDate, 4 * 7))), generateResultObject("dose8", helpers_1.addDaysToDate(currentDate, 8 * 7))), generateResultObject("dose16", helpers_1.addDaysToDate(currentDate, 16 * 7)));
    if (dose20Visibility()) {
        formatObjects = __assign(__assign({}, formatObjects), generateResultObject("dose20", helpers_1.addDaysToDate(currentDate, 20 * 7)));
    }
    if (dose22Visibility()) {
        formatObjects = __assign(__assign({}, formatObjects), generateResultObject("dose22", helpers_1.addDaysToDate(currentDate, 22 * 7)));
    }
    if (dose24Visibility()) {
        formatObjects = __assign(__assign({}, formatObjects), generateResultObject("dose24", helpers_1.addDaysToDate(currentDate, 24 * 7)));
    }
    if (extendedTwo26Visibility()) {
        formatObjects = __assign(__assign({}, formatObjects), generateResultObject("extendedTwo26", helpers_1.addDaysToDate(currentDate, 26 * 7)));
    }
    if (extendedTwo26Visibility()) {
        formatObjects = __assign(__assign({}, formatObjects), generateResultObject("extendedTwo26", helpers_1.addDaysToDate(currentDate, 26 * 7)));
    }
    if (extendedFour28Visibility()) {
        formatObjects = __assign(__assign({}, formatObjects), generateResultObject("extendedFour28", helpers_1.addDaysToDate(currentDate, 28 * 7)));
    }
    return formatObjects;
};
var generateResultObject = function (name, value) {
    var _a;
    return _a = {},
        _a[name] = {
            qID: name,
            titleTexts: "regular",
            resultTexts: "regular",
            tParams: [
                {
                    type: "date",
                    value: value
                },
            ]
        },
        _a;
};
var returnVisibleQuestions = function () {
    visibleQuestions.dose20 = dose20Visibility();
    visibleQuestions.dose22 = dose22Visibility();
    visibleQuestions.dose24 = dose24Visibility();
    visibleQuestions.extendedTwo26 = extendedTwo26Visibility();
    visibleQuestions.extendedFour28 = extendedFour28Visibility();
    visibleQuestions.proceed = proceedVisibility();
    visibleQuestions.warning = warningVisibility();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.section4 = proceedVisibility();
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        result: { number: result, range: result },
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
