"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};


var visibleQuestions = {
    arcusCornealis: true,
    causativeMutation: true,
    childrenLDLC: true,
    firstDegreeTendinousXanthomata: true,
    prematureCoronary: true,
    prematureCoronaryOrVascular: true,
    prematureVascular: true,
    relativeLDLC: true,
    ldlcRange: true,
    tendiousXanthomata: true
};
var visibleSections = {
    familyHistory: true,
    clinicalHistory: true,
    physicalExamination: true,
    ldlcLevels: true,
    dnaAnalysis: true
};
var inputs = {
    arcusCornealis: null,
    causativeMutation: null,
    childrenLDLC: null,
    firstDegreeTendinousXanthomata: null,
    prematureCoronary: null,
    prematureCoronaryOrVascular: null,
    prematureVascular: null,
    relativeLDLC: null,
    ldlcRange: null,
    tendiousXanthomata: null
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_toolScore = function () {
    return calculatePoints();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return true;
};
var calculatePoints = function () {
    var familyHistory = Math.max(Number(inputs.prematureCoronaryOrVascular.currentPoints || 0), Number(inputs.relativeLDLC.currentPoints || 0), Number(inputs.firstDegreeTendinousXanthomata.currentPoints || 0), Number(inputs.childrenLDLC.currentPoints || 0));
    var clinicalHistory = Math.max(Number(inputs.prematureCoronary.currentPoints || 0), Number(inputs.prematureVascular.currentPoints || 0));
    var physicalExamination = Math.max(Number(inputs.tendiousXanthomata.currentPoints || 0), Number(inputs.arcusCornealis.currentPoints || 0));
    var ldlcLevels = Number(inputs.ldlcRange.currentPoints || 0);
    var dnaAnalysis = Number(inputs.causativeMutation.currentPoints || 0);
    var pointsSum = familyHistory +
        clinicalHistory +
        physicalExamination +
        ldlcLevels +
        dnaAnalysis;
    var outputResult = helpers_1.formatCalculationResult(pointsSum);
    return helpers_1.returnToolScoreObject({ number: outputResult, range: outputResult });
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return __assign(__assign({ exportResultsEnabled: isExportResultsEnabled() }, result), { visibleQuestions: ut_visibleQuestions(), visibleSections: ut_visibleSections() });
});
