"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    sex: true,
    age: true,
    weight: true,
    height: true,
    waistCircumferenceMale: false,
    waistCircumferenceFemale: false,
    vegetables: true,
    activity: true,
    bloodPressureMedications: true,
    bloodGlucose: true,
    family: true,
    lowRisk: false,
    slightlyElevatedRisk: false,
    moderateRisk: false,
    highRisk: false,
    veryHighRisk: false,
    noAnswerText: true
};
var visibleSections = {
    inputSection: true,
    results: false,
    noAnswerSection: true
};
var inputs = {
    sex: null,
    age: null,
    weight: null,
    height: null,
    waistCircumferenceMale: null,
    waistCircumferenceFemale: null,
    vegetables: null,
    activity: null,
    bloodPressureMedications: null,
    bloodGlucose: null,
    family: null
};
var answeredAll = function () {
    return (helpers_1.isAnswered(inputs.sex) &&
        helpers_1.isAnswered(inputs.age) &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 200 }) &&
        helpers_1.numberInLimits({ input: inputs.height, min: 1, max: 250 }) &&
        (helpers_1.isAnswered(inputs.waistCircumferenceMale) ||
            helpers_1.isAnswered(inputs.waistCircumferenceFemale)) &&
        helpers_1.isAnswered(inputs.vegetables) &&
        helpers_1.isAnswered(inputs.activity) &&
        helpers_1.isAnswered(inputs.bloodPressureMedications) &&
        helpers_1.isAnswered(inputs.bloodGlucose) &&
        helpers_1.isAnswered(inputs.family));
};
var points = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    var BMI = inputs.weight.currentPoints /
        ((inputs.height.currentPoints / 100) *
            (inputs.height.currentPoints / 100));
    var BMIPoints = BMI > 30 ? 3 : BMI <= 30 && BMI >= 25 ? 1 : 0;
    return (Number((_a = inputs.sex) === null || _a === void 0 ? void 0 : _a.currentPoints) +
        Number((_b = inputs.age) === null || _b === void 0 ? void 0 : _b.currentPoints) +
        BMIPoints +
        Number((_c = inputs.waistCircumferenceMale) === null || _c === void 0 ? void 0 : _c.currentPoints) +
        Number((_d = inputs.waistCircumferenceFemale) === null || _d === void 0 ? void 0 : _d.currentPoints) +
        Number((_e = inputs.vegetables) === null || _e === void 0 ? void 0 : _e.currentPoints) +
        Number((_f = inputs.activity) === null || _f === void 0 ? void 0 : _f.currentPoints) +
        Number((_g = inputs.bloodPressureMedications) === null || _g === void 0 ? void 0 : _g.currentPoints) +
        Number((_h = inputs.bloodGlucose) === null || _h === void 0 ? void 0 : _h.currentPoints) +
        Number((_j = inputs.family) === null || _j === void 0 ? void 0 : _j.currentPoints));
};
var calculatePoints = function () {
    var _a;
    if (answeredAll()) {
        var qID = helpers_1.inLimits(points(), 0, 6)
            ? 'lowRisk'
            : helpers_1.inLimits(points(), 7, 11)
                ? 'slightlyElevatedRisk'
                : helpers_1.inLimits(points(), 12, 14)
                    ? 'moderateRisk'
                    : helpers_1.inLimits(points(), 15, 20)
                        ? 'highRisk'
                        : 'veryHighRisk';
        return _a = {},
            _a[qID] = {
                qID: qID,
                tParams: __spreadArrays(helpers_1.returnNumberObject(points(), 0, 0)),
                titleTexts: 'result1'
            },
            _a;
    }
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.waistCircumferenceMale = helpers_1.answerMatches(inputs.sex, 'male');
    visibleQuestions.waistCircumferenceFemale = helpers_1.answerMatches(inputs.sex, 'female');
    visibleQuestions.lowRisk = answeredAll() && helpers_1.inLimits(points(), 0, 6);
    visibleQuestions.slightlyElevatedRisk =
        answeredAll() && helpers_1.inLimits(points(), 7, 11);
    visibleQuestions.moderateRisk = answeredAll() && helpers_1.inLimits(points(), 12, 14);
    visibleQuestions.highRisk = answeredAll() && helpers_1.inLimits(points(), 15, 20);
    visibleQuestions.veryHighRisk = answeredAll() && helpers_1.inLimits(points(), 21);
    visibleQuestions.noAnswerText = !answeredAll();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.inputSection = true;
    visibleSections.results = answeredAll();
    visibleSections.noAnswerSection = !answeredAll();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return answeredAll();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
