"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};


var visibleQuestions = {
    age: true,
    vaccinationScheme: true,
    firstVaccination: false,
    timelineStart: false,
    timelineMonth: false,
    timelineYear: false,
    timelineFourYears: false,
    timelineNineYears: false,
    timelineFourteenYears: false,
    timelineEveryFiveYears: false,
    sendMail: false,
    answerAll: true
};
var visibleSections = {
    vaccinationInfo: true,
    scheme: false,
    share: false,
    answerAllSection: true
};
var inputs = {
    age: null,
    vaccinationScheme: null,
    firstVaccination: null
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var calculatePoints = function () {
    var resultResponse = {
        number: null,
        range: null
    };
    if (!helpers_1.isAnswered(inputs.age) ||
        inputs.age.currentPoints < 0 ||
        inputs.age.currentPoints > 99) {
        visibleSections.scheme = false;
        visibleQuestions = __assign(__assign({}, visibleQuestions), { firstVaccination: false, timelineStart: false, timelineMonth: false, timelineYear: false, timelineFourYears: false, timelineNineYears: false, timelineFourteenYears: false, timelineEveryFiveYears: false, answerAll: true });
        return resultResponse;
    }
    visibleSections.scheme = true;
    visibleQuestions = __assign(__assign({}, visibleQuestions), { firstVaccination: true, timelineStart: true, timelineMonth: true, timelineYear: true, timelineFourYears: true, timelineNineYears: true, timelineFourteenYears: true, timelineEveryFiveYears: true, answerAll: false });
    if (inputs.firstVaccination.currentDate === null) {
        return resultResponse;
    }
    resultResponse.timelineStart = {
        qID: "timelineStart",
        date: helpers_1.addMonthsToDate(inputs.firstVaccination.currentDate, 0),
        age: Number(inputs.age.currentPoints) || 0
    };
    resultResponse.timelineStart = __assign(__assign({}, resultResponse.timelineStart), { tParams: [
            {
                type: "date",
                value: resultResponse.timelineStart.date
            },
            {
                name: "age",
                type: "number",
                value: resultResponse.timelineStart.age
            },
        ], titleTexts: "regular", resultTexts: "first" });
    if (!inputs.vaccinationScheme.currentPoints) {
        resultResponse.timelineMonth = {
            qID: "timelineMonth",
            date: helpers_1.addMonthsToDate(resultResponse.timelineStart.date, 1),
            age: Number(resultResponse.timelineStart.age)
        };
        resultResponse.timelineMonth = __assign(__assign({}, resultResponse.timelineMonth), { tParams: [
                {
                    type: "date",
                    value: resultResponse.timelineMonth.date
                },
                {
                    name: "age",
                    type: "number",
                    value: resultResponse.timelineMonth.age
                },
            ], titleTexts: "regular", resultTexts: "second" });
    }
    else {
        resultResponse.timelineMonth = {
            qID: "timelineMonth",
            date: helpers_1.addDaysToDate(resultResponse.timelineStart.date, 14),
            age: Number(resultResponse.timelineStart.age)
        };
        resultResponse.timelineMonth = __assign(__assign({}, resultResponse.timelineMonth), { tParams: [
                {
                    type: "date",
                    value: resultResponse.timelineMonth.date
                },
                {
                    name: "age",
                    type: "number",
                    value: resultResponse.timelineMonth.age
                },
            ], titleTexts: "regular", resultTexts: "second" });
    }
    resultResponse.timelineYear = {
        qID: "timelineYear",
        date: helpers_1.addMonthsToDate(resultResponse.timelineMonth.date, 12),
        age: Number(resultResponse.timelineMonth.age) + 1
    };
    resultResponse.timelineYear = __assign(__assign({}, resultResponse.timelineYear), { tParams: [
            {
                type: "date",
                value: resultResponse.timelineYear.date
            },
            {
                name: "age",
                type: "number",
                value: resultResponse.timelineYear.age
            },
        ], titleTexts: "regular", resultTexts: "third" });
    resultResponse.timelineFourYears = {
        qID: "timelineFourYears",
        date: helpers_1.addMonthsToDate(resultResponse.timelineYear.date, 12 * 3),
        age: Number(resultResponse.timelineYear.age) + 3
    };
    resultResponse.timelineFourYears = __assign(__assign({}, resultResponse.timelineFourYears), { tParams: [
            {
                type: "date",
                value: resultResponse.timelineFourYears.date
            },
            {
                name: "age",
                type: "number",
                value: resultResponse.timelineFourYears.age
            },
        ], titleTexts: "regular", resultTexts: "firstBooster" });
    if (resultResponse.timelineFourYears.age + 3 > 60) {
        resultResponse.timelineNineYears = {
            qID: "timelineNineYears",
            date: helpers_1.addMonthsToDate(resultResponse.timelineFourYears.date, 12 * 3),
            age: Number(resultResponse.timelineFourYears.age) + 3
        };
        resultResponse.timelineNineYears = __assign(__assign({}, resultResponse.timelineNineYears), { tParams: [
                {
                    type: "date",
                    value: resultResponse.timelineNineYears.date
                },
                {
                    name: "age",
                    type: "number",
                    value: resultResponse.timelineNineYears.age
                },
            ], titleTexts: "regular", resultTexts: "secondBooster" });
    }
    else {
        resultResponse.timelineNineYears = {
            qID: "timelineNineYears",
            date: helpers_1.addMonthsToDate(resultResponse.timelineFourYears.date, 12 * 5),
            age: Number(resultResponse.timelineFourYears.age) + 5
        };
        resultResponse.timelineNineYears = __assign(__assign({}, resultResponse.timelineNineYears), { tParams: [
                {
                    type: "date",
                    value: resultResponse.timelineNineYears.date
                },
                {
                    name: "age",
                    type: "number",
                    value: resultResponse.timelineNineYears.age
                },
            ], titleTexts: "regular", resultTexts: "secondBooster" });
    }
    if (resultResponse.timelineNineYears.age + 3 > 60) {
        resultResponse.timelineFourteenYears = {
            qID: "timelineFourteenYears",
            date: helpers_1.addMonthsToDate(resultResponse.timelineNineYears.date, 12 * 3),
            age: Number(resultResponse.timelineNineYears.age) + 3
        };
        resultResponse.timelineFourteenYears = __assign(__assign({}, resultResponse.timelineFourteenYears), { tParams: [
                {
                    type: "date",
                    value: resultResponse.timelineFourteenYears.date
                },
                {
                    name: "age",
                    type: "number",
                    value: resultResponse.timelineFourteenYears.age
                },
            ], titleTexts: "regular", resultTexts: "thirdBooster" });
    }
    else {
        resultResponse.timelineFourteenYears = {
            qID: "timelineFourteenYears",
            date: helpers_1.addMonthsToDate(resultResponse.timelineNineYears.date, 12 * 5),
            age: Number(resultResponse.timelineNineYears.age) + 5
        };
        resultResponse.timelineFourteenYears = __assign(__assign({}, resultResponse.timelineFourteenYears), { tParams: [
                {
                    type: "date",
                    value: resultResponse.timelineFourteenYears.date
                },
                {
                    name: "age",
                    type: "number",
                    value: resultResponse.timelineFourteenYears.age
                },
            ], titleTexts: "regular", resultTexts: "thirdBooster" });
    }
    if (resultResponse.timelineFourteenYears.age + 3 > 60 ||
        resultResponse.timelineFourteenYears.age + 5 > 60) {
        resultResponse.timelineEveryFiveYears = {
            qID: "timelineEveryFiveYears",
            tParams: [],
            titleTexts: "regularOld",
            resultTexts: "consecutive"
        };
    }
    else {
        resultResponse.timelineEveryFiveYears = {
            qID: "timelineEveryFiveYears",
            tParams: [],
            titleTexts: "regular",
            resultTexts: "consecutive"
        };
    }
    return resultResponse;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    return {
        result: calculatePoints(),
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
