"use strict";


var visibleQuestions = {
    age: true,
    no: true,
    kidsDose1: true,
    necessity1: true,
    adolescentsDoseTbl1: true,
    duration1: true,
    adultDoseTbl1: true,
    duration2: true,
    kidney: true,
    anti: true
};
var visibleSections = {
    ageSelection: true,
    noAnswer: false,
    kidsDose: false,
    necessity: false,
    adolescentsDoseTbl: false,
    adultDoseTbl: false,
    warningKidney: false,
    warningAb: false
};
var inputs = {
    age: null
};
var areAllVisibleQuesionsAnswered = function () {
    return helpers_1.isAnswered(inputs.age);
};
var isAdolescentOrAdult = function () {
    return (helpers_1.answerMatches(inputs.age, 'adolecents') ||
        helpers_1.answerMatches(inputs.age, 'adult'));
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = !areAllVisibleQuesionsAnswered();
    visibleSections.kidsDose = helpers_1.answerMatches(inputs.age, 'kids');
    visibleSections.necessity = helpers_1.answerMatches(inputs.age, 'adolecents');
    visibleSections.adolescentsDoseTbl = helpers_1.answerMatches(inputs.age, 'adolecents');
    visibleSections.adultDoseTbl = helpers_1.answerMatches(inputs.age, 'adult');
    visibleSections.warningKidney = isAdolescentOrAdult();
    visibleSections.warningAb = isAdolescentOrAdult();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return areAllVisibleQuesionsAnswered();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
