"use strict";


var visibleQuestions = {
    age: true,
    startDate: false,
    no: true,
    kidsDose1: true,
    day1: true,
    day4: true,
    day7: true,
    dayX: true,
    kidney: true,
    anti: true
};
var visibleSections = {
    ageSelection: true,
    noAnswer: false,
    kidsDose: false,
    adultDoseTbl: false,
    warningKidney: false,
    warningAb: false
};
var inputs = {
    age: null,
    startDate: null
};
var isStartDateVisible = function () {
    return helpers_1.answerMatches(inputs.age, 'adult');
};
var areAllVisibleQuesionsAnswered = function () {
    return (helpers_1.isAnswered(inputs.age) &&
        ((isStartDateVisible() && helpers_1.isAnswered(inputs.startDate)) ||
            !isStartDateVisible()));
};
var isAdultDoseTblSectionVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'adult') &&
        isStartDateVisible() &&
        helpers_1.isAnswered(inputs.startDate));
};
var calculatePoints = function () {
    var _a, _b, _c;
    if (isAdultDoseTblSectionVisible()) {
        return {
            day1: {
                qID: 'day1',
                tParams: [
                    {
                        type: 'date',
                        value: (_a = inputs.startDate) === null || _a === void 0 ? void 0 : _a.currentDate
                    },
                ],
                titleTexts: 'result1',
                resultTexts: 'result1'
            },
            day4: {
                qID: 'day4',
                tParams: [
                    {
                        type: 'date',
                        value: helpers_1.addDaysToDate((_b = inputs.startDate) === null || _b === void 0 ? void 0 : _b.currentDate, 3)
                    },
                ],
                titleTexts: 'result1',
                resultTexts: 'result1'
            },
            day7: {
                qID: 'day7',
                tParams: [
                    {
                        type: 'date',
                        value: helpers_1.addDaysToDate((_c = inputs.startDate) === null || _c === void 0 ? void 0 : _c.currentDate, 6)
                    },
                ],
                titleTexts: 'result1',
                resultTexts: 'result1'
            },
            dayX: {
                qID: 'dayX',
                titleTexts: 'result1',
                resultTexts: 'result1'
            }
        };
    }
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.startDate = isStartDateVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = !areAllVisibleQuesionsAnswered();
    visibleSections.kidsDose = helpers_1.answerMatches(inputs.age, 'kids');
    visibleSections.adultDoseTbl = isAdultDoseTblSectionVisible();
    visibleSections.warningKidney = isAdultDoseTblSectionVisible();
    visibleSections.warningAb = isAdultDoseTblSectionVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return areAllVisibleQuesionsAnswered();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
