"use strict";


var visibleQuestions = {
    coma: true,
    decisionMaking: false,
    impairmentCount: false,
    severeImpairment: false,
    eating: false
};
var visibleSections = {
    section1: true
};
var inputs = {
    coma: null,
    decisionMaking: null,
    impairmentCount: null,
    severeImpairment: null,
    eating: null
};
var getResultId = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    if (((_a = inputs.coma) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "yes" ||
        ((_b = inputs.eating) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "yes") {
        return "result6";
    }
    if (((_c = inputs.eating) === null || _c === void 0 ? void 0 : _c.currentIdentifier) === "no") {
        return "result5";
    }
    if (((_d = inputs.severeImpairment) === null || _d === void 0 ? void 0 : _d.currentIdentifier) === "two") {
        return "result4";
    }
    if (((_e = inputs.severeImpairment) === null || _e === void 0 ? void 0 : _e.currentIdentifier) === "one") {
        return "result3";
    }
    if (((_f = inputs.severeImpairment) === null || _f === void 0 ? void 0 : _f.currentIdentifier) === "zero") {
        return "result2";
    }
    if (((_g = inputs.impairmentCount) === null || _g === void 0 ? void 0 : _g.currentIdentifier) === "one") {
        return "result1";
    }
    if (((_h = inputs.impairmentCount) === null || _h === void 0 ? void 0 : _h.currentIdentifier) === "zero") {
        return "result0";
    }
    return "answerAll";
};
var calculatePoints = function () {
    var currentResultId = getResultId();
    return helpers_1.returnToolScoreObject({ resultById: currentResultId });
};
var isComaAnsweredWithId = function (answerId) {
    var _a;
    return ((_a = inputs.coma) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === answerId;
};
var isDecisionMakingAnsweredWithId = function (answerId) {
    var _a;
    return ((_a = inputs.decisionMaking) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === answerId;
};
var isImpCountAnsweredWithId = function (answerId) {
    var _a;
    return ((_a = inputs.impairmentCount) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === answerId;
};
var returnVisibleQuestions = function () {
    visibleQuestions.decisionMaking = isComaAnsweredWithId("no");
    visibleQuestions.impairmentCount = isDecisionMakingAnsweredWithId("notSeverely");
    visibleQuestions.severeImpairment =
        isImpCountAnsweredWithId("two") || isImpCountAnsweredWithId("three");
    visibleQuestions.eating = isDecisionMakingAnsweredWithId("severely");
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_toolScore = function () {
    return calculatePoints();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
