"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};


var visibleQuestions = {
    coma: true,
    decisionMaking: false,
    shortTermMemory: false,
    understoodByOthers: false,
    eating: false
};
var visibleSections = {
    section1: true
};
var inputs = {
    coma: null,
    decisionMaking: null,
    shortTermMemory: null,
    understoodByOthers: null,
    eating: null
};
var calculatePoints = function () {
    return helpers_1.returnToolScoreObject({
        resultById: getResult()
    });
};
var getResult = function () {
    if (isAnswerAllVisible()) {
        return 'answerAll';
    }
    if (isResult0Visible()) {
        return 'result0';
    }
    if (isResult1Visible()) {
        return 'result1';
    }
    if (isResult2Visible()) {
        return 'result2';
    }
    if (isResult3Visible()) {
        return 'result3';
    }
    if (isResult4Visible()) {
        return 'result4';
    }
    if (isResult5Visible()) {
        return 'result5';
    }
    if (isResult6Visible()) {
        return 'result6';
    }
    return 'answerAll';
};
var calculateImpairementCount = function () {
    var impairementCountResult = 0;
    if (helpers_1.answerMatches(inputs.decisionMaking, 'modifiedIndependent') ||
        helpers_1.answerMatches(inputs.decisionMaking, 'moderatelyImpaired')) {
        impairementCountResult += 1;
    }
    if (helpers_1.answerMatches(inputs.understoodByOthers, 'usuallyUnderstood') ||
        helpers_1.answerMatches(inputs.understoodByOthers, 'sometimesUnderstood') ||
        helpers_1.answerMatches(inputs.understoodByOthers, 'rarelyUnderstood')) {
        impairementCountResult += 1;
    }
    if (helpers_1.answerMatches(inputs.shortTermMemory, 'memoryProblem')) {
        impairementCountResult += 1;
    }
    return impairementCountResult;
};
var calculateSevereImpairementCount = function () {
    var severeImpairementCountResult = 0;
    if (calculateImpairementCount() === 2 || calculateImpairementCount() === 3) {
        if (helpers_1.answerMatches(inputs.decisionMaking, 'moderatelyImpaired')) {
            severeImpairementCountResult += 1;
        }
        if (helpers_1.answerMatches(inputs.understoodByOthers, 'sometimesUnderstood') ||
            helpers_1.answerMatches(inputs.understoodByOthers, 'rarelyUnderstood')) {
            severeImpairementCountResult += 1;
        }
    }
    return severeImpairementCountResult;
};
var isDecisionMakingVisible = function () {
    return helpers_1.answerMatches(inputs.coma, 'no');
};
var isShortTermMemoryVisible = function () {
    return (helpers_1.answerMatches(inputs.decisionMaking, 'independent') ||
        helpers_1.answerMatches(inputs.decisionMaking, 'modifiedIndependent') ||
        helpers_1.answerMatches(inputs.decisionMaking, 'moderatelyImpaired'));
};
var isUnderstoodByOthersVisible = function () {
    return helpers_1.isAnswered(inputs.shortTermMemory);
};
var isEatingVisible = function () {
    return helpers_1.answerMatches(inputs.decisionMaking, 'severelyImpaired');
};
var isAnswerAllVisible = function () {
    return ((helpers_1.answerMatches(inputs.coma, 'no') && !helpers_1.isAnswered(inputs.decisionMaking)) ||
        (isShortTermMemoryVisible() && !helpers_1.isAnswered(inputs.shortTermMemory)) ||
        (isUnderstoodByOthersVisible() && !helpers_1.isAnswered(inputs.understoodByOthers)) ||
        (isEatingVisible() && !helpers_1.isAnswered(inputs.eating)) ||
        !helpers_1.isAnswered(inputs.coma));
};
var isResult0Visible = function () {
    return (isShortTermMemoryVisible() &&
        calculateImpairementCount() === 0 &&
        helpers_1.answerMatches(inputs.coma, 'no') &&
        !isAnswerAllVisible());
};
var isResult1Visible = function () {
    return calculateImpairementCount() === 1 && !isAnswerAllVisible();
};
var isResult2Visible = function () {
    return ((calculateImpairementCount() === 2 &&
        calculateSevereImpairementCount() === 0) ||
        (calculateImpairementCount() === 3 &&
            calculateSevereImpairementCount() === 0));
};
var isResult3Visible = function () {
    return ((calculateImpairementCount() === 2 &&
        calculateSevereImpairementCount() === 1) ||
        (calculateImpairementCount() === 3 &&
            calculateSevereImpairementCount() === 1));
};
var isResult4Visible = function () {
    return ((calculateImpairementCount() === 2 &&
        calculateSevereImpairementCount() === 2) ||
        (calculateImpairementCount() === 3 &&
            calculateSevereImpairementCount() === 2));
};
var isResult5Visible = function () {
    return (helpers_1.answerMatches(inputs.eating, 'independent') ||
        helpers_1.answerMatches(inputs.eating, 'supervision') ||
        helpers_1.answerMatches(inputs.eating, 'limitedAssistance') ||
        helpers_1.answerMatches(inputs.eating, 'extensiveAssistance'));
};
var isResult6Visible = function () {
    return (helpers_1.answerMatches(inputs.coma, 'yes') ||
        helpers_1.answerMatches(inputs.eating, 'totalDependence'));
};
var returnVisibleQuestions = function () {
    visibleQuestions.decisionMaking = isDecisionMakingVisible();
    visibleQuestions.shortTermMemory = isShortTermMemoryVisible();
    visibleQuestions.understoodByOthers = isUnderstoodByOthersVisible();
    visibleQuestions.eating = isEatingVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_toolScore = function () {
    return calculatePoints();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return !isAnswerAllVisible();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return __assign(__assign({ exportResultsEnabled: isExportResultsEnabled() }, result), { visibleQuestions: ut_visibleQuestions(), visibleSections: ut_visibleSections() });
});
