"use strict";


var visibleQuestions = {
    corridorWalk: true,
    bmi: false,
    age: false,
    wandering: false,
    previousFall: false,
    previousFracture: false,
    cps: false,
    fall: false,
    transfer: false,
    answerAll: false,
    level3a: false,
    level4a: false,
    level5a: false,
    level7a: false,
    level8: false,
    level3b: false,
    level4b: false,
    level5b: false,
    level6: false,
    level7b: false,
    level1: false,
    level2: false,
    level4c: false
};
var visibleSections = {
    section1: true,
    resultRange1: false,
    resultRange2: false,
    resultRange3: false,
    resultRange4: false
};
var inputs = {
    corridorWalk: null,
    bmi: null,
    age: null,
    wandering: null,
    previousFall: null,
    previousFracture: null,
    cps: null,
    fall: null,
    transfer: null
};
var calculatePoints = function () {
    return null;
};
var isBMIVisible = function () {
    return (helpers_1.answerMatches(inputs.corridorWalk, 'zero') ||
        helpers_1.answerMatches(inputs.corridorWalk, 'one') ||
        helpers_1.answerMatches(inputs.corridorWalk, 'two') ||
        helpers_1.answerMatches(inputs.corridorWalk, 'three'));
};
var isWanderingVisible = function () {
    return ((helpers_1.answerMatches(inputs.corridorWalk, 'zero') &&
        helpers_1.answerMatches(inputs.bmi, 'between')) ||
        helpers_1.answerMatches(inputs.age, 'no'));
};
var isPreviousFallVisible = function () {
    return ((helpers_1.answerMatches(inputs.corridorWalk, 'zero') &&
        helpers_1.answerMatches(inputs.bmi, 'less18')) ||
        (helpers_1.answerMatches(inputs.corridorWalk, 'zero') &&
            helpers_1.answerMatches(inputs.bmi, 'between') &&
            helpers_1.answerMatches(inputs.wandering, 'zero')) ||
        (helpers_1.answerMatches(inputs.corridorWalk, 'zero') &&
            helpers_1.answerMatches(inputs.bmi, 'between') &&
            helpers_1.answerMatches(inputs.wandering, 'one')));
};
var isPreviousFractureVisible = function () {
    return ((helpers_1.answerMatches(inputs.corridorWalk, 'zero') &&
        helpers_1.answerMatches(inputs.bmi, 'between') &&
        helpers_1.answerMatches(inputs.wandering, 'zero') &&
        helpers_1.answerMatches(inputs.previousFall, 'no')) ||
        (helpers_1.answerMatches(inputs.corridorWalk, 'zero') &&
            helpers_1.answerMatches(inputs.bmi, 'between') &&
            helpers_1.answerMatches(inputs.wandering, 'one') &&
            helpers_1.answerMatches(inputs.previousFall, 'no')));
};
var isCPSVisible = function () {
    return ((helpers_1.answerMatches(inputs.corridorWalk, 'zero') &&
        helpers_1.answerMatches(inputs.bmi, 'between') &&
        helpers_1.answerMatches(inputs.wandering, 'zero') &&
        helpers_1.answerMatches(inputs.previousFall, 'yes')) ||
        (helpers_1.answerMatches(inputs.corridorWalk, 'zero') &&
            helpers_1.answerMatches(inputs.bmi, 'between') &&
            helpers_1.answerMatches(inputs.wandering, 'one') &&
            helpers_1.answerMatches(inputs.previousFall, 'yes')) ||
        helpers_1.answerMatches(inputs.age, 'yes'));
};
var isCPSAnswered = function () {
    return helpers_1.isAnswered(inputs.cps) && !helpers_1.answerMatches(inputs.cps, 'answerAll');
};
var isAgeVisible = function () {
    return ((helpers_1.answerMatches(inputs.corridorWalk, 'one') &&
        helpers_1.answerMatches(inputs.bmi, 'between')) ||
        (helpers_1.answerMatches(inputs.corridorWalk, 'two') &&
            helpers_1.answerMatches(inputs.bmi, 'between')) ||
        (helpers_1.answerMatches(inputs.corridorWalk, 'three') &&
            helpers_1.answerMatches(inputs.bmi, 'between')));
};
var isFallVisible = function () {
    return (helpers_1.answerMatches(inputs.corridorWalk, 'four') ||
        helpers_1.answerMatches(inputs.corridorWalk, 'eight'));
};
var isLevel3aVisible = function () {
    return (helpers_1.answerMatches(inputs.previousFracture, 'no') ||
        helpers_1.answerMatches(inputs.bmi, 'more30'));
};
var isLevel4aVisible = function () {
    return helpers_1.answerMatches(inputs.cps, 'result0');
};
var isLevel5aVisible = function () {
    return ((helpers_1.answerMatches(inputs.bmi, 'between') &&
        helpers_1.answerMatches(inputs.wandering, 'two')) ||
        (helpers_1.answerMatches(inputs.bmi, 'between') &&
            helpers_1.answerMatches(inputs.wandering, 'three')) ||
        helpers_1.answerMatches(inputs.previousFracture, 'yes') ||
        helpers_1.answerMatches(inputs.cps, 'result1') ||
        helpers_1.answerMatches(inputs.cps, 'result2') ||
        helpers_1.answerMatches(inputs.cps, 'result3') ||
        helpers_1.answerMatches(inputs.cps, 'result4') ||
        helpers_1.answerMatches(inputs.cps, 'result5') ||
        helpers_1.answerMatches(inputs.cps, 'result6'));
};
var isTransferVisible = function () {
    return helpers_1.answerMatches(inputs.fall, 'no');
};
var isLevel7aVisible = function () {
    return (helpers_1.answerMatches(inputs.bmi, 'less18') &&
        helpers_1.answerMatches(inputs.previousFall, 'no'));
};
var isLevel8Visible = function () {
    return (helpers_1.answerMatches(inputs.bmi, 'less18') &&
        helpers_1.answerMatches(inputs.previousFall, 'yes'));
};
var isLevel3bVisible = function () {
    return helpers_1.answerMatches(inputs.bmi, 'more30');
};
var isLevel4bVisible = function () {
    var condition1 = helpers_1.answerMatches(inputs.bmi, 'between') &&
        helpers_1.answerMatches(inputs.age, 'no') &&
        helpers_1.answerMatches(inputs.wandering, 'zero');
    var condition2 = helpers_1.answerMatches(inputs.bmi, 'between') &&
        helpers_1.answerMatches(inputs.age, 'no') &&
        helpers_1.answerMatches(inputs.wandering, 'one');
    var condition3 = helpers_1.answerMatches(inputs.bmi, 'between') &&
        helpers_1.answerMatches(inputs.age, 'no') &&
        helpers_1.answerMatches(inputs.wandering, 'two');
    return condition1 || condition2 || condition3;
};
var isLevel5bVisible = function () {
    return (helpers_1.answerMatches(inputs.cps, 'result0') ||
        helpers_1.answerMatches(inputs.cps, 'result1') ||
        helpers_1.answerMatches(inputs.cps, 'result2'));
};
var isLevel6Visible = function () {
    return (helpers_1.answerMatches(inputs.bmi, 'between') &&
        helpers_1.answerMatches(inputs.age, 'no') &&
        helpers_1.answerMatches(inputs.wandering, 'three'));
};
var isLevel7bVisible = function () {
    return (helpers_1.answerMatches(inputs.bmi, 'less18') ||
        helpers_1.answerMatches(inputs.cps, 'result3') ||
        helpers_1.answerMatches(inputs.cps, 'result4') ||
        helpers_1.answerMatches(inputs.cps, 'result4') ||
        helpers_1.answerMatches(inputs.cps, 'result5') ||
        helpers_1.answerMatches(inputs.cps, 'result6'));
};
var isLevel1Visible = function () {
    return ((helpers_1.answerMatches(inputs.fall, 'no') &&
        helpers_1.answerMatches(inputs.transfer, 'four')) ||
        (helpers_1.answerMatches(inputs.fall, 'no') &&
            helpers_1.answerMatches(inputs.transfer, 'eight')));
};
var isLevel2Visible = function () {
    return ((helpers_1.answerMatches(inputs.fall, 'no') &&
        helpers_1.answerMatches(inputs.transfer, 'null')) ||
        (helpers_1.answerMatches(inputs.fall, 'no') &&
            helpers_1.answerMatches(inputs.transfer, 'one')) ||
        (helpers_1.answerMatches(inputs.fall, 'no') &&
            helpers_1.answerMatches(inputs.transfer, 'two')) ||
        (helpers_1.answerMatches(inputs.fall, 'no') &&
            helpers_1.answerMatches(inputs.transfer, 'three')));
};
var isLevel4cVisible = function () {
    return helpers_1.answerMatches(inputs.fall, 'yes');
};
var isResultRange1Visible = function () {
    return (!helpers_1.isAnswered(inputs.corridorWalk) ||
        (isBMIVisible() && !helpers_1.isAnswered(inputs.bmi)) ||
        (isAgeVisible() && !helpers_1.isAnswered(inputs.age)) ||
        (isWanderingVisible() && !helpers_1.isAnswered(inputs.wandering)) ||
        (isPreviousFallVisible() && !helpers_1.isAnswered(inputs.previousFall)) ||
        (isPreviousFractureVisible() && !helpers_1.isAnswered(inputs.previousFracture)) ||
        (isCPSVisible() && !isCPSAnswered()) ||
        (isFallVisible() && !helpers_1.isAnswered(inputs.fall)) ||
        (isTransferVisible() && !helpers_1.isAnswered(inputs.transfer)));
};
var isResultRange2Visible = function () {
    return !isResultRange1Visible() && helpers_1.answerMatches(inputs.corridorWalk, 'zero');
};
var isResultRange3Visible = function () {
    return ((!isResultRange1Visible() && helpers_1.answerMatches(inputs.corridorWalk, 'one')) ||
        (!isResultRange1Visible() && helpers_1.answerMatches(inputs.corridorWalk, 'two')) ||
        (!isResultRange1Visible() && helpers_1.answerMatches(inputs.corridorWalk, 'three')));
};
var isResultRange4Visible = function () {
    return ((!isResultRange1Visible() && helpers_1.answerMatches(inputs.corridorWalk, 'four')) ||
        (!isResultRange1Visible() && helpers_1.answerMatches(inputs.corridorWalk, 'eight')));
};
var returnVisibleQuestions = function () {
    visibleQuestions.bmi = isBMIVisible();
    visibleQuestions.age = isAgeVisible();
    visibleQuestions.wandering = isWanderingVisible();
    visibleQuestions.previousFall = isPreviousFallVisible();
    visibleQuestions.previousFracture = isPreviousFractureVisible();
    visibleQuestions.cps = isCPSVisible();
    visibleQuestions.fall = isFallVisible();
    visibleQuestions.transfer = isTransferVisible();
    visibleQuestions.answerAll = isResultRange1Visible();
    visibleQuestions.level3a = isLevel3aVisible() && isResultRange2Visible();
    visibleQuestions.level4a = isLevel4aVisible() && isResultRange2Visible();
    visibleQuestions.level5a = isLevel5aVisible() && isResultRange2Visible();
    visibleQuestions.level7a = isLevel7aVisible() && isResultRange2Visible();
    visibleQuestions.level8 = isLevel8Visible() && isResultRange2Visible();
    visibleQuestions.level3b = isLevel3bVisible() && isResultRange3Visible();
    visibleQuestions.level4b = isLevel4bVisible() && isResultRange3Visible();
    visibleQuestions.level5b = isLevel5bVisible() && isResultRange3Visible();
    visibleQuestions.level6 = isLevel6Visible() && isResultRange3Visible();
    visibleQuestions.level7b = isLevel7bVisible() && isResultRange3Visible();
    visibleQuestions.level1 = isLevel1Visible() && isResultRange4Visible();
    visibleQuestions.level2 = isLevel2Visible() && isResultRange4Visible();
    visibleQuestions.level4c = isLevel4cVisible() && isResultRange4Visible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.resultRange1 = isResultRange1Visible();
    visibleSections.resultRange2 = isResultRange2Visible();
    visibleSections.resultRange3 = isResultRange3Visible();
    visibleSections.resultRange4 = isResultRange4Visible();
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return !isResultRange1Visible();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});