"use strict";


var visibleQuestions = {
    age: true,
    weight: false,
    noAnswerWarning: true,
    contraindicationKids: false,
    adultsLowWeightDose: false,
    adultsLowWeightDuration: false,
    warningOld: false,
    adultsHighWeightDose: false,
    adultsHighWeightDuration: false,
    warningOld2: false,
    warning: false,
    infoKidneyFunction: false,
    infoKidney: false,
    mildKidney: false,
    moderateKidney: false,
    severeKidner: false,
    infoAdministration: false,
    info: false
};
var visibleSections = {
    inputQuestions: true,
    noAnswer: true,
    kidsResult: false,
    adultsLowWeight: false,
    adultsHighWeight: false,
    warningPlatlets: false,
    kidneyFunction: false,
    administering: false
};
var inputs = {
    age: null,
    weight: null,
    infoKidneyFunction: null,
    infoAdministration: null
};
var calculatePoints = function () {
    return null;
};
var isAgeKids = function () {
    return helpers_1.answerMatches(inputs.age, 'kids');
};
var isAgeAdults = function () {
    return helpers_1.answerMatches(inputs.age, 'adults');
};
var isLowWeight = function () {
    return isAgeAdults() && helpers_1.answerMatches(inputs.weight, 'lowWeight');
};
var isHightWeight = function () {
    return isAgeAdults() && helpers_1.answerMatches(inputs.weight, 'highWeight');
};
var isOnlyAdults = function () {
    return isAgeAdults() && helpers_1.isAnswered(inputs.weight);
};
var isInfoKidneyFunction = function () {
    return isOnlyAdults() && helpers_1.answerMatches(inputs.infoKidneyFunction, 'close');
};
var isInfoAdministrationFunction = function () {
    return isOnlyAdults() && helpers_1.answerMatches(inputs.infoAdministration, 'close');
};
var isAnswerallVisible = function () {
    return !(isAgeKids() || (isAgeAdults() && helpers_1.isAnswered(inputs.weight)));
};
var returnVisibleQuestions = function () {
    visibleQuestions.weight = isAgeAdults();
    visibleQuestions.noAnswerWarning = isAnswerallVisible();
    visibleQuestions.contraindicationKids = isAgeKids();
    visibleQuestions.adultsLowWeightDose = isLowWeight();
    visibleQuestions.adultsLowWeightDuration = isLowWeight();
    visibleQuestions.warningOld = isLowWeight();
    visibleQuestions.adultsHighWeightDose = isHightWeight();
    visibleQuestions.adultsHighWeightDuration = isHightWeight();
    visibleQuestions.warningOld2 = isHightWeight();
    visibleQuestions.warning = isOnlyAdults();
    visibleQuestions.infoKidneyFunction = isOnlyAdults();
    visibleQuestions.infoKidney = isInfoKidneyFunction();
    visibleQuestions.mildKidney = isInfoKidneyFunction();
    visibleQuestions.moderateKidney = isInfoKidneyFunction();
    visibleQuestions.severeKidner = isInfoKidneyFunction();
    visibleQuestions.infoAdministration = isOnlyAdults();
    visibleQuestions.info = isInfoAdministrationFunction();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = isAnswerallVisible();
    visibleSections.kidsResult = isAgeKids();
    visibleSections.adultsLowWeight = isLowWeight();
    visibleSections.adultsHighWeight = isHightWeight();
    visibleSections.warningPlatlets = isOnlyAdults();
    visibleSections.kidneyFunction = isOnlyAdults();
    visibleSections.administering = isOnlyAdults();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return !isAnswerallVisible();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
