"use strict";


var visibleQuestions = {
    age: true,
    weight: false,
    noAnswerResult: true,
    contraindicationKids: false,
    adultsLowDose: false,
    adultsLowWarning: false,
    adultsMiddleDose: false,
    adultsMiddleWarning: false,
    adultsHighDose: false,
    adultsHighWarning: false,
    warning: false,
    infoAdministration: false,
    info: false,
};
var visibleSections = {
    inputQuestions: true,
    noAnswer: true,
    kidsResult: false,
    adultsLow: false,
    adultsMiddle: false,
    adultsHigh: false,
    warningPlatlets: false,
    administering: false,
};
var inputs = {
    age: null,
    weight: null,
    infoAdministration: null
};
var calculatePoints = function () {
    return null;
};
var isAgeKids = function () {
    return helpers_1.answerMatches(inputs.age, 'kids');
};
var isAgeAdults = function () {
    return helpers_1.answerMatches(inputs.age, 'adults');
};
var isOnlyAdults = function () {
    return isAgeAdults() && helpers_1.isAnswered(inputs.weight);
};
var isWeightMatching = function (weight) {
    return isAgeAdults() && helpers_1.answerMatches(inputs.weight, weight);
};
var isInfoAdministrationFunction = function () {
    return isOnlyAdults() && helpers_1.answerMatches(inputs.infoAdministration, 'close');
};
var isAnswerallVisible = function () {
    return !(isAgeKids() || isOnlyAdults());
};
var returnVisibleQuestions = function () {
    visibleQuestions.weight = isAgeAdults();
    visibleQuestions.noAnswerResult = isAnswerallVisible();
    visibleQuestions.contraindicationKids = isAgeKids();
    visibleQuestions.adultsLowDose = isWeightMatching('lowWeight');
    visibleQuestions.adultsLowWarning = isWeightMatching('lowWeight');
    visibleQuestions.adultsMiddleDose = isWeightMatching('middleWeight');
    visibleQuestions.adultsMiddleWarning = isWeightMatching('middleWeight');
    visibleQuestions.adultsHighDose = isWeightMatching('highWeight');
    visibleQuestions.adultsHighWarning = isWeightMatching('highWeight');
    visibleQuestions.warning = isOnlyAdults();
    visibleQuestions.infoAdministration = isOnlyAdults();
    visibleQuestions.info = isInfoAdministrationFunction();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = isAnswerallVisible();
    visibleSections.kidsResult = isAgeKids();
    visibleSections.adultsLow = isWeightMatching('lowWeight');
    visibleSections.adultsMiddle = isWeightMatching('middleWeight');
    visibleSections.adultsHigh = isWeightMatching('highWeight');
    visibleSections.warningPlatlets = isOnlyAdults();
    visibleSections.administering = isOnlyAdults();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return !isAnswerallVisible();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
