"use strict";


var visibleQuestions = {
    age: true,
    operation: false,
    weight: false,
    noAnswerResult: true,
    contraindicationKids: false,
    adultsNoOperationDose: false,
    adultsNoOperationDuration: false,
    adultsYesOperationDoseLowWeight: false,
    adultsYesOperationDose2LowWeight: false,
    adultsYesOperationDurationLowWeight: false,
    adultsYesOperationDoseMiddleWeight: false,
    adultsYesOperationDose2MiddleWeight: false,
    adultsYesOperationDurationMiddleWeight: false,
    adultsYesOperationDoseHighWeight: false,
    adultsYesOperationDose2HighWeight: false,
    adultsYesOperationDurationHighWeight: false,
    warning: false,
    infoKidneyFunction: false,
    infoKidney: false,
    mildKidney: false,
    moderateKidney: false,
    severeKidney: false,
    infoAdministration: false,
    info: false
};
var visibleSections = {
    inputQuestions: true,
    noAnswer: true,
    kidsResult: false,
    adultsNoOperation: false,
    adultsYesOperationLowWeight: false,
    adultsYesOperationMiddleWeight: false,
    adultsYesOperationHighWeight: false,
    warningPlatlets: false,
    kidneyFunction: false,
    administering: false
};
var inputs = {
    age: null,
    operation: null,
    weight: null,
    infoKidneyFunction: null,
    infoAdministration: null
};
var calculatePoints = function () {
    return null;
};
var isAgeKids = function () {
    return helpers_1.answerMatches(inputs.age, 'kids');
};
var isAgeAdults = function () {
    return helpers_1.answerMatches(inputs.age, 'adults');
};
var isAgeAdultsOperationNo = function () {
    return isAgeAdults() && helpers_1.answerMatches(inputs.operation, 'no');
};
var isAgeAdultsOperationYes = function () {
    return isAgeAdults() && helpers_1.answerMatches(inputs.operation, 'yes');
};
var isLowWeight = function () {
    return isAgeAdultsOperationYes() && helpers_1.answerMatches(inputs.weight, 'lowWeight');
};
var isMiddleWeight = function () {
    return (isAgeAdultsOperationYes() && helpers_1.answerMatches(inputs.weight, 'middleWeight'));
};
var isHeightWeight = function () {
    return (isAgeAdultsOperationYes() && helpers_1.answerMatches(inputs.weight, 'highWeight'));
};
var isOnlyAdults = function () {
    return isAgeAdults() && !isAnswerallVisible();
};
var isInfoKidneyFunction = function () {
    return isOnlyAdults() && helpers_1.answerMatches(inputs.infoKidneyFunction, 'close');
};
var isInfoAdministrationFunction = function () {
    return isOnlyAdults() && helpers_1.answerMatches(inputs.infoAdministration, 'close');
};
var isAnswerallVisible = function () {
    return !(isAgeKids() ||
        (isAgeAdults() &&
            helpers_1.answerMatches(inputs.operation, 'yes') &&
            helpers_1.isAnswered(inputs.weight)) ||
        (isAgeAdults() && helpers_1.answerMatches(inputs.operation, 'no')));
};
var returnVisibleQuestions = function () {
    visibleQuestions.operation = isAgeAdults();
    visibleQuestions.weight =
        isAgeAdults() && helpers_1.answerMatches(inputs.operation, 'yes');
    visibleQuestions.noAnswerResult = isAnswerallVisible();
    visibleQuestions.contraindicationKids = isAgeKids();
    visibleQuestions.adultsNoOperationDose = isAgeAdultsOperationNo();
    visibleQuestions.adultsNoOperationDuration = isAgeAdultsOperationNo();
    visibleQuestions.adultsYesOperationDoseLowWeight = isLowWeight();
    visibleQuestions.adultsYesOperationDose2LowWeight = isLowWeight();
    visibleQuestions.adultsYesOperationDurationLowWeight = isLowWeight();
    visibleQuestions.adultsYesOperationDoseMiddleWeight = isMiddleWeight();
    visibleQuestions.adultsYesOperationDose2MiddleWeight = isMiddleWeight();
    visibleQuestions.adultsYesOperationDurationMiddleWeight = isMiddleWeight();
    visibleQuestions.adultsYesOperationDoseHighWeight = isHeightWeight();
    visibleQuestions.adultsYesOperationDose2HighWeight = isHeightWeight();
    visibleQuestions.adultsYesOperationDurationHighWeight = isHeightWeight();
    visibleQuestions.warning = isOnlyAdults();
    visibleQuestions.infoKidneyFunction = isOnlyAdults();
    visibleQuestions.infoKidney = isInfoKidneyFunction();
    visibleQuestions.mildKidney = isInfoKidneyFunction();
    visibleQuestions.moderateKidney = isInfoKidneyFunction();
    visibleQuestions.severeKidney = isInfoKidneyFunction();
    visibleQuestions.infoAdministration = isOnlyAdults();
    visibleQuestions.info = isInfoAdministrationFunction();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = isAnswerallVisible();
    visibleSections.kidsResult = isAgeKids();
    visibleSections.adultsNoOperation = isAgeAdultsOperationNo();
    visibleSections.adultsYesOperationLowWeight = isLowWeight();
    visibleSections.adultsYesOperationMiddleWeight = isMiddleWeight();
    visibleSections.adultsYesOperationHighWeight = isHeightWeight();
    visibleSections.warningPlatlets = isOnlyAdults();
    visibleSections.kidneyFunction = isOnlyAdults();
    visibleSections.administering = isOnlyAdults();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return !isAnswerallVisible();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
