"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};

var dictionary = [];


var currentTime = new Date();
var packagesTable = [
    [
        [0.2, 25.0, 4.0],
        [0.25, 20.0, 5.0],
        [0.3, 16.0, 6.0],
        [0.35, 14.0, 7.0],
        [0.4, 12.0, 8.0],
        [0.45, 11.0, 9.0],
        [0.5, 10.0, 10.0],
        [0.55, 9.0, 11.0],
        [0.6, 8.0, 12.0],
        [0.65, 7.0, 12.0],
        [0.7, 7.0, 13.0],
        [0.75, 6.0, 14.0],
        [0.8, 6.0, 15.0],
        [0.85, 5.0, 16.0],
        [0.9, 5.0, 17.0],
        [0.95, 5.0, 18.0],
        [1.0, 5.0, 19.0],
        [1.05, 4.0, 20.0],
        [1.1, 4.0, 21.0],
        [1.15, 4.0, 22.0],
        [1.2, 4.0, 23.0],
        [1.25, 4.0, 23.0],
    ],
    [
        [0.4, 25.0, 4.0],
        [0.5, 20.0, 5.0],
        [0.6, 16.0, 6.0],
        [0.7, 14.0, 7.0],
        [0.8, 12.0, 8.0],
        [0.9, 11.0, 9.0],
        [1.0, 10.0, 10.0],
        [1.1, 9.0, 11.0],
        [1.2, 8.0, 12.0],
        [1.3, 7.0, 12.0],
        [1.4, 7.0, 13.0],
        [1.5, 6.0, 14.0],
        [1.6, 6.0, 15.0],
        [1.7, 5.0, 16.0],
        [1.8, 5.0, 17.0],
        [1.9, 5.0, 18.0],
        [2.0, 5.0, 19.0],
        [2.1, 4.0, 20.0],
        [2.2, 4.0, 21.0],
        [2.3, 4.0, 22.0],
        [2.4, 4.0, 23.0],
        [2.5, 4.0, 23.0],
    ],
    [
        [0.6, 25.0, 4.0],
        [0.7, 21.0, 5.0],
        [0.8, 18.0, 5.0],
        [0.9, 16.0, 6.0],
        [1.0, 15.0, 7.0],
        [1.1, 13.0, 7.0],
        [1.2, 12.0, 8.0],
        [1.3, 11.0, 8.0],
        [1.4, 10.0, 9.0],
        [1.5, 10.0, 10.0],
        [1.6, 9.0, 10.0],
        [1.7, 8.0, 11.0],
        [1.8, 8.0, 12.0],
        [1.9, 7.0, 12.0],
        [2.0, 7.0, 13.0],
        [2.1, 7.0, 13.0],
        [2.2, 7.0, 14.0],
        [2.3, 6.0, 15.0],
        [2.4, 6.0, 15.0],
        [2.5, 6.0, 16.0],
        [2.6, 6.0, 16.0],
        [2.7, 5.0, 17.0],
        [2.8, 5.0, 18.0],
        [2.9, 5.0, 18.0],
        [3.0, 5.0, 19.0],
        [3.1, 4.0, 20.0],
        [3.2, 4.0, 20.0],
        [3.3, 4.0, 21.0],
        [3.4, 4.0, 21.0],
        [3.5, 4.0, 22.0],
        [3.6, 4.0, 23.0],
        [3.7, 4.0, 23.0],
        [3.8, 4.0, 24.0],
        [3.9, 4.0, 24.0],
        [40.0, 4.0, 25.0],
    ],
];
var visibleQuestions = {
    birthDay: true,
    sex: true,
    weight: false,
    height: false,
    centileAndSDBirthSelect: false,
    centileAndSD: false,
    bmi: false,
    birthWeight: false,
    birthLength: false,
    centileAndSDSelect: false,
    centileAndSDBirth: false,
    centileAndSDBirthLength: false,
    motherHeight: false,
    fatherHeight: false,
    averageParentSelect: false,
    averageParentHeight: false,
    averageParentHeightCentile: false,
    priorMeasurementDate: false,
    priorHeightMeasurement: false,
    growthVelocitySelect: false,
    growthVelocity: false,
    growthVelocityNegativeWarning: false,
    growthVelocityWarning: false,
    indication: false,
    indicationSelect: false,
    doseGHD: false,
    doseTS: false,
    doseSGA: false,
    dose: false,
    penLow: false,
    penLowMid: false,
    penMid: false,
    penMidHigh: false,
    penHigh: false,
    penSelect: false,
    packageNr: false
};
var visibleSections = {
    basicInfo: true,
    todaysMeasurement: false,
    birthInformation: false,
    parentHeight: false,
    priorMeasurement: false,
    indicationSection: false,
    penSection: false
};
var inputs = {
    birthDay: null,
    sex: null,
    weight: null,
    height: null,
    birthWeight: null,
    birthLength: null,
    motherHeight: null,
    fatherHeight: null,
    priorMeasurementDate: null,
    priorHeightMeasurement: null,
    indication: null,
    doseGHD: null,
    doseTS: null,
    penLowMid: null,
    penMid: null,
    penMidHigh: null
};
var areBirthDayAndSexAnswered = function () {
    return helpers_1.isAnswered(inputs.birthDay) && helpers_1.isAnswered(inputs.sex);
};
var areWeightAndHeightAnswered = function () {
    return helpers_1.isAnswered(inputs.weight) && helpers_1.isAnswered(inputs.height);
};
var arebBrthWeightAndBirthLengthAnswered = function () {
    return helpers_1.isAnswered(inputs.birthWeight) && helpers_1.isAnswered(inputs.birthLength);
};
var isCentileAndSDBirthSelectVisible = function () {
    return (areWeightAndHeightAnswered() && !arebBrthWeightAndBirthLengthAnswered());
};
var areMotherHeightAndFatherHeightVisible = function () {
    return helpers_1.isAnswered(inputs.motherHeight) && helpers_1.isAnswered(inputs.fatherHeight);
};
var arePriorMeasurementDateAndPriorHeightMeasurementVisible = function () {
    return (helpers_1.isAnswered(inputs.priorMeasurementDate) &&
        helpers_1.isAnswered(inputs.priorHeightMeasurement));
};
var isGrowthVelocityNegativeWarningVisible = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.priorHeightMeasurement) &&
        Number((_a = inputs.height) === null || _a === void 0 ? void 0 : _a.currentPoints) <
            Number((_b = inputs.priorHeightMeasurement) === null || _b === void 0 ? void 0 : _b.currentPoints));
};
var isGrowthVelocityWarningVisible = function () {
    var _a;
    var differenceOfDays = helpers_1.differenceBetweenDates((_a = inputs.birthDay) === null || _a === void 0 ? void 0 : _a.currentDate, currentTime.getTime() / 100, 'months');
    return differenceOfDays <= 0;
};
var isIndicationSelectVisible = function () {
    return !helpers_1.isAnswered(inputs.indication);
};
var isDoseGHDVisible = function () {
    return helpers_1.answerMatches(inputs.indication, 'ghd');
};
var isDoseTSVisible = function () {
    return helpers_1.answerMatches(inputs.indication, 'ts');
};
var isDoseSGAVisible = function () {
    return helpers_1.answerMatches(inputs.indication, 'sga');
};
var areSection6QuestionsAnswered = function () {
    return ((helpers_1.isAnswered(inputs.indication) &&
        helpers_1.answerMatches(inputs.indication, 'ghd') &&
        helpers_1.isAnswered(inputs.doseGHD)) ||
        (helpers_1.isAnswered(inputs.indication) &&
            helpers_1.answerMatches(inputs.indication, 'ts') &&
            helpers_1.isAnswered(inputs.doseTS)) ||
        (helpers_1.isAnswered(inputs.indication) && helpers_1.answerMatches(inputs.indication, 'sga')));
};
var isPenLowVisible = function () {
    var _a;
    var currentDose = (_a = calculateDose()) === null || _a === void 0 ? void 0 : _a.doseResult;
    return currentDose < 0.4;
};
var isPenLowMidVisible = function () {
    var _a;
    var currentDose = (_a = calculateDose()) === null || _a === void 0 ? void 0 : _a.doseResult;
    return currentDose >= 0.4 && currentDose < 0.6;
};
var isPenMidVisible = function () {
    var _a;
    var currentDose = (_a = calculateDose()) === null || _a === void 0 ? void 0 : _a.doseResult;
    return currentDose >= 0.6 && currentDose < 1.25;
};
var isPenMidHighVisible = function () {
    var _a;
    var currentDose = (_a = calculateDose()) === null || _a === void 0 ? void 0 : _a.doseResult;
    return currentDose >= 1.25 && currentDose < 2.5;
};
var isPenHighVisible = function () {
    var _a;
    var currentDose = (_a = calculateDose()) === null || _a === void 0 ? void 0 : _a.doseResult;
    return currentDose >= 2.5;
};
var ispenSelectVisible = function () {
    return ((isPenLowMidVisible() && !helpers_1.isAnswered(inputs.penLowMid)) ||
        (isPenMidVisible() && !helpers_1.isAnswered(inputs.penMid)) ||
        (isPenMidHighVisible() && !helpers_1.isAnswered(inputs.penMidHigh)));
};
var isPackageNrVisible = function () {
    return ((isPenLowMidVisible() && helpers_1.isAnswered(inputs.penLowMid)) ||
        (isPenMidVisible() && helpers_1.isAnswered(inputs.penMid)) ||
        (isPenMidHighVisible() && helpers_1.isAnswered(inputs.penMidHigh)) ||
        isPenLowVisible() ||
        isPenHighVisible());
};
var returnVisibleQuestions = function () {
    visibleQuestions.weight = areBirthDayAndSexAnswered();
    visibleQuestions.height = areBirthDayAndSexAnswered();
    visibleQuestions.centileAndSDBirthSelect =
        !areWeightAndHeightAnswered() && areBirthDayAndSexAnswered();
    visibleQuestions.centileAndSD = areWeightAndHeightAnswered();
    visibleQuestions.bmi = areWeightAndHeightAnswered();
    visibleQuestions.birthWeight = areWeightAndHeightAnswered();
    visibleQuestions.birthLength = areWeightAndHeightAnswered();
    visibleQuestions.centileAndSDSelect = isCentileAndSDBirthSelectVisible();
    visibleQuestions.centileAndSDBirth = arebBrthWeightAndBirthLengthAnswered();
    visibleQuestions.centileAndSDBirthLength =
        arebBrthWeightAndBirthLengthAnswered();
    visibleQuestions.motherHeight = arebBrthWeightAndBirthLengthAnswered();
    visibleQuestions.fatherHeight = arebBrthWeightAndBirthLengthAnswered();
    visibleQuestions.averageParentSelect =
        !areMotherHeightAndFatherHeightVisible() &&
            arebBrthWeightAndBirthLengthAnswered();
    visibleQuestions.averageParentHeight =
        areMotherHeightAndFatherHeightVisible();
    visibleQuestions.averageParentHeightCentile =
        areMotherHeightAndFatherHeightVisible();
    visibleQuestions.priorMeasurementDate =
        areMotherHeightAndFatherHeightVisible();
    visibleQuestions.priorHeightMeasurement =
        areMotherHeightAndFatherHeightVisible();
    visibleQuestions.growthVelocitySelect =
        !arePriorMeasurementDateAndPriorHeightMeasurementVisible() &&
            areMotherHeightAndFatherHeightVisible();
    visibleQuestions.growthVelocity =
        arePriorMeasurementDateAndPriorHeightMeasurementVisible();
    visibleQuestions.growthVelocityNegativeWarning =
        isGrowthVelocityNegativeWarningVisible();
    visibleQuestions.growthVelocityWarning = isGrowthVelocityWarningVisible();
    visibleQuestions.indication =
        arePriorMeasurementDateAndPriorHeightMeasurementVisible();
    visibleQuestions.indicationSelect =
        isIndicationSelectVisible() &&
            arePriorMeasurementDateAndPriorHeightMeasurementVisible();
    visibleQuestions.doseGHD = isDoseGHDVisible();
    visibleQuestions.doseTS = isDoseTSVisible();
    visibleQuestions.doseSGA = isDoseSGAVisible();
    visibleQuestions.dose = areSection6QuestionsAnswered();
    visibleQuestions.penLow = isPenLowVisible();
    visibleQuestions.penLowMid = isPenLowMidVisible();
    visibleQuestions.penMid = isPenMidVisible();
    visibleQuestions.penMidHigh = isPenMidHighVisible();
    visibleQuestions.penHigh = isPenHighVisible();
    visibleQuestions.penSelect = ispenSelectVisible();
    visibleQuestions.packageNr = isPackageNrVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.todaysMeasurement = areBirthDayAndSexAnswered();
    visibleSections.birthInformation = areWeightAndHeightAnswered();
    visibleSections.parentHeight = arebBrthWeightAndBirthLengthAnswered();
    visibleSections.priorMeasurement = areMotherHeightAndFatherHeightVisible();
    visibleSections.indicationSection =
        arePriorMeasurementDateAndPriorHeightMeasurementVisible();
    visibleSections.penSection = areSection6QuestionsAnswered();
    return visibleSections;
};
var calculateZScore = function (input, index) {
    var sexIndex = helpers_1.answerMatches(inputs.sex, 'male') ? 0 : 1;
    var inputData = dictionary[sexIndex][index];
    var ageInMonths = calculateAgeInMonths();
    var resultData = inputData.find(function (item) { return item.months === Math.round(ageInMonths); });
    if (!resultData) {
        return 0;
    }
    return ((Math.pow(input / resultData.median, resultData.power) - 1) /
        (resultData.power * resultData.coefficient));
};
var calculateBirthZScore = function (input, index) {
    var sexIndex = helpers_1.answerMatches(inputs.sex, 'male') ? 0 : 1;
    var inputData = dictionary[sexIndex][index];
    var resultData = inputData.find(function (item) { return item.months === 0; });
    if (!resultData) {
        return 0;
    }
    return ((Math.pow(input / resultData.median, resultData.power) - 1) /
        (resultData.power * resultData.coefficient));
};
var calculateAVGHeightZScore = function (input, index) {
    var sexIndex = helpers_1.answerMatches(inputs.sex, 'male') ? 0 : 1;
    var inputData = dictionary[sexIndex][index];
    var resultData = inputData.find(function (item) { return item.months === 228; });
    if (!resultData) {
        return 0;
    }
    return ((Math.pow(input / resultData.median, resultData.power) - 1) /
        (resultData.power * resultData.coefficient));
};
var calculatePercentile = function (zScore) {
    return 0.5 * (1 + math_1.erf(zScore / Math.sqrt(2.0))) * 100;
};
var calculateAgeInMonths = function () {
    return helpers_1.differenceBetweenMonths(helpers_1.unixToDate(Number(inputs.birthDay.currentDate)), currentTime);
};
var returnSDResult = function (value) {
    var SDresult = value.toFixed(1).replace('.', ',');
    var v = value > 0 ? "+" + SDresult : "" + SDresult;
    return {
        value: v.toString(),
        type: 'string'
    };
};
var calculatePoints = function () {
    var _a, _b, _c;
    if (helpers_1.isAnsweredDate(inputs.birthDay) &&
        helpers_1.isAnswered(inputs.weight) &&
        helpers_1.isAnswered(inputs.height)) {
        var BMI = calculateBMI();
        var BMIZScore = calculateZScore(BMI, 2);
        var BMIPercentile = calculatePercentile(BMIZScore);
        var bmi = {
            qID: 'bmi',
            rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(BMI, 2), 2, 2), centileFormatter(BMIPercentile), [
                returnSDResult(BMIZScore),
            ]),
            resultTexts: getBMIResultText(BMIZScore)
        };
        var heightZScore = calculateZScore(Number(inputs.height.currentPoints), 0);
        var heightPercentile = calculatePercentile(heightZScore);
        var centileAndSD = {
            qID: 'centileAndSD',
            rParams: __spreadArrays(centileFormatter(heightPercentile), [
                returnSDResult(heightZScore),
            ]),
            resultTexts: 'regular'
        };
        if (arebBrthWeightAndBirthLengthAnswered()) {
            var birthWeightZSScore = calculateBirthZScore(Number((_a = inputs.birthWeight) === null || _a === void 0 ? void 0 : _a.currentPoints) / 1000, 1);
            var birthWeightPercentile = calculatePercentile(birthWeightZSScore);
            var centileAndSDBirth = {
                qID: 'centileAndSDBirth',
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(birthWeightPercentile), 0, 0), [
                    returnSDResult(birthWeightZSScore),
                ]),
                resultTexts: 'regular'
            };
            var birthLengthZScore = calculateBirthZScore(Number((_b = inputs.birthLength) === null || _b === void 0 ? void 0 : _b.currentPoints), 0);
            var birthLengthPercentile = calculatePercentile(birthLengthZScore);
            var centileAndSDBirthLength = {
                qID: 'centileAndSDBirthLength',
                rParams: __spreadArrays(centileFormatter(birthLengthPercentile), [
                    returnSDResult(birthLengthZScore),
                ]),
                resultTexts: 'regular'
            };
            if (areMotherHeightAndFatherHeightVisible()) {
                var avgParentHeight = calculateAverageHeight();
                var averageParentHeight = {
                    qID: 'averageParentHeight',
                    rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(avgParentHeight, 1), 1)),
                    resultTexts: 'regular'
                };
                var avgParentHeightZScore = calculateAVGHeightZScore(avgParentHeight, 0);
                var avgParentHeightPercentile = calculatePercentile(avgParentHeightZScore);
                var averageParentHeightCentile = {
                    qID: 'averageParentHeightCentile',
                    rParams: __spreadArrays(centileFormatter(avgParentHeightPercentile), [
                        returnSDResult(avgParentHeightZScore),
                    ]),
                    resultTexts: 'regular'
                };
                if (arePriorMeasurementDateAndPriorHeightMeasurementVisible()) {
                    var growthVelocityResult = calculateGrowthVelocity();
                    var growthVelocity = {
                        qID: 'growthVelocity',
                        rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(growthVelocityResult, 1), 1, 1)),
                        resultTexts: 'regular'
                    };
                    if (areSection6QuestionsAnswered()) {
                        var calculatedDose = (_c = calculateDose()) === null || _c === void 0 ? void 0 : _c.doseResult;
                        var dose = {
                            qID: 'dose',
                            rParams: __spreadArrays(roundTo3Decimals(calculatedDose)),
                            resultTexts: 'regular'
                        };
                        if (isPackageNrVisible()) {
                            var pnr = getPackageNrResult();
                            var packageNr = {
                                qID: 'packageNr',
                                rParams: __spreadArrays(roundTo2Decimals(pnr)),
                                resultTexts: 'regular'
                            };
                            return {
                                bmi: bmi,
                                centileAndSD: centileAndSD,
                                centileAndSDBirth: centileAndSDBirth,
                                centileAndSDBirthLength: centileAndSDBirthLength,
                                averageParentHeight: averageParentHeight,
                                averageParentHeightCentile: averageParentHeightCentile,
                                growthVelocity: growthVelocity,
                                dose: dose,
                                packageNr: packageNr
                            };
                        }
                        return {
                            bmi: bmi,
                            centileAndSD: centileAndSD,
                            centileAndSDBirth: centileAndSDBirth,
                            centileAndSDBirthLength: centileAndSDBirthLength,
                            averageParentHeight: averageParentHeight,
                            averageParentHeightCentile: averageParentHeightCentile,
                            growthVelocity: growthVelocity,
                            dose: dose
                        };
                    }
                    return {
                        bmi: bmi,
                        centileAndSD: centileAndSD,
                        centileAndSDBirth: centileAndSDBirth,
                        centileAndSDBirthLength: centileAndSDBirthLength,
                        averageParentHeight: averageParentHeight,
                        averageParentHeightCentile: averageParentHeightCentile,
                        growthVelocity: growthVelocity
                    };
                }
                return {
                    bmi: bmi,
                    centileAndSD: centileAndSD,
                    centileAndSDBirth: centileAndSDBirth,
                    centileAndSDBirthLength: centileAndSDBirthLength,
                    averageParentHeight: averageParentHeight,
                    averageParentHeightCentile: averageParentHeightCentile
                };
            }
            return {
                bmi: bmi,
                centileAndSD: centileAndSD,
                centileAndSDBirth: centileAndSDBirth,
                centileAndSDBirthLength: centileAndSDBirthLength
            };
        }
        return {
            bmi: bmi,
            centileAndSD: centileAndSD
        };
    }
    return null;
};
var roundTo2Decimals = function (value) {
    return helpers_1.returnNumberObject(helpers_1.formatCalculationResult(value, 2), 2, 2);
};
var roundTo3Decimals = function (value) {
    return helpers_1.returnNumberObject(helpers_1.formatCalculationResult(value, 3), 3, 3);
};
var centileFormatter = function (centileNum) {
    if (centileNum < 1.0 || centileNum > 99.0) {
        var centile = centileNum;
        if (centile > 99.9) {
            centile = 99.9;
        }
        else if (centile < 0.1) {
            centile = 0.1;
        }
        return helpers_1.returnNumberObject(helpers_1.formatCalculationResult(centile, 1), 0, 1);
    }
    return helpers_1.returnNumberObject(helpers_1.formatCalculationResult(centileNum, 0), 0, 0);
};
var calculateBMI = function () {
    return (Number(inputs.weight.currentPoints) /
        Math.pow(Number(inputs.height.currentPoints) / 100, 2));
};
var getBMIResultText = function (zScore) {
    if (zScore < -2) {
        return 'thinness';
    }
    if (zScore >= -2 && zScore <= 1) {
        return 'normal';
    }
    if (zScore > 1 && zScore <= 2) {
        return 'overweight';
    }
    return 'obesity';
};
var calculateAverageHeight = function () {
    var _a, _b, _c;
    var height = (Number((_a = inputs.fatherHeight) === null || _a === void 0 ? void 0 : _a.currentPoints) +
        Number((_b = inputs.motherHeight) === null || _b === void 0 ? void 0 : _b.currentPoints)) /
        2 +
        Number((_c = inputs.sex) === null || _c === void 0 ? void 0 : _c.currentPoints);
    return height;
};
var calculateGrowthVelocity = function () {
    var _a, _b, _c;
    if (helpers_1.isAnswered(inputs.height) &&
        helpers_1.isAnswered(inputs.priorMeasurementDate) &&
        helpers_1.isAnswered(inputs.priorHeightMeasurement)) {
        var height = Number((_a = inputs.height) === null || _a === void 0 ? void 0 : _a.currentPoints);
        var priorHeightMeasurement = Number((_b = inputs.priorHeightMeasurement) === null || _b === void 0 ? void 0 : _b.currentPoints);
        var priorMeasurementDate = (_c = inputs.priorMeasurementDate) === null || _c === void 0 ? void 0 : _c.currentDate;
        var heightDifference = height - priorHeightMeasurement;
        var yearDifference = helpers_1.differenceBetweenDates(priorMeasurementDate, currentTime.getTime() / 1000, 'years');
        var growthVelocity = yearDifference === 0 || heightDifference <= 0.0
            ? 0.0
            : heightDifference / yearDifference;
        return growthVelocity;
    }
    return null;
};
var calculateDose = function () {
    var _a;
    if (helpers_1.isAnswered(inputs.weight) && getIndicationBasedDose() !== null) {
        var weight = Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints);
        var indicationBasedDose = getIndicationBasedDose();
        var doseResult = indicationBasedDose * weight > 4.0 ? 4.0 : indicationBasedDose * weight;
        return { doseResult: doseResult, indicationBasedDose: indicationBasedDose };
    }
    return null;
};
var getIndicationBasedDose = function () {
    var _a, _b;
    if (helpers_1.isAnswered(inputs.indication)) {
        if (helpers_1.answerMatches(inputs.indication, 'ghd') && helpers_1.isAnswered(inputs.doseGHD)) {
            return Number((_a = inputs.doseGHD) === null || _a === void 0 ? void 0 : _a.currentPoints);
        }
        if (helpers_1.answerMatches(inputs.indication, 'sga')) {
            return 0.035;
        }
        if (helpers_1.answerMatches(inputs.indication, 'ts') && helpers_1.isAnswered(inputs.doseTS)) {
            return Number((_b = inputs.doseTS) === null || _b === void 0 ? void 0 : _b.currentPoints);
        }
        return null;
    }
    return null;
};
var getPenPointsResult = function () {
    var _a, _b, _c;
    if (isPenLowVisible()) {
        return 0.0;
    }
    if (isPenLowMidVisible() && helpers_1.isAnswered(inputs.penLowMid)) {
        return Number((_a = inputs.penLowMid) === null || _a === void 0 ? void 0 : _a.currentPoints);
    }
    if (isPenMidVisible() && helpers_1.isAnswered(inputs.penMid)) {
        return Number((_b = inputs.penMid) === null || _b === void 0 ? void 0 : _b.currentPoints);
    }
    if (isPenMidHighVisible() && helpers_1.isAnswered(inputs.penMidHigh)) {
        return Number((_c = inputs.penMidHigh) === null || _c === void 0 ? void 0 : _c.currentPoints);
    }
    if (isPenHighVisible()) {
        return 2.0;
    }
    return null;
};
var compareValues = function (value1, value2, currentDose) {
    if (Math.abs(value1 - currentDose) < Math.abs(value2 - currentDose)) {
        return true;
    }
    return false;
};
var getPackageNrResult = function () {
    var _a;
    var weight = Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints);
    var packageSize = getPenPointsResult();
    var currentDose = getIndicationBasedDose();
    var currentDailyDose = packageSize === 0
        ? Math.ceil(20 * currentDose * weight) / 20
        : Math.ceil(10 * currentDose * weight) / 10;
    if (currentDailyDose > 4.0) {
        currentDailyDose = 4.0;
    }
    return getCurrentBox(currentDailyDose, packageSize);
};
var getCurrentBox = function (dose, packageSize) {
    var currentBox;
    var boxRow = packagesTable[packageSize];
    for (var i = 0; i < boxRow.length - 1; i++) {
        var shouldSkip = false;
        for (var j = 1; j < boxRow.length - 1 - i; j++) {
            var first = boxRow[i][0];
            var second = boxRow[i + j][0];
            var compared = compareValues(first, second, dose);
            if (!compared) {
                shouldSkip = true;
                break;
            }
        }
        if (shouldSkip) {
            shouldSkip = false;
            continue;
        }
        currentBox = boxRow[i][2];
        break;
    }
    return currentBox;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return areWeightAndHeightAnswered();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
