"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};


var visibleQuestions = {
    hypertension: true,
    abnormalRenalFunction: true,
    abnormalLiverFunction: true,
    stroke: true,
    priorBleeding: true,
    labile: true,
    elderly: true,
    medicationUsage: true,
    alcoholUse: true
};
var visibleSections = {
    main: true
};
var inputs = {
    hypertension: null,
    abnormalRenalFunction: null,
    abnormalLiverFunction: null,
    stroke: null,
    priorBleeding: null,
    labile: null,
    elderly: null,
    medicationUsage: null,
    alcoholUse: null
};
var calculatePoints = function () {
    var outputResult = helpers_1.formatCalculationResult(Number(inputs.hypertension.currentPoints) +
        Number(inputs.abnormalRenalFunction.currentPoints) +
        Number(inputs.abnormalLiverFunction.currentPoints) +
        Number(inputs.stroke.currentPoints) +
        Number(inputs.priorBleeding.currentPoints) +
        Number(inputs.labile.currentPoints) +
        Number(inputs.elderly.currentPoints) +
        Number(inputs.medicationUsage.currentPoints) +
        Number(inputs.alcoholUse.currentPoints));
    return helpers_1.returnToolScoreObject({ number: outputResult, range: outputResult });
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_toolScore = function () {
    return calculatePoints();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return true;
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return __assign(__assign({ exportResultsEnabled: isExportResultsEnabled() }, result), { visibleQuestions: ut_visibleQuestions(), visibleSections: ut_visibleSections() });
});
