"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    severePain: true,
    limitsActivities: true,
    lieDown: true,
    tooTired: true,
    irritated: true,
    limitConcentration: true,
    answerAll: true,
    noImpact: false,
    someImpact: false,
    substantialImpact: false,
    severeImpact: false
};
var visibleSections = {
    inputSection: true,
    resultSection: true
};
var inputs = {
    severePain: null,
    limitsActivities: null,
    lieDown: null,
    tooTired: null,
    irritated: null,
    limitConcentration: null
};
var isAnswerAllVisible = function () {
    return !(helpers_1.isAnswered(inputs.severePain) &&
        helpers_1.isAnswered(inputs.limitsActivities) &&
        helpers_1.isAnswered(inputs.lieDown) &&
        helpers_1.isAnswered(inputs.tooTired) &&
        helpers_1.isAnswered(inputs.irritated) &&
        helpers_1.isAnswered(inputs.limitConcentration));
};
var result = function () {
    var _a, _b, _c, _d, _e, _f;
    var result = Number((_a = inputs.severePain) === null || _a === void 0 ? void 0 : _a.currentPoints) +
        Number((_b = inputs.limitsActivities) === null || _b === void 0 ? void 0 : _b.currentPoints) +
        Number((_c = inputs.lieDown) === null || _c === void 0 ? void 0 : _c.currentPoints) +
        Number((_d = inputs.tooTired) === null || _d === void 0 ? void 0 : _d.currentPoints) +
        Number((_e = inputs.irritated) === null || _e === void 0 ? void 0 : _e.currentPoints) +
        Number((_f = inputs.limitConcentration) === null || _f === void 0 ? void 0 : _f.currentPoints);
    return result;
};
var isGreenVisible = function () {
    return !isAnswerAllVisible() && helpers_1.inLimits(result(), 0, 49);
};
var isYellowVisible = function () {
    return !isAnswerAllVisible() && helpers_1.inLimits(result(), 50, 55);
};
var isOrangeVisible = function () {
    return !isAnswerAllVisible() && helpers_1.inLimits(result(), 56, 59);
};
var isRedVisible = function () {
    return !isAnswerAllVisible() && helpers_1.inLimits(result(), 60, 78);
};
var calculatePoints = function () {
    if (isGreenVisible()) {
        return {
            noImpact: {
                qID: 'noImpact',
                tParams: __spreadArrays(helpers_1.returnNumberObject(result(), 0, 0)),
                titleTexts: 'result1'
            }
        };
    }
    if (isYellowVisible()) {
        return {
            someImpact: {
                qID: 'someImpact',
                tParams: __spreadArrays(helpers_1.returnNumberObject(result(), 0, 0)),
                titleTexts: 'result1'
            }
        };
    }
    if (isOrangeVisible()) {
        return {
            substantialImpact: {
                qID: 'substantialImpact',
                tParams: __spreadArrays(helpers_1.returnNumberObject(result(), 0, 0)),
                titleTexts: 'result1'
            }
        };
    }
    if (isRedVisible()) {
        return {
            severeImpact: {
                qID: 'severeImpact',
                tParams: __spreadArrays(helpers_1.returnNumberObject(result(), 0, 0)),
                titleTexts: 'result1'
            }
        };
    }
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.answerAll = isAnswerAllVisible();
    visibleQuestions.noImpact = isGreenVisible();
    visibleQuestions.someImpact = isYellowVisible();
    visibleQuestions.substantialImpact = isOrangeVisible();
    visibleQuestions.severeImpact = isRedVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return !isAnswerAllVisible();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
