"use strict";


var visibleQuestions = {
    initialDate: true,
    nodules1: true,
    abscess1: true,
    fistula1: true,
    initialResultYes: false,
    initialResultNo: false,
    endDate: true,
    nodules2: true,
    abscess2: true,
    fistula2: true,
    endResultYes: false,
    endResultNo: false,
    result1: false,
    result2: false,
    result3: false,
    result4: false,
    result5: false,
    result6: false
};
var visibleSections = {
    section1: true,
    section2: false,
    resultSection: false
};
var inputs = {
    initialDate: null,
    nodules1: null,
    abscess1: null,
    fistula1: null,
    endDate: null,
    nodules2: null,
    abscess2: null,
    fistula2: null
};
var inputs1Answered = function () {
    var _a, _b, _c, _d;
    return (((_a = inputs.initialDate) === null || _a === void 0 ? void 0 : _a.currentDate) !== null &&
        ((_b = inputs.nodules1) === null || _b === void 0 ? void 0 : _b.currentPoints) !== null &&
        ((_c = inputs.abscess1) === null || _c === void 0 ? void 0 : _c.currentPoints) !== null &&
        ((_d = inputs.fistula1) === null || _d === void 0 ? void 0 : _d.currentPoints) !== null);
};
var inputs1Valid = function () {
    var _a, _b, _c, _d, _e, _f;
    return (((_a = inputs.nodules1) === null || _a === void 0 ? void 0 : _a.currentPoints) >= 0 &&
        ((_b = inputs.nodules1) === null || _b === void 0 ? void 0 : _b.currentPoints) <= 100 &&
        ((_c = inputs.abscess1) === null || _c === void 0 ? void 0 : _c.currentPoints) >= 0 &&
        ((_d = inputs.abscess1) === null || _d === void 0 ? void 0 : _d.currentPoints) <= 100 &&
        ((_e = inputs.fistula1) === null || _e === void 0 ? void 0 : _e.currentPoints) >= 0 &&
        ((_f = inputs.fistula1) === null || _f === void 0 ? void 0 : _f.currentPoints) <= 100);
};
var inputs2Answered = function () {
    var _a, _b, _c, _d;
    return (((_a = inputs.endDate) === null || _a === void 0 ? void 0 : _a.currentDate) !== null &&
        ((_b = inputs.nodules2) === null || _b === void 0 ? void 0 : _b.currentPoints) !== null &&
        ((_c = inputs.abscess2) === null || _c === void 0 ? void 0 : _c.currentPoints) !== null &&
        ((_d = inputs.fistula2) === null || _d === void 0 ? void 0 : _d.currentPoints) !== null);
};
var inputs2Valid = function () {
    var _a, _b, _c, _d, _e, _f;
    return (((_a = inputs.nodules2) === null || _a === void 0 ? void 0 : _a.currentPoints) >= 0 &&
        ((_b = inputs.nodules2) === null || _b === void 0 ? void 0 : _b.currentPoints) <= 100 &&
        ((_c = inputs.abscess2) === null || _c === void 0 ? void 0 : _c.currentPoints) >= 0 &&
        ((_d = inputs.abscess2) === null || _d === void 0 ? void 0 : _d.currentPoints) <= 100 &&
        ((_e = inputs.fistula2) === null || _e === void 0 ? void 0 : _e.currentPoints) >= 0 &&
        ((_f = inputs.fistula2) === null || _f === void 0 ? void 0 : _f.currentPoints) <= 100);
};
var calculateInitialResult = function () {
    var _a, _b, _c;
    return (Number(((_a = inputs.nodules1) === null || _a === void 0 ? void 0 : _a.currentPoints) || 0) +
        Number(((_b = inputs.abscess1) === null || _b === void 0 ? void 0 : _b.currentPoints) || 0) +
        Number(((_c = inputs.fistula1) === null || _c === void 0 ? void 0 : _c.currentPoints) || 0));
};
var calculateEndResult = function () {
    var _a, _b, _c;
    return (Number(((_a = inputs.nodules2) === null || _a === void 0 ? void 0 : _a.currentPoints) || 0) +
        Number(((_b = inputs.abscess2) === null || _b === void 0 ? void 0 : _b.currentPoints) || 0) +
        Number(((_c = inputs.fistula2) === null || _c === void 0 ? void 0 : _c.currentPoints) || 0));
};
var calculatePoints = function () {
    var initialResult = calculateInitialResult();
    var endResult = calculateEndResult();
    return {
        number: 0,
        result: 0,
        initialResultYes: {
            qID: "initialResultYes",
            rParams: [
                {
                    type: "string",
                    value: initialResult.toFixed(0)
                },
            ],
            titleTexts: "regular",
            resultTexts: "regular"
        },
        initialResultNo: {
            qID: "initialResultNo",
            titleTexts: "regular",
            resultTexts: "regular"
        },
        endResultYes: {
            qID: "endResultYes",
            rParams: [
                {
                    type: "string",
                    value: endResult.toFixed(0)
                },
            ],
            titleTexts: "regular",
            resultTexts: "regular"
        },
        endResultNo: {
            qID: "endResultNo",
            titleTexts: "regular",
            resultTexts: "regular"
        },
        result1: {
            qID: "result1",
            titleTexts: "regular",
            resultTexts: "regular"
        },
        result2: {
            qID: "result2",
            tParams: [
                {
                    type: "string",
                    value: endResult !== 0 && initialResult !== 0
                        ? ((1 - Number(endResult / initialResult)) * 100 || 0).toFixed(0)
                        : "0"
                },
            ],
            titleTexts: "regular",
            resultTexts: "regular"
        },
        result3: {
            qID: "result3",
            titleTexts: "regular",
            resultTexts: "regular"
        },
        result4: {
            qID: "result4",
            titleTexts: "regular",
            resultTexts: "regular"
        },
        result5: {
            qID: "result5",
            tParams: [
                {
                    type: "string",
                    value: endResult !== 0 && initialResult !== 0
                        ? ((1 - Number(endResult / initialResult)) * 100 || 0).toFixed(0)
                        : "0"
                },
            ],
            titleTexts: "regular",
            resultTexts: "regular"
        },
        result6: {
            qID: "result6",
            titleTexts: "regular",
            resultTexts: "regular"
        }
    };
};
var returnVisibleQuestions = function () {
    var _a, _b;
    visibleQuestions.initialResultYes = inputs1Answered() && inputs1Valid();
    visibleQuestions.initialResultNo = !inputs1Answered() || !inputs1Valid();
    visibleQuestions.endResultYes = inputs2Answered() && inputs2Valid();
    visibleQuestions.endResultNo = !inputs2Answered() || !inputs2Valid();
    var initialResult = calculateInitialResult();
    var endResult = calculateEndResult();
    var weeksDifference = helpers_1.differenceBetweenDates(((_a = inputs.endDate) === null || _a === void 0 ? void 0 : _a.currentDate) || 0, ((_b = inputs.initialDate) === null || _b === void 0 ? void 0 : _b.currentDate) || 0, "weeks");
    visibleQuestions.result1 =
        endResult <= 0.75 * initialResult &&
            weeksDifference < 12 &&
            visibleQuestions.initialResultYes &&
            visibleQuestions.endResultYes &&
            inputs1Valid() &&
            inputs2Valid();
    visibleQuestions.result2 =
        endResult <= 0.75 * initialResult &&
            visibleQuestions.initialResultYes &&
            visibleQuestions.endResultYes &&
            inputs1Valid() &&
            inputs2Valid();
    visibleQuestions.result3 =
        endResult <= 0.75 * initialResult &&
            visibleQuestions.initialResultYes &&
            visibleQuestions.endResultYes &&
            inputs1Valid() &&
            inputs2Valid();
    visibleQuestions.result4 =
        endResult > 0.75 * initialResult &&
            weeksDifference < 12 &&
            visibleQuestions.initialResultYes &&
            visibleQuestions.endResultYes &&
            inputs1Valid() &&
            inputs2Valid();
    visibleQuestions.result5 =
        endResult > 0.75 * initialResult &&
            visibleQuestions.initialResultYes &&
            visibleQuestions.endResultYes &&
            inputs1Valid() &&
            inputs2Valid();
    visibleQuestions.result6 =
        endResult > 0.75 * initialResult &&
            visibleQuestions.initialResultYes &&
            visibleQuestions.endResultYes &&
            inputs1Valid() &&
            inputs2Valid();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.section2 = inputs1Answered() && inputs1Valid();
    visibleSections.resultSection =
        visibleSections.section2 && inputs2Answered() && inputs2Valid();
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
