"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};


var visibleQuestions = {
    histopathology: true,
    lymphNodes: true,
    CRP: true,
    anemia: true,
    thrombocytopenia: true,
    hypoalbuminemia: true,
    renal: true,
    hypergammaglobulinemia: true,
    symptoms: true,
    liver: true,
    fluid: true,
    hemangiomatosis: true,
    pneumonitis: true,
    HHV8: true,
    EBV: true,
    adenopathy: true,
    warning1: true,
    erythematosus: true,
    RA: true,
    stillDisease: true,
    juvelineA: true,
    lymphoproliferative: true,
    warning2: true,
    lymphoma: true,
    myeloma: true,
    plasmacytoma: true,
    sarcoma: true,
    POEMS: true,
    VEGF: true,
    reticulin: true,
    disorders: true
};
var visibleSections = {
    major: true,
    minorLab: true,
    minorClin: true,
    exclusion1: true,
    exclusion2: true,
    exclusion3: true,
    additionalFeatures: true
};
var inputs = {
    histopathology: null,
    lymphNodes: null,
    CRP: null,
    anemia: null,
    thrombocytopenia: null,
    hypoalbuminemia: null,
    renal: null,
    hypergammaglobulinemia: null,
    symptoms: null,
    liver: null,
    fluid: null,
    hemangiomatosis: null,
    pneumonitis: null,
    HHV8: null,
    EBV: null,
    adenopathy: null,
    erythematosus: null,
    RA: null,
    stillDisease: null,
    juvelineA: null,
    lymphoproliferative: null,
    lymphoma: null,
    myeloma: null,
    plasmacytoma: null,
    sarcoma: null,
    POEMS: null,
    VEGF: null,
    reticulin: null,
    disorders: null
};
var meetsCriteria = function () {
    var _a, _b;
    if (!helpers_1.isAnswered(inputs.histopathology) ||
        !helpers_1.isAnswered(inputs.lymphNodes) ||
        ((_a = inputs.histopathology) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "no" ||
        ((_b = inputs.lymphNodes) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "no") {
        return false;
    }
    var labCriterias = [
        "CRP",
        "anemia",
        "thrombocytopenia",
        "hypoalbuminemia",
        "renal",
        "hypergammaglobulinemia",
    ];
    var clinCriterias = [
        "symptoms",
        "liver",
        "fluid",
        "hemangiomatosis",
        "pneumonitis",
    ];
    var exclCriterias = [
        "HHV8",
        "EBV",
        "adenopathy",
        "erythematosus",
        "RA",
        "stillDisease",
        "juvelineA",
        "lymphoproliferative",
        "lymphoma",
        "myeloma",
        "plasmacytoma",
        "sarcoma",
        "POEMS",
    ];
    var labCriteriasMet = labCriterias.filter(function (labCriteria) { var _a; return ((_a = inputs[labCriteria]) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "yes"; }).length;
    var clinCriteriasMet = clinCriterias.filter(function (clinCriteria) { var _a; return ((_a = inputs[clinCriteria]) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "yes"; }).length;
    var exclCriteriasNr = exclCriterias.filter(function (clinCriteria) { var _a; return ((_a = inputs[clinCriteria]) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "yes"; }).length;
    return (labCriteriasMet + clinCriteriasMet >= 2 &&
        labCriteriasMet >= 1 &&
        exclCriteriasNr === 0);
};
var calculatePoints = function () {
    return {
        resultById: meetsCriteria() ? "red" : "greenResult",
        result: {}
    };
};
var isRestVisible = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.histopathology) &&
        helpers_1.isAnswered(inputs.lymphNodes) &&
        ((_a = inputs.histopathology) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "yes" &&
        ((_b = inputs.lymphNodes) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "yes");
};
var returnVisibleQuestions = function () {
    visibleQuestions.CRP = isRestVisible();
    visibleQuestions.anemia = isRestVisible();
    visibleQuestions.thrombocytopenia = isRestVisible();
    visibleQuestions.hypoalbuminemia = isRestVisible();
    visibleQuestions.renal = isRestVisible();
    visibleQuestions.hypergammaglobulinemia = isRestVisible();
    visibleQuestions.symptoms = isRestVisible();
    visibleQuestions.liver = isRestVisible();
    visibleQuestions.fluid = isRestVisible();
    visibleQuestions.hemangiomatosis = isRestVisible();
    visibleQuestions.pneumonitis = isRestVisible();
    visibleQuestions.HHV8 = isRestVisible();
    visibleQuestions.EBV = isRestVisible();
    visibleQuestions.adenopathy = isRestVisible();
    visibleQuestions.warning1 = isRestVisible();
    visibleQuestions.erythematosus = isRestVisible();
    visibleQuestions.RA = isRestVisible();
    visibleQuestions.stillDisease = isRestVisible();
    visibleQuestions.juvelineA = isRestVisible();
    visibleQuestions.lymphoproliferative = isRestVisible();
    visibleQuestions.warning2 = isRestVisible();
    visibleQuestions.lymphoma = isRestVisible();
    visibleQuestions.myeloma = isRestVisible();
    visibleQuestions.plasmacytoma = isRestVisible();
    visibleQuestions.sarcoma = isRestVisible();
    visibleQuestions.POEMS = isRestVisible();
    visibleQuestions.VEGF = isRestVisible();
    visibleQuestions.reticulin = isRestVisible();
    visibleQuestions.disorders = isRestVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.minorLab = isRestVisible();
    visibleSections.minorClin = isRestVisible();
    visibleSections.exclusion1 = isRestVisible();
    visibleSections.exclusion2 = isRestVisible();
    visibleSections.exclusion3 = isRestVisible();
    visibleSections.additionalFeatures = isRestVisible();
    return visibleSections;
};
var ut_toolScore = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return true;
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return __assign(__assign({ exportResultsEnabled: isExportResultsEnabled() }, result), { visibleQuestions: ut_visibleQuestions(), visibleSections: ut_visibleSections() });
});
