"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};


var visibleQuestions = {
    answer1: true,
    answer2: true,
    answer3: true,
    answer4: true,
    answer5: true,
    answer6: true,
    answer7: true
};
var visibleSections = {
    choices: true
};
var inputs = {
    answer1: null,
    answer2: null,
    answer3: null,
    answer4: null,
    answer5: null,
    answer6: null,
    answer7: null
};
var areAllQuestionsAnsweredNo = function () {
    return (helpers_1.answerMatches(inputs.answer1, 'no') &&
        helpers_1.answerMatches(inputs.answer2, 'no') &&
        helpers_1.answerMatches(inputs.answer3, 'no') &&
        helpers_1.answerMatches(inputs.answer4, 'no') &&
        helpers_1.answerMatches(inputs.answer5, 'no') &&
        helpers_1.answerMatches(inputs.answer6, 'no') &&
        helpers_1.answerMatches(inputs.answer7, 'no'));
};
var calculatePoints = function () {
    if (areAllQuestionsAnsweredNo()) {
        return helpers_1.returnToolScoreObject({ resultById: 'noClinicalRelapse' });
    }
    return helpers_1.returnToolScoreObject({ resultById: 'clinicalRelapse' });
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return true;
};
var ut_toolScore = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return __assign(__assign({ exportResultsEnabled: isExportResultsEnabled() }, result), { visibleQuestions: ut_visibleQuestions(), visibleSections: ut_visibleSections() });
});
