"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};


var visibleQuestions = {
    constantUrge: true,
    frequency: true,
    incompleteBladder: true,
    interuptions: true,
    nocturia: true,
    qualityOfLife: true,
    straining: true,
    weakStream: true
};
var visibleSections = {};
var inputs = {
    constantUrge: null,
    frequency: null,
    incompleteBladder: null,
    interuptions: null,
    nocturia: null,
    qualityOfLife: null,
    straining: null,
    weakStream: null
};
var calculatePoints = function () {
    if (!helpers_1.isAnswered(inputs.constantUrge) ||
        !helpers_1.isAnswered(inputs.frequency) ||
        !helpers_1.isAnswered(inputs.incompleteBladder) ||
        !helpers_1.isAnswered(inputs.interuptions) ||
        !helpers_1.isAnswered(inputs.nocturia) ||
        !helpers_1.isAnswered(inputs.weakStream) ||
        !helpers_1.isAnswered(inputs.straining))
        return helpers_1.returnToolScoreObject({});
    var outputResult = helpers_1.formatCalculationResult(inputs.constantUrge.currentPoints +
        inputs.frequency.currentPoints +
        inputs.incompleteBladder.currentPoints +
        inputs.interuptions.currentPoints +
        inputs.nocturia.currentPoints +
        inputs.straining.currentPoints +
        inputs.weakStream.currentPoints, 2);
    return helpers_1.returnToolScoreObject({ number: outputResult, range: outputResult });
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_toolScore = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return __assign(__assign({}, result), { visibleQuestions: ut_visibleQuestions(), visibleSections: ut_visibleSections() });
});
