"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};


var visibleQuestions = {
    age: true,
    weight: false,
    answerAll: true,
    warning1: true,
    tabletsKidsResult1: true,
    tabletsKidsResult2: false,
    tabletsKidsResult3: false,
    duration1: true,
    powder40KidsResult1: true,
    powder40KidsResult2: true,
    duration2: true,
    powder20KidsResult1: true,
    powder20KidsResult2: true,
    duration3: true,
    tabletsAdultsResult1: true,
    tabletsAdultsResult2: true,
    duration4: true,
    powderAdultsResult1: true,
    powderAdultsResult2: true,
    duration5: true,
    kidneyOk: true,
    kidneyBad: true
};
var visibleSections = {
    inputSection: true,
    dosing: false,
    under5warning: false,
    tabletsKids: false,
    powder40Kids: false,
    powder20Kids: false,
    tabletsAdults: false,
    powderAdults: false,
    kidney: false
};
var inputs = {
    age: null,
    weight: null
};
var generateResultObject = function (name, tParams) {
    var _a;
    var params = [];
    tParams.forEach(function (item) { return params.push.apply(params, helpers_1.returnNumberObject(item, 0, 1)); });
    return _a = {},
        _a[name] = {
            qID: name,
            titleTexts: 'regular',
            resultTexts: 'result1',
            tParams: params
        },
        _a;
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p;
    var result = {
        number: null,
        range: null
    };
    if (isPowder40KidsVisible()) {
        var res1Arg1 = (7 * Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints)) / 40;
        var res1Arg2 = (10 * Number((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints)) / 40;
        var res1Arg3 = 7 * Number((_c = inputs.weight) === null || _c === void 0 ? void 0 : _c.currentPoints);
        var res1Arg4 = 10 * Number((_d = inputs.weight) === null || _d === void 0 ? void 0 : _d.currentPoints);
        var res2Arg1 = (30 * Number((_e = inputs.weight) === null || _e === void 0 ? void 0 : _e.currentPoints)) / 40;
        var res2Arg2 = 30 * Number((_f = inputs.weight) === null || _f === void 0 ? void 0 : _f.currentPoints);
        if (Number((_g = inputs.weight) === null || _g === void 0 ? void 0 : _g.currentPoints) >= 26.7) {
            res2Arg1 = 20;
            res2Arg2 = 800;
        }
        result = __assign(__assign(__assign({}, result), generateResultObject('powder40KidsResult1', [
            res1Arg1,
            res1Arg2,
            res1Arg3,
            res1Arg4,
        ])), generateResultObject('powder40KidsResult2', [res2Arg1, res2Arg2]));
    }
    if (isPowder20KidsVisible()) {
        var res1Arg1 = (7 * Number((_h = inputs.weight) === null || _h === void 0 ? void 0 : _h.currentPoints)) / 20;
        var res1Arg2 = (10 * Number((_j = inputs.weight) === null || _j === void 0 ? void 0 : _j.currentPoints)) / 20;
        var res1Arg3 = 7 * Number((_k = inputs.weight) === null || _k === void 0 ? void 0 : _k.currentPoints);
        var res1Arg4 = 10 * Number((_l = inputs.weight) === null || _l === void 0 ? void 0 : _l.currentPoints);
        var res2Arg1 = (30 * Number((_m = inputs.weight) === null || _m === void 0 ? void 0 : _m.currentPoints)) / 20;
        var res2Arg2 = 30 * Number((_o = inputs.weight) === null || _o === void 0 ? void 0 : _o.currentPoints);
        if (Number((_p = inputs.weight) === null || _p === void 0 ? void 0 : _p.currentPoints) >= 26.7) {
            res2Arg1 = 40;
            res2Arg2 = 800;
        }
        result = __assign(__assign(__assign({}, result), generateResultObject('powder20KidsResult1', [
            res1Arg1,
            res1Arg2,
            res1Arg3,
            res1Arg4,
        ])), generateResultObject('powder20KidsResult2', [res2Arg1, res2Arg2]));
    }
    return result;
};
var isWeightValid = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 70 });
};
var isWeightVisible = function () { return helpers_1.answerMatches(inputs.age, 'less12'); };
var isDosingVisible = function () {
    return !helpers_1.isAnswered(inputs.age) || (isWeightVisible() && !isWeightValid());
};
var isUnder5warningVisible = function () {
    var _a;
    return (helpers_1.answerMatches(inputs.age, 'less12') &&
        isWeightValid() &&
        Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints) < 5);
};
var isTabletsKidsResult2Visible = function () {
    var _a, _b;
    return (isWeightValid() &&
        Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints) >= 20 &&
        Number((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints) < 30);
};
var isTabletsKidsResult3Visible = function () {
    var _a, _b;
    return (isWeightValid() &&
        Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints) >= 30 &&
        Number((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints) < 40);
};
var isTabletsKidsVisible = function () {
    var _a, _b;
    return (helpers_1.answerMatches(inputs.age, 'less12') &&
        Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints) >= 20 &&
        Number((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints) < 40);
};
var isPowder40KidsVisible = function () {
    var _a, _b;
    return (helpers_1.answerMatches(inputs.age, 'less12') &&
        Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints) >= 10 &&
        Number((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints) < 40);
};
var isPowder20KidsVisible = function () {
    var _a, _b;
    return (helpers_1.answerMatches(inputs.age, 'less12') &&
        Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints) >= 5 &&
        Number((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints) < 40);
};
var isTabletsAdultsVisible = function () {
    var _a;
    return (helpers_1.answerMatches(inputs.age, 'more12') ||
        (helpers_1.answerMatches(inputs.age, 'less12') &&
            isWeightValid() &&
            Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints) >= 40));
};
var isKidneyVisible = function () {
    var _a;
    return (helpers_1.answerMatches(inputs.age, 'more12') ||
        (helpers_1.answerMatches(inputs.age, 'less12') &&
            isWeightValid() &&
            Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints) >= 5));
};
var returnVisibleQuestions = function () {
    visibleQuestions.weight = isWeightVisible();
    visibleQuestions.tabletsKidsResult2 = isTabletsKidsResult2Visible();
    visibleQuestions.tabletsKidsResult3 = isTabletsKidsResult3Visible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.dosing = isDosingVisible();
    visibleSections.under5warning = isUnder5warningVisible();
    visibleSections.tabletsKids = isTabletsKidsVisible();
    visibleSections.powder40Kids = isPowder40KidsVisible();
    visibleSections.powder20Kids = isPowder20KidsVisible();
    visibleSections.tabletsAdults = isTabletsAdultsVisible();
    visibleSections.powderAdults = isTabletsAdultsVisible();
    visibleSections.kidney = isKidneyVisible();
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return !isDosingVisible();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
