"use strict";


var visibleQuestions = {
    age: true,
    answerAll: true,
    kidsResult1: true,
    adolescents400Result1: true,
    adolescents400Result2: true,
    adolescents400Result3: true,
    adolescents600Result1: true,
    adolescents600Result2: true,
    adolescents600Result3: true,
    adults400Result1: true,
    adults400Result2: true,
    adults400Result3: true,
    adults600Result1: true,
    adults600Result2: true,
    adults600Result3: true,
    adults800Result1: true,
    adults800Result2: true,
    adults800Result3: true,
    kidney1: true,
    kidney2: true
};
var visibleSections = {
    inputSection: true,
    dosing: false,
    dosingKids: false,
    tabletsAdolescents400: false,
    tabletsAdolescents600: false,
    tabletsAdults400: false,
    tabletsAdults600: false,
    tabletsAdults800: false,
    kidney: false
};
var inputs = {
    age: null
};
var calculatePoints = function () {
    return null;
};
var isDosingVisible = function () { return !helpers_1.isAnswered(inputs.age); };
var isDosingKidsVisible = function () { return helpers_1.answerMatches(inputs.age, 'kids'); };
var isTabletsAdolescents400Visible = function () {
    return helpers_1.answerMatches(inputs.age, 'adolescents');
};
var isTabletsAdolescents600Visible = function () {
    return helpers_1.answerMatches(inputs.age, 'adolescents');
};
var isTabletsAdults400Visible = function () { return helpers_1.answerMatches(inputs.age, 'adults'); };
var isTabletsAdults600Visible = function () { return helpers_1.answerMatches(inputs.age, 'adults'); };
var isTabletsAdults800Visible = function () { return helpers_1.answerMatches(inputs.age, 'adults'); };
var isKidneyVisible = function () {
    return helpers_1.answerMatches(inputs.age, 'adolescents') ||
        helpers_1.answerMatches(inputs.age, 'adults');
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.dosing = isDosingVisible();
    visibleSections.dosingKids = isDosingKidsVisible();
    visibleSections.tabletsAdolescents400 = isTabletsAdolescents400Visible();
    visibleSections.tabletsAdolescents600 = isTabletsAdolescents600Visible();
    visibleSections.tabletsAdults400 = isTabletsAdults400Visible();
    visibleSections.tabletsAdults600 = isTabletsAdults600Visible();
    visibleSections.tabletsAdults800 = isTabletsAdults800Visible();
    visibleSections.kidney = isKidneyVisible();
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return !isDosingVisible();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: { number: result, range: result },
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
