"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var dictionary = [];
var visibleQuestions = {
    indication: true,
    weight: true,
    answerAll: true,
    recommendedDose: false,
    numberOfVials: false,
    requiredVolume: false
};
var visibleSections = {
    monotherapy: true,
    resultSection: true
};
var inputs = {
    weight: null
};
var calculatePoints = function () {
    visibleQuestions.answerAll = true;
    visibleQuestions.recommendedDose = false;
    visibleQuestions.numberOfVials = false;
    visibleQuestions.requiredVolume = false;
    if (!helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 300 }))
        return null;
    var resultRow = dictionary.find(function (dict) { return dict.weight === Number(inputs.weight.currentPoints); });
    if (!resultRow)
        return null;
    visibleQuestions.answerAll = false;
    visibleQuestions.recommendedDose = true;
    visibleQuestions.numberOfVials = true;
    visibleQuestions.requiredVolume = true;
    var result = {
        recommendedDose: {
            qID: "recommendedDose",
            rParams: __spreadArrays(helpers_1.returnNumberObject(resultRow.z)),
            titleTexts: "regular",
            resultTexts: "regular"
        },
        numberOfVials: {
            qID: "numberOfVials",
            tParams: __spreadArrays(helpers_1.returnNumberObject(resultRow.x), helpers_1.returnNumberObject(resultRow.y)),
            titleTexts: "regular"
        },
        requiredVolume: {
            qID: "requiredVolume",
            tParams: __spreadArrays(helpers_1.returnNumberObject(resultRow.a), helpers_1.returnNumberObject(resultRow.b)),
            titleTexts: "regular"
        }
    };
    return result;
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    calculatePoints();
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    calculatePoints();
    return returnVisibleSections();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});