"use strict";

var visibleQuestions = {
    nivolumab: true,
    indication1: false,
    name1: false,
    smpcLink1: false,
    pembrolizumab1: true,
    indication2: false,
    name2: false,
    smpcLink2: false,
    pembrolizumab2: true,
    indication3: false,
    name3: false,
    smpcLink3: false
};
var visibleSections = {
    section1: true,
    section2: true,
    section3: true
};
var inputs = {
    nivolumab: null,
    pembrolizumab1: null,
    pembrolizumab2: null
};
var isNivolumabOpened = function () {
    return inputs.nivolumab.currentIdentifier === 'close';
};
var isPembrolizumab1Opened = function () {
    return inputs.pembrolizumab1.currentIdentifier === 'close';
};
var isPembrolizumab2Opened = function () {
    return inputs.pembrolizumab2.currentIdentifier === 'close';
};
var returnVisibleQuestions = function () {
    visibleQuestions.indication1 = isNivolumabOpened();
    visibleQuestions.name1 = isNivolumabOpened();
    visibleQuestions.smpcLink1 = isNivolumabOpened();
    visibleQuestions.indication2 = isPembrolizumab1Opened();
    visibleQuestions.name2 = isPembrolizumab1Opened();
    visibleQuestions.smpcLink2 = isPembrolizumab1Opened();
    visibleQuestions.indication3 = isPembrolizumab2Opened();
    visibleQuestions.name3 = isPembrolizumab2Opened();
    visibleQuestions.smpcLink3 = isPembrolizumab2Opened();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return true;
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
