"use strict";

var visibleQuestions = {
    ipilimumab1: true,
    indication1: false,
    name1: false,
    smpcLink1: false,
    ipilimumab2: true,
    indication2: false,
    name2: false,
    smpcLink2: false,
    nivolumab1: true,
    indication3: false,
    name3: false,
    smpcLink3: false,
    nivolumab2: true,
    indication4: false,
    name4: false,
    smpcLink4: false,
    pembrolizumab1: true,
    indication5: false,
    name5: false,
    smpcLink5: false,
    pembrolizumab2: true,
    indication6: false,
    name6: false,
    smpcLink6: false
};
var visibleSections = {
    section1: true,
    section2: true,
    section3: true,
    section4: true,
    section5: true,
    section6: true
};
var inputs = {
    ipilimumab1: null,
    ipilimumab2: null,
    nivolumab1: null,
    nivolumab2: null,
    pembrolizumab1: null,
    pembrolizumab2: null
};
var isIpilimumab1Opened = function () {
    return inputs.ipilimumab1.currentIdentifier === 'close';
};
var isIpilimumab2Opened = function () {
    return inputs.ipilimumab2.currentIdentifier === 'close';
};
var isNivolumab1Opened = function () {
    return inputs.nivolumab1.currentIdentifier === 'close';
};
var isNivolumab2Opened = function () {
    return inputs.nivolumab2.currentIdentifier === 'close';
};
var isPembrolizumab1Opened = function () {
    return inputs.pembrolizumab1.currentIdentifier === 'close';
};
var isPembrolizumab2Opened = function () {
    return inputs.pembrolizumab2.currentIdentifier === 'close';
};
var returnVisibleQuestions = function () {
    visibleQuestions.indication1 = isIpilimumab1Opened();
    visibleQuestions.name1 = isIpilimumab1Opened();
    visibleQuestions.smpcLink1 = isIpilimumab1Opened();
    visibleQuestions.indication2 = isIpilimumab2Opened();
    visibleQuestions.name2 = isIpilimumab2Opened();
    visibleQuestions.smpcLink2 = isIpilimumab2Opened();
    visibleQuestions.indication3 = isNivolumab1Opened();
    visibleQuestions.name3 = isNivolumab1Opened();
    visibleQuestions.smpcLink3 = isNivolumab1Opened();
    visibleQuestions.indication4 = isNivolumab2Opened();
    visibleQuestions.name4 = isNivolumab2Opened();
    visibleQuestions.smpcLink4 = isNivolumab2Opened();
    visibleQuestions.indication5 = isPembrolizumab1Opened();
    visibleQuestions.name5 = isPembrolizumab1Opened();
    visibleQuestions.smpcLink5 = isPembrolizumab1Opened();
    visibleQuestions.indication6 = isPembrolizumab2Opened();
    visibleQuestions.name6 = isPembrolizumab2Opened();
    visibleQuestions.smpcLink6 = isPembrolizumab2Opened();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return true;
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
