"use strict";

var visibleQuestions = {
    nivolumab1: true,
    indication1: false,
    name1: false,
    smpcLink1: false,
    nivolumab2: true,
    indication2: false,
    name2: false,
    smpcLink2: false,
    pembrolizumab1: true,
    indication3: false,
    name3: false,
    smpcLink3: false,
    pembrolizumab2: true,
    indication4: false,
    name4: false,
    smpcLink4: false,
    pembrolizumab3: true,
    indication5: false,
    name5: false,
    smpcLink5: false,
    pembrolizumab4: true,
    indication6: false,
    name6: false,
    smpcLink6: false,
    atezolizumab1: true,
    indication7: false,
    name7: false,
    smpcLink7: false,
    atezolizumab2: true,
    indication8: false,
    name8: false,
    smpcLink8: false,
    atezolizumab3: true,
    indication9: false,
    name9: false,
    smpcLink9: false,
    atezolizumab4: true,
    indication10: false,
    name10: false,
    smpcLink10: false,
    durvalumab: true,
    indication11: false,
    name11: false,
    smpcLink11: false,
    ipilimumab: true,
    indication12: false,
    name12: false,
    smpcLink12: false,
    cemiplimab: true,
    indication13: false,
    name13: false,
    smpcLink13: false
};
var visibleSections = {
    section1: true,
    section2: true,
    section3: true,
    section4: true,
    section5: true,
    section6: true,
    section7: true,
    section8: true,
    section9: true,
    section10: true,
    section11: true,
    section12: true,
    section13: true
};
var inputs = {
    nivolumab1: null,
    nivolumab2: null,
    pembrolizumab1: null,
    pembrolizumab2: null,
    pembrolizumab3: null,
    pembrolizumab4: null,
    atezolizumab1: null,
    atezolizumab2: null,
    atezolizumab3: null,
    atezolizumab4: null,
    durvalumab: null,
    ipilimumab: null,
    cemiplimab: null
};
var isNivolumab1Opened = function () {
    return inputs.nivolumab1.currentIdentifier === 'close';
};
var isNivolumab2Opened = function () {
    return inputs.nivolumab2.currentIdentifier === 'close';
};
var isPembrolizumab1Opened = function () {
    return inputs.pembrolizumab1.currentIdentifier === 'close';
};
var isPembrolizumab2Opened = function () {
    return inputs.pembrolizumab2.currentIdentifier === 'close';
};
var isPembrolizumab3Opened = function () {
    return inputs.pembrolizumab3.currentIdentifier === 'close';
};
var isPembrolizumab4Opened = function () {
    return inputs.pembrolizumab4.currentIdentifier === 'close';
};
var isAtezolizumab1Opened = function () {
    return inputs.atezolizumab1.currentIdentifier === 'close';
};
var isAtezolizumab2Opened = function () {
    return inputs.atezolizumab2.currentIdentifier === 'close';
};
var isAtezolizumab3Opened = function () {
    return inputs.atezolizumab3.currentIdentifier === 'close';
};
var isAtezolizumab4Opened = function () {
    return inputs.atezolizumab4.currentIdentifier === 'close';
};
var isDurvalumabOpened = function () {
    return inputs.durvalumab.currentIdentifier === 'close';
};
var isIpilimumabOpened = function () {
    return inputs.ipilimumab.currentIdentifier === 'close';
};
var isCemiplimabOpened = function () {
    return inputs.cemiplimab.currentIdentifier === 'close';
};
var returnVisibleQuestions = function () {
    visibleQuestions.indication1 = isNivolumab1Opened();
    visibleQuestions.name1 = isNivolumab1Opened();
    visibleQuestions.smpcLink1 = isNivolumab1Opened();
    visibleQuestions.indication2 = isNivolumab2Opened();
    visibleQuestions.name2 = isNivolumab2Opened();
    visibleQuestions.smpcLink2 = isNivolumab2Opened();
    visibleQuestions.indication3 = isPembrolizumab1Opened();
    visibleQuestions.name3 = isPembrolizumab1Opened();
    visibleQuestions.smpcLink3 = isPembrolizumab1Opened();
    visibleQuestions.indication4 = isPembrolizumab2Opened();
    visibleQuestions.name4 = isPembrolizumab2Opened();
    visibleQuestions.smpcLink4 = isPembrolizumab2Opened();
    visibleQuestions.indication5 = isPembrolizumab3Opened();
    visibleQuestions.name5 = isPembrolizumab3Opened();
    visibleQuestions.smpcLink5 = isPembrolizumab3Opened();
    visibleQuestions.indication6 = isPembrolizumab4Opened();
    visibleQuestions.name6 = isPembrolizumab4Opened();
    visibleQuestions.smpcLink6 = isPembrolizumab4Opened();
    visibleQuestions.indication7 = isAtezolizumab1Opened();
    visibleQuestions.name7 = isAtezolizumab1Opened();
    visibleQuestions.smpcLink7 = isAtezolizumab1Opened();
    visibleQuestions.indication8 = isAtezolizumab2Opened();
    visibleQuestions.name8 = isAtezolizumab2Opened();
    visibleQuestions.smpcLink8 = isAtezolizumab2Opened();
    visibleQuestions.indication9 = isAtezolizumab3Opened();
    visibleQuestions.name9 = isAtezolizumab3Opened();
    visibleQuestions.smpcLink9 = isAtezolizumab3Opened();
    visibleQuestions.indication10 = isAtezolizumab4Opened();
    visibleQuestions.name10 = isAtezolizumab4Opened();
    visibleQuestions.smpcLink10 = isAtezolizumab4Opened();
    visibleQuestions.indication11 = isDurvalumabOpened();
    visibleQuestions.name11 = isDurvalumabOpened();
    visibleQuestions.smpcLink11 = isDurvalumabOpened();
    visibleQuestions.indication12 = isIpilimumabOpened();
    visibleQuestions.name12 = isIpilimumabOpened();
    visibleQuestions.smpcLink12 = isIpilimumabOpened();
    visibleQuestions.indication13 = isCemiplimabOpened();
    visibleQuestions.name13 = isCemiplimabOpened();
    visibleQuestions.smpcLink13 = isCemiplimabOpened();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return true;
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
