"use strict";

var visibleQuestions = {
    nivolumab1: true,
    indication1: false,
    name1: false,
    smpcLink1: false,
    nivolumab2: true,
    indication2: false,
    name2: false,
    smpcLink2: false,
    nivolumab3: true,
    indication3: false,
    name3: false,
    smpcLink3: false,
    pembrolizumab: true,
    indication4: false,
    name4: false,
    smpcLink4: false
};
var visibleSections = {
    section1: true,
    section2: true,
    section3: true,
    section4: true
};
var inputs = {
    nivolumab1: null,
    nivolumab2: null,
    nivolumab3: null,
    pembrolizumab: null
};
var isNivolumab1Opened = function () {
    return inputs.nivolumab1.currentIdentifier === 'close';
};
var isNivolumab2Opened = function () {
    return inputs.nivolumab2.currentIdentifier === 'close';
};
var isNivolumab3Opened = function () {
    return inputs.nivolumab3.currentIdentifier === 'close';
};
var isPembrolizumabOpened = function () {
    return inputs.pembrolizumab.currentIdentifier === 'close';
};
var returnVisibleQuestions = function () {
    visibleQuestions.indication1 = isNivolumab1Opened();
    visibleQuestions.name1 = isNivolumab1Opened();
    visibleQuestions.smpcLink1 = isNivolumab1Opened();
    visibleQuestions.indication2 = isNivolumab2Opened();
    visibleQuestions.name2 = isNivolumab2Opened();
    visibleQuestions.smpcLink2 = isNivolumab2Opened();
    visibleQuestions.indication3 = isNivolumab3Opened();
    visibleQuestions.name3 = isNivolumab3Opened();
    visibleQuestions.smpcLink3 = isNivolumab3Opened();
    visibleQuestions.indication4 = isPembrolizumabOpened();
    visibleQuestions.name4 = isPembrolizumabOpened();
    visibleQuestions.smpcLink4 = isPembrolizumabOpened();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return true;
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
