"use strict";

var visibleQuestions = {
    nivolumab1: true,
    indication1: false,
    name1: false,
    smpcLink1: false,
    nivolumab2: true,
    indication2: false,
    name2: false,
    smpcLink2: false,
    nivolumab3: true,
    indication3: false,
    name3: false,
    smpcLink3: false,
    pembrolizumab: true,
    indication4: false,
    name4: false,
    smpcLink4: false,
    avelumab: true,
    indication5: false,
    name5: false,
    smpcLink5: false,
    ipilimumab: true,
    indication6: false,
    name6: false,
    smpcLink6: false
};
var visibleSections = {
    section1: true,
    section2: true,
    section3: true,
    section4: true,
    section5: true,
    section6: true
};
var inputs = {
    nivolumab1: null,
    nivolumab2: null,
    nivolumab3: null,
    pembrolizumab: null,
    avelumab: null,
    ipilimumab: null
};
var isNivomulab1Opened = function () {
    return inputs.nivolumab1.currentIdentifier === 'close';
};
var isNivomulab2Opened = function () {
    return inputs.nivolumab2.currentIdentifier === 'close';
};
var isNivomulab3Opened = function () {
    return inputs.nivolumab3.currentIdentifier === 'close';
};
var isPembrolizumabOpened = function () {
    return inputs.pembrolizumab.currentIdentifier === 'close';
};
var isAvelumabOpened = function () {
    return inputs.avelumab.currentIdentifier === 'close';
};
var isIpilimumabOpened = function () {
    return inputs.ipilimumab.currentIdentifier === 'close';
};
var returnVisibleQuestions = function () {
    visibleQuestions.indication1 = isNivomulab1Opened();
    visibleQuestions.name1 = isNivomulab1Opened();
    visibleQuestions.smpcLink1 = isNivomulab1Opened();
    visibleQuestions.indication2 = isNivomulab2Opened();
    visibleQuestions.name2 = isNivomulab2Opened();
    visibleQuestions.smpcLink2 = isNivomulab2Opened();
    visibleQuestions.indication3 = isNivomulab3Opened();
    visibleQuestions.name3 = isNivomulab3Opened();
    visibleQuestions.smpcLink3 = isNivomulab3Opened();
    visibleQuestions.indication4 = isPembrolizumabOpened();
    visibleQuestions.name4 = isPembrolizumabOpened();
    visibleQuestions.smpcLink4 = isPembrolizumabOpened();
    visibleQuestions.indication5 = isAvelumabOpened();
    visibleQuestions.name5 = isAvelumabOpened();
    visibleQuestions.smpcLink5 = isAvelumabOpened();
    visibleQuestions.indication6 = isIpilimumabOpened();
    visibleQuestions.name6 = isIpilimumabOpened();
    visibleQuestions.smpcLink6 = isIpilimumabOpened();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return true;
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
