"use strict";

var numberRounding_1 = {

    roundNumber: function(input, decimals) {
        if (decimals === void 0) {
            decimals = 0;
        }
        if (typeof input === 'number')
            input = input.toString();
        var isNegative = false;
        if (input[0] === '-') {
            isNegative = true;
            input = input.substring(1);
        }
        var parts = input.split('.');
        var integerPart = parts[0];
        var decimalPart = parts[1];
        if (decimals < 0) {
            decimals = -decimals;
            if (integerPart.length <= decimals)
                return '0';
            var prefix = integerPart.substring(0, integerPart.length - decimals);
            input =
                prefix +
                '.' +
                integerPart.substring(integerPart.length - decimals) +
                decimalPart;
            prefix = numberRounding_1.roundNumber(input, 0);
            return numberRounding_1.formatResult(isNegative, prefix + new Array(decimals + 1).join('0'));
        }
        if (decimals === 0) {
            if (numberRounding_1.shouldRoundUp(parts[1])) {
                return numberRounding_1.formatResult(isNegative, numberRounding_1.increment(integerPart));
            }
            return numberRounding_1.formatResult(isNegative, integerPart);
        }
        if (!parts[1]) {
            return numberRounding_1.formatResult(isNegative, integerPart, new Array(decimals + 1).join('0'));
        } else if (parts[1].length < decimals) {
            return numberRounding_1.formatResult(isNegative, integerPart, parts[1] + new Array(decimals - parts[1].length + 1).join('0'));
        }
        decimalPart = parts[1].substring(0, decimals);
        var remainingDecimals = parts[1].substring(decimals);
        if (remainingDecimals && numberRounding_1.shouldRoundUp(remainingDecimals)) {
            decimalPart = numberRounding_1.increment(decimalPart);
            if (decimalPart.length > decimals) {
                return numberRounding_1.formatResult(isNegative, numberRounding_1.increment(integerPart, parseInt(decimalPart[0])), decimalPart.substring(1));
            }
        }
        return numberRounding_1.formatResult(isNegative, integerPart, decimalPart);
    },

    shouldRoundUp: function(part) {
        if (!part || part === new Array(part.length + 1).join('0'))
            return false;
        if (Number(part[0]) >= 5) {
            return true;
        }
        return false;
    },

    increment: function(part, c) {
        if (c === void 0) {
            c = 0;
        }
        if (!c)
            c = 1;
        if (typeof part === 'number')
            part.toString();
        var l = part.length - 1;
        var s = '';
        for (var i = l; i >= 0; i--) {
            var x = parseInt(part[i]) + c;
            if (x === 10) {
                c = 1;
                x = 0;
            } else {
                c = 0;
            }
            s += x;
        }
        if (c)
            s += c;
        return s.split('').reverse().join('');
    },

    formatResult(negative, integerPart, decimalPart) {
        var result = (negative ? '-' : '') + integerPart;
        if (decimalPart) {
            result += '.' + decimalPart;
        }
        return result;
    }

}
