"use strict";

var visibleQuestions = {
    cardiacFunction: true,
    FEV: true,
    DLCO: true,
    VO2max: true,
    ppoFEV1: true,
    ppoDLCO: true,
    ppoVO2Max: true,
    result21: true,
    result212: false,
    result222: false,
    result232: false
};
var visibleSections = {
    questions: true,
    resultSection2: true,
    resultSection22: true
};
var inputs = {
    FEV: null,
    DLCO: null,
    VO2max: null,
    ppoFEV1: null,
    ppoDLCO: null,
    ppoVO2Max: null
};
var VO2maxVisibility = function () {
    if (!(helpers_1.isAnswered(inputs.FEV) && helpers_1.isAnswered(inputs.DLCO)))
        return false;
    if (inputs.FEV.currentIdentifier == "lessthan")
        return true;
    if (inputs.DLCO.currentIdentifier == "lessthan")
        return true;
    return false;
};
var ppoFEV1Visibility = function () {
    if (!VO2maxVisibility())
        return false;
    if (inputs.VO2max.currentIdentifier == "between")
        return true;
    return false;
};
var ppoDLCOVisibility = function () {
    if (!VO2maxVisibility())
        return false;
    if (inputs.VO2max.currentIdentifier == "between")
        return true;
    return false;
};
var ppoVO2MaxVisibility = function () {
    if (!(helpers_1.isAnswered(inputs.ppoFEV1) && helpers_1.isAnswered(inputs.ppoDLCO)))
        return false;
    if (ppoFEV1Visibility() && inputs.ppoFEV1.currentIdentifier == "lessthan")
        return true;
    if (ppoDLCOVisibility() && inputs.ppoDLCO.currentIdentifier == "lessthan")
        return true;
    return false;
};
var answerAllVisibility = function () {
    if (!helpers_1.isAnswered(inputs.FEV))
        return true;
    if (!helpers_1.isAnswered(inputs.DLCO))
        return true;
    if (VO2maxVisibility() && !helpers_1.isAnswered(inputs.VO2max))
        return true;
    if (ppoFEV1Visibility() && !helpers_1.isAnswered(inputs.ppoFEV1))
        return true;
    if (ppoDLCOVisibility() && !helpers_1.isAnswered(inputs.ppoDLCO))
        return true;
    if (ppoVO2MaxVisibility() && !helpers_1.isAnswered(inputs.ppoVO2Max))
        return true;
    return false;
};
var resultSection22Visibility = function () {
    return !answerAllVisibility();
};
var result212Visibility = function () {
    if (VO2maxVisibility() && inputs.VO2max.currentIdentifier == "lessthan")
        return true;
    if (ppoVO2MaxVisibility() &&
        inputs.ppoVO2Max.currentIdentifier == "lessthan")
        return true;
    return false;
};
var result222Visibility = function () {
    if (ppoFEV1Visibility() &&
        ppoDLCOVisibility() &&
        inputs.ppoFEV1.currentIdentifier == "morethan" &&
        inputs.ppoDLCO.currentIdentifier == "morethan")
        return true;
    if (ppoVO2MaxVisibility() &&
        inputs.ppoVO2Max.currentIdentifier == "morethan")
        return true;
    return false;
};
var result232Visibility = function () {
    if (inputs.FEV.currentIdentifier == "morethan" &&
        inputs.DLCO.currentIdentifier == "morethan")
        return true;
    if (VO2maxVisibility() && inputs.VO2max.currentIdentifier == "morethan")
        return true;
    return false;
};
var returnVisibleQuestions = function () {
    visibleQuestions.VO2max = VO2maxVisibility();
    visibleQuestions.ppoFEV1 = ppoFEV1Visibility();
    visibleQuestions.ppoDLCO = ppoDLCOVisibility();
    visibleQuestions.ppoVO2Max = ppoVO2MaxVisibility();
    visibleQuestions.result212 = result212Visibility();
    visibleQuestions.result222 = result222Visibility();
    visibleQuestions.result232 = result232Visibility();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.resultSection2 = answerAllVisibility();
    visibleSections.resultSection22 = resultSection22Visibility();
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    return {
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
