"use strict";


var visibleQuestions = {
    visualAcuity: true,
    cornealThickness: false,
    'BRVO-CRVOCriteria': false,
    'BRVO-CRVOCriteria2': false,
    'BRVO-CRVOExclusionCriteria': false,
    answerAll: true,
    notReimbursed: false,
    eylea: false,
    lucentis: false,
    ozurdex: false
};
var visibleSections = {
    questions: true,
    results: true
};
var inputs = {
    visualAcuity: null,
    cornealThickness: null,
    'BRVO-CRVOCriteria': null,
    'BRVO-CRVOCriteria2': null,
    'BRVO-CRVOExclusionCriteria': null
};
var isCornealThicknessVisible = function () {
    return (helpers_1.isAnswered(inputs.visualAcuity) &&
        !(helpers_1.answerMatches(inputs.visualAcuity, 'aboveTwelve') ||
            helpers_1.answerMatches(inputs.visualAcuity, 'lessThanHundredTwenty')));
};
var isBRVOCRVOCriteriaVisible = function () {
    return (helpers_1.answerMatches(inputs.cornealThickness, 'aboveTwoHundredFifty') ||
        helpers_1.answerMatches(inputs.cornealThickness, 'aboveOrEqualsThreeHundred'));
};
var isBRVOCRVOCriteria2Visible = function () {
    return helpers_1.answerMatches(inputs['BRVO-CRVOCriteria'], 'yes');
};
var isBRVOCRVOExclusionCriteriaVisible = function () {
    return helpers_1.isAnswered(inputs['BRVO-CRVOCriteria2']);
};
var isAnswerAllVisible = function () {
    if (isBRVOCRVOCriteriaVisible() &&
        (!helpers_1.isAnswered(inputs['BRVO-CRVOCriteria']) ||
            helpers_1.answerMatches(inputs['BRVO-CRVOCriteria'], 'yes')) &&
        !helpers_1.isAnswered(inputs['BRVO-CRVOExclusionCriteria'])) {
        return true;
    }
    if (isCornealThicknessVisible() &&
        !isBRVOCRVOCriteriaVisible() &&
        (!helpers_1.isAnswered(inputs.cornealThickness) ||
            !helpers_1.answerMatches(inputs.cornealThickness, 'lessThanTwoHundredFifty'))) {
        return true;
    }
    if (!helpers_1.isAnswered(inputs.visualAcuity) &&
        !(helpers_1.answerMatches(inputs.visualAcuity, 'aboveTwelve') ||
            helpers_1.answerMatches(inputs.visualAcuity, 'lessThanHundredTwenty'))) {
        return true;
    }
    return false;
};
var isNotReimbursedVisible = function () {
    return (!isAnswerAllVisible() &&
        !(isEyleaVisible() || isLucentisVisible() || isOzurdexVisible()));
};
var isEyleaVisible = function () {
    return ((helpers_1.answerMatches(inputs.visualAcuity, 'twelveToFifteen') ||
        helpers_1.answerMatches(inputs.visualAcuity, 'fifteenToSixty') ||
        helpers_1.answerMatches(inputs.visualAcuity, 'sixtyToNinetySix')) &&
        (helpers_1.answerMatches(inputs.cornealThickness, 'aboveTwoHundredFifty') ||
            helpers_1.answerMatches(inputs.cornealThickness, 'aboveOrEqualsThreeHundred')) &&
        helpers_1.answerMatches(inputs['BRVO-CRVOCriteria'], 'yes') &&
        helpers_1.answerMatches(inputs['BRVO-CRVOCriteria2'], 'yes') &&
        helpers_1.answerMatches(inputs['BRVO-CRVOExclusionCriteria'], 'yes'));
};
var isLucentisVisible = function () {
    return ((helpers_1.answerMatches(inputs.visualAcuity, 'twelveToFifteen') ||
        helpers_1.answerMatches(inputs.visualAcuity, 'fifteenToSixty') ||
        helpers_1.answerMatches(inputs.visualAcuity, 'sixtyToNinetySix') ||
        helpers_1.answerMatches(inputs.visualAcuity, 'ninetySixToHundredTwenty')) &&
        (helpers_1.answerMatches(inputs.cornealThickness, 'aboveTwoHundredFifty') ||
            helpers_1.answerMatches(inputs.cornealThickness, 'aboveOrEqualsThreeHundred')) &&
        helpers_1.answerMatches(inputs['BRVO-CRVOCriteria'], 'yes') &&
        helpers_1.answerMatches(inputs['BRVO-CRVOCriteria2'], 'yes') &&
        helpers_1.answerMatches(inputs['BRVO-CRVOExclusionCriteria'], 'yes'));
};
var isOzurdexVisible = function () {
    return (helpers_1.answerMatches(inputs.visualAcuity, 'fifteenToSixty') &&
        helpers_1.answerMatches(inputs.cornealThickness, 'aboveOrEqualsThreeHundred') &&
        helpers_1.answerMatches(inputs['BRVO-CRVOCriteria'], 'yes') &&
        helpers_1.isAnswered(inputs['BRVO-CRVOExclusionCriteria']));
};
var returnVisibleQuestions = function () {
    visibleQuestions.cornealThickness = isCornealThicknessVisible();
    visibleQuestions['BRVO-CRVOCriteria'] = isBRVOCRVOCriteriaVisible();
    visibleQuestions['BRVO-CRVOCriteria2'] = isBRVOCRVOCriteria2Visible();
    visibleQuestions['BRVO-CRVOExclusionCriteria'] =
        isBRVOCRVOExclusionCriteriaVisible();
    visibleQuestions.answerAll = isAnswerAllVisible();
    visibleQuestions.notReimbursed = isNotReimbursedVisible();
    visibleQuestions.eylea = isEyleaVisible();
    visibleQuestions.lucentis = isLucentisVisible();
    visibleQuestions.ozurdex = isOzurdexVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return false;
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: null,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
