"use strict";


var visibleQuestions = {
    'CNV-PMCriteria': true,
    'CNV-PMCExclusionCriteria': true,
    answerAll: true,
    notReimbursed: false,
    eylea: false,
    lucentis: false
};
var visibleSections = {
    questions: true,
    results: true
};
var inputs = {
    'CNV-PMCriteria': null,
    'CNV-PMCExclusionCriteria': null
};
var isCNVPMCExclusionCriteriaVisible = function () {
    return helpers_1.answerMatches(inputs['CNV-PMCriteria'], 'yes');
};
var isAnswerAllVisible = function () {
    return (!helpers_1.isAnswered(inputs['CNV-PMCriteria']) ||
        (helpers_1.answerMatches(inputs['CNV-PMCriteria'], 'yes') &&
            !helpers_1.isAnswered(inputs['CNV-PMCExclusionCriteria'])));
};
var isNotReimbursedVisible = function () {
    return (helpers_1.answerMatches(inputs['CNV-PMCriteria'], 'no') ||
        helpers_1.answerMatches(inputs['CNV-PMCExclusionCriteria'], 'no'));
};
var isLucentisAndEyleaVisible = function () {
    return (helpers_1.answerMatches(inputs['CNV-PMCriteria'], 'yes') &&
        helpers_1.answerMatches(inputs['CNV-PMCExclusionCriteria'], 'yes'));
};
var returnVisibleQuestions = function () {
    visibleQuestions['CNV-PMCExclusionCriteria'] =
        isCNVPMCExclusionCriteriaVisible();
    visibleQuestions.answerAll = isAnswerAllVisible();
    visibleQuestions.notReimbursed = isNotReimbursedVisible();
    visibleQuestions.lucentis = isLucentisAndEyleaVisible();
    visibleQuestions.eylea = isLucentisAndEyleaVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return false;
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: null,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
