"use strict";


var visibleQuestions = {
    DMECriteria: true,
    DMEExclusionCriteria: false,
    answerAll: true,
    notReimbursed: false,
    eylea: false,
    lucentis: false
};
var visibleSections = {
    questions: true,
    results: true
};
var inputs = {
    DMECriteria: null,
    DMEExclusionCriteria: null
};
var isDMEExclusionCriteriaVisible = function () {
    return (helpers_1.isAnswered(inputs.DMECriteria) && helpers_1.answerMatches(inputs.DMECriteria, 'yes'));
};
var isAnswerAllVisible = function () {
    return (!helpers_1.isAnswered(inputs.DMECriteria) ||
        (helpers_1.answerMatches(inputs.DMECriteria, 'yes') &&
            !helpers_1.isAnswered(inputs.DMEExclusionCriteria)));
};
var isNotReimbursedVisible = function () {
    return (helpers_1.answerMatches(inputs.DMECriteria, 'no') ||
        helpers_1.answerMatches(inputs.DMEExclusionCriteria, 'no'));
};
var isLucentisAndEyleaVisible = function () {
    return (helpers_1.answerMatches(inputs.DMECriteria, 'yes') &&
        helpers_1.answerMatches(inputs.DMEExclusionCriteria, 'yes'));
};
var returnVisibleQuestions = function () {
    visibleQuestions.DMEExclusionCriteria = isDMEExclusionCriteriaVisible();
    visibleQuestions.answerAll = isAnswerAllVisible();
    visibleQuestions.notReimbursed = isNotReimbursedVisible();
    visibleQuestions.eylea = isLucentisAndEyleaVisible();
    visibleQuestions.lucentis = isLucentisAndEyleaVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return false;
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: null,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
