"use strict";

var visibleQuestions = {
    PETCT: true,
    lymphNodes: false,
    location: false,
    size: false,
    EBUSorVAM: false,
    EBUS: false,
    VAM: false,
    answerAll: true,
    operation: false,
    multimodalTreatment: false
};
var visibleSections = {
    questions: true,
    resultSection: true
};
var inputs = {
    PETCT: null,
    lymphNodes: null,
    location: null,
    size: null,
    EBUSorVAM: null,
    EBUS: null,
    VAM: null
};
var lymphNodesVisibility = function () {
    if (inputs.PETCT.currentIdentifier == "negative")
        return true;
    return false;
};
var locationVisibility = function () {
    if (lymphNodesVisibility() && helpers_1.isAnswered(inputs.lymphNodes))
        return true;
    return false;
};
var sizeVisibility = function () {
    if (locationVisibility() && helpers_1.isAnswered(inputs.location))
        return true;
    return false;
};
var EBUSorVAMVisibility = function () {
    if (lymphNodesVisibility() &&
        locationVisibility() &&
        sizeVisibility() &&
        helpers_1.isAnswered(inputs.lymphNodes) &&
        helpers_1.isAnswered(inputs.location) &&
        helpers_1.isAnswered(inputs.size) &&
        (inputs.lymphNodes.currentIdentifier == "n1" ||
            inputs.location.currentIdentifier == "central" ||
            inputs.size.currentIdentifier == "gt3"))
        return true;
    return false;
};
var EBUSVisibility = function () {
    if (inputs.PETCT.currentIdentifier == "positive")
        return true;
    return false;
};
var VAMVisibility = function () {
    if (EBUSVisibility() && inputs.EBUS.currentIdentifier == "negative")
        return true;
    return false;
};
var answerAllVisibility = function () {
    if (!helpers_1.isAnswered(inputs.PETCT))
        return true;
    if (lymphNodesVisibility() && !helpers_1.isAnswered(inputs.lymphNodes))
        return true;
    if (locationVisibility() && !helpers_1.isAnswered(inputs.location))
        return true;
    if (sizeVisibility() && !helpers_1.isAnswered(inputs.size))
        return true;
    if (EBUSorVAMVisibility() && !helpers_1.isAnswered(inputs.EBUSorVAM))
        return true;
    if (EBUSVisibility() && !helpers_1.isAnswered(inputs.EBUS))
        return true;
    if (VAMVisibility() && !helpers_1.isAnswered(inputs.VAM))
        return true;
    return false;
};
var operationVisibility = function () {
    if (lymphNodesVisibility() &&
        helpers_1.isAnswered(inputs.lymphNodes) &&
        inputs.lymphNodes.currentIdentifier == "n0" &&
        locationVisibility() &&
        helpers_1.isAnswered(inputs.location) &&
        inputs.location.currentIdentifier == "pripheral" &&
        sizeVisibility() &&
        helpers_1.isAnswered(inputs.size) &&
        inputs.size.currentIdentifier == "lt3")
        return true;
    if (EBUSorVAMVisibility() &&
        helpers_1.isAnswered(inputs.EBUSorVAM) &&
        inputs.EBUSorVAM.currentIdentifier == "negative")
        return true;
    if (VAMVisibility() &&
        helpers_1.isAnswered(inputs.VAM) &&
        inputs.VAM.currentIdentifier == "negative")
        return true;
    return false;
};
var multimodalTreatmentVisibility = function () {
    if (EBUSorVAMVisibility() &&
        helpers_1.isAnswered(inputs.EBUSorVAM) &&
        inputs.EBUSorVAM.currentIdentifier == "positive")
        return true;
    if (VAMVisibility() &&
        helpers_1.isAnswered(inputs.VAM) &&
        inputs.VAM.currentIdentifier == "positive")
        return true;
    if (EBUSVisibility() &&
        helpers_1.isAnswered(inputs.EBUS) &&
        inputs.EBUS.currentIdentifier == "positive")
        return true;
    return false;
};
var returnVisibleQuestions = function () {
    visibleQuestions.lymphNodes = lymphNodesVisibility();
    visibleQuestions.location = locationVisibility();
    visibleQuestions.size = sizeVisibility();
    visibleQuestions.EBUSorVAM = EBUSorVAMVisibility();
    visibleQuestions.EBUS = EBUSVisibility();
    visibleQuestions.VAM = VAMVisibility();
    visibleQuestions.answerAll = answerAllVisibility();
    visibleQuestions.operation = operationVisibility();
    visibleQuestions.multimodalTreatment = multimodalTreatmentVisibility();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    return {
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
