"use strict";


var visibleQuestions = {
    age: true,
    creatinine: false,
    childrenText: true,
    warning: true,
    dosing: true,
    duration: true,
    dosingLow: true,
    dosingLowSecond: true,
    durationLow: true,
    dosingLowVery: true,
    dosingLowSecondVery: true,
    durationLowVery: true,
    guidelinesText: true,
    noAnswer: true
};
var visibleSections = {
    ageSelection: true,
    kinderSection: false,
    warningSection: false,
    adultsSection: false,
    adultsSectionLow: false,
    adultsSectionLowVery: false,
    guidelines: false,
    noAnswerSection: false
};
var inputs = {
    age: null,
    creatinine: null
};
var calculatePoints = function () {
    return null;
};
var isCreatinineVisible = function () { return helpers_1.answerMatches(inputs.age, 'adults'); };
var isKinderSectionVisible = function () { return helpers_1.answerMatches(inputs.age, 'children'); };
var isWarningSectionVisible = function () { return helpers_1.answerMatches(inputs.age, 'adults'); };
var isAdultsSectionVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'adults') &&
        helpers_1.answerMatches(inputs.creatinine, 'normal'));
};
var isAdultsSectionLowVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'adults') &&
        helpers_1.answerMatches(inputs.creatinine, 'low'));
};
var isAdultsSectionLowVeryVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'adults') &&
        helpers_1.answerMatches(inputs.creatinine, 'veryLow'));
};
var isGuidelinesVisible = function () { return helpers_1.answerMatches(inputs.age, 'adults'); };
var isNoAnswerSectionVisible = function () {
    return (!helpers_1.isAnswered(inputs.age) ||
        (isCreatinineVisible() && !helpers_1.isAnswered(inputs.creatinine)));
};
var returnVisibleQuestions = function () {
    visibleQuestions.creatinine = isCreatinineVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.kinderSection = isKinderSectionVisible();
    visibleSections.warningSection = isWarningSectionVisible();
    visibleSections.adultsSection = isAdultsSectionVisible();
    visibleSections.adultsSectionLow = isAdultsSectionLowVisible();
    visibleSections.adultsSectionLowVery = isAdultsSectionLowVeryVisible();
    visibleSections.guidelines = isGuidelinesVisible();
    visibleSections.noAnswerSection = isNoAnswerSectionVisible();
    return visibleSections;
};
var ut_toolScore = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return !isNoAnswerSectionVisible();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: { number: result, range: result },
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
