"use strict";


var visibleQuestions = {
    age: true,
    creatinine: false,
    childrenText: true,
    dosingInfusion: true,
    durationInfusion: true,
    dosing: true,
    duration: true,
    dosingSecond: true,
    durationSecond: true,
    dosingInfusionLow: true,
    dosingInfusionLowSecond: true,
    durationInfusionLow: true,
    dosingSecondLow: true,
    dosingLowSecond: true,
    durationSecondLow: true,
    dosingInfusionLowVery: true,
    dosingInfusionLowVerySecond: true,
    durationInfusionLowVery: true,
    dosingSecondLowVery: true,
    dosingLowSecondVery: true,
    durationSecondLowLow: true,
    gudelinesText: true
};
var visibleSections = {
    ageSelection: true,
    kinderSection: false,
    infusionSection: false,
    adultsSection: false,
    adultsSecond: false,
    infusionSectionLow: false,
    adultsSecondLow: false,
    infusionSectionLowVery: false,
    adultsSecondLowVery: false,
    guidelines: false
};
var inputs = {
    age: null,
    creatinine: null
};
var calculatePoints = function () {
    return null;
};
var isCreatinineVisible = function () { return helpers_1.answerMatches(inputs.age, 'adults'); };
var isKinderSectionVisible = function () { return helpers_1.answerMatches(inputs.age, 'children'); };
var isAdultsSectionVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'adults') &&
        helpers_1.answerMatches(inputs.creatinine, 'normal'));
};
var isAdultsSectionLowVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'adults') &&
        helpers_1.answerMatches(inputs.creatinine, 'low'));
};
var isAdultsSectionLowVeryVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'adults') &&
        helpers_1.answerMatches(inputs.creatinine, 'veryLow'));
};
var isGuidelinesVisible = function () { return helpers_1.answerMatches(inputs.age, 'adults'); };
var returnVisibleQuestions = function () {
    visibleQuestions.creatinine = isCreatinineVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.kinderSection = isKinderSectionVisible();
    visibleSections.infusionSection = isAdultsSectionVisible();
    visibleSections.adultsSection = isAdultsSectionVisible();
    visibleSections.adultsSecond = isAdultsSectionVisible();
    visibleSections.infusionSectionLow = isAdultsSectionLowVisible();
    visibleSections.adultsSecondLow = isAdultsSectionLowVisible();
    visibleSections.infusionSectionLowVery = isAdultsSectionLowVeryVisible();
    visibleSections.adultsSecondLowVery = isAdultsSectionLowVeryVisible();
    visibleSections.guidelines = isGuidelinesVisible();
    return visibleSections;
};
var ut_toolScore = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return true;
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: { number: result, range: result },
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
