"use strict";

var visibleQuestions = {
    PETCT: true,
    invasiveDiagnosisNeg1: false,
    invasiveDiagnosisNeg2: false,
    invasiveDiagnosisPos: false,
    n2: false,
    N2randomly: false,
    N2resectable: false,
    N2nonresectable: false,
    council: false,
    chemotherapy: false,
    surgicalTherapy: false,
    nonsurgicalTherapy: false
};
var visibleSections = {
    questions: true
};
var inputs = {
    PETCT: null,
    invasiveDiagnosisPos: null,
    n2: null
};
var invasiveDiagnosisNeg1Visibility = function () {
    if (helpers_1.isAnswered(inputs.PETCT) &&
        inputs.PETCT.currentIdentifier == "peripheralTumor")
        return true;
    return false;
};
var invasiveDiagnosisNeg2Visibility = function () {
    if (helpers_1.isAnswered(inputs.PETCT) &&
        inputs.PETCT.currentIdentifier == "infiltration")
        return true;
    return false;
};
var invasiveDiagnosisPosVisibility = function () {
    if (helpers_1.isAnswered(inputs.PETCT) &&
        inputs.PETCT.currentIdentifier == "centralTumor")
        return true;
    return false;
};
var n2Visibility = function () {
    if (invasiveDiagnosisPosVisibility() &&
        helpers_1.isAnswered(inputs.invasiveDiagnosisPos) &&
        inputs.invasiveDiagnosisPos.currentIdentifier == "n2")
        return true;
    return false;
};
var N2randomlyVisibility = function () {
    if (helpers_1.isAnswered(inputs.PETCT) &&
        inputs.PETCT.currentIdentifier == "peripheralTumor")
        return true;
    if (invasiveDiagnosisPosVisibility() &&
        helpers_1.isAnswered(inputs.invasiveDiagnosisPos) &&
        inputs.invasiveDiagnosisPos.currentIdentifier == "n0n1")
        return true;
    return false;
};
var N2resectableVisibility = function () {
    if (n2Visibility() &&
        helpers_1.isAnswered(inputs.n2) &&
        inputs.n2.currentIdentifier == "n21")
        return true;
    return false;
};
var N2nonresectableVisibility = function () {
    if (helpers_1.isAnswered(inputs.PETCT) &&
        inputs.PETCT.currentIdentifier == "infiltration")
        return true;
    if (n2Visibility() &&
        helpers_1.isAnswered(inputs.n2) &&
        inputs.n2.currentIdentifier == "n22")
        return true;
    return false;
};
var councilVisibility = function () {
    if (chemotherapyVisibility() ||
        surgicalTherapyVisibility() ||
        nonsurgicalTherapyVisibility())
        return true;
    return false;
};
var chemotherapyVisibility = function () {
    if (helpers_1.isAnswered(inputs.PETCT) &&
        inputs.PETCT.currentIdentifier == "peripheralTumor")
        return true;
    if (invasiveDiagnosisPosVisibility() &&
        helpers_1.isAnswered(inputs.invasiveDiagnosisPos) &&
        inputs.invasiveDiagnosisPos.currentIdentifier == "n0n1")
        return true;
    return false;
};
var surgicalTherapyVisibility = function () {
    if (n2Visibility() &&
        helpers_1.isAnswered(inputs.n2) &&
        inputs.n2.currentIdentifier == "n21")
        return true;
    return false;
};
var nonsurgicalTherapyVisibility = function () {
    if (helpers_1.isAnswered(inputs.PETCT) &&
        inputs.PETCT.currentIdentifier == "infiltration")
        return true;
    if (invasiveDiagnosisPosVisibility() &&
        helpers_1.isAnswered(inputs.invasiveDiagnosisPos) &&
        inputs.invasiveDiagnosisPos.currentIdentifier == "n3")
        return true;
    if (invasiveDiagnosisPosVisibility() &&
        n2Visibility() &&
        helpers_1.isAnswered(inputs.invasiveDiagnosisPos) &&
        inputs.invasiveDiagnosisPos.currentIdentifier == "n2" &&
        helpers_1.isAnswered(inputs.n2) &&
        inputs.n2.currentIdentifier == "n22")
        return true;
    return false;
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    visibleQuestions.invasiveDiagnosisNeg1 = invasiveDiagnosisNeg1Visibility();
    visibleQuestions.invasiveDiagnosisNeg2 = invasiveDiagnosisNeg2Visibility();
    visibleQuestions.invasiveDiagnosisPos = invasiveDiagnosisPosVisibility();
    visibleQuestions.n2 = n2Visibility();
    visibleQuestions.N2randomly = N2randomlyVisibility();
    visibleQuestions.N2resectable = N2resectableVisibility();
    visibleQuestions.N2nonresectable = N2nonresectableVisibility();
    visibleQuestions.council = councilVisibility();
    visibleQuestions.chemotherapy = chemotherapyVisibility();
    visibleQuestions.surgicalTherapy = surgicalTherapyVisibility();
    visibleQuestions.nonsurgicalTherapy = nonsurgicalTherapyVisibility();
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    return {
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});