"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var totalDoses = {
    mgDoses15: 0,
    mgDoses20: 0
};
var visibleQuestions = {
    dosingType: true,
    CrCl: false,
    warning: false,
    doseReducing: false,
    lastDose: false,
    weight: false,
    height: false,
    startDate: false,
    answerAll: true,
    bsaResult: false,
    loweredDailyDose: false,
    splitDailyDose: false,
    totalDailyDose: false,
    noTablets: false,
    noPackages: false,
    week1: false,
    wk1d1to5: false,
    wk1d6and7: false,
    week2: false,
    wk2d1to5: false,
    wk2d6and7: false,
    week3: false,
    wk3d1to7: false,
    week4: false,
    wk4d1to7: false,
    useMethod: false,
    warning1: false,
    warning3: false,
    warning4: false,
    warning5: false,
    warningNotRecommended: false
};
var visibleSections = {
    main: true,
    patientInfoSection: false,
    answerAllSection: true,
    doseSection: false,
    week1DoseSchemeSection: false,
    week2DoseSchemeSection: false,
    week3DoseSchemeSection: false,
    week4DoseSchemeSection: false,
    warningSection: false,
    deferredSection: false,
    warningNotRecommendedSection: false
};
var inputs = {
    dosingType: null,
    CrCl: null,
    lastDose: null,
    weight: null,
    height: null,
    startDate: null
};
var returnVisibleQuestions = function () {
    visibility();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibility();
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
function ut_formatTexts() {
    return calculatePoints();
}
var weekVisibility = function (weekNumber, status) {
    visibleSections["week" + weekNumber + "DoseSchemeSection"] = status;
    visibleQuestions["week" + weekNumber] = status;
    if (weekNumber < 3) {
        visibleQuestions["wk" + weekNumber + "d1to5"] = status;
        visibleQuestions["wk" + weekNumber + "d6and7"] = status;
    }
    else if (weekNumber >= 3) {
        visibleQuestions["wk" + weekNumber + "d1to7"] = status;
    }
};
var visibility = function () {
    weekVisibility(1, false);
    weekVisibility(2, false);
    weekVisibility(3, false);
    weekVisibility(4, false);
    visibleSections.warningSection = false;
    visibleSections.deferredSection = false;
    visibleSections.warningNotRecommendedSection = false;
    visibleQuestions.warningNotRecommended = false;
    visibleQuestions.warning1 = false;
    visibleQuestions.warning3 = false;
    visibleQuestions.warning4 = false;
    visibleQuestions.warning5 = false;
    visibleQuestions.smpcLink = true;
    visibleSections.patientInfoSection = false;
    visibleQuestions.lastDose = false;
    visibleQuestions.weight = false;
    visibleQuestions.height = false;
    visibleQuestions.startDate = false;
    visibleSections.answerAllSection = true;
    visibleQuestions.answerAll = true;
    visibleQuestions.warning = false;
    visibleQuestions.doseReducing = false;
    visibleSections.doseSection = false;
    visibleQuestions.bsaResult = false;
    visibleQuestions.splitDailyDose = false;
    visibleQuestions.totalDailyDose = false;
    visibleQuestions.noTablets = false;
    visibleQuestions.noPackages = false;
    visibleQuestions.useMethod = false;
    visibleQuestions.loweredDailyDose = false;
    if (!helpers_1.isAnswered(inputs.dosingType)) {
        return null;
    }
    else {
        visibleQuestions.CrCl = true;
    }
    if (inputs.dosingType.currentIdentifier === 'start') {
        switch (inputs.CrCl.currentIdentifier) {
            case 'low':
                visibleSections.warningNotRecommendedSection = true;
                visibleQuestions.warningNotRecommended = true;
                visibleQuestions.answerAll = false;
                visibleSections.answerAllSection = false;
                return null;
            case 'medium':
            case 'high':
                visibleQuestions.warning = true;
                visibleSections.warningSection = true;
                visibleSections.patientInfoSection = true;
                visibleQuestions.weight = true;
                visibleQuestions.height = true;
                visibleQuestions.startDate = true;
                break;
        }
    }
    else if (inputs.dosingType.currentIdentifier === 'lowered') {
        switch (inputs.CrCl.currentIdentifier) {
            case 'low':
                visibleSections.warningNotRecommendedSection = true;
                visibleQuestions.warningNotRecommended = true;
                visibleQuestions.answerAll = false;
                visibleSections.answerAllSection = false;
                return null;
            case 'medium':
            case 'high':
                visibleQuestions.doseReducing = true;
                visibleSections.warningSection = true;
                visibleSections.patientInfoSection = true;
                visibleQuestions.weight = true;
                visibleQuestions.height = true;
                visibleQuestions.startDate = true;
                break;
        }
        if (inputs.CrCl.currentIdentifier === 'high') {
            visibleQuestions.lastDose = true;
        }
    }
    if (!helpers_1.isAnswered(inputs.weight) ||
        Number(inputs.weight.currentPoints) < 1 ||
        Number(inputs.weight.currentPoints) > 300 ||
        !helpers_1.isAnswered(inputs.height) ||
        Number(inputs.height.currentPoints) < 1 ||
        Number(inputs.height.currentPoints) > 250 ||
        !helpers_1.isAnsweredDate(inputs.startDate)) {
        return null;
    }
    if (inputs.dosingType.currentIdentifier === 'lowered' &&
        inputs.CrCl.currentIdentifier === 'high' &&
        !helpers_1.isAnswered(inputs.lastDose)) {
        return null;
    }
    visibleQuestions.answerAll = false;
    visibleSections.answerAllSection = false;
    visibleSections.doseSection = true;
    visibleQuestions.bsaResult = true;
    visibleQuestions.splitDailyDose = true;
    visibleQuestions.totalDailyDose = true;
    visibleQuestions.noTablets = true;
    visibleQuestions.noPackages = true;
    visibleQuestions.useMethod = true;
    if (inputs.dosingType.currentIdentifier === 'start') {
        visibleQuestions.warning1 = true;
        visibleQuestions.warning3 = true;
    }
    if (inputs.dosingType.currentIdentifier === 'lowered') {
        if (inputs.CrCl.currentIdentifier === 'medium' ||
            inputs.CrCl.currentIdentifier === 'high') {
            visibleSections.deferredSection = true;
            visibleQuestions.warning4 = true;
            visibleQuestions.warning5 = true;
        }
        if (inputs.CrCl.currentIdentifier === 'medium') {
            visibleQuestions.loweredDailyDose = true;
        }
        else if (inputs.CrCl.currentIdentifier === 'high' &&
            helpers_1.isAnswered(inputs.lastDose)) {
            visibleQuestions.loweredDailyDose = true;
        }
    }
    weekVisibility(1, true);
    weekVisibility(2, true);
    weekVisibility(3, true);
    weekVisibility(4, true);
    return null;
};
var calculateBSA = function () {
    return helpers_1.formatCalculationResult(0.20247 *
        Math.pow(inputs.height.currentPoints / 100, 0.725) *
        Math.pow(inputs.weight.currentPoints, 0.425), 2);
};
var calculateDoses = function (BSA) {
    var doseInMg = 0;
    var tablet15Dose = 0;
    var tablet20Dose = 0;
    var reducedDose = 0;
    if (inputs.dosingType.currentIdentifier === 'start') {
        if (inputs.CrCl.currentIdentifier === 'high') {
            switch (true) {
                case BSA < 1.07:
                    doseInMg = 35;
                    tablet15Dose = 1;
                    tablet20Dose = 1;
                    break;
                case BSA < 1.23:
                    doseInMg = 40;
                    tablet15Dose = 0;
                    tablet20Dose = 2;
                    break;
                case BSA < 1.38:
                    doseInMg = 45;
                    tablet15Dose = 3;
                    tablet20Dose = 0;
                    break;
                case BSA < 1.53:
                    doseInMg = 50;
                    tablet15Dose = 2;
                    tablet20Dose = 1;
                    break;
                case BSA < 1.69:
                    doseInMg = 55;
                    tablet15Dose = 1;
                    tablet20Dose = 2;
                    break;
                case BSA < 1.84:
                    doseInMg = 60;
                    tablet15Dose = 0;
                    tablet20Dose = 3;
                    break;
                case BSA < 1.99:
                    doseInMg = 65;
                    tablet15Dose = 3;
                    tablet20Dose = 1;
                    break;
                case BSA < 2.15:
                    doseInMg = 70;
                    tablet15Dose = 2;
                    tablet20Dose = 2;
                    break;
                case BSA < 2.3:
                    doseInMg = 75;
                    tablet15Dose = 1;
                    tablet20Dose = 3;
                    break;
                default:
                    doseInMg = 80;
                    tablet15Dose = 0;
                    tablet20Dose = 4;
            }
        }
        else if (inputs.CrCl.currentIdentifier === 'medium') {
            switch (true) {
                case BSA < 1.14:
                    doseInMg = 20;
                    tablet15Dose = 0;
                    tablet20Dose = 1;
                    break;
                case BSA < 1.35:
                    doseInMg = 25;
                    tablet15Dose = 2;
                    tablet20Dose = 1;
                    break;
                case BSA < 1.6:
                    doseInMg = 30;
                    tablet15Dose = 2;
                    tablet20Dose = 0;
                    break;
                case BSA < 1.95:
                    doseInMg = 35;
                    tablet15Dose = 1;
                    tablet20Dose = 1;
                    break;
                case BSA < 2.1:
                    doseInMg = 40;
                    tablet15Dose = 0;
                    tablet20Dose = 2;
                    break;
                case BSA < 2.35:
                    doseInMg = 45;
                    tablet15Dose = 3;
                    tablet20Dose = 0;
                    break;
                default:
                    doseInMg = 50;
                    tablet15Dose = 2;
                    tablet20Dose = 1;
            }
        }
    }
    else if (inputs.dosingType.currentIdentifier === 'lowered') {
        if (inputs.CrCl.currentIdentifier === 'high') {
            switch (inputs.lastDose.currentIdentifier) {
                case 'twentyfive':
                    reducedDose = 25 - 5;
                    break;
                case 'thirty':
                    reducedDose = 30 - 5;
                    break;
                case 'thirtyfive':
                    reducedDose = 35 - 5;
                    break;
            }
            if (inputs.lastDose.currentIdentifier === 'thirtyfive') {
                switch (true) {
                    case BSA < 1.09:
                        doseInMg = 30;
                        tablet15Dose = 2;
                        tablet20Dose = 0;
                        break;
                    case BSA < 1.25:
                        doseInMg = 35;
                        tablet15Dose = 1;
                        tablet20Dose = 1;
                        break;
                    case BSA < 1.4:
                        doseInMg = 40;
                        tablet15Dose = 0;
                        tablet20Dose = 2;
                        break;
                    case BSA < 1.55:
                        doseInMg = 45;
                        tablet15Dose = 3;
                        tablet20Dose = 0;
                        break;
                    case BSA < 1.7:
                        doseInMg = 50;
                        tablet15Dose = 2;
                        tablet20Dose = 1;
                        break;
                    case BSA < 1.95:
                        doseInMg = 55;
                        tablet15Dose = 1;
                        tablet20Dose = 2;
                        break;
                    case BSA < 2.1:
                        doseInMg = 60;
                        tablet15Dose = 0;
                        tablet20Dose = 3;
                        break;
                    case BSA < 2.29:
                        doseInMg = 65;
                        tablet15Dose = 3;
                        tablet20Dose = 1;
                        break;
                    default:
                        doseInMg = 70;
                        tablet15Dose = 2;
                        tablet20Dose = 2;
                }
            }
            else if (inputs.lastDose.currentIdentifier === 'thirty') {
                switch (true) {
                    case BSA < 1.1:
                        doseInMg = 25;
                        tablet15Dose = 2;
                        tablet20Dose = 1;
                        break;
                    case BSA < 1.3:
                        doseInMg = 30;
                        tablet15Dose = 2;
                        tablet20Dose = 0;
                        break;
                    case BSA < 1.5:
                        doseInMg = 35;
                        tablet15Dose = 1;
                        tablet20Dose = 1;
                        break;
                    case BSA < 1.7:
                        doseInMg = 40;
                        tablet15Dose = 0;
                        tablet20Dose = 2;
                        break;
                    case BSA < 1.9:
                        doseInMg = 45;
                        tablet15Dose = 3;
                        tablet20Dose = 0;
                        break;
                    case BSA < 2.1:
                        doseInMg = 50;
                        tablet15Dose = 2;
                        tablet20Dose = 1;
                        break;
                    case BSA < 2.3:
                        doseInMg = 55;
                        tablet15Dose = 1;
                        tablet20Dose = 2;
                        break;
                    default:
                        doseInMg = 60;
                        tablet15Dose = 0;
                        tablet20Dose = 3;
                }
            }
            else if (inputs.lastDose.currentIdentifier === 'twentyfive') {
                switch (true) {
                    case BSA < 1.14:
                        doseInMg = 20;
                        tablet15Dose = 0;
                        tablet20Dose = 1;
                        break;
                    case BSA < 1.35:
                        doseInMg = 25;
                        tablet15Dose = 2;
                        tablet20Dose = 1;
                        break;
                    case BSA < 1.6:
                        doseInMg = 30;
                        tablet15Dose = 2;
                        tablet20Dose = 0;
                        break;
                    case BSA < 1.95:
                        doseInMg = 35;
                        tablet15Dose = 1;
                        tablet20Dose = 1;
                        break;
                    case BSA < 2.1:
                        doseInMg = 40;
                        tablet15Dose = 0;
                        tablet20Dose = 2;
                        break;
                    case BSA < 2.34:
                        doseInMg = 45;
                        tablet15Dose = 3;
                        tablet20Dose = 0;
                        break;
                    default:
                        doseInMg = 50;
                        tablet15Dose = 2;
                        tablet20Dose = 1;
                }
            }
        }
        else if (inputs.CrCl.currentIdentifier === 'medium') {
            reducedDose = 15;
            switch (true) {
                case BSA < 1.15:
                    doseInMg = 15;
                    tablet15Dose = 1;
                    tablet20Dose = 0;
                    break;
                case BSA < 1.5:
                    doseInMg = 20;
                    tablet15Dose = 0;
                    tablet20Dose = 1;
                    break;
                case BSA < 1.85:
                    doseInMg = 25;
                    tablet15Dose = 2;
                    tablet20Dose = 1;
                    break;
                case BSA < 2.1:
                    doseInMg = 30;
                    tablet15Dose = 2;
                    tablet20Dose = 0;
                    break;
                case BSA < 2.35:
                    doseInMg = 35;
                    tablet15Dose = 1;
                    tablet20Dose = 1;
                    break;
                default:
                    doseInMg = 40;
                    tablet15Dose = 0;
                    tablet20Dose = 2;
            }
        }
    }
    var response = { doseInMg: doseInMg, tablet15Dose: tablet15Dose, tablet20Dose: tablet20Dose, reducedDose: reducedDose };
    return response;
};
var dosesString = function (tablet15Dose, tablet20Dose, doseInMg, timeOfDay) {
    var result = [];
    if (doseInMg * 2 === 50) {
        if (timeOfDay === 'morning') {
            result.push("1\u00D7 {{20}}/{{8.19}} mg");
        }
        else if (timeOfDay === 'evening') {
            result.push("2\u00D7 {{15}}/{{6.14}} mg");
        }
        totalDoses = {
            mgDoses15: 4 * 5,
            mgDoses20: 2 * 5
        };
    }
    else {
        if (tablet15Dose > 0) {
            result.push(tablet15Dose + "\u00D7 {{15}}/{{6.14}} mg");
            totalDoses = __assign(__assign({}, totalDoses), { mgDoses15: totalDoses.mgDoses15 + tablet15Dose * 5 });
        }
        if (tablet20Dose > 0) {
            result.push(tablet20Dose + "\u00D7 {{20}}/{{8.19}} mg");
            totalDoses = __assign(__assign({}, totalDoses), { mgDoses20: totalDoses.mgDoses20 + tablet20Dose * 5 });
        }
    }
    return result.join('<br/>');
};
var week1Output = function (startDate, doses) {
    return {
        week1: {
            qID: 'week1',
            rParams: [
                {
                    type: 'date',
                    value: startDate
                },
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate(startDate, 6)
                },
            ],
            resultTexts: 'regular'
        },
        wk1d1to5: {
            qID: 'wk1d1to5',
            rParams: [
                {
                    type: 'string',
                    value: dosesString(doses.tablet15Dose, doses.tablet20Dose, doses.doseInMg, 'morning')
                },
                {
                    type: 'string',
                    value: dosesString(doses.tablet15Dose, doses.tablet20Dose, doses.doseInMg, 'evening')
                },
            ],
            tParams: [
                {
                    type: 'date',
                    value: startDate
                },
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate(startDate, 4)
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        wk1d6and7: {
            qID: 'wk1d6and7',
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate(startDate, 5)
                },
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate(startDate, 6)
                },
            ],
            resultTexts: 'regular',
            titleTexts: 'regular'
        }
    };
};
var week2Output = function (startDate, doses) {
    return {
        week2: {
            qID: 'week2',
            rParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate(startDate, 7)
                },
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate(startDate, 13)
                },
            ],
            resultTexts: 'regular'
        },
        wk2d1to5: {
            qID: 'wk2d1to5',
            rParams: [
                {
                    type: 'string',
                    value: dosesString(doses.tablet15Dose, doses.tablet20Dose, doses.doseInMg, 'morning')
                },
                {
                    type: 'string',
                    value: dosesString(doses.tablet15Dose, doses.tablet20Dose, doses.doseInMg, 'evening')
                },
            ],
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate(startDate, 7)
                },
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate(startDate, 11)
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        wk2d6and7: {
            qID: 'wk2d6and7',
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate(startDate, 12)
                },
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate(startDate, 13)
                },
            ],
            resultTexts: 'regular',
            titleTexts: 'regular'
        }
    };
};
var week3Output = function (startDate) {
    return {
        week3: {
            qID: 'week3',
            rParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate(startDate, 14)
                },
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate(startDate, 20)
                },
            ],
            resultTexts: 'regular'
        },
        wk3d1to7: {
            qID: 'wk3d1to7',
            rParams: [],
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate(startDate, 14)
                },
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate(startDate, 20)
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        }
    };
};
var week4Output = function (startDate) {
    return {
        week4: {
            qID: 'week4',
            rParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate(startDate, 21)
                },
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate(startDate, 27)
                },
            ],
            resultTexts: 'regular'
        },
        wk4d1to7: {
            qID: 'wk4d1to7',
            rParams: [],
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate(startDate, 21)
                },
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate(startDate, 27)
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        }
    };
};
var calculatePoints = function () {
    totalDoses = {
        mgDoses15: 0,
        mgDoses20: 0
    };
    if (!helpers_1.isAnswered(inputs.weight) ||
        Number(inputs.weight.currentPoints) < 1 ||
        Number(inputs.weight.currentPoints) > 300 ||
        !helpers_1.isAnswered(inputs.height) ||
        Number(inputs.height.currentPoints) < 1 ||
        Number(inputs.height.currentPoints) > 250 ||
        !helpers_1.isAnsweredDate(inputs.startDate)) {
        return null;
    }
    if (inputs.dosingType.currentIdentifier === 'lowered' &&
        inputs.CrCl.currentIdentifier === 'high' &&
        !helpers_1.isAnswered(inputs.lastDose)) {
        return null;
    }
    var BSA = calculateBSA();
    var doses = calculateDoses(BSA);
    var startDate = inputs.startDate.currentDate;
    var week1Result = week1Output(startDate, doses);
    var week2Result = week2Output(startDate, doses);
    var week3Result = week3Output(startDate);
    var week4Result = week4Output(startDate);
    var noTabletsResult = [];
    var noPackagesResult = [];
    if (totalDoses.mgDoses15 > 0) {
        noTabletsResult.push(totalDoses.mgDoses15 + "\u00D7 {{15}}/{{6.14}} mg");
        noPackagesResult.push(Math.ceil(totalDoses.mgDoses15 / 20) + "\u00D7 {{15}}/{{6.14}} mg");
    }
    if (totalDoses.mgDoses20 > 0) {
        noTabletsResult.push(totalDoses.mgDoses20 + "\u00D7 {{20}}/{{8.19}} mg");
        noPackagesResult.push(Math.ceil(totalDoses.mgDoses20 / 20) + "\u00D7 {{20}}/{{8.19}} mg");
    }
    var result = __assign(__assign(__assign(__assign({ bsaResult: {
            qID: 'bsaResult',
            rParams: __spreadArrays(helpers_1.returnNumberObject(BSA, 2, 2)),
            resultTexts: 'regular'
        }, loweredDailyDose: {
            qID: 'loweredDailyDose',
            rParams: __spreadArrays(helpers_1.returnNumberObject(doses.reducedDose, 0, 0)),
            resultTexts: 'regular'
        }, splitDailyDose: {
            qID: 'splitDailyDose',
            rParams: __spreadArrays(helpers_1.returnNumberObject(doses.doseInMg, 0, 0)),
            resultTexts: 'regular'
        }, totalDailyDose: {
            qID: 'totalDailyDose',
            rParams: __spreadArrays(helpers_1.returnNumberObject(doses.doseInMg * 2, 0, 0)),
            resultTexts: 'regular'
        }, noTablets: {
            qID: 'noTablets',
            rParams: [
                {
                    type: 'string',
                    value: noTabletsResult.join('<br/>')
                },
            ],
            resultTexts: 'regular'
        }, noPackages: {
            qID: 'noPackages',
            rParams: [
                {
                    type: 'string',
                    value: noPackagesResult.join('<br/>')
                },
            ],
            resultTexts: 'regular'
        } }, week1Result), week2Result), week3Result), week4Result);
    return result;
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    return {
        result: calculatePoints(),
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
