"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};


var visibleQuestions = {
    antiRNP: true,
    swollenHands: true,
    synovitis: true,
    myositis: true,
    raynaud: true,
    acrosclerosis: true
};
var visibleSections = {
    questionSection: true,
    clinicalCriteria: false
};
var inputs = {
    antiRNP: null,
    swollenHands: null,
    synovitis: null,
    myositis: null,
    raynaud: null,
    acrosclerosis: null
};
var isClinicalCriteriaVisible = function () {
    return helpers_1.answerMatches(inputs.antiRNP, 'yes');
};
var isSynovitisOrMyositisAnsweredYes = function () {
    return (helpers_1.answerMatches(inputs.myositis, 'yes') ||
        helpers_1.answerMatches(inputs.synovitis, 'yes'));
};
var clinicalCriteriaQuestionsAnsweredYes = function () {
    var questionsAnsweredYes = 0;
    if (helpers_1.answerMatches(inputs.swollenHands, 'yes')) {
        questionsAnsweredYes += 1;
    }
    if (helpers_1.answerMatches(inputs.synovitis, 'yes')) {
        questionsAnsweredYes += 1;
    }
    if (helpers_1.answerMatches(inputs.myositis, 'yes')) {
        questionsAnsweredYes += 1;
    }
    if (helpers_1.answerMatches(inputs.raynaud, 'yes')) {
        questionsAnsweredYes += 1;
    }
    if (helpers_1.answerMatches(inputs.acrosclerosis, 'yes')) {
        questionsAnsweredYes += 1;
    }
    return questionsAnsweredYes;
};
var isResultRedVisible = function () {
    return (isClinicalCriteriaVisible() &&
        isSynovitisOrMyositisAnsweredYes() &&
        clinicalCriteriaQuestionsAnsweredYes() >= 3);
};
var calculatePoints = function () {
    if (isResultRedVisible()) {
        return helpers_1.returnToolScoreObject({ resultById: 'resultRed' });
    }
    return helpers_1.returnToolScoreObject({ resultById: 'resultGreen' });
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.clinicalCriteria = isClinicalCriteriaVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return true;
};
var ut_toolScore = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return __assign(__assign({ exportResultsEnabled: isExportResultsEnabled() }, result), { visibleQuestions: ut_visibleQuestions(), visibleSections: ut_visibleSections() });
});
