"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};


var visibleQuestions = {
    symptoms: true,
    frequency: true
};
var visibleSections = {
    section1: true
};
var inputs = {
    symptoms: null,
    frequency: null
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e;
    if (((_a = inputs.symptoms) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "no") {
        return helpers_1.returnToolScoreObject({
            number: -1,
            range: -1,
            resultById: "noSymptoms"
        });
    }
    if (!helpers_1.isAnswered(inputs.frequency)) {
        return helpers_1.returnToolScoreObject({
            number: -2,
            range: -2,
            resultById: "incomplete"
        });
    }
    var points = Number((_b = inputs.frequency) === null || _b === void 0 ? void 0 : _b.currentPoints) + 1;
    return helpers_1.returnToolScoreObject({
        number: points,
        range: points,
        title: [(_d = (_c = inputs.frequency) === null || _c === void 0 ? void 0 : _c.data) === null || _d === void 0 ? void 0 : _d.title],
        resultById: (_e = inputs.frequency) === null || _e === void 0 ? void 0 : _e.currentIdentifier
    });
};
var returnVisibleQuestions = function () {
    var _a;
    visibleQuestions.frequency =
        helpers_1.isAnswered(inputs.symptoms) && ((_a = inputs.symptoms) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "yes";
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_toolScore = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return false;
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return __assign(__assign({ exportResultsEnabled: isExportResultsEnabled() }, result), { visibleQuestions: ut_visibleQuestions(), visibleSections: ut_visibleSections() });
});
