"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};


var visibleQuestions = {
    weight: true,
    kidneyFunction: true,
    liverFunction: true,
    infection: true,
    year: true,
    leukocyteCount1: false,
    leukocyteCount2: false,
    therapyStartDate: true,
    noResult: true,
    contraindication: false,
    aditionalInfo: false,
    notRecommended: false,
    firstWeek40mg: false,
    firstWeek50mg: false,
    firstWeek60mg: false,
    firstWeek70mg: false,
    firstWeek80mg: false,
    firstWeek90mg: false,
    firstWeekAbove100mg: false,
    week1day1PillsPerDay1: false,
    week1day1PillsPerDay2: false,
    week1day2PillsPerDay1: false,
    week1day2PillsPerDay2: false,
    week1day3PillsPerDay1: false,
    week1day3PillsPerDay2: false,
    week1day4PillsPerDay1: false,
    week1day4PillsPerDay2: false,
    week1day5PillsPerDay0: false,
    week1day5PillsPerDay1: false,
    week1day5PillsPerDay2: false,
    fifthWeek40mg: false,
    fifthWeek50mg: false,
    fifthWeek60mg: false,
    fifthWeek70mg: false,
    fifthWeek80mg: false,
    fifthWeek90mg: false,
    fifthWeekAbove100mg: false,
    week5day1PillsPerDay1: false,
    week5day1PillsPerDay2: false,
    week5day2PillsPerDay1: false,
    week5day2PillsPerDay2: false,
    week5day3PillsPerDay1: false,
    week5day3PillsPerDay2: false,
    week5day4PillsPerDay1: false,
    week5day4PillsPerDay2: false,
    week5day5PillsPerDay0: false,
    week5day5PillsPerDay1: false,
    week5day5PillsPerDay2: false,
    packaging1: false,
    packaging2: false,
    packaging3: false,
    packaging4: false,
    packaging5: false,
    packaging6: false,
    packaging7: false,
    packaging8: false
};
var visibleSections = {
    main: true,
    therapyStartDate: true,
    firstWeek: true,
    dosing: false,
    packaging: false
};
var inputs = {
    weight: null,
    kidneyFunction: null,
    liverFunction: null,
    infection: null,
    year: null,
    leukocyteCount1: null,
    leukocyteCount2: null,
    therapyStartDate: null
};
var areAllQuestionsAnswered = function () {
    return (helpers_1.isAnswered(inputs.weight) &&
        helpers_1.isAnswered(inputs.kidneyFunction) &&
        helpers_1.isAnswered(inputs.year));
};
var firstWeekVisibility = function () {
    return (areAllQuestionsAnswered() ||
        noResultVisibility() ||
        contraindicationVisibility() ||
        notRecommendedVisibility() ||
        weekResultVisibility("40to50") ||
        weekResultVisibility("50to60") ||
        weekResultVisibility("60to70") ||
        weekResultVisibility("70to80") ||
        weekResultVisibility("80to90") ||
        weekResultVisibility("90to100") ||
        weekResultVisibility("100to110") ||
        weekResultVisibility("above110"));
};
var noResultVisibility = function () {
    if (!areAllQuestionsAnswered()) {
        return true;
    }
    return false;
};
var contraindicationVisibility = function () {
    var _a, _b, _c, _d;
    if ((helpers_1.isAnswered(inputs.weight) &&
        ((_a = inputs.kidneyFunction) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "below60" &&
        helpers_1.isAnswered(inputs.year)) ||
        (helpers_1.isAnswered(inputs.weight) &&
            helpers_1.isAnswered(inputs.kidneyFunction) &&
            ((_b = inputs.infection) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "yes" &&
            helpers_1.isAnswered(inputs.year)) ||
        (helpers_1.isAnswered(inputs.weight) &&
            helpers_1.isAnswered(inputs.kidneyFunction) &&
            helpers_1.isAnswered(inputs.year) &&
            (((_c = inputs.leukocyteCount1) === null || _c === void 0 ? void 0 : _c.currentIdentifier) === "yes" ||
                ((_d = inputs.leukocyteCount2) === null || _d === void 0 ? void 0 : _d.currentIdentifier) === "yes"))) {
        return true;
    }
    return false;
};
var notRecommendedVisibility = function () {
    var _a;
    if (helpers_1.isAnswered(inputs.weight) &&
        helpers_1.isAnswered(inputs.kidneyFunction) &&
        helpers_1.isAnswered(inputs.year) &&
        ((_a = inputs.liverFunction) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "yes") {
        return true;
    }
    return false;
};
var dosingVisibility = function () {
    var _a, _b, _c, _d, _e, _f, _g;
    if (helpers_1.isAnswered(inputs.weight) &&
        ((_a = inputs.kidneyFunction) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "above60" &&
        ((_b = inputs.liverFunction) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "no" &&
        ((_c = inputs.infection) === null || _c === void 0 ? void 0 : _c.currentIdentifier) === "no" &&
        ((((_d = inputs.year) === null || _d === void 0 ? void 0 : _d.currentIdentifier) === "firstYear" &&
            ((_e = inputs.leukocyteCount1) === null || _e === void 0 ? void 0 : _e.currentIdentifier) === "no") ||
            (((_f = inputs.year) === null || _f === void 0 ? void 0 : _f.currentIdentifier) === "secondYear" &&
                ((_g = inputs.leukocyteCount2) === null || _g === void 0 ? void 0 : _g.currentIdentifier) === "no"))) {
        return true;
    }
    return false;
};
var weekResultVisibility = function (weight) {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    if (((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === weight &&
        ((_b = inputs.kidneyFunction) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "above60" &&
        ((_c = inputs.liverFunction) === null || _c === void 0 ? void 0 : _c.currentIdentifier) === "no" &&
        ((_d = inputs.infection) === null || _d === void 0 ? void 0 : _d.currentIdentifier) === "no" &&
        ((((_e = inputs.year) === null || _e === void 0 ? void 0 : _e.currentIdentifier) === "firstYear" &&
            ((_f = inputs.leukocyteCount1) === null || _f === void 0 ? void 0 : _f.currentIdentifier) === "no") ||
            (((_g = inputs.year) === null || _g === void 0 ? void 0 : _g.currentIdentifier) === "secondYear" &&
                ((_h = inputs.leukocyteCount2) === null || _h === void 0 ? void 0 : _h.currentIdentifier) === "no"))) {
        return true;
    }
    return false;
};
var weekdayPillsPerDayVisibility = function (weights) {
    return (weights.filter(function (weight) { return weekResultVisibility(weight); }).length > 0);
};
var returnVisibleQuestions = function () {
    var _a, _b, _c;
    visibleQuestions.leukocyteCount1 =
        ((_a = inputs.year) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "firstYear";
    visibleQuestions.leukocyteCount2 =
        ((_b = inputs.year) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "secondYear";
    visibleQuestions.noResult = noResultVisibility();
    visibleQuestions.contraindication = contraindicationVisibility();
    visibleQuestions.notRecommended =
        !contraindicationVisibility() && notRecommendedVisibility();
    visibleQuestions.aditionalInfo =
        ((_c = inputs.leukocyteCount2) === null || _c === void 0 ? void 0 : _c.currentIdentifier) === "yes";
    visibleQuestions.firstWeek40mg = weekResultVisibility("40to50");
    visibleQuestions.firstWeek50mg = weekResultVisibility("50to60");
    visibleQuestions.firstWeek60mg = weekResultVisibility("60to70");
    visibleQuestions.firstWeek70mg = weekResultVisibility("70to80");
    visibleQuestions.firstWeek80mg = weekResultVisibility("80to90");
    visibleQuestions.firstWeek90mg = weekResultVisibility("90to100");
    visibleQuestions.firstWeekAbove100mg =
        weekResultVisibility("100to110") || weekResultVisibility("above110");
    visibleQuestions.fifthWeek40mg = weekResultVisibility("40to50");
    visibleQuestions.fifthWeek50mg = weekResultVisibility("50to60");
    visibleQuestions.fifthWeek60mg = weekResultVisibility("60to70");
    visibleQuestions.fifthWeek70mg =
        weekResultVisibility("70to80") || weekResultVisibility("80to90");
    visibleQuestions.fifthWeek80mg = weekResultVisibility("90to100");
    visibleQuestions.fifthWeek90mg = weekResultVisibility("100to110");
    visibleQuestions.fifthWeekAbove100mg = weekResultVisibility("above110");
    visibleQuestions.week1day1PillsPerDay1 = weekdayPillsPerDayVisibility([
        "40to50",
        "50to60",
    ]);
    visibleQuestions.week1day1PillsPerDay2 = weekdayPillsPerDayVisibility([
        "60to70",
        "70to80",
        "80to90",
        "90to100",
        "100to110",
        "above110",
    ]);
    visibleQuestions.week1day2PillsPerDay1 = weekdayPillsPerDayVisibility([
        "40to50",
        "50to60",
        "60to70",
    ]);
    visibleQuestions.week1day2PillsPerDay2 = weekdayPillsPerDayVisibility([
        "70to80",
        "80to90",
        "90to100",
        "100to110",
        "above110",
    ]);
    visibleQuestions.week1day3PillsPerDay1 = weekdayPillsPerDayVisibility([
        "40to50",
        "50to60",
        "60to70",
        "70to80",
    ]);
    visibleQuestions.week1day3PillsPerDay2 = weekdayPillsPerDayVisibility([
        "80to90",
        "90to100",
        "100to110",
        "above110",
    ]);
    visibleQuestions.week1day4PillsPerDay1 = weekdayPillsPerDayVisibility([
        "40to50",
        "50to60",
        "60to70",
        "70to80",
        "80to90",
    ]);
    visibleQuestions.week1day4PillsPerDay2 = weekdayPillsPerDayVisibility([
        "90to100",
        "100to110",
        "above110",
    ]);
    visibleQuestions.week1day5PillsPerDay0 = weekdayPillsPerDayVisibility([
        "40to50",
    ]);
    visibleQuestions.week1day5PillsPerDay1 = weekdayPillsPerDayVisibility([
        "50to60",
        "60to70",
        "70to80",
        "80to90",
        "90to100",
    ]);
    visibleQuestions.week1day5PillsPerDay2 = weekdayPillsPerDayVisibility([
        "100to110",
        "above110",
    ]);
    visibleQuestions.week5day1PillsPerDay1 = weekdayPillsPerDayVisibility([
        "40to50",
        "50to60",
    ]);
    visibleQuestions.week5day1PillsPerDay2 = weekdayPillsPerDayVisibility([
        "60to70",
        "70to80",
        "80to90",
        "90to100",
        "100to110",
        "above110",
    ]);
    visibleQuestions.week5day2PillsPerDay1 = weekdayPillsPerDayVisibility([
        "40to50",
        "50to60",
        "60to70",
    ]);
    visibleQuestions.week5day2PillsPerDay2 = weekdayPillsPerDayVisibility([
        "70to80",
        "80to90",
        "90to100",
        "100to110",
        "above110",
    ]);
    visibleQuestions.week5day3PillsPerDay1 = weekdayPillsPerDayVisibility([
        "40to50",
        "50to60",
        "60to70",
        "70to80",
        "80to90",
    ]);
    visibleQuestions.week5day3PillsPerDay2 = weekdayPillsPerDayVisibility([
        "90to100",
        "100to110",
        "above110",
    ]);
    visibleQuestions.week5day4PillsPerDay1 = weekdayPillsPerDayVisibility([
        "40to50",
        "50to60",
        "60to70",
        "70to80",
        "80to90",
        "90to100",
    ]);
    visibleQuestions.week5day4PillsPerDay2 = weekdayPillsPerDayVisibility([
        "100to110",
        "above110",
    ]);
    visibleQuestions.week5day5PillsPerDay0 = weekdayPillsPerDayVisibility([
        "40to50",
    ]);
    visibleQuestions.week5day5PillsPerDay1 = weekdayPillsPerDayVisibility([
        "50to60",
        "60to70",
        "70to80",
        "80to90",
        "90to100",
        "100to110",
    ]);
    visibleQuestions.week5day5PillsPerDay2 = weekdayPillsPerDayVisibility([
        "above110",
    ]);
    visibleQuestions.packaging1 = weekResultVisibility("40to50");
    visibleQuestions.packaging2 = weekResultVisibility("50to60");
    visibleQuestions.packaging3 = weekResultVisibility("60to70");
    visibleQuestions.packaging4 = weekResultVisibility("70to80");
    visibleQuestions.packaging5 = weekResultVisibility("80to90");
    visibleQuestions.packaging6 = weekResultVisibility("90to100");
    visibleQuestions.packaging7 = weekResultVisibility("100to110");
    visibleQuestions.packaging8 = weekResultVisibility("above110");
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.firstWeek = firstWeekVisibility();
    visibleSections.dosing = dosingVisibility();
    visibleSections.packaging = dosingVisibility();
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return dosingVisibility();
};
var weekDayPillsPerDayResult = function (week, day, pills) {
    var _a;
    var _b;
    return _a = {},
        _a[("week" + week + "day" + day + "PillsPerDay" + pills).toString()] = {
            qID: ("week" + week + "day" + day + "PillsPerDay" + pills).toString(),
            tParams: [
                {
                    type: "date",
                    value: helpers_1.addDaysToDate((_b = inputs.therapyStartDate) === null || _b === void 0 ? void 0 : _b.currentDate, (week - 1) * 7 + (day - 1))
                },
            ],
            titleTexts: "default",
            rParams: [],
            resultTexts: "default"
        },
        _a;
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3;
    return __assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign({ firstWeek40mg: {
            qID: "firstWeek40mg",
            tParams: [
                {
                    type: "date",
                    value: (_a = inputs.therapyStartDate) === null || _a === void 0 ? void 0 : _a.currentDate
                },
                {
                    type: "date",
                    value: helpers_1.addDaysToDate((_b = inputs.therapyStartDate) === null || _b === void 0 ? void 0 : _b.currentDate, 4)
                },
            ],
            titleTexts: "default"
        }, firstWeek50mg: {
            qID: "firstWeek50mg",
            tParams: [
                {
                    type: "date",
                    value: (_c = inputs.therapyStartDate) === null || _c === void 0 ? void 0 : _c.currentDate
                },
                {
                    type: "date",
                    value: helpers_1.addDaysToDate((_d = inputs.therapyStartDate) === null || _d === void 0 ? void 0 : _d.currentDate, 4)
                },
            ],
            titleTexts: "default"
        }, firstWeek60mg: {
            qID: "firstWeek60mg",
            tParams: [
                {
                    type: "date",
                    value: (_e = inputs.therapyStartDate) === null || _e === void 0 ? void 0 : _e.currentDate
                },
                {
                    type: "date",
                    value: helpers_1.addDaysToDate((_f = inputs.therapyStartDate) === null || _f === void 0 ? void 0 : _f.currentDate, 4)
                },
            ],
            titleTexts: "default"
        }, firstWeek70mg: {
            qID: "firstWeek70mg",
            tParams: [
                {
                    type: "date",
                    value: (_g = inputs.therapyStartDate) === null || _g === void 0 ? void 0 : _g.currentDate
                },
                {
                    type: "date",
                    value: helpers_1.addDaysToDate((_h = inputs.therapyStartDate) === null || _h === void 0 ? void 0 : _h.currentDate, 4)
                },
            ],
            titleTexts: "default"
        }, firstWeek80mg: {
            qID: "firstWeek80mg",
            tParams: [
                {
                    type: "date",
                    value: (_j = inputs.therapyStartDate) === null || _j === void 0 ? void 0 : _j.currentDate
                },
                {
                    type: "date",
                    value: helpers_1.addDaysToDate((_k = inputs.therapyStartDate) === null || _k === void 0 ? void 0 : _k.currentDate, 4)
                },
            ],
            titleTexts: "default"
        }, firstWeek90mg: {
            qID: "firstWeek90mg",
            tParams: [
                {
                    type: "date",
                    value: (_l = inputs.therapyStartDate) === null || _l === void 0 ? void 0 : _l.currentDate
                },
                {
                    type: "date",
                    value: helpers_1.addDaysToDate((_m = inputs.therapyStartDate) === null || _m === void 0 ? void 0 : _m.currentDate, 4)
                },
            ],
            titleTexts: "default"
        }, firstWeekAbove100mg: {
            qID: "firstWeekAbove100mg",
            tParams: [
                {
                    type: "date",
                    value: (_o = inputs.therapyStartDate) === null || _o === void 0 ? void 0 : _o.currentDate
                },
                {
                    type: "date",
                    value: helpers_1.addDaysToDate((_p = inputs.therapyStartDate) === null || _p === void 0 ? void 0 : _p.currentDate, 4)
                },
            ],
            titleTexts: "default"
        }, fifthWeek40mg: {
            qID: "fifthWeek40mg",
            tParams: [
                {
                    type: "date",
                    value: helpers_1.addDaysToDate((_q = inputs.therapyStartDate) === null || _q === void 0 ? void 0 : _q.currentDate, 28)
                },
                {
                    type: "date",
                    value: helpers_1.addDaysToDate((_r = inputs.therapyStartDate) === null || _r === void 0 ? void 0 : _r.currentDate, 32)
                },
            ],
            titleTexts: "default"
        }, fifthWeek50mg: {
            qID: "fifthWeek50mg",
            tParams: [
                {
                    type: "date",
                    value: helpers_1.addDaysToDate((_s = inputs.therapyStartDate) === null || _s === void 0 ? void 0 : _s.currentDate, 28)
                },
                {
                    type: "date",
                    value: helpers_1.addDaysToDate((_t = inputs.therapyStartDate) === null || _t === void 0 ? void 0 : _t.currentDate, 32)
                },
            ],
            titleTexts: "default"
        }, fifthWeek60mg: {
            qID: "fifthWeek60mg",
            tParams: [
                {
                    type: "date",
                    value: helpers_1.addDaysToDate((_u = inputs.therapyStartDate) === null || _u === void 0 ? void 0 : _u.currentDate, 28)
                },
                {
                    type: "date",
                    value: helpers_1.addDaysToDate((_v = inputs.therapyStartDate) === null || _v === void 0 ? void 0 : _v.currentDate, 32)
                },
            ],
            titleTexts: "default"
        }, fifthWeek70mg: {
            qID: "fifthWeek70mg",
            tParams: [
                {
                    type: "date",
                    value: helpers_1.addDaysToDate((_w = inputs.therapyStartDate) === null || _w === void 0 ? void 0 : _w.currentDate, 28)
                },
                {
                    type: "date",
                    value: helpers_1.addDaysToDate((_x = inputs.therapyStartDate) === null || _x === void 0 ? void 0 : _x.currentDate, 32)
                },
            ],
            titleTexts: "default"
        }, fifthWeek80mg: {
            qID: "fifthWeek80mg",
            tParams: [
                {
                    type: "date",
                    value: helpers_1.addDaysToDate((_y = inputs.therapyStartDate) === null || _y === void 0 ? void 0 : _y.currentDate, 28)
                },
                {
                    type: "date",
                    value: helpers_1.addDaysToDate((_z = inputs.therapyStartDate) === null || _z === void 0 ? void 0 : _z.currentDate, 32)
                },
            ],
            titleTexts: "default"
        }, fifthWeek90mg: {
            qID: "fifthWeek90mg",
            tParams: [
                {
                    type: "date",
                    value: helpers_1.addDaysToDate((_0 = inputs.therapyStartDate) === null || _0 === void 0 ? void 0 : _0.currentDate, 28)
                },
                {
                    type: "date",
                    value: helpers_1.addDaysToDate((_1 = inputs.therapyStartDate) === null || _1 === void 0 ? void 0 : _1.currentDate, 32)
                },
            ],
            titleTexts: "default"
        }, fifthWeekAbove100mg: {
            qID: "fifthWeekAbove100mg",
            tParams: [
                {
                    type: "date",
                    value: helpers_1.addDaysToDate((_2 = inputs.therapyStartDate) === null || _2 === void 0 ? void 0 : _2.currentDate, 28)
                },
                {
                    type: "date",
                    value: helpers_1.addDaysToDate((_3 = inputs.therapyStartDate) === null || _3 === void 0 ? void 0 : _3.currentDate, 32)
                },
            ],
            titleTexts: "default"
        } }, weekDayPillsPerDayResult(1, 1, 1)), weekDayPillsPerDayResult(1, 1, 2)), weekDayPillsPerDayResult(1, 2, 1)), weekDayPillsPerDayResult(1, 2, 2)), weekDayPillsPerDayResult(1, 3, 1)), weekDayPillsPerDayResult(1, 3, 2)), weekDayPillsPerDayResult(1, 4, 1)), weekDayPillsPerDayResult(1, 4, 2)), weekDayPillsPerDayResult(1, 5, 0)), weekDayPillsPerDayResult(1, 5, 1)), weekDayPillsPerDayResult(1, 5, 2)), weekDayPillsPerDayResult(5, 1, 1)), weekDayPillsPerDayResult(5, 1, 2)), weekDayPillsPerDayResult(5, 2, 1)), weekDayPillsPerDayResult(5, 2, 2)), weekDayPillsPerDayResult(5, 3, 1)), weekDayPillsPerDayResult(5, 3, 2)), weekDayPillsPerDayResult(5, 4, 1)), weekDayPillsPerDayResult(5, 4, 2)), weekDayPillsPerDayResult(5, 5, 0)), weekDayPillsPerDayResult(5, 5, 1)), weekDayPillsPerDayResult(5, 5, 2));
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: calculatePoints(),
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
