"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};


var visibleQuestions = {
    primaryTumor: true,
    t1subgroups: false,
    t2subgroups: false,
    t3subgroups: false,
    t4subgroups: false,
    lymphNodes: false,
    n1subgroups: false,
    n2subgroups: false,
    n3subgroups: false,
    metastasis: false,
    subGroupM1: false,
    concentrationLDH: false
};
var visibleSections = {
    classification: true
};
var inputs = {
    primaryTumor: null,
    t1subgroups: null,
    t2subgroups: null,
    t3subgroups: null,
    t4subgroups: null,
    lymphNodes: null,
    n1subgroups: null,
    n2subgroups: null,
    n3subgroups: null,
    metastasis: null,
    subGroupM1: null,
    concentrationLDH: null
};
var isPrimaryTumorT0 = function () {
    return helpers_1.answerMatches(inputs.primaryTumor, 't0');
};
var isPrimaryTumorTis = function () {
    return helpers_1.answerMatches(inputs.primaryTumor, 'tis');
};
var isPrimaryTumorT1 = function () {
    return helpers_1.answerMatches(inputs.primaryTumor, 't1');
};
var isPrimaryTumorT2 = function () {
    return helpers_1.answerMatches(inputs.primaryTumor, 't2');
};
var isPrimaryTumorT3 = function () {
    return helpers_1.answerMatches(inputs.primaryTumor, 't3');
};
var isPrimaryTumorT4 = function () {
    return helpers_1.answerMatches(inputs.primaryTumor, 't4');
};
var isPrimaryTumorAnswered = function () {
    return (helpers_1.isAnswered(inputs.primaryTumor) ||
        helpers_1.isAnswered(inputs.t1subgroups) ||
        helpers_1.isAnswered(inputs.t2subgroups) ||
        helpers_1.isAnswered(inputs.t3subgroups) ||
        helpers_1.isAnswered(inputs.t4subgroups));
};
var isLymphNodesN0 = function () {
    return helpers_1.answerMatches(inputs.lymphNodes, 'n0');
};
var isLymphNodesN1 = function () {
    return helpers_1.answerMatches(inputs.lymphNodes, 'n1');
};
var isLymphNodesN2 = function () {
    return helpers_1.answerMatches(inputs.lymphNodes, 'n2');
};
var isLymphNodesN3 = function () {
    return helpers_1.answerMatches(inputs.lymphNodes, 'n3');
};
var isLymphNodesAnswered = function () {
    return (helpers_1.isAnswered(inputs.lymphNodes) ||
        helpers_1.isAnswered(inputs.n1subgroups) ||
        helpers_1.isAnswered(inputs.n2subgroups) ||
        helpers_1.isAnswered(inputs.n3subgroups));
};
var isMetastasisM0 = function () {
    return helpers_1.answerMatches(inputs.metastasis, 'm0');
};
var isMetastasisM1 = function () {
    return helpers_1.answerMatches(inputs.metastasis, 'm1');
};
var isSubGroupM1Answered = function () {
    return helpers_1.isAnswered(inputs.subGroupM1);
};
var isT1SubgroupsT1a = function () {
    return isPrimaryTumorT1() && helpers_1.answerMatches(inputs.t1subgroups, 't1a');
};
var isT1SubgroupsT1b = function () {
    return isPrimaryTumorT1() && helpers_1.answerMatches(inputs.t1subgroups, 't1b');
};
var isT2SubgroupsT2a = function () {
    return isPrimaryTumorT2() && helpers_1.answerMatches(inputs.t2subgroups, 't2a');
};
var isT2SubgroupsT2b = function () {
    return isPrimaryTumorT2() && helpers_1.answerMatches(inputs.t2subgroups, 't2b');
};
var isT3SubgroupsT3a = function () {
    return isPrimaryTumorT3() && helpers_1.answerMatches(inputs.t3subgroups, 't3a');
};
var isT3SubgroupsT3b = function () {
    return isPrimaryTumorT3() && helpers_1.answerMatches(inputs.t3subgroups, 't3b');
};
var isT4SubgroupsT4a = function () {
    return isPrimaryTumorT4() && helpers_1.answerMatches(inputs.t4subgroups, 't4a');
};
var isT4SubgroupsT4b = function () {
    return isPrimaryTumorT4() && helpers_1.answerMatches(inputs.t4subgroups, 't4b');
};
var isN1SubgroupsN1a = function () {
    return isLymphNodesN1() && helpers_1.answerMatches(inputs.n1subgroups, 'n1a');
};
var isN1SubgroupsN1b = function () {
    return isLymphNodesN1() && helpers_1.answerMatches(inputs.n1subgroups, 'n1b');
};
var isN1SubgroupsN1c = function () {
    return isLymphNodesN1() && helpers_1.answerMatches(inputs.n1subgroups, 'n1c');
};
var isN2SubgroupsN2a = function () {
    return isLymphNodesN2() && helpers_1.answerMatches(inputs.n2subgroups, 'n2a');
};
var isN2SubgroupsN2b = function () {
    return isLymphNodesN2() && helpers_1.answerMatches(inputs.n2subgroups, 'n2b');
};
var isN2SubgroupsN2c = function () {
    return isLymphNodesN2() && helpers_1.answerMatches(inputs.n2subgroups, 'n2c');
};
var isN3SubgroupsN3a = function () {
    return isLymphNodesN3() && helpers_1.answerMatches(inputs.n3subgroups, 'n3a');
};
var isN3SubgroupsN3b = function () {
    return isLymphNodesN3() && helpers_1.answerMatches(inputs.n3subgroups, 'n3b');
};
var isN3SubgroupsN3c = function () {
    return isLymphNodesN3() && helpers_1.answerMatches(inputs.n3subgroups, 'n3c');
};
var checkResultRange1 = function () {
    var firstCondition = !helpers_1.isAnswered(inputs.primaryTumor);
    var secondCondition = isPrimaryTumorT1() && !helpers_1.isAnswered(inputs.t1subgroups);
    var thirdCondition = isPrimaryTumorT2() && !helpers_1.isAnswered(inputs.t2subgroups);
    var fourthCondition = isPrimaryTumorT3() && !helpers_1.isAnswered(inputs.t3subgroups);
    var fifthCondition = isPrimaryTumorT4() && !helpers_1.isAnswered(inputs.t4subgroups);
    var sixthCondition = isLymphNodesVisible() && !helpers_1.isAnswered(inputs.lymphNodes);
    var seventhCondition = isLymphNodesN1() && !helpers_1.isAnswered(inputs.n1subgroups);
    var eightCondition = isLymphNodesN2() && !helpers_1.isAnswered(inputs.n2subgroups);
    var ninthCondition = isLymphNodesN3() && !helpers_1.isAnswered(inputs.n3subgroups);
    var tenthCondition = isMetastatisVisible() && !helpers_1.isAnswered(inputs.metastasis);
    var eleventhCondition = isMetastasisM1() && !helpers_1.isAnswered(inputs.subGroupM1);
    var twelfthCondition = isSubGroupM1Answered() && !helpers_1.isAnswered(inputs.concentrationLDH);
    return (firstCondition ||
        secondCondition ||
        thirdCondition ||
        fourthCondition ||
        fifthCondition ||
        sixthCondition ||
        seventhCondition ||
        eightCondition ||
        ninthCondition ||
        tenthCondition ||
        eleventhCondition ||
        twelfthCondition);
};
var checkNoDisease = function () {
    return (helpers_1.answerMatches(inputs.primaryTumor, 't0') &&
        helpers_1.answerMatches(inputs.lymphNodes, 'n0') &&
        helpers_1.answerMatches(inputs.metastasis, 'm0'));
};
var checkResultRange3 = function () {
    return isPrimaryTumorTis() && isLymphNodesN0() && isMetastasisM0();
};
var checkResultRange4 = function () {
    return isT1SubgroupsT1a() && isLymphNodesN0() && isMetastasisM0();
};
var checkResultRange5 = function () {
    var firstCondition = isT1SubgroupsT1b() || isT2SubgroupsT2a();
    return firstCondition && isLymphNodesN0() && isMetastasisM0();
};
var checkResultRange6 = function () {
    var firstCondition = isT2SubgroupsT2b() || isT3SubgroupsT3a();
    return firstCondition && isLymphNodesN0() && isMetastasisM0();
};
var checkResultRange7 = function () {
    var firstCondition = isT3SubgroupsT3b() || isT4SubgroupsT4a();
    return firstCondition && isLymphNodesN0() && isMetastasisM0();
};
var checkResultRange8 = function () {
    return isT4SubgroupsT4b() && isLymphNodesN0() && isMetastasisM0();
};
var checkResultRange9 = function () {
    var firstCondition = isT1SubgroupsT1a() || isT1SubgroupsT1b() || isT2SubgroupsT2a();
    var secondCondition = isN1SubgroupsN1a() || isN2SubgroupsN2a();
    return firstCondition && secondCondition && isMetastasisM0();
};
var checkResultRange10 = function () {
    var firstNCondition = isN1SubgroupsN1b() || isN1SubgroupsN1c();
    var firstCondition = isPrimaryTumorT0() && firstNCondition && isMetastasisM0();
    var secondTCondition = isT1SubgroupsT1a() || isT1SubgroupsT1b() || isT2SubgroupsT2a();
    var secondNCondition = isN1SubgroupsN1b() || isN1SubgroupsN1c() || isN2SubgroupsN2b();
    var secondCondition = secondTCondition && secondNCondition && isMetastasisM0();
    var thirdTCondition = isT2SubgroupsT2b() || isT3SubgroupsT3a();
    var thirdNCondition = isN1SubgroupsN1a() ||
        isN1SubgroupsN1b() ||
        isN1SubgroupsN1c() ||
        isN2SubgroupsN2a() ||
        isN2SubgroupsN2b();
    var thirdCondition = thirdTCondition && thirdNCondition && isMetastasisM0();
    return firstCondition || secondCondition || thirdCondition;
};
var checkResultRange11 = function () {
    var firstNCondition = isN2SubgroupsN2b() ||
        isN2SubgroupsN2c() ||
        isN3SubgroupsN3b() ||
        isN3SubgroupsN3c();
    var firstCondition = isPrimaryTumorT0() && firstNCondition && isMetastasisM0();
    var secondTCondition = isT1SubgroupsT1a() ||
        isT1SubgroupsT1b() ||
        isT2SubgroupsT2a() ||
        isT2SubgroupsT2b() ||
        isT3SubgroupsT3a();
    var secondNCondition = isN2SubgroupsN2c() ||
        isN3SubgroupsN3a() ||
        isN3SubgroupsN3b() ||
        isN3SubgroupsN3c();
    var secondCondition = secondTCondition && secondNCondition && isMetastasisM0();
    var thirdTCondition = isT3SubgroupsT3b() || isT4SubgroupsT4a();
    var thirdCondition = thirdTCondition && isLymphNodesAnswered() && isMetastasisM0();
    var fourthNCondition = isN1SubgroupsN1a() ||
        isN1SubgroupsN1b() ||
        isN1SubgroupsN1c() ||
        isN2SubgroupsN2a() ||
        isN2SubgroupsN2b() ||
        isN2SubgroupsN2c();
    var fourthCondition = isT4SubgroupsT4b() && fourthNCondition && isMetastasisM0();
    return firstCondition || secondCondition || thirdCondition || fourthCondition;
};
var checkResultRange12 = function () {
    var secondCondition = isN3SubgroupsN3a() || isN3SubgroupsN3b() || isN3SubgroupsN3c();
    return isT4SubgroupsT4b() && secondCondition && isMetastasisM0();
};
var checkResultRange13 = function () {
    return (isPrimaryTumorAnswered() &&
        isLymphNodesAnswered() &&
        helpers_1.answerMatches(inputs.subGroupM1, 'm1a'));
};
var checkResultRange14 = function () {
    return (isPrimaryTumorAnswered() &&
        isLymphNodesAnswered() &&
        helpers_1.answerMatches(inputs.subGroupM1, 'm1b'));
};
var checkResultRange15 = function () {
    return (isPrimaryTumorAnswered() &&
        isLymphNodesAnswered() &&
        helpers_1.answerMatches(inputs.subGroupM1, 'm1c'));
};
var checkResultRange16 = function () {
    return (isPrimaryTumorAnswered() &&
        isLymphNodesAnswered() &&
        helpers_1.answerMatches(inputs.subGroupM1, 'm1d'));
};
var isLymphNodesVisible = function () {
    var firstCondition = helpers_1.answerMatches(inputs.primaryTumor, 't1') && helpers_1.isAnswered(inputs.t1subgroups);
    var secondCondition = helpers_1.answerMatches(inputs.primaryTumor, 't2') && helpers_1.isAnswered(inputs.t2subgroups);
    var thirdCondition = helpers_1.answerMatches(inputs.primaryTumor, 't3') && helpers_1.isAnswered(inputs.t3subgroups);
    var fourthCondition = helpers_1.answerMatches(inputs.primaryTumor, 't4') && helpers_1.isAnswered(inputs.t4subgroups);
    return (helpers_1.answerMatches(inputs.primaryTumor, 'tx') ||
        helpers_1.answerMatches(inputs.primaryTumor, 't0') ||
        helpers_1.answerMatches(inputs.primaryTumor, 'tis') ||
        firstCondition ||
        secondCondition ||
        thirdCondition ||
        fourthCondition);
};
var isMetastatisVisible = function () {
    var firstCondition = helpers_1.answerMatches(inputs.lymphNodes, 'n1') && helpers_1.isAnswered(inputs.n1subgroups);
    var secondCondition = helpers_1.answerMatches(inputs.lymphNodes, 'n2') && helpers_1.isAnswered(inputs.n2subgroups);
    var thirdCondition = helpers_1.answerMatches(inputs.lymphNodes, 'n3') && helpers_1.isAnswered(inputs.n3subgroups);
    return (helpers_1.answerMatches(inputs.lymphNodes, 'nx') ||
        helpers_1.answerMatches(inputs.lymphNodes, 'n0') ||
        firstCondition ||
        secondCondition ||
        thirdCondition);
};
var calculatePoints = function () {
    if (checkResultRange1()) {
        return helpers_1.returnToolScoreObject({
            resultById: 'resultRange1'
        });
    }
    if (checkResultRange3()) {
        return helpers_1.returnToolScoreObject({
            resultById: 'resultRange3'
        });
    }
    if (checkResultRange4()) {
        return helpers_1.returnToolScoreObject({
            resultById: 'resultRange4'
        });
    }
    if (checkResultRange5()) {
        return helpers_1.returnToolScoreObject({
            resultById: 'resultRange5'
        });
    }
    if (checkResultRange6()) {
        return helpers_1.returnToolScoreObject({
            resultById: 'resultRange6'
        });
    }
    if (checkResultRange7()) {
        return helpers_1.returnToolScoreObject({
            resultById: 'resultRange7'
        });
    }
    if (checkResultRange8()) {
        return helpers_1.returnToolScoreObject({
            resultById: 'resultRange8'
        });
    }
    if (checkResultRange9()) {
        return helpers_1.returnToolScoreObject({
            resultById: 'resultRange9'
        });
    }
    if (checkResultRange10()) {
        return helpers_1.returnToolScoreObject({
            resultById: 'resultRange10'
        });
    }
    if (checkResultRange11()) {
        return helpers_1.returnToolScoreObject({
            resultById: 'resultRange11'
        });
    }
    if (checkResultRange12()) {
        return helpers_1.returnToolScoreObject({
            resultById: 'resultRange12'
        });
    }
    if (checkResultRange13()) {
        return helpers_1.returnToolScoreObject({
            resultById: 'resultRange13'
        });
    }
    if (checkResultRange14()) {
        return helpers_1.returnToolScoreObject({
            resultById: 'resultRange14'
        });
    }
    if (checkResultRange15()) {
        return helpers_1.returnToolScoreObject({
            resultById: 'resultRange15'
        });
    }
    if (checkResultRange16()) {
        return helpers_1.returnToolScoreObject({
            resultById: 'resultRange16'
        });
    }
    if (checkNoDisease()) {
        return helpers_1.returnToolScoreObject({
            resultById: 'noDisease'
        });
    }
    return helpers_1.returnToolScoreObject({
        resultById: 'resultRange2'
    });
};
var returnVisibleQuestions = function () {
    visibleQuestions.t1subgroups = isPrimaryTumorT1();
    visibleQuestions.t2subgroups = isPrimaryTumorT2();
    visibleQuestions.t3subgroups = isPrimaryTumorT3();
    visibleQuestions.t4subgroups = isPrimaryTumorT4();
    visibleQuestions.n1subgroups = isLymphNodesN1();
    visibleQuestions.n2subgroups = isLymphNodesN2();
    visibleQuestions.n3subgroups = isLymphNodesN3();
    visibleQuestions.subGroupM1 = isMetastasisM1();
    visibleQuestions.concentrationLDH = isSubGroupM1Answered();
    visibleQuestions.lymphNodes = isLymphNodesVisible();
    visibleQuestions.metastasis = isMetastatisVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var ut_toolScore = function () {
    return calculatePoints();
};
var isExportResultsEnabled = function () {
    return !checkResultRange1();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return __assign(__assign({ exportResultsEnabled: isExportResultsEnabled() }, result), { visibleQuestions: ut_visibleQuestions(), visibleSections: ut_visibleSections() });
});
