"use strict";


var visibleQuestions = {
    creatinine: true,
    result2a: false,
    result2b: false,
    result2c: false,
    result2d: false,
    duration: false,
    warningKidney: false,
    anti2: false
};
var visibleSections = {
    ageSelection: true,
    adultsDose: false,
    warningA: false,
    anti: false
};
var inputs = {
    creatinine: null
};
var isAdultsDoseVisible = function () {
    return helpers_1.isAnswered(inputs.creatinine);
};
var isWarningAVisible = function () {
    return (helpers_1.answerMatches(inputs.creatinine, 'less10') ||
        helpers_1.answerMatches(inputs.creatinine, 'middle') ||
        helpers_1.answerMatches(inputs.creatinine, 'upperMiddle'));
};
var isAntiVisible = function () {
    return isAdultsDoseVisible();
};
var isResult2aVisible = function () {
    return isAdultsDoseVisible() && helpers_1.answerMatches(inputs.creatinine, 'above50');
};
var isResult2bVisible = function () {
    return (isAdultsDoseVisible() && helpers_1.answerMatches(inputs.creatinine, 'upperMiddle'));
};
var isResult2cVisible = function () {
    return isAdultsDoseVisible() && helpers_1.answerMatches(inputs.creatinine, 'middle');
};
var isResult2dVisible = function () {
    return isAdultsDoseVisible() && helpers_1.answerMatches(inputs.creatinine, 'less10');
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.result2a = isResult2aVisible();
    visibleQuestions.result2b = isResult2bVisible();
    visibleQuestions.result2c = isResult2cVisible();
    visibleQuestions.result2d = isResult2dVisible();
    visibleQuestions.duration = isAdultsDoseVisible();
    visibleQuestions.warningKidney = isWarningAVisible();
    visibleQuestions.anti2 = isAntiVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.adultsDose = isAdultsDoseVisible();
    visibleSections.warningA = isWarningAVisible();
    visibleSections.anti = isAntiVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return helpers_1.isAnswered(inputs.creatinine);
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: { number: result, range: result },
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
