"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    weight: true,
    answerAll: false,
    tabletsA1: false,
    tabletsA3: false,
    tabletsA4: false,
    suspensionA1: false,
    suspensionA3: false,
    suspensionA4: false,
    warningK1: false,
    tabletsK1: false,
    tabletsK3: false,
    tabletsK4: false,
    suspensionK1: false,
    suspensionK3: false,
    suspensionK4: false,
    warningWeight1: false,
    warningB1: false,
    suspensionB1: false,
    suspensionB3: false,
    suspensionB4: false,
    kidneyMildWarning: false,
    kidneyEndWarning: false,
    liverWarning: false
};
var visibleSections = {
    weightSelection: true,
    dosing: false,
    tabletsA: false,
    suspensionA: false,
    warningK: false,
    tabletsK: false,
    suspensionK: false,
    warningWeight: false,
    warningB: false,
    suspensionB: false,
    kidney: false
};
var inputs = {
    weight: null
};
var isWeightInLimits = function () {
    return helpers_1.numberInLimits({
        input: inputs.weight,
        min: 1,
        max: 200
    });
};
var isDosingVisible = function () {
    return !isWeightInLimits();
};
var isTabletsAVisible = function () {
    return helpers_1.numberInLimits({
        input: inputs.weight,
        min: 60.001,
        max: 200
    });
};
var isWarningKVisible = function () {
    return helpers_1.numberInLimits({
        input: inputs.weight,
        min: 30,
        max: 60
    });
};
var isWarningWeightVisible = function () {
    return helpers_1.numberInLimits({
        input: inputs.weight,
        min: 1,
        max: 12.999
    });
};
var isWarningBVisible = function () {
    return helpers_1.numberInLimits({
        input: inputs.weight,
        min: 1,
        max: 29.999
    });
};
var isKidneyVisible = function () {
    return helpers_1.numberInLimits({
        input: inputs.weight,
        min: 13,
        max: 200
    });
};
var calculatePoints = function () {
    var _a, _b, _c, _d;
    if (isWarningKVisible()) {
        var result1 = Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints) * 0.1;
        var result2 = Number((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints) * 0.15;
        return {
            suspensionK1: {
                qID: 'suspensionK1',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(result1, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(result2, 2), 0, 2)),
                titleTexts: 'regular'
            }
        };
    }
    if (isWarningBVisible()) {
        var result1 = Number((_c = inputs.weight) === null || _c === void 0 ? void 0 : _c.currentPoints) * 0.1;
        var result2 = Number((_d = inputs.weight) === null || _d === void 0 ? void 0 : _d.currentPoints) * 0.15;
        return {
            suspensionB1: {
                qID: 'suspensionB1',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(result1, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(result2, 2), 0, 2)),
                titleTexts: 'regular'
            }
        };
    }
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.answerAll = isDosingVisible();
    visibleQuestions.tabletsA1 = isTabletsAVisible();
    visibleQuestions.tabletsA3 = isTabletsAVisible();
    visibleQuestions.tabletsA4 = isTabletsAVisible();
    visibleQuestions.suspensionA1 = isTabletsAVisible();
    visibleQuestions.suspensionA3 = isTabletsAVisible();
    visibleQuestions.suspensionA4 = isTabletsAVisible();
    visibleQuestions.warningK1 = isWarningKVisible();
    visibleQuestions.tabletsK1 = isWarningKVisible();
    visibleQuestions.tabletsK3 = isWarningKVisible();
    visibleQuestions.tabletsK4 = isWarningKVisible();
    visibleQuestions.suspensionK1 = isWarningKVisible();
    visibleQuestions.suspensionK3 = isWarningKVisible();
    visibleQuestions.suspensionK4 = isWarningKVisible();
    visibleQuestions.warningWeight1 = isWarningWeightVisible();
    visibleQuestions.warningB1 = isWarningBVisible();
    visibleQuestions.suspensionB1 = isWarningBVisible();
    visibleQuestions.suspensionB3 = isWarningBVisible();
    visibleQuestions.suspensionB4 = isWarningBVisible();
    visibleQuestions.kidneyMildWarning = isKidneyVisible();
    visibleQuestions.kidneyEndWarning = isKidneyVisible();
    visibleQuestions.liverWarning = isKidneyVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.dosing = isDosingVisible();
    visibleSections.tabletsA = isTabletsAVisible();
    visibleSections.suspensionA = isTabletsAVisible();
    visibleSections.warningK = isWarningKVisible();
    visibleSections.tabletsK = isWarningKVisible();
    visibleSections.suspensionK = isWarningKVisible();
    visibleSections.warningWeight = isWarningWeightVisible();
    visibleSections.suspensionB = isWarningBVisible();
    visibleSections.warningB = isWarningBVisible();
    visibleSections.kidney = isKidneyVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return !isDosingVisible();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
