"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    age: true,
    weight: false,
    noAnswerElement: false,
    dosingToddlersElement: false,
    warningSix: false,
    doseSix: false,
    doseSixB: false,
    durationSix: false,
    doseAboveSixA: false,
    durationAboveSixA: false,
    divider1_copy: false,
    warningAboveSix: false,
    doseAboveSixB: false,
    doseAboveSixC: false,
    durationAboveSixB: false,
    doseAdolescents: false,
    durationAdolescents: false,
    doseAdults: false,
    durationAdults: false,
    kidneyDisease: false,
    kidneyAnuria: false,
    element1: false
};
var visibleSections = {
    ageSection: true,
    noAnswer: true,
    dosingUnderSix: false,
    dosingSix: false,
    dosingAboveSix: false,
    dosingAdolescents: false,
    dosingAdults: false,
    kidney: false,
    antimicrobialWarning: false
};
var inputs = {
    age: null,
    weight: null
};
var isWeightVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'aboveSix') || helpers_1.answerMatches(inputs.age, 'six'));
};
var isAnswerAllVisible = function () {
    return !(helpers_1.isAnswered(inputs.age) &&
        ((isWeightVisible() &&
            helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 70 })) ||
            !isWeightVisible()));
};
var isDosingUnderSixVisible = function () {
    return helpers_1.answerMatches(inputs.age, 'underSix');
};
var isDosingSixVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'six') &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 70 }));
};
var isWarningSixVisible = function () {
    return (isDosingSixVisible() &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 20.1, max: 70 }));
};
var isDoseSixVisible = function () {
    return (isDosingSixVisible() &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 68.5 }));
};
var isDoseSixBVisible = function () {
    return (isDosingSixVisible() &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 68.6, max: 70 }));
};
var isDosingAboveSixVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'aboveSix') &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 70 }));
};
var isWarningAboveSixVisible = function () {
    return (isDosingAboveSixVisible() &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 20.1, max: 70 }));
};
var isDoseAboveSixBVisible = function () {
    return (isDosingAboveSixVisible() &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 68.5 }));
};
var isDoseAboveSixCVisible = function () {
    return (isDosingAboveSixVisible() &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 68.6, max: 70 }));
};
var isDosingAdolescentsVisible = function () {
    return helpers_1.answerMatches(inputs.age, 'adolescents');
};
var isDosingAdultsVisible = function () {
    return helpers_1.answerMatches(inputs.age, 'adults');
};
var isKidneyVisible = function () {
    return !isAnswerAllVisible() && !helpers_1.answerMatches(inputs.age, 'underSix');
};
var calculatePoints = function () {
    var _a;
    var weight = Number((_a = inputs === null || inputs === void 0 ? void 0 : inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints);
    if (isDosingSixVisible()) {
        var X = weight * 35;
        var Y = weight >= 48 ? 2400 : weight * 50;
        return {
            doseSix: {
                qID: 'doseSix',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(X, 0), 0, 0), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(Y, 0), 0, 0)),
                titleTexts: 'doseSix'
            }
        };
    }
    if (isDoseAboveSixBVisible()) {
        var X = weight * 35;
        var Y = weight >= 48 ? 2400 : weight * 50;
        return {
            doseAboveSixB: {
                qID: 'doseAboveSixB',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(X, 0), 0, 0), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(Y, 0), 0, 0)),
                titleTexts: 'doseAboveSix1'
            }
        };
    }
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.weight = isWeightVisible();
    visibleQuestions.noAnswerElement = isAnswerAllVisible();
    visibleQuestions.dosingToddlersElement = isDosingUnderSixVisible();
    visibleQuestions.warningSix = isWarningSixVisible();
    visibleQuestions.doseSix = isDoseSixVisible();
    visibleQuestions.doseSixB = isDoseSixBVisible();
    visibleQuestions.durationSix = isDosingSixVisible();
    visibleQuestions.doseAboveSixA = isDosingAboveSixVisible();
    visibleQuestions.durationAboveSixA = isDosingAboveSixVisible();
    visibleQuestions.divider1_copy = isDosingAboveSixVisible();
    visibleQuestions.warningAboveSix = isWarningAboveSixVisible();
    visibleQuestions.doseAboveSixB = isDoseAboveSixBVisible();
    visibleQuestions.doseAboveSixC = isDoseAboveSixCVisible();
    visibleQuestions.durationAboveSixB = isDosingAboveSixVisible();
    visibleQuestions.doseAdolescents = isDosingAdolescentsVisible();
    visibleQuestions.durationAdolescents = isDosingAdolescentsVisible();
    visibleQuestions.doseAdults = isDosingAdultsVisible();
    visibleQuestions.durationAdults = isDosingAdultsVisible();
    visibleQuestions.kidneyDisease = isKidneyVisible();
    visibleQuestions.kidneyAnuria = isKidneyVisible();
    visibleQuestions.element1 = isKidneyVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = isAnswerAllVisible();
    visibleSections.dosingUnderSix = isDosingUnderSixVisible();
    visibleSections.dosingSix = isDosingSixVisible();
    visibleSections.dosingAboveSix = isDosingAboveSixVisible();
    visibleSections.dosingAdolescents = isDosingAdolescentsVisible();
    visibleSections.dosingAdults = isDosingAdultsVisible();
    visibleSections.kidney = isKidneyVisible();
    visibleSections.antimicrobialWarning = isKidneyVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return !isAnswerAllVisible();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
