"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    age: true,
    weightChildren: false,
    weightBabies: false,
    noAnswerElement: true,
    doseBabies: false,
    dividerDosingBabies: false,
    doseBabiesB: false,
    durationBabiesB: false,
    warningBabies: false,
    doseChildrenTablets2: false,
    doseChildrenTablets: false,
    durationChildrenTablets: false,
    doseChildrenInfusion: false,
    dividerChildrenInfusion: false,
    doseChildrenInfusionB: false,
    durationChildrenInfusionB: false,
    doseAdultsTablets: false,
    doseAdultsBTablets: false,
    durationAdultsTablets: false,
    doseAdultsInfusion: false,
    instructionAdults: false,
    durationAdultsInfusion: false,
    dividerDosingAdultsInfusion: false,
    doseAdultsInfusion2: false,
    doseAdultsInfusion3: false,
    durationAdultsInfusion2: false,
    kidneyDisease: false,
    kidneyAnuria: false,
    element1: false
};
var visibleSections = {
    ageSection: true,
    noAnswer: true,
    dosingBabiesInfusion: false,
    dosingChildrenTablets: false,
    dosingChildrenInfusion: false,
    dosingAdultsTablets: false,
    dosingAdultsInfusion: false,
    kidney: false,
    antimicrobialWarning: false
};
var inputs = {
    age: null,
    weightChildren: null,
    weightBabies: null
};
var isWeightChildrenVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'smallChildren') ||
        helpers_1.answerMatches(inputs.age, 'children'));
};
var isWeightBabiesVisible = function () {
    return helpers_1.answerMatches(inputs.age, 'babies');
};
var isAnswerAllVisible = function () {
    return !((isWeightChildrenVisible() &&
        helpers_1.numberInLimits({ input: inputs.weightChildren, min: 1, max: 70 })) ||
        (isWeightBabiesVisible() &&
            helpers_1.numberInLimits({ input: inputs.weightBabies, min: 1, max: 8 })) ||
        helpers_1.answerMatches(inputs.age, 'adults'));
};
var isDosingBabiesInfusionVisible = function () {
    return helpers_1.numberInLimits({ input: inputs.weightBabies, min: 1, max: 8 });
};
var isDoseChildrenTablets2Visible = function () {
    return (helpers_1.answerMatches(inputs.age, 'children') &&
        helpers_1.numberInLimits({ input: inputs.weightChildren, min: 33.4, max: 70 }));
};
var isDosingChildrenTabletsVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'children') &&
        helpers_1.numberInLimits({ input: inputs.weightChildren, min: 10, max: 70 }));
};
var isDosingChildrenInfusionVisible = function () {
    return ((helpers_1.answerMatches(inputs.age, 'children') ||
        helpers_1.answerMatches(inputs.age, 'smallChildren')) &&
        helpers_1.numberInLimits({ input: inputs.weightChildren, min: 1, max: 70 }));
};
var isDosingAdultsTabletsVisible = function () {
    return helpers_1.answerMatches(inputs.age, 'adults');
};
var isDosingAdultsInfusionVisible = function () {
    return helpers_1.answerMatches(inputs.age, 'adults');
};
var calculatePoints = function () {
    var _a, _b;
    if (isDosingBabiesInfusionVisible()) {
        var weight = Number((_a = inputs === null || inputs === void 0 ? void 0 : inputs.weightBabies) === null || _a === void 0 ? void 0 : _a.currentPoints);
        var X = weight * 3;
        var Y = weight * 15;
        var N = weight * 1.5;
        var M = weight * 7.5;
        return {
            doseBabies: {
                qID: 'doseBabies',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(X, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(Y, 0), 0, 0)),
                titleTexts: 'doseBabies1'
            },
            doseBabiesB: {
                qID: 'doseBabiesB',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(N, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(M, 0), 0, 0)),
                titleTexts: 'doseBabiesB1'
            }
        };
    }
    if (isDosingChildrenInfusionVisible()) {
        var weight = Number((_b = inputs === null || inputs === void 0 ? void 0 : inputs.weightChildren) === null || _b === void 0 ? void 0 : _b.currentPoints);
        var X = weight * 4;
        var Y = weight >= 50 ? 300 : weight * 6;
        var Z = weight * 20;
        var C = weight >= 50 ? 1500 : weight * 30;
        var N = weight >= 66.7 ? 100 : weight * 1.5;
        var M = weight >= 66.7 ? 500 : weight * 7.5;
        var obj = {};
        if (isDosingChildrenTabletsVisible()) {
            var J = weight * 20;
            var I = weight >= 66.7 ? 2000 : weight * 30;
            obj = {
                doseChildrenTablets: {
                    qID: 'doseChildrenTablets',
                    tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(J, 0), 0, 0), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(I, 0), 0, 0)),
                    titleTexts: 'doseChildrenTablets'
                }
            };
        }
        return __assign({ doseChildrenInfusion: {
                qID: 'doseChildrenInfusion',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(X, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(Y, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(Z, 0), 0, 0), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(C, 0), 0, 0)),
                titleTexts: 'doseChildrenInfusion'
            }, doseChildrenInfusionB: {
                qID: 'doseChildrenInfusionB',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(N, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(M, 0), 0, 0)),
                titleTexts: 'doseChildrenB1'
            } }, obj);
    }
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.weightChildren = isWeightChildrenVisible();
    visibleQuestions.weightBabies = isWeightBabiesVisible();
    visibleQuestions.noAnswerElement = isAnswerAllVisible();
    visibleQuestions.doseBabies = isDosingBabiesInfusionVisible();
    visibleQuestions.dividerDosingBabies = isDosingBabiesInfusionVisible();
    visibleQuestions.doseBabiesB = isDosingBabiesInfusionVisible();
    visibleQuestions.durationBabiesB = isDosingBabiesInfusionVisible();
    visibleQuestions.warningBabies = isDosingBabiesInfusionVisible();
    visibleQuestions.doseChildrenTablets2 = isDoseChildrenTablets2Visible();
    visibleQuestions.doseChildrenTablets = isDosingChildrenTabletsVisible();
    visibleQuestions.durationChildrenTablets = isDosingChildrenTabletsVisible();
    visibleQuestions.doseChildrenInfusion = isDosingChildrenInfusionVisible();
    visibleQuestions.dividerChildrenInfusion = isDosingChildrenInfusionVisible();
    visibleQuestions.doseChildrenInfusionB = isDosingChildrenInfusionVisible();
    visibleQuestions.durationChildrenInfusionB =
        isDosingChildrenInfusionVisible();
    visibleQuestions.doseAdultsTablets = isDosingAdultsTabletsVisible();
    visibleQuestions.doseAdultsBTablets = isDosingAdultsTabletsVisible();
    visibleQuestions.durationAdultsTablets = isDosingAdultsTabletsVisible();
    visibleQuestions.doseAdultsInfusion = isDosingAdultsTabletsVisible();
    visibleQuestions.instructionAdults = isDosingAdultsTabletsVisible();
    visibleQuestions.durationAdultsInfusion = isDosingAdultsTabletsVisible();
    visibleQuestions.dividerDosingAdultsInfusion = isDosingAdultsTabletsVisible();
    visibleQuestions.doseAdultsInfusion2 = isDosingAdultsTabletsVisible();
    visibleQuestions.doseAdultsInfusion3 = isDosingAdultsTabletsVisible();
    visibleQuestions.durationAdultsInfusion2 = isDosingAdultsTabletsVisible();
    visibleQuestions.kidneyDisease = !isAnswerAllVisible();
    visibleQuestions.kidneyAnuria = !isAnswerAllVisible();
    visibleQuestions.element1 = !isAnswerAllVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = isAnswerAllVisible();
    visibleSections.dosingBabiesInfusion = isDosingBabiesInfusionVisible();
    visibleSections.dosingChildrenTablets = isDosingChildrenTabletsVisible();
    visibleSections.dosingChildrenInfusion = isDosingChildrenInfusionVisible();
    visibleSections.dosingAdultsTablets = isDosingAdultsTabletsVisible();
    visibleSections.dosingAdultsInfusion = isDosingAdultsInfusionVisible();
    visibleSections.kidney = !isAnswerAllVisible();
    visibleSections.antimicrobialWarning = !isAnswerAllVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return !isAnswerAllVisible();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
