"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    age: true,
    weightChildren: false,
    weightNeonates: false,
    noAnswerElement: true,
    doseBabies: false,
    durationNeonates: false,
    doseChildrenTablets2: false,
    doseChildrenTablets: false,
    durationChildrenTablets: false,
    doseChildrenInfusion2: false,
    doseChildrenInfusion: false,
    durationChildrenInfusion: false,
    doseAdultsTablets: false,
    doseAdultsInfusion: false,
    doseAdultsInfusionB: false,
    instructionsAdults: false,
    kidneyDisease: false,
    kidneyAnuria: false,
    element1: false
};
var visibleSections = {
    ageSection: true,
    noAnswer: true,
    dosingNeonatesInfusion: false,
    dosingChildrenTablets: false,
    dosingChildrenInfusion: false,
    dosingAdultsTablets: false,
    dosingAdultsInfusion: false,
    kidney: false,
    antimicrobialWarning: false
};
var inputs = {
    age: null,
    weightChildren: null,
    weightNeonates: null
};
var calculatePoints = function () {
    var _a, _b;
    if (isDosingNeonatesInfusionVisible()) {
        var weight = Number((_a = inputs === null || inputs === void 0 ? void 0 : inputs.weightNeonates) === null || _a === void 0 ? void 0 : _a.currentPoints);
        var X = weight * 2;
        var Y = weight * 10;
        return {
            doseBabies: {
                qID: 'doseBabies',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(X, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(Y, 0), 0, 0)),
                titleTexts: 'doseBabies1'
            }
        };
    }
    if (isDosingChildrenInfusionVisible()) {
        var weight = Number((_b = inputs === null || inputs === void 0 ? void 0 : inputs.weightChildren) === null || _b === void 0 ? void 0 : _b.currentPoints);
        var obj = {};
        if (isDosingChildrenTabletsVisible()) {
            var J = weight * 20;
            var I = weight >= 66.7 ? 2000 : weight * 30;
            obj = {
                doseChildrenTablets: {
                    qID: 'doseChildrenTablets',
                    tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(J, 0), 0, 0), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(I, 0), 0, 0)),
                    titleTexts: 'doseChildrenTablets'
                }
            };
        }
        var X = weight * 4;
        var Y = weight >= 50 ? 300 : weight * 6;
        var Z = weight * 20;
        var N = weight >= 50 ? 1500 : weight * 30;
        return __assign({ doseChildrenInfusion: {
                qID: 'doseChildrenInfusion',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(X, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(Y, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(Z, 0), 0, 0), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(N, 0), 0, 0)),
                titleTexts: 'doseChildrenInfusion'
            } }, obj);
    }
    return null;
};
var isWeightChildrenVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'children') ||
        helpers_1.answerMatches(inputs.age, 'smallChildren'));
};
var isWeightNeonatesVisible = function () {
    return helpers_1.answerMatches(inputs.age, 'neonates');
};
var isAnswerAllVisible = function () {
    return !(helpers_1.answerMatches(inputs.age, 'adults') ||
        (isWeightChildrenVisible() &&
            helpers_1.numberInLimits({ input: inputs.weightChildren, min: 1, max: 70 })) ||
        (isWeightNeonatesVisible() &&
            helpers_1.numberInLimits({ input: inputs.weightNeonates, min: 1, max: 8 })));
};
var isDosingNeonatesInfusionVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'neonates') &&
        helpers_1.numberInLimits({ input: inputs.weightNeonates, min: 1, max: 8 }));
};
var isDosingChildrenTabletsVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'children') &&
        helpers_1.numberInLimits({ input: inputs.weightChildren, min: 10, max: 70 }));
};
var isDosingChildrenTablets2Visible = function () {
    return (helpers_1.answerMatches(inputs.age, 'children') &&
        helpers_1.numberInLimits({ input: inputs.weightChildren, min: 20.1, max: 70 }));
};
var isDosingChildrenInfusionVisible = function () {
    return ((helpers_1.answerMatches(inputs.age, 'children') ||
        helpers_1.answerMatches(inputs.age, 'smallChildren')) &&
        helpers_1.numberInLimits({ input: inputs.weightChildren, min: 1, max: 70 }));
};
var isDosingChildrenInfusion2Visible = function () {
    return (isDosingChildrenInfusionVisible() &&
        helpers_1.numberInLimits({ input: inputs.weightChildren, min: 16.7, max: 70 }));
};
var isAdultsVisible = function () {
    return helpers_1.answerMatches(inputs.age, 'adults');
};
var returnVisibleQuestions = function () {
    visibleQuestions.weightChildren = isWeightChildrenVisible();
    visibleQuestions.weightNeonates = isWeightNeonatesVisible();
    visibleQuestions.noAnswerElement = isAnswerAllVisible();
    visibleQuestions.doseBabies = isDosingNeonatesInfusionVisible();
    visibleQuestions.durationNeonates = isDosingNeonatesInfusionVisible();
    visibleQuestions.doseChildrenTablets2 = isDosingChildrenTablets2Visible();
    visibleQuestions.doseChildrenTablets = isDosingChildrenTabletsVisible();
    visibleQuestions.durationChildrenTablets = isDosingChildrenTabletsVisible();
    visibleQuestions.doseChildrenInfusion2 = isDosingChildrenInfusion2Visible();
    visibleQuestions.doseChildrenInfusion = isDosingChildrenInfusionVisible();
    visibleQuestions.durationChildrenInfusion = isDosingChildrenInfusionVisible();
    visibleQuestions.doseAdultsTablets = isAdultsVisible();
    visibleQuestions.doseAdultsInfusion = isAdultsVisible();
    visibleQuestions.doseAdultsInfusionB = isAdultsVisible();
    visibleQuestions.instructionsAdults = isAdultsVisible();
    visibleQuestions.kidneyDisease = !isAnswerAllVisible();
    visibleQuestions.kidneyAnuria = !isAnswerAllVisible();
    visibleQuestions.element1 = !isAnswerAllVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = isAnswerAllVisible();
    visibleSections.dosingNeonatesInfusion = isDosingNeonatesInfusionVisible();
    visibleSections.dosingChildrenTablets = isDosingChildrenTabletsVisible();
    visibleSections.dosingChildrenInfusion = isDosingChildrenInfusionVisible();
    visibleSections.dosingAdultsTablets = isAdultsVisible();
    visibleSections.dosingAdultsInfusion = isAdultsVisible();
    visibleSections.kidney = !isAnswerAllVisible();
    visibleSections.antimicrobialWarning = !isAnswerAllVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return !isAnswerAllVisible();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
