"use strict";


var visibleQuestions = {
    age: true,
    noAnswerElement: true,
    doseAdolescentsA: false,
    durationAdolescentsA: false,
    dividerAdolescents: false,
    doseAdolescentsB: false,
    durationAdolescentsB: false,
    doseAdultsA: false,
    durationAdultsA: false,
    dividerAdults: false,
    doseAdultsB: false,
    durationAdultsB: false,
    kidneyDisease: false,
    kidneyAnuria: false,
    element1: false
};
var visibleSections = {
    ageSection: true,
    noAnswer: true,
    dosingAdolescents: false,
    dosingAdults: false,
    kidney: false,
    antimicrobialWarning: false
};
var inputs = {
    age: null
};
var isAnswerAgeMatches = function (name) {
    return helpers_1.answerMatches(inputs.age, name);
};
var isNoAnswerVisible = function () {
    return !helpers_1.isAnswered(inputs.age);
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.noAnswerElement = isNoAnswerVisible();
    visibleQuestions.doseAdolescentsA = isAnswerAgeMatches('adolescents');
    visibleQuestions.durationAdolescentsA = isAnswerAgeMatches('adolescents');
    visibleQuestions.dividerAdolescents = isAnswerAgeMatches('adolescents');
    visibleQuestions.doseAdolescentsB = isAnswerAgeMatches('adolescents');
    visibleQuestions.durationAdolescentsB = isAnswerAgeMatches('adolescents');
    visibleQuestions.doseAdultsA = isAnswerAgeMatches('adults');
    visibleQuestions.durationAdultsA = isAnswerAgeMatches('adults');
    visibleQuestions.dividerAdults = isAnswerAgeMatches('adults');
    visibleQuestions.doseAdultsB = isAnswerAgeMatches('adults');
    visibleQuestions.durationAdultsB = isAnswerAgeMatches('adults');
    visibleQuestions.kidneyDisease = !isNoAnswerVisible();
    visibleQuestions.kidneyAnuria = !isNoAnswerVisible();
    visibleQuestions.element1 = !isNoAnswerVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = isNoAnswerVisible();
    visibleSections.dosingAdolescents = isAnswerAgeMatches('adolescents');
    visibleSections.dosingAdults = isAnswerAgeMatches('adults');
    visibleSections.kidney = !isNoAnswerVisible();
    visibleSections.antimicrobialWarning = !isNoAnswerVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return !isNoAnswerVisible();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
