"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    indications: true,
    age: true,
    weight: false,
    noAnswerResult: false,
    resultsTabletsA: false,
    dosingTabletsAdults: false,
    durationAdultsT: false,
    resultsSolutionA: false,
    dosingDailyAdults: false,
    durationAdultsL: false,
    intravenousAdults: false,
    warningInjection: false,
    dividerAdultIntramuscular: false,
    intramuscularAdults: false,
    durationAdultsI: false,
    intrathecalAdults: false,
    warningDiscontinuationA: false,
    doseInfoA: false,
    warningChronicA: false,
    resultsTabletsChildrenAdults: false,
    dosingDailyAdultsChildrenTablets: false,
    durationChildrenAdults: false,
    resultsSolutionC: false,
    dosingDailyChildren: false,
    durationChildrenLosung: false,
    resultsTabletsChildrenAdultsSecond: false,
    dosingDailyAdultsChildrenTabletsSecond: false,
    durationChildrenAdultsSecond: false,
    resultsSolutionSecond: false,
    dosingDailySecond: false,
    durationChildrenSecond: false,
    intravenousChildren: false,
    warningChildren: false,
    dividerintramuscularChildren: false,
    intramuscularChildren: false,
    durationChildrenI: false,
    intrathecalChildren: false,
    warningDiscontinuationC: false,
    doseInfoC: false,
    warningChronicC: false,
    kidneyText: false,
    smpc1: true,
    smpc2: true,
    smpc3: true
};
var visibleSections = {
    indicationsSection: true,
    questionSection: true,
    noAnswerSection: false,
    tabletsAdults: false,
    resultsAdultSolution: false,
    resultsAdultInjection: false,
    warningsAdults: false,
    tabletsChildrenAdults: false,
    resultsChildrenSolution: false,
    tabletsChildrenAdultsSecond: false,
    resultsChildrenSolutionSecond: false,
    resultsChildrenInjection: false,
    warningsChildren: false,
    kidneySection: false
};
var inputs = {
    age: null,
    weight: null
};
var isWeightVisible = function () {
    return helpers_1.isAnswered(inputs.age);
};
var isWeightInLimits = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 200 });
};
var isNoAnswerSectionVisible = function () {
    return !isWeightVisible() || !isWeightInLimits();
};
var isTabletsAdultsVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'adults') &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 20, max: 200 }));
};
var isResultsAdultSolutionVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'adults') &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 12.5, max: 200 }));
};
var isResultsAdultInjectionVisible = function () {
    return helpers_1.answerMatches(inputs.age, 'adults') && isWeightInLimits();
};
var isWarningsAdultsVisible = function () {
    return isResultsAdultInjectionVisible();
};
var isTabletsChildrenAdultsVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'children') &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 20, max: 50 }));
};
var isResultsChildrenSolutionVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'children') &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 12.5, max: 50 }));
};
var isTabletsChildrenAdultsSecondVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'children') &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 50.01, max: 200 }));
};
var isResultsChildrenSolutionSecondVisible = function () {
    return isTabletsChildrenAdultsSecondVisible();
};
var isResultsChildrenInjectionVisible = function () {
    return helpers_1.answerMatches(inputs.age, 'children') && isWeightInLimits();
};
var isWarningsChildrenVisible = function () {
    return isResultsChildrenInjectionVisible();
};
var isKidneySectionVisible = function () {
    return helpers_1.isAnswered(inputs.age) && isWeightInLimits();
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9;
    if (isTabletsAdultsVisible() && isResultsAdultSolutionVisible()) {
        var minMgTabletsA = Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints) * 0.2;
        var maxMgTabletsA = Number((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints) * 0.3;
        var minMgResultsTabletsA = minMgTabletsA < 1
            ? minMgTabletsA
            : helpers_1.formatCalculationResult(minMgTabletsA, 0);
        var maxMgResultsTabletsA = maxMgTabletsA < 1
            ? maxMgTabletsA
            : helpers_1.formatCalculationResult(maxMgTabletsA, 0);
        var minMlSolutionA = Number((_c = inputs.weight) === null || _c === void 0 ? void 0 : _c.currentPoints) * 0.1;
        var maxMlSolutionA = Number((_d = inputs.weight) === null || _d === void 0 ? void 0 : _d.currentPoints) * 0.15;
        var minMgSolutionA = Number((_e = inputs.weight) === null || _e === void 0 ? void 0 : _e.currentPoints) * 0.2;
        var maxMgSolutionA = Number((_f = inputs.weight) === null || _f === void 0 ? void 0 : _f.currentPoints) * 0.3;
        return {
            resultsTabletsA: {
                qID: 'resultsTabletsA',
                tParams: __spreadArrays(helpers_1.returnNumberObject(minMgResultsTabletsA, 0, 0), helpers_1.returnNumberObject(maxMgResultsTabletsA, 0, 0)),
                rParams: [],
                titleTexts: 'result1',
                resultTexts: 'result1'
            },
            dosingTabletsAdults: {
                qID: 'dosingTabletsAdults',
                tParams: [],
                titleTexts: 'result1'
            },
            durationAdultsT: {
                qID: 'durationAdultsT',
                tParams: [],
                titleTexts: 'durationAdults1'
            },
            resultsSolutionA: {
                qID: 'resultsSolutionA',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(minMlSolutionA, 2), 0, 2), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(maxMlSolutionA, 2), 0, 2), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(minMgSolutionA, 2), 0, 2), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(maxMgSolutionA, 2), 0, 2)),
                rParams: [],
                titleTexts: 'result1',
                resultTexts: 'result1'
            },
            dosingDailyAdults: {
                qID: 'dosingDailyAdults',
                tParams: [],
                titleTexts: 'result1'
            },
            durationAdultsL: {
                qID: 'durationAdultsL',
                tParams: [],
                titleTexts: 'durationAdults1'
            }
        };
    }
    if (isResultsAdultSolutionVisible()) {
        var minMlSolutionA = Number((_g = inputs.weight) === null || _g === void 0 ? void 0 : _g.currentPoints) * 0.1;
        var maxMlSolutionA = Number((_h = inputs.weight) === null || _h === void 0 ? void 0 : _h.currentPoints) * 0.15;
        var minMgSolutionA = Number((_j = inputs.weight) === null || _j === void 0 ? void 0 : _j.currentPoints) * 0.2;
        var maxMgSolutionA = Number((_k = inputs.weight) === null || _k === void 0 ? void 0 : _k.currentPoints) * 0.3;
        return {
            resultsSolutionA: {
                qID: 'resultsSolutionA',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(minMlSolutionA, 2), 0, 2), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(maxMlSolutionA, 2), 0, 2), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(minMgSolutionA, 2), 0, 2), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(maxMgSolutionA, 2), 0, 2)),
                rParams: [],
                titleTexts: 'result1',
                resultTexts: 'result1'
            },
            dosingDailyAdults: {
                qID: 'dosingDailyAdults',
                tParams: [],
                titleTexts: 'result1'
            },
            durationAdultsL: {
                qID: 'durationAdultsL',
                tParams: [],
                titleTexts: 'durationAdults1'
            }
        };
    }
    if (isResultsChildrenInjectionVisible()) {
        var minMlIntravenousC = Number((_l = inputs.weight) === null || _l === void 0 ? void 0 : _l.currentPoints) * 0.005;
        var maxMlIntravenousC = Number((_m = inputs.weight) === null || _m === void 0 ? void 0 : _m.currentPoints) * 0.01;
        var minMgIntravenousC = Number((_o = inputs.weight) === null || _o === void 0 ? void 0 : _o.currentPoints) * 0.05;
        var maxMgIntravenousC = Number((_p = inputs.weight) === null || _p === void 0 ? void 0 : _p.currentPoints) * 0.1;
        var minMlIntramuscularC = Number((_q = inputs.weight) === null || _q === void 0 ? void 0 : _q.currentPoints) * 0.005;
        var maxMlIntramuscularC = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 75,
            max: 200
        })
            ? 1.5
            : Number((_r = inputs.weight) === null || _r === void 0 ? void 0 : _r.currentPoints) * 0.02;
        var minMgIntramuscularC = Number((_s = inputs.weight) === null || _s === void 0 ? void 0 : _s.currentPoints) * 0.05;
        var maxMgIntramuscularC = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 75,
            max: 200
        })
            ? 15
            : Number((_t = inputs.weight) === null || _t === void 0 ? void 0 : _t.currentPoints) * 0.2;
        var intravenousChildren = {
            qID: 'intravenousChildren',
            tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(helpers_1.formatCalculationResult(minMlIntravenousC, 4), 3), 0, 3), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(maxMlIntravenousC, 3), 0, 3), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(minMgIntravenousC, 2), 0, 2), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(maxMgIntravenousC, 2), 0, 2)),
            rParams: [],
            titleTexts: 'intravenousC',
            resultTexts: 'result1'
        };
        var intramuscularChildren = {
            qID: 'intramuscularChildren',
            tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(helpers_1.formatCalculationResult(minMlIntramuscularC, 4), 3), 0, 3), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(maxMlIntramuscularC, 3), 0, 3), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(minMgIntramuscularC, 2), 0, 2), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(maxMgIntramuscularC, 2), 0, 2)),
            rParams: [],
            titleTexts: 'intramuscularA',
            resultTexts: 'result1'
        };
        var warningChildren = {
            qID: 'warningChildren',
            tParams: [],
            titleTexts: 'result1'
        };
        var durationChildrenI = {
            qID: 'durationChildrenI',
            tParams: [],
            titleTexts: 'durationChildren'
        };
        var intrathecalChildren = {
            qID: 'intrathecalChildren',
            tParams: [],
            titleTexts: 'result1'
        };
        if (isTabletsChildrenAdultsVisible() &&
            isResultsChildrenSolutionVisible()) {
            var minMgTabletsC = Number((_u = inputs.weight) === null || _u === void 0 ? void 0 : _u.currentPoints) * 0.2;
            var maxMgTabletsC = Number((_v = inputs.weight) === null || _v === void 0 ? void 0 : _v.currentPoints) * 0.3;
            var minMlSolutionC = Number((_w = inputs.weight) === null || _w === void 0 ? void 0 : _w.currentPoints) * 0.1;
            var maxMlSolutionC = Number((_x = inputs.weight) === null || _x === void 0 ? void 0 : _x.currentPoints) * 0.15;
            var minMgSolutionC = Number((_y = inputs.weight) === null || _y === void 0 ? void 0 : _y.currentPoints) * 0.2;
            var maxMgSolutionC = Number((_z = inputs.weight) === null || _z === void 0 ? void 0 : _z.currentPoints) * 0.3;
            return {
                resultsTabletsChildrenAdults: {
                    qID: 'resultsTabletsChildrenAdults',
                    tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(minMgTabletsC, 0), 0, 0), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(maxMgTabletsC), 0, 0)),
                    rParams: [],
                    titleTexts: 'result1',
                    resultTexts: 'result1'
                },
                dosingDailyAdultsChildrenTablets: {
                    qID: 'dosingDailyAdultsChildrenTablets',
                    tParams: [],
                    titleTexts: 'result1'
                },
                durationChildrenAdults: {
                    qID: 'durationChildrenAdults',
                    tParams: [],
                    titleTexts: 'durationAdults1'
                },
                resultsSolutionC: {
                    qID: 'resultsSolutionC',
                    tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(minMlSolutionC, 2), 0, 2), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(maxMlSolutionC, 2), 0, 2), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(minMgSolutionC, 2), 0, 2), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(maxMgSolutionC, 2), 0, 2)),
                    rParams: [],
                    titleTexts: 'result1',
                    resultTexts: 'result1'
                },
                dosingDailyChildren: {
                    qID: 'dosingDailyChildren',
                    tParams: [],
                    titleTexts: 'result1'
                },
                durationChildrenLosung: {
                    qID: 'durationChildrenLosung',
                    tParams: [],
                    titleTexts: 'durationChildrenL'
                },
                intravenousChildren: intravenousChildren,
                warningChildren: warningChildren,
                intramuscularChildren: intramuscularChildren,
                durationChildrenI: durationChildrenI,
                intrathecalChildren: intrathecalChildren
            };
        }
        if (isResultsChildrenSolutionVisible()) {
            var minMlSolutionC = Number((_0 = inputs.weight) === null || _0 === void 0 ? void 0 : _0.currentPoints) * 0.1;
            var maxMlSolutionC = Number((_1 = inputs.weight) === null || _1 === void 0 ? void 0 : _1.currentPoints) * 0.15;
            var minMgSolutionC = Number((_2 = inputs.weight) === null || _2 === void 0 ? void 0 : _2.currentPoints) * 0.2;
            var maxMgSolutionC = Number((_3 = inputs.weight) === null || _3 === void 0 ? void 0 : _3.currentPoints) * 0.3;
            return {
                resultsSolutionC: {
                    qID: 'resultsSolutionC',
                    tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(minMlSolutionC, 2), 0, 2), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(maxMlSolutionC, 2), 0, 2), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(minMgSolutionC, 2), 0, 2), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(maxMgSolutionC, 2), 0, 2)),
                    rParams: [],
                    titleTexts: 'result1',
                    resultTexts: 'result1'
                },
                dosingDailyChildren: {
                    qID: 'dosingDailyChildren',
                    tParams: [],
                    titleTexts: 'result1'
                },
                durationChildrenLosung: {
                    qID: 'durationChildrenLosung',
                    tParams: [],
                    titleTexts: 'durationChildrenL'
                },
                intravenousChildren: intravenousChildren,
                warningChildren: warningChildren,
                intramuscularChildren: intramuscularChildren,
                durationChildrenI: durationChildrenI,
                intrathecalChildren: intrathecalChildren
            };
        }
        if (isTabletsChildrenAdultsSecondVisible()) {
            var minMgTabletsCSecond = Number((_4 = inputs.weight) === null || _4 === void 0 ? void 0 : _4.currentPoints) * 0.2;
            var maxMgTabletsCSecond = Number((_5 = inputs.weight) === null || _5 === void 0 ? void 0 : _5.currentPoints) * 0.3;
            var minMlSolutionCSecond = Number((_6 = inputs.weight) === null || _6 === void 0 ? void 0 : _6.currentPoints) * 0.1;
            var maxMlSolutionCSecond = Number((_7 = inputs.weight) === null || _7 === void 0 ? void 0 : _7.currentPoints) * 0.15;
            var minMgSolutionCSecond = Number((_8 = inputs.weight) === null || _8 === void 0 ? void 0 : _8.currentPoints) * 0.2;
            var maxMgSolutionCSecond = Number((_9 = inputs.weight) === null || _9 === void 0 ? void 0 : _9.currentPoints) * 0.3;
            return {
                resultsTabletsChildrenAdultsSecond: {
                    qID: 'resultsTabletsChildrenAdultsSecond',
                    tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(minMgTabletsCSecond, 0), 0, 0), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(maxMgTabletsCSecond, 0), 0, 0)),
                    rParams: [],
                    titleTexts: 'result1',
                    resultTexts: 'result1'
                },
                dosingDailyAdultsChildrenTabletsSecond: {
                    qID: 'dosingDailyAdultsChildrenTabletsSecond',
                    tParams: [],
                    titleTexts: 'result1'
                },
                durationChildrenAdultsSecond: {
                    qID: 'durationChildrenAdultsSecond',
                    tParams: [],
                    titleTexts: 'durationAdults1'
                },
                resultsSolutionSecond: {
                    qID: 'resultsSolutionSecond',
                    tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(minMlSolutionCSecond, 2), 0, 2), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(helpers_1.formatCalculationResult(maxMlSolutionCSecond, 3), 2), 0, 2), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(minMgSolutionCSecond, 2), 0, 2), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(maxMgSolutionCSecond, 2), 0, 2)),
                    rParams: [],
                    titleTexts: 'result1',
                    resultTexts: 'result1'
                },
                dosingDailySecond: {
                    qID: 'dosingDailySecond',
                    tParams: [],
                    titleTexts: 'result1'
                },
                durationChildrenSecond: {
                    qID: 'durationChildrenSecond',
                    tParams: [],
                    titleTexts: 'durationAdults'
                },
                intravenousChildren: intravenousChildren,
                warningChildren: warningChildren,
                intramuscularChildren: intramuscularChildren,
                durationChildrenI: durationChildrenI,
                intrathecalChildren: intrathecalChildren
            };
        }
        return {
            intravenousChildren: intravenousChildren,
            warningChildren: warningChildren,
            intramuscularChildren: intramuscularChildren,
            durationChildrenI: durationChildrenI,
            intrathecalChildren: intrathecalChildren
        };
    }
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.weight = isWeightVisible();
    visibleQuestions.noAnswerResult = isNoAnswerSectionVisible();
    visibleQuestions.resultsTabletsA = isTabletsAdultsVisible();
    visibleQuestions.dosingTabletsAdults = isTabletsAdultsVisible();
    visibleQuestions.durationAdultsT = isTabletsAdultsVisible();
    visibleQuestions.resultsSolutionA = isResultsAdultSolutionVisible();
    visibleQuestions.dosingDailyAdults = isResultsAdultSolutionVisible();
    visibleQuestions.durationAdultsL = isResultsAdultSolutionVisible();
    visibleQuestions.intravenousAdults = isResultsAdultInjectionVisible();
    visibleQuestions.warningInjection = isResultsAdultInjectionVisible();
    visibleQuestions.dividerAdultIntramuscular = isResultsAdultInjectionVisible();
    visibleQuestions.intramuscularAdults = isResultsAdultInjectionVisible();
    visibleQuestions.durationAdultsI = isResultsAdultInjectionVisible();
    visibleQuestions.intrathecalAdults = isResultsAdultInjectionVisible();
    visibleQuestions.warningDiscontinuationA = isWarningsAdultsVisible();
    visibleQuestions.doseInfoA = isWarningsAdultsVisible();
    visibleQuestions.warningChronicA = isWarningsAdultsVisible();
    visibleQuestions.resultsTabletsChildrenAdults =
        isTabletsChildrenAdultsVisible();
    visibleQuestions.dosingDailyAdultsChildrenTablets =
        isTabletsChildrenAdultsVisible();
    visibleQuestions.durationChildrenAdults = isTabletsChildrenAdultsVisible();
    visibleQuestions.resultsSolutionC = isResultsChildrenSolutionVisible();
    visibleQuestions.dosingDailyChildren = isResultsChildrenSolutionVisible();
    visibleQuestions.durationChildrenLosung = isResultsChildrenSolutionVisible();
    visibleQuestions.resultsTabletsChildrenAdultsSecond =
        isTabletsChildrenAdultsSecondVisible();
    visibleQuestions.dosingDailyAdultsChildrenTabletsSecond =
        isTabletsChildrenAdultsSecondVisible();
    visibleQuestions.durationChildrenAdultsSecond =
        isTabletsChildrenAdultsSecondVisible();
    visibleQuestions.resultsSolutionSecond =
        isResultsChildrenSolutionSecondVisible();
    visibleQuestions.dosingDailySecond = isResultsChildrenSolutionSecondVisible();
    visibleQuestions.durationChildrenSecond =
        isResultsChildrenSolutionSecondVisible();
    visibleQuestions.intravenousChildren = isResultsChildrenInjectionVisible();
    visibleQuestions.warningChildren = isResultsChildrenInjectionVisible();
    visibleQuestions.dividerintramuscularChildren =
        isResultsChildrenInjectionVisible();
    visibleQuestions.intramuscularChildren = isResultsChildrenInjectionVisible();
    visibleQuestions.durationChildrenI = isResultsChildrenInjectionVisible();
    visibleQuestions.intrathecalChildren = isResultsChildrenInjectionVisible();
    visibleQuestions.warningDiscontinuationC = isWarningsChildrenVisible();
    visibleQuestions.doseInfoC = isWarningsChildrenVisible();
    visibleQuestions.warningChronicC = isWarningsChildrenVisible();
    visibleQuestions.kidneyText = isKidneySectionVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswerSection = isNoAnswerSectionVisible();
    visibleSections.tabletsAdults = isTabletsAdultsVisible();
    visibleSections.resultsAdultSolution = isResultsAdultSolutionVisible();
    visibleSections.resultsAdultInjection = isResultsAdultInjectionVisible();
    visibleSections.warningsAdults = isWarningsAdultsVisible();
    visibleSections.tabletsChildrenAdults = isTabletsChildrenAdultsVisible();
    visibleSections.resultsChildrenSolution = isResultsChildrenSolutionVisible();
    visibleSections.tabletsChildrenAdultsSecond =
        isTabletsChildrenAdultsSecondVisible();
    visibleSections.resultsChildrenSolutionSecond =
        isResultsChildrenSolutionSecondVisible();
    visibleSections.resultsChildrenInjection =
        isResultsChildrenInjectionVisible();
    visibleSections.warningsChildren = isWarningsChildrenVisible();
    visibleSections.kidneySection = isKidneySectionVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return !isNoAnswerSectionVisible();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
