"use strict";

var visibleQuestions = {
    info: true,
    leftHand: true,
    nailPsoriasisLeftHand: true,
    leftThumb: false,
    leftIndex: false,
    leftMiddle: false,
    leftRing: false,
    leftLittle: false,
    rightHand: true,
    nailPsoriasisRightHand: true,
    rightThumb: false,
    rightIndex: false,
    rightMiddle: false,
    rightRing: false,
    rightLittle: false,
    leftFoot: true,
    nailPsoriasisLeftFoot: true,
    leftFirstToe: false,
    leftSecondToe: false,
    leftThirdToe: false,
    leftFourthToe: false,
    leftFifthToe: false,
    rightFoot: true,
    nailPsoriasisRightFoot: true,
    rightFirstToe: false,
    rightSecondToe: false,
    rightThirdToe: false,
    rightFourthToe: false,
    rightFifthToe: false,
    sendMail: false
};
var visibleSections = {
    infoSection: true,
    leftH: true,
    rightH: true,
    leftF: true,
    rightF: true,
    emailSection: false
};
var inputs = {
    nailPsoriasisLeftHand: null,
    leftThumb: null,
    leftIndex: null,
    leftMiddle: null,
    leftRing: null,
    leftLittle: null,
    nailPsoriasisRightHand: null,
    rightThumb: null,
    rightIndex: null,
    rightMiddle: null,
    rightRing: null,
    rightLittle: null,
    nailPsoriasisLeftFoot: null,
    leftFirstToe: null,
    leftSecondToe: null,
    leftThirdToe: null,
    leftFourthToe: null,
    leftFifthToe: null,
    nailPsoriasisRightFoot: null,
    rightFirstToe: null,
    rightSecondToe: null,
    rightThirdToe: null,
    rightFourthToe: null,
    rightFifthToe: null
};
var leftHQuestionVisibility = function () {
    if (!helpers_1.isAnswered(inputs.nailPsoriasisLeftHand) ||
        inputs.nailPsoriasisLeftHand.currentIdentifier === "no")
        return false;
    return true;
};
var rightHQuestionVisibility = function () {
    if (!helpers_1.isAnswered(inputs.nailPsoriasisRightHand) ||
        inputs.nailPsoriasisRightHand.currentIdentifier === "no")
        return false;
    return true;
};
var leftFQuestionVisibility = function () {
    if (!helpers_1.isAnswered(inputs.nailPsoriasisLeftFoot) ||
        inputs.nailPsoriasisLeftFoot.currentIdentifier === "no")
        return false;
    return true;
};
var rightFQuestionVisibility = function () {
    if (!helpers_1.isAnswered(inputs.nailPsoriasisRightFoot) ||
        inputs.nailPsoriasisRightFoot.currentIdentifier === "no")
        return false;
    return true;
};
var sendMailVisibility = function () {
    return (helpers_1.answerMatches(inputs.nailPsoriasisLeftHand, "yes") ||
        helpers_1.answerMatches(inputs.nailPsoriasisRightHand, "yes") ||
        helpers_1.answerMatches(inputs.nailPsoriasisLeftFoot, "yes") ||
        helpers_1.answerMatches(inputs.nailPsoriasisRightFoot, "yes"));
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21;
    var outputResult = helpers_1.formatCalculationResult(Number((_b = (_a = inputs.leftThumb) === null || _a === void 0 ? void 0 : _a.currentPoints) !== null && _b !== void 0 ? _b : 0) +
        Number((_d = (_c = inputs.leftIndex) === null || _c === void 0 ? void 0 : _c.currentPoints) !== null && _d !== void 0 ? _d : 0) +
        Number((_f = (_e = inputs.leftMiddle) === null || _e === void 0 ? void 0 : _e.currentPoints) !== null && _f !== void 0 ? _f : 0) +
        Number((_h = (_g = inputs.leftRing) === null || _g === void 0 ? void 0 : _g.currentPoints) !== null && _h !== void 0 ? _h : 0) +
        Number((_k = (_j = inputs.leftLittle) === null || _j === void 0 ? void 0 : _j.currentPoints) !== null && _k !== void 0 ? _k : 0) +
        Number((_m = (_l = inputs.nailPsoriasisRightHand) === null || _l === void 0 ? void 0 : _l.currentPoints) !== null && _m !== void 0 ? _m : 0) +
        Number((_p = (_o = inputs.rightThumb) === null || _o === void 0 ? void 0 : _o.currentPoints) !== null && _p !== void 0 ? _p : 0) +
        Number((_r = (_q = inputs.rightIndex) === null || _q === void 0 ? void 0 : _q.currentPoints) !== null && _r !== void 0 ? _r : 0) +
        Number((_t = (_s = inputs.rightMiddle) === null || _s === void 0 ? void 0 : _s.currentPoints) !== null && _t !== void 0 ? _t : 0) +
        Number((_v = (_u = inputs.rightRing) === null || _u === void 0 ? void 0 : _u.currentPoints) !== null && _v !== void 0 ? _v : 0) +
        Number((_x = (_w = inputs.rightLittle) === null || _w === void 0 ? void 0 : _w.currentPoints) !== null && _x !== void 0 ? _x : 0) +
        Number((_z = (_y = inputs.nailPsoriasisLeftFoot) === null || _y === void 0 ? void 0 : _y.currentPoints) !== null && _z !== void 0 ? _z : 0) +
        Number((_1 = (_0 = inputs.leftFirstToe) === null || _0 === void 0 ? void 0 : _0.currentPoints) !== null && _1 !== void 0 ? _1 : 0) +
        Number((_3 = (_2 = inputs.leftSecondToe) === null || _2 === void 0 ? void 0 : _2.currentPoints) !== null && _3 !== void 0 ? _3 : 0) +
        Number((_5 = (_4 = inputs.leftThirdToe) === null || _4 === void 0 ? void 0 : _4.currentPoints) !== null && _5 !== void 0 ? _5 : 0) +
        Number((_7 = (_6 = inputs.leftFourthToe) === null || _6 === void 0 ? void 0 : _6.currentPoints) !== null && _7 !== void 0 ? _7 : 0) +
        Number((_9 = (_8 = inputs.leftFifthToe) === null || _8 === void 0 ? void 0 : _8.currentPoints) !== null && _9 !== void 0 ? _9 : 0) +
        Number((_11 = (_10 = inputs.nailPsoriasisRightFoot) === null || _10 === void 0 ? void 0 : _10.currentPoints) !== null && _11 !== void 0 ? _11 : 0) +
        Number((_13 = (_12 = inputs.rightFirstToe) === null || _12 === void 0 ? void 0 : _12.currentPoints) !== null && _13 !== void 0 ? _13 : 0) +
        Number((_15 = (_14 = inputs.rightSecondToe) === null || _14 === void 0 ? void 0 : _14.currentPoints) !== null && _15 !== void 0 ? _15 : 0) +
        Number((_17 = (_16 = inputs.rightThirdToe) === null || _16 === void 0 ? void 0 : _16.currentPoints) !== null && _17 !== void 0 ? _17 : 0) +
        Number((_19 = (_18 = inputs.rightFourthToe) === null || _18 === void 0 ? void 0 : _18.currentPoints) !== null && _19 !== void 0 ? _19 : 0) +
        Number((_21 = (_20 = inputs.rightFifthToe) === null || _20 === void 0 ? void 0 : _20.currentPoints) !== null && _21 !== void 0 ? _21 : 0));
    return outputResult;
};
var returnVisibleQuestions = function () {
    visibleQuestions.leftHand = true;
    visibleQuestions.nailPsoriasisLeftHand = true;
    visibleQuestions.leftThumb = leftHQuestionVisibility();
    visibleQuestions.leftIndex = leftHQuestionVisibility();
    visibleQuestions.leftMiddle = leftHQuestionVisibility();
    visibleQuestions.leftRing = leftHQuestionVisibility();
    visibleQuestions.leftLittle = leftHQuestionVisibility();
    visibleQuestions.rightHand = true;
    visibleQuestions.nailPsoriasisRightHand = true;
    visibleQuestions.rightThumb = rightHQuestionVisibility();
    visibleQuestions.rightIndex = rightHQuestionVisibility();
    visibleQuestions.rightMiddle = rightHQuestionVisibility();
    visibleQuestions.rightRing = rightHQuestionVisibility();
    visibleQuestions.rightLittle = rightHQuestionVisibility();
    visibleQuestions.leftFoot = true;
    visibleQuestions.nailPsoriasisLeftFoot = true;
    visibleQuestions.leftFirstToe = leftFQuestionVisibility();
    visibleQuestions.leftSecondToe = leftFQuestionVisibility();
    visibleQuestions.leftThirdToe = leftFQuestionVisibility();
    visibleQuestions.leftFourthToe = leftFQuestionVisibility();
    visibleQuestions.leftFifthToe = leftFQuestionVisibility();
    visibleQuestions.rightFoot = true;
    visibleQuestions.nailPsoriasisRightFoot = true;
    visibleQuestions.rightFirstToe = rightFQuestionVisibility();
    visibleQuestions.rightSecondToe = rightFQuestionVisibility();
    visibleQuestions.rightThirdToe = rightFQuestionVisibility();
    visibleQuestions.rightFourthToe = rightFQuestionVisibility();
    visibleQuestions.rightFifthToe = rightFQuestionVisibility();
    visibleQuestions.sendMail = sendMailVisibility();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.emailSection = sendMailVisibility();
    return visibleSections;
};
var ut_toolScore = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        result: { number: result, range: result },
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});