"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    respiratoryFailure: true,
    respiratoryRate: true,
    spO2Room: false,
    spO2: false,
    air: true,
    bloodPressure: true,
    pulse: true,
    temperature: true,
    consciousness: true,
    warningOrange: false,
    answerAllQuestions: false,
    score0: false,
    scoreLow: false,
    scoreLowMedium: false,
    scoreMedium: false,
    scoreHigh: false
};
var visibleSections = {
    inputSection: true,
    warning: false,
    answerAll: false,
    resultSection: false
};
var inputs = {
    respiratoryFailure: null,
    respiratoryRate: null,
    spO2Room: null,
    spO2: null,
    air: null,
    bloodPressure: null,
    pulse: null,
    temperature: null,
    consciousness: null
};
var warningOrange = function () {
    return (((helpers_1.answerMatches(inputs.spO2, 'more93') ||
        helpers_1.answerMatches(inputs.spO2, 'more95') ||
        helpers_1.answerMatches(inputs.spO2, 'more97')) &&
        helpers_1.answerMatches(inputs.air, 'room')) ||
        (helpers_1.answerMatches(inputs.spO2, 'more93air') &&
            helpers_1.answerMatches(inputs.air, 'supplemental')));
};
var isAnswerdAllVisible = function () {
    return !(helpers_1.isAnswered(inputs.respiratoryFailure) &&
        helpers_1.isAnswered(inputs.respiratoryRate) &&
        ((helpers_1.answerMatches(inputs.respiratoryFailure, 'no') &&
            helpers_1.isAnswered(inputs.spO2Room)) ||
            (helpers_1.answerMatches(inputs.respiratoryFailure, 'yes') &&
                helpers_1.isAnswered(inputs.spO2))) &&
        helpers_1.isAnswered(inputs.air) &&
        helpers_1.isAnswered(inputs.bloodPressure) &&
        helpers_1.isAnswered(inputs.pulse) &&
        helpers_1.isAnswered(inputs.temperature) &&
        helpers_1.isAnswered(inputs.consciousness));
};
var result = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    return (Number((_a = inputs.respiratoryFailure) === null || _a === void 0 ? void 0 : _a.currentPoints) +
        Number((_b = inputs.respiratoryRate) === null || _b === void 0 ? void 0 : _b.currentPoints) +
        Number((_c = inputs.spO2Room) === null || _c === void 0 ? void 0 : _c.currentPoints) +
        Number((_d = inputs.spO2) === null || _d === void 0 ? void 0 : _d.currentPoints) +
        Number((_e = inputs.air) === null || _e === void 0 ? void 0 : _e.currentPoints) +
        Number((_f = inputs.bloodPressure) === null || _f === void 0 ? void 0 : _f.currentPoints) +
        Number((_g = inputs.pulse) === null || _g === void 0 ? void 0 : _g.currentPoints) +
        Number((_h = inputs.temperature) === null || _h === void 0 ? void 0 : _h.currentPoints) +
        Number((_j = inputs.consciousness) === null || _j === void 0 ? void 0 : _j.currentPoints));
};
var isAnyValueMore3 = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    switch (true) {
        case Number((_a = inputs.respiratoryFailure) === null || _a === void 0 ? void 0 : _a.currentPoints) === 3:
            return true;
        case Number((_b = inputs.respiratoryRate) === null || _b === void 0 ? void 0 : _b.currentPoints) === 3:
            return true;
        case Number((_c = inputs.spO2Room) === null || _c === void 0 ? void 0 : _c.currentPoints) === 3:
            return true;
        case Number((_d = inputs.spO2) === null || _d === void 0 ? void 0 : _d.currentPoints) === 3:
            return true;
        case Number((_e = inputs.air) === null || _e === void 0 ? void 0 : _e.currentPoints) === 3:
            return true;
        case Number((_f = inputs.bloodPressure) === null || _f === void 0 ? void 0 : _f.currentPoints) === 3:
            return true;
        case Number((_g = inputs.pulse) === null || _g === void 0 ? void 0 : _g.currentPoints) === 3:
            return true;
        case Number((_h = inputs.temperature) === null || _h === void 0 ? void 0 : _h.currentPoints) === 3:
            return true;
        case Number((_j = inputs.consciousness) === null || _j === void 0 ? void 0 : _j.currentPoints) === 3:
            return true;
        default:
            return false;
    }
};
var calculatePoints = function () {
    if (!isAnswerdAllVisible() &&
        !warningOrange() &&
        helpers_1.inLimits(result(), 1, 4) &&
        !isAnyValueMore3()) {
        return {
            scoreLow: {
                qID: 'scoreLow',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(result(), 1), 0, 1)),
                titleTexts: 'result1'
            }
        };
    }
    if (!isAnswerdAllVisible() &&
        !warningOrange() &&
        helpers_1.inLimits(result(), 0, 4) &&
        isAnyValueMore3()) {
        return {
            scoreLowMedium: {
                qID: 'scoreLowMedium',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(result(), 1), 0, 1)),
                titleTexts: 'result1'
            }
        };
    }
    if (!isAnswerdAllVisible() && !warningOrange() && helpers_1.inLimits(result(), 5, 6)) {
        return {
            scoreMedium: {
                qID: 'scoreMedium',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(result(), 1), 0, 1)),
                titleTexts: 'result1'
            }
        };
    }
    if (!isAnswerdAllVisible() && !warningOrange() && helpers_1.inLimits(result(), 7)) {
        return {
            scoreHigh: {
                qID: 'scoreHigh',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(result(), 1), 0, 1)),
                titleTexts: 'result1'
            }
        };
    }
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.spO2Room = helpers_1.answerMatches(inputs.respiratoryFailure, 'no');
    visibleQuestions.spO2 = helpers_1.answerMatches(inputs.respiratoryFailure, 'yes');
    visibleQuestions.warningOrange = warningOrange();
    visibleQuestions.answerAllQuestions = isAnswerdAllVisible();
    visibleQuestions.score0 =
        !isAnswerdAllVisible() && !warningOrange() && helpers_1.inLimits(result(), 0, 0);
    visibleQuestions.scoreLow =
        !isAnswerdAllVisible() &&
            !warningOrange() &&
            helpers_1.inLimits(result(), 1, 4) &&
            !isAnyValueMore3();
    visibleQuestions.scoreLowMedium =
        !isAnswerdAllVisible() &&
            !warningOrange() &&
            helpers_1.inLimits(result(), 0, 4) &&
            isAnyValueMore3();
    visibleQuestions.scoreMedium =
        !isAnswerdAllVisible() && !warningOrange() && helpers_1.inLimits(result(), 5, 6);
    visibleQuestions.scoreHigh =
        !isAnswerdAllVisible() && !warningOrange() && helpers_1.inLimits(result(), 7);
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.warning = warningOrange();
    visibleSections.answerAll = isAnswerdAllVisible();
    visibleSections.resultSection = !isAnswerdAllVisible() && !warningOrange();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return !isAnswerdAllVisible();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
