"use strict";


var visibleQuestions = {
    info: true,
    dose: true,
    startDate: true,
    dose1: true,
    dose2: true,
    dosesGeneral: true,
    dose1a: true,
    dose2a: true,
    dosesGeneral2: true
};
var visibleSections = {
    combinationTreatment: true,
    dosing240mg: false,
    dosing360mg: false
};
var inputs = {
    dose: null,
    startDate: null
};
var areDoseAndStartDateAnswered = function () {
    return helpers_1.isAnswered(inputs.dose) && helpers_1.isAnswered(inputs.startDate);
};
var calculatePoints = function () {
    var _a, _b, _c, _d;
    if (!areDoseAndStartDateAnswered())
        return {};
    if (helpers_1.answerMatches(inputs.dose, 'lowDose')) {
        return {
            dose1: {
                qID: 'dose1',
                tParams: [
                    {
                        type: 'date',
                        value: (_a = inputs.startDate) === null || _a === void 0 ? void 0 : _a.currentDate
                    },
                ],
                titleTexts: 'dose24011',
                resultTexts: 'dose24012'
            },
            dose2: {
                qID: 'dose2',
                tParams: [
                    {
                        type: 'date',
                        value: helpers_1.addDaysToDate((_b = inputs.startDate) === null || _b === void 0 ? void 0 : _b.currentDate, 14)
                    },
                ],
                titleTexts: 'dose24021',
                resultTexts: 'dose24022'
            },
            dosesGeneral: {
                qID: 'dosesGeneral',
                titleTexts: 'dose240n1',
                resultTexts: 'dose240n2'
            }
        };
    }
    return {
        dose1a: {
            qID: 'dose1a',
            tParams: [
                {
                    type: 'date',
                    value: (_c = inputs.startDate) === null || _c === void 0 ? void 0 : _c.currentDate
                },
            ],
            titleTexts: 'dose36011',
            resultTexts: 'dose36012'
        },
        dose2a: {
            qID: 'dose2a',
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate((_d = inputs.startDate) === null || _d === void 0 ? void 0 : _d.currentDate, 21)
                },
            ],
            titleTexts: 'dose36021',
            resultTexts: 'dose36022'
        },
        dosesGeneral2: {
            qID: 'dosesGeneral2',
            titleTexts: 'dose360n1',
            resultTexts: 'dose360n2'
        }
    };
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.dosing240mg =
        helpers_1.isAnswered(inputs.startDate) && helpers_1.answerMatches(inputs.dose, 'lowDose');
    visibleSections.dosing360mg =
        helpers_1.isAnswered(inputs.startDate) && helpers_1.answerMatches(inputs.dose, 'highDose');
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return areDoseAndStartDateAnswered();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
