"use strict";


var visibleQuestions = {
    info: true,
    dose: true,
    startDate: true,
    dose2401: false,
    dose2402: false,
    dose2403: false,
    dose2404: false,
    dose2405: false,
    dose2406: false,
    dose2407: false,
    dose2408: false,
    dose2409: false,
    dose2410: false,
    dose2411: false,
    dose240n: false,
    dose240Result4: false,
    dose4801: false,
    dose4802: false,
    dose480n: false,
    dose480Result4: false
};
var visibleSections = {
    combinationTreatment: true,
    dosing240mgSection: false,
    dosing480mgSection: false
};
var inputs = {
    dose: null,
    startDate: null
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p;
    if (!helpers_1.isAnswered(inputs.dose) || !helpers_1.isAnswered(inputs.startDate))
        return {};
    if (((_a = inputs.dose) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === '240mg') {
        return {
            dose2401: {
                qID: 'dose2401',
                tParams: [
                    {
                        type: 'date',
                        value: (_b = inputs.startDate) === null || _b === void 0 ? void 0 : _b.currentDate
                    },
                ],
                titleTexts: 'regular',
                resultTexts: 'regular'
            },
            dose2402: {
                qID: 'dose2402',
                tParams: [
                    {
                        type: 'date',
                        value: helpers_1.addDaysToDate((_c = inputs.startDate) === null || _c === void 0 ? void 0 : _c.currentDate, 14)
                    },
                ],
                titleTexts: 'regular',
                resultTexts: 'regular'
            },
            dose2403: {
                qID: 'dose2403',
                tParams: [
                    {
                        type: 'date',
                        value: helpers_1.addDaysToDate((_d = inputs.startDate) === null || _d === void 0 ? void 0 : _d.currentDate, 28)
                    },
                ],
                titleTexts: 'regular',
                resultTexts: 'regular'
            },
            dose2404: {
                qID: 'dose2404',
                tParams: [
                    {
                        type: 'date',
                        value: helpers_1.addDaysToDate((_e = inputs.startDate) === null || _e === void 0 ? void 0 : _e.currentDate, 42)
                    },
                ],
                titleTexts: 'regular',
                resultTexts: 'regular'
            },
            dose2405: {
                qID: 'dose2405',
                tParams: [
                    {
                        type: 'date',
                        value: helpers_1.addDaysToDate((_f = inputs.startDate) === null || _f === void 0 ? void 0 : _f.currentDate, 56)
                    },
                ],
                titleTexts: 'regular',
                resultTexts: 'regular'
            },
            dose2406: {
                qID: 'dose2406',
                tParams: [
                    {
                        type: 'date',
                        value: helpers_1.addDaysToDate((_g = inputs.startDate) === null || _g === void 0 ? void 0 : _g.currentDate, 70)
                    },
                ],
                titleTexts: 'regular',
                resultTexts: 'regular'
            },
            dose2407: {
                qID: 'dose2407',
                tParams: [
                    {
                        type: 'date',
                        value: helpers_1.addDaysToDate((_h = inputs.startDate) === null || _h === void 0 ? void 0 : _h.currentDate, 84)
                    },
                ],
                titleTexts: 'regular',
                resultTexts: 'regular'
            },
            dose2408: {
                qID: 'dose2408',
                tParams: [
                    {
                        type: 'date',
                        value: helpers_1.addDaysToDate((_j = inputs.startDate) === null || _j === void 0 ? void 0 : _j.currentDate, 98)
                    },
                ],
                titleTexts: 'regular',
                resultTexts: 'regular'
            },
            dose2409: {
                qID: 'dose2409',
                tParams: [
                    {
                        type: 'date',
                        value: helpers_1.addDaysToDate((_k = inputs.startDate) === null || _k === void 0 ? void 0 : _k.currentDate, 112)
                    },
                ],
                titleTexts: 'regular',
                resultTexts: 'regular'
            },
            dose2410: {
                qID: 'dose2410',
                tParams: [
                    {
                        type: 'date',
                        value: helpers_1.addDaysToDate((_l = inputs.startDate) === null || _l === void 0 ? void 0 : _l.currentDate, 126)
                    },
                ],
                titleTexts: 'regular',
                resultTexts: 'regular'
            },
            dose2411: {
                qID: 'dose2411',
                tParams: [
                    {
                        type: 'date',
                        value: helpers_1.addDaysToDate((_m = inputs.startDate) === null || _m === void 0 ? void 0 : _m.currentDate, 154)
                    },
                ],
                titleTexts: 'regular',
                resultTexts: 'regular'
            },
            dose240n: {
                qID: 'dose240n',
                titleTexts: 'regular',
                resultTexts: 'regular'
            }
        };
    }
    return {
        dose4801: {
            qID: 'dose4801',
            tParams: [
                {
                    type: 'date',
                    value: (_o = inputs.startDate) === null || _o === void 0 ? void 0 : _o.currentDate
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        dose4802: {
            qID: 'dose4802',
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate((_p = inputs.startDate) === null || _p === void 0 ? void 0 : _p.currentDate, 28)
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        dose480n: {
            qID: 'dose480n',
            titleTexts: 'regular',
            resultTexts: 'regular'
        }
    };
};
var returnVisibleQuestions = function () {
    var _a, _b;
    if (!helpers_1.isAnswered(inputs.dose) || !helpers_1.isAnswered(inputs.startDate)) {
        return visibleQuestions;
    }
    visibleQuestions.dose2401 =
        helpers_1.isAnswered(inputs.dose) && ((_a = inputs.dose) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === '240mg';
    visibleQuestions.dose2402 = visibleQuestions.dose2401;
    visibleQuestions.dose2403 = visibleQuestions.dose2401;
    visibleQuestions.dose2404 = visibleQuestions.dose2401;
    visibleQuestions.dose2405 = visibleQuestions.dose2401;
    visibleQuestions.dose2406 = visibleQuestions.dose2401;
    visibleQuestions.dose2407 = visibleQuestions.dose2401;
    visibleQuestions.dose2408 = visibleQuestions.dose2401;
    visibleQuestions.dose2409 = visibleQuestions.dose2401;
    visibleQuestions.dose2410 = visibleQuestions.dose2401;
    visibleQuestions.dose2411 = visibleQuestions.dose2401;
    visibleQuestions.dose240n = visibleQuestions.dose2401;
    visibleQuestions.dose240Result4 = visibleQuestions.dose2401;
    visibleQuestions.dose4801 =
        helpers_1.isAnswered(inputs.dose) && ((_b = inputs.dose) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === '480mg';
    visibleQuestions.dose4802 = visibleQuestions.dose4801;
    visibleQuestions.dose480n = visibleQuestions.dose4801;
    visibleQuestions.dose480Result4 = visibleQuestions.dose4801;
    return visibleQuestions;
};
var returnVisibleSections = function () {
    var _a, _b;
    if (!helpers_1.isAnswered(inputs.dose) || !helpers_1.isAnswered(inputs.startDate)) {
        return visibleSections;
    }
    visibleSections.dosing240mgSection =
        helpers_1.isAnswered(inputs.dose) && ((_a = inputs.dose) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === '240mg';
    visibleSections.dosing480mgSection =
        helpers_1.isAnswered(inputs.dose) && ((_b = inputs.dose) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === '480mg';
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
