"use strict";


var visibleQuestions = {
    weight: true,
    startDate: true,
    doseCombination1: false,
    doseCombination2: false,
    doseCombination3: false,
    doseCombination4: false,
    dose2401: false,
    dose2402: false,
    dose240n: false
};
var visibleSections = {
    combinationTreatment: true,
    dosingCombinationSection: false,
    monotherapyTreatment: false
};
var inputs = {
    weight: null,
    startDate: null
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p;
    if (!helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 300 }) ||
        !helpers_1.isAnswered(inputs.startDate))
        return {};
    return {
        doseCombination1: {
            qID: 'doseCombination1',
            tParams: [
                {
                    type: 'date',
                    value: (_a = inputs.startDate) === null || _a === void 0 ? void 0 : _a.currentDate
                },
            ],
            rParams: [
                {
                    type: 'number',
                    value: Number((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints) * 3
                },
                {
                    type: 'number',
                    value: Number((_c = inputs.weight) === null || _c === void 0 ? void 0 : _c.currentPoints)
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        doseCombination2: {
            qID: 'doseCombination2',
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate((_d = inputs.startDate) === null || _d === void 0 ? void 0 : _d.currentDate, 21)
                },
            ],
            rParams: [
                {
                    type: 'number',
                    value: Number((_e = inputs.weight) === null || _e === void 0 ? void 0 : _e.currentPoints) * 3
                },
                {
                    type: 'number',
                    value: Number((_f = inputs.weight) === null || _f === void 0 ? void 0 : _f.currentPoints)
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        doseCombination3: {
            qID: 'doseCombination3',
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate((_g = inputs.startDate) === null || _g === void 0 ? void 0 : _g.currentDate, 42)
                },
            ],
            rParams: [
                {
                    type: 'number',
                    value: Number((_h = inputs.weight) === null || _h === void 0 ? void 0 : _h.currentPoints) * 3
                },
                {
                    type: 'number',
                    value: Number((_j = inputs.weight) === null || _j === void 0 ? void 0 : _j.currentPoints)
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        doseCombination4: {
            qID: 'doseCombination4',
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate((_k = inputs.startDate) === null || _k === void 0 ? void 0 : _k.currentDate, 63)
                },
            ],
            rParams: [
                {
                    type: 'number',
                    value: Number((_l = inputs.weight) === null || _l === void 0 ? void 0 : _l.currentPoints) * 3
                },
                {
                    type: 'number',
                    value: Number((_m = inputs.weight) === null || _m === void 0 ? void 0 : _m.currentPoints)
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        dose2401: {
            qID: 'dose2401',
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate((_o = inputs.startDate) === null || _o === void 0 ? void 0 : _o.currentDate, 84)
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        dose2402: {
            qID: 'dose2402',
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate((_p = inputs.startDate) === null || _p === void 0 ? void 0 : _p.currentDate, 98)
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        dose240n: {
            qID: 'dose240n',
            titleTexts: 'regular',
            resultTexts: 'regular'
        }
    };
};
var returnVisibleQuestions = function () {
    visibleQuestions.doseCombination1 =
        helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 300 }) &&
            helpers_1.isAnswered(inputs.startDate);
    visibleQuestions.doseCombination2 = visibleQuestions.doseCombination1;
    visibleQuestions.doseCombination3 = visibleQuestions.doseCombination1;
    visibleQuestions.doseCombination4 = visibleQuestions.doseCombination1;
    visibleQuestions.dose2401 = visibleQuestions.doseCombination1;
    visibleQuestions.dose2402 = visibleQuestions.doseCombination1;
    visibleQuestions.dose240n = visibleQuestions.doseCombination1;
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.dosingCombinationSection =
        helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 300 }) &&
            helpers_1.isAnswered(inputs.startDate);
    visibleSections.monotherapyTreatment =
        visibleSections.dosingCombinationSection;
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
