"use strict";


var visibleQuestions = {
    weight: true,
    startDate: true,
    nivolumabDose: true,
    dose1: true,
    dose2: true,
    dose3: true,
    dose4: true,
    dosesGeneral: true,
    dose1a: true,
    dose2a: true,
    dose3a: true,
    dosesGeneral2: true
};
var visibleSections = {
    combinationTreatment: true,
    doseType: false,
    nivolumabPerKg: false,
    nivolumab360: false
};
var inputs = {
    weight: null,
    startDate: null,
    nivolumabDose: null
};
var areWeightAndStartDateAnswered = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 300 }) &&
        helpers_1.isAnswered(inputs.startDate));
};
var isNivolumabDoseVisible = function () {
    return areWeightAndStartDateAnswered();
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q;
    if (!areWeightAndStartDateAnswered() || !helpers_1.isAnswered(inputs.nivolumabDose))
        return {};
    if (helpers_1.answerMatches(inputs.nivolumabDose, 'dosage3')) {
        return {
            dose1: {
                qID: 'dose1',
                tParams: [
                    {
                        type: 'date',
                        value: (_a = inputs.startDate) === null || _a === void 0 ? void 0 : _a.currentDate
                    },
                ],
                rParams: [
                    {
                        type: 'number',
                        value: Number((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints) * 3
                    },
                    {
                        type: 'number',
                        value: Number((_c = inputs.weight) === null || _c === void 0 ? void 0 : _c.currentPoints)
                    },
                ],
                titleTexts: 'result1',
                resultTexts: 'result1'
            },
            dose2: {
                qID: 'dose2',
                tParams: [
                    {
                        type: 'date',
                        value: helpers_1.addDaysToDate((_d = inputs.startDate) === null || _d === void 0 ? void 0 : _d.currentDate, 14)
                    },
                ],
                rParams: [
                    {
                        type: 'number',
                        value: Number((_e = inputs.weight) === null || _e === void 0 ? void 0 : _e.currentPoints) * 3
                    },
                ],
                titleTexts: 'result1',
                resultTexts: 'result1'
            },
            dose3: {
                qID: 'dose3',
                tParams: [
                    {
                        type: 'date',
                        value: helpers_1.addDaysToDate((_f = inputs.startDate) === null || _f === void 0 ? void 0 : _f.currentDate, 28)
                    },
                ],
                rParams: [
                    {
                        type: 'number',
                        value: Number((_g = inputs.weight) === null || _g === void 0 ? void 0 : _g.currentPoints) * 3
                    },
                ],
                titleTexts: 'result1',
                resultTexts: 'result1'
            },
            dose4: {
                qID: 'dose4',
                tParams: [
                    {
                        type: 'date',
                        value: helpers_1.addDaysToDate((_h = inputs.startDate) === null || _h === void 0 ? void 0 : _h.currentDate, 42)
                    },
                ],
                rParams: [
                    {
                        type: 'number',
                        value: Number((_j = inputs.weight) === null || _j === void 0 ? void 0 : _j.currentPoints) * 3
                    },
                    {
                        type: 'number',
                        value: Number((_k = inputs.weight) === null || _k === void 0 ? void 0 : _k.currentPoints)
                    },
                ],
                titleTexts: 'result1',
                resultTexts: 'result1'
            },
            dosesGeneral: {
                qID: 'dosesGeneral',
                tParams: [],
                titleTexts: 'result1'
            }
        };
    }
    return {
        dose1a: {
            qID: 'dose1a',
            tParams: [
                {
                    type: 'date',
                    value: (_l = inputs.startDate) === null || _l === void 0 ? void 0 : _l.currentDate
                },
            ],
            rParams: [
                {
                    type: 'number',
                    value: Number((_m = inputs.weight) === null || _m === void 0 ? void 0 : _m.currentPoints)
                },
            ],
            titleTexts: 'result1',
            resultTexts: 'result1'
        },
        dose2a: {
            qID: 'dose2a',
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate((_o = inputs.startDate) === null || _o === void 0 ? void 0 : _o.currentDate, 21)
                },
            ],
            rParams: [],
            titleTexts: 'result1',
            resultTexts: 'result1'
        },
        dose3a: {
            qID: 'dose3a',
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate((_p = inputs.startDate) === null || _p === void 0 ? void 0 : _p.currentDate, 42)
                },
            ],
            rParams: [
                {
                    type: 'number',
                    value: Number((_q = inputs.weight) === null || _q === void 0 ? void 0 : _q.currentPoints)
                },
            ],
            titleTexts: 'result1',
            resultTexts: 'result1'
        },
        dosesGeneral2: {
            qID: 'dosesGeneral2',
            tParams: [],
            titleTexts: 'result1'
        }
    };
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.doseType = isNivolumabDoseVisible();
    visibleSections.nivolumabPerKg = helpers_1.answerMatches(inputs.nivolumabDose, 'dosage3');
    visibleSections.nivolumab360 = helpers_1.answerMatches(inputs.nivolumabDose, 'dosage360');
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return areWeightAndStartDateAnswered() && helpers_1.isAnswered(inputs.nivolumabDose);
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
