"use strict";


var visibleQuestions = {
    weight: true,
    startDate: true,
    doseCombination1: true,
    doseCombination2: true,
    doseCombination3: true,
    doseCombination4: true,
    doseCombination5: true,
    dose24: true
};
var visibleSections = {
    combinationTreatment: true,
    dosingCombinationSection: false
};
var inputs = {
    weight: null,
    startDate: null
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    if (!helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 300 }) ||
        !helpers_1.isAnswered(inputs.startDate))
        return {};
    return {
        doseCombination1: {
            qID: 'doseCombination1',
            tParams: [
                {
                    type: 'date',
                    value: (_a = inputs.startDate) === null || _a === void 0 ? void 0 : _a.currentDate
                },
            ],
            rParams: [
                {
                    type: 'number',
                    value: (_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        doseCombination2: {
            qID: 'doseCombination2',
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate((_c = inputs.startDate) === null || _c === void 0 ? void 0 : _c.currentDate, 21)
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        doseCombination3: {
            qID: 'doseCombination3',
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate((_d = inputs.startDate) === null || _d === void 0 ? void 0 : _d.currentDate, 42)
                },
            ],
            rParams: [
                {
                    type: 'number',
                    value: (_e = inputs.weight) === null || _e === void 0 ? void 0 : _e.currentPoints
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        doseCombination4: {
            qID: 'doseCombination4',
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate((_f = inputs.startDate) === null || _f === void 0 ? void 0 : _f.currentDate, 63)
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        doseCombination5: {
            qID: 'doseCombination5',
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate((_g = inputs.startDate) === null || _g === void 0 ? void 0 : _g.currentDate, 84)
                },
            ],
            rParams: [
                {
                    type: 'number',
                    value: (_h = inputs.weight) === null || _h === void 0 ? void 0 : _h.currentPoints
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        dose24: {
            qID: 'dose24',
            rParams: [
                {
                    type: 'number',
                    value: (_j = inputs.weight) === null || _j === void 0 ? void 0 : _j.currentPoints
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        }
    };
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.dosingCombinationSection =
        helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 300 }) &&
            helpers_1.isAnswered(inputs.startDate);
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
