"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};


var visibleQuestions = {
    weight: true,
    startDate: true,
    doseCombination1: true,
    doseCombination2: true,
    doseCombination3: true,
    doseCombination4: true,
    monotherapyDose: true,
    dose2401: true,
    dose2402: true,
    dose240n: true,
    dose4801: true,
    dose4802: true,
    dose480n: true,
    additionalInfo: true
};
var visibleSections = {
    combinationTreatment: true,
    dosingCombinationSection: false,
    monotherapyTreatment: false,
    dosing240mgSection: false,
    dosing480mgSection: false,
    additional: false
};
var inputs = {
    weight: null,
    startDate: null,
    monotherapyDose: null
};
var areWeightAndStartDateAnswered = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 300 }) &&
        helpers_1.isAnswered(inputs.startDate));
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r;
    if (!helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 300 }) ||
        !helpers_1.isAnswered(inputs.startDate))
        return {};
    return __assign(__assign({ doseCombination1: {
            qID: 'doseCombination1',
            tParams: [
                {
                    type: 'date',
                    value: (_a = inputs.startDate) === null || _a === void 0 ? void 0 : _a.currentDate
                },
            ],
            rParams: [
                {
                    type: 'number',
                    value: Number((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints)
                },
                {
                    type: 'number',
                    value: Number((_c = inputs.weight) === null || _c === void 0 ? void 0 : _c.currentPoints) * 3
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        }, doseCombination2: {
            qID: 'doseCombination2',
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate((_d = inputs.startDate) === null || _d === void 0 ? void 0 : _d.currentDate, 21)
                },
            ],
            rParams: [
                {
                    type: 'number',
                    value: Number((_e = inputs.weight) === null || _e === void 0 ? void 0 : _e.currentPoints)
                },
                {
                    type: 'number',
                    value: Number((_f = inputs.weight) === null || _f === void 0 ? void 0 : _f.currentPoints) * 3
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        }, doseCombination3: {
            qID: 'doseCombination3',
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate((_g = inputs.startDate) === null || _g === void 0 ? void 0 : _g.currentDate, 42)
                },
            ],
            rParams: [
                {
                    type: 'number',
                    value: Number((_h = inputs.weight) === null || _h === void 0 ? void 0 : _h.currentPoints)
                },
                {
                    type: 'number',
                    value: Number((_j = inputs.weight) === null || _j === void 0 ? void 0 : _j.currentPoints) * 3
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        }, doseCombination4: {
            qID: 'doseCombination4',
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate((_k = inputs.startDate) === null || _k === void 0 ? void 0 : _k.currentDate, 63)
                },
            ],
            rParams: [
                {
                    type: 'number',
                    value: Number((_l = inputs.weight) === null || _l === void 0 ? void 0 : _l.currentPoints)
                },
                {
                    type: 'number',
                    value: Number((_m = inputs.weight) === null || _m === void 0 ? void 0 : _m.currentPoints) * 3
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        } }, (helpers_1.answerMatches(inputs.monotherapyDose, '240mg') && {
        dose2401: {
            qID: 'dose2401',
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate((_o = inputs.startDate) === null || _o === void 0 ? void 0 : _o.currentDate, 84)
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        dose2402: {
            qID: 'dose2402',
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate((_p = inputs.startDate) === null || _p === void 0 ? void 0 : _p.currentDate, 98)
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        dose240n: {
            qID: 'dose240n',
            titleTexts: 'regular',
            resultTexts: 'regular'
        }
    })), (helpers_1.answerMatches(inputs.monotherapyDose, '480mg') && {
        dose4801: {
            qID: 'dose4801',
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate((_q = inputs.startDate) === null || _q === void 0 ? void 0 : _q.currentDate, 105)
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        dose4802: {
            qID: 'dose4802',
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate((_r = inputs.startDate) === null || _r === void 0 ? void 0 : _r.currentDate, 133)
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        dose480n: {
            qID: 'dose480n',
            titleTexts: 'regular',
            resultTexts: 'regular'
        }
    }));
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.dosingCombinationSection = areWeightAndStartDateAnswered();
    visibleSections.monotherapyTreatment = areWeightAndStartDateAnswered();
    visibleSections.dosing240mgSection =
        areWeightAndStartDateAnswered() &&
            helpers_1.answerMatches(inputs.monotherapyDose, '240mg');
    visibleSections.dosing480mgSection =
        areWeightAndStartDateAnswered() &&
            helpers_1.answerMatches(inputs.monotherapyDose, '480mg');
    visibleSections.additional = helpers_1.isAnswered(inputs.monotherapyDose);
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return areWeightAndStartDateAnswered();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
