"use strict";


var visibleQuestions = {
    recommended: true,
    nivolumabDose: true,
    startDate: true,
    dose1: true,
    dose2: true,
    dose3: true,
    dose4: true,
    dosesGeneral: true,
    dose1a: true,
    dose2a: true,
    dose3a: true,
    dose4a: true,
    dosesGeneral2: true
};
var visibleSections = {
    combinationTreatment: true,
    result240mg: false,
    result480mg: false
};
var inputs = {
    nivolumabDose: null,
    startDate: null
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    if (!helpers_1.isAnswered(inputs.nivolumabDose) || !helpers_1.isAnswered(inputs.startDate))
        return {};
    if (helpers_1.answerMatches(inputs.nivolumabDose, 'dosing240mg') &&
        helpers_1.isAnswered(inputs.startDate)) {
        return {
            dose1: {
                qID: 'dose1',
                tParams: [
                    {
                        type: 'date',
                        value: (_a = inputs.startDate) === null || _a === void 0 ? void 0 : _a.currentDate
                    },
                ],
                rParams: [],
                titleTexts: 'result1',
                resultTexts: 'result1'
            },
            dose2: {
                qID: 'dose2',
                tParams: [
                    {
                        type: 'date',
                        value: helpers_1.addDaysToDate((_b = inputs.startDate) === null || _b === void 0 ? void 0 : _b.currentDate, 14)
                    },
                ],
                rParams: [],
                titleTexts: 'result1',
                resultTexts: 'result1'
            },
            dose3: {
                qID: 'dose3',
                tParams: [
                    {
                        type: 'date',
                        value: helpers_1.addDaysToDate((_c = inputs.startDate) === null || _c === void 0 ? void 0 : _c.currentDate, 28)
                    },
                ],
                rParams: [],
                titleTexts: 'result1',
                resultTexts: 'result1'
            },
            dose4: {
                qID: 'dose4',
                tParams: [
                    {
                        type: 'date',
                        value: helpers_1.addDaysToDate((_d = inputs.startDate) === null || _d === void 0 ? void 0 : _d.currentDate, 42)
                    },
                ],
                rParams: [],
                titleTexts: 'result1',
                resultTexts: 'result1'
            },
            dosesGeneral: {
                qID: 'dosesGeneral',
                tParams: [],
                rParams: [],
                titleTexts: 'result1',
                resultTexts: 'result1'
            }
        };
    }
    return {
        dose1a: {
            qID: 'dose1a',
            tParams: [
                {
                    type: 'date',
                    value: (_e = inputs.startDate) === null || _e === void 0 ? void 0 : _e.currentDate
                },
            ],
            rParams: [],
            titleTexts: 'result1',
            resultTexts: 'result1'
        },
        dose2a: {
            qID: 'dose2a',
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate((_f = inputs.startDate) === null || _f === void 0 ? void 0 : _f.currentDate, 28)
                },
            ],
            rParams: [],
            titleTexts: 'result1',
            resultTexts: 'result1'
        },
        dose3a: {
            qID: 'dose3a',
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate((_g = inputs.startDate) === null || _g === void 0 ? void 0 : _g.currentDate, 56)
                },
            ],
            rParams: [],
            titleTexts: 'result1',
            resultTexts: 'result1'
        },
        dose4a: {
            qID: 'dose4a',
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate((_h = inputs.startDate) === null || _h === void 0 ? void 0 : _h.currentDate, 84)
                },
            ],
            rParams: [],
            titleTexts: 'result1',
            resultTexts: 'result1'
        },
        dosesGeneral2: {
            qID: 'dosesGeneral2',
            tParams: [],
            rParams: [],
            titleTexts: 'result1',
            resultTexts: 'result1'
        }
    };
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.result240mg =
        helpers_1.isAnswered(inputs.startDate) &&
            helpers_1.answerMatches(inputs.nivolumabDose, 'dosing240mg');
    visibleSections.result480mg =
        helpers_1.isAnswered(inputs.startDate) &&
            helpers_1.answerMatches(inputs.nivolumabDose, 'dosing480mg');
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return helpers_1.isAnswered(inputs.nivolumabDose) && helpers_1.isAnswered(inputs.startDate);
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
