"use strict";


var visibleQuestions = {
    info: true,
    dose: true,
    startDate: true,
    dose1: true,
    dose2: true,
    dosesGeneral: true,
    dose240Result4: true,
    dose240Result5: true,
    dose1a: true,
    dose2a: true,
    dosesGeneral2: true,
    dose480Result4: true,
    additionalInfo: true
};
var visibleSections = {
    main: true,
    dosing240mgSection: false,
    dosing480mgSection: false,
    additional: true
};
var inputs = {
    dose: null,
    startDate: null
};
var areDoseAndStartDateAnswered = function () {
    return helpers_1.isAnswered(inputs.dose) && helpers_1.isAnswered(inputs.startDate);
};
var calculatePoints = function () {
    var _a, _b, _c, _d;
    if (!areDoseAndStartDateAnswered())
        return {};
    if (helpers_1.answerMatches(inputs.dose, '240mg')) {
        return {
            dose1: {
                qID: 'dose1',
                tParams: [
                    {
                        type: 'date',
                        value: (_a = inputs.startDate) === null || _a === void 0 ? void 0 : _a.currentDate
                    },
                ],
                titleTexts: 'regular',
                resultTexts: 'regular'
            },
            dose2: {
                qID: 'dose2',
                tParams: [
                    {
                        type: 'date',
                        value: helpers_1.addDaysToDate((_b = inputs.startDate) === null || _b === void 0 ? void 0 : _b.currentDate, 14)
                    },
                ],
                titleTexts: 'regular',
                resultTexts: 'regular'
            },
            dosesGeneral: {
                qID: 'dosesGeneral',
                titleTexts: 'regular',
                resultTexts: 'regular'
            }
        };
    }
    return {
        dose1a: {
            qID: 'dose1a',
            tParams: [
                {
                    type: 'date',
                    value: (_c = inputs.startDate) === null || _c === void 0 ? void 0 : _c.currentDate
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        dose2a: {
            qID: 'dose2a',
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate((_d = inputs.startDate) === null || _d === void 0 ? void 0 : _d.currentDate, 28)
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        dosesGeneral2: {
            qID: 'dosesGeneral2',
            titleTexts: 'regular',
            resultTexts: 'regular'
        }
    };
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.dosing240mgSection =
        helpers_1.answerMatches(inputs.dose, '240mg') && helpers_1.isAnswered(inputs.startDate);
    visibleSections.dosing480mgSection =
        helpers_1.answerMatches(inputs.dose, '480mg') && helpers_1.isAnswered(inputs.startDate);
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return areDoseAndStartDateAnswered();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
