"use strict";


var visibleQuestions = {
    info: true,
    startDate: true,
    dose1: true,
    dose2: true,
    dosen: true
};
var visibleSections = {
    main: true,
    dosingSection: false
};
var inputs = {
    startDate: null
};
var calculatePoints = function () {
    var _a, _b;
    if (!helpers_1.isAnswered(inputs.startDate))
        return {};
    return {
        dose1: {
            qID: 'dose1',
            tParams: [
                {
                    type: 'date',
                    value: (_a = inputs.startDate) === null || _a === void 0 ? void 0 : _a.currentDate
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        dose2: {
            qID: 'dose2',
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate((_b = inputs.startDate) === null || _b === void 0 ? void 0 : _b.currentDate, 14)
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        dosen: {
            qID: 'dosen',
            titleTexts: 'regular',
            resultTexts: 'regular'
        }
    };
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.dosingSection = helpers_1.isAnswered(inputs.startDate);
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
