"use strict";


var visibleQuestions = {
    info: true,
    dose: true,
    startDate: true,
    doseKabo: true,
    doseKabo1: true,
    doseKaboEveryDay: true,
    dose2401: true,
    dose2402: true,
    dose240n: true,
    dose2407: true,
    doseKabo3: true,
    doseKabo31: true,
    doseKaboEveryDay3: true,
    dose4801: true,
    dose4802: true,
    dose480n: true,
    dose4807: true
};
var visibleSections = {
    main: true,
    dosingSection: false,
    dosingSection2: false,
    dosingSection3: false,
    dosingSection4: false
};
var inputs = {
    dose: null,
    startDate: null
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    if (!helpers_1.isAnswered(inputs.dose) || !helpers_1.isAnswered(inputs.startDate))
        return {};
    if (((_a = inputs.dose) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === '240mg') {
        return {
            doseKabo: {
                qID: 'doseKabo',
                tParams: [
                    {
                        type: 'date',
                        value: (_b = inputs.startDate) === null || _b === void 0 ? void 0 : _b.currentDate
                    },
                ],
                titleTexts: 'regular',
                resultTexts: 'regular'
            },
            doseKabo1: {
                qID: 'doseKabo1',
                tParams: [
                    {
                        type: 'date',
                        value: helpers_1.addDaysToDate((_c = inputs.startDate) === null || _c === void 0 ? void 0 : _c.currentDate, 1)
                    },
                ],
                titleTexts: 'regular',
                resultTexts: 'regular'
            },
            doseKaboEveryDay: {
                qID: 'doseKaboEveryDay',
                titleTexts: 'regular',
                resultTexts: 'regular'
            },
            dose2401: {
                qID: 'dose2401',
                tParams: [
                    {
                        type: 'date',
                        value: (_d = inputs.startDate) === null || _d === void 0 ? void 0 : _d.currentDate
                    },
                ],
                titleTexts: 'regular',
                resultTexts: 'regular'
            },
            dose2402: {
                qID: 'dose2402',
                tParams: [
                    {
                        type: 'date',
                        value: helpers_1.addDaysToDate((_e = inputs.startDate) === null || _e === void 0 ? void 0 : _e.currentDate, 14)
                    },
                ],
                titleTexts: 'regular',
                resultTexts: 'regular'
            },
            dose240n: {
                qID: 'dose240n',
                titleTexts: 'regular',
                resultTexts: 'regular'
            }
        };
    }
    return {
        doseKabo3: {
            qID: 'doseKabo3',
            tParams: [
                {
                    type: 'date',
                    value: (_f = inputs.startDate) === null || _f === void 0 ? void 0 : _f.currentDate
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        doseKabo31: {
            qID: 'doseKabo31',
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate((_g = inputs.startDate) === null || _g === void 0 ? void 0 : _g.currentDate, 1)
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        doseKaboEveryDay3: {
            qID: 'doseKaboEveryDay3',
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        dose4801: {
            qID: 'dose4801',
            tParams: [
                {
                    type: 'date',
                    value: (_h = inputs.startDate) === null || _h === void 0 ? void 0 : _h.currentDate
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        dose4802: {
            qID: 'dose4802',
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate((_j = inputs.startDate) === null || _j === void 0 ? void 0 : _j.currentDate, 28)
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        dose480n: {
            qID: 'dose480n',
            titleTexts: 'regular',
            resultTexts: 'regular'
        }
    };
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    var _a, _b, _c, _d;
    if (!helpers_1.isAnswered(inputs.dose) || !helpers_1.isAnswered(inputs.startDate)) {
        return visibleSections;
    }
    visibleSections.dosingSection =
        helpers_1.isAnswered(inputs.dose) && ((_a = inputs.dose) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === '240mg';
    visibleSections.dosingSection2 =
        helpers_1.isAnswered(inputs.dose) && ((_b = inputs.dose) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === '240mg';
    visibleSections.dosingSection3 =
        helpers_1.isAnswered(inputs.dose) && ((_c = inputs.dose) === null || _c === void 0 ? void 0 : _c.currentIdentifier) === '480mg';
    visibleSections.dosingSection4 =
        helpers_1.isAnswered(inputs.dose) && ((_d = inputs.dose) === null || _d === void 0 ? void 0 : _d.currentIdentifier) === '480mg';
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
