"use strict";


var visibleQuestions = {
    info: true,
    dose: true,
    startDate: true,
    dose2401: true,
    dose2402: true,
    dose240n: true,
    dose240Result4: true,
    dose4801: true,
    dose4802: true,
    dose480n: true,
    dose480Result4: true
};
var visibleSections = {
    combinationTreatment: true,
    dosing240mgSection: false,
    dosing480mgSection: false
};
var inputs = {
    dose: null,
    startDate: null
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e;
    if (!helpers_1.isAnswered(inputs.dose) || !helpers_1.isAnswered(inputs.startDate))
        return {};
    if (((_a = inputs.dose) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === '240mg') {
        return {
            dose2401: {
                qID: 'dose2401',
                tParams: [
                    {
                        type: 'date',
                        value: (_b = inputs.startDate) === null || _b === void 0 ? void 0 : _b.currentDate
                    },
                ],
                titleTexts: 'regular',
                resultTexts: 'regular'
            },
            dose2402: {
                qID: 'dose2402',
                tParams: [
                    {
                        type: 'date',
                        value: helpers_1.addDaysToDate((_c = inputs.startDate) === null || _c === void 0 ? void 0 : _c.currentDate, 14)
                    },
                ],
                titleTexts: 'regular',
                resultTexts: 'regular'
            },
            dose240n: {
                qID: 'dose240n',
                titleTexts: 'regular',
                resultTexts: 'regular'
            }
        };
    }
    return {
        dose4801: {
            qID: 'dose4801',
            tParams: [
                {
                    type: 'date',
                    value: (_d = inputs.startDate) === null || _d === void 0 ? void 0 : _d.currentDate
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        dose4802: {
            qID: 'dose4802',
            tParams: [
                {
                    type: 'date',
                    value: helpers_1.addDaysToDate((_e = inputs.startDate) === null || _e === void 0 ? void 0 : _e.currentDate, 28)
                },
            ],
            titleTexts: 'regular',
            resultTexts: 'regular'
        },
        dose480n: {
            qID: 'dose480n',
            titleTexts: 'regular',
            resultTexts: 'regular'
        }
    };
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    var _a, _b;
    visibleSections.dosing240mgSection =
        helpers_1.isAnswered(inputs.dose) &&
            helpers_1.isAnswered(inputs.startDate) &&
            ((_a = inputs.dose) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === '240mg';
    visibleSections.dosing480mgSection =
        helpers_1.isAnswered(inputs.dose) &&
            helpers_1.isAnswered(inputs.startDate) &&
            ((_b = inputs.dose) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === '480mg';
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
