// Starting visibility state of all questions that change in JS. If the question isn't here, default is taken from JSON.
var visibleQuestions = {
    statinDose: true,
    titration: false,
    targethLDL: false,
    ezetimibe: false,
    hLDLvalues: false,
    result21: false,
    result22: false,
    result23: false,
    result31: false,
    result41: false,
    result42: false
};

// Starting visibility state of all sections that change in JS. If the section isn't here, default is taken from JSON.
var visibleSections = {
    questions: true,
    resultSection2: false,
    resultSection3: false,
    resultSection4: false
};

// All input questions must be listed below.
var inputs = {
    statinDose: null,
    targethLDL: null,
    hLDLvalues: null
};

// Private functions
function statinDoseVisibility() {
    return true;
}

function titrationVisibility() {
    return inputs.statinDose.currentIdentifier != null && inputs.statinDose.currentIdentifier == "no";
}

function targethLDLVisibility() {
    return inputs.statinDose.currentIdentifier != null;
}

function ezetimibeVisibility() {
    return targethLDLVisibility() && inputs.targethLDL.currentIdentifier != null && inputs.targethLDL.currentIdentifier == "no";
}

function hLDLvaluesVisibility() {
    return targethLDLVisibility() && inputs.targethLDL.currentIdentifier != null && inputs.targethLDL.currentIdentifier == "no";
}

function result21Visibility() {
    return hLDLvaluesVisibility() && inputs.hLDLvalues.currentIdentifier != null && inputs.hLDLvalues.currentIdentifier == "yes";
}

function result22Visibility() {
    return result21Visibility();
}

function result23Visibility() {
    return hLDLvaluesVisibility() && inputs.hLDLvalues.currentIdentifier != null && inputs.hLDLvalues.currentIdentifier == "no" || targethLDLVisibility() && inputs.targethLDL.currentIdentifier != null && inputs.targethLDL.currentIdentifier == "yes";
}

function result31Visibility() {
    return hLDLvaluesVisibility() && inputs.targethLDL.currentIdentifier != null && inputs.hLDLvalues.currentIdentifier == "yes";
}

function result41Visibility() {
    return hLDLvaluesVisibility() && inputs.targethLDL.currentIdentifier != null && inputs.hLDLvalues.currentIdentifier == "yes";
}

function result42Visibility() {
    return result41Visibility();
}

// Methods below are called from the app and their name, function, and output shouldn't change.
function returnVisibleQuestions() {
    visibleQuestions.statinDose = statinDoseVisibility();
    visibleQuestions.titration = titrationVisibility();
    visibleQuestions.targethLDL = targethLDLVisibility();
    visibleQuestions.ezetimibe = ezetimibeVisibility();
    visibleQuestions.hLDLvalues = hLDLvaluesVisibility();
    visibleQuestions.result21 = result21Visibility();
    visibleQuestions.result22 = result22Visibility();
    visibleQuestions.result23 = result23Visibility();
    visibleQuestions.result31 = result31Visibility();
    visibleQuestions.result41 = result41Visibility();
    visibleQuestions.result42 = result42Visibility();
    return visibleQuestions; // {no1: true, no2: true, no3: false,…}
}

function questionsVisibility(){
    return true;
}

function resultSection2Visibility(){
    return result21Visibility() || result23Visibility();
}

function resultSection3Visibility(){
    return result31Visibility();
}

function resultSection4Visibility(){
    return result41Visibility();
}

function returnVisibleSections() {
    visibleSections.questions = questionsVisibility();
    visibleSections.resultSection2 = resultSection2Visibility();
    visibleSections.resultSection3 = resultSection3Visibility();
    visibleSections.resultSection4 = resultSection4Visibility();
    return visibleSections;
}
// Called from the mobile app. Input questions are preloaded, so their values don't need updating.
function ut_visibleQuestions() {
    return returnVisibleQuestions();
}

function ut_visibleSections() {
    return returnVisibleSections();
}

exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    return {
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
