"use strict";


var visibleQuestions = {
    indications: true,
    weight: true,
    kidney: false,
    noAnswerResult: false,
    suppWarningA: false,
    tabletsDoseFG: false,
    tabletsDoseFG2: false,
    duration1: false,
    tabletsDoseFGLow: false,
    duration1Low: false,
    tabletsDoseH: false,
    tabletsDoseH2: false,
    tabletsDoseExtraMaxH: false,
    duration2: false,
    tabletsAlternativeH: false,
    tabletsDoseHLow: false,
    duration2Low: false,
    tabletsAlternativeHLow: false,
    tabletsDoseI: false,
    tabletsDoseI2: false,
    duration3: false,
    tabletsDoseILow: false,
    duration3Low: false,
    tabletsDoseJ: false,
    tabletsDoseJ2: false,
    duration4: false,
    tabletsDoseJLow: false,
    duration4Low: false,
    supp125DoseBCD: false,
    supp125DoseBCD2: false,
    supp125DoseBCD3: false,
    duration5: false,
    supp125DoseBCDLow: false,
    duration5Low: false,
    supp250DoseEFG: false,
    supp250DoseEFG2: false,
    supp250DoseEFG3: false,
    duration6: false,
    supp250DoseEFGLow: false,
    duration6Low: false,
    supp1000DoseJ: false,
    supp1000DoseJ2: false,
    duration8: false,
    supp1000DoseJLow: false,
    duration8Low: false,
    supp500DoseHI: false,
    supp500DoseHI2: false,
    supp500DoseHI3: false,
    supp500DoseJ: false,
    supp500DoseJ2: false,
    duration7: false,
    supp500DoseHILow: false,
    supp500DoseJLow: false,
    duration7Low: false,
    oralSolutionDoseBC: false,
    oralSolutionDoseBC2: false,
    duration9: false,
    oralSolutionDoseBCLow: false,
    duration9Low: false,
    oralSolutionDoseD: false,
    oralSolutionDoseD2: false,
    duration10: false,
    oralSolutionDoseDLow: false,
    duration10Low: false,
    oralSolutionDoseEF: false,
    oralSolutionDoseEF2: false,
    duration11: false,
    oralSolutionDoseEFLow: false,
    duration11Low: false,
    oralSolutionDoseG: false,
    oralSolutionDoseG2: false,
    duration12: false,
    oralSolutionDoseGLow: false,
    duration12Low: false,
    oralSolutionDoseH: false,
    oralSolutionDoseH2: false,
    duration13: false,
    oralSolutionDoseHLow: false,
    duration13Low: false,
    oralSolutionDoseI: false,
    oralSolutionDoseI2: false,
    duration14: false,
    oralSolutionDoseILow: false,
    duration14Low: false,
    liver: false,
    kidneyWarningResult: false
};
var visibleSections = {
    indicationsSection: true,
    inputs: true,
    noAnswer: false,
    anythingA: false,
    tabletsFG: false,
    tabletsFGLow: false,
    tabletsH: false,
    tabletsHLow: false,
    tabletsI: false,
    tabletsILow: false,
    tabletsJ: false,
    tabletsJLow: false,
    supp125BCD: false,
    supp125BCDLow: false,
    supp250EFG: false,
    supp250EFGLow: false,
    supp500and1000J: false,
    supp500and1000JLow: false,
    supp500HI: false,
    supp500HILow: false,
    oralSolutionBC: false,
    oralSolutionBCLow: false,
    oralSolutionD: false,
    oralSolutionDLow: false,
    oralSolutionEF: false,
    oralSolutionEFLow: false,
    oralSolutionG: false,
    oralSolutionGLow: false,
    oralSolutionH: false,
    oralSolutionHLow: false,
    oralSolutionI: false,
    oralSolutionILow: false,
    kidneyWarning: false
};
var inputs = {
    weight: null,
    kidney: null
};
var isWeightInLimits = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 200 });
};
var isKidneyVisible = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 7, max: 200 });
};
var isNoAnswerVisible = function () {
    return !isWeightInLimits();
};
var isAnythingAVisible = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 6.99 });
};
var isTabletsFGVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 16.5, max: 25.49 }) &&
        helpers_1.answerMatches(inputs.kidney, 'high'));
};
var isTabletsFGLowVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 16.5, max: 25.49 }) &&
        helpers_1.answerMatches(inputs.kidney, 'low'));
};
var isTabletsHVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 25.5, max: 32.49 }) &&
        helpers_1.answerMatches(inputs.kidney, 'high'));
};
var isTabletsHLowVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 25.5, max: 32.49 }) &&
        helpers_1.answerMatches(inputs.kidney, 'low'));
};
var isTabletsIVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 32.5, max: 43.49 }) &&
        helpers_1.answerMatches(inputs.kidney, 'high'));
};
var isTabletsILowVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 32.5, max: 43.49 }) &&
        helpers_1.answerMatches(inputs.kidney, 'low'));
};
var isTabletsJVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 43.5, max: 200 }) &&
        helpers_1.answerMatches(inputs.kidney, 'high'));
};
var isTabletsJLowVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 43.5, max: 200 }) &&
        helpers_1.answerMatches(inputs.kidney, 'low'));
};
var isSupp125BCDVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 7, max: 12.49 }) &&
        helpers_1.answerMatches(inputs.kidney, 'high'));
};
var isSupp125DoseBCD2Visible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 7, max: 8.49 }) &&
        helpers_1.answerMatches(inputs.kidney, 'high'));
};
var isSupp125DoseBCD3Visible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 8.5, max: 12.49 }) &&
        helpers_1.answerMatches(inputs.kidney, 'high'));
};
var isSupp125BCDLowVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 7, max: 12.49 }) &&
        helpers_1.answerMatches(inputs.kidney, 'low'));
};
var isSupp250EFGVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 12.5, max: 25.49 }) &&
        helpers_1.answerMatches(inputs.kidney, 'high'));
};
var isSupp250EFG2Visible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 12.5, max: 16.49 }) &&
        helpers_1.answerMatches(inputs.kidney, 'high'));
};
var isSupp250EFG3Visible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 16.5, max: 25.49 }) &&
        helpers_1.answerMatches(inputs.kidney, 'high'));
};
var isSupp250EFGLowVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 12.5, max: 25.49 }) &&
        helpers_1.answerMatches(inputs.kidney, 'low'));
};
var isSupp500and1000JVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 43.5, max: 200 }) &&
        helpers_1.answerMatches(inputs.kidney, 'high'));
};
var isSupp500and1000JLowVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 43.5, max: 200 }) &&
        helpers_1.answerMatches(inputs.kidney, 'low'));
};
var isSupp500HIVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 25.5, max: 200 }) &&
        helpers_1.answerMatches(inputs.kidney, 'high'));
};
var isSupp500DoseHIVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 25.5, max: 43.49 }) &&
        helpers_1.answerMatches(inputs.kidney, 'high'));
};
var isSupp500DoseHI2Visible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 25.5, max: 32.49 }) &&
        helpers_1.answerMatches(inputs.kidney, 'high'));
};
var isSupp500DoseHI3Visible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 32.5, max: 43.49 }) &&
        helpers_1.answerMatches(inputs.kidney, 'high'));
};
var isSupp500DoseJVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 43.5, max: 200 }) &&
        helpers_1.answerMatches(inputs.kidney, 'high'));
};
var isSupp500HILowVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 25.5, max: 200 }) &&
        helpers_1.answerMatches(inputs.kidney, 'low'));
};
var isSupp500DoseHILowVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 25.5, max: 43.49 }) &&
        helpers_1.answerMatches(inputs.kidney, 'low'));
};
var isSupp500DoseJLowVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 43.5, max: 200 }) &&
        helpers_1.answerMatches(inputs.kidney, 'low'));
};
var isOralSolutionBCVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 7, max: 9.49 }) &&
        helpers_1.answerMatches(inputs.kidney, 'high'));
};
var isOralSolutionBCLowVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 7, max: 9.49 }) &&
        helpers_1.answerMatches(inputs.kidney, 'low'));
};
var isOralSolutionDVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 9.5, max: 12.49 }) &&
        helpers_1.answerMatches(inputs.kidney, 'high'));
};
var isOralSolutionDLowVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 9.5, max: 12.49 }) &&
        helpers_1.answerMatches(inputs.kidney, 'low'));
};
var isOralSolutionEFVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 12.5, max: 18.49 }) &&
        helpers_1.answerMatches(inputs.kidney, 'high'));
};
var isOralSolutionEFLowVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 12.5, max: 18.49 }) &&
        helpers_1.answerMatches(inputs.kidney, 'low'));
};
var isOralSolutionGVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 18.5, max: 25.49 }) &&
        helpers_1.answerMatches(inputs.kidney, 'high'));
};
var isOralSolutionGLowVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 18.5, max: 25.49 }) &&
        helpers_1.answerMatches(inputs.kidney, 'low'));
};
var isOralSolutionHVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 25.5, max: 32.49 }) &&
        helpers_1.answerMatches(inputs.kidney, 'high'));
};
var isOralSolutionHLowVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 25.5, max: 32.49 }) &&
        helpers_1.answerMatches(inputs.kidney, 'low'));
};
var isOralSolutionIVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 32.5, max: 43.49 }) &&
        helpers_1.answerMatches(inputs.kidney, 'high'));
};
var isOralSolutionILowVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 32.5, max: 43.49 }) &&
        helpers_1.answerMatches(inputs.kidney, 'low'));
};
var isKidneyWarningVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 7, max: 200 }) &&
        helpers_1.isAnswered(inputs.kidney));
};
var isKidneyWarningResultVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 7, max: 200 }) &&
        helpers_1.answerMatches(inputs.kidney, 'high'));
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.kidney = isKidneyVisible();
    visibleQuestions.noAnswerResult = isNoAnswerVisible();
    visibleQuestions.suppWarningA = isAnythingAVisible();
    visibleQuestions.tabletsDoseFG = isTabletsFGVisible();
    visibleQuestions.tabletsDoseFG2 = isTabletsFGVisible();
    visibleQuestions.duration1 = isTabletsFGVisible();
    visibleQuestions.tabletsDoseFGLow = isTabletsFGLowVisible();
    visibleQuestions.duration1Low = isTabletsFGLowVisible();
    visibleQuestions.tabletsDoseH = isTabletsHVisible();
    visibleQuestions.tabletsDoseH2 = isTabletsHVisible();
    visibleQuestions.tabletsDoseExtraMaxH = isTabletsHVisible();
    visibleQuestions.duration2 = isTabletsHVisible();
    visibleQuestions.tabletsAlternativeH = isTabletsHVisible();
    visibleQuestions.tabletsDoseHLow = isTabletsHLowVisible();
    visibleQuestions.duration2Low = isTabletsHLowVisible();
    visibleQuestions.tabletsAlternativeHLow = isTabletsHLowVisible();
    visibleQuestions.tabletsDoseI = isTabletsIVisible();
    visibleQuestions.tabletsDoseI2 = isTabletsIVisible();
    visibleQuestions.duration3 = isTabletsIVisible();
    visibleQuestions.tabletsDoseILow = isTabletsILowVisible();
    visibleQuestions.duration3Low = isTabletsILowVisible();
    visibleQuestions.tabletsDoseJ = isTabletsJVisible();
    visibleQuestions.tabletsDoseJ2 = isTabletsJVisible();
    visibleQuestions.duration4 = isTabletsJVisible();
    visibleQuestions.tabletsDoseJLow = isTabletsJLowVisible();
    visibleQuestions.duration4Low = isTabletsJLowVisible();
    visibleQuestions.supp125DoseBCD = isSupp125BCDVisible();
    visibleQuestions.supp125DoseBCD2 = isSupp125DoseBCD2Visible();
    visibleQuestions.supp125DoseBCD3 = isSupp125DoseBCD3Visible();
    visibleQuestions.duration5 = isSupp125BCDVisible();
    visibleQuestions.supp125DoseBCDLow = isSupp125BCDLowVisible();
    visibleQuestions.duration5Low = isSupp125BCDLowVisible();
    visibleQuestions.supp250DoseEFG = isSupp250EFGVisible();
    visibleQuestions.supp250DoseEFG2 = isSupp250EFG2Visible();
    visibleQuestions.supp250DoseEFG3 = isSupp250EFG3Visible();
    visibleQuestions.duration6 = isSupp250EFGVisible();
    visibleQuestions.supp250DoseEFGLow = isSupp250EFGLowVisible();
    visibleQuestions.duration6Low = isSupp250EFGLowVisible();
    visibleQuestions.supp1000DoseJ = isSupp500and1000JVisible();
    visibleQuestions.supp1000DoseJ2 = isSupp500and1000JVisible();
    visibleQuestions.duration8 = isSupp500and1000JVisible();
    visibleQuestions.supp1000DoseJLow = isSupp500and1000JLowVisible();
    visibleQuestions.duration8Low = isSupp500and1000JLowVisible();
    visibleQuestions.supp500DoseHI = isSupp500DoseHIVisible();
    visibleQuestions.supp500DoseHI2 = isSupp500DoseHI2Visible();
    visibleQuestions.supp500DoseHI3 = isSupp500DoseHI3Visible();
    visibleQuestions.supp500DoseJ = isSupp500DoseJVisible();
    visibleQuestions.supp500DoseJ2 = isSupp500DoseJVisible();
    visibleQuestions.duration7 = isSupp500HIVisible();
    visibleQuestions.supp500DoseHILow = isSupp500DoseHILowVisible();
    visibleQuestions.supp500DoseJLow = isSupp500DoseJLowVisible();
    visibleQuestions.duration7Low = isSupp500HILowVisible();
    visibleQuestions.oralSolutionDoseBC = isOralSolutionBCVisible();
    visibleQuestions.oralSolutionDoseBC2 = isOralSolutionBCVisible();
    visibleQuestions.duration9 = isOralSolutionBCVisible();
    visibleQuestions.oralSolutionDoseBCLow = isOralSolutionBCLowVisible();
    visibleQuestions.duration9Low = isOralSolutionBCLowVisible();
    visibleQuestions.oralSolutionDoseD = isOralSolutionDVisible();
    visibleQuestions.oralSolutionDoseD2 = isOralSolutionDVisible();
    visibleQuestions.duration10 = isOralSolutionDVisible();
    visibleQuestions.oralSolutionDoseDLow = isOralSolutionDLowVisible();
    visibleQuestions.duration10Low = isOralSolutionDLowVisible();
    visibleQuestions.oralSolutionDoseEF = isOralSolutionEFVisible();
    visibleQuestions.oralSolutionDoseEF2 = isOralSolutionEFVisible();
    visibleQuestions.duration11 = isOralSolutionEFVisible();
    visibleQuestions.oralSolutionDoseEFLow = isOralSolutionEFLowVisible();
    visibleQuestions.duration11Low = isOralSolutionEFLowVisible();
    visibleQuestions.oralSolutionDoseG = isOralSolutionGVisible();
    visibleQuestions.oralSolutionDoseG2 = isOralSolutionGVisible();
    visibleQuestions.duration12 = isOralSolutionGVisible();
    visibleQuestions.oralSolutionDoseGLow = isOralSolutionGLowVisible();
    visibleQuestions.duration12Low = isOralSolutionGLowVisible();
    visibleQuestions.oralSolutionDoseH = isOralSolutionHVisible();
    visibleQuestions.oralSolutionDoseH2 = isOralSolutionHVisible();
    visibleQuestions.duration13 = isOralSolutionHVisible();
    visibleQuestions.oralSolutionDoseHLow = isOralSolutionHLowVisible();
    visibleQuestions.duration13Low = isOralSolutionHLowVisible();
    visibleQuestions.oralSolutionDoseI = isOralSolutionIVisible();
    visibleQuestions.oralSolutionDoseI2 = isOralSolutionIVisible();
    visibleQuestions.duration14 = isOralSolutionIVisible();
    visibleQuestions.oralSolutionDoseILow = isOralSolutionILowVisible();
    visibleQuestions.duration14Low = isOralSolutionILowVisible();
    visibleQuestions.liver = isKidneyWarningVisible();
    visibleQuestions.kidneyWarningResult = isKidneyWarningResultVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = isNoAnswerVisible();
    visibleSections.anythingA = isAnythingAVisible();
    visibleSections.tabletsFG = isTabletsFGVisible();
    visibleSections.tabletsFGLow = isTabletsFGLowVisible();
    visibleSections.tabletsH = isTabletsHVisible();
    visibleSections.tabletsHLow = isTabletsHLowVisible();
    visibleSections.tabletsI = isTabletsIVisible();
    visibleSections.tabletsILow = isTabletsILowVisible();
    visibleSections.tabletsJ = isTabletsJVisible();
    visibleSections.tabletsJLow = isTabletsJLowVisible();
    visibleSections.supp125BCD = isSupp125BCDVisible();
    visibleSections.supp125BCDLow = isSupp125BCDLowVisible();
    visibleSections.supp250EFG = isSupp250EFGVisible();
    visibleSections.supp250EFGLow = isSupp250EFGLowVisible();
    visibleSections.supp500and1000J = isSupp500and1000JVisible();
    visibleSections.supp500and1000JLow = isSupp500and1000JLowVisible();
    visibleSections.supp500HI = isSupp500HIVisible();
    visibleSections.supp500HILow = isSupp500HILowVisible();
    visibleSections.oralSolutionBC = isOralSolutionBCVisible();
    visibleSections.oralSolutionBCLow = isOralSolutionBCLowVisible();
    visibleSections.oralSolutionD = isOralSolutionDVisible();
    visibleSections.oralSolutionDLow = isOralSolutionDLowVisible();
    visibleSections.oralSolutionEF = isOralSolutionEFVisible();
    visibleSections.oralSolutionEFLow = isOralSolutionEFLowVisible();
    visibleSections.oralSolutionG = isOralSolutionGVisible();
    visibleSections.oralSolutionGLow = isOralSolutionGLowVisible();
    visibleSections.oralSolutionH = isOralSolutionHVisible();
    visibleSections.oralSolutionHLow = isOralSolutionHLowVisible();
    visibleSections.oralSolutionI = isOralSolutionIVisible();
    visibleSections.oralSolutionILow = isOralSolutionILowVisible();
    visibleSections.kidneyWarning = isKidneyWarningVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return !isNoAnswerVisible();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: { number: result, range: result },
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
