"use strict";


var visibleQuestions = {
    indication: true,
    info: true,
    age: true,
    contraindicatatedDrugs: false,
    liverpool: false,
    liverpoolLink: false,
    questionHepatic: false,
    egfr: false,
    warningAnswerText: false,
    warningAgeText: false,
    contraindication: false,
    hepaticImpairment: false,
    severeRenal: false,
    warningDosingText: false,
    tabletsRenal: false,
    resultRenalDuration: false,
    recommendationOne: false,
    warningRenalText: false,
    tablets: false,
    resultDuration: false,
    recommendationTwo: false
};
var visibleSections = {
    indicationsSection: true,
    questionSection: true,
    warningAnswer: false,
    warningAge: false,
    warningContraindication: false,
    warningHepatic: false,
    warningSevereRenal: false,
    warningDosing: false,
    resultDosingRenal: false,
    warningModerateRenal: false,
    resultDosing: false
};
var inputs = {
    age: null,
    contraindicatatedDrugs: null,
    liverpool: null,
    questionHepatic: null,
    egfr: null
};
var isAnswerAllVisible = function () {
    return !(helpers_1.answerMatches(inputs.age, 'less18') ||
        helpers_1.answerMatches(inputs.contraindicatatedDrugs, 'yes') ||
        helpers_1.answerMatches(inputs.liverpool, 'liverpoolYes') ||
        helpers_1.answerMatches(inputs.questionHepatic, 'answerHepaticYes') ||
        helpers_1.isAnswered(inputs.egfr));
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.contraindicatatedDrugs = helpers_1.answerMatches(inputs.age, 'more18');
    visibleQuestions.liverpool = helpers_1.answerMatches(inputs.contraindicatatedDrugs, 'no');
    visibleQuestions.liverpoolLink = helpers_1.answerMatches(inputs.contraindicatatedDrugs, 'no');
    visibleQuestions.questionHepatic = helpers_1.answerMatches(inputs.liverpool, 'liverpoolNo');
    visibleQuestions.egfr = helpers_1.answerMatches(inputs.questionHepatic, 'answerHepaticNo');
    visibleQuestions.warningAnswerText = isAnswerAllVisible();
    visibleQuestions.warningAgeText = helpers_1.answerMatches(inputs.age, 'less18');
    visibleQuestions.contraindication =
        helpers_1.answerMatches(inputs.contraindicatatedDrugs, 'yes') ||
            helpers_1.answerMatches(inputs.liverpool, 'liverpoolYes');
    visibleQuestions.hepaticImpairment = helpers_1.answerMatches(inputs.questionHepatic, 'answerHepaticYes');
    visibleQuestions.severeRenal = helpers_1.answerMatches(inputs.egfr, 'lessThirty');
    visibleQuestions.warningDosingText =
        helpers_1.answerMatches(inputs.egfr, 'thirtySixty') ||
            helpers_1.answerMatches(inputs.egfr, 'moreSixty');
    visibleQuestions.tabletsRenal = helpers_1.answerMatches(inputs.egfr, 'thirtySixty');
    visibleQuestions.resultRenalDuration = helpers_1.answerMatches(inputs.egfr, 'thirtySixty');
    visibleQuestions.recommendationOne = helpers_1.answerMatches(inputs.egfr, 'thirtySixty');
    visibleQuestions.warningRenalText = helpers_1.answerMatches(inputs.egfr, 'thirtySixty');
    visibleQuestions.tablets = helpers_1.answerMatches(inputs.egfr, 'moreSixty');
    visibleQuestions.resultDuration = helpers_1.answerMatches(inputs.egfr, 'moreSixty');
    visibleQuestions.recommendationTwo = helpers_1.answerMatches(inputs.egfr, 'moreSixty');
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.warningAnswer = isAnswerAllVisible();
    visibleSections.warningAge = helpers_1.answerMatches(inputs.age, 'less18');
    visibleSections.warningContraindication =
        helpers_1.answerMatches(inputs.contraindicatatedDrugs, 'yes') ||
            helpers_1.answerMatches(inputs.liverpool, 'liverpoolYes');
    visibleSections.warningHepatic = helpers_1.answerMatches(inputs.questionHepatic, 'answerHepaticYes');
    visibleSections.warningSevereRenal = helpers_1.answerMatches(inputs.egfr, 'lessThirty');
    visibleSections.warningDosing =
        helpers_1.answerMatches(inputs.egfr, 'thirtySixty') ||
            helpers_1.answerMatches(inputs.egfr, 'moreSixty');
    visibleSections.resultDosingRenal = helpers_1.answerMatches(inputs.egfr, 'thirtySixty');
    visibleSections.warningModerateRenal = helpers_1.answerMatches(inputs.egfr, 'thirtySixty');
    visibleSections.resultDosing = helpers_1.answerMatches(inputs.egfr, 'moreSixty');
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return !isAnswerAllVisible();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
