"use strict";


var visibleQuestions = {
    age: true,
    renalA: false,
    dosing1: true,
    kidsDose1: false,
    duration: false,
    infection: false,
    redAlow: false,
    redAmedium: false,
    adultDoseResult: false,
    durationRedA: false,
    warA: false,
    warningAnti: false
};
var visibleSections = {
    ageSelection: true,
    dosing: true,
    kidsDose: false,
    adultsDose: false,
    doseReductionA: false,
    warnings: false,
    anti: false
};
var inputs = {
    age: null,
    renalA: null
};
var calculatePoints = function () {
    return null;
};
var isRenalAVisible = function () {
    return helpers_1.answerMatches(inputs.age, 'adults');
};
var isAnswerAllVisible = function () {
    return !(helpers_1.answerMatches(inputs.age, 'kids') ||
        (helpers_1.answerMatches(inputs.age, 'adults') && helpers_1.isAnswered(inputs.renalA)));
};
var isKidsDoseVisible = function () {
    return helpers_1.answerMatches(inputs.age, 'kids');
};
var isAdultsDoseVisible = function () {
    return helpers_1.answerMatches(inputs.renalA, 'highA');
};
var isDoseReductionAVisible = function () {
    return (helpers_1.answerMatches(inputs.renalA, 'lowA') ||
        helpers_1.answerMatches(inputs.renalA, 'mediumA'));
};
var isRedAlowVisible = function () {
    return helpers_1.answerMatches(inputs.renalA, 'lowA');
};
var isRedAmediumVisible = function () {
    return helpers_1.answerMatches(inputs.renalA, 'mediumA');
};
var isWarningAntiVisible = function () {
    return helpers_1.isAnswered(inputs.renalA);
};
var returnVisibleQuestions = function () {
    visibleQuestions.renalA = isRenalAVisible();
    visibleQuestions.dosing1 = isAnswerAllVisible();
    visibleQuestions.kidsDose1 = isKidsDoseVisible();
    visibleQuestions.duration = isAdultsDoseVisible();
    visibleQuestions.infection = isAdultsDoseVisible();
    visibleQuestions.adultDoseResult = isAdultsDoseVisible();
    visibleQuestions.redAlow = isRedAlowVisible();
    visibleQuestions.redAmedium = isRedAmediumVisible();
    visibleQuestions.durationRedA = isDoseReductionAVisible();
    visibleQuestions.warA = isRedAlowVisible();
    visibleQuestions.warningAnti = isWarningAntiVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.dosing = isAnswerAllVisible();
    visibleSections.kidsDose = isKidsDoseVisible();
    visibleSections.adultsDose = isAdultsDoseVisible();
    visibleSections.doseReductionA = isDoseReductionAVisible();
    visibleSections.warnings = isRedAlowVisible();
    visibleSections.anti = isWarningAntiVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return !isAnswerAllVisible();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
