"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    indicationstext: true,
    age: true,
    weight: true,
    noAnswer1: true,
    warningPotassiumText: true,
    babiesRectalDosing: true,
    babiesRectalDuration: true,
    babiesWarningRectal: true,
    kidsDoseOral: true,
    kidsDuration: true,
    kidsOralWarning2: true,
    kidsOralWarning3: true,
    kidsOralWarning4: true,
    kidsRectalDose: true,
    kidsRectalDuration: true,
    kidsRectalWarning1: true,
    adultsDoseOral: true,
    adultsDurationOral: true,
    adultsOralWarning2: true,
    adultsOralWarning3: true,
    adultsOralWarning4: true,
    adultsDoseRectal: true,
    adultsDurationRectal: true,
    adultsRectalWarning2: true,
    kidneyText: true
};
var visibleSections = {
    indications: true,
    ageSelection: true,
    noAnswer: false,
    warningPotassium: false,
    babiesResultRectal: false,
    babiesResultRectalWarning: false,
    kidsResultOral: false,
    kidsResultOralWarnings: false,
    kidsResultRectal: false,
    kidsResultRectalWarnings: false,
    adultsResultOral: false,
    adultsResultOralWarnings: false,
    adultsResultRectal: false,
    adultsResultRectalInfo: false,
    kidneySection: false
};
var inputs = {
    age: null,
    weight: null
};
var isWeightVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'babies') || helpers_1.answerMatches(inputs.age, 'kids'));
};
var isNoAnswerVisible = function () {
    return (!helpers_1.isAnswered(inputs.age) ||
        (isWeightVisible() && (!helpers_1.isAnswered(inputs.weight) || !isWeightInputValid())));
};
var isWarningPotassiumVisible = function () {
    return !isNoAnswerVisible();
};
var isBabiesResultVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'babies') &&
        helpers_1.isAnswered(inputs.weight) &&
        isWeightInputValid());
};
var isKidsResultVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'kids') &&
        helpers_1.isAnswered(inputs.weight) &&
        isWeightInputValid());
};
var isAdultsResultVisible = function () {
    return helpers_1.answerMatches(inputs.age, 'adults');
};
var isKidneySectionVisible = function () {
    return !isNoAnswerVisible();
};
var isWeightInputValid = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 70 });
};
var returnvisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    visibleQuestions.weight = isWeightVisible();
    visibleQuestions.warningPotassiumText = isWarningPotassiumVisible();
    visibleQuestions.babiesRectalDosing = isBabiesResultVisible();
    visibleQuestions.babiesRectalDuration = isBabiesResultVisible();
    visibleQuestions.babiesWarningRectal = isBabiesResultVisible();
    visibleQuestions.kidsDoseOral = isKidsResultVisible();
    visibleQuestions.kidsDuration = isKidsResultVisible();
    visibleQuestions.kidsOralWarning2 = isKidsResultVisible();
    visibleQuestions.kidsOralWarning3 = isKidsResultVisible();
    visibleQuestions.kidsOralWarning4 = isKidsResultVisible();
    visibleQuestions.kidsRectalDose = isKidsResultVisible();
    visibleQuestions.kidsRectalDuration = isKidsResultVisible();
    visibleQuestions.kidsRectalWarning1 = isKidsResultVisible();
    visibleQuestions.adultsDoseOral = isAdultsResultVisible();
    visibleQuestions.adultsDurationOral = isAdultsResultVisible();
    visibleQuestions.adultsOralWarning2 = isAdultsResultVisible();
    visibleQuestions.adultsOralWarning3 = isAdultsResultVisible();
    visibleQuestions.adultsOralWarning4 = isAdultsResultVisible();
    visibleQuestions.adultsDoseRectal = isAdultsResultVisible();
    visibleQuestions.adultsDurationRectal = isAdultsResultVisible();
    visibleQuestions.adultsRectalWarning2 = isAdultsResultVisible();
    visibleQuestions.kidneyText = isKidneySectionVisible();
    return returnvisibleQuestions();
};
var ut_visibleSections = function () {
    visibleSections.noAnswer = isNoAnswerVisible();
    visibleSections.warningPotassium = isWarningPotassiumVisible();
    visibleSections.babiesResultRectal = isBabiesResultVisible();
    visibleSections.babiesResultRectalWarning = isBabiesResultVisible();
    visibleSections.kidsResultOral = isKidsResultVisible();
    visibleSections.kidsResultOralWarnings = isKidsResultVisible();
    visibleSections.kidsResultRectal = isKidsResultVisible();
    visibleSections.kidsResultRectalWarnings = isKidsResultVisible();
    visibleSections.adultsResultOral = isAdultsResultVisible();
    visibleSections.adultsResultOralWarnings = isAdultsResultVisible();
    visibleSections.adultsResultRectal = isAdultsResultVisible();
    visibleSections.adultsResultRectalInfo = isAdultsResultVisible();
    visibleSections.kidneySection = isKidneySectionVisible();
    return returnVisibleSections();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return !isNoAnswerVisible();
};
var calculateDosing = function () {
    var _a, _b;
    return {
        x: Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints) * 0.5,
        y: Number((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints)
    };
};
var returnBabiesResult = function () {
    return {
        babiesRectalDosing: {
            qID: 'babiesRectalDosing',
            rParams: helpers_1.returnNumberObject(calculateDosing().x),
            tParams: __spreadArrays(helpers_1.returnNumberObject(calculateDosing().x), helpers_1.returnNumberObject(calculateDosing().y)),
            titleTexts: 'babiesRectalDosing1',
            resultTexts: 'babiesRectalDosing2'
        },
        babiesRectalDuration: {
            qID: 'babiesRectalDuration',
            rParams: [],
            tParams: [],
            titleTexts: 'babiesRectalDuration1',
            resultTexts: 'result1'
        },
        babiesResultRectalWarning: {
            qID: 'babiesResultRectalWarning',
            rParams: [],
            tParams: [],
            titleTexts: 'babiesWarningRectal2'
        }
    };
};
var returnKidsResult = function () {
    return {
        kidsDoseOral: {
            qID: 'kidsDoseOral',
            rParams: helpers_1.returnNumberObject(calculateDosing().x),
            tParams: __spreadArrays(helpers_1.returnNumberObject(calculateDosing().x), helpers_1.returnNumberObject(calculateDosing().y)),
            titleTexts: 'kidsDoseOral1',
            resultTexts: 'kidsDoseOral2'
        },
        kidsDuration: {
            qID: 'kidsDuration',
            rParams: [],
            tParams: [],
            titleTexts: 'kidsDuration1',
            resultTexts: 'result1'
        },
        kidsOralWarning2: {
            qID: 'kidsOralWarning2',
            tParams: [],
            titleTexts: 'kidsOralWarning22'
        },
        kidsOralWarning3: {
            qID: 'kidsOralWarning3',
            tParams: [],
            titleTexts: 'kidsOralWarning32'
        },
        kidsOralWarning4: {
            qID: 'kidsOralWarning4',
            tParams: [],
            titleTexts: 'kidsOralWarning42'
        },
        kidsRectalDose: {
            qID: 'kidsRectalDose',
            rParams: helpers_1.returnNumberObject(calculateDosing().x),
            tParams: __spreadArrays(helpers_1.returnNumberObject(calculateDosing().x), helpers_1.returnNumberObject(calculateDosing().y)),
            titleTexts: 'kidsRectalDose1',
            resultTexts: 'kidsRectalDose2'
        },
        kidsRectalDuration: {
            qID: 'kidsRectalDuration',
            rParams: helpers_1.returnNumberObject(calculateDosing().x),
            tParams: __spreadArrays(helpers_1.returnNumberObject(calculateDosing().x), helpers_1.returnNumberObject(calculateDosing().y)),
            titleTexts: 'kidsRectalDuration1',
            resultTexts: 'result1'
        },
        kidsRectalWarning1: {
            qID: 'kidsRectalWarning1',
            tParams: [],
            titleTexts: 'kidsRectalWarning12'
        }
    };
};
var returnAdultsResult = function () {
    return {
        adultsDoseOral: {
            qID: 'adultsDoseOral',
            tParams: [],
            titleTexts: 'adultsDoseOral1'
        },
        adultsDurationOral: {
            qID: 'adultsDurationOral',
            rParams: [],
            tParams: [],
            titleTexts: 'adultsDurationOral1',
            resultTexts: 'result1'
        },
        adultsOralWarning2: {
            qID: 'adultsOralWarning2',
            tParams: [],
            titleTexts: 'adultsOralWarning22'
        },
        adultsOralWarning3: {
            qID: 'adultsOralWarning3',
            tParams: [],
            titleTexts: 'adultsOralWarning32'
        },
        adultsOralWarning4: {
            qID: 'adultsOralWarning4',
            tParams: [],
            titleTexts: 'adultsOralWarning42'
        },
        adultsDoseRectal: {
            qID: 'adultsDoseRectal',
            tParams: [],
            titleTexts: 'adultsDoseRectal1'
        },
        adultsDurationRectal: {
            qID: 'adultsDurationRectal',
            rParams: [],
            tParams: [],
            titleTexts: 'adultsDurationRectal1',
            resultTexts: 'result1'
        },
        adultsRectalWarning2: {
            qID: 'adultsRectalWarning2',
            rParams: [],
            tParams: [],
            titleTexts: 'adultsRectalWarning22',
            resultTexts: 'result1'
        }
    };
};
var returnKidneyResult = function () {
    return {
        kidneyText: {
            qID: 'kidneyText',
            tParams: [],
            titleTexts: 'result1'
        }
    };
};
var calculatePoints = function () {
    var result = __assign(__assign(__assign(__assign({}, (isBabiesResultVisible() && returnBabiesResult())), (isKidsResultVisible() && returnKidsResult())), (isAdultsResultVisible() && returnAdultsResult())), (!isNoAnswerVisible() && returnKidneyResult()));
    if (Object.keys(result).length === 0) {
        return null;
    }
    return result;
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
