"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleSections = {
    weightSection: true,
    noAnswerSection: false,
    dosing: false,
    kidneySection: false
};
var visibleQuestions = {
    weight: true,
    noAnswer: true,
    dosingResult: true,
    duration: true,
    warning: true,
    kidneyText: true
};
var inputs = {
    weight: null
};
var isWeightValid = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 150 });
};
var getParam13 = function () {
    var _a;
    return 0.25 * ((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints);
};
var getParam2 = function () {
    var _a;
    if (helpers_1.numberInLimits({ input: inputs.weight, min: 106.67, max: 150 }))
        return 53.3;
    return 0.5 * ((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints);
};
var getParam4 = function () {
    var _a;
    if (helpers_1.numberInLimits({ input: inputs.weight, min: 80, max: 150 }))
        return 40;
    return 0.5 * ((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints);
};
var getParam5 = function () {
    var _a;
    if (helpers_1.numberInLimits({ input: inputs.weight, min: 40, max: 150 }))
        return 40;
    return (_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints;
};
var calculatePoints = function () {
    if (isWeightValid()) {
        return {
            dosingResult: {
                qID: 'dosingResult',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(getParam13(), 2), 0, 2), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(getParam2(), 2), 0, 2), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(getParam13(), 2), 0, 2), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(getParam4(), 2), 0, 2)),
                titleTexts: 'result1',
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(getParam5(), 2), 0, 2)),
                resultTexts: 'result1'
            }
        };
    }
    return null;
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswerSection = !isWeightValid();
    visibleSections.dosing = isWeightValid();
    visibleSections.kidneySection = isWeightValid();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return isWeightValid();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
