"use strict";


var visibleQuestions = {
    inputType: true,
    heartRate: false,
    rrInterval: false,
    qtInterval: true,
    answerAll: false,
    result1: false,
    result2: false,
    warning: false
};
var visibleSections = {
    patientInfo: true,
    result: true
};
var inputs = {
    inputType: null,
    heartRate: null,
    rrInterval: null,
    qtInterval: null
};
var answerAllVisibility = function () {
    var _a, _b, _c;
    return (!helpers_1.isAnswered(inputs.inputType) ||
        (((_a = inputs.inputType) === null || _a === void 0 ? void 0 : _a.currentPoints) === 0
            ? !result1Visibility()
            : !result2Visibility()) ||
        !helpers_1.isAnswered(inputs.qtInterval) ||
        ((_b = inputs.qtInterval) === null || _b === void 0 ? void 0 : _b.currentPoints) < 0 ||
        ((_c = inputs.qtInterval) === null || _c === void 0 ? void 0 : _c.currentPoints) > 30000);
};
var result1Visibility = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.heartRate) &&
        ((_a = inputs.heartRate) === null || _a === void 0 ? void 0 : _a.currentPoints) >= 20 &&
        ((_b = inputs.heartRate) === null || _b === void 0 ? void 0 : _b.currentPoints) <= 300);
};
var result2Visibility = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.rrInterval) &&
        ((_a = inputs.rrInterval) === null || _a === void 0 ? void 0 : _a.currentPoints) >= 200 &&
        ((_b = inputs.rrInterval) === null || _b === void 0 ? void 0 : _b.currentPoints) <= 3000);
};
var returnVisibleQuestions = function () {
    var _a, _b;
    visibleQuestions.heartRate = ((_a = inputs.inputType) === null || _a === void 0 ? void 0 : _a.currentPoints) === 0;
    visibleQuestions.rrInterval = ((_b = inputs.inputType) === null || _b === void 0 ? void 0 : _b.currentPoints) === 1;
    visibleQuestions.answerAll = answerAllVisibility();
    visibleQuestions.result1 = !answerAllVisibility();
    visibleQuestions.result2 = !answerAllVisibility();
    visibleQuestions.warning = !answerAllVisibility();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return !answerAllVisibility();
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r;
    var fridericiaResult = 0;
    var bazettResult = 0;
    if (helpers_1.isAnswered(inputs.inputType) &&
        helpers_1.isAnswered(inputs.qtInterval) &&
        ((_a = inputs.qtInterval) === null || _a === void 0 ? void 0 : _a.currentPoints) >= 0 &&
        ((_b = inputs.qtInterval) === null || _b === void 0 ? void 0 : _b.currentPoints) <= 30000) {
        if (((_c = inputs.inputType) === null || _c === void 0 ? void 0 : _c.currentPoints) === 0 &&
            helpers_1.isAnswered(inputs.heartRate) &&
            ((_d = inputs.heartRate) === null || _d === void 0 ? void 0 : _d.currentPoints) >= 20 &&
            ((_e = inputs.heartRate) === null || _e === void 0 ? void 0 : _e.currentPoints) <= 300) {
            fridericiaResult = helpers_1.formatCalculationResult(Number((_f = inputs.qtInterval) === null || _f === void 0 ? void 0 : _f.currentPoints) /
                Math.cbrt(60 / Number((_g = inputs.heartRate) === null || _g === void 0 ? void 0 : _g.currentPoints)));
            bazettResult = helpers_1.formatCalculationResult(Number((_h = inputs.qtInterval) === null || _h === void 0 ? void 0 : _h.currentPoints) /
                Math.sqrt(60 / Number((_j = inputs.heartRate) === null || _j === void 0 ? void 0 : _j.currentPoints)));
        }
        else if (((_k = inputs.inputType) === null || _k === void 0 ? void 0 : _k.currentPoints) === 1 &&
            helpers_1.isAnswered(inputs.rrInterval) &&
            ((_l = inputs.rrInterval) === null || _l === void 0 ? void 0 : _l.currentPoints) >= 200 &&
            ((_m = inputs.rrInterval) === null || _m === void 0 ? void 0 : _m.currentPoints) <= 3000) {
            fridericiaResult = helpers_1.formatCalculationResult(Number((_o = inputs.qtInterval) === null || _o === void 0 ? void 0 : _o.currentPoints) /
                Math.cbrt(Number((_p = inputs.rrInterval) === null || _p === void 0 ? void 0 : _p.currentPoints) / 1000));
            bazettResult = helpers_1.formatCalculationResult(Number((_q = inputs.qtInterval) === null || _q === void 0 ? void 0 : _q.currentPoints) /
                Math.sqrt(Number((_r = inputs.rrInterval) === null || _r === void 0 ? void 0 : _r.currentPoints) / 1000));
        }
    }
    return {
        number: 0,
        range: 0,
        answerAll: {
            qID: "answerAll",
            titleTexts: "default"
        },
        result1: {
            qID: "result1",
            tParams: [
                {
                    type: "string",
                    value: fridericiaResult.toFixed(0)
                },
            ],
            titleTexts: "default"
        },
        result2: {
            qID: "result2",
            tParams: [
                {
                    type: "string",
                    value: bazettResult.toFixed(0)
                },
            ],
            titleTexts: "default"
        },
        warning: {
            qID: "warning",
            resultTexts: "default"
        }
    };
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
