"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};


var visibleQuestions = {
    absolute: true,
    nodes: true,
    spleen: true,
    liver: true,
    anemia: true,
    thrombocytopenia: true
};
var visibleSections = {
    inputs: true
};
var inputs = {
    absolute: null,
    nodes: null,
    spleen: null,
    liver: null,
    anemia: null,
    thrombocytopenia: null
};
var isAnswerAllVisible = function () {
    return (helpers_1.answerMatches(inputs.absolute, 'no') &&
        helpers_1.isAnswered(inputs.nodes) &&
        helpers_1.isAnswered(inputs.spleen) &&
        helpers_1.isAnswered(inputs.liver) &&
        helpers_1.isAnswered(inputs.anemia) &&
        helpers_1.isAnswered(inputs.thrombocytopenia));
};
var isLowRiskVisible = function () {
    return (helpers_1.answerMatches(inputs.absolute, 'yes') &&
        helpers_1.answerMatches(inputs.nodes, 'no') &&
        helpers_1.answerMatches(inputs.spleen, 'no') &&
        helpers_1.answerMatches(inputs.liver, 'no') &&
        helpers_1.answerMatches(inputs.anemia, 'no') &&
        helpers_1.answerMatches(inputs.thrombocytopenia, 'no'));
};
var isIntermediateRisk1Visible = function () {
    return (helpers_1.answerMatches(inputs.absolute, 'yes') &&
        helpers_1.answerMatches(inputs.nodes, 'yes') &&
        helpers_1.answerMatches(inputs.spleen, 'no') &&
        helpers_1.answerMatches(inputs.liver, 'no') &&
        helpers_1.answerMatches(inputs.anemia, 'no') &&
        helpers_1.answerMatches(inputs.thrombocytopenia, 'no'));
};
var isIntermediateRisk2Visible = function () {
    return ((helpers_1.answerMatches(inputs.absolute, 'yes') &&
        helpers_1.isAnswered(inputs.nodes) &&
        helpers_1.answerMatches(inputs.liver, 'yes') &&
        helpers_1.answerMatches(inputs.spleen, 'no') &&
        helpers_1.answerMatches(inputs.anemia, 'no') &&
        helpers_1.answerMatches(inputs.thrombocytopenia, 'no')) ||
        (helpers_1.answerMatches(inputs.absolute, 'yes') &&
            helpers_1.isAnswered(inputs.nodes) &&
            helpers_1.answerMatches(inputs.spleen, 'yes') &&
            helpers_1.answerMatches(inputs.liver, 'no') &&
            helpers_1.answerMatches(inputs.anemia, 'no') &&
            helpers_1.answerMatches(inputs.thrombocytopenia, 'no')) ||
        (helpers_1.answerMatches(inputs.absolute, 'yes') &&
            helpers_1.isAnswered(inputs.nodes) &&
            helpers_1.answerMatches(inputs.spleen, 'yes') &&
            helpers_1.answerMatches(inputs.liver, 'yes') &&
            helpers_1.answerMatches(inputs.anemia, 'no') &&
            helpers_1.answerMatches(inputs.thrombocytopenia, 'no')));
};
var isHighRisk3Visible = function () {
    return (helpers_1.answerMatches(inputs.absolute, 'yes') &&
        helpers_1.answerMatches(inputs.anemia, 'yes') &&
        helpers_1.isAnswered(inputs.nodes) &&
        helpers_1.isAnswered(inputs.spleen) &&
        helpers_1.isAnswered(inputs.liver) &&
        helpers_1.answerMatches(inputs.thrombocytopenia, 'no'));
};
var isHighRisk4Visible = function () {
    return (helpers_1.answerMatches(inputs.absolute, 'yes') &&
        helpers_1.answerMatches(inputs.thrombocytopenia, 'yes') &&
        helpers_1.isAnswered(inputs.nodes) &&
        helpers_1.isAnswered(inputs.spleen) &&
        helpers_1.isAnswered(inputs.liver) &&
        helpers_1.isAnswered(inputs.anemia));
};
var calculatePoints = function () {
    var resultById = 'notDefined';
    if (isAnswerAllVisible()) {
        resultById = 'notDefined';
    }
    if (isLowRiskVisible()) {
        resultById = 'lowRisk';
    }
    if (isIntermediateRisk1Visible()) {
        resultById = 'intermediateRisk1';
    }
    if (isIntermediateRisk2Visible()) {
        resultById = 'intermediateRisk2';
    }
    if (isHighRisk3Visible()) {
        resultById = 'highRisk3';
    }
    if (isHighRisk4Visible()) {
        resultById = 'highRisk4';
    }
    return helpers_1.returnToolScoreObject({
        number: 1,
        range: 1,
        resultById: resultById
    });
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_toolScore = function () {
    return calculatePoints();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return true;
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return __assign({ exportResultsEnabled: isExportResultsEnabled(), visibleQuestions: ut_visibleQuestions(), visibleSections: ut_visibleSections() }, result);
});
