"use strict";


var visibleQuestions = {
    coindication: true,
    contraindications: false,
    answerAll: true,
    result1: false,
    result2: false,
    result3: false
};
var visibleSections = {
    main: true,
    answerAllSection: true,
    results: false
};
var inputs = {
    coindication: null,
    contraindications: null
};
var isContraindicationsNegative = function () {
    return helpers_1.answerMatches(inputs.coindication, 'no');
};
var isResult1Visible = function () {
    return (helpers_1.answerMatches(inputs.coindication, 'yes') ||
        helpers_1.answerMatches(inputs.contraindications, 'yes'));
};
var isResult2Visible = function () {
    return (isContraindicationsNegative() &&
        helpers_1.answerMatches(inputs.contraindications, 'no'));
};
var areResultsVisible = function () {
    return isResult1Visible() || isResult2Visible();
};
var returnVisibleQuestions = function () {
    visibleQuestions.contraindications = isContraindicationsNegative();
    visibleQuestions.answerAll = !areResultsVisible();
    visibleQuestions.result1 = isResult1Visible();
    visibleQuestions.result2 = isResult2Visible();
    visibleQuestions.result3 = isResult2Visible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.answerAllSection = !areResultsVisible();
    visibleSections.results = areResultsVisible();
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return areResultsVisible();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
