"use strict";


var visibleSections = {
    specialPatientGroups: true,
    noAnswer: false,
    dosingLowGFR: false,
    dosingSevere: false,
    dosingOk: false
};
var visibleQuestions = {
    gfr: true,
    noAnswerResult: true,
    doseLowGFR: true,
    doseSevere: true,
    durationSevere: true,
    doseLow: true,
    durationLow: true
};
var inputs = {
    gfr: null
};
var isNoAnswerSectionVisible = function () {
    return !helpers_1.isAnswered(inputs.gfr);
};
var isDosingLowGFRSectionVisible = function () {
    return helpers_1.answerMatches(inputs.gfr, 'verySevere');
};
var isDosingSevereSectionVisible = function () {
    return helpers_1.answerMatches(inputs.gfr, 'severe');
};
var isDosingOkSectionVisible = function () {
    return helpers_1.answerMatches(inputs.gfr, 'ok');
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = isNoAnswerSectionVisible();
    visibleSections.dosingLowGFR = isDosingLowGFRSectionVisible();
    visibleSections.dosingSevere = isDosingSevereSectionVisible();
    visibleSections.dosingOk = isDosingOkSectionVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return helpers_1.isAnswered(inputs.gfr);
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
