"use strict";


var visibleSections = {
    specialPatientGroups: true,
    noAnswer: false,
    dosingLowGFR: false,
    dosingShort: false,
    dosingLong: false
};
var visibleQuestions = {
    group: true,
    gfr: false,
    noAnswerResult: true,
    doseLowGFR: true,
    doseShortA: true,
    doseShortB1: false,
    doseShortB2: false,
    durationShort: true,
    doseLongA: true,
    doseLongB1: false,
    doseLongB2: false,
    durationLong: true
};
var inputs = {
    group: null,
    gfr: null
};
var isGfrVisible = function () {
    return helpers_1.isAnswered(inputs.group);
};
var isDoseShortB1Visible = function () {
    return helpers_1.answerMatches(inputs.gfr, 'ok');
};
var isDoseShortB2Visible = function () {
    return helpers_1.answerMatches(inputs.gfr, 'severe');
};
var isDoseLongB1Visible = function () {
    return helpers_1.answerMatches(inputs.gfr, 'ok');
};
var isDoseLongB2Visible = function () {
    return helpers_1.answerMatches(inputs.gfr, 'severe');
};
var isNoAnswerSectionVisible = function () {
    return !(helpers_1.isAnswered(inputs.group) && helpers_1.isAnswered(inputs.gfr));
};
var isDosingLowGFRSectionVisible = function () {
    return helpers_1.answerMatches(inputs.gfr, 'verySevere');
};
var isDosingShortSectionVisible = function () {
    return (helpers_1.answerMatches(inputs.group, 'riskfactor') &&
        (helpers_1.answerMatches(inputs.gfr, 'severe') || helpers_1.answerMatches(inputs.gfr, 'ok')));
};
var isDosingLongSectionVisible = function () {
    return (helpers_1.answerMatches(inputs.group, 'other') &&
        (helpers_1.answerMatches(inputs.gfr, 'severe') || helpers_1.answerMatches(inputs.gfr, 'ok')));
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.gfr = isGfrVisible();
    visibleQuestions.doseShortB1 = isDoseShortB1Visible();
    visibleQuestions.doseShortB2 = isDoseShortB2Visible();
    visibleQuestions.doseLongB1 = isDoseLongB1Visible();
    visibleQuestions.doseLongB2 = isDoseLongB2Visible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = isNoAnswerSectionVisible();
    visibleSections.dosingLowGFR = isDosingLowGFRSectionVisible();
    visibleSections.dosingShort = isDosingShortSectionVisible();
    visibleSections.dosingLong = isDosingLongSectionVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return helpers_1.isAnswered(inputs.group) && helpers_1.isAnswered(inputs.gfr);
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
