"use strict";


var visibleSections = {
    specialPatientGroups: true,
    noAnswer: false,
    dosingLowGFR: false,
    dosingHip: false,
    dosingKnee: false
};
var visibleQuestions = {
    operation: true,
    gfr: false,
    noAnswerResult: true,
    doseLowGFR: true,
    doseHip: true,
    durationHip: true,
    warningHipSevere: false,
    doseKnee: true,
    durationKnee: true,
    warningKneeSevere: false
};
var inputs = {
    operation: null,
    gfr: null
};
var isGfrVisible = function () {
    return helpers_1.isAnswered(inputs.operation);
};
var isWarningHipSevereVisible = function () {
    return helpers_1.answerMatches(inputs.gfr, 'severe');
};
var isWarningKneeSevereVisible = function () {
    return helpers_1.answerMatches(inputs.gfr, 'severe');
};
var isNoAnswerSectionVisible = function () {
    return !(helpers_1.isAnswered(inputs.operation) && helpers_1.isAnswered(inputs.gfr));
};
var isDosingLowGFRSectionVisible = function () {
    return helpers_1.answerMatches(inputs.gfr, 'verySevere');
};
var isDosingHipSectionVisible = function () {
    return (helpers_1.answerMatches(inputs.operation, 'hip') &&
        (helpers_1.answerMatches(inputs.gfr, 'severe') || helpers_1.answerMatches(inputs.gfr, 'ok')));
};
var isDosingKneeSectionVisible = function () {
    return (helpers_1.answerMatches(inputs.operation, 'knee') &&
        (helpers_1.answerMatches(inputs.gfr, 'severe') || helpers_1.answerMatches(inputs.gfr, 'ok')));
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.gfr = isGfrVisible();
    visibleQuestions.warningHipSevere = isWarningHipSevereVisible();
    visibleQuestions.warningKneeSevere = isWarningKneeSevereVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = isNoAnswerSectionVisible();
    visibleSections.dosingLowGFR = isDosingLowGFRSectionVisible();
    visibleSections.dosingHip = isDosingHipSectionVisible();
    visibleSections.dosingKnee = isDosingKneeSectionVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return helpers_1.isAnswered(inputs.operation) && helpers_1.isAnswered(inputs.gfr);
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
