"use strict";


var visibleSections = {
    specialPatientGroups: true,
    noAnswer: false,
    warnings: false,
    dosingOver50: false,
    dosingOver30: false,
    powderA: false,
    powderB: false,
    powderC: false,
    powderD: false,
    powderE: false,
    powderF: false,
    powderG: false,
    powderH: false,
    powderI: false,
    powderJ: false,
    powderK: false,
    kidney: false
};
var visibleQuestions = {
    weight: true,
    cath: false,
    noAnswerResult: true,
    warningLarge: false,
    warningSmall: false,
    warningWeight: true,
    doseOver50: true,
    durationOver50: true,
    doseOver30: true,
    durationOver30: true,
    dosePowderA: true,
    durationPowderA1: false,
    durationPowderA2: false,
    dosePowderB: true,
    durationPowderB1: false,
    durationPowderB2: false,
    dosePowderC: true,
    durationPowderC1: false,
    durationPowderC2: false,
    dosePowderD: true,
    durationPowderD1: false,
    durationPowderD2: false,
    dosePowderE: true,
    durationPowderE1: false,
    durationPowderE2: false,
    dosePowderF: true,
    durationPowderF1: false,
    durationPowderF2: false,
    dosePowderG: true,
    durationPowderG1: false,
    durationPowderG2: false,
    dosePowderH: true,
    durationPowderH1: false,
    durationPowderH2: false,
    dosePowderI: true,
    durationPowderI1: false,
    durationPowderI2: false,
    dosePowderJ: true,
    durationPowderJ: true,
    dosePowderK: true,
    durationPowderK: true,
    kidney1: true,
    kidney2: true,
    kidney3: false
};
var inputs = {
    weight: null,
    cath: null
};
var isCathVisible = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 2.6, max: 19.9999 });
};
var isWarningLargeVisible = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 12, max: 150 });
};
var isWarningSmallVisible = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 2.6, max: 11.9999 });
};
var isCathYes = function () {
    return helpers_1.answerMatches(inputs.cath, 'yes');
};
var isCathNo = function () {
    return helpers_1.answerMatches(inputs.cath, 'no');
};
var isdurationPowderI1Visible = function () {
    return ((isCathVisible() && isCathNo()) ||
        helpers_1.numberInLimits({ input: inputs.weight, min: 20, max: 29.999 }));
};
var isdurationPowderI2Visible = function () {
    return isCathVisible() && isCathYes();
};
var isKidney3Visible = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 2.6, max: 14.9999 });
};
var areAllVisibleSectionsAnswered = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 2.6, max: 150 }) &&
        ((isCathVisible() && helpers_1.isAnswered(inputs.cath)) || !isCathVisible()));
};
var isNoAnswerSectionVisible = function () {
    return !areAllVisibleSectionsAnswered();
};
var isWarningsSectionVisible = function () {
    return areAllVisibleSectionsAnswered();
};
var isDosingOver50SectionVisible = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 50, max: 150 });
};
var isDosingOver30SectionVisible = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 30, max: 49.9999 });
};
var isPowderASectionVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 2.6, max: 2.9999 }) &&
        helpers_1.isAnswered(inputs.cath));
};
var isPowderBSectionVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 3, max: 3.9999 }) &&
        helpers_1.isAnswered(inputs.cath));
};
var isPowderCSectionVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 4, max: 4.9999 }) &&
        helpers_1.isAnswered(inputs.cath));
};
var isPowderDSectionVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 5, max: 6.9999 }) &&
        helpers_1.isAnswered(inputs.cath));
};
var isPowderESectionVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 7, max: 7.9999 }) &&
        helpers_1.isAnswered(inputs.cath));
};
var isPowderFSectionVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 8, max: 8.9999 }) &&
        helpers_1.isAnswered(inputs.cath));
};
var isPowderGSectionVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 9, max: 9.9999 }) &&
        helpers_1.isAnswered(inputs.cath));
};
var isPowderHSectionVisible = function () {
    return (helpers_1.numberInLimits({ input: inputs.weight, min: 10, max: 11.9999 }) &&
        helpers_1.isAnswered(inputs.cath));
};
var isPowderISectionVisible = function () {
    if (isCathVisible()) {
        return (helpers_1.numberInLimits({ input: inputs.weight, min: 12, max: 29.9999 }) &&
            helpers_1.isAnswered(inputs.cath));
    }
    return helpers_1.numberInLimits({ input: inputs.weight, min: 12, max: 29.9999 });
};
var isPowderJSectionVisible = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 30, max: 49.9999 });
};
var isPowderKSectionVisible = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 50, max: 150 });
};
var isKidneySectionVisible = function () {
    return areAllVisibleSectionsAnswered();
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.cath = isCathVisible();
    visibleQuestions.warningLarge = isWarningLargeVisible();
    visibleQuestions.warningSmall = isWarningSmallVisible();
    visibleQuestions.durationPowderA1 = isCathNo();
    visibleQuestions.durationPowderA2 = isCathYes();
    visibleQuestions.durationPowderB1 = isCathNo();
    visibleQuestions.durationPowderB2 = isCathYes();
    visibleQuestions.durationPowderC1 = isCathNo();
    visibleQuestions.durationPowderC2 = isCathYes();
    visibleQuestions.durationPowderD1 = isCathNo();
    visibleQuestions.durationPowderD2 = isCathYes();
    visibleQuestions.durationPowderE1 = isCathNo();
    visibleQuestions.durationPowderE2 = isCathYes();
    visibleQuestions.durationPowderF1 = isCathNo();
    visibleQuestions.durationPowderF2 = isCathYes();
    visibleQuestions.durationPowderG1 = isCathNo();
    visibleQuestions.durationPowderG2 = isCathYes();
    visibleQuestions.durationPowderH1 = isCathNo();
    visibleQuestions.durationPowderH2 = isCathYes();
    visibleQuestions.durationPowderI1 = isdurationPowderI1Visible();
    visibleQuestions.durationPowderI2 = isdurationPowderI2Visible();
    visibleQuestions.kidney3 = isKidney3Visible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = isNoAnswerSectionVisible();
    visibleSections.warnings = isWarningsSectionVisible();
    visibleSections.dosingOver50 = isDosingOver50SectionVisible();
    visibleSections.dosingOver30 = isDosingOver30SectionVisible();
    visibleSections.powderA = isPowderASectionVisible();
    visibleSections.powderB = isPowderBSectionVisible();
    visibleSections.powderC = isPowderCSectionVisible();
    visibleSections.powderD = isPowderDSectionVisible();
    visibleSections.powderE = isPowderESectionVisible();
    visibleSections.powderF = isPowderFSectionVisible();
    visibleSections.powderG = isPowderGSectionVisible();
    visibleSections.powderH = isPowderHSectionVisible();
    visibleSections.powderI = isPowderISectionVisible();
    visibleSections.powderJ = isPowderJSectionVisible();
    visibleSections.powderK = isPowderKSectionVisible();
    visibleSections.kidney = isKidneySectionVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return areAllVisibleSectionsAnswered();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
