"use strict";


var visibleSections = {
    specialPatientGroups: true,
    noAnswer: false,
    dosingLowGFR: false,
    dosingA: false,
    dosingB: false
};
var visibleQuestions = {
    gfr: true,
    highrisk: false,
    noAnswerResult: true,
    doseLowGFR: true,
    dose1: true,
    duration1: true,
    dose2A: false,
    warning: false,
    duration2: true
};
var inputs = {
    group: null,
    gfr: null
};
var isHighriskVisible = function () {
    return helpers_1.answerMatches(inputs.gfr, 'ok') || helpers_1.answerMatches(inputs.gfr, 'severe');
};
var isDose2AVisible = function () {
    return helpers_1.answerMatches(inputs.gfr, 'ok') || helpers_1.answerMatches(inputs.gfr, 'severe');
};
var isWarningVisible = function () {
    return helpers_1.answerMatches(inputs.gfr, 'severe');
};
var areAllVisibleSectionsAnswered = function () {
    return (helpers_1.isAnswered(inputs.gfr) &&
        ((isHighriskVisible() && helpers_1.isAnswered(inputs.highrisk)) ||
            !isHighriskVisible()));
};
var isDosingLowGFRSectionVisible = function () {
    return helpers_1.answerMatches(inputs.gfr, 'verySevere');
};
var isDosingASectionVisible = function () {
    return helpers_1.answerMatches(inputs.highrisk, 'no');
};
var isDosingBSectionVisible = function () {
    return helpers_1.answerMatches(inputs.highrisk, 'yes');
};
var calculatePoints = function () {
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.highrisk = isHighriskVisible();
    visibleQuestions.dose2A = isDose2AVisible();
    visibleQuestions.warning = isWarningVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = !areAllVisibleSectionsAnswered();
    visibleSections.dosingLowGFR = isDosingLowGFRSectionVisible();
    visibleSections.dosingA = isDosingASectionVisible();
    visibleSections.dosingB = isDosingBSectionVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return areAllVisibleSectionsAnswered();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
