"use strict";


var visibleQuestions = {
    age: true,
    headNeck: true,
    upperLeft: true,
    upperRight: true,
    lowerLeft: true,
    lowerRight: true,
    trunk: true,
    back: true,
    genitals: true,
    erythema: true,
    edema: true,
    oozing: true,
    excoriation: true,
    lichenification: true,
    dryness: true,
    itch: true,
    sleeplessness: true,
    answerAll: true,
    mild: false,
    moderate: false,
    severe: false,
    scoradLinkQuestion: false
};
var visibleSections = {
    emailSection: false
};
var inputs = {
    age: null,
    headNeck: null,
    upperLeft: null,
    upperRight: null,
    lowerLeft: null,
    lowerRight: null,
    trunk: null,
    back: null,
    genitals: null,
    erythema: null,
    edema: null,
    oozing: null,
    excoriation: null,
    lichenification: null,
    dryness: null,
    itch: null,
    sleeplessness: null
};
var scoradPoints = function () {
    var areaSectionRes = areaSection();
    var instensitySectionRes = instensitySection();
    var symptomsSectionRes = symptomsSection();
    if (areaSectionRes == null ||
        instensitySectionRes == null ||
        symptomsSectionRes == null)
        return null;
    return (areaSectionRes / 5 + (7 * instensitySectionRes) / 2 + symptomsSectionRes);
};
var areaSection = function () {
    var _a, _b;
    if (!helpers_1.isAnswered(inputs.age) ||
        !helpers_1.isAnswered(inputs.headNeck) ||
        !helpers_1.isAnswered(inputs.upperLeft) ||
        !helpers_1.isAnswered(inputs.upperRight) ||
        !helpers_1.isAnswered(inputs.lowerLeft) ||
        !helpers_1.isAnswered(inputs.lowerRight) ||
        !helpers_1.isAnswered(inputs.trunk) ||
        !helpers_1.isAnswered(inputs.back) ||
        !helpers_1.isAnswered(inputs.genitals))
        return null;
    var headMod = ((_a = inputs.age) == null || _a == void 0 ? void 0 : _a.currentIdentifier) == "more2" ? 1.0 : 17 / 9;
    var lowerMod = ((_b = inputs.age) == null || _b == void 0 ? void 0 : _b.currentIdentifier) == "more2" ? 1.0 : 14 / 18;
    return (inputs.headNeck.currentPoints * headMod +
        inputs.upperLeft.currentPoints +
        inputs.upperRight.currentPoints +
        (inputs.lowerLeft.currentPoints + inputs.lowerRight.currentPoints) *
            lowerMod +
        inputs.trunk.currentPoints +
        inputs.back.currentPoints +
        inputs.genitals.currentPoints);
};
var instensitySection = function () {
    if (!helpers_1.isAnswered(inputs.erythema) ||
        !helpers_1.isAnswered(inputs.edema) ||
        !helpers_1.isAnswered(inputs.oozing) ||
        !helpers_1.isAnswered(inputs.excoriation) ||
        !helpers_1.isAnswered(inputs.lichenification) ||
        !helpers_1.isAnswered(inputs.dryness))
        return null;
    return (inputs.erythema.currentPoints +
        inputs.edema.currentPoints +
        inputs.oozing.currentPoints +
        inputs.excoriation.currentPoints +
        inputs.lichenification.currentPoints +
        inputs.dryness.currentPoints);
};
var symptomsSection = function () {
    if (!helpers_1.isAnswered(inputs.itch) || !helpers_1.isAnswered(inputs.sleeplessness))
        return null;
    return inputs.itch.currentPoints + inputs.sleeplessness.currentPoints;
};
var answerAllVisibility = function () {
    if (scoradPoints() == null) {
        return true;
    }
    return false;
};
var mildVisibility = function () {
    var scoradPointsRes = scoradPoints();
    if (scoradPointsRes == null)
        return false;
    if (scoradPointsRes < 25.0)
        return true;
    return false;
};
var moderateVisibility = function () {
    var scoradPointsRes = scoradPoints();
    if (scoradPointsRes == null)
        return false;
    if (scoradPointsRes >= 25.0 && scoradPointsRes <= 50.0)
        return true;
    return false;
};
var severeVisibility = function () {
    var scoradPointsRes = scoradPoints();
    if (scoradPointsRes == null)
        return false;
    if (scoradPointsRes > 50.0)
        return true;
    return false;
};
var scoradLinkQuestionVisibility = function () {
    return !answerAllVisibility();
};
var emailSectionVisibility = function () {
    return !answerAllVisibility();
};
var returnVisibleQuestions = function () {
    visibleQuestions.answerAll = answerAllVisibility();
    visibleQuestions.mild = mildVisibility();
    visibleQuestions.moderate = moderateVisibility();
    visibleQuestions.severe = severeVisibility();
    visibleQuestions.scoradLinkQuestion = scoradLinkQuestionVisibility();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.emailSection = emailSectionVisibility();
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    return {
        result: scoradPoints(),
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
