"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};



var visibleQuestions = {
    sex: true,
    age: false,
    smoking: false,
    bloodPressure: false,
    cholesterol: false,
    answerAll: true,
    results21: false,
    results22: false,
    results23: false,
    results31: false,
    results32: false,
    results33: false,
    results41: false,
    results42: false,
    results43: false
};
var visibleSections = {
    section1: true,
    results1: true,
    results2: false,
    results3: false,
    results4: false
};
var inputs = {
    sex: null,
    age: null,
    smoking: null,
    bloodPressure: null,
    cholesterol: null
};
var scoreMatrix = [
    [
        [
            [
                [2, 2, 3, 3],
                [1, 2, 2, 2],
                [1, 1, 1, 2],
                [1, 1, 1, 1],
            ],
            [
                [5, 5, 6, 7],
                [3, 4, 5, 5],
                [3, 3, 3, 4],
                [2, 2, 2, 3],
            ],
        ],
        [
            [
                [3, 3, 3, 4],
                [2, 2, 3, 3],
                [2, 2, 2, 2],
                [1, 1, 1, 2],
            ],
            [
                [6, 7, 8, 9],
                [5, 5, 6, 6],
                [3, 4, 4, 5],
                [3, 3, 3, 4],
            ],
        ],
        [
            [
                [4, 4, 5, 5],
                [3, 3, 4, 4],
                [2, 2, 3, 3],
                [2, 2, 2, 2],
            ],
            [
                [8, 8, 9, 10],
                [6, 6, 7, 8],
                [5, 5, 6, 6],
                [3, 4, 4, 5],
            ],
        ],
        [
            [
                [5, 6, 6, 7],
                [4, 4, 5, 5],
                [3, 3, 4, 4],
                [3, 3, 3, 3],
            ],
            [
                [10, 11, 11, 12],
                [8, 8, 9, 10],
                [6, 7, 7, 8],
                [5, 5, 6, 6],
            ],
        ],
        [
            [
                [7, 8, 8, 9],
                [6, 6, 7, 7],
                [5, 5, 5, 6],
                [4, 4, 4, 5],
            ],
            [
                [12, 13, 14, 15],
                [10, 11, 11, 12],
                [8, 9, 9, 10],
                [6, 7, 7, 8],
            ],
        ],
        [
            [
                [10, 10, 11, 12],
                [8, 9, 9, 9],
                [7, 7, 7, 8],
                [5, 6, 6, 6],
            ],
            [
                [15, 16, 17, 18],
                [13, 13, 14, 15],
                [10, 11, 12, 12],
                [9, 9, 9, 10],
            ],
        ],
        [
            [
                [13, 14, 15, 16],
                [11, 11, 12, 13],
                [9, 9, 10, 11],
                [7, 7, 8, 8],
            ],
            [
                [22, 23, 25, 26],
                [18, 19, 20, 22],
                [15, 16, 17, 18],
                [12, 13, 13, 14],
            ],
        ],
        [
            [
                [19, 20, 21, 23],
                [16, 17, 18, 19],
                [14, 15, 15, 16],
                [12, 12, 13, 14],
            ],
            [
                [27, 29, 30, 32],
                [24, 25, 26, 28],
                [20, 21, 22, 24],
                [17, 18, 19, 20],
            ],
        ],
        [
            [
                [27, 28, 30, 31],
                [24, 25, 27, 28],
                [21, 22, 24, 25],
                [19, 20, 21, 22],
            ],
            [
                [34, 35, 37, 39],
                [30, 32, 33, 35],
                [27, 28, 30, 31],
                [24, 25, 27, 28],
            ],
        ],
        [
            [
                [37, 39, 40, 42],
                [35, 36, 38, 39],
                [32, 34, 35, 37],
                [30, 32, 33, 34],
            ],
            [
                [41, 43, 44, 46],
                [39, 40, 42, 43],
                [36, 38, 39, 41],
                [34, 35, 37, 38],
            ],
        ],
    ],
    [
        [
            [
                [4, 5, 6, 7],
                [3, 4, 4, 5],
                [2, 3, 3, 4],
                [2, 2, 2, 3],
            ],
            [
                [8, 9, 11, 13],
                [6, 7, 8, 10],
                [4, 5, 6, 8],
                [3, 4, 5, 6],
            ],
        ],
        [
            [
                [5, 6, 7, 8],
                [4, 5, 5, 6],
                [3, 4, 4, 5],
                [2, 3, 3, 4],
            ],
            [
                [9, 11, 13, 15],
                [7, 8, 10, 12],
                [5, 7, 8, 9],
                [4, 5, 6, 7],
            ],
        ],
        [
            [
                [7, 8, 9, 10],
                [5, 6, 7, 8],
                [4, 5, 5, 6],
                [3, 4, 4, 5],
            ],
            [
                [11, 13, 15, 17],
                [9, 10, 12, 14],
                [7, 8, 9, 11],
                [5, 6, 7, 8],
            ],
        ],
        [
            [
                [9, 10, 11, 12],
                [7, 8, 9, 10],
                [5, 6, 7, 8],
                [4, 5, 6, 6],
            ],
            [
                [14, 16, 17, 20],
                [11, 13, 14, 16],
                [9, 10, 11, 13],
                [7, 8, 9, 10],
            ],
        ],
        [
            [
                [11, 12, 13, 15],
                [9, 10, 11, 12],
                [7, 8, 9, 10],
                [6, 7, 7, 8],
            ],
            [
                [17, 18, 20, 22],
                [14, 15, 17, 18],
                [11, 13, 14, 15],
                [9, 10, 11, 12],
            ],
        ],
        [
            [
                [14, 15, 17, 18],
                [12, 13, 14, 15],
                [10, 11, 12, 13],
                [8, 9, 10, 10],
            ],
            [
                [20, 22, 23, 25],
                [17, 18, 20, 21],
                [14, 15, 17, 18],
                [12, 13, 14, 15],
            ],
        ],
        [
            [
                [19, 21, 23, 25],
                [15, 17, 18, 20],
                [12, 13, 15, 16],
                [10, 11, 12, 13],
            ],
            [
                [28, 31, 34, 36],
                [23, 25, 28, 30],
                [19, 20, 22, 24],
                [15, 16, 18, 20],
            ],
        ],
        [
            [
                [24, 27, 31, 35],
                [21, 23, 27, 30],
                [17, 20, 23, 26],
                [15, 17, 19, 22],
            ],
            [
                [31, 35, 39, 44],
                [27, 30, 34, 38],
                [23, 26, 29, 33],
                [19, 22, 25, 29],
            ],
        ],
        [
            [
                [30, 35, 41, 47],
                [27, 32, 37, 43],
                [25, 29, 34, 40],
                [22, 26, 31, 36],
            ],
            [
                [34, 40, 46, 53],
                [31, 36, 42, 48],
                [28, 33, 38, 44],
                [25, 30, 35, 40],
            ],
        ],
        [
            [
                [37, 45, 53, 62],
                [36, 43, 51, 59],
                [34, 41, 49, 57],
                [32, 39, 47, 55],
            ],
            [
                [37, 45, 53, 61],
                [35, 43, 51, 59],
                [34, 41, 48, 57],
                [32, 39, 46, 55],
            ],
        ],
    ],
];
var getAgeIndex = function (age) {
    if (age <= 44) {
        return 0;
    }
    if (age >= 45 && age <= 49) {
        return 1;
    }
    if (age >= 50 && age <= 54) {
        return 2;
    }
    if (age >= 55 && age <= 59) {
        return 3;
    }
    if (age >= 60 && age <= 64) {
        return 4;
    }
    if (age >= 65 && age <= 69) {
        return 5;
    }
    if (age >= 70 && age <= 74) {
        return 6;
    }
    if (age >= 75 && age <= 79) {
        return 7;
    }
    if (age >= 80 && age <= 84) {
        return 8;
    }
    return 9;
};
var getBloodPressureIndex = function (bloodPressure) {
    if (bloodPressure === 'pressure1') {
        return 3;
    }
    if (bloodPressure === 'pressure2') {
        return 2;
    }
    if (bloodPressure === 'pressure3') {
        return 1;
    }
    return 0;
};
var getCholesterolIndex = function (cholesterol) {
    if (cholesterol === 'three') {
        return 0;
    }
    if (cholesterol === 'four') {
        return 1;
    }
    if (cholesterol === 'five') {
        return 2;
    }
    return 3;
};
var isSmokingVisible = function () {
    return (helpers_1.isAnswered(inputs.age) &&
        Number(inputs.age.currentPoints) >= 40 &&
        Number(inputs.age.currentPoints) <= 89);
};
var isResults21Visible = function () {
    if (!isResults2Visible()) {
        return false;
    }
    var score = calculateScore();
    return score < 2.5;
};
var isResults22Visible = function () {
    if (!isResults2Visible()) {
        return false;
    }
    var score = calculateScore();
    return score >= 2.5 && score < 7.5;
};
var isResults23Visible = function () {
    if (!isResults2Visible()) {
        return false;
    }
    var score = calculateScore();
    return score >= 7.5;
};
var isResults2Visible = function () {
    if (!areAllQuestionsAnswered()) {
        return false;
    }
    return helpers_1.numberInLimits({ input: inputs.age, max: 49 });
};
var isResults31Visible = function () {
    if (!isResults3Visible()) {
        return false;
    }
    var score = calculateScore();
    return score < 5;
};
var isResults32Visible = function () {
    if (!isResults3Visible()) {
        return false;
    }
    var score = calculateScore();
    return score >= 5 && score < 10;
};
var isResults33Visible = function () {
    if (!isResults3Visible()) {
        return false;
    }
    var score = calculateScore();
    return score >= 10;
};
var isResults3Visible = function () {
    if (!areAllQuestionsAnswered()) {
        return false;
    }
    return helpers_1.numberInLimits({ input: inputs.age, min: 50, max: 69 });
};
var isResults41Visible = function () {
    if (!isResults4Visible()) {
        return false;
    }
    var score = calculateScore();
    return score < 7.5;
};
var isResults42Visible = function () {
    if (!isResults4Visible()) {
        return false;
    }
    var score = calculateScore();
    return score >= 7.5 && score < 15;
};
var isResults43Visible = function () {
    if (!isResults4Visible()) {
        return false;
    }
    var score = calculateScore();
    return score >= 15;
};
var isResults4Visible = function () {
    if (!areAllQuestionsAnswered()) {
        return false;
    }
    return helpers_1.numberInLimits({ input: inputs.age, min: 70 });
};
var returnVisibleQuestions = function () {
    visibleQuestions.age = helpers_1.isAnswered(inputs.sex);
    visibleQuestions.smoking = isSmokingVisible();
    visibleQuestions.bloodPressure = helpers_1.isAnswered(inputs.smoking);
    visibleQuestions.cholesterol = helpers_1.isAnswered(inputs.bloodPressure);
    visibleQuestions.answerAll = !areAllQuestionsAnswered();
    visibleQuestions.results21 = isResults21Visible();
    visibleQuestions.results22 = isResults22Visible();
    visibleQuestions.results23 = isResults23Visible();
    visibleQuestions.results31 = isResults31Visible();
    visibleQuestions.results32 = isResults32Visible();
    visibleQuestions.results33 = isResults33Visible();
    visibleQuestions.results41 = isResults41Visible();
    visibleQuestions.results42 = isResults42Visible();
    visibleQuestions.results43 = isResults43Visible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.results1 = !areAllQuestionsAnswered();
    visibleSections.results2 = isResults2Visible();
    visibleSections.results3 = isResults3Visible();
    visibleSections.results4 = isResults4Visible();
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var areAllQuestionsAnswered = function () {
    return (helpers_1.isAnswered(inputs.sex) &&
        helpers_1.isAnswered(inputs.age) &&
        helpers_1.isAnswered(inputs.smoking) &&
        helpers_1.isAnswered(inputs.bloodPressure) &&
        helpers_1.isAnswered(inputs.cholesterol));
};
var calculateScore = function () {
    var sexIndex = inputs.sex.currentPoints;
    var ageIndex = getAgeIndex(inputs.age.currentPoints);
    var smokingIndex = inputs.smoking.currentPoints;
    var bloodPressureIndex = getBloodPressureIndex(inputs.bloodPressure.currentIdentifier);
    var cholesterolIndex = getCholesterolIndex(inputs.cholesterol.currentIdentifier);
    return scoreMatrix[sexIndex][ageIndex][smokingIndex][bloodPressureIndex][cholesterolIndex];
};
var calculatePoints = function () {
    if (isResults2Visible()) {
        var score = calculateScore();
        if (isResults21Visible()) {
            return {
                results21: {
                    qID: 'results21',
                    tParams: __spreadArrays(helpers_1.returnNumberObject(score, 0, 1)),
                    titleTexts: 'regular'
                }
            };
        }
        if (isResults22Visible()) {
            return {
                results22: {
                    qID: 'results22',
                    tParams: __spreadArrays(helpers_1.returnNumberObject(score, 0, 1)),
                    titleTexts: 'regular'
                }
            };
        }
        if (isResults23Visible()) {
            return {
                results23: {
                    qID: 'results23',
                    tParams: __spreadArrays(helpers_1.returnNumberObject(score, 0, 1)),
                    titleTexts: 'regular'
                }
            };
        }
    }
    if (isResults3Visible()) {
        var score = calculateScore();
        if (isResults31Visible()) {
            return {
                results31: {
                    qID: 'results31',
                    tParams: __spreadArrays(helpers_1.returnNumberObject(score, 0, 1)),
                    titleTexts: 'regular'
                }
            };
        }
        if (isResults32Visible()) {
            return {
                results32: {
                    qID: 'results32',
                    tParams: __spreadArrays(helpers_1.returnNumberObject(score, 0, 1)),
                    titleTexts: 'regular'
                }
            };
        }
        if (isResults33Visible()) {
            return {
                results33: {
                    qID: 'results33',
                    tParams: __spreadArrays(helpers_1.returnNumberObject(score, 0, 1)),
                    titleTexts: 'regular'
                }
            };
        }
    }
    if (isResults4Visible()) {
        var score = calculateScore();
        if (isResults41Visible()) {
            return {
                results41: {
                    qID: 'results41',
                    tParams: __spreadArrays(helpers_1.returnNumberObject(score, 0, 1)),
                    titleTexts: 'regular'
                }
            };
        }
        if (isResults42Visible()) {
            return {
                results42: {
                    qID: 'results42',
                    tParams: __spreadArrays(helpers_1.returnNumberObject(score, 0, 1)),
                    titleTexts: 'regular'
                }
            };
        }
        if (isResults43Visible()) {
            return {
                results43: {
                    qID: 'results43',
                    tParams: __spreadArrays(helpers_1.returnNumberObject(score, 0, 1)),
                    titleTexts: 'regular'
                }
            };
        }
    }
    return null;
};
var isExportResultsEnabled = function () {
    return areAllQuestionsAnswered();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});