"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    cracker: true,
    dental: true,
    tearing: true,
    tears: true,
    smoking: true,
    noR: false,
    result1: false,
    result2: false
};
var visibleSections = {
    questions: true,
    noResult: false,
    results: false
};
var inputs = {
    cracker: null,
    dental: null,
    tearing: null,
    tears: null,
    smoking: null
};
var calculateSumOfPoints = function () {
    var _a, _b, _c, _d, _e;
    return (Number((_a = inputs.cracker) === null || _a === void 0 ? void 0 : _a.currentPoints) +
        Number((_b = inputs.dental) === null || _b === void 0 ? void 0 : _b.currentPoints) +
        Number((_c = inputs.tearing) === null || _c === void 0 ? void 0 : _c.currentPoints) +
        Number((_d = inputs.tears) === null || _d === void 0 ? void 0 : _d.currentPoints) +
        Number((_e = inputs.smoking) === null || _e === void 0 ? void 0 : _e.currentPoints));
};
var isNoResultVisible = function () {
    return (!helpers_1.isAnswered(inputs.cracker) ||
        !helpers_1.isAnswered(inputs.dental) ||
        !helpers_1.isAnswered(inputs.tearing) ||
        !helpers_1.isAnswered(inputs.tears) ||
        !helpers_1.isAnswered(inputs.smoking));
};
var isResult1Visible = function () {
    return (!isNoResultVisible() &&
        calculateSumOfPoints() >= 7 &&
        calculateSumOfPoints() <= 11);
};
var isResult2Visible = function () {
    return (!isNoResultVisible() &&
        calculateSumOfPoints() >= 0 &&
        calculateSumOfPoints() <= 6);
};
var calculatePoints = function () {
    if (isResult1Visible()) {
        return {
            result1: {
                qID: 'result1',
                tParams: __spreadArrays(helpers_1.returnNumberObject(calculateSumOfPoints(), 0, 0)),
                rParams: [],
                titleTexts: 'title1',
                resultTexts: 'res1'
            }
        };
    }
    if (isResult2Visible()) {
        return {
            result2: {
                qID: 'result2',
                tParams: __spreadArrays(helpers_1.returnNumberObject(calculateSumOfPoints(), 0, 0)),
                titleTexts: 'title2'
            }
        };
    }
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.noR = isNoResultVisible();
    visibleQuestions.result1 = isResult1Visible();
    visibleQuestions.result2 = isResult2Visible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noResult = isNoResultVisible();
    visibleSections.results = !isNoResultVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return !isNoResultVisible();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
