"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};

var visibleQuestions = {
    intendedUse: true,
    age: true,
    weight: true,
    resultAnswerAll: true,
    result221: true,
    result321: true,
    result331: true,
    result341: true,
    result421: true,
    result431: true,
    linkToSpc1: true
};
var visibleSections = {
    section1: true,
    result12: true,
    result22: true,
    result32: true,
    result33: true,
    result34: true,
    result42: true,
    result43: true,
    toolAdditionalInfoSection: true
};
var inputs = {
    intendedUse: null,
    age: null,
    weight: null
};
var isAgeVisible = function () {
    return helpers_1.isAnswered(inputs.intendedUse);
};
var isWeightValid = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.weight) &&
        Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints) > 0 &&
        Number((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints) <= 300);
};
var isWeightVisible = function () {
    var _a, _b;
    return (((_a = inputs.intendedUse) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "treat" &&
        helpers_1.isAnswered(inputs.age) &&
        ((_b = inputs.age) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "twelve");
};
var isAnswerAllVisible = function () {
    return !helpers_1.isAnswered(inputs.age) || (isWeightVisible() && !isWeightValid());
};
var isResultRange2Visible = function () {
    var _a;
    return (helpers_1.isAnswered(inputs.intendedUse) &&
        ((_a = inputs.age) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "twelveLess");
};
var isResultRange3Visible = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.intendedUse) &&
        ((_a = inputs.intendedUse) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "treat" &&
        ((_b = inputs.age) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "twelve" &&
        isWeightValid());
};
var isResultRange4Visible = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.intendedUse) &&
        ((_a = inputs.intendedUse) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "prevent" &&
        ((_b = inputs.age) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "twelve");
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    var result = {
        number: null,
        range: null
    };
    if (isAnswerAllVisible()) {
        return result;
    }
    if (isResultRange3Visible()) {
        result = __assign(__assign({}, result), { result321: {
                qID: "result321",
                tParams: __spreadArrays(helpers_1.returnNumberObject((Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints) * 80) / 4, 0, 1), helpers_1.returnNumberObject((Number((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints) * 100) / 4, 0, 1), helpers_1.returnNumberObject((Number((_c = inputs.weight) === null || _c === void 0 ? void 0 : _c.currentPoints) * 16) / 4, 0, 1), helpers_1.returnNumberObject((Number((_d = inputs.weight) === null || _d === void 0 ? void 0 : _d.currentPoints) * 20) / 4, 0, 1), helpers_1.returnNumberObject((Number((_e = inputs.weight) === null || _e === void 0 ? void 0 : _e.currentPoints) * 80) / 3, 0, 1), helpers_1.returnNumberObject((Number((_f = inputs.weight) === null || _f === void 0 ? void 0 : _f.currentPoints) * 100) / 3, 0, 1), helpers_1.returnNumberObject((Number((_g = inputs.weight) === null || _g === void 0 ? void 0 : _g.currentPoints) * 16) / 3, 0, 1), helpers_1.returnNumberObject((Number((_h = inputs.weight) === null || _h === void 0 ? void 0 : _h.currentPoints) * 20) / 3, 0, 1)),
                titleTexts: "regular"
            } });
    }
    return result;
};
var returnVisibleQuestions = function () {
    visibleQuestions.age = isAgeVisible();
    visibleQuestions.weight = isWeightVisible();
    visibleQuestions.resultAnswerAll = isAnswerAllVisible();
    visibleQuestions.result221 = isResultRange2Visible();
    visibleQuestions.result321 = isResultRange3Visible();
    visibleQuestions.result331 = isResultRange3Visible();
    visibleQuestions.result341 = isResultRange3Visible();
    visibleQuestions.result421 = isResultRange4Visible();
    visibleQuestions.result431 = isResultRange4Visible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.result12 = isAnswerAllVisible();
    visibleSections.result22 = isResultRange2Visible();
    visibleSections.result32 = isResultRange3Visible();
    visibleSections.result33 = isResultRange3Visible();
    visibleSections.result34 = isResultRange3Visible();
    visibleSections.result42 = isResultRange4Visible();
    visibleSections.result43 = isResultRange4Visible();
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return !isAnswerAllVisible();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
