"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};

var visibleQuestions = {
    intendedUse: true,
    age: true,
    weightA: true,
    weightAD: true,
    weightK: true,
    resultAnswerAll: true,
    result221: true,
    result231: true,
    result232: true,
    result233: true,
    result241: true,
    result251: true,
    result321: true,
    result322: true,
    result323: true,
    result331: true,
    result341: true,
    result421: true,
    result431: true,
    result441: true,
    result521: true,
    result531: true,
    result541: true,
    result551: true,
    result621: true,
    result631: true,
    result632: true,
    result633: true,
    result641: true,
    linkToSpc1: true,
    linkToSpc2: true
};
var visibleSections = {
    section1: true,
    result12: true,
    result22: true,
    result23: true,
    result24: true,
    result25: true,
    result32: true,
    result33: true,
    result34: true,
    result42: true,
    result43: true,
    result44: true,
    result52: true,
    result53: true,
    result54: true,
    result55: true,
    result62: true,
    result63: true,
    result64: true,
    toolAdditionalInfoSection: true
};
var inputs = {
    intendedUse: null,
    age: null,
    weightA: null,
    weightAD: null,
    weightK: null
};
var isAgeVisible = function () {
    return helpers_1.isAnswered(inputs.intendedUse);
};
var isWeightAValid = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.weightA) &&
        Number((_a = inputs.weightA) === null || _a === void 0 ? void 0 : _a.currentPoints) > 0 &&
        Number((_b = inputs.weightA) === null || _b === void 0 ? void 0 : _b.currentPoints) <= 300);
};
var isWeightAVisible = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.intendedUse) &&
        ((_a = inputs.intendedUse) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "treat" &&
        helpers_1.isAnswered(inputs.age) &&
        ((_b = inputs.age) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "twelve");
};
var isWeightADValid = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.weightAD) &&
        Number((_a = inputs.weightAD) === null || _a === void 0 ? void 0 : _a.currentPoints) > 0 &&
        Number((_b = inputs.weightAD) === null || _b === void 0 ? void 0 : _b.currentPoints) <= 50);
};
var isWeightADVisible = function () {
    var _a;
    return (helpers_1.isAnswered(inputs.intendedUse) &&
        helpers_1.isAnswered(inputs.age) &&
        ((_a = inputs.age) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "sixToTwelve");
};
var isWeightKValid = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.weightK) &&
        Number((_a = inputs.weightK) === null || _a === void 0 ? void 0 : _a.currentPoints) > 0 &&
        Number((_b = inputs.weightK) === null || _b === void 0 ? void 0 : _b.currentPoints) <= 30);
};
var isWeightKVisible = function () {
    var _a;
    return (helpers_1.isAnswered(inputs.intendedUse) &&
        helpers_1.isAnswered(inputs.age) &&
        ((_a = inputs.age) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "six");
};
var isAnswerAllVisible = function () {
    return (!helpers_1.isAnswered(inputs.intendedUse) ||
        !helpers_1.isAnswered(inputs.age) ||
        (isWeightAVisible() && !isWeightAValid()) ||
        (isWeightADVisible() && !isWeightADValid()) ||
        (isWeightKVisible() && !isWeightKValid()));
};
var isResultRange2Visible = function () {
    var _a, _b, _c;
    return (helpers_1.isAnswered(inputs.intendedUse) &&
        ((_a = inputs.intendedUse) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "treat" &&
        helpers_1.isAnswered(inputs.age) &&
        (((_b = inputs.age) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "twelve" ||
            ((_c = inputs.age) === null || _c === void 0 ? void 0 : _c.currentIdentifier) === "sixToTwelve") &&
        ((isWeightAVisible() && isWeightAValid()) ||
            (isWeightADVisible() && isWeightADValid())));
};
var isResultRange3Visible = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.intendedUse) &&
        ((_a = inputs.intendedUse) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "treat" &&
        helpers_1.isAnswered(inputs.age) &&
        ((_b = inputs.age) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "six" &&
        isWeightKVisible() &&
        isWeightKValid());
};
var isResultRange4Visible = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.intendedUse) &&
        ((_a = inputs.intendedUse) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "prevent" &&
        helpers_1.isAnswered(inputs.age) &&
        ((_b = inputs.age) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "twelve");
};
var isResultRange5Visible = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.intendedUse) &&
        ((_a = inputs.intendedUse) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "prevent" &&
        helpers_1.isAnswered(inputs.age) &&
        ((_b = inputs.age) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "sixToTwelve" &&
        isWeightADVisible() &&
        isWeightADValid());
};
var isResultRange6Visible = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.intendedUse) &&
        ((_a = inputs.intendedUse) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "prevent" &&
        helpers_1.isAnswered(inputs.age) &&
        ((_b = inputs.age) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "six" &&
        isWeightKVisible() &&
        isWeightKValid());
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l;
    var result = {};
    if (!isAnswerAllVisible()) {
        if (isResultRange2Visible()) {
            var activeWeight = isWeightAVisible() && isWeightAValid()
                ? Number((_a = inputs.weightA) === null || _a === void 0 ? void 0 : _a.currentPoints)
                : Number((_b = inputs.weightAD) === null || _b === void 0 ? void 0 : _b.currentPoints);
            result = __assign(__assign({}, result), { result221: {
                    qID: "result221",
                    tParams: __spreadArrays(helpers_1.returnNumberObject(activeWeight * 100, 0, 1), helpers_1.returnNumberObject(activeWeight * 20, 0, 1)),
                    titleTexts: "regular"
                }, result231: {
                    qID: "result231",
                    tParams: __spreadArrays(helpers_1.returnNumberObject((activeWeight * 100) / 40, 0, 1)),
                    titleTexts: "regular"
                }, result232: {
                    qID: "result232",
                    tParams: __spreadArrays(helpers_1.returnNumberObject(activeWeight * 100, 0, 1)),
                    titleTexts: "regular"
                }, result233: {
                    qID: "result233",
                    tParams: __spreadArrays(helpers_1.returnNumberObject(activeWeight * 20, 0, 1)),
                    titleTexts: "regular"
                } });
        }
        if (isResultRange3Visible()) {
            result = __assign(__assign({}, result), { result321: {
                    qID: "result321",
                    tParams: __spreadArrays(helpers_1.returnNumberObject((Number((_c = inputs.weightK) === null || _c === void 0 ? void 0 : _c.currentPoints) * 100) / 40, 0, 1)),
                    titleTexts: "regular"
                }, result322: {
                    qID: "result322",
                    tParams: __spreadArrays(helpers_1.returnNumberObject(Number((_d = inputs.weightK) === null || _d === void 0 ? void 0 : _d.currentPoints) * 100, 0, 1)),
                    titleTexts: "regular"
                }, result323: {
                    qID: "result323",
                    tParams: __spreadArrays(helpers_1.returnNumberObject(Number((_e = inputs.weightK) === null || _e === void 0 ? void 0 : _e.currentPoints) * 20, 0, 1)),
                    titleTexts: "regular"
                } });
        }
        if (isResultRange5Visible()) {
            result = __assign(__assign({}, result), { result531: {
                    qID: "result531",
                    tParams: __spreadArrays(helpers_1.returnNumberObject((Number((_f = inputs.weightAD) === null || _f === void 0 ? void 0 : _f.currentPoints) * 30) / 40, 0, 1), helpers_1.returnNumberObject(Number((_g = inputs.weightAD) === null || _g === void 0 ? void 0 : _g.currentPoints) * 30, 0, 1), helpers_1.returnNumberObject(Number((_h = inputs.weightAD) === null || _h === void 0 ? void 0 : _h.currentPoints) * 6, 0, 1)),
                    titleTexts: "regular"
                } });
        }
        if (isResultRange6Visible()) {
            result = __assign(__assign({}, result), { result621: {
                    qID: "result621",
                    tParams: __spreadArrays(helpers_1.returnNumberObject((Number((_j = inputs.weightK) === null || _j === void 0 ? void 0 : _j.currentPoints) * 30) / 40, 0, 1), helpers_1.returnNumberObject(Number((_k = inputs.weightK) === null || _k === void 0 ? void 0 : _k.currentPoints) * 30, 0, 1), helpers_1.returnNumberObject(Number((_l = inputs.weightK) === null || _l === void 0 ? void 0 : _l.currentPoints) * 6, 0, 1)),
                    titleTexts: "regular"
                } });
        }
    }
    return result;
};
var returnVisibleQuestions = function () {
    visibleQuestions.age = isAgeVisible();
    visibleQuestions.weightA = isWeightAVisible();
    visibleQuestions.weightAD = isWeightADVisible();
    visibleQuestions.weightK = isWeightKVisible();
    visibleQuestions.resultAnswerAll = isAnswerAllVisible();
    visibleQuestions.result221 = isResultRange2Visible();
    visibleQuestions.result231 = isResultRange2Visible();
    visibleQuestions.result232 = isResultRange2Visible();
    visibleQuestions.result233 = isResultRange2Visible();
    visibleQuestions.result241 = isResultRange2Visible();
    visibleQuestions.result251 = isResultRange2Visible();
    visibleQuestions.result321 = isResultRange3Visible();
    visibleQuestions.result322 = isResultRange3Visible();
    visibleQuestions.result323 = isResultRange3Visible();
    visibleQuestions.result331 = isResultRange3Visible();
    visibleQuestions.result341 = isResultRange3Visible();
    visibleQuestions.result421 = isResultRange4Visible();
    visibleQuestions.result431 = isResultRange4Visible();
    visibleQuestions.result441 = isResultRange4Visible();
    visibleQuestions.result521 = isResultRange5Visible();
    visibleQuestions.result531 = isResultRange5Visible();
    visibleQuestions.result541 = isResultRange5Visible();
    visibleQuestions.result551 = isResultRange5Visible();
    visibleQuestions.result621 = isResultRange6Visible();
    visibleQuestions.result631 = isResultRange6Visible();
    visibleQuestions.result632 = isResultRange6Visible();
    visibleQuestions.result633 = isResultRange6Visible();
    visibleQuestions.result641 = isResultRange6Visible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.result12 = isAnswerAllVisible();
    visibleSections.result22 = isResultRange2Visible();
    visibleSections.result23 = isResultRange2Visible();
    visibleSections.result24 = isResultRange2Visible();
    visibleSections.result25 = isResultRange2Visible();
    visibleSections.result32 = isResultRange3Visible();
    visibleSections.result33 = isResultRange3Visible();
    visibleSections.result34 = isResultRange3Visible();
    visibleSections.result42 = isResultRange4Visible();
    visibleSections.result43 = isResultRange4Visible();
    visibleSections.result44 = isResultRange4Visible();
    visibleSections.result52 = isResultRange5Visible();
    visibleSections.result53 = isResultRange5Visible();
    visibleSections.result54 = isResultRange5Visible();
    visibleSections.result55 = isResultRange5Visible();
    visibleSections.result62 = isResultRange6Visible();
    visibleSections.result63 = isResultRange6Visible();
    visibleSections.result64 = isResultRange6Visible();
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return !isAnswerAllVisible();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
