"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    intendedUse: true,
    age: false,
    weight: false,
    weight2: false,
    weight3: false,
    weight4: false,
    textNoAnswer: true,
    dosingbabiesiv: false,
    sulfbabiesiv: false,
    durationbabiesiv: false,
    warningbabieswarning: false,
    dosingSuspension: false,
    sulfChildren200: false,
    durationBabiesSusp: false,
    dosingkidsiv: false,
    sulfKidsinf: false,
    durationkidsiv: false,
    warningkidswarning: false,
    dosingSuspensionKids: false,
    sulfChildrenKids: false,
    dosingSuspensionKidsSecond: false,
    sulfChildrenKidsSecond: false,
    durationKidsSusp: false,
    dosingchildreinv: false,
    sulfChildreninf: false,
    durationchidlreniv: false,
    warningchidlrenivwarning: false,
    dosingSuspensionChildren: false,
    sulfChildren: false,
    dosingSuspensionChildrenSecond: false,
    sulfChildrenSecond: false,
    durationChildrenSusp: false,
    dosingadultsiv: false,
    sulfAdults400: false,
    durationiv: false,
    warningAdultsiv: false,
    dosingAdults: false,
    durationTabletsAdults: false,
    warningAdultsivSecond: false,
    dosingAdultsSuspension: false,
    sulfAdults: false,
    durationSuspension: false,
    warningAdultsivSecondSusp: false,
    dosingAdultsSuspSecond: false,
    sulfAdultsSecond: false,
    durationSuspSecond: false,
    dosingPrevent: false,
    sulfAdultPrevent800: false,
    dosingPreventSusp: false,
    sulfDosingAdultsPreventSulf: false,
    warningAdultsPro: false,
    preventionText: false,
    kidneygray: false,
    kidneyYellow: false,
    kidneyRed: false,
    chidlrenKidneyText: false,
    kidneyBabies: false,
    text: false
};
var visibleSections = {
    selection: true,
    noAnswer: true,
    babiesInfusin: false,
    babiesSuspension: false,
    kidsInfusin: false,
    kidsSuspension: false,
    childrenInfusin: false,
    childrenSuspension200: false,
    dosingAdults400: false,
    tabletsAdults: false,
    suspensionAdults: false,
    suspensionAdultsSecond: false,
    tabletsAdultsPrevent: false,
    tabletsAdultsPreventSusp: false,
    warningAdults: false,
    preventionChildren: false,
    kidneySection: false,
    childrenKidney: false,
    babiesKidney: false,
    noteAntibiotics: false
};
var inputs = {
    intendedUse: null,
    age: null,
    weight: null,
    weight2: null,
    weight3: null,
    weight4: null
};
var isAgeVisible = function () {
    return helpers_1.isAnswered(inputs.intendedUse);
};
var isWeightVisible = function () {
    return (helpers_1.answerMatches(inputs.intendedUse, 'treat') &&
        (helpers_1.answerMatches(inputs.age, 'adults') || helpers_1.answerMatches(inputs.age, 'teens')));
};
var isWeight2Visible = function () {
    return (helpers_1.answerMatches(inputs.intendedUse, 'treat') &&
        helpers_1.answerMatches(inputs.age, 'children'));
};
var isWeight3Visible = function () {
    return (helpers_1.answerMatches(inputs.intendedUse, 'treat') &&
        helpers_1.answerMatches(inputs.age, 'kids'));
};
var isWeight4Visible = function () {
    return (helpers_1.answerMatches(inputs.intendedUse, 'treat') &&
        helpers_1.answerMatches(inputs.age, 'babies'));
};
var isAnsweredAll = function () {
    return !(helpers_1.isAnswered(inputs.intendedUse) &&
        helpers_1.isAnswered(inputs.age) &&
        (helpers_1.answerMatches(inputs.intendedUse, 'prevent') ||
            (helpers_1.answerMatches(inputs.intendedUse, 'treat') &&
                ((isWeightVisible() &&
                    helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 200 })) ||
                    (isWeight2Visible() &&
                        helpers_1.numberInLimits({ input: inputs.weight2, min: 1, max: 70 })) ||
                    (isWeight3Visible() &&
                        helpers_1.numberInLimits({ input: inputs.weight3, min: 1, max: 30 })) ||
                    (isWeight4Visible() &&
                        helpers_1.numberInLimits({ input: inputs.weight4, min: 1, max: 12 }))))));
};
var isBabiesInfusinVisible = function () {
    return (isWeight4Visible() &&
        helpers_1.numberInLimits({ input: inputs.weight4, min: 1, max: 12 }));
};
var isKidsInfusinVisible = function () {
    return (isWeight3Visible() &&
        helpers_1.numberInLimits({ input: inputs.weight3, min: 1, max: 30 }));
};
var isChildrenInfusinVisible = function () {
    return (isWeight2Visible() &&
        helpers_1.numberInLimits({ input: inputs.weight2, min: 1, max: 70 }));
};
var isDosingAdults400Visible = function () {
    return (isWeightVisible() &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 200 }));
};
var isTabletsAdultsVisible = function () {
    return (isWeightVisible() &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 16, max: 200 }));
};
var isSuspensionAdultsSecondVisible = function () {
    return (helpers_1.answerMatches(inputs.intendedUse, 'treat') &&
        helpers_1.answerMatches(inputs.age, 'teens') &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 200 }));
};
var isTabletsAdultsPreventVisible = function () {
    return (helpers_1.answerMatches(inputs.intendedUse, 'prevent') &&
        helpers_1.answerMatches(inputs.age, 'adults'));
};
var isPreventionChildrenVisible = function () {
    return (helpers_1.answerMatches(inputs.intendedUse, 'prevent') &&
        helpers_1.isAnswered(inputs.age) &&
        !helpers_1.answerMatches(inputs.age, 'adults'));
};
var isKidneySectionVisible = function () {
    return ((isWeightVisible() && !isAnsweredAll()) ||
        (helpers_1.answerMatches(inputs.intendedUse, 'prevent') &&
            helpers_1.answerMatches(inputs.age, 'adults')));
};
var isChildrenKidneyVisible = function () {
    return (helpers_1.answerMatches(inputs.intendedUse, 'treat') &&
        helpers_1.answerMatches(inputs.age, 'children') &&
        helpers_1.numberInLimits({ input: inputs.weight2, min: 1, max: 70 }));
};
var isBabiesKidneyVisible = function () {
    return (helpers_1.answerMatches(inputs.intendedUse, 'treat') &&
        (helpers_1.answerMatches(inputs.age, 'babies') ||
            helpers_1.answerMatches(inputs.age, 'kids')) &&
        !isAnsweredAll());
};
var isNoteAntibioticsVisible = function () {
    return ((helpers_1.answerMatches(inputs.intendedUse, 'treat') && !isAnsweredAll()) ||
        (helpers_1.answerMatches(inputs.intendedUse, 'prevent') &&
            helpers_1.answerMatches(inputs.age, 'adults')));
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    var obj = {};
    if (isBabiesInfusinVisible()) {
        var weight = Number((_a = inputs === null || inputs === void 0 ? void 0 : inputs.weight4) === null || _a === void 0 ? void 0 : _a.currentPoints);
        var X = weight >= 10 ? 12.5 : (weight * 5) / 4;
        var N = weight >= 10 ? 1000 : weight * 100;
        var M = weight >= 10 ? 200 : weight * 20;
        var Y = (weight * 75) / 40;
        var Z = weight >= 10 ? 25 : (weight * 10) / 4;
        var T1 = weight * 75;
        var T2 = weight >= 10 ? 1000 : weight * 100;
        var R1 = weight * 15;
        var R2 = weight >= 10 ? 200 : weight * 20;
        obj = __assign(__assign({}, obj), { dosingbabiesiv: {
                qID: 'dosingbabiesiv',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(X, 1), 0, 1)),
                titleTexts: 'result1'
            }, sulfbabiesiv: {
                qID: 'sulfbabiesiv',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(N, 1), 0, 1)),
                titleTexts: 'result1',
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(M, 1), 0, 1)),
                resultTexts: 'result1'
            }, dosingSuspension: {
                qID: 'dosingSuspension',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(Y, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(Z, 1), 0, 1)),
                titleTexts: 'result1'
            }, sulfChildren200: {
                qID: 'sulfChildren200',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T1, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T2, 1), 0, 1)),
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(R1, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(R2, 1), 0, 1)),
                resultTexts: 'result1',
                titleTexts: 'result1'
            } });
    }
    if (isKidsInfusinVisible()) {
        var weight = Number((_b = inputs === null || inputs === void 0 ? void 0 : inputs.weight3) === null || _b === void 0 ? void 0 : _b.currentPoints);
        var X = weight >= 20 ? 25 : (weight * 5) / 4;
        var T1 = weight >= 20 ? 2000 : weight * 100;
        var R1 = weight >= 20 ? 400 : weight * 20;
        obj = __assign(__assign({}, obj), { dosingkidsiv: {
                qID: 'dosingkidsiv',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(X, 1), 0, 1)),
                titleTexts: 'result1'
            }, sulfKidsinf: {
                qID: 'sulfKidsinf',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T1, 1), 0, 1)),
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(R1, 1), 0, 1)),
                resultTexts: 'result1',
                titleTexts: 'result1'
            } });
    }
    if (isKidsInfusinVisible() &&
        helpers_1.numberInLimits({ input: inputs.weight3, min: 1, max: 26.66 })) {
        var weight = Number((_c = inputs === null || inputs === void 0 ? void 0 : inputs.weight3) === null || _c === void 0 ? void 0 : _c.currentPoints);
        var X = (weight * 75) / 40;
        var Y = weight >= 20 ? 50 : (weight * 10) / 4;
        var T1 = weight * 75;
        var T2 = weight >= 20 ? 2000 : weight * 100;
        var R1 = weight * 15;
        var R2 = weight >= 20 ? 400 : weight * 20;
        obj = __assign(__assign({}, obj), { dosingSuspensionKids: {
                qID: 'dosingSuspensionKids',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(X, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(Y, 1), 0, 1)),
                titleTexts: 'result1'
            }, sulfChildrenKids: {
                qID: 'sulfChildrenKids',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T1, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T2, 1), 0, 1)),
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(R1, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(R2, 1), 0, 1)),
                resultTexts: 'result1',
                titleTexts: 'result1'
            } });
    }
    if (isChildrenInfusinVisible()) {
        var weight = Number((_d = inputs === null || inputs === void 0 ? void 0 : inputs.weight2) === null || _d === void 0 ? void 0 : _d.currentPoints);
        var X = weight >= 40 ? 50 : (weight * 5) / 4;
        var T1 = weight >= 40 ? 4000 : weight * 100;
        var R1 = weight >= 40 ? 800 : weight * 20;
        obj = __assign(__assign({}, obj), { dosingchildreinv: {
                qID: 'dosingchildreinv',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(X, 1), 0, 1)),
                titleTexts: 'result1'
            }, sulfChildreninf: {
                qID: 'sulfChildreninf',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T1, 1), 0, 1)),
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(R1, 1), 0, 1)),
                resultTexts: 'result1',
                titleTexts: 'result1'
            } });
    }
    if (isChildrenInfusinVisible() &&
        helpers_1.numberInLimits({ input: inputs.weight2, min: 1, max: 53.3 })) {
        var weight = Number((_e = inputs === null || inputs === void 0 ? void 0 : inputs.weight2) === null || _e === void 0 ? void 0 : _e.currentPoints);
        var X = (weight * 75) / 40;
        var Y = weight >= 40 ? 100 : (weight * 10) / 4;
        var T1 = weight * 75;
        var T2 = weight >= 40 ? 4000 : weight * 100;
        var R1 = weight * 15;
        var R2 = weight >= 40 ? 800 : weight * 20;
        obj = __assign(__assign({}, obj), { dosingSuspensionChildren: {
                qID: 'dosingSuspensionChildren',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(X, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(Y, 1), 0, 1)),
                titleTexts: 'result1'
            }, sulfChildren: {
                qID: 'sulfChildren',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T1, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T2, 1), 0, 1)),
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(R1, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(R2, 1), 0, 1)),
                resultTexts: 'result1',
                titleTexts: 'result1'
            } });
    }
    if (isDosingAdults400Visible()) {
        var weight = Number((_f = inputs === null || inputs === void 0 ? void 0 : inputs.weight) === null || _f === void 0 ? void 0 : _f.currentPoints);
        var X = weight >= 80 ? 100 : (weight * 5) / 4;
        var T1 = weight >= 80 ? 8000 : weight * 100;
        var R1 = weight >= 80 ? 1600 : weight * 20;
        obj = __assign(__assign({}, obj), { dosingadultsiv: {
                qID: 'dosingadultsiv',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(X, 1), 0, 1)),
                titleTexts: 'result1'
            }, sulfAdults400: {
                qID: 'sulfAdults400',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T1, 1), 0, 1)),
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(R1, 1), 0, 1)),
                resultTexts: 'result1',
                titleTexts: 'result1'
            }, dosingAdultsSuspension: {
                qID: 'dosingAdultsSuspension',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(X, 1), 0, 1)),
                titleTexts: 'result1'
            }, sulfAdults: {
                qID: 'sulfAdults',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T1, 1), 0, 1)),
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(R1, 1), 0, 1)),
                resultTexts: 'result1',
                titleTexts: 'result1'
            } });
    }
    if (isTabletsAdultsVisible()) {
        var weight = Number((_g = inputs === null || inputs === void 0 ? void 0 : inputs.weight) === null || _g === void 0 ? void 0 : _g.currentPoints);
        var X = weight >= 80 ? 8000 : weight * 100;
        var Y = weight >= 80 ? 1600 : weight * 20;
        obj = __assign(__assign({}, obj), { dosingAdults: {
                qID: 'dosingAdults',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(X, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(Y, 1), 0, 1)),
                titleTexts: 'result1'
            } });
    }
    if (isKidneySectionVisible()) {
        var weight = Number((_h = inputs === null || inputs === void 0 ? void 0 : inputs.weight) === null || _h === void 0 ? void 0 : _h.currentPoints);
        var X = weight >= 80 ? 200 : (weight * 10) / 4;
        var T1 = weight >= 80 ? 8000 : weight * 100;
        var R1 = weight >= 80 ? 1600 : weight * 20;
        obj = __assign(__assign({}, obj), { dosingAdultsSuspSecond: {
                qID: 'dosingAdultsSuspSecond',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(X, 1), 0, 1)),
                titleTexts: 'result1'
            }, sulfAdultsSecond: {
                qID: 'sulfAdultsSecond',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T1, 1), 0, 1)),
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(R1, 1), 0, 1)),
                resultTexts: 'result1',
                titleTexts: 'result1'
            } });
    }
    return Object.keys(obj).length ? obj : null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.age = isAgeVisible();
    visibleQuestions.weight = isWeightVisible();
    visibleQuestions.weight2 = isWeight2Visible();
    visibleQuestions.weight3 = isWeight3Visible();
    visibleQuestions.weight4 = isWeight4Visible();
    visibleQuestions.textNoAnswer = isAnsweredAll();
    visibleQuestions.dosingbabiesiv = isBabiesInfusinVisible();
    visibleQuestions.sulfbabiesiv = isBabiesInfusinVisible();
    visibleQuestions.durationbabiesiv = isBabiesInfusinVisible();
    visibleQuestions.warningbabieswarning = isBabiesInfusinVisible();
    visibleQuestions.dosingSuspension = isBabiesInfusinVisible();
    visibleQuestions.sulfChildren200 = isBabiesInfusinVisible();
    visibleQuestions.durationBabiesSusp = isBabiesInfusinVisible();
    visibleQuestions.dosingkidsiv = isKidsInfusinVisible();
    visibleQuestions.sulfKidsinf = isKidsInfusinVisible();
    visibleQuestions.durationkidsiv = isKidsInfusinVisible();
    visibleQuestions.warningkidswarning = isKidsInfusinVisible();
    visibleQuestions.dosingSuspensionKids =
        isWeight3Visible() &&
            helpers_1.numberInLimits({ input: inputs.weight3, min: 1, max: 26.66 });
    visibleQuestions.sulfChildrenKids =
        isWeight3Visible() &&
            helpers_1.numberInLimits({ input: inputs.weight3, min: 1, max: 26.66 });
    visibleQuestions.dosingSuspensionKidsSecond =
        isWeight3Visible() &&
            helpers_1.numberInLimits({ input: inputs.weight3, min: 26.67, max: 30 });
    visibleQuestions.sulfChildrenKidsSecond =
        isWeight3Visible() &&
            helpers_1.numberInLimits({ input: inputs.weight3, min: 26.67, max: 30 });
    visibleQuestions.durationKidsSusp = isKidsInfusinVisible();
    visibleQuestions.dosingchildreinv = isChildrenInfusinVisible();
    visibleQuestions.sulfChildreninf = isChildrenInfusinVisible();
    visibleQuestions.durationchidlreniv = isChildrenInfusinVisible();
    visibleQuestions.warningchidlrenivwarning = isChildrenInfusinVisible();
    visibleQuestions.dosingSuspensionChildren =
        isChildrenInfusinVisible() &&
            helpers_1.numberInLimits({ input: inputs.weight2, min: 1, max: 53.3 });
    visibleQuestions.sulfChildren =
        isChildrenInfusinVisible() &&
            helpers_1.numberInLimits({ input: inputs.weight2, min: 1, max: 53.3 });
    visibleQuestions.dosingSuspensionChildrenSecond =
        isChildrenInfusinVisible() &&
            helpers_1.numberInLimits({ input: inputs.weight2, min: 53.4, max: 70 });
    visibleQuestions.sulfChildrenSecond =
        isChildrenInfusinVisible() &&
            helpers_1.numberInLimits({ input: inputs.weight2, min: 53.4, max: 70 });
    visibleQuestions.durationChildrenSusp = isChildrenInfusinVisible();
    visibleQuestions.dosingadultsiv = isDosingAdults400Visible();
    visibleQuestions.sulfAdults400 = isDosingAdults400Visible();
    visibleQuestions.durationiv = isDosingAdults400Visible();
    visibleQuestions.warningAdultsiv = isTabletsAdultsVisible();
    visibleQuestions.dosingAdults = isTabletsAdultsVisible();
    visibleQuestions.durationTabletsAdults = isTabletsAdultsVisible();
    visibleQuestions.warningAdultsivSecond = isDosingAdults400Visible();
    visibleQuestions.dosingAdultsSuspension = isDosingAdults400Visible();
    visibleQuestions.sulfAdults = isDosingAdults400Visible();
    visibleQuestions.durationSuspension = isDosingAdults400Visible();
    visibleQuestions.warningAdultsivSecondSusp =
        isSuspensionAdultsSecondVisible();
    visibleQuestions.dosingAdultsSuspSecond = isSuspensionAdultsSecondVisible();
    visibleQuestions.sulfAdultsSecond = isSuspensionAdultsSecondVisible();
    visibleQuestions.durationSuspSecond = isSuspensionAdultsSecondVisible();
    visibleQuestions.dosingPrevent = isTabletsAdultsPreventVisible();
    visibleQuestions.sulfAdultPrevent800 = isTabletsAdultsPreventVisible();
    visibleQuestions.dosingPreventSusp = isTabletsAdultsPreventVisible();
    visibleQuestions.sulfDosingAdultsPreventSulf =
        isTabletsAdultsPreventVisible();
    visibleQuestions.warningAdultsPro = isTabletsAdultsPreventVisible();
    visibleQuestions.preventionText = isPreventionChildrenVisible();
    visibleQuestions.kidneygray = isKidneySectionVisible();
    visibleQuestions.kidneyYellow = isKidneySectionVisible();
    visibleQuestions.kidneyRed = isKidneySectionVisible();
    visibleQuestions.chidlrenKidneyText = isChildrenKidneyVisible();
    visibleQuestions.kidneyBabies = isBabiesKidneyVisible();
    visibleQuestions.text = isNoteAntibioticsVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = isAnsweredAll();
    visibleSections.babiesInfusin = isBabiesInfusinVisible();
    visibleSections.babiesSuspension = isBabiesInfusinVisible();
    visibleSections.kidsInfusin = isKidsInfusinVisible();
    visibleSections.kidsSuspension = isKidsInfusinVisible();
    visibleSections.childrenInfusin = isChildrenInfusinVisible();
    visibleSections.childrenSuspension200 = isChildrenInfusinVisible();
    visibleSections.dosingAdults400 = isDosingAdults400Visible();
    visibleSections.tabletsAdults = isTabletsAdultsVisible();
    visibleSections.suspensionAdults = isDosingAdults400Visible();
    visibleSections.suspensionAdultsSecond = isSuspensionAdultsSecondVisible();
    visibleSections.tabletsAdultsPrevent = isTabletsAdultsPreventVisible();
    visibleSections.tabletsAdultsPreventSusp = isTabletsAdultsPreventVisible();
    visibleSections.warningAdults = isTabletsAdultsPreventVisible();
    visibleSections.preventionChildren = isPreventionChildrenVisible();
    visibleSections.kidneySection = isKidneySectionVisible();
    visibleSections.childrenKidney = isChildrenKidneyVisible();
    visibleSections.babiesKidney = isBabiesKidneyVisible();
    visibleSections.noteAntibiotics = isNoteAntibioticsVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return !isAnsweredAll();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
