"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    age: true,
    weight: false,
    weight2: false,
    weight3: false,
    weight4: false,
    textNoAnswer: true,
    dosingAdultsSmall: false,
    sulfAdults400: false,
    durationTabletsAdultsSmall: false,
    dosingAdults: false,
    sulfAdults800: false,
    durationTabletsAdults: false,
    dosingAdultsSuspension: false,
    sulfAdults: false,
    durationSuspension: false,
    dosingtwelveTabletsSmall: false,
    sulfTeens400: false,
    durationtwelveTabletsSmall: false,
    dosingTwelveTablets: false,
    sulfTeens800: false,
    durationTwelveTablets: false,
    ageteens: false,
    dosingsuspensionTwelve400Age: false,
    sulfsuspensionTwelve400Age: false,
    durationsuspensionTwelve400Age: false,
    weightteens: false,
    dosingWarning: false,
    dosingsuspensionTwelve400: false,
    sulfsuspensionTwelve400: false,
    durationsuspensionTwelve400: false,
    dosingtabletsTwelveless: false,
    trimsuspensionChildren400: false,
    durationtabletsTwelveless: false,
    dosingtabletsTwelveless800: false,
    sulfsuspensionChildren800: false,
    durationtabletsTwelveless800: false,
    ageChildren200: false,
    dosingTwelveSusp200Age: false,
    sulfTwelveSusp200Age: false,
    durationTwelveSusp200Age: false,
    weightChildren200: false,
    warningChidlren: false,
    dosingTwelveSusp200: false,
    sulfTwelveSusp200: false,
    dosingTwelveSusp200Second: false,
    durationTwelveSusp200: false,
    ageKids: false,
    dosingfiveSusp200Age: false,
    sulffiveSusp200Age: false,
    durationfiveSusp200Age: false,
    weightKids: false,
    dosingfiveSusp200: false,
    sulffiveSusp200: false,
    dosingfiveSusp200Second: false,
    durationfiveSusp200: false,
    ageBabies: false,
    dosingfivelessSusp200Age: false,
    sulffivelessSusp200Age: false,
    durationfivelessSusp200Age: false,
    weightBabies: false,
    dosingfivelessSusp200: false,
    sulffivelessSusp200: false,
    dosingfivelessSusp200Second: false,
    durationfivelessSusp200: false,
    kidneygrey: false,
    kidneyyellow: false,
    kidneyred: false,
    kidneyChildren: false,
    babiesKidney: false,
    text: false
};
var visibleSections = {
    selection: true,
    noAnswer: true,
    tabletsAdultsSmall: false,
    tabletsAdults: false,
    suspensionAdults: false,
    twelveTabletsSmall: false,
    tabletsAdultsPrevent: false,
    suspensionTwelve400: false,
    tabletsTwelveless: false,
    tabletsTwelveless800: false,
    twelveSusp200: false,
    fiveSusp200: false,
    fivelessSusp200: false,
    kidneySection: false,
    childrenKidney: false,
    kidneyBabies: false,
    noteAntibiotics: false
};
var inputs = {
    age: null,
    weight: null,
    weight2: null,
    weight3: null,
    weight4: null
};
var isAgeMatching = function (name) {
    return helpers_1.answerMatches(inputs.age, name);
};
var isAnswerAllVisible = function () {
    return !(isAgeMatching('adults') ||
        (helpers_1.isAnswered(inputs.age) &&
            (helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 150 }) ||
                helpers_1.numberInLimits({ input: inputs.weight2, min: 1, max: 70 }) ||
                helpers_1.numberInLimits({ input: inputs.weight3, min: 1, max: 30 }) ||
                helpers_1.numberInLimits({ input: inputs.weight4, min: 1, max: 12 }))));
};
var isTeensVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'teens') &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 150 }));
};
var isDosingWarningVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'teens') &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 53.4, max: 150 }));
};
var isChildrenVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'children') &&
        helpers_1.numberInLimits({ input: inputs.weight2, min: 1, max: 70 }));
};
var isWarningChidlrenVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'children') &&
        helpers_1.numberInLimits({ input: inputs.weight2, min: 35.6, max: 70 }));
};
var isKidsVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'kids') &&
        helpers_1.numberInLimits({ input: inputs.weight3, min: 1, max: 30 }));
};
var isBabiesVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'babies') &&
        helpers_1.numberInLimits({ input: inputs.weight4, min: 1, max: 12 }));
};
var isAgeAdultOrTeen = function () {
    return (!isAnswerAllVisible() && (isAgeMatching('teens') || isAgeMatching('adults')));
};
var isAgeBabieOrsKids = function () {
    return (!isAnswerAllVisible() && (isAgeMatching('babies') || isAgeMatching('kids')));
};
var calculatePoints = function () {
    var _a, _b, _c, _d;
    if (isTeensVisible()) {
        var weight = Number((_a = inputs === null || inputs === void 0 ? void 0 : inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints);
        var X = (weight * 3) / 16;
        var T = (weight * 30) / 2;
        var R = (weight * 6) / 2;
        return {
            dosingsuspensionTwelve400: {
                qID: 'dosingsuspensionTwelve400',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(X, 1), 0, 1)),
                titleTexts: 'result1'
            },
            sulfsuspensionTwelve400: {
                qID: 'sulfsuspensionTwelve400',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T, 1), 0, 1)),
                titleTexts: 'result1',
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(R, 1), 0, 1)),
                resultTexts: 'result1'
            }
        };
    }
    if (isChildrenVisible()) {
        var weight = Number((_b = inputs === null || inputs === void 0 ? void 0 : inputs.weight2) === null || _b === void 0 ? void 0 : _b.currentPoints);
        var X = (weight * 3) / 8;
        var T = (weight * 30) / 2;
        var R = (weight * 6) / 2;
        var T1 = (weight * 9) / 16;
        var T2 = (weight * 45) / 2;
        var T3 = (weight * 9) / 2;
        return {
            dosingTwelveSusp200: {
                qID: 'dosingTwelveSusp200',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(X, 1), 0, 1)),
                titleTexts: 'result1'
            },
            sulfTwelveSusp200: {
                qID: 'sulfTwelveSusp200',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T, 1), 0, 1)),
                titleTexts: 'result1',
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(R, 1), 0, 1)),
                resultTexts: 'result1'
            },
            dosingTwelveSusp200Second: {
                qID: 'dosingTwelveSusp200Second',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T1, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T2, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T3, 1), 0, 1)),
                titleTexts: 'result1'
            }
        };
    }
    if (isKidsVisible()) {
        var weight = Number((_c = inputs === null || inputs === void 0 ? void 0 : inputs.weight3) === null || _c === void 0 ? void 0 : _c.currentPoints);
        var X = (weight * 3) / 8;
        var T = (weight * 30) / 2;
        var R = (weight * 6) / 2;
        var T1 = (weight * 9) / 16;
        var T2 = (weight * 45) / 2;
        var T3 = (weight * 9) / 2;
        return {
            dosingfiveSusp200: {
                qID: 'dosingfiveSusp200',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(X, 1), 0, 1)),
                titleTexts: 'result1'
            },
            sulffiveSusp200: {
                qID: 'sulffiveSusp200',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T, 1), 0, 1)),
                titleTexts: 'result1',
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(R, 1), 0, 1)),
                resultTexts: 'result1'
            },
            dosingfiveSusp200Second: {
                qID: 'dosingfiveSusp200Second',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T1, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T2, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T3, 1), 0, 1)),
                titleTexts: 'result1'
            }
        };
    }
    if (isBabiesVisible()) {
        var weight = Number((_d = inputs === null || inputs === void 0 ? void 0 : inputs.weight4) === null || _d === void 0 ? void 0 : _d.currentPoints);
        var X = (weight * 3) / 8;
        var T = (weight * 30) / 2;
        var R = (weight * 6) / 2;
        var T1 = (weight * 9) / 16;
        var T2 = (weight * 45) / 2;
        var T3 = (weight * 9) / 2;
        return {
            dosingfivelessSusp200: {
                qID: 'dosingfivelessSusp200',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(X, 1), 0, 1)),
                titleTexts: 'result1'
            },
            sulffivelessSusp200: {
                qID: 'sulffivelessSusp200',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T, 1), 0, 1)),
                titleTexts: 'result1',
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(R, 1), 0, 1)),
                resultTexts: 'result1'
            },
            dosingfivelessSusp200Second: {
                qID: 'dosingfivelessSusp200Second',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T1, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T2, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T3, 1), 0, 1)),
                titleTexts: 'result1'
            }
        };
    }
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.weight = isAgeMatching('teens');
    visibleQuestions.weight2 = isAgeMatching('children');
    visibleQuestions.weight3 = isAgeMatching('kids');
    visibleQuestions.weight4 = isAgeMatching('babies');
    visibleQuestions.textNoAnswer = isAnswerAllVisible();
    visibleQuestions.dosingAdultsSmall = isAgeMatching('adults');
    visibleQuestions.sulfAdults400 = isAgeMatching('adults');
    visibleQuestions.durationTabletsAdultsSmall = isAgeMatching('adults');
    visibleQuestions.dosingAdults = isAgeMatching('adults');
    visibleQuestions.sulfAdults800 = isAgeMatching('adults');
    visibleQuestions.durationTabletsAdults = isAgeMatching('adults');
    visibleQuestions.dosingAdultsSuspension = isAgeMatching('adults');
    visibleQuestions.sulfAdults = isAgeMatching('adults');
    visibleQuestions.durationSuspension = isAgeMatching('adults');
    visibleQuestions.dosingtwelveTabletsSmall = isTeensVisible();
    visibleQuestions.sulfTeens400 = isTeensVisible();
    visibleQuestions.durationtwelveTabletsSmall = isTeensVisible();
    visibleQuestions.dosingTwelveTablets = isTeensVisible();
    visibleQuestions.sulfTeens800 = isTeensVisible();
    visibleQuestions.durationTwelveTablets = isTeensVisible();
    visibleQuestions.ageteens = isTeensVisible();
    visibleQuestions.dosingsuspensionTwelve400Age = isTeensVisible();
    visibleQuestions.sulfsuspensionTwelve400Age = isTeensVisible();
    visibleQuestions.durationsuspensionTwelve400Age = isTeensVisible();
    visibleQuestions.weightteens = isTeensVisible();
    visibleQuestions.dosingWarning = isDosingWarningVisible();
    visibleQuestions.dosingsuspensionTwelve400 = isTeensVisible();
    visibleQuestions.sulfsuspensionTwelve400 = isTeensVisible();
    visibleQuestions.durationsuspensionTwelve400 = isTeensVisible();
    visibleQuestions.dosingtabletsTwelveless = isChildrenVisible();
    visibleQuestions.trimsuspensionChildren400 = isChildrenVisible();
    visibleQuestions.durationtabletsTwelveless = isChildrenVisible();
    visibleQuestions.dosingtabletsTwelveless800 = isChildrenVisible();
    visibleQuestions.sulfsuspensionChildren800 = isChildrenVisible();
    visibleQuestions.durationtabletsTwelveless800 = isChildrenVisible();
    visibleQuestions.ageChildren200 = isChildrenVisible();
    visibleQuestions.dosingTwelveSusp200Age = isChildrenVisible();
    visibleQuestions.sulfTwelveSusp200Age = isChildrenVisible();
    visibleQuestions.durationTwelveSusp200Age = isChildrenVisible();
    visibleQuestions.weightChildren200 = isChildrenVisible();
    visibleQuestions.warningChidlren = isWarningChidlrenVisible();
    visibleQuestions.dosingTwelveSusp200 = isChildrenVisible();
    visibleQuestions.sulfTwelveSusp200 = isChildrenVisible();
    visibleQuestions.dosingTwelveSusp200Second = isChildrenVisible();
    visibleQuestions.durationTwelveSusp200 = isChildrenVisible();
    visibleQuestions.ageKids = isKidsVisible();
    visibleQuestions.dosingfiveSusp200Age = isKidsVisible();
    visibleQuestions.sulffiveSusp200Age = isKidsVisible();
    visibleQuestions.durationfiveSusp200Age = isKidsVisible();
    visibleQuestions.weightKids = isKidsVisible();
    visibleQuestions.dosingfiveSusp200 = isKidsVisible();
    visibleQuestions.sulffiveSusp200 = isKidsVisible();
    visibleQuestions.dosingfiveSusp200Second = isKidsVisible();
    visibleQuestions.durationfiveSusp200 = isKidsVisible();
    visibleQuestions.ageBabies = isBabiesVisible();
    visibleQuestions.dosingfivelessSusp200Age = isBabiesVisible();
    visibleQuestions.sulffivelessSusp200Age = isBabiesVisible();
    visibleQuestions.durationfivelessSusp200Age = isBabiesVisible();
    visibleQuestions.weightBabies = isBabiesVisible();
    visibleQuestions.dosingfivelessSusp200 = isBabiesVisible();
    visibleQuestions.sulffivelessSusp200 = isBabiesVisible();
    visibleQuestions.dosingfivelessSusp200Second = isBabiesVisible();
    visibleQuestions.durationfivelessSusp200 = isBabiesVisible();
    visibleQuestions.kidneygrey = isAgeAdultOrTeen();
    visibleQuestions.kidneyyellow = isAgeAdultOrTeen();
    visibleQuestions.kidneyred = isAgeAdultOrTeen();
    visibleQuestions.kidneyChildren =
        !isAnswerAllVisible() && isAgeMatching('children');
    visibleQuestions.babiesKidney = isAgeBabieOrsKids();
    visibleQuestions.text = !isAnswerAllVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = isAnswerAllVisible();
    visibleSections.tabletsAdultsSmall = isAgeMatching('adults');
    visibleSections.tabletsAdults = isAgeMatching('adults');
    visibleSections.suspensionAdults = isAgeMatching('adults');
    visibleSections.twelveTabletsSmall = isTeensVisible();
    visibleSections.tabletsAdultsPrevent = isTeensVisible();
    visibleSections.suspensionTwelve400 = isTeensVisible();
    visibleSections.tabletsTwelveless = isChildrenVisible();
    visibleSections.tabletsTwelveless800 = isChildrenVisible();
    visibleSections.twelveSusp200 = isChildrenVisible();
    visibleSections.fiveSusp200 = isKidsVisible();
    visibleSections.fivelessSusp200 = isBabiesVisible();
    visibleSections.kidneySection = isAgeAdultOrTeen();
    visibleSections.childrenKidney =
        !isAnswerAllVisible() && isAgeMatching('children');
    visibleSections.kidneyBabies = isAgeBabieOrsKids();
    visibleSections.noteAntibiotics = !isAnswerAllVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return !isAnswerAllVisible();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
