"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    age: true,
    treatment: false,
    weight: false,
    weight2: false,
    weight3: false,
    weight4: false,
    textNoAnswer: true,
    dosingtabletsAdultsAcuteSmall: false,
    sulfAdults400: false,
    durationtabletsAdultsAcuteSmall: false,
    dosingtabletsAdultsAcute: false,
    sulfAdults800: false,
    durationtabletsAdultsAcute: false,
    dosingAdultsSuspension: false,
    sulfAdultsSuspension: false,
    durationAdultsSuspension: false,
    dosingtabletsTwelveSmall: false,
    sulfTablets400: false,
    durationtabletsTwelveSmall: false,
    dosingtabletsTwelve: false,
    sulfTablets800: false,
    durationtabletsTwelve: false,
    ageteens: false,
    dosingtwelveSuspensionAge: false,
    sulftwelveSuspensionAge: false,
    durationtwelveSuspensionAge: false,
    weightteens: false,
    dosingWarning: false,
    dosingtwelveSuspension: false,
    sulftwelveSuspension: false,
    durationtwelveSuspension: false,
    dosingtwelvelessTablets: false,
    sulfsuspensionChildren400: false,
    durationtwelvelessTablets: false,
    dosingtwelvelessTabletsSecond: false,
    sulfsuspensionChildren800: false,
    durationtwelvelessTabletsSecond: false,
    ageChildren200: false,
    dosingtwelvelessSuspensionSmall: false,
    sulftwelvelessSuspensionSmall: false,
    durationtwelvelessSuspensionSmall: false,
    weightChildren200: false,
    warningChidlren: false,
    dosingtwelvelessSuspension: false,
    sulftwelvelessSuspension: false,
    dosingtwelvelessSuspensionSecond: false,
    durationtwelvelessSuspension: false,
    ageKids: false,
    dosingfiveSuspensionSecond: false,
    sulffiveSuspensionSecond: false,
    durationfiveSuspensionSecond: false,
    weightKids: false,
    dosingfiveSuspension: false,
    sulffiveSuspension: false,
    dosingfiveSuspensionSecondHigh: false,
    durationfiveSuspension: false,
    ageBabies: false,
    dosingfivelessSuspensionSmall: false,
    sulffivelessSuspensionSmall: false,
    durationfivelessSuspensionSmall: false,
    weightBabies: false,
    dosingfivelessSuspension: false,
    sulffivelessSuspension: false,
    dosingfivelessSuspensionSecond: false,
    durationfivelessSuspension: false,
    dosingchronicTabletsSecond: false,
    sulfChronic400: false,
    durationchronicTabletsSecond: false,
    kineygrey: false,
    kidneyyellow: false,
    kidneyred: false,
    kidneyChildren: false,
    babiesKidney: false,
    text: false
};
var visibleSections = {
    selection: true,
    noAnswer: true,
    tabletsAdultsAcuteSmall: false,
    tabletsAdultsAcute: false,
    suspensionAdults: false,
    tabletsTwelveSmall: false,
    tabletsTwelve: false,
    twelveSuspension: false,
    twelvelessTablets: false,
    twelvelessTabletsSecond: false,
    twelvelessSuspension: false,
    fiveSuspension: false,
    fivelessSuspension: false,
    chronicTabletsSecond: false,
    kidneyAdults: false,
    childrenKidney: false,
    kidneyBabies: false,
    noteAntibiotics: false
};
var inputs = {
    age: null,
    treatment: null,
    weight: null,
    weight2: null,
    weight3: null,
    weight4: null
};
var isAgeMatching = function (name) {
    return helpers_1.answerMatches(inputs.age, name);
};
var isAnswerAllVisible = function () {
    return !((isAgeMatching('adults') && helpers_1.isAnswered(inputs.treatment)) ||
        (isAgeMatching('teens') &&
            (helpers_1.answerMatches(inputs.treatment, 'chronic') ||
                (helpers_1.answerMatches(inputs.treatment, 'acute') &&
                    helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 150 })))) ||
        (helpers_1.isAnswered(inputs.age) &&
            (helpers_1.numberInLimits({ input: inputs.weight2, min: 1, max: 70 }) ||
                helpers_1.numberInLimits({ input: inputs.weight3, min: 1, max: 30 }) ||
                helpers_1.numberInLimits({ input: inputs.weight4, min: 1, max: 12 }))));
};
var isAdultsAcuteVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'adults') &&
        helpers_1.answerMatches(inputs.treatment, 'acute'));
};
var isTeensAcuteVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'teens') &&
        helpers_1.answerMatches(inputs.treatment, 'acute') &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 150 }));
};
var isTeensAcuteDosingWarningVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'teens') &&
        helpers_1.answerMatches(inputs.treatment, 'acute') &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 53.4, max: 150 }));
};
var isChildrenVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'children') &&
        helpers_1.numberInLimits({ input: inputs.weight2, min: 1, max: 70 }));
};
var isChildrenWarningChidlrenVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'children') &&
        helpers_1.numberInLimits({ input: inputs.weight2, min: 35.6, max: 70 }));
};
var isKidsVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'kids') &&
        helpers_1.numberInLimits({ input: inputs.weight3, min: 1, max: 30 }));
};
var isBabiesVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'babies') &&
        helpers_1.numberInLimits({ input: inputs.weight4, min: 1, max: 12 }));
};
var isAgeAdultOrTeenCronic = function () {
    return (helpers_1.answerMatches(inputs.treatment, 'chronic') &&
        (isAgeMatching('teens') || isAgeMatching('adults')));
};
var isKidneyAdults = function () {
    return ((isAgeMatching('adults') && helpers_1.isAnswered(inputs.treatment)) ||
        isTeensAcuteVisible() ||
        (isAgeMatching('teens') && helpers_1.answerMatches(inputs.treatment, 'chronic')));
};
var calculatePoints = function () {
    var _a, _b, _c, _d;
    if (isTeensAcuteVisible()) {
        var weight = Number((_a = inputs === null || inputs === void 0 ? void 0 : inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints);
        var X = (weight * 3) / 16;
        var T = (weight * 30) / 2;
        var R = (weight * 6) / 2;
        return {
            dosingtwelveSuspension: {
                qID: 'dosingtwelveSuspension',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(X, 1), 0, 1)),
                titleTexts: 'result1'
            },
            sulftwelveSuspension: {
                qID: 'sulftwelveSuspension',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T, 1), 0, 1)),
                titleTexts: 'result1',
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(R, 1), 0, 1)),
                resultTexts: 'result1'
            }
        };
    }
    if (isChildrenVisible()) {
        var weight = Number((_b = inputs === null || inputs === void 0 ? void 0 : inputs.weight2) === null || _b === void 0 ? void 0 : _b.currentPoints);
        var X = (weight * 3) / 8;
        var T = (weight * 30) / 2;
        var R = (weight * 6) / 2;
        var T1 = (weight * 9) / 16;
        var T2 = (weight * 45) / 2;
        var T3 = (weight * 9) / 2;
        return {
            dosingtwelvelessSuspension: {
                qID: 'dosingtwelvelessSuspension',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(X, 1), 0, 1)),
                titleTexts: 'result1'
            },
            sulftwelvelessSuspension: {
                qID: 'sulftwelvelessSuspension',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T, 1), 0, 1)),
                titleTexts: 'result1',
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(R, 1), 0, 1)),
                resultTexts: 'result1'
            },
            dosingtwelvelessSuspensionSecond: {
                qID: 'dosingtwelvelessSuspensionSecond',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T1, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T2, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T3, 1), 0, 1)),
                titleTexts: 'result1'
            }
        };
    }
    if (isKidsVisible()) {
        var weight = Number((_c = inputs === null || inputs === void 0 ? void 0 : inputs.weight3) === null || _c === void 0 ? void 0 : _c.currentPoints);
        var X = (weight * 3) / 8;
        var T = (weight * 30) / 2;
        var R = (weight * 6) / 2;
        var T1 = (weight * 9) / 16;
        var T2 = (weight * 45) / 2;
        var T3 = (weight * 9) / 2;
        return {
            dosingfiveSuspension: {
                qID: 'dosingfiveSuspension',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(X, 1), 0, 1)),
                titleTexts: 'result1'
            },
            sulffiveSuspension: {
                qID: 'sulffiveSuspension',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T, 1), 0, 1)),
                titleTexts: 'result1',
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(R, 1), 0, 1)),
                resultTexts: 'result1'
            },
            dosingfiveSuspensionSecondHigh: {
                qID: 'dosingfiveSuspensionSecondHigh',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T1, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T2, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T3, 1), 0, 1)),
                titleTexts: 'result1'
            }
        };
    }
    if (isBabiesVisible()) {
        var weight = Number((_d = inputs === null || inputs === void 0 ? void 0 : inputs.weight4) === null || _d === void 0 ? void 0 : _d.currentPoints);
        var X = (weight * 3) / 8;
        var T = (weight * 30) / 2;
        var R = (weight * 6) / 2;
        var T1 = (weight * 9) / 16;
        var T2 = (weight * 45) / 2;
        var T3 = (weight * 9) / 2;
        return {
            dosingfivelessSuspension: {
                qID: 'dosingfivelessSuspension',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(X, 1), 0, 1)),
                titleTexts: 'result1'
            },
            sulffivelessSuspension: {
                qID: 'sulffivelessSuspension',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T, 1), 0, 1)),
                titleTexts: 'result1',
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(R, 1), 0, 1)),
                resultTexts: 'result1'
            },
            dosingfivelessSuspensionSecond: {
                qID: 'dosingfivelessSuspensionSecond',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T1, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T2, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(T3, 1), 0, 1)),
                titleTexts: 'result1'
            }
        };
    }
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.treatment =
        isAgeMatching('adults') || isAgeMatching('teens');
    visibleQuestions.weight =
        isAgeMatching('teens') && helpers_1.answerMatches(inputs.treatment, 'acute');
    visibleQuestions.weight2 = isAgeMatching('children');
    visibleQuestions.weight3 = isAgeMatching('kids');
    visibleQuestions.weight4 = isAgeMatching('babies');
    visibleQuestions.textNoAnswer = isAnswerAllVisible();
    visibleQuestions.dosingtabletsAdultsAcuteSmall = isAdultsAcuteVisible();
    visibleQuestions.sulfAdults400 = isAdultsAcuteVisible();
    visibleQuestions.durationtabletsAdultsAcuteSmall = isAdultsAcuteVisible();
    visibleQuestions.dosingtabletsAdultsAcute = isAdultsAcuteVisible();
    visibleQuestions.sulfAdults800 = isAdultsAcuteVisible();
    visibleQuestions.durationtabletsAdultsAcute = isAdultsAcuteVisible();
    visibleQuestions.dosingAdultsSuspension = isAdultsAcuteVisible();
    visibleQuestions.sulfAdultsSuspension = isAdultsAcuteVisible();
    visibleQuestions.durationAdultsSuspension = isAdultsAcuteVisible();
    visibleQuestions.dosingtabletsTwelveSmall = isTeensAcuteVisible();
    visibleQuestions.sulfTablets400 = isTeensAcuteVisible();
    visibleQuestions.durationtabletsTwelveSmall = isTeensAcuteVisible();
    visibleQuestions.dosingtabletsTwelve = isTeensAcuteVisible();
    visibleQuestions.sulfTablets800 = isTeensAcuteVisible();
    visibleQuestions.durationtabletsTwelve = isTeensAcuteVisible();
    visibleQuestions.ageteens = isTeensAcuteVisible();
    visibleQuestions.dosingtwelveSuspensionAge = isTeensAcuteVisible();
    visibleQuestions.sulftwelveSuspensionAge = isTeensAcuteVisible();
    visibleQuestions.durationtwelveSuspensionAge = isTeensAcuteVisible();
    visibleQuestions.weightteens = isTeensAcuteVisible();
    visibleQuestions.dosingWarning = isTeensAcuteDosingWarningVisible();
    visibleQuestions.dosingtwelveSuspension = isTeensAcuteVisible();
    visibleQuestions.sulftwelveSuspension = isTeensAcuteVisible();
    visibleQuestions.durationtwelveSuspension = isTeensAcuteVisible();
    visibleQuestions.dosingtwelvelessTablets = isChildrenVisible();
    visibleQuestions.sulfsuspensionChildren400 = isChildrenVisible();
    visibleQuestions.durationtwelvelessTablets = isChildrenVisible();
    visibleQuestions.dosingtwelvelessTabletsSecond = isChildrenVisible();
    visibleQuestions.sulfsuspensionChildren800 = isChildrenVisible();
    visibleQuestions.durationtwelvelessTabletsSecond = isChildrenVisible();
    visibleQuestions.ageChildren200 = isChildrenVisible();
    visibleQuestions.dosingtwelvelessSuspensionSmall = isChildrenVisible();
    visibleQuestions.sulftwelvelessSuspensionSmall = isChildrenVisible();
    visibleQuestions.durationtwelvelessSuspensionSmall = isChildrenVisible();
    visibleQuestions.weightChildren200 = isChildrenVisible();
    visibleQuestions.warningChidlren = isChildrenWarningChidlrenVisible();
    visibleQuestions.dosingtwelvelessSuspension = isChildrenVisible();
    visibleQuestions.sulftwelvelessSuspension = isChildrenVisible();
    visibleQuestions.dosingtwelvelessSuspensionSecond = isChildrenVisible();
    visibleQuestions.durationtwelvelessSuspension = isChildrenVisible();
    visibleQuestions.ageKids = isKidsVisible();
    visibleQuestions.dosingfiveSuspensionSecond = isKidsVisible();
    visibleQuestions.sulffiveSuspensionSecond = isKidsVisible();
    visibleQuestions.durationfiveSuspensionSecond = isKidsVisible();
    visibleQuestions.weightKids = isKidsVisible();
    visibleQuestions.dosingfiveSuspension = isKidsVisible();
    visibleQuestions.sulffiveSuspension = isKidsVisible();
    visibleQuestions.dosingfiveSuspensionSecondHigh = isKidsVisible();
    visibleQuestions.durationfiveSuspension = isKidsVisible();
    visibleQuestions.ageBabies = isBabiesVisible();
    visibleQuestions.dosingfivelessSuspensionSmall = isBabiesVisible();
    visibleQuestions.sulffivelessSuspensionSmall = isBabiesVisible();
    visibleQuestions.durationfivelessSuspensionSmall = isBabiesVisible();
    visibleQuestions.weightBabies = isBabiesVisible();
    visibleQuestions.dosingfivelessSuspension = isBabiesVisible();
    visibleQuestions.sulffivelessSuspension = isBabiesVisible();
    visibleQuestions.dosingfivelessSuspensionSecond = isBabiesVisible();
    visibleQuestions.durationfivelessSuspension = isBabiesVisible();
    visibleQuestions.dosingchronicTabletsSecond = isAgeAdultOrTeenCronic();
    visibleQuestions.sulfChronic400 = isAgeAdultOrTeenCronic();
    visibleQuestions.durationchronicTabletsSecond = isAgeAdultOrTeenCronic();
    visibleQuestions.kineygrey = isKidneyAdults();
    visibleQuestions.kidneyyellow = isKidneyAdults();
    visibleQuestions.kidneyred = isKidneyAdults();
    visibleQuestions.kidneyChildren =
        !isAnswerAllVisible() && isAgeMatching('children');
    visibleQuestions.babiesKidney =
        !isAnswerAllVisible() && (isAgeMatching('babies') || isAgeMatching('kids'));
    visibleQuestions.text = !isAnswerAllVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = isAnswerAllVisible();
    visibleSections.tabletsAdultsAcuteSmall = isAdultsAcuteVisible();
    visibleSections.tabletsAdultsAcute = isAdultsAcuteVisible();
    visibleSections.suspensionAdults = isAdultsAcuteVisible();
    visibleSections.tabletsTwelveSmall = isTeensAcuteVisible();
    visibleSections.tabletsTwelve = isTeensAcuteVisible();
    visibleSections.twelveSuspension = isTeensAcuteVisible();
    visibleSections.twelvelessTablets = isChildrenVisible();
    visibleSections.twelvelessTabletsSecond = isChildrenVisible();
    visibleSections.twelvelessSuspension = isChildrenVisible();
    visibleSections.fiveSuspension = isKidsVisible();
    visibleSections.fivelessSuspension = isBabiesVisible();
    visibleSections.chronicTabletsSecond = isAgeAdultOrTeenCronic();
    visibleSections.kidneyAdults = isKidneyAdults();
    visibleSections.childrenKidney =
        !isAnswerAllVisible() && isAgeMatching('children');
    visibleSections.kidneyBabies =
        !isAnswerAllVisible() && (isAgeMatching('babies') || isAgeMatching('kids'));
    visibleSections.noteAntibiotics = !isAnswerAllVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return !isAnswerAllVisible();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
