"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};

var visibleQuestions = {
    intendedUse: true,
    age: true,
    weightA: true,
    weightAD: true,
    weightK: true,
    result121: true,
    result221: true,
    result231: true,
    result232: true,
    result233: true,
    result241: true,
    result251: true,
    result321: true,
    result322: true,
    result323: true,
    result331: true,
    result341: true,
    result421: true,
    result431: true,
    result521: true,
    result531: true,
    result541: true,
    result621: true,
    result631: true,
    linkToSpc1: true,
    linkToSpc2: true
};
var visibleSections = {
    section1: true,
    result12: true,
    result22: true,
    result23: true,
    result24: true,
    result25: true,
    result32: true,
    result33: true,
    result34: true,
    result42: true,
    result43: true,
    result52: true,
    result53: true,
    result54: true,
    result62: true,
    result63: true,
    toolAdditionalInfoSection: true
};
var inputs = {
    intendedUse: null,
    age: null,
    weightA: null,
    weightAD: null,
    weightK: null
};
var weightAValid = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.weightA) &&
        Number((_a = inputs.weightA) === null || _a === void 0 ? void 0 : _a.currentPoints) > 0 &&
        Number((_b = inputs.weightA) === null || _b === void 0 ? void 0 : _b.currentPoints) <= 300);
};
var weightADValid = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.weightAD) &&
        Number((_a = inputs.weightAD) === null || _a === void 0 ? void 0 : _a.currentPoints) > 0 &&
        Number((_b = inputs.weightAD) === null || _b === void 0 ? void 0 : _b.currentPoints) <= 50);
};
var weightKValid = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.weightK) &&
        Number((_a = inputs.weightK) === null || _a === void 0 ? void 0 : _a.currentPoints) > 0 &&
        Number((_b = inputs.weightK) === null || _b === void 0 ? void 0 : _b.currentPoints) <= 30);
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q;
    var result = {
        number: null,
        range: null
    };
    if (helpers_1.isAnswered(inputs.intendedUse) && helpers_1.isAnswered(inputs.age)) {
        if (weightAValid() || weightADValid()) {
            var activeWeight = helpers_1.isAnswered(inputs.weightA)
                ? Number((_a = inputs.weightA) === null || _a === void 0 ? void 0 : _a.currentPoints)
                : Number((_b = inputs.weightAD) === null || _b === void 0 ? void 0 : _b.currentPoints);
            result = __assign(__assign({}, result), (isResultsRange2Visible() && {
                result221: {
                    qID: "result221",
                    tParams: __spreadArrays(helpers_1.returnNumberObject(activeWeight * 100, 0, 1), helpers_1.returnNumberObject(activeWeight * 20, 0, 1)),
                    titleTexts: "regular"
                },
                result231: {
                    qID: "result231",
                    tParams: __spreadArrays(helpers_1.returnNumberObject((activeWeight * 100) / 40 / 4, 0, 1)),
                    titleTexts: "regular"
                },
                result232: {
                    qID: "result232",
                    tParams: __spreadArrays(helpers_1.returnNumberObject((activeWeight * 100) / 4, 0, 1), helpers_1.returnNumberObject(activeWeight * 100, 0, 1)),
                    titleTexts: "regular"
                },
                result233: {
                    qID: "result233",
                    tParams: __spreadArrays(helpers_1.returnNumberObject((activeWeight * 20) / 4, 0, 1), helpers_1.returnNumberObject(activeWeight * 20, 0, 1)),
                    titleTexts: "regular"
                }
            }));
        }
        if (isResultsRange3Visible()) {
            result = __assign(__assign({}, result), { result321: {
                    qID: "result321",
                    tParams: __spreadArrays(helpers_1.returnNumberObject((Number((_c = inputs.weightK) === null || _c === void 0 ? void 0 : _c.currentPoints) * 100) / 40 / 4, 0, 1)),
                    titleTexts: "regular"
                }, result322: {
                    qID: "result322",
                    tParams: __spreadArrays(helpers_1.returnNumberObject((Number((_d = inputs.weightK) === null || _d === void 0 ? void 0 : _d.currentPoints) * 100) / 4, 0, 1), helpers_1.returnNumberObject(Number((_e = inputs.weightK) === null || _e === void 0 ? void 0 : _e.currentPoints) * 100, 0, 1)),
                    titleTexts: "regular"
                }, result323: {
                    qID: "result323",
                    tParams: __spreadArrays(helpers_1.returnNumberObject((Number((_f = inputs.weightK) === null || _f === void 0 ? void 0 : _f.currentPoints) * 20) / 4, 0, 1), helpers_1.returnNumberObject(Number((_g = inputs.weightK) === null || _g === void 0 ? void 0 : _g.currentPoints) * 20, 0, 1)),
                    titleTexts: "regular"
                } });
        }
        if (isResultsRange5Visible()) {
            result = __assign(__assign({}, result), { result521: {
                    qID: "result521",
                    tParams: __spreadArrays(helpers_1.returnNumberObject(Number((_h = inputs.weightAD) === null || _h === void 0 ? void 0 : _h.currentPoints) * 30, 0, 1), helpers_1.returnNumberObject(Number((_j = inputs.weightAD) === null || _j === void 0 ? void 0 : _j.currentPoints) * 6, 0, 1)),
                    titleTexts: "regular"
                }, result531: {
                    qID: "result531",
                    tParams: __spreadArrays(helpers_1.returnNumberObject((Number((_k = inputs.weightAD) === null || _k === void 0 ? void 0 : _k.currentPoints) * 30) / 40, 0, 1), helpers_1.returnNumberObject(Number((_l = inputs.weightAD) === null || _l === void 0 ? void 0 : _l.currentPoints) * 30, 0, 1), helpers_1.returnNumberObject(Number((_m = inputs.weightAD) === null || _m === void 0 ? void 0 : _m.currentPoints) * 6, 0, 1)),
                    titleTexts: "regular"
                } });
        }
        if (isResultsRange6Visible()) {
            result = __assign(__assign({}, result), { result621: {
                    qID: "result621",
                    tParams: __spreadArrays(helpers_1.returnNumberObject((Number((_o = inputs.weightK) === null || _o === void 0 ? void 0 : _o.currentPoints) * 30) / 40, 0, 1), helpers_1.returnNumberObject(Number((_p = inputs.weightK) === null || _p === void 0 ? void 0 : _p.currentPoints) * 30, 0, 1), helpers_1.returnNumberObject(Number((_q = inputs.weightK) === null || _q === void 0 ? void 0 : _q.currentPoints) * 6, 0, 1)),
                    titleTexts: "regular"
                } });
        }
    }
    return result;
};
var isAgeVisible = function () {
    return helpers_1.isAnswered(inputs.intendedUse);
};
var isWeightAVisible = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.intendedUse) &&
        ((_a = inputs.intendedUse) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "treat" &&
        helpers_1.isAnswered(inputs.age) &&
        ((_b = inputs.age) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "twelve");
};
var isWeightADVisible = function () {
    var _a;
    return (helpers_1.isAnswered(inputs.intendedUse) &&
        helpers_1.isAnswered(inputs.age) &&
        ((_a = inputs.age) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "sixToTwelve");
};
var isWeightKVisible = function () {
    var _a;
    return (helpers_1.isAnswered(inputs.intendedUse) &&
        helpers_1.isAnswered(inputs.age) &&
        ((_a = inputs.age) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "six");
};
var isAnswerAllVisible = function () {
    var _a, _b, _c;
    if (!helpers_1.isAnswered(inputs.intendedUse) || !helpers_1.isAnswered(inputs.age))
        return true;
    if (((_a = inputs.age) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "six") {
        return !weightKValid();
    }
    if (((_b = inputs.intendedUse) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "prevent" &&
        ((_c = inputs.age) === null || _c === void 0 ? void 0 : _c.currentIdentifier) === "twelve") {
        return false;
    }
    return !weightAValid() && !weightADValid();
};
var isResultsRange2Visible = function () {
    var _a, _b, _c;
    return (helpers_1.isAnswered(inputs.intendedUse) &&
        ((_a = inputs.intendedUse) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "treat" &&
        helpers_1.isAnswered(inputs.age) &&
        (((_b = inputs.age) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "twelve" ||
            ((_c = inputs.age) === null || _c === void 0 ? void 0 : _c.currentIdentifier) === "sixToTwelve") &&
        (weightAValid() || weightADValid()));
};
var isResultsRange3Visible = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.intendedUse) &&
        ((_a = inputs.intendedUse) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "treat" &&
        helpers_1.isAnswered(inputs.age) &&
        ((_b = inputs.age) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "six" &&
        weightKValid());
};
var isResultsRange4Visible = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.intendedUse) &&
        ((_a = inputs.intendedUse) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "prevent" &&
        helpers_1.isAnswered(inputs.age) &&
        ((_b = inputs.age) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "twelve");
};
var isResultsRange5Visible = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.intendedUse) &&
        ((_a = inputs.intendedUse) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "prevent" &&
        helpers_1.isAnswered(inputs.age) &&
        ((_b = inputs.age) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "sixToTwelve" &&
        weightADValid());
};
var isResultsRange6Visible = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.intendedUse) &&
        ((_a = inputs.intendedUse) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "prevent" &&
        helpers_1.isAnswered(inputs.age) &&
        ((_b = inputs.age) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "six" &&
        weightKValid());
};
var returnVisibleQuestions = function () {
    visibleQuestions.age = isAgeVisible();
    visibleQuestions.weightA = isWeightAVisible();
    visibleQuestions.weightAD = isWeightADVisible();
    visibleQuestions.weightK = isWeightKVisible();
    visibleQuestions.result121 = isAnswerAllVisible();
    visibleQuestions.result221 = isResultsRange2Visible();
    visibleQuestions.result231 = isResultsRange2Visible();
    visibleQuestions.result232 = isResultsRange2Visible();
    visibleQuestions.result233 = isResultsRange2Visible();
    visibleQuestions.result241 = isResultsRange2Visible();
    visibleQuestions.result251 = isResultsRange2Visible();
    visibleQuestions.result321 = isResultsRange3Visible();
    visibleQuestions.result322 = isResultsRange3Visible();
    visibleQuestions.result323 = isResultsRange3Visible();
    visibleQuestions.result331 = isResultsRange3Visible();
    visibleQuestions.result341 = isResultsRange3Visible();
    visibleQuestions.result421 = isResultsRange4Visible();
    visibleQuestions.result431 = isResultsRange4Visible();
    visibleQuestions.result521 = isResultsRange5Visible();
    visibleQuestions.result531 = isResultsRange5Visible();
    visibleQuestions.result541 = isResultsRange5Visible();
    visibleQuestions.result621 = isResultsRange6Visible();
    visibleQuestions.result631 = isResultsRange6Visible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.result12 = isAnswerAllVisible();
    visibleSections.result22 = isResultsRange2Visible();
    visibleSections.result23 = isResultsRange2Visible();
    visibleSections.result24 = isResultsRange2Visible();
    visibleSections.result25 = isResultsRange2Visible();
    visibleSections.result32 = isResultsRange3Visible();
    visibleSections.result33 = isResultsRange3Visible();
    visibleSections.result34 = isResultsRange3Visible();
    visibleSections.result42 = isResultsRange4Visible();
    visibleSections.result43 = isResultsRange4Visible();
    visibleSections.result52 = isResultsRange5Visible();
    visibleSections.result53 = isResultsRange5Visible();
    visibleSections.result54 = isResultsRange5Visible();
    visibleSections.result62 = isResultsRange6Visible();
    visibleSections.result63 = isResultsRange6Visible();
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return !isAnswerAllVisible();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
