"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    age: true,
    intendedUse: false,
    weight1: false,
    height1: false,
    weight2: false,
    height2: false,
    weight3: false,
    height3: false,
    weight4: false,
    weight5: false,
    resultAnswerAll: true,
    testNewborns: true,
    treatKidsText: true,
    warningExceedAdultsSecond: false,
    dosingAdultsTreatSecondText: true,
    durationAdultsTreatSecond: true,
    warningExceedAdults: false,
    dosingAdultsTreatText: true,
    sulfAdultsTreat: true,
    durationAdultsTreat: true,
    dosingBabiesPrevention: true,
    sulfBabiesPrevention: true,
    durationBabiesPrevention: true,
    dosingKidsPrevention: true,
    sulfKidsPrevention: true,
    durationKidsPrevention: true,
    dosingchildrenPrevention: true,
    sulfchildrenPrevention: true,
    durationChildrenPrevention: true,
    dosingadultsPreventionTablets: true,
    sulfadultsPreventionTablets: true,
    durationAdultPreventionTablets: true,
    adultsPreventionTabletsLowText: true,
    kidneyInfo: true,
    kidneyGrey: false,
    kidneyYellow: false,
    kidneyRed: false,
    antibioticsText: true
};
var visibleSections = {
    section1: true,
    noAnswer: false,
    newbornsSection: false,
    treatKids: false,
    dosingAdultsTreatSecond: false,
    dosingAdultsTreat: false,
    babiesPrevention: false,
    kidsPrevention: false,
    childrenPrevention: false,
    adultsPreventionTablets: false,
    adultsPreventionTabletsLow: false,
    kidneySection: false,
    antibioticsSection: false
};
var inputs = {
    age: null,
    intendedUse: null,
    weight1: null,
    height1: null,
    weight2: null,
    height2: null,
    weight3: null,
    height3: null,
    weight4: null,
    weight5: null,
    kidneyInfo: null
};
var isTreatKidsVisible = function () {
    var condition1 = helpers_1.answerMatches(inputs.age, 'babies') ||
        helpers_1.answerMatches(inputs.age, 'kids') ||
        helpers_1.answerMatches(inputs.age, 'children');
    var condition2 = helpers_1.answerMatches(inputs.intendedUse, 'treat');
    return condition1 && condition2;
};
var isDosingAdultsTreatSecondVisible = function () {
    return (helpers_1.answerMatches(inputs.intendedUse, 'treat') &&
        helpers_1.numberInLimits({
            input: inputs.weight4,
            min: 32,
            max: 200
        }));
};
var isDosingAdultsTreatVisible = function () {
    return (helpers_1.answerMatches(inputs.intendedUse, 'treat') &&
        helpers_1.numberInLimits({
            input: inputs.weight4,
            min: 1,
            max: 200
        }));
};
var isBabiesPreventionVisible = function () {
    return (helpers_1.numberInLimits({
        input: inputs.weight1,
        min: 1,
        max: 12
    }) &&
        helpers_1.numberInLimits({
            input: inputs.height1,
            min: 1,
            max: 80
        }));
};
var isKidsPreventionVisible = function () {
    return (helpers_1.numberInLimits({
        input: inputs.weight2,
        min: 1,
        max: 30
    }) &&
        helpers_1.numberInLimits({
            input: inputs.height2,
            min: 1,
            max: 130
        }));
};
var isChildrenPreventionVisible = function () {
    return (helpers_1.numberInLimits({
        input: inputs.weight3,
        min: 1,
        max: 70
    }) &&
        helpers_1.numberInLimits({
            input: inputs.height3,
            min: 1,
            max: 170
        }));
};
var isAdultsPreventionTabletsVisible = function () {
    return (helpers_1.answerMatches(inputs.intendedUse, 'prevent') &&
        helpers_1.answerMatches(inputs.weight5, 'big'));
};
var isAdultsPreventionTabletsLowVisible = function () {
    return (helpers_1.answerMatches(inputs.intendedUse, 'prevent') &&
        helpers_1.answerMatches(inputs.weight5, 'small'));
};
var isIntendedUseAnsweredIfVisible = function () {
    return !helpers_1.answerMatches(inputs.age, 'newborns')
        ? helpers_1.isAnswered(inputs.intendedUse)
        : true;
};
var isAgeBabiesAndIntendedUsePrevent = function () {
    return (helpers_1.answerMatches(inputs.age, 'babies') &&
        helpers_1.answerMatches(inputs.intendedUse, 'prevent'));
};
var isAgeKidsAndIntendedUsePrevent = function () {
    return (helpers_1.answerMatches(inputs.age, 'kids') &&
        helpers_1.answerMatches(inputs.intendedUse, 'prevent'));
};
var isAgeChildrenAndIntendedUsePrevent = function () {
    return (helpers_1.answerMatches(inputs.age, 'children') &&
        helpers_1.answerMatches(inputs.intendedUse, 'prevent'));
};
var isAgeAdultsAndIntendedUsePrevent = function () {
    return (helpers_1.answerMatches(inputs.age, 'adults') &&
        helpers_1.answerMatches(inputs.intendedUse, 'prevent'));
};
var isAgeAdultsAndIntendedUseTreat = function () {
    return (helpers_1.answerMatches(inputs.age, 'adults') &&
        helpers_1.answerMatches(inputs.intendedUse, 'treat'));
};
var isWeight1AnsweredIfVisible = function () {
    return isAgeBabiesAndIntendedUsePrevent()
        ? helpers_1.numberInLimits({
            input: inputs.weight1,
            min: 1,
            max: 12
        })
        : true;
};
var isHeight1AnsweredIfVisible = function () {
    return isAgeBabiesAndIntendedUsePrevent()
        ? helpers_1.numberInLimits({
            input: inputs.height1,
            min: 1,
            max: 80
        })
        : true;
};
var isWeight2AnsweredIfVisible = function () {
    return isAgeKidsAndIntendedUsePrevent()
        ? helpers_1.numberInLimits({
            input: inputs.weight2,
            min: 1,
            max: 30
        })
        : true;
};
var isHeight2AnsweredIfVisible = function () {
    return isAgeKidsAndIntendedUsePrevent()
        ? helpers_1.numberInLimits({
            input: inputs.height2,
            min: 1,
            max: 130
        })
        : true;
};
var isWeight3AnsweredIfVisible = function () {
    return isAgeChildrenAndIntendedUsePrevent()
        ? helpers_1.numberInLimits({
            input: inputs.weight3,
            min: 1,
            max: 70
        })
        : true;
};
var isHeight3AnsweredIfVisible = function () {
    return isAgeChildrenAndIntendedUsePrevent()
        ? helpers_1.numberInLimits({
            input: inputs.height3,
            min: 1,
            max: 170
        })
        : true;
};
var isWeight4AnsweredIfVisible = function () {
    return isAgeAdultsAndIntendedUseTreat()
        ? helpers_1.numberInLimits({
            input: inputs.weight4,
            min: 1,
            max: 200
        })
        : true;
};
var isWeight5AnsweredIfVisible = function () {
    return isAgeAdultsAndIntendedUsePrevent() ? helpers_1.isAnswered(inputs.weight5) : true;
};
var areVisibleQuestionsAnswered = function () {
    return (helpers_1.isAnswered(inputs.age) &&
        isIntendedUseAnsweredIfVisible() &&
        isWeight1AnsweredIfVisible() &&
        isHeight1AnsweredIfVisible() &&
        isWeight2AnsweredIfVisible() &&
        isHeight2AnsweredIfVisible() &&
        isWeight3AnsweredIfVisible() &&
        isHeight3AnsweredIfVisible() &&
        isWeight4AnsweredIfVisible() &&
        isWeight5AnsweredIfVisible());
};
var isKidneySectionVisible = function () {
    var condition1 = helpers_1.answerMatches(inputs.intendedUse, 'treat') &&
        helpers_1.numberInLimits({
            input: inputs.weight4,
            min: 1,
            max: 200
        });
    var condition2 = helpers_1.answerMatches(inputs.age, 'babies') ||
        helpers_1.answerMatches(inputs.age, 'kids') ||
        helpers_1.answerMatches(inputs.age, 'children');
    var condition3 = helpers_1.answerMatches(inputs.intendedUse, 'prevent') &&
        areVisibleQuestionsAnswered();
    var condition4 = helpers_1.answerMatches(inputs.age, 'adults') &&
        helpers_1.answerMatches(inputs.intendedUse, 'prevent') &&
        helpers_1.answerMatches(inputs.weight5, 'big');
    return condition1 || (condition2 && condition3) || condition4;
};
var isWarningExceedAdultsSecondVisible = function () {
    return (helpers_1.answerMatches(inputs.intendedUse, 'treat') &&
        helpers_1.numberInLimits({
            input: inputs.weight4,
            min: 100.01,
            max: 200
        }));
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p;
    if (isDosingAdultsTreatSecondVisible()) {
        var dosingAdultsResult1 = Number((_a = inputs.weight4) === null || _a === void 0 ? void 0 : _a.currentPoints) * 25;
        var dosingAdultsResult2 = Number((_b = inputs.weight4) === null || _b === void 0 ? void 0 : _b.currentPoints) * 5;
        var dosingAdultsTreatResult = (Number((_c = inputs.weight4) === null || _c === void 0 ? void 0 : _c.currentPoints) * 25) / 80;
        var trimetoprimResult = Number((_d = inputs.weight4) === null || _d === void 0 ? void 0 : _d.currentPoints) * 5;
        var sulfametoxazoloResult = Number((_e = inputs.weight4) === null || _e === void 0 ? void 0 : _e.currentPoints) * 25;
        return {
            dosingAdultsTreatSecondText: {
                qID: 'dosingAdultsTreatSecondText',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(dosingAdultsResult1, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(dosingAdultsResult2, 1), 0, 1)),
                titleTexts: 'result1'
            },
            dosingAdultsTreatText: {
                qID: 'dosingAdultsTreatText',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(dosingAdultsTreatResult, 1), 0, 1)),
                titleTexts: 'result1'
            },
            sulfAdultsTreat: {
                qID: 'sulfAdultsTreat',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(sulfametoxazoloResult, 1), 0, 1)),
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(trimetoprimResult, 1), 0, 1)),
                titleTexts: 'result1',
                resultTexts: 'result1'
            }
        };
    }
    if (isDosingAdultsTreatVisible()) {
        var dosingAdultsTreatResult = (Number((_f = inputs.weight4) === null || _f === void 0 ? void 0 : _f.currentPoints) * 25) / 80;
        var trimetoprimResult = Number((_g = inputs.weight4) === null || _g === void 0 ? void 0 : _g.currentPoints) * 5;
        var sulfametoxazoloResult = Number((_h = inputs.weight4) === null || _h === void 0 ? void 0 : _h.currentPoints) * 25;
        return {
            dosingAdultsTreatText: {
                qID: 'dosingAdultsTreatText',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(dosingAdultsTreatResult, 1), 0, 1)),
                titleTexts: 'result1'
            },
            sulfAdultsTreat: {
                qID: 'sulfAdultsTreat',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(sulfametoxazoloResult, 1), 0, 1)),
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(trimetoprimResult, 1), 0, 1)),
                titleTexts: 'result1',
                resultTexts: 'result1'
            }
        };
    }
    if (isBabiesPreventionVisible()) {
        var height1 = Number((_j = inputs.height1) === null || _j === void 0 ? void 0 : _j.currentPoints);
        var weight1 = Number((_k = inputs.weight1) === null || _k === void 0 ? void 0 : _k.currentPoints);
        var resultBSA = Math.sqrt((height1 * weight1) / 3600);
        var dosingBabiesResult = (resultBSA * 375) / 80;
        var sulfametoxazoloResult = (resultBSA * 750) / 2;
        var trimetoprimResult = (resultBSA * 150) / 2;
        return {
            dosingBabiesPrevention: {
                qID: 'dosingBabiesPrevention',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(dosingBabiesResult, 1), 0, 1)),
                rParams: [],
                titleTexts: 'result1',
                resultTexts: 'result1'
            },
            sulfBabiesPrevention: {
                qID: 'sulfBabiesPrevention',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(sulfametoxazoloResult, 1), 0, 1)),
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(trimetoprimResult, 1), 0, 1)),
                titleTexts: 'result1',
                resultTexts: 'result1'
            }
        };
    }
    if (isKidsPreventionVisible()) {
        var height2 = Number((_l = inputs.height2) === null || _l === void 0 ? void 0 : _l.currentPoints);
        var weight2 = Number((_m = inputs.weight2) === null || _m === void 0 ? void 0 : _m.currentPoints);
        var resultBSA = Math.sqrt((height2 * weight2) / 3600);
        var dosingKidsResult = (resultBSA * 375) / 80;
        var sulfametoxazoloResult = (resultBSA * 750) / 2;
        var trimetoprimResult = (resultBSA * 150) / 2;
        return {
            dosingKidsPrevention: {
                qID: 'dosingKidsPrevention',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(dosingKidsResult, 1), 0, 1)),
                rParams: [],
                titleTexts: 'result1',
                resultTexts: 'result1'
            },
            sulfKidsPrevention: {
                qID: 'sulfKidsPrevention',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(sulfametoxazoloResult, 1), 0, 1)),
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(trimetoprimResult, 1), 0, 1)),
                titleTexts: 'result1',
                resultTexts: 'result1'
            }
        };
    }
    if (isChildrenPreventionVisible()) {
        var height3 = Number((_o = inputs.height3) === null || _o === void 0 ? void 0 : _o.currentPoints);
        var weight3 = Number((_p = inputs.weight3) === null || _p === void 0 ? void 0 : _p.currentPoints);
        var resultBSA = Math.sqrt((height3 * weight3) / 3600);
        var dosingChildrenResult = resultBSA > 2.133 ? 10 : (resultBSA * 375) / 80;
        var sulfametoxazoloResult = (resultBSA * 750) / 2;
        var trimetoprimResult = (resultBSA * 150) / 2;
        return {
            dosingchildrenPrevention: {
                qID: 'dosingchildrenPrevention',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(dosingChildrenResult, 1), 0, 1)),
                rParams: [],
                titleTexts: 'result1',
                resultTexts: 'result1'
            },
            sulfchildrenPrevention: {
                qID: 'sulfchildrenPrevention',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(sulfametoxazoloResult, 1), 0, 1)),
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(trimetoprimResult, 1), 0, 1)),
                titleTexts: 'result1',
                resultTexts: 'result1'
            }
        };
    }
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.intendedUse =
        !helpers_1.answerMatches(inputs.age, 'newborns') && helpers_1.isAnswered(inputs.age);
    visibleQuestions.weight1 = isAgeBabiesAndIntendedUsePrevent();
    visibleQuestions.height1 = isAgeBabiesAndIntendedUsePrevent();
    visibleQuestions.weight2 = isAgeKidsAndIntendedUsePrevent();
    visibleQuestions.height2 = isAgeKidsAndIntendedUsePrevent();
    visibleQuestions.weight3 = isAgeChildrenAndIntendedUsePrevent();
    visibleQuestions.height3 = isAgeChildrenAndIntendedUsePrevent();
    visibleQuestions.weight4 = isAgeAdultsAndIntendedUseTreat();
    visibleQuestions.weight5 = isAgeAdultsAndIntendedUsePrevent();
    visibleQuestions.warningExceedAdultsSecond =
        isWarningExceedAdultsSecondVisible();
    visibleQuestions.warningExceedAdults = isWarningExceedAdultsSecondVisible();
    visibleQuestions.kidneyGrey =
        isKidneySectionVisible() && helpers_1.answerMatches(inputs.kidneyInfo, 'close');
    visibleQuestions.kidneyYellow =
        isKidneySectionVisible() && helpers_1.answerMatches(inputs.kidneyInfo, 'close');
    visibleQuestions.kidneyRed =
        isKidneySectionVisible() && helpers_1.answerMatches(inputs.kidneyInfo, 'close');
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = !areVisibleQuestionsAnswered();
    visibleSections.newbornsSection = helpers_1.answerMatches(inputs.age, 'newborns');
    visibleSections.treatKids = isTreatKidsVisible();
    visibleSections.dosingAdultsTreatSecond = isDosingAdultsTreatSecondVisible();
    visibleSections.dosingAdultsTreat = isDosingAdultsTreatVisible();
    visibleSections.babiesPrevention = isBabiesPreventionVisible();
    visibleSections.kidsPrevention = isKidsPreventionVisible();
    visibleSections.childrenPrevention = isChildrenPreventionVisible();
    visibleSections.adultsPreventionTablets = isAdultsPreventionTabletsVisible();
    visibleSections.adultsPreventionTabletsLow =
        isAdultsPreventionTabletsLowVisible();
    visibleSections.kidneySection = isKidneySectionVisible();
    visibleSections.antibioticsSection = isKidneySectionVisible();
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return areVisibleQuestionsAnswered();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
