"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    age: true,
    weight1: false,
    weight2: false,
    weight3: false,
    weight4: false,
    resultAnswerAll: true,
    newbornsText: true,
    babiesAge: true,
    dosingBabiesAge: true,
    sulBabiesAge: true,
    durationBabiesAge: true,
    babiesWeight: true,
    dosingBabiesWeight: true,
    sulfBabiesWeight: true,
    durationBabiesWeight: true,
    kidsAge: true,
    dosingkidsAge: true,
    sulfkidsAge: true,
    durationkidsAge: true,
    kidsWeight: true,
    dosingkidsWeight: true,
    sulfkidsWeight: true,
    durationkidsWeight: true,
    childrenAge: true,
    dosingchildrenAge: true,
    sulfchildrenAge: true,
    durationchildrenAge: true,
    childrenWeight: true,
    dosingchildrenWeight: true,
    sulfchildrenWeight: true,
    durationchildrenWeight: true,
    dosingAdultsTablets: true,
    sulfTabletAdults: true,
    durationTabletsAdults: true,
    dosingWomen: true,
    dosingWomendose: true,
    sulfWomen: true,
    durationWomen: true,
    dosingAdultsSusp: true,
    sulfSuspAdults: true,
    durationSuspAdults: true,
    kdineyInfo: true,
    kidneyGrey: false,
    kidneyYellow: false,
    kidneyRed: false,
    antibioticsText: true
};
var visibleSections = {
    section1: true,
    noAnswer: false,
    newbornsSection: false,
    dosingBabies: false,
    dosingKids: false,
    dosingChildren: false,
    adultsDosingSecond: false,
    adultsDosing: false,
    kidneySection: false,
    antibioticsSection: false
};
var inputs = {
    age: null,
    weight1: null,
    weight2: null,
    weight3: null,
    weight4: null,
    kdineyInfo: null
};
var isWeight1InLimits = function () {
    return helpers_1.numberInLimits({
        input: inputs.weight1,
        min: 1,
        max: 12
    });
};
var isWeight2InLimits = function () {
    return helpers_1.numberInLimits({
        input: inputs.weight2,
        min: 1,
        max: 30
    });
};
var isWeight3InLimits = function () {
    return helpers_1.numberInLimits({
        input: inputs.weight3,
        min: 1,
        max: 70
    });
};
var isWeight1AnsweredIfVisible = function () {
    return helpers_1.answerMatches(inputs.age, 'babies') ? isWeight1InLimits() : true;
};
var isWeight2AnsweredIfVisible = function () {
    return helpers_1.answerMatches(inputs.age, 'kids') ? isWeight2InLimits() : true;
};
var isWeight3AnsweredIfVisible = function () {
    return helpers_1.answerMatches(inputs.age, 'children') ? isWeight3InLimits() : true;
};
var isWeight4AnsweredIfVisible = function () {
    return helpers_1.answerMatches(inputs.age, 'teens') ? helpers_1.isAnswered(inputs.weight4) : true;
};
var areAllAnswered = function () {
    return (helpers_1.isAnswered(inputs.age) &&
        isWeight1AnsweredIfVisible() &&
        isWeight2AnsweredIfVisible() &&
        isWeight3AnsweredIfVisible() &&
        isWeight4AnsweredIfVisible());
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    if (isWeight1InLimits()) {
        var dosingBabiesResult = (Number((_a = inputs.weight1) === null || _a === void 0 ? void 0 : _a.currentPoints) * 15) / 80;
        var trimetoprimResult = Number((_b = inputs.weight1) === null || _b === void 0 ? void 0 : _b.currentPoints) * 3;
        var sulfametoxazoloResult = Number((_c = inputs.weight1) === null || _c === void 0 ? void 0 : _c.currentPoints) * 15;
        return {
            dosingBabiesWeight: {
                qID: 'dosingBabiesWeight',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(dosingBabiesResult, 1), 0, 1)),
                titleTexts: 'result1'
            },
            sulfBabiesWeight: {
                qID: 'sulfBabiesWeight',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(sulfametoxazoloResult, 1), 0, 1)),
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(trimetoprimResult, 1), 0, 1)),
                titleTexts: 'result1',
                resultTexts: 'result1'
            }
        };
    }
    if (isWeight2InLimits()) {
        var dosingKidsResult = (Number((_d = inputs.weight2) === null || _d === void 0 ? void 0 : _d.currentPoints) * 15) / 80;
        var trimetoprimResult = Number((_e = inputs.weight2) === null || _e === void 0 ? void 0 : _e.currentPoints) * 3;
        var sulfametoxazoloResult = Number((_f = inputs.weight2) === null || _f === void 0 ? void 0 : _f.currentPoints) * 15;
        return {
            dosingkidsWeight: {
                qID: 'dosingkidsWeight',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(dosingKidsResult, 1), 0, 1)),
                titleTexts: 'result1'
            },
            sulfkidsWeight: {
                qID: 'sulfkidsWeight',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(sulfametoxazoloResult, 1), 0, 1)),
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(trimetoprimResult, 1), 0, 1)),
                titleTexts: 'result1',
                resultTexts: 'result1'
            }
        };
    }
    if (isWeight3InLimits()) {
        var dosingChildrenResult = (Number((_g = inputs.weight3) === null || _g === void 0 ? void 0 : _g.currentPoints) * 15) / 80;
        var trimetoprimResult = Number((_h = inputs.weight3) === null || _h === void 0 ? void 0 : _h.currentPoints) * 3;
        var sulfametoxazoloResult = Number((_j = inputs.weight3) === null || _j === void 0 ? void 0 : _j.currentPoints) * 15;
        return {
            dosingchildrenWeight: {
                qID: 'dosingchildrenWeight',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(dosingChildrenResult, 1), 0, 1)),
                titleTexts: 'result1'
            },
            sulfchildrenWeight: {
                qID: 'sulfchildrenWeight',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(sulfametoxazoloResult, 1), 0, 1)),
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(trimetoprimResult, 1), 0, 1)),
                titleTexts: 'result1',
                resultTexts: 'result1'
            }
        };
    }
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.weight1 = helpers_1.answerMatches(inputs.age, 'babies');
    visibleQuestions.weight2 = helpers_1.answerMatches(inputs.age, 'kids');
    visibleQuestions.weight3 = helpers_1.answerMatches(inputs.age, 'children');
    visibleQuestions.weight4 = helpers_1.answerMatches(inputs.age, 'teens');
    visibleQuestions.kidneyGrey = helpers_1.answerMatches(inputs.kdineyInfo, 'close');
    visibleQuestions.kidneyYellow = helpers_1.answerMatches(inputs.kdineyInfo, 'close');
    visibleQuestions.kidneyRed = helpers_1.answerMatches(inputs.kdineyInfo, 'close');
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = !areAllAnswered();
    visibleSections.newbornsSection = helpers_1.answerMatches(inputs.age, 'newborns');
    visibleSections.dosingBabies = isWeight1InLimits();
    visibleSections.dosingKids = isWeight2InLimits();
    visibleSections.dosingChildren = isWeight3InLimits();
    visibleSections.adultsDosingSecond = helpers_1.answerMatches(inputs.weight4, 'big');
    visibleSections.adultsDosing = helpers_1.isAnswered(inputs.weight4);
    visibleSections.kidneySection =
        !helpers_1.answerMatches(inputs.age, 'newborns') && areAllAnswered();
    visibleSections.antibioticsSection =
        !helpers_1.answerMatches(inputs.age, 'newborns') && areAllAnswered();
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return areAllAnswered();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
