"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};

var visibleQuestions = {
    intendedUse: true,
    age: true,
    weightA: true,
    weightK: true,
    height: true,
    result121: true,
    result221: true,
    result231: true,
    result241: true,
    result321: true,
    result322: true,
    result323: true,
    result331: true,
    result341: true,
    result421: true,
    result431: true,
    result441: true,
    result521: true,
    result522: true,
    result531: true,
    linkToSpc1: true,
    linkToSpc2: true
};
var visibleSections = {
    section1: true,
    result12: true,
    result22: true,
    result23: true,
    result24: true,
    result32: true,
    result33: true,
    result34: true,
    result42: true,
    result43: true,
    result44: true,
    result52: true,
    result53: true,
    toolAdditionalInfoSection: true
};
var inputs = {
    intendedUse: null,
    age: null,
    weightA: null,
    weightK: null,
    height: null
};
var isAgeVisible = function () {
    return helpers_1.isAnswered(inputs.intendedUse);
};
var isWeightAValid = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.weightA) &&
        Number((_a = inputs.weightA) === null || _a === void 0 ? void 0 : _a.currentPoints) > 0 &&
        Number((_b = inputs.weightA) === null || _b === void 0 ? void 0 : _b.currentPoints) <= 300);
};
var isWeightAVisible = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.intendedUse) &&
        ((_a = inputs.intendedUse) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "treat" &&
        helpers_1.isAnswered(inputs.age) &&
        ((_b = inputs.age) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "twelve");
};
var isWeightKValid = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.weightK) &&
        Number((_a = inputs.weightK) === null || _a === void 0 ? void 0 : _a.currentPoints) > 0 &&
        Number((_b = inputs.weightK) === null || _b === void 0 ? void 0 : _b.currentPoints) <= 50);
};
var isWeightKVisible = function () {
    var _a;
    return (helpers_1.isAnswered(inputs.intendedUse) &&
        helpers_1.isAnswered(inputs.age) &&
        ((_a = inputs.age) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "lessTwelve");
};
var isHeightValid = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.height) &&
        Number((_a = inputs.height) === null || _a === void 0 ? void 0 : _a.currentPoints) > 0 &&
        Number((_b = inputs.height) === null || _b === void 0 ? void 0 : _b.currentPoints) <= 180);
};
var isHeightVisible = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.intendedUse) &&
        ((_a = inputs.intendedUse) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "prevent" &&
        helpers_1.isAnswered(inputs.age) &&
        ((_b = inputs.age) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "lessTwelve" &&
        isWeightKVisible() &&
        helpers_1.isAnswered(inputs.weightK));
};
var isAnswerAllVisible = function () {
    return (!helpers_1.isAnswered(inputs.age) ||
        (isWeightAVisible() && !isWeightAValid()) ||
        (isWeightKVisible() && !isWeightKValid()) ||
        (isHeightVisible() && !isHeightValid()));
};
var isResultRange2Visible = function () {
    var _a, _b;
    return (((_a = inputs.intendedUse) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "treat" &&
        helpers_1.isAnswered(inputs.age) &&
        ((_b = inputs.age) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "twelve" &&
        isWeightAValid());
};
var isResultRange3Visible = function () {
    var _a, _b;
    return (((_a = inputs.intendedUse) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "treat" &&
        helpers_1.isAnswered(inputs.age) &&
        ((_b = inputs.age) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "lessTwelve" &&
        isWeightKValid());
};
var isResultRange4Visible = function () {
    var _a, _b;
    return (((_a = inputs.intendedUse) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "prevent" &&
        helpers_1.isAnswered(inputs.age) &&
        ((_b = inputs.age) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "twelve");
};
var isResultRange5Visible = function () {
    var _a, _b;
    return (((_a = inputs.intendedUse) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "prevent" &&
        helpers_1.isAnswered(inputs.age) &&
        ((_b = inputs.age) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "lessTwelve" &&
        isWeightKValid() &&
        isHeightValid());
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e, _f, _g;
    var result = {
        number: null,
        range: null
    };
    if (isAnswerAllVisible())
        return result;
    if (isResultRange2Visible()) {
        result = __assign(__assign({}, result), { result221: {
                qID: "result221",
                tParams: __spreadArrays(helpers_1.returnNumberObject(Number((_a = inputs.weightA) === null || _a === void 0 ? void 0 : _a.currentPoints) * 100, 0, 1), helpers_1.returnNumberObject(Number((_b = inputs.weightA) === null || _b === void 0 ? void 0 : _b.currentPoints) * 20, 0, 1)),
                titleTexts: "regular"
            } });
    }
    if (isResultRange3Visible()) {
        result = __assign(__assign({}, result), { result321: {
                qID: "result321",
                tParams: __spreadArrays(helpers_1.returnNumberObject((Number((_c = inputs.weightK) === null || _c === void 0 ? void 0 : _c.currentPoints) * 100) / 25, 0, 1)),
                titleTexts: "regular"
            }, result322: {
                qID: "result322",
                tParams: __spreadArrays(helpers_1.returnNumberObject(Number((_d = inputs.weightK) === null || _d === void 0 ? void 0 : _d.currentPoints) * 100, 0, 1)),
                titleTexts: "regular"
            }, result323: {
                qID: "result323",
                tParams: __spreadArrays(helpers_1.returnNumberObject(Number((_e = inputs.weightK) === null || _e === void 0 ? void 0 : _e.currentPoints) * 20, 0, 1)),
                titleTexts: "regular"
            } });
    }
    if (isResultRange5Visible()) {
        var BSA = Math.sqrt(Number((_f = inputs.height) === null || _f === void 0 ? void 0 : _f.currentPoints) *
            Number((_g = inputs.weightK) === null || _g === void 0 ? void 0 : _g.currentPoints)) / 60;
        result = __assign(__assign({}, result), { result521: {
                qID: "result521",
                tParams: __spreadArrays(helpers_1.returnNumberObject((750 * BSA) / 25, 0, 1), helpers_1.returnNumberObject(750 * BSA, 0, 1), helpers_1.returnNumberObject(150 * BSA, 0, 1)),
                titleTexts: "regular"
            } });
    }
    return result;
};
var returnVisibleQuestions = function () {
    visibleQuestions.age = isAgeVisible();
    visibleQuestions.weightA = isWeightAVisible();
    visibleQuestions.weightK = isWeightKVisible();
    visibleQuestions.height = isHeightVisible();
    visibleQuestions.result121 = isAnswerAllVisible();
    visibleQuestions.result221 = isResultRange2Visible();
    visibleQuestions.result231 = isResultRange2Visible();
    visibleQuestions.result241 = isResultRange2Visible();
    visibleQuestions.result321 = isResultRange3Visible();
    visibleQuestions.result322 = isResultRange3Visible();
    visibleQuestions.result323 = isResultRange3Visible();
    visibleQuestions.result331 = isResultRange3Visible();
    visibleQuestions.result341 = isResultRange3Visible();
    visibleQuestions.result421 = isResultRange4Visible();
    visibleQuestions.result431 = isResultRange4Visible();
    visibleQuestions.result441 = isResultRange4Visible();
    visibleQuestions.result521 = isResultRange5Visible();
    visibleQuestions.result522 = isResultRange5Visible();
    visibleQuestions.result531 = isResultRange5Visible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.result12 = isAnswerAllVisible();
    visibleSections.result22 = isResultRange2Visible();
    visibleSections.result23 = isResultRange2Visible();
    visibleSections.result24 = isResultRange2Visible();
    visibleSections.result32 = isResultRange3Visible();
    visibleSections.result33 = isResultRange3Visible();
    visibleSections.result34 = isResultRange3Visible();
    visibleSections.result42 = isResultRange4Visible();
    visibleSections.result43 = isResultRange4Visible();
    visibleSections.result44 = isResultRange4Visible();
    visibleSections.result52 = isResultRange5Visible();
    visibleSections.result53 = isResultRange5Visible();
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return !isAnswerAllVisible();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
