"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};

var visibleQuestions = {
    age: true,
    weightAD: true,
    weightK: true,
    resultAnswerAll: true,
    result221: true,
    result222: true,
    result223: true,
    result231: true,
    result232: true,
    result233: true,
    result234: true,
    result241: true,
    result242: true,
    result251: true,
    result321: true,
    result331: true,
    result332: true,
    result333: true,
    result341: true,
    result351: true,
    result352: true,
    result361: true,
    result421: true,
    result422: true,
    result423: true,
    result431: true,
    result432: true,
    result433: true,
    result434: true,
    result441: true,
    result442: true,
    result451: true,
    linkToSpc1: true,
    linkToSpc2: true
};
var visibleSections = {
    section1: true,
    result12: true,
    result22: true,
    result23: true,
    result24: true,
    result25: true,
    result32: true,
    result33: true,
    result34: true,
    result35: true,
    result36: true,
    result42: true,
    result43: true,
    result44: true,
    result45: true,
    toolAdditionalInfoSection: true
};
var inputs = {
    age: null,
    weightAD: null,
    weightK: null
};
var isWeightADValid = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.weightAD) &&
        Number((_a = inputs.weightAD) === null || _a === void 0 ? void 0 : _a.currentPoints) > 0 &&
        Number((_b = inputs.weightAD) === null || _b === void 0 ? void 0 : _b.currentPoints) <= 50);
};
var isWeightADVisible = function () {
    var _a;
    return (helpers_1.isAnswered(inputs.age) && ((_a = inputs.age) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "sixToTwelve");
};
var isWeightKValid = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.weightK) &&
        Number((_a = inputs.weightK) === null || _a === void 0 ? void 0 : _a.currentPoints) > 0 &&
        Number((_b = inputs.weightK) === null || _b === void 0 ? void 0 : _b.currentPoints) <= 30);
};
var isWeightKVisible = function () {
    var _a;
    return helpers_1.isAnswered(inputs.age) && ((_a = inputs.age) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "six";
};
var isAnswerAllVisible = function () {
    return (!helpers_1.isAnswered(inputs.age) ||
        (isWeightADVisible() && !isWeightADValid()) ||
        (isWeightKVisible() && !isWeightKValid()));
};
var isResultRange2Visible = function () {
    var _a;
    return helpers_1.isAnswered(inputs.age) && ((_a = inputs.age) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "twelve";
};
var isResultRange3Visible = function () {
    var _a;
    return (helpers_1.isAnswered(inputs.age) &&
        ((_a = inputs.age) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "sixToTwelve" &&
        isWeightADValid());
};
var isResultRange4Visible = function () {
    var _a;
    return (helpers_1.isAnswered(inputs.age) &&
        ((_a = inputs.age) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "six" &&
        isWeightKValid());
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    var result = {
        number: null,
        range: null
    };
    if (isAnswerAllVisible()) {
        return result;
    }
    if (isResultRange3Visible()) {
        result = __assign(__assign({}, result), { result331: {
                qID: "result331",
                tParams: __spreadArrays(helpers_1.returnNumberObject((Number((_a = inputs.weightAD) === null || _a === void 0 ? void 0 : _a.currentPoints) * 30) / 25 / 2, 0, 1)),
                titleTexts: "regular"
            }, result332: {
                qID: "result332",
                tParams: __spreadArrays(helpers_1.returnNumberObject((Number((_b = inputs.weightAD) === null || _b === void 0 ? void 0 : _b.currentPoints) * 30) / 2, 0, 1), helpers_1.returnNumberObject(Number((_c = inputs.weightAD) === null || _c === void 0 ? void 0 : _c.currentPoints) * 30, 0, 1)),
                titleTexts: "regular"
            }, result333: {
                qID: "result333",
                tParams: __spreadArrays(helpers_1.returnNumberObject((Number((_d = inputs.weightAD) === null || _d === void 0 ? void 0 : _d.currentPoints) * 6) / 2, 0, 1), helpers_1.returnNumberObject(Number((_e = inputs.weightAD) === null || _e === void 0 ? void 0 : _e.currentPoints) * 6, 0, 1)),
                titleTexts: "regular"
            } });
    }
    if (isResultRange4Visible()) {
        result = __assign(__assign({}, result), { result421: {
                qID: "result421",
                tParams: __spreadArrays(helpers_1.returnNumberObject((Number((_f = inputs.weightK) === null || _f === void 0 ? void 0 : _f.currentPoints) * 30) / 25 / 2, 0, 1)),
                titleTexts: "regular"
            }, result422: {
                qID: "result422",
                tParams: __spreadArrays(helpers_1.returnNumberObject((Number((_g = inputs.weightK) === null || _g === void 0 ? void 0 : _g.currentPoints) * 30) / 2, 0, 1), helpers_1.returnNumberObject(Number((_h = inputs.weightK) === null || _h === void 0 ? void 0 : _h.currentPoints) * 30, 0, 1)),
                titleTexts: "regular"
            }, result423: {
                qID: "result423",
                tParams: __spreadArrays(helpers_1.returnNumberObject((Number((_j = inputs.weightK) === null || _j === void 0 ? void 0 : _j.currentPoints) * 6) / 2, 0, 1), helpers_1.returnNumberObject(Number((_k = inputs.weightK) === null || _k === void 0 ? void 0 : _k.currentPoints) * 6, 0, 1)),
                titleTexts: "regular"
            } });
    }
    return result;
};
var returnVisibleQuestions = function () {
    visibleQuestions.weightAD = isWeightADVisible();
    visibleQuestions.weightK = isWeightKVisible();
    visibleQuestions.resultAnswerAll = isAnswerAllVisible();
    visibleQuestions.result221 = isResultRange2Visible();
    visibleQuestions.result222 = isResultRange2Visible();
    visibleQuestions.result223 = isResultRange2Visible();
    visibleQuestions.result231 = isResultRange2Visible();
    visibleQuestions.result232 = isResultRange2Visible();
    visibleQuestions.result233 = isResultRange2Visible();
    visibleQuestions.result234 = isResultRange2Visible();
    visibleQuestions.result241 = isResultRange2Visible();
    visibleQuestions.result242 = isResultRange2Visible();
    visibleQuestions.result251 = isResultRange2Visible();
    visibleQuestions.result321 = isResultRange3Visible();
    visibleQuestions.result331 = isResultRange3Visible();
    visibleQuestions.result332 = isResultRange3Visible();
    visibleQuestions.result333 = isResultRange3Visible();
    visibleQuestions.result341 = isResultRange3Visible();
    visibleQuestions.result351 = isResultRange3Visible();
    visibleQuestions.result352 = isResultRange3Visible();
    visibleQuestions.result361 = isResultRange3Visible();
    visibleQuestions.result421 = isResultRange4Visible();
    visibleQuestions.result422 = isResultRange4Visible();
    visibleQuestions.result423 = isResultRange4Visible();
    visibleQuestions.result431 = isResultRange4Visible();
    visibleQuestions.result432 = isResultRange4Visible();
    visibleQuestions.result433 = isResultRange4Visible();
    visibleQuestions.result434 = isResultRange4Visible();
    visibleQuestions.result441 = isResultRange4Visible();
    visibleQuestions.result442 = isResultRange4Visible();
    visibleQuestions.result451 = isResultRange4Visible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.result12 = isAnswerAllVisible();
    visibleSections.result22 = isResultRange2Visible();
    visibleSections.result23 = isResultRange2Visible();
    visibleSections.result24 = isResultRange2Visible();
    visibleSections.result25 = isResultRange2Visible();
    visibleSections.result32 = isResultRange3Visible();
    visibleSections.result33 = isResultRange3Visible();
    visibleSections.result34 = isResultRange3Visible();
    visibleSections.result35 = isResultRange3Visible();
    visibleSections.result36 = isResultRange3Visible();
    visibleSections.result42 = isResultRange4Visible();
    visibleSections.result43 = isResultRange4Visible();
    visibleSections.result44 = isResultRange4Visible();
    visibleSections.result45 = isResultRange4Visible();
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return !isAnswerAllVisible();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
