"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};

var visibleQuestions = {
    intendedUse: true,
    age: true,
    weightA: true,
    weightK: true,
    result121: true,
    result221: true,
    result231: true,
    result241: true,
    result321: true,
    result322: true,
    result323: true,
    result331: true,
    result341: true,
    result421: true,
    result431: true,
    result521: true,
    result531: true,
    result621: true,
    result622: true,
    result623: true,
    result631: true,
    result632: true,
    result633: true,
    result641: true,
    linkToSpc1: true,
    linkToSpc2: true
};
var visibleSections = {
    section1: true,
    result12: true,
    result22: true,
    result23: true,
    result24: true,
    result32: true,
    result33: true,
    result34: true,
    result42: true,
    result43: true,
    result52: true,
    result53: true,
    result62: true,
    result63: true,
    result64: true,
    toolAdditionalInfoSection: true
};
var inputs = {
    intendedUse: null,
    age: null,
    weightA: null,
    weightK: null
};
var isAgeVisible = function () {
    return helpers_1.isAnswered(inputs.intendedUse);
};
var isWeightAValid = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.weightA) &&
        Number((_a = inputs.weightA) === null || _a === void 0 ? void 0 : _a.currentPoints) > 0 &&
        Number((_b = inputs.weightA) === null || _b === void 0 ? void 0 : _b.currentPoints) <= 300);
};
var isWeightKValid = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.weightK) &&
        Number((_a = inputs.weightK) === null || _a === void 0 ? void 0 : _a.currentPoints) > 0 &&
        Number((_b = inputs.weightK) === null || _b === void 0 ? void 0 : _b.currentPoints) <= 50);
};
var isWeightAVisible = function () {
    var _a, _b, _c;
    return (helpers_1.isAnswered(inputs.intendedUse) &&
        ((_a = inputs.intendedUse) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "treat" &&
        helpers_1.isAnswered(inputs.age) &&
        (((_b = inputs.age) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "lessEighteen" ||
            ((_c = inputs.age) === null || _c === void 0 ? void 0 : _c.currentIdentifier) === "eighteen"));
};
var isWeightKVisible = function () {
    var _a;
    return (helpers_1.isAnswered(inputs.intendedUse) &&
        helpers_1.isAnswered(inputs.age) &&
        ((_a = inputs.age) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "lessTwelve");
};
var isAnswerAllVisible = function () {
    if (!helpers_1.isAnswered(inputs.intendedUse) || !helpers_1.isAnswered(inputs.age))
        return true;
    return ((isWeightAVisible() && !isWeightAValid()) ||
        (isWeightKVisible() && !isWeightKValid()));
};
var isResultsRange2Visible = function () {
    var _a, _b, _c;
    return (helpers_1.isAnswered(inputs.intendedUse) &&
        ((_a = inputs.intendedUse) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "treat" &&
        helpers_1.isAnswered(inputs.age) &&
        (((_b = inputs.age) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "eighteen" ||
            ((_c = inputs.age) === null || _c === void 0 ? void 0 : _c.currentIdentifier) === "lessEighteen") &&
        isWeightAValid());
};
var isResultsRange3Visible = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.intendedUse) &&
        ((_a = inputs.intendedUse) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "treat" &&
        helpers_1.isAnswered(inputs.age) &&
        ((_b = inputs.age) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "lessTwelve" &&
        isWeightKValid());
};
var isResultsRange4Visible = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.intendedUse) &&
        ((_a = inputs.intendedUse) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "prevent" &&
        helpers_1.isAnswered(inputs.age) &&
        ((_b = inputs.age) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "eighteen");
};
var isResultsRange5Visible = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.intendedUse) &&
        ((_a = inputs.intendedUse) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "prevent" &&
        helpers_1.isAnswered(inputs.age) &&
        ((_b = inputs.age) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "lessEighteen");
};
var isResultsRange6Visible = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.intendedUse) &&
        ((_a = inputs.intendedUse) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "prevent" &&
        helpers_1.isAnswered(inputs.age) &&
        ((_b = inputs.age) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === "lessTwelve" &&
        isWeightKValid());
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    var result = {};
    if (!isAnswerAllVisible()) {
        if (isResultsRange2Visible()) {
            result = __assign(__assign({}, result), { result221: {
                    qID: "result221",
                    tParams: __spreadArrays(helpers_1.returnNumberObject(Number((_a = inputs.weightA) === null || _a === void 0 ? void 0 : _a.currentPoints) * 100, 0, 1), helpers_1.returnNumberObject(Number((_b = inputs.weightA) === null || _b === void 0 ? void 0 : _b.currentPoints) * 20, 0, 1)),
                    titleTexts: "regular"
                } });
        }
        if (isResultsRange3Visible()) {
            result = __assign(__assign({}, result), { result321: {
                    qID: "result321",
                    tParams: __spreadArrays(helpers_1.returnNumberObject((Number((_c = inputs.weightK) === null || _c === void 0 ? void 0 : _c.currentPoints) * 100) / 40, 0, 1)),
                    titleTexts: "regular"
                }, result322: {
                    qID: "result322",
                    tParams: __spreadArrays(helpers_1.returnNumberObject(Number((_d = inputs.weightK) === null || _d === void 0 ? void 0 : _d.currentPoints) * 100, 0, 1)),
                    titleTexts: "regular"
                }, result323: {
                    qID: "result323",
                    tParams: __spreadArrays(helpers_1.returnNumberObject(Number((_e = inputs.weightK) === null || _e === void 0 ? void 0 : _e.currentPoints) * 20, 0, 1)),
                    titleTexts: "regular"
                } });
        }
        if (isResultsRange6Visible()) {
            result = __assign(__assign({}, result), { result621: {
                    qID: "result621",
                    tParams: __spreadArrays(helpers_1.returnNumberObject((Number((_f = inputs.weightK) === null || _f === void 0 ? void 0 : _f.currentPoints) * 30) / 40 / 2, 0, 1), helpers_1.returnNumberObject((Number((_g = inputs.weightK) === null || _g === void 0 ? void 0 : _g.currentPoints) * 30) / 40, 0, 1)),
                    titleTexts: "regular"
                }, result622: {
                    qID: "result622",
                    tParams: __spreadArrays(helpers_1.returnNumberObject(Number((_h = inputs.weightK) === null || _h === void 0 ? void 0 : _h.currentPoints) * 30, 0, 1)),
                    titleTexts: "regular"
                }, result623: {
                    qID: "result623",
                    tParams: __spreadArrays(helpers_1.returnNumberObject(Number((_j = inputs.weightK) === null || _j === void 0 ? void 0 : _j.currentPoints) * 6, 0, 1)),
                    titleTexts: "regular"
                } });
        }
    }
    return result;
};
var returnVisibleQuestions = function () {
    visibleQuestions.age = isAgeVisible();
    visibleQuestions.weightA = isWeightAVisible();
    visibleQuestions.weightK = isWeightKVisible();
    visibleQuestions.result121 = isAnswerAllVisible();
    visibleQuestions.result221 = isResultsRange2Visible();
    visibleQuestions.result231 = isResultsRange2Visible();
    visibleQuestions.result241 = isResultsRange2Visible();
    visibleQuestions.result321 = isResultsRange3Visible();
    visibleQuestions.result322 = isResultsRange3Visible();
    visibleQuestions.result323 = isResultsRange3Visible();
    visibleQuestions.result331 = isResultsRange3Visible();
    visibleQuestions.result341 = isResultsRange3Visible();
    visibleQuestions.result421 = isResultsRange4Visible();
    visibleQuestions.result431 = isResultsRange4Visible();
    visibleQuestions.result521 = isResultsRange5Visible();
    visibleQuestions.result531 = isResultsRange5Visible();
    visibleQuestions.result621 = isResultsRange6Visible();
    visibleQuestions.result622 = isResultsRange6Visible();
    visibleQuestions.result623 = isResultsRange6Visible();
    visibleQuestions.result631 = isResultsRange6Visible();
    visibleQuestions.result632 = isResultsRange6Visible();
    visibleQuestions.result633 = isResultsRange6Visible();
    visibleQuestions.result641 = isResultsRange6Visible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.result12 = isAnswerAllVisible();
    visibleSections.result22 = isResultsRange2Visible();
    visibleSections.result23 = isResultsRange2Visible();
    visibleSections.result24 = isResultsRange2Visible();
    visibleSections.result32 = isResultsRange3Visible();
    visibleSections.result33 = isResultsRange3Visible();
    visibleSections.result34 = isResultsRange3Visible();
    visibleSections.result42 = isResultsRange4Visible();
    visibleSections.result43 = isResultsRange4Visible();
    visibleSections.result52 = isResultsRange5Visible();
    visibleSections.result53 = isResultsRange5Visible();
    visibleSections.result62 = isResultsRange6Visible();
    visibleSections.result63 = isResultsRange6Visible();
    visibleSections.result64 = isResultsRange6Visible();
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return !isAnswerAllVisible();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
