"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};

var visibleQuestions = {
    age: true,
    weight: true,
    resultAnswerAll: true,
    result221: true,
    result231: true,
    result232: true,
    result241: true,
    result321: true,
    result322: true,
    result323: true,
    result331: true,
    result332: true,
    result333: true,
    result334: true,
    result341: true,
    result342: true,
    result351: true,
    linkToSpc1: true,
    linkToSpc2: true
};
var visibleSections = {
    section1: true,
    result11: true,
    result22: true,
    result23: true,
    result24: true,
    result32: true,
    result33: true,
    result34: true,
    result35: true,
    toolAdditionalInfoSection: true
};
var inputs = {
    age: null,
    weight: null
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e;
    var result = {};
    if (!isAnswerAllVisible()) {
        if (isResultRange3Visible()) {
            result = __assign(__assign({}, result), { result321: {
                    qID: "result321",
                    tParams: __spreadArrays(helpers_1.returnNumberObject((Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints) * 3) / 8, 0, 1)),
                    titleTexts: "regular"
                }, result322: {
                    qID: "result322",
                    tParams: __spreadArrays(helpers_1.returnNumberObject((Number((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints) * 30) / 2, 0, 1), helpers_1.returnNumberObject(Number((_c = inputs.weight) === null || _c === void 0 ? void 0 : _c.currentPoints) * 30, 0, 1)),
                    titleTexts: "regular"
                }, result323: {
                    qID: "result323",
                    tParams: __spreadArrays(helpers_1.returnNumberObject((Number((_d = inputs.weight) === null || _d === void 0 ? void 0 : _d.currentPoints) * 6) / 2, 0, 1), helpers_1.returnNumberObject(Number((_e = inputs.weight) === null || _e === void 0 ? void 0 : _e.currentPoints) * 6, 0, 1)),
                    titleTexts: "regular"
                } });
        }
    }
    return result;
};
var isWeightValid = function () {
    var _a, _b;
    return (helpers_1.isAnswered(inputs.weight) &&
        Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints) > 0 &&
        Number((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints) <= 50);
};
var isWeightVisible = function () {
    var _a;
    return (helpers_1.isAnswered(inputs.age) && ((_a = inputs.age) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "twelveLess");
};
var isAnswerAllVisible = function () {
    return !helpers_1.isAnswered(inputs.age) || (isWeightVisible() && !isWeightValid());
};
var isResultRange2Visible = function () {
    var _a;
    return helpers_1.isAnswered(inputs.age) && ((_a = inputs.age) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "twelve";
};
var isResultRange3Visible = function () {
    var _a;
    return (helpers_1.isAnswered(inputs.age) &&
        ((_a = inputs.age) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === "twelveLess" &&
        isWeightValid());
};
var returnVisibleQuestions = function () {
    visibleQuestions.weight = isWeightVisible();
    visibleQuestions.resultAnswerAll = isAnswerAllVisible();
    visibleQuestions.result221 = isResultRange2Visible();
    visibleQuestions.result231 = isResultRange2Visible();
    visibleQuestions.result232 = isResultRange2Visible();
    visibleQuestions.result241 = isResultRange2Visible();
    visibleQuestions.result321 = isResultRange3Visible();
    visibleQuestions.result322 = isResultRange3Visible();
    visibleQuestions.result323 = isResultRange3Visible();
    visibleQuestions.result331 = isResultRange3Visible();
    visibleQuestions.result332 = isResultRange3Visible();
    visibleQuestions.result333 = isResultRange3Visible();
    visibleQuestions.result334 = isResultRange3Visible();
    visibleQuestions.result341 = isResultRange3Visible();
    visibleQuestions.result342 = isResultRange3Visible();
    visibleQuestions.result351 = isResultRange3Visible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.result11 = isAnswerAllVisible();
    visibleSections.result22 = isResultRange2Visible();
    visibleSections.result23 = isResultRange2Visible();
    visibleSections.result24 = isResultRange2Visible();
    visibleSections.result32 = isResultRange3Visible();
    visibleSections.result33 = isResultRange3Visible();
    visibleSections.result34 = isResultRange3Visible();
    visibleSections.result35 = isResultRange3Visible();
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return !isAnswerAllVisible();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
