"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    age: true,
    weight1: false,
    weight2: false,
    weight3: false,
    resultAnswerAll: true,
    newbornsDosing: false,
    dosingBabiesSusp: false,
    resultBabiesSusp: false,
    sulfBabiesSusp: false,
    durationBabiesSusp: false,
    dosingBabiesWeightSusp: false,
    dosingBabiesSuspSecond: false,
    sulftrimSuspBabiesSecond: false,
    durationBabiesSuspSecond: false,
    dosingKidsAge: false,
    dosingdosingKidsAge: false,
    sulfdosingKidsAge: false,
    durationdosingKidsAge: false,
    dosingKidsWeight: false,
    dosingdosingKidsWeight: false,
    sulftdosingKidsWeight: false,
    durationdosingKidsWeight: false,
    dosingTeensAge: false,
    doseTeensAge: false,
    sulfdosingTeensAge: false,
    durationdosingTeensAge: false,
    dosingTeensWeight: false,
    doseTeensWeight: false,
    durationdosingTeensWeight: false,
    dosingTeensSecondAge: false,
    resultdosingTeensSecondAge: false,
    sultrimdosingTeensSecondAge: false,
    durationdosingTeensSecondAge: false,
    dosingTeensSuspAge: false,
    resultdosingTeensSuspAge: false,
    sulftrimdosingTeensSuspAge: false,
    durationdosingTeensSuspAge: false,
    dosingTeensSuspWeight: false,
    resultdosingTeensSuspWeight: false,
    sulftrimdosingTeensSuspWeight: false,
    durationDosingTeensSuspWeight: false,
    resultdosingAdults: false,
    sultrimdosingAdults: false,
    durationdosingAdults: false,
    kidneyInfo: false,
    kidneyGrey: false,
    kidneyYellow: false,
    kidneyRed: false,
    resultConsideration431: false
};
var visibleSections = {
    weightSection: true,
    result11: true,
    newbornsSection: false,
    resultBabies: false,
    dosingKids: false,
    dosingTeens: false,
    dosingTeensSecond: false,
    dosingTeensSusp: false,
    dosingAdults: false,
    kidneyDosin: false,
    result43: false
};
var inputs = {
    age: null,
    weight1: null,
    weight2: null,
    weight3: null,
    kidneyInfo: null
};
var calculatePoints = function () {
    var _a, _b, _c, _d;
    if (isBabies()) {
        var weight = Number((_a = inputs.weight1) === null || _a === void 0 ? void 0 : _a.currentPoints);
        return {
            dosingBabiesSuspSecond: {
                qID: 'dosingBabiesSuspSecond',
                titleTexts: 'result1',
                tParams: __spreadArrays(helpers_1.returnNumberObject((weight * 3) / 8, 0, 1))
            },
            sulftrimSuspBabiesSecond: {
                qID: 'sulftrimSuspBabiesSecond',
                titleTexts: 'result1',
                tParams: __spreadArrays(helpers_1.returnNumberObject(weight * 15, 0, 1)),
                resultTexts: 'result1',
                rParams: __spreadArrays(helpers_1.returnNumberObject(weight * 3, 0, 1))
            }
        };
    }
    if (isKids()) {
        var weight = Number((_b = inputs.weight2) === null || _b === void 0 ? void 0 : _b.currentPoints);
        return {
            dosingdosingKidsWeight: {
                qID: 'dosingdosingKidsWeight',
                titleTexts: 'result1',
                tParams: __spreadArrays(helpers_1.returnNumberObject((weight * 3) / 8, 0, 1))
            },
            sulftdosingKidsWeight: {
                qID: 'sulftdosingKidsWeight',
                titleTexts: 'result1',
                tParams: __spreadArrays(helpers_1.returnNumberObject(weight * 15, 0, 1)),
                resultTexts: 'result1',
                rParams: __spreadArrays(helpers_1.returnNumberObject(weight * 3, 0, 1))
            }
        };
    }
    if (isTeens()) {
        var weight = Number((_c = inputs.weight3) === null || _c === void 0 ? void 0 : _c.currentPoints);
        var obj = {};
        if (isTeensFirst()) {
            var weight_1 = Number((_d = inputs.weight3) === null || _d === void 0 ? void 0 : _d.currentPoints);
            obj = {
                doseTeensWeight: {
                    qID: 'doseTeensWeight',
                    titleTexts: 'result1',
                    tParams: __spreadArrays(helpers_1.returnNumberObject(weight_1 * 15, 0, 1), helpers_1.returnNumberObject(weight_1 * 3, 0, 1))
                }
            };
        }
        return __assign(__assign({}, obj), { resultdosingTeensSuspWeight: {
                qID: 'resultdosingTeensSuspWeight',
                titleTexts: 'result1',
                tParams: __spreadArrays(helpers_1.returnNumberObject((weight * 3) / 8, 0, 1))
            }, sulftrimdosingTeensSuspWeight: {
                qID: 'sulftrimdosingTeensSuspWeight',
                titleTexts: 'result1',
                tParams: __spreadArrays(helpers_1.returnNumberObject(weight * 15, 0, 1)),
                resultTexts: 'result1',
                rParams: __spreadArrays(helpers_1.returnNumberObject(weight * 3, 0, 1))
            } });
    }
    return null;
};
var isNewborn = function () {
    return helpers_1.answerMatches(inputs.age, 'newborns');
};
var isBabies = function () {
    return (helpers_1.answerMatches(inputs.age, 'babies') &&
        helpers_1.numberInLimits({ input: inputs.weight1, min: 1, max: 20 }));
};
var isKids = function () {
    return (helpers_1.answerMatches(inputs.age, 'kids') &&
        helpers_1.numberInLimits({ input: inputs.weight2, min: 1, max: 30 }));
};
var isTeens = function () {
    return (helpers_1.answerMatches(inputs.age, 'teens') &&
        helpers_1.numberInLimits({ input: inputs.weight3, min: 1, max: 70 }));
};
var isTeensFirst = function () {
    return (helpers_1.answerMatches(inputs.age, 'teens') &&
        helpers_1.numberInLimits({ input: inputs.weight3, min: 13.34, max: 70 }));
};
var isTeensSecond = function () {
    return (helpers_1.answerMatches(inputs.age, 'teens') &&
        helpers_1.numberInLimits({ input: inputs.weight3, min: 1, max: 13.33 }));
};
var isAdults = function () {
    return helpers_1.answerMatches(inputs.age, 'adults');
};
var isAnswerAllVisible = function () {
    return !(isNewborn() || isAdults() || isBabies() || isKids() || isTeens());
};
var isOpen = function () {
    return helpers_1.answerMatches(inputs.kidneyInfo, 'close');
};
var returnVisibleQuestions = function () {
    visibleQuestions.weight1 = helpers_1.answerMatches(inputs.age, 'babies');
    visibleQuestions.weight2 = helpers_1.answerMatches(inputs.age, 'kids');
    visibleQuestions.weight3 = helpers_1.answerMatches(inputs.age, 'teens');
    visibleQuestions.resultAnswerAll = isAnswerAllVisible();
    visibleQuestions.newbornsDosing = isNewborn();
    visibleQuestions.dosingBabiesSusp = isBabies();
    visibleQuestions.resultBabiesSusp = isBabies();
    visibleQuestions.sulfBabiesSusp = isBabies();
    visibleQuestions.durationBabiesSusp = isBabies();
    visibleQuestions.dosingBabiesWeightSusp = isBabies();
    visibleQuestions.dosingBabiesSuspSecond = isBabies();
    visibleQuestions.sulftrimSuspBabiesSecond = isBabies();
    visibleQuestions.durationBabiesSuspSecond = isBabies();
    visibleQuestions.dosingKidsAge = isKids();
    visibleQuestions.dosingdosingKidsAge = isKids();
    visibleQuestions.sulfdosingKidsAge = isKids();
    visibleQuestions.durationdosingKidsAge = isKids();
    visibleQuestions.dosingKidsWeight = isKids();
    visibleQuestions.dosingdosingKidsWeight = isKids();
    visibleQuestions.sulftdosingKidsWeight = isKids();
    visibleQuestions.durationdosingKidsWeight = isKids();
    visibleQuestions.dosingTeensAge = isTeensFirst();
    visibleQuestions.doseTeensAge = isTeensFirst();
    visibleQuestions.sulfdosingTeensAge = isTeensFirst();
    visibleQuestions.durationdosingTeensAge = isTeensFirst();
    visibleQuestions.dosingTeensWeight = isTeensFirst();
    visibleQuestions.doseTeensWeight = isTeensFirst();
    visibleQuestions.durationdosingTeensWeight = isTeensFirst();
    visibleQuestions.dosingTeensSecondAge = isTeensSecond();
    visibleQuestions.resultdosingTeensSecondAge = isTeensSecond();
    visibleQuestions.sultrimdosingTeensSecondAge = isTeensSecond();
    visibleQuestions.durationdosingTeensSecondAge = isTeensSecond();
    visibleQuestions.dosingTeensSuspAge = isTeens();
    visibleQuestions.resultdosingTeensSuspAge = isTeens();
    visibleQuestions.sulftrimdosingTeensSuspAge = isTeens();
    visibleQuestions.durationdosingTeensSuspAge = isTeens();
    visibleQuestions.dosingTeensSuspWeight = isTeens();
    visibleQuestions.resultdosingTeensSuspWeight = isTeens();
    visibleQuestions.sulftrimdosingTeensSuspWeight = isTeens();
    visibleQuestions.durationDosingTeensSuspWeight = isTeens();
    visibleQuestions.resultdosingAdults = isAdults();
    visibleQuestions.sultrimdosingAdults = isAdults();
    visibleQuestions.durationdosingAdults = isAdults();
    visibleQuestions.kidneyInfo = !isAnswerAllVisible() && !isNewborn();
    visibleQuestions.kidneyGrey =
        !isAnswerAllVisible() && !isNewborn() && isOpen();
    visibleQuestions.kidneyYellow =
        !isAnswerAllVisible() && !isNewborn() && isOpen();
    visibleQuestions.kidneyRed =
        !isAnswerAllVisible() && !isNewborn() && isOpen();
    visibleQuestions.resultConsideration431 =
        !isAnswerAllVisible() && !isNewborn();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.result11 = isAnswerAllVisible();
    visibleSections.newbornsSection = isNewborn();
    visibleSections.resultBabies = isBabies();
    visibleSections.dosingKids = isKids();
    visibleSections.dosingTeens = isTeensFirst();
    visibleSections.dosingTeensSecond = isTeensSecond();
    visibleSections.dosingTeensSusp = isTeens();
    visibleSections.dosingAdults = isAdults();
    visibleSections.kidneyDosin = !isAnswerAllVisible();
    visibleSections.result43 = !isAnswerAllVisible() && !isNewborn();
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return !isAnswerAllVisible();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections(),
        exportResultsEnabled: isExportResultsEnabled()
    };
});
