"use strict";


var visibleQuestions = {
    age: true,
    resultAnswerAll: true,
    warningKids: false,
    result211: false,
    sulfTrimAdults: false,
    durationAdults: false,
    kidneyInfo: false,
    kidneyGrey: false,
    kidneyYellow: false,
    kidneyRed: false,
    resultConsideration221: true
};
var visibleSections = {
    ageSection: true,
    result11: true,
    dosingTeens: false,
    dosingAdults: false,
    kidneySection: false,
    antibioticsWarning: false
};
var inputs = {
    age: null,
    kidneyInfo: null
};
var calculatePoints = function () {
    return null;
};
var isAnswerAllVisible = function () {
    return !(helpers_1.answerMatches(inputs.age, 'teens') || helpers_1.answerMatches(inputs.age, 'adults'));
};
var isOpen = function () {
    return helpers_1.answerMatches(inputs.kidneyInfo, 'close');
};
var returnVisibleQuestions = function () {
    visibleQuestions.resultAnswerAll = isAnswerAllVisible();
    visibleQuestions.warningKids = helpers_1.answerMatches(inputs.age, 'teens');
    visibleQuestions.result211 = helpers_1.answerMatches(inputs.age, 'adults');
    visibleQuestions.sulfTrimAdults = helpers_1.answerMatches(inputs.age, 'adults');
    visibleQuestions.durationAdults = helpers_1.answerMatches(inputs.age, 'adults');
    visibleQuestions.kidneyInfo = helpers_1.answerMatches(inputs.age, 'adults');
    visibleQuestions.kidneyGrey = helpers_1.answerMatches(inputs.age, 'adults') && isOpen();
    visibleQuestions.kidneyYellow =
        helpers_1.answerMatches(inputs.age, 'adults') && isOpen();
    visibleQuestions.kidneyRed = helpers_1.answerMatches(inputs.age, 'adults') && isOpen();
    visibleQuestions.resultConsideration221 = helpers_1.answerMatches(inputs.age, 'adults');
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.result11 = isAnswerAllVisible();
    visibleSections.dosingTeens = helpers_1.answerMatches(inputs.age, 'teens');
    visibleSections.dosingAdults = helpers_1.answerMatches(inputs.age, 'adults');
    visibleSections.kidneySection = helpers_1.answerMatches(inputs.age, 'adults');
    visibleSections.antibioticsWarning = helpers_1.answerMatches(inputs.age, 'adults');
    return visibleSections;
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var isExportResultsEnabled = function () {
    return !isAnswerAllVisible();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections(),
        exportResultsEnabled: isExportResultsEnabled()
    };
});
