"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    age: true,
    weight: false,
    noAnswerText: false,
    toddlersUnder10SuspensionDose: false,
    warningToddlersUnder10: false,
    toddlersOver10SuspensionA: false,
    toddlersOver10SuspensionB: false,
    toddlersOver10SuspensionC: false,
    childrenTabletsDose: false,
    childrenTabletsDoseB: false,
    childrenSuspensionDose: false,
    childrenSuspensionDoseB: false,
    childrenSuspensionDoseC: false,
    kidney1: false
};
var visibleSections = {
    weightSelection: true,
    noAnswer: false,
    toddlersUnder10Suspension: false,
    toddlersOver10Suspension: false,
    childrenTablets: false,
    childrenSuspension: false,
    kidneySection: false
};
var inputs = {
    age: null,
    weight: null
};
var isWeightVisible = function () {
    return helpers_1.isAnswered(inputs.age);
};
var isWeightInLimits = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 150 });
};
var isNoAnswerVisible = function () {
    return !helpers_1.isAnswered(inputs.age) || !isWeightInLimits();
};
var isToddlersUnder10SuspensionVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'ageBabies') &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 9.99 }));
};
var isToddlersOver10SuspensionVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'ageBabies') &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 10, max: 150 }));
};
var isToddlersOver10SuspensionAVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'ageBabies') &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 10, max: 89.99 }));
};
var isToddlersOver10SuspensionBVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'ageBabies') &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 90, max: 112.49 }));
};
var isToddlersOver10SuspensionCVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'ageBabies') &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 112.5, max: 150 }));
};
var isChildrenTabletsVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'ageChildren') &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 12.5, max: 150 }));
};
var isChildrenTabletsDoseVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'ageChildren') &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 12.5, max: 137.49 }));
};
var isChildrenTabletsDoseBVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'ageChildren') &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 137.5, max: 150 }));
};
var isChildrenSuspensionVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'ageChildren') &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 150 }));
};
var isChildrenSuspensionDoseVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'ageChildren') &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 89.99 }));
};
var isChildrenSuspensionDoseBVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'ageChildren') &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 90, max: 112.49 }));
};
var isChildrenSuspensionDoseCVisible = function () {
    return (helpers_1.answerMatches(inputs.age, 'ageChildren') &&
        helpers_1.numberInLimits({ input: inputs.weight, min: 112.5, max: 150 }));
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x;
    if (isToddlersUnder10SuspensionVisible()) {
        var toddlersUnder10Result1Low = (Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints) * 20) / 50;
        var toddlersUnder10Result1High = Number((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints) * 20;
        var toddlersUnder10Result2Low = (Number((_c = inputs.weight) === null || _c === void 0 ? void 0 : _c.currentPoints) * 30) / 50;
        var toddlersUnder10Result2High = Number((_d = inputs.weight) === null || _d === void 0 ? void 0 : _d.currentPoints) * 30;
        return {
            toddlersUnder10SuspensionDose: {
                qID: 'toddlersUnder10SuspensionDose',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(toddlersUnder10Result1Low, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(toddlersUnder10Result1High, 0), 0, 0)),
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(toddlersUnder10Result2Low, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(toddlersUnder10Result2High, 0), 0, 0)),
                titleTexts: 'toddlersUnder10Suspension1',
                resultTexts: 'toddlersUnder10Suspension2'
            }
        };
    }
    if (isToddlersOver10SuspensionAVisible()) {
        var toddlersOver10Result1Low = (Number((_e = inputs.weight) === null || _e === void 0 ? void 0 : _e.currentPoints) * 20) / 50;
        var toddlersOver10Result1High = (Number((_f = inputs.weight) === null || _f === void 0 ? void 0 : _f.currentPoints) * 25) / 50;
        var toddlersOver10Result2Low = Number((_g = inputs.weight) === null || _g === void 0 ? void 0 : _g.currentPoints) * 20;
        var toddlersOver10Result2High = Number((_h = inputs.weight) === null || _h === void 0 ? void 0 : _h.currentPoints) * 25;
        var toddlersOver10Result3Low = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 75,
            max: 89.99
        })
            ? 45
            : (Number((_j = inputs.weight) === null || _j === void 0 ? void 0 : _j.currentPoints) * 30) / 50;
        var toddlersOver10Result3High = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 75,
            max: 89.99
        })
            ? 2250
            : Number((_k = inputs.weight) === null || _k === void 0 ? void 0 : _k.currentPoints) * 30;
        return {
            toddlersOver10SuspensionA: {
                qID: 'toddlersOver10SuspensionA',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(toddlersOver10Result1Low, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(toddlersOver10Result1High, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(toddlersOver10Result2Low, 0), 0, 0), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(toddlersOver10Result2High, 0), 0, 0)),
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(toddlersOver10Result3Low, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(toddlersOver10Result3High, 0), 0, 0)),
                titleTexts: 'toddlersOver10Suspension1',
                resultTexts: 'toddlersOver10Suspension2'
            }
        };
    }
    if (isToddlersOver10SuspensionBVisible()) {
        var toddlersOver10Result1Low = (Number((_l = inputs.weight) === null || _l === void 0 ? void 0 : _l.currentPoints) * 20) / 50;
        var toddlersOver10Result1High = Number((_m = inputs.weight) === null || _m === void 0 ? void 0 : _m.currentPoints) * 20;
        return {
            toddlersOver10SuspensionB: {
                qID: 'toddlersOver10SuspensionB',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(toddlersOver10Result1Low, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(toddlersOver10Result1High, 0), 0, 0)),
                titleTexts: 'toddlersOver10Suspension1'
            }
        };
    }
    if (isChildrenSuspensionVisible()) {
        var childrenTabletsDoseMg = 0;
        var childrenTabletsDailyDoseMg = 0;
        var childrenSuspensionDoseLowMl = 0;
        var childrenSuspensionDoseHighMl = 0;
        var childrenSuspensionDoseLowMg = 0;
        var childrenSuspensionDoseHighMg = 0;
        var childrenSuspensionDoseDailyMl = 0;
        var childrenSuspensionDoseDailyMg = 0;
        var childrenSuspensionDoseBMl = 0;
        var childrenSuspensionDoseBMg = 0;
        if (isChildrenTabletsDoseVisible() && isChildrenTabletsVisible()) {
            childrenTabletsDoseMg = Number((_o = inputs.weight) === null || _o === void 0 ? void 0 : _o.currentPoints) * 20;
            childrenTabletsDailyDoseMg = helpers_1.numberInLimits({
                input: inputs.weight,
                min: 91.67,
                max: 137.49
            })
                ? 2750
                : Number((_p = inputs.weight) === null || _p === void 0 ? void 0 : _p.currentPoints) * 30;
        }
        if (isChildrenSuspensionDoseVisible()) {
            childrenSuspensionDoseLowMl =
                (Number((_q = inputs.weight) === null || _q === void 0 ? void 0 : _q.currentPoints) * 20) / 50;
            childrenSuspensionDoseHighMl =
                (Number((_r = inputs.weight) === null || _r === void 0 ? void 0 : _r.currentPoints) * 25) / 50;
            childrenSuspensionDoseLowMg = Number((_s = inputs.weight) === null || _s === void 0 ? void 0 : _s.currentPoints) * 20;
            childrenSuspensionDoseHighMg = Number((_t = inputs.weight) === null || _t === void 0 ? void 0 : _t.currentPoints) * 25;
            childrenSuspensionDoseDailyMl = helpers_1.numberInLimits({
                input: inputs.weight,
                min: 75,
                max: 89.99
            })
                ? 45
                : (Number((_u = inputs.weight) === null || _u === void 0 ? void 0 : _u.currentPoints) * 30) / 50;
            childrenSuspensionDoseDailyMg = helpers_1.numberInLimits({
                input: inputs.weight,
                min: 75,
                max: 89.99
            })
                ? 2250
                : Number((_v = inputs.weight) === null || _v === void 0 ? void 0 : _v.currentPoints) * 30;
        }
        if (isChildrenSuspensionDoseBVisible()) {
            childrenSuspensionDoseBMl =
                (Number((_w = inputs.weight) === null || _w === void 0 ? void 0 : _w.currentPoints) * 20) / 50;
            childrenSuspensionDoseBMg = Number((_x = inputs.weight) === null || _x === void 0 ? void 0 : _x.currentPoints) * 20;
        }
        return {
            childrenTabletsDose: {
                qID: 'childrenTabletsDose',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(childrenTabletsDoseMg, 0), 0, 0)),
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(childrenTabletsDailyDoseMg, 0), 0, 0)),
                titleTexts: 'childrenTabletsDose1',
                resultTexts: 'childrenTabletsDose2'
            },
            childrenSuspensionDose: {
                qID: 'childrenSuspensionDose',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(childrenSuspensionDoseLowMl, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(childrenSuspensionDoseHighMl, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(childrenSuspensionDoseLowMg, 0), 0, 0), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(childrenSuspensionDoseHighMg, 0), 0, 0)),
                rParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(childrenSuspensionDoseDailyMl, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(childrenSuspensionDoseDailyMg, 0), 0, 0)),
                titleTexts: 'childrenSuspensionDose1',
                resultTexts: 'childrenSuspensionDose2'
            },
            childrenSuspensionDoseB: {
                qID: 'childrenSuspensionDoseB',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(childrenSuspensionDoseBMl, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(childrenSuspensionDoseBMg, 0), 0, 0)),
                titleTexts: 'childrenSuspensionDose1'
            }
        };
    }
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.weight = isWeightVisible();
    visibleQuestions.noAnswerText = isNoAnswerVisible();
    visibleQuestions.toddlersUnder10SuspensionDose =
        isToddlersUnder10SuspensionVisible();
    visibleQuestions.warningToddlersUnder10 =
        isToddlersUnder10SuspensionVisible();
    visibleQuestions.toddlersOver10SuspensionA =
        isToddlersOver10SuspensionAVisible();
    visibleQuestions.toddlersOver10SuspensionB =
        isToddlersOver10SuspensionBVisible();
    visibleQuestions.toddlersOver10SuspensionC =
        isToddlersOver10SuspensionCVisible();
    visibleQuestions.childrenTabletsDose = isChildrenTabletsDoseVisible();
    visibleQuestions.childrenTabletsDoseB = isChildrenTabletsDoseBVisible();
    visibleQuestions.childrenSuspensionDose = isChildrenSuspensionDoseVisible();
    visibleQuestions.childrenSuspensionDoseC = isChildrenSuspensionDoseCVisible();
    visibleQuestions.childrenSuspensionDoseB = isChildrenSuspensionDoseBVisible();
    visibleQuestions.kidney1 = !isNoAnswerVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = isNoAnswerVisible();
    visibleSections.toddlersUnder10Suspension =
        isToddlersUnder10SuspensionVisible();
    visibleSections.toddlersOver10Suspension =
        isToddlersOver10SuspensionVisible();
    visibleSections.childrenTablets = isChildrenTabletsVisible();
    visibleSections.childrenSuspension = isChildrenSuspensionVisible();
    visibleSections.kidneySection = !isNoAnswerVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return !isNoAnswerVisible();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
