"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    weight: true,
    noAnswerText: false,
    adultsTabletsDose: false,
    adultsTabletsDuration: false,
    adultsTabletsWarning: false,
    adultsSuspensionDose: false,
    adultsSuspensionDuration: false,
    adultsSuspensionWarning: false,
    childrenSuspensionDose: false,
    childrenSuspensionDuration: false,
    childrenSuspensionWarning: false,
    kidney1: false
};
var visibleSections = {
    weightSelection: true,
    noAnswer: false,
    adultsTablets: false,
    adultsSuspension: false,
    childrenSuspension: false,
    kidneySection: false
};
var inputs = {
    weight: null
};
var isWeightInLimits = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 300 });
};
var isAdultsTabletsVisible = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 47, max: 300 });
};
var isChildrenSuspensionVisible = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 46.99 });
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e;
    if (isAdultsTabletsVisible()) {
        var adultsTabletsDoseMg = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 125,
            max: 300
        })
            ? 1250
            : Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints) * 10;
        var adultsSuspensionDoseMl = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 125,
            max: 300
        })
            ? 25
            : (Number((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints) * 10) / 50;
        var adultsSuspensionDoseMg = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 125,
            max: 300
        })
            ? 1250
            : Number((_c = inputs.weight) === null || _c === void 0 ? void 0 : _c.currentPoints) * 10;
        return {
            adultsTabletsDose: {
                qID: 'adultsTabletsDose',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(adultsTabletsDoseMg, 0), 0, 0)),
                rParams: [],
                titleTexts: 'adultsTabletsDose1',
                resultTexts: 'adultsTabletsDose2'
            },
            adultsSuspensionDose: {
                qID: 'adultsSuspensionDose',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(adultsSuspensionDoseMl, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(adultsSuspensionDoseMg, 0), 0, 0)),
                rParams: [],
                titleTexts: 'adultsSuspensionDose1',
                resultTexts: 'adultsSuspensionDose2'
            }
        };
    }
    if (isChildrenSuspensionVisible()) {
        var childrenSuspensionDoseMl = (Number((_d = inputs.weight) === null || _d === void 0 ? void 0 : _d.currentPoints) * 10) / 50;
        var childrenSuspensionDoseMg = Number((_e = inputs.weight) === null || _e === void 0 ? void 0 : _e.currentPoints) * 10;
        return {
            childrenSuspensionDose: {
                qID: 'childrenSuspensionDose',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(childrenSuspensionDoseMl, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(childrenSuspensionDoseMg, 0), 0, 0)),
                rParams: [],
                titleTexts: 'childrenSuspensionDose1',
                resultTexts: 'childrenSuspensionDose1'
            }
        };
    }
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.noAnswerText = !isWeightInLimits();
    visibleQuestions.adultsTabletsDose = isAdultsTabletsVisible();
    visibleQuestions.adultsTabletsDuration = isAdultsTabletsVisible();
    visibleQuestions.adultsTabletsWarning = isAdultsTabletsVisible();
    visibleQuestions.adultsSuspensionDose = isAdultsTabletsVisible();
    visibleQuestions.adultsSuspensionDuration = isAdultsTabletsVisible();
    visibleQuestions.adultsSuspensionWarning = isAdultsTabletsVisible();
    visibleQuestions.childrenSuspensionDose = isChildrenSuspensionVisible();
    visibleQuestions.childrenSuspensionDuration = isChildrenSuspensionVisible();
    visibleQuestions.childrenSuspensionWarning = isChildrenSuspensionVisible();
    visibleQuestions.kidney1 = isWeightInLimits();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = !isWeightInLimits();
    visibleSections.adultsTablets = isAdultsTabletsVisible();
    visibleSections.adultsSuspension = isAdultsTabletsVisible();
    visibleSections.childrenSuspension = isChildrenSuspensionVisible();
    visibleSections.kidneySection = isWeightInLimits();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return isWeightInLimits();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
