"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    weight: true,
    noAnswerText: false,
    adultsTabletsDose: false,
    adultsTabletsDuration: false,
    adultsTabletsDoseSecond: false,
    adultsTabletsDurationSecond: false,
    adultsSuspensionDose: false,
    adultsSuspensionDuration: false,
    adultsSuspensionDoseSecond: false,
    adultsSuspensionDurationSecond: false,
    childrenSuspensionDose: false,
    childrenSuspensionDuration: false,
    kidney1: false
};
var visibleSections = {
    weightSelection: true,
    noAnswer: false,
    adultsTablets: false,
    adultsTabletsSecond: false,
    adultsSuspension: false,
    adultsSuspensionSecond: false,
    childrenSuspension: false,
    kidneySection: false
};
var inputs = {
    weight: null
};
var isWeightInLimits = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 300 });
};
var isAdultsTabletsVisible = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 47, max: 145.79 });
};
var isAdultsTabletsSecondVisible = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 145.8, max: 300 });
};
var isChildrenSuspensionVisible = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 46.99 });
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    if (isAdultsTabletsVisible()) {
        var adultsTabletsDoseMgLow = Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints) * 12;
        var adultsTabletsDoseMgHigh = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 109.4,
            max: 145.79
        })
            ? 1750
            : Number((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints) * 16;
        var adultsSuspensionDoseMlLow = (Number((_c = inputs.weight) === null || _c === void 0 ? void 0 : _c.currentPoints) * 12) / 50;
        var adultsSuspensionDoseMlHigh = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 109.4,
            max: 145.79
        })
            ? 35
            : (Number((_d = inputs.weight) === null || _d === void 0 ? void 0 : _d.currentPoints) * 16) / 50;
        return {
            adultsTabletsDose: {
                qID: 'adultsTabletsDose',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(adultsTabletsDoseMgLow, 0), 0, 0), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(adultsTabletsDoseMgHigh, 0), 0, 0)),
                rParams: [],
                titleTexts: 'adultsTabletsDose1',
                resultTexts: 'adultsTabletsDose2'
            },
            adultsSuspensionDose: {
                qID: 'adultsSuspensionDose',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(adultsSuspensionDoseMlLow, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(adultsSuspensionDoseMlHigh, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(adultsTabletsDoseMgLow, 0), 0, 0), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(adultsTabletsDoseMgHigh, 0), 0, 0)),
                rParams: [],
                titleTexts: 'adultsSuspensionDose1',
                resultTexts: 'adultsSuspensionDose2'
            }
        };
    }
    if (isChildrenSuspensionVisible()) {
        var childrenSuspensionDoseMlLow = (Number((_e = inputs.weight) === null || _e === void 0 ? void 0 : _e.currentPoints) * 12) / 50;
        var childrenSuspensionDoseMlHigh = (Number((_f = inputs.weight) === null || _f === void 0 ? void 0 : _f.currentPoints) * 16) / 50;
        var childrenSuspensionDoseMgLow = Number((_g = inputs.weight) === null || _g === void 0 ? void 0 : _g.currentPoints) * 12;
        var childrenSuspensionDoseMgHigh = Number((_h = inputs.weight) === null || _h === void 0 ? void 0 : _h.currentPoints) * 16;
        return {
            childrenSuspensionDose: {
                qID: 'childrenSuspensionDose',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(childrenSuspensionDoseMlLow, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(childrenSuspensionDoseMlHigh, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(childrenSuspensionDoseMgLow, 0), 0, 0), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(childrenSuspensionDoseMgHigh, 0), 0, 0)),
                rParams: [],
                titleTexts: 'childrenSuspensionDose1',
                resultTexts: 'childrenSuspensionDose2'
            }
        };
    }
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.noAnswerText = !isWeightInLimits();
    visibleQuestions.adultsTabletsDose = isAdultsTabletsVisible();
    visibleQuestions.adultsTabletsDuration = isAdultsTabletsVisible();
    visibleQuestions.adultsTabletsDoseSecond = isAdultsTabletsSecondVisible();
    visibleQuestions.adultsTabletsDurationSecond = isAdultsTabletsSecondVisible();
    visibleQuestions.adultsSuspensionDose = isAdultsTabletsVisible();
    visibleQuestions.adultsSuspensionDoseSecond = isAdultsTabletsSecondVisible();
    visibleQuestions.adultsSuspensionDurationSecond =
        isAdultsTabletsSecondVisible();
    visibleQuestions.adultsSuspensionDuration = isAdultsTabletsVisible();
    visibleQuestions.childrenSuspensionDose = isChildrenSuspensionVisible();
    visibleQuestions.childrenSuspensionDuration = isChildrenSuspensionVisible();
    visibleQuestions.kidney1 = isWeightInLimits();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = !isWeightInLimits();
    visibleSections.adultsTablets = isAdultsTabletsVisible();
    visibleSections.adultsTabletsSecond = isAdultsTabletsSecondVisible();
    visibleSections.adultsSuspension = isAdultsTabletsVisible();
    visibleSections.adultsSuspensionSecond = isAdultsTabletsSecondVisible();
    visibleSections.childrenSuspension = isChildrenSuspensionVisible();
    visibleSections.kidneySection = isWeightInLimits();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return isWeightInLimits();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
