"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    age: true,
    ageBaby: false,
    weight: false,
    noAnswerText: false,
    extraMiniDose1: false,
    extraMiniDuration1: false,
    extraMiniWarning1: false,
    miniDose1: false,
    miniDuration1: false,
    miniWarning1: false,
    newbornDose1: false,
    newbornDuration1: false,
    newbornWarning1: false,
    kidsDose1: false,
    kidsDose1interval: false,
    kidsDuration1: false,
    adultsDose1: false,
    adultsDose1interval: false,
    severeDose: false,
    severeDoseinterval: false,
    adultsDuration1: false,
    kidney: false,
    anti: false
};
var visibleSections = {
    ageSelection: true,
    noAnswer: false,
    extraMiniDosing1: false,
    miniDosing1: false,
    newbornDosing1: false,
    kidsDosing1: false,
    adultsDosing1: false,
    warningKidney: false,
    warningA: false
};
var inputs = {
    age: null,
    ageBaby: null,
    weight: null
};
var isAgeBabyVisible = function () {
    return helpers_1.answerMatches(inputs.age, 'baby');
};
var isAgeBabyAnsweredIfVisible = function () {
    return isAgeBabyVisible() ? helpers_1.isAnswered(inputs.ageBaby) : true;
};
var isWeightVisible = function () {
    return helpers_1.isAnswered(inputs.age) && isAgeBabyAnsweredIfVisible();
};
var isWeightInLimits = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 200 });
};
var isNoAnswerVisible = function () {
    return (!helpers_1.isAnswered(inputs.age) ||
        (isAgeBabyVisible() && !helpers_1.isAnswered(inputs.ageBaby)) ||
        (isWeightVisible() && !isWeightInLimits()));
};
var isExtraMiniDosing1Visible = function () {
    return (helpers_1.answerMatches(inputs.age, 'baby') &&
        helpers_1.answerMatches(inputs.ageBaby, 'extraMini') &&
        isWeightInLimits());
};
var isMiniDosing1Visible = function () {
    return (helpers_1.answerMatches(inputs.age, 'baby') &&
        helpers_1.answerMatches(inputs.ageBaby, 'mini') &&
        isWeightInLimits());
};
var isNewbornDosing1Visible = function () {
    return (helpers_1.answerMatches(inputs.age, 'baby') &&
        helpers_1.answerMatches(inputs.ageBaby, 'newborn') &&
        isWeightInLimits());
};
var isKidsDosing1Visible = function () {
    return helpers_1.answerMatches(inputs.age, 'kids') && isWeightInLimits();
};
var isKidsDose1Visible = function () {
    return (isKidsDosing1Visible() &&
        helpers_1.numberInLimits({
            input: inputs.weight,
            min: 1,
            max: 199.99
        }));
};
var isKidsDose1IntervalVisible = function () {
    var _a;
    return isKidsDosing1Visible() && Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints) === 200;
};
var isAdultsDosing1Visible = function () {
    return helpers_1.answerMatches(inputs.age, 'adults') && isWeightInLimits();
};
var isAdultsDose1Visible = function () {
    return (isAdultsDosing1Visible() &&
        helpers_1.numberInLimits({
            input: inputs.weight,
            min: 1,
            max: 133.39
        }));
};
var isAdultsDose1IntervalVisible = function () {
    return (isAdultsDosing1Visible() &&
        helpers_1.numberInLimits({
            input: inputs.weight,
            min: 133.4,
            max: 200
        }));
};
var isSevereDoseVisible = function () {
    return (isAdultsDosing1Visible() &&
        helpers_1.numberInLimits({
            input: inputs.weight,
            min: 1,
            max: 119.99
        }));
};
var isSevereDoseIntervalVisible = function () {
    return (isAdultsDosing1Visible() &&
        helpers_1.numberInLimits({
            input: inputs.weight,
            min: 120,
            max: 200
        }));
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l;
    if (isExtraMiniDosing1Visible()) {
        var extraMiniDose1Result = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 133.4,
            max: 200
        })
            ? 2000
            : Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints) * 15;
        return {
            extraMiniDose1: {
                qID: 'extraMiniDose1',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(extraMiniDose1Result, 1), 0, 1)),
                rParams: [],
                resultTexts: 'result1',
                titleTexts: 'extraMiniDose12'
            }
        };
    }
    if (isMiniDosing1Visible()) {
        var miniDose1Result = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 133.4,
            max: 200
        })
            ? 2000
            : Number((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints) * 15;
        return {
            miniDose1: {
                qID: 'miniDose1',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(miniDose1Result, 1), 0, 1)),
                rParams: [],
                resultTexts: 'result1',
                titleTexts: 'miniDose12'
            }
        };
    }
    if (isNewbornDosing1Visible()) {
        var newbornDose1Result = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 133.4,
            max: 200
        })
            ? 2000
            : Number((_c = inputs.weight) === null || _c === void 0 ? void 0 : _c.currentPoints) * 15;
        return {
            newbornDose1: {
                qID: 'newbornDose1',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(newbornDose1Result, 1), 0, 1)),
                rParams: [],
                resultTexts: 'result1',
                titleTexts: 'newbornDose12'
            }
        };
    }
    if (isKidsDose1Visible()) {
        var kidsDose1ResultLow = Number((_d = inputs.weight) === null || _d === void 0 ? void 0 : _d.currentPoints) * 10;
        var kidsDose1ResultHigh = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 133.4,
            max: 200
        })
            ? 2000
            : Number((_e = inputs.weight) === null || _e === void 0 ? void 0 : _e.currentPoints) * 15;
        return {
            kidsDose1: {
                qID: 'kidsDose1',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(kidsDose1ResultLow, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(kidsDose1ResultHigh, 1), 0, 1)),
                rParams: [],
                resultTexts: 'result1',
                titleTexts: 'kidsDose12'
            }
        };
    }
    if (isAdultsDose1Visible() && isSevereDoseIntervalVisible()) {
        var kidsDose1ResultLow = Number((_f = inputs.weight) === null || _f === void 0 ? void 0 : _f.currentPoints) * 15;
        var kidsDose1ResultHigh = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 100,
            max: 200
        })
            ? 2000
            : Number((_g = inputs.weight) === null || _g === void 0 ? void 0 : _g.currentPoints) * 20;
        return {
            adultsDose1: {
                qID: 'adultsDose1',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(kidsDose1ResultLow, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(kidsDose1ResultHigh, 1), 0, 1)),
                rParams: [],
                resultTexts: 'result1',
                titleTexts: 'adultsDose12'
            }
        };
    }
    if (isAdultsDose1Visible() && isSevereDoseVisible()) {
        var adultsDose1ResultLow = Number((_h = inputs.weight) === null || _h === void 0 ? void 0 : _h.currentPoints) * 15;
        var adultsDose1ResultHigh = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 100,
            max: 200
        })
            ? 2000
            : Number((_j = inputs.weight) === null || _j === void 0 ? void 0 : _j.currentPoints) * 20;
        var severeDoseResultLow = Number((_k = inputs.weight) === null || _k === void 0 ? void 0 : _k.currentPoints) * 25;
        var severeDoseResultHigh = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 100,
            max: 200
        })
            ? 3000
            : Number((_l = inputs.weight) === null || _l === void 0 ? void 0 : _l.currentPoints) * 30;
        return {
            adultsDose1: {
                qID: 'adultsDose1',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(adultsDose1ResultLow, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(adultsDose1ResultHigh, 1), 0, 1)),
                rParams: [],
                resultTexts: 'result1',
                titleTexts: 'adultsDose12'
            },
            severeDose: {
                qID: 'severeDose',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(severeDoseResultLow, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(severeDoseResultHigh, 1), 0, 1)),
                titleTexts: 'result1'
            }
        };
    }
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.ageBaby = isAgeBabyVisible();
    visibleQuestions.weight = isWeightVisible();
    visibleQuestions.noAnswerText = isNoAnswerVisible();
    visibleQuestions.extraMiniDose1 = isExtraMiniDosing1Visible();
    visibleQuestions.extraMiniDuration1 = isExtraMiniDosing1Visible();
    visibleQuestions.extraMiniWarning1 = isExtraMiniDosing1Visible();
    visibleQuestions.miniDose1 = isMiniDosing1Visible();
    visibleQuestions.miniDuration1 = isMiniDosing1Visible();
    visibleQuestions.miniWarning1 = isMiniDosing1Visible();
    visibleQuestions.newbornDose1 = isNewbornDosing1Visible();
    visibleQuestions.newbornDuration1 = isNewbornDosing1Visible();
    visibleQuestions.newbornWarning1 = isNewbornDosing1Visible();
    visibleQuestions.kidsDose1 = isKidsDose1Visible();
    visibleQuestions.kidsDose1interval = isKidsDose1IntervalVisible();
    visibleQuestions.kidsDuration1 = isKidsDosing1Visible();
    visibleQuestions.adultsDose1 = isAdultsDose1Visible();
    visibleQuestions.adultsDose1interval = isAdultsDose1IntervalVisible();
    visibleQuestions.severeDose = isSevereDoseVisible();
    visibleQuestions.severeDoseinterval = isSevereDoseIntervalVisible();
    visibleQuestions.adultsDuration1 = isAdultsDosing1Visible();
    visibleQuestions.kidney = !isNoAnswerVisible();
    visibleQuestions.anti = !isNoAnswerVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = isNoAnswerVisible();
    visibleSections.extraMiniDosing1 = isExtraMiniDosing1Visible();
    visibleSections.miniDosing1 = isMiniDosing1Visible();
    visibleSections.newbornDosing1 = isNewbornDosing1Visible();
    visibleSections.kidsDosing1 = isKidsDosing1Visible();
    visibleSections.adultsDosing1 = isAdultsDosing1Visible();
    visibleSections.warningKidney = !isNoAnswerVisible();
    visibleSections.warningA = !isNoAnswerVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return !isNoAnswerVisible();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
