"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    weight: true,
    noAnswerText: false,
    dose1: false,
    duration1: false,
    anti: false
};
var visibleSections = {
    weightSelection: true,
    noAnswer: false,
    dosing1: false,
    warningA: false
};
var inputs = {
    weight: null
};
var isWeightInLimits = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 200 });
};
var isNoAnswerVisible = function () {
    return !isWeightInLimits();
};
var calculatePoints = function () {
    var _a;
    if (!isNoAnswerVisible()) {
        var dose1ResultResult = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 133.4,
            max: 200
        })
            ? 2000
            : Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints) * 15;
        return {
            dose1: {
                qID: 'dose1',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(dose1ResultResult, 1), 0, 1)),
                titleTexts: 'dose12'
            }
        };
    }
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.noAnswerText = isNoAnswerVisible();
    visibleQuestions.dose1 = !isNoAnswerVisible();
    visibleQuestions.duration1 = !isNoAnswerVisible();
    visibleQuestions.anti = !isNoAnswerVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = isNoAnswerVisible();
    visibleSections.dosing1 = !isNoAnswerVisible();
    visibleSections.warningA = !isNoAnswerVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return !isNoAnswerVisible();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
