"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};


var visibleQuestions = {
    age: true,
    ageBaby: false,
    weight: false,
    necroseYesNo: false,
    noAnswerText: false,
    extraMiniDose1: false,
    extraMiniDuration1: false,
    extraMiniWarning1: false,
    extraMiniDose2: false,
    extraMiniDuration2: false,
    extraMiniWarning2: false,
    miniDose1: false,
    miniDuration1: false,
    miniWarning1: false,
    miniDose2: false,
    miniDuration2: false,
    miniWarning2: false,
    newbornDose1: false,
    newbornDuration1: false,
    newbornWarning1: false,
    newbornDose2: false,
    newbornDuration2: false,
    newbornWarning2: false,
    kidsDose1: false,
    kidsDoseInterval: false,
    kidsDuration1: false,
    kidsDose2: false,
    kidsDose2Interval: false,
    kidsDuration2: false,
    adultsDose1: false,
    adultsDose1interval: false,
    severeDose: false,
    severeDoseInterval: false,
    adultsDuration1: false,
    adultsDose2: false,
    adultsDose2Interval: false,
    severeDose2: false,
    severeDose2Interval: false,
    adultsDuration2: false,
    kidneyKids1: false,
    anti: false
};
var visibleSections = {
    inputs: true,
    noAnswer: false,
    extraMiniDosing1: false,
    extraMiniDosing2: false,
    miniDosing1: false,
    miniDosing2: false,
    newbornDosing1: false,
    newbornDosing2: false,
    kidsDosing1: false,
    kidsDosing2: false,
    adultsDosing1: false,
    adultsDosing2: false,
    kidneyWarning: false,
    warningA: false
};
var inputs = {
    age: null,
    ageBaby: null,
    weight: null,
    necroseYesNo: null
};
var isAgeBabyVisible = function () {
    return helpers_1.answerMatches(inputs.age, 'baby');
};
var isAgeBabyAnsweredIfVisible = function () {
    return isAgeBabyVisible() ? helpers_1.isAnswered(inputs.ageBaby) : true;
};
var isWeightVisible = function () {
    return helpers_1.isAnswered(inputs.age) && isAgeBabyAnsweredIfVisible();
};
var isWeightInLimits = function () {
    return helpers_1.numberInLimits({ input: inputs.weight, min: 1, max: 200 });
};
var isNecroseYesNoVisible = function () {
    return (helpers_1.isAnswered(inputs.age) && isAgeBabyAnsweredIfVisible() && isWeightInLimits());
};
var isNoAnswerVisible = function () {
    return (!helpers_1.isAnswered(inputs.age) ||
        (isAgeBabyVisible() && !helpers_1.isAnswered(inputs.ageBaby)) ||
        (isWeightVisible() && !isWeightInLimits()) ||
        (isNecroseYesNoVisible() && !helpers_1.isAnswered(inputs.necroseYesNo)));
};
var isExtraMiniDosing1Visible = function () {
    return (helpers_1.answerMatches(inputs.age, 'baby') &&
        helpers_1.answerMatches(inputs.ageBaby, 'extraMini') &&
        isWeightInLimits() &&
        helpers_1.answerMatches(inputs.necroseYesNo, 'no'));
};
var isExtraMiniDosing2Visible = function () {
    return (helpers_1.answerMatches(inputs.age, 'baby') &&
        helpers_1.answerMatches(inputs.ageBaby, 'extraMini') &&
        isWeightInLimits() &&
        helpers_1.answerMatches(inputs.necroseYesNo, 'yes'));
};
var isMiniDosing1Visible = function () {
    return (helpers_1.answerMatches(inputs.age, 'baby') &&
        helpers_1.answerMatches(inputs.ageBaby, 'mini') &&
        isWeightInLimits() &&
        helpers_1.answerMatches(inputs.necroseYesNo, 'no'));
};
var isMiniDosing2Visible = function () {
    return (helpers_1.answerMatches(inputs.age, 'baby') &&
        helpers_1.answerMatches(inputs.ageBaby, 'mini') &&
        isWeightInLimits() &&
        helpers_1.answerMatches(inputs.necroseYesNo, 'yes'));
};
var isNewbornDosing1Visible = function () {
    return (helpers_1.answerMatches(inputs.age, 'baby') &&
        helpers_1.answerMatches(inputs.ageBaby, 'newborn') &&
        isWeightInLimits() &&
        helpers_1.answerMatches(inputs.necroseYesNo, 'no'));
};
var isNewbornDosing2Visible = function () {
    return (helpers_1.answerMatches(inputs.age, 'baby') &&
        helpers_1.answerMatches(inputs.ageBaby, 'newborn') &&
        isWeightInLimits() &&
        helpers_1.answerMatches(inputs.necroseYesNo, 'yes'));
};
var isKidsDosing1Visible = function () {
    return (helpers_1.answerMatches(inputs.age, 'kids') &&
        isWeightInLimits() &&
        helpers_1.answerMatches(inputs.necroseYesNo, 'no'));
};
var isKidsDosing2Visible = function () {
    return (helpers_1.answerMatches(inputs.age, 'kids') &&
        isWeightInLimits() &&
        helpers_1.answerMatches(inputs.necroseYesNo, 'yes'));
};
var isKidsDose1Visible = function () {
    return (isKidsDosing1Visible() &&
        helpers_1.numberInLimits({
            input: inputs.weight,
            min: 1,
            max: 199.99
        }));
};
var isKidsDose2Visible = function () {
    return (isKidsDosing2Visible() &&
        helpers_1.numberInLimits({
            input: inputs.weight,
            min: 1,
            max: 199.99
        }));
};
var isKidsDose1IntervalVisible = function () {
    var _a;
    return isKidsDosing1Visible() && Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints) === 200;
};
var isKidsDose2IntervalVisible = function () {
    var _a;
    return isKidsDosing2Visible() && Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints) === 200;
};
var isAdultsDosing1Visible = function () {
    return (helpers_1.answerMatches(inputs.age, 'adults') &&
        isWeightInLimits() &&
        helpers_1.answerMatches(inputs.necroseYesNo, 'no'));
};
var isAdultsDosing2Visible = function () {
    return (helpers_1.answerMatches(inputs.age, 'adults') &&
        isWeightInLimits() &&
        helpers_1.answerMatches(inputs.necroseYesNo, 'yes'));
};
var isAdultsDose1Visible = function () {
    return (isAdultsDosing1Visible() &&
        helpers_1.numberInLimits({
            input: inputs.weight,
            min: 1,
            max: 133.39
        }));
};
var isAdultsDose2Visible = function () {
    return (isAdultsDosing2Visible() &&
        helpers_1.numberInLimits({
            input: inputs.weight,
            min: 1,
            max: 133.39
        }));
};
var isAdultsDose1IntervalVisible = function () {
    return (isAdultsDosing1Visible() &&
        helpers_1.numberInLimits({
            input: inputs.weight,
            min: 133.4,
            max: 200
        }));
};
var isAdultsDose2IntervalVisible = function () {
    return (isAdultsDosing2Visible() &&
        helpers_1.numberInLimits({
            input: inputs.weight,
            min: 133.4,
            max: 200
        }));
};
var isSevereDoseVisible = function () {
    return (isAdultsDosing1Visible() &&
        helpers_1.numberInLimits({
            input: inputs.weight,
            min: 1,
            max: 119.99
        }));
};
var isSevereDose2Visible = function () {
    return (isAdultsDosing2Visible() &&
        helpers_1.numberInLimits({
            input: inputs.weight,
            min: 1,
            max: 119.99
        }));
};
var isSevereDoseIntervalVisible = function () {
    return (isAdultsDosing1Visible() &&
        helpers_1.numberInLimits({
            input: inputs.weight,
            min: 120,
            max: 200
        }));
};
var isSevereDose2IntervalVisible = function () {
    return (isAdultsDosing2Visible() &&
        helpers_1.numberInLimits({
            input: inputs.weight,
            min: 120,
            max: 200
        }));
};
var calculatePoints = function () {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x;
    if (isExtraMiniDosing1Visible()) {
        var extraMiniDose1Result = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 133.4,
            max: 200
        })
            ? 2000
            : Number((_a = inputs.weight) === null || _a === void 0 ? void 0 : _a.currentPoints) * 15;
        return {
            extraMiniDose1: {
                qID: 'extraMiniDose1',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(extraMiniDose1Result, 1), 0, 1)),
                rParams: [],
                resultTexts: 'result1',
                titleTexts: 'extraMiniDose12'
            }
        };
    }
    if (isExtraMiniDosing2Visible()) {
        var extraMiniDose1Result = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 133.4,
            max: 200
        })
            ? 2000
            : Number((_b = inputs.weight) === null || _b === void 0 ? void 0 : _b.currentPoints) * 15;
        return {
            extraMiniDose2: {
                qID: 'extraMiniDose2',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(extraMiniDose1Result, 1), 0, 1)),
                rParams: [],
                resultTexts: 'result1',
                titleTexts: 'extraMiniDose22'
            }
        };
    }
    if (isMiniDosing1Visible()) {
        var miniDose1Result = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 133.4,
            max: 200
        })
            ? 2000
            : Number((_c = inputs.weight) === null || _c === void 0 ? void 0 : _c.currentPoints) * 15;
        return {
            miniDose1: {
                qID: 'miniDose1',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(miniDose1Result, 1), 0, 1)),
                rParams: [],
                resultTexts: 'result1',
                titleTexts: 'miniDose12'
            }
        };
    }
    if (isMiniDosing2Visible()) {
        var miniDose1Result = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 133.4,
            max: 200
        })
            ? 2000
            : Number((_d = inputs.weight) === null || _d === void 0 ? void 0 : _d.currentPoints) * 15;
        return {
            miniDose2: {
                qID: 'miniDose2',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(miniDose1Result, 1), 0, 1)),
                rParams: [],
                resultTexts: 'result1',
                titleTexts: 'miniDose22'
            }
        };
    }
    if (isNewbornDosing1Visible()) {
        var newbornDose1Result = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 133.4,
            max: 200
        })
            ? 2000
            : Number((_e = inputs.weight) === null || _e === void 0 ? void 0 : _e.currentPoints) * 15;
        return {
            newbornDose1: {
                qID: 'newbornDose1',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(newbornDose1Result, 1), 0, 1)),
                rParams: [],
                resultTexts: 'result1',
                titleTexts: 'result1'
            }
        };
    }
    if (isNewbornDosing2Visible()) {
        var newbornDose1Result = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 133.4,
            max: 200
        })
            ? 2000
            : Number((_f = inputs.weight) === null || _f === void 0 ? void 0 : _f.currentPoints) * 15;
        return {
            newbornDose2: {
                qID: 'newbornDose2',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(newbornDose1Result, 1), 0, 1)),
                rParams: [],
                resultTexts: 'result1',
                titleTexts: 'newbornDosing22'
            }
        };
    }
    if (isKidsDose1Visible()) {
        var kidsDose1ResultLow = Number((_g = inputs.weight) === null || _g === void 0 ? void 0 : _g.currentPoints) * 10;
        var kidsDose1ResultHigh = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 133.4,
            max: 200
        })
            ? 2000
            : Number((_h = inputs.weight) === null || _h === void 0 ? void 0 : _h.currentPoints) * 15;
        return {
            kidsDose1: {
                qID: 'kidsDose1',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(kidsDose1ResultLow, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(kidsDose1ResultHigh, 1), 0, 1)),
                rParams: [],
                resultTexts: 'result1',
                titleTexts: 'kidsDose12'
            }
        };
    }
    if (isKidsDose2Visible()) {
        var kidsDose1ResultLow = Number((_j = inputs.weight) === null || _j === void 0 ? void 0 : _j.currentPoints) * 10;
        var kidsDose1ResultHigh = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 133.4,
            max: 200
        })
            ? 2000
            : Number((_k = inputs.weight) === null || _k === void 0 ? void 0 : _k.currentPoints) * 15;
        return {
            kidsDose2: {
                qID: 'kidsDose2',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(kidsDose1ResultLow, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(kidsDose1ResultHigh, 1), 0, 1)),
                rParams: [],
                resultTexts: 'result1',
                titleTexts: 'kidsDose22'
            }
        };
    }
    if (isAdultsDose1Visible() && isSevereDoseIntervalVisible()) {
        var kidsDose1ResultLow = Number((_l = inputs.weight) === null || _l === void 0 ? void 0 : _l.currentPoints) * 15;
        var kidsDose1ResultHigh = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 100,
            max: 200
        })
            ? 2000
            : Number((_m = inputs.weight) === null || _m === void 0 ? void 0 : _m.currentPoints) * 20;
        return {
            adultsDose1: {
                qID: 'adultsDose1',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(kidsDose1ResultLow, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(kidsDose1ResultHigh, 1), 0, 1)),
                rParams: [],
                resultTexts: 'result1',
                titleTexts: 'adultsDose12'
            }
        };
    }
    if (isAdultsDose1Visible() && isSevereDoseVisible()) {
        var kidsDose1ResultLow = Number((_o = inputs.weight) === null || _o === void 0 ? void 0 : _o.currentPoints) * 15;
        var kidsDose1ResultHigh = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 100,
            max: 200
        })
            ? 2000
            : Number((_p = inputs.weight) === null || _p === void 0 ? void 0 : _p.currentPoints) * 20;
        var severeDoseResultLow = Number((_q = inputs.weight) === null || _q === void 0 ? void 0 : _q.currentPoints) * 25;
        var severeDoseResultHigh = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 100,
            max: 200
        })
            ? 3000
            : Number((_r = inputs.weight) === null || _r === void 0 ? void 0 : _r.currentPoints) * 30;
        return {
            adultsDose1: {
                qID: 'adultsDose1',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(kidsDose1ResultLow, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(kidsDose1ResultHigh, 1), 0, 1)),
                rParams: [],
                resultTexts: 'result1',
                titleTexts: 'adultsDose12'
            },
            severeDose: {
                qID: 'severeDose',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(severeDoseResultLow, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(severeDoseResultHigh, 1), 0, 1)),
                titleTexts: 'result1'
            }
        };
    }
    if (isAdultsDose2Visible() && isSevereDose2IntervalVisible()) {
        var kidsDose1ResultLow = Number((_s = inputs.weight) === null || _s === void 0 ? void 0 : _s.currentPoints) * 15;
        var kidsDose1ResultHigh = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 100,
            max: 200
        })
            ? 2000
            : Number((_t = inputs.weight) === null || _t === void 0 ? void 0 : _t.currentPoints) * 20;
        return {
            adultsDose2: {
                qID: 'adultsDose2',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(kidsDose1ResultLow, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(kidsDose1ResultHigh, 1), 0, 1)),
                rParams: [],
                resultTexts: 'result1',
                titleTexts: 'adultsDose22'
            }
        };
    }
    if (isAdultsDose2Visible() && isSevereDose2Visible()) {
        var kidsDose1ResultLow = Number((_u = inputs.weight) === null || _u === void 0 ? void 0 : _u.currentPoints) * 15;
        var kidsDose1ResultHigh = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 100,
            max: 200
        })
            ? 2000
            : Number((_v = inputs.weight) === null || _v === void 0 ? void 0 : _v.currentPoints) * 20;
        var severeDoseResultLow = Number((_w = inputs.weight) === null || _w === void 0 ? void 0 : _w.currentPoints) * 25;
        var severeDoseResultHigh = helpers_1.numberInLimits({
            input: inputs.weight,
            min: 100,
            max: 200
        })
            ? 3000
            : Number((_x = inputs.weight) === null || _x === void 0 ? void 0 : _x.currentPoints) * 30;
        return {
            adultsDose2: {
                qID: 'adultsDose2',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(kidsDose1ResultLow, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(kidsDose1ResultHigh, 1), 0, 1)),
                rParams: [],
                resultTexts: 'result1',
                titleTexts: 'adultsDose22'
            },
            severeDose2: {
                qID: 'severeDose2',
                tParams: __spreadArrays(helpers_1.returnNumberObject(helpers_1.formatCalculationResult(severeDoseResultLow, 1), 0, 1), helpers_1.returnNumberObject(helpers_1.formatCalculationResult(severeDoseResultHigh, 1), 0, 1)),
                titleTexts: 'result1'
            }
        };
    }
    return null;
};
var returnVisibleQuestions = function () {
    visibleQuestions.ageBaby = isAgeBabyVisible();
    visibleQuestions.weight = isWeightVisible();
    visibleQuestions.necroseYesNo = isNecroseYesNoVisible();
    visibleQuestions.noAnswerText = isNoAnswerVisible();
    visibleQuestions.extraMiniDose1 = isExtraMiniDosing1Visible();
    visibleQuestions.extraMiniDuration1 = isExtraMiniDosing1Visible();
    visibleQuestions.extraMiniWarning1 = isExtraMiniDosing1Visible();
    visibleQuestions.extraMiniDose2 = isExtraMiniDosing2Visible();
    visibleQuestions.extraMiniDuration2 = isExtraMiniDosing2Visible();
    visibleQuestions.extraMiniWarning2 = isExtraMiniDosing2Visible();
    visibleQuestions.miniDose1 = isMiniDosing1Visible();
    visibleQuestions.miniDuration1 = isMiniDosing1Visible();
    visibleQuestions.miniWarning1 = isMiniDosing1Visible();
    visibleQuestions.miniDose2 = isMiniDosing2Visible();
    visibleQuestions.miniDuration2 = isMiniDosing2Visible();
    visibleQuestions.miniWarning2 = isMiniDosing2Visible();
    visibleQuestions.newbornDose1 = isNewbornDosing1Visible();
    visibleQuestions.newbornDuration1 = isNewbornDosing1Visible();
    visibleQuestions.newbornWarning1 = isNewbornDosing1Visible();
    visibleQuestions.newbornDose2 = isNewbornDosing2Visible();
    visibleQuestions.newbornDuration2 = isNewbornDosing2Visible();
    visibleQuestions.newbornWarning2 = isNewbornDosing2Visible();
    visibleQuestions.kidsDose1 = isKidsDose1Visible();
    visibleQuestions.kidsDoseInterval = isKidsDose1IntervalVisible();
    visibleQuestions.kidsDuration1 = isKidsDosing1Visible();
    visibleQuestions.kidsDose2 = isKidsDose2Visible();
    visibleQuestions.kidsDose2Interval = isKidsDose2IntervalVisible();
    visibleQuestions.kidsDuration2 = isKidsDosing2Visible();
    visibleQuestions.adultsDose1 = isAdultsDose1Visible();
    visibleQuestions.adultsDose1interval = isAdultsDose1IntervalVisible();
    visibleQuestions.severeDose = isSevereDoseVisible();
    visibleQuestions.severeDoseInterval = isSevereDoseIntervalVisible();
    visibleQuestions.adultsDuration1 = isAdultsDosing1Visible();
    visibleQuestions.adultsDose2 = isAdultsDose2Visible();
    visibleQuestions.adultsDose2Interval = isAdultsDose2IntervalVisible();
    visibleQuestions.severeDose2 = isSevereDose2Visible();
    visibleQuestions.severeDose2Interval = isSevereDose2IntervalVisible();
    visibleQuestions.adultsDuration2 = isAdultsDosing2Visible();
    visibleQuestions.kidneyKids1 = !isNoAnswerVisible();
    visibleQuestions.anti = !isNoAnswerVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    visibleSections.noAnswer = isNoAnswerVisible();
    visibleSections.extraMiniDosing1 = isExtraMiniDosing1Visible();
    visibleSections.extraMiniDosing2 = isExtraMiniDosing2Visible();
    visibleSections.miniDosing1 = isMiniDosing1Visible();
    visibleSections.miniDosing2 = isMiniDosing2Visible();
    visibleSections.newbornDosing1 = isNewbornDosing1Visible();
    visibleSections.newbornDosing2 = isNewbornDosing2Visible();
    visibleSections.kidsDosing1 = isKidsDosing1Visible();
    visibleSections.kidsDosing2 = isKidsDosing2Visible();
    visibleSections.adultsDosing1 = isAdultsDosing1Visible();
    visibleSections.adultsDosing2 = isAdultsDosing2Visible();
    visibleSections.kidneyWarning = !isNoAnswerVisible();
    visibleSections.warningA = !isNoAnswerVisible();
    return visibleSections;
};
var isExportResultsEnabled = function () {
    return !isNoAnswerVisible();
};
var ut_formatTexts = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return {
        exportResultsEnabled: isExportResultsEnabled(),
        result: result,
        visibleQuestions: ut_visibleQuestions(),
        visibleSections: ut_visibleSections()
    };
});
