"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};


var visibleQuestions = {
    gender: true,
    age: false,
    smoking: false,
    bloodPressure: false,
    cholesterol: false
};
var visibleSections = {
    section1: true
};
var inputs = {
    gender: null,
    age: null,
    smoking: null,
    bloodPressure: null,
    cholesterol: null
};
var scoreMatrix = [
    [
        [
            [
                [2, 2, 3, 4],
                [1, 2, 2, 2],
                [1, 1, 1, 2],
                [1, 1, 1, 1],
            ],
            [
                [6, 7, 9, 10],
                [4, 5, 6, 7],
                [3, 4, 4, 5],
                [2, 2, 3, 3],
            ],
        ],
        [
            [
                [3, 4, 4, 5],
                [2, 3, 3, 4],
                [2, 2, 2, 2],
                [1, 1, 2, 2],
            ],
            [
                [8, 10, 11, 13],
                [6, 7, 8, 9],
                [4, 5, 6, 6],
                [3, 3, 4, 5],
            ],
        ],
        [
            [
                [5, 5, 6, 7],
                [3, 4, 4, 5],
                [3, 3, 3, 4],
                [2, 2, 2, 3],
            ],
            [
                [11, 13, 14, 16],
                [8, 9, 10, 12],
                [6, 7, 8, 9],
                [4, 5, 6, 6],
            ],
        ],
        [
            [
                [7, 8, 9, 10],
                [5, 6, 7, 7],
                [4, 4, 5, 5],
                [3, 3, 4, 4],
            ],
            [
                [15, 16, 18, 20],
                [11, 12, 14, 15],
                [8, 9, 10, 11],
                [6, 7, 8, 8],
            ],
        ],
        [
            [
                [11, 11, 12, 13],
                [8, 9, 9, 10],
                [6, 7, 7, 8],
                [5, 5, 6, 6],
            ],
            [
                [20, 21, 23, 25],
                [15, 16, 18, 19],
                [12, 13, 14, 15],
                [9, 10, 11, 11],
            ],
        ],
        [
            [
                [15, 16, 17, 18],
                [12, 13, 14, 14],
                [10, 10, 11, 11],
                [8, 8, 8, 9],
            ],
            [
                [26, 27, 29, 30],
                [21, 22, 23, 24],
                [16, 17, 18, 19],
                [13, 14, 14, 15],
            ],
        ],
        [
            [
                [21, 22, 24, 25],
                [17, 18, 19, 20],
                [14, 15, 16, 17],
                [11, 12, 13, 14],
            ],
            [
                [33, 35, 37, 39],
                [28, 29, 31, 33],
                [23, 24, 26, 27],
                [19, 20, 21, 22],
            ],
        ],
        [
            [
                [29, 31, 32, 34],
                [25, 27, 28, 29],
                [22, 23, 24, 25],
                [18, 19, 20, 22],
            ],
            [
                [41, 43, 45, 47],
                [35, 37, 39, 41],
                [31, 32, 34, 36],
                [26, 28, 29, 31],
            ],
        ],
        [
            [
                [40, 42, 44, 45],
                [36, 38, 39, 41],
                [32, 34, 36, 37],
                [29, 31, 32, 34],
            ],
            [
                [49, 51, 53, 55],
                [44, 46, 48, 50],
                [40, 42, 44, 46],
                [36, 38, 40, 41],
            ],
        ],
        [
            [
                [53, 55, 57, 58],
                [50, 52, 54, 55],
                [47, 49, 51, 52],
                [44, 46, 48, 50],
            ],
            [
                [58, 59, 61, 63],
                [55, 56, 58, 60],
                [52, 53, 55, 57],
                [49, 51, 52, 54],
            ],
        ],
    ],
    [
        [
            [
                [4, 5, 6, 7],
                [3, 3, 4, 5],
                [2, 2, 3, 4],
                [1, 2, 2, 3],
            ],
            [
                [8, 10, 13, 16],
                [6, 7, 9, 11],
                [4, 5, 7, 8],
                [3, 4, 5, 6],
            ],
        ],
        [
            [
                [5, 6, 8, 9],
                [4, 5, 6, 7],
                [3, 3, 4, 5],
                [2, 2, 3, 4],
            ],
            [
                [10, 13, 15, 18],
                [8, 9, 11, 14],
                [6, 7, 8, 10],
                [4, 5, 6, 7],
            ],
        ],
        [
            [
                [7, 8, 10, 11],
                [5, 6, 7, 9],
                [4, 5, 5, 6],
                [3, 3, 4, 5],
            ],
            [
                [13, 15, 18, 21],
                [10, 12, 14, 16],
                [7, 9, 10, 12],
                [6, 7, 8, 9],
            ],
        ],
        [
            [
                [9, 11, 12, 14],
                [7, 8, 10, 11],
                [6, 6, 7, 9],
                [4, 5, 6, 7],
            ],
            [
                [16, 19, 21, 24],
                [13, 15, 17, 19],
                [10, 11, 13, 15],
                [8, 9, 10, 12],
            ],
        ],
        [
            [
                [13, 13, 16, 18],
                [10, 11, 13, 14],
                [8, 9, 10, 11],
                [6, 7, 8, 9],
            ],
            [
                [20, 23, 25, 28],
                [16, 18, 20, 23],
                [13, 15, 16, 18],
                [10, 12, 13, 15],
            ],
        ],
        [
            [
                [17, 18, 20, 22],
                [14, 15, 16, 18],
                [11, 12, 13, 15],
                [9, 10, 11, 12],
            ],
            [
                [25, 28, 30, 32],
                [21, 23, 25, 27],
                [17, 19, 20, 22],
                [14, 15, 17, 18],
            ],
        ],
        [
            [
                [23, 25, 27, 29],
                [19, 20, 22, 24],
                [15, 17, 18, 20],
                [12, 14, 15, 16],
            ],
            [
                [33, 35, 38, 41],
                [27, 29, 32, 34],
                [22, 24, 26, 28],
                [18, 20, 22, 23],
            ],
        ],
        [
            [
                [28, 32, 35, 39],
                [24, 27, 31, 34],
                [21, 24, 27, 30],
                [18, 20, 23, 26],
            ],
            [
                [35, 39, 44, 48],
                [31, 34, 38, 43],
                [27, 30, 34, 37],
                [23, 26, 29, 33],
            ],
        ],
        [
            [
                [34, 40, 45, 51],
                [31, 36, 42, 47],
                [29, 33, 38, 44],
                [26, 30, 35, 40],
            ],
            [
                [38, 44, 50, 56],
                [35, 40, 46, 52],
                [32, 37, 42, 48],
                [29, 34, 39, 44],
            ],
        ],
        [
            [
                [42, 49, 57, 65],
                [40, 47, 55, 63],
                [38, 45, 53, 61],
                [36, 43, 51, 58],
            ],
            [
                [41, 49, 56, 65],
                [40, 47, 54, 62],
                [38, 45, 52, 60],
                [36, 43, 50, 58],
            ],
        ],
    ],
];
var getAgeIndex = function (age) {
    if (age <= 44) {
        return 0;
    }
    if (age >= 45 && age <= 49) {
        return 1;
    }
    if (age >= 50 && age <= 54) {
        return 2;
    }
    if (age >= 55 && age <= 59) {
        return 3;
    }
    if (age >= 60 && age <= 64) {
        return 4;
    }
    if (age >= 65 && age <= 69) {
        return 5;
    }
    if (age >= 70 && age <= 74) {
        return 6;
    }
    if (age >= 75 && age <= 79) {
        return 7;
    }
    if (age >= 80 && age <= 84) {
        return 8;
    }
    return 9;
};
var getBloodPressureIndex = function (bloodPressure) {
    if (bloodPressure === 'bloodPressure1') {
        return 3;
    }
    if (bloodPressure === 'bloodPressure2') {
        return 2;
    }
    if (bloodPressure === 'bloodPressure3') {
        return 1;
    }
    return 0;
};
var getCholesterolIndex = function (cholesterol) {
    if (cholesterol === 'cholesterol1') {
        return 0;
    }
    if (cholesterol === 'cholesterol2') {
        return 1;
    }
    if (cholesterol === 'cholesterol3') {
        return 2;
    }
    return 3;
};
var calculateScore = function () {
    var _a, _b;
    var genderIndex = ((_a = inputs.gender) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === 'gender2' ? 0 : 1;
    var ageIndex = getAgeIndex(inputs.age.currentPoints);
    var smokingIndex = ((_b = inputs.smoking) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === 'smoking1' ? 0 : 1;
    var bloodPressureIndex = getBloodPressureIndex(inputs.bloodPressure.currentIdentifier);
    var cholesterolIndex = getCholesterolIndex(inputs.cholesterol.currentIdentifier);
    return scoreMatrix[genderIndex][ageIndex][smokingIndex][bloodPressureIndex][cholesterolIndex];
};
var calculatePoints = function () {
    var _a;
    if (!isAnswerAllVisible()) {
        var scoreRisk = calculateScore();
        var vascularScore = 0;
        if (((_a = inputs.gender) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === 'gender1') {
            vascularScore = Math.log(scoreRisk / 0.0594) / 0.0762;
        }
        else {
            vascularScore = Math.log(scoreRisk / 0.0238) / 0.0885;
        }
        return helpers_1.returnToolScoreObject({
            resultById: 'result',
            title: [Math.round(vascularScore)],
            subtitle: [scoreRisk]
        });
    }
    return helpers_1.returnToolScoreObject({
        resultById: 'answerAll'
    });
};
var isAgeValid = function () {
    return helpers_1.numberInLimits({ input: inputs.age, min: 40, max: 89 });
};
var isAgeVisible = function () {
    return helpers_1.isAnswered(inputs.gender);
};
var isSmokingVisible = function () {
    return helpers_1.isAnswered(inputs.age) && isAgeValid();
};
var isBloodPressureVisible = function () {
    return helpers_1.isAnswered(inputs.smoking);
};
var isCholesterolVisible = function () {
    return helpers_1.isAnswered(inputs.bloodPressure);
};
var isAnswerAllVisible = function () {
    return !helpers_1.isAnswered(inputs.cholesterol);
};
var returnVisibleQuestions = function () {
    visibleQuestions.age = isAgeVisible();
    visibleQuestions.smoking = isSmokingVisible();
    visibleQuestions.bloodPressure = isBloodPressureVisible();
    visibleQuestions.cholesterol = isCholesterolVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_toolScore = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return !isAnswerAllVisible();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return __assign(__assign({}, result), { exportResultsEnabled: isExportResultsEnabled(), visibleQuestions: ut_visibleQuestions(), visibleSections: ut_visibleSections() });
});
