"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};


var visibleQuestions = {
    gender: true,
    age: false,
    smoking: false,
    bloodPressure: false,
    cholesterol: false
};
var visibleSections = {
    section1: true
};
var inputs = {
    gender: null,
    age: null,
    smoking: null,
    bloodPressure: null,
    cholesterol: null
};
var scoreMatrix = [
    [
        [
            [
                [2, 2, 3, 3],
                [1, 2, 2, 2],
                [1, 1, 1, 2],
                [1, 1, 1, 1],
            ],
            [
                [5, 5, 6, 7],
                [3, 4, 5, 5],
                [3, 3, 3, 4],
                [2, 2, 2, 3],
            ],
        ],
        [
            [
                [3, 3, 3, 4],
                [2, 2, 3, 3],
                [2, 2, 2, 2],
                [1, 1, 1, 2],
            ],
            [
                [6, 7, 8, 9],
                [5, 5, 6, 6],
                [3, 4, 4, 5],
                [3, 3, 3, 4],
            ],
        ],
        [
            [
                [4, 4, 5, 5],
                [3, 3, 4, 4],
                [2, 2, 3, 3],
                [2, 2, 2, 2],
            ],
            [
                [8, 8, 9, 10],
                [6, 6, 7, 8],
                [5, 5, 6, 6],
                [3, 4, 4, 5],
            ],
        ],
        [
            [
                [5, 6, 6, 7],
                [4, 4, 5, 5],
                [3, 3, 4, 4],
                [3, 3, 3, 3],
            ],
            [
                [10, 11, 11, 12],
                [8, 8, 9, 10],
                [6, 7, 7, 8],
                [5, 5, 6, 6],
            ],
        ],
        [
            [
                [7, 8, 8, 9],
                [6, 6, 7, 7],
                [5, 5, 5, 6],
                [4, 4, 4, 5],
            ],
            [
                [12, 13, 14, 15],
                [10, 11, 11, 12],
                [8, 9, 9, 10],
                [6, 7, 7, 8],
            ],
        ],
        [
            [
                [10, 10, 11, 12],
                [8, 9, 9, 9],
                [7, 7, 7, 8],
                [5, 6, 6, 6],
            ],
            [
                [15, 16, 17, 18],
                [13, 13, 14, 15],
                [10, 11, 12, 12],
                [9, 9, 9, 10],
            ],
        ],
        [
            [
                [13, 14, 15, 16],
                [11, 11, 12, 13],
                [9, 9, 10, 11],
                [7, 7, 8, 8],
            ],
            [
                [22, 23, 25, 26],
                [18, 19, 20, 22],
                [15, 16, 17, 18],
                [12, 13, 13, 14],
            ],
        ],
        [
            [
                [19, 20, 21, 23],
                [16, 17, 18, 19],
                [14, 15, 15, 16],
                [12, 12, 13, 14],
            ],
            [
                [27, 29, 30, 32],
                [24, 25, 26, 28],
                [20, 21, 22, 24],
                [17, 18, 19, 20],
            ],
        ],
        [
            [
                [27, 28, 30, 31],
                [24, 25, 27, 28],
                [21, 22, 24, 25],
                [19, 20, 21, 22],
            ],
            [
                [34, 35, 37, 39],
                [30, 32, 33, 35],
                [27, 28, 30, 31],
                [24, 25, 27, 28],
            ],
        ],
        [
            [
                [37, 39, 40, 42],
                [35, 36, 38, 39],
                [32, 34, 35, 37],
                [30, 32, 33, 34],
            ],
            [
                [41, 43, 44, 46],
                [39, 40, 42, 43],
                [36, 38, 39, 41],
                [34, 35, 37, 38],
            ],
        ],
    ],
    [
        [
            [
                [4, 5, 6, 7],
                [3, 4, 4, 5],
                [2, 3, 3, 4],
                [2, 2, 2, 3],
            ],
            [
                [8, 9, 11, 13],
                [6, 7, 8, 10],
                [4, 5, 6, 8],
                [3, 4, 5, 6],
            ],
        ],
        [
            [
                [5, 6, 7, 8],
                [4, 5, 5, 6],
                [3, 4, 4, 5],
                [2, 3, 3, 4],
            ],
            [
                [9, 11, 13, 15],
                [7, 8, 10, 12],
                [5, 7, 8, 9],
                [4, 5, 6, 7],
            ],
        ],
        [
            [
                [7, 8, 9, 10],
                [5, 6, 7, 8],
                [4, 5, 5, 6],
                [3, 4, 4, 5],
            ],
            [
                [11, 13, 15, 17],
                [9, 10, 12, 14],
                [7, 8, 9, 11],
                [5, 6, 7, 8],
            ],
        ],
        [
            [
                [9, 10, 11, 12],
                [7, 8, 9, 10],
                [5, 6, 7, 8],
                [4, 5, 6, 6],
            ],
            [
                [14, 16, 17, 20],
                [11, 13, 14, 16],
                [9, 10, 11, 13],
                [7, 8, 9, 10],
            ],
        ],
        [
            [
                [11, 12, 13, 15],
                [9, 10, 11, 12],
                [7, 8, 9, 10],
                [6, 7, 7, 8],
            ],
            [
                [17, 18, 20, 22],
                [14, 15, 17, 18],
                [11, 13, 14, 15],
                [9, 10, 11, 12],
            ],
        ],
        [
            [
                [14, 15, 17, 18],
                [12, 13, 14, 15],
                [10, 11, 12, 13],
                [8, 9, 10, 10],
            ],
            [
                [20, 22, 23, 25],
                [17, 18, 20, 21],
                [14, 15, 17, 18],
                [12, 13, 14, 15],
            ],
        ],
        [
            [
                [19, 21, 23, 25],
                [15, 17, 18, 20],
                [12, 13, 15, 16],
                [10, 11, 12, 13],
            ],
            [
                [28, 31, 34, 36],
                [23, 25, 28, 30],
                [19, 20, 22, 24],
                [15, 16, 18, 20],
            ],
        ],
        [
            [
                [24, 27, 31, 35],
                [21, 23, 27, 30],
                [17, 20, 23, 26],
                [15, 17, 19, 22],
            ],
            [
                [31, 35, 39, 44],
                [27, 30, 34, 38],
                [23, 26, 29, 33],
                [19, 22, 25, 29],
            ],
        ],
        [
            [
                [30, 35, 41, 47],
                [27, 32, 37, 43],
                [25, 29, 34, 40],
                [22, 26, 31, 36],
            ],
            [
                [34, 40, 46, 53],
                [31, 36, 42, 48],
                [28, 33, 38, 44],
                [25, 30, 35, 40],
            ],
        ],
        [
            [
                [37, 45, 53, 62],
                [36, 43, 51, 59],
                [34, 41, 49, 57],
                [32, 39, 47, 55],
            ],
            [
                [37, 45, 53, 61],
                [35, 43, 51, 59],
                [34, 41, 48, 57],
                [32, 39, 46, 55],
            ],
        ],
    ],
];
var getAgeIndex = function (age) {
    if (age <= 44) {
        return 0;
    }
    if (age >= 45 && age <= 49) {
        return 1;
    }
    if (age >= 50 && age <= 54) {
        return 2;
    }
    if (age >= 55 && age <= 59) {
        return 3;
    }
    if (age >= 60 && age <= 64) {
        return 4;
    }
    if (age >= 65 && age <= 69) {
        return 5;
    }
    if (age >= 70 && age <= 74) {
        return 6;
    }
    if (age >= 75 && age <= 79) {
        return 7;
    }
    if (age >= 80 && age <= 84) {
        return 8;
    }
    return 9;
};
var getBloodPressureIndex = function (bloodPressure) {
    if (bloodPressure === 'bloodPressure1') {
        return 3;
    }
    if (bloodPressure === 'bloodPressure2') {
        return 2;
    }
    if (bloodPressure === 'bloodPressure3') {
        return 1;
    }
    return 0;
};
var getCholesterolIndex = function (cholesterol) {
    if (cholesterol === 'cholesterol1') {
        return 0;
    }
    if (cholesterol === 'cholesterol2') {
        return 1;
    }
    if (cholesterol === 'cholesterol3') {
        return 2;
    }
    return 3;
};
var calculateScore = function () {
    var _a, _b;
    var genderIndex = ((_a = inputs.gender) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === 'gender2' ? 0 : 1;
    var ageIndex = getAgeIndex(inputs.age.currentPoints);
    var smokingIndex = ((_b = inputs.smoking) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === 'smoking1' ? 0 : 1;
    var bloodPressureIndex = getBloodPressureIndex(inputs.bloodPressure.currentIdentifier);
    var cholesterolIndex = getCholesterolIndex(inputs.cholesterol.currentIdentifier);
    return scoreMatrix[genderIndex][ageIndex][smokingIndex][bloodPressureIndex][cholesterolIndex];
};
var calculatePoints = function () {
    var _a;
    if (!isAnswerAllVisible()) {
        var scoreRisk = calculateScore();
        var vascularScore = 0;
        if (((_a = inputs.gender) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === 'gender1') {
            vascularScore = Math.log(scoreRisk / 0.1261) / 0.064;
        }
        else {
            vascularScore = Math.log(scoreRisk / 0.0403) / 0.0763;
        }
        return helpers_1.returnToolScoreObject({
            resultById: 'result',
            title: [Math.round(vascularScore)],
            subtitle: [scoreRisk]
        });
    }
    return helpers_1.returnToolScoreObject({
        resultById: 'answerAll'
    });
};
var isAgeValid = function () {
    return helpers_1.numberInLimits({ input: inputs.age, min: 40, max: 89 });
};
var isAgeVisible = function () {
    return helpers_1.isAnswered(inputs.gender);
};
var isSmokingVisible = function () {
    return helpers_1.isAnswered(inputs.age) && isAgeValid();
};
var isBloodPressureVisible = function () {
    return helpers_1.isAnswered(inputs.smoking);
};
var isCholesterolVisible = function () {
    return helpers_1.isAnswered(inputs.bloodPressure);
};
var isAnswerAllVisible = function () {
    return !helpers_1.isAnswered(inputs.cholesterol);
};
var returnVisibleQuestions = function () {
    visibleQuestions.age = isAgeVisible();
    visibleQuestions.smoking = isSmokingVisible();
    visibleQuestions.bloodPressure = isBloodPressureVisible();
    visibleQuestions.cholesterol = isCholesterolVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_toolScore = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return !isAnswerAllVisible();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return __assign(__assign({}, result), { exportResultsEnabled: isExportResultsEnabled(), visibleQuestions: ut_visibleQuestions(), visibleSections: ut_visibleSections() });
});
