"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};


var visibleQuestions = {
    gender: true,
    age: false,
    smoking: false,
    bloodPressure: false,
    cholesterol: false
};
var visibleSections = {
    section1: true
};
var inputs = {
    gender: null,
    age: null,
    smoking: null,
    bloodPressure: null,
    cholesterol: null
};
var scoreMatrix = [
    [
        [
            [
                [5, 6, 7, 8],
                [4, 4, 5, 6],
                [3, 3, 3, 4],
                [2, 2, 2, 3],
            ],
            [
                [13, 15, 17, 19],
                [9, 11, 12, 14],
                [7, 8, 9, 10],
                [5, 6, 6, 7],
            ],
        ],
        [
            [
                [7, 8, 9, 10],
                [5, 6, 7, 8],
                [4, 4, 5, 6],
                [3, 3, 4, 4],
            ],
            [
                [16, 18, 21, 23],
                [12, 14, 15, 17],
                [9, 10, 12, 13],
                [7, 8, 9, 10],
            ],
        ],
        [
            [
                [10, 11, 12, 14],
                [8, 9, 9, 11],
                [6, 6, 7, 8],
                [4, 5, 5, 6],
            ],
            [
                [21, 23, 25, 28],
                [16, 18, 19, 22],
                [12, 13, 15, 17],
                [9, 10, 11, 13],
            ],
        ],
        [
            [
                [14, 15, 17, 18],
                [11, 12, 13, 14],
                [8, 9, 10, 11],
                [7, 7, 8, 9],
            ],
            [
                [26, 28, 31, 33],
                [21, 23, 24, 26],
                [16, 18, 19, 21],
                [13, 14, 15, 16],
            ],
        ],
        [
            [
                [20, 21, 22, 24],
                [16, 17, 18, 19],
                [12, 13, 14, 15],
                [10, 11, 11, 12],
            ],
            [
                [33, 35, 37, 39],
                [27, 29, 30, 32],
                [22, 23, 25, 26],
                [17, 18, 20, 21],
            ],
        ],
        [
            [
                [27, 28, 30, 31],
                [22, 23, 24, 26],
                [18, 19, 20, 21],
                [15, 16, 16, 17],
            ],
            [
                [41, 42, 44, 46],
                [34, 36, 37, 39],
                [28, 30, 31, 33],
                [23, 24, 26, 27],
            ],
        ],
        [
            [
                [37, 38, 39, 41],
                [33, 34, 35, 36],
                [29, 30, 31, 32],
                [26, 27, 28, 29],
            ],
            [
                [48, 49, 51, 52],
                [43, 44, 46, 47],
                [39, 40, 41, 43],
                [34, 36, 37, 38],
            ],
        ],
        [
            [
                [44, 46, 47, 48],
                [41, 42, 43, 45],
                [37, 39, 40, 41],
                [34, 35, 36, 37],
            ],
            [
                [53, 55, 56, 58],
                [49, 51, 52, 53],
                [46, 47, 48, 49],
                [42, 43, 44, 46],
            ],
        ],
        [
            [
                [53, 54, 55, 57],
                [50, 51, 52, 54],
                [47, 48, 49, 51],
                [44, 45, 47, 48],
            ],
            [
                [59, 60, 62, 63],
                [56, 57, 59, 60],
                [53, 54, 56, 57],
                [50, 51, 53, 54],
            ],
        ],
        [
            [
                [62, 63, 64, 65],
                [60, 61, 62, 63],
                [58, 59, 60, 61],
                [56, 57, 58, 60],
            ],
            [
                [65, 66, 67, 68],
                [63, 64, 65, 66],
                [61, 62, 63, 65],
                [59, 60, 61, 63],
            ],
        ],
    ],
    [
        [
            [
                [7, 9, 11, 13],
                [5, 6, 8, 10],
                [4, 5, 6, 7],
                [3, 4, 4, 5],
            ],
            [
                [14, 17, 20, 24],
                [11, 13, 16, 19],
                [8, 10, 12, 14],
                [6, 7, 9, 11],
            ],
        ],
        [
            [
                [9, 11, 13, 16],
                [7, 8, 10, 12],
                [5, 6, 8, 9],
                [4, 5, 6, 7],
            ],
            [
                [17, 20, 24, 28],
                [13, 16, 18, 22],
                [10, 12, 14, 17],
                [8, 9, 11, 13],
            ],
        ],
        [
            [
                [12, 14, 16, 19],
                [10, 11, 13, 15],
                [7, 9, 10, 12],
                [6, 7, 8, 9],
            ],
            [
                [21, 24, 28, 31],
                [17, 19, 22, 25],
                [13, 15, 17, 20],
                [10, 12, 14, 16],
            ],
        ],
        [
            [
                [16, 18, 20, 23],
                [13, 14, 16, 18],
                [10, 11, 13, 15],
                [8, 9, 10, 12],
            ],
            [
                [25, 28, 32, 35],
                [21, 23, 26, 29],
                [17, 19, 21, 24],
                [13, 15, 17, 19],
            ],
        ],
        [
            [
                [20, 23, 25, 27],
                [17, 19, 20, 22],
                [14, 15, 17, 18],
                [11, 12, 14, 15],
            ],
            [
                [31, 33, 36, 40],
                [25, 28, 31, 33],
                [21, 23, 25, 28],
                [17, 19, 21, 23],
            ],
        ],
        [
            [
                [26, 28, 30, 32],
                [22, 24, 26, 27],
                [18, 20, 21, 23],
                [15, 17, 18, 19],
            ],
            [
                [36, 39, 42, 44],
                [31, 33, 36, 38],
                [26, 28, 30, 33],
                [22, 24, 26, 28],
            ],
        ],
        [
            [
                [35, 37, 39, 40],
                [32, 33, 35, 36],
                [28, 30, 31, 33],
                [25, 26, 28, 29],
            ],
            [
                [43, 45, 47, 49],
                [39, 41, 42, 44],
                [35, 36, 38, 40],
                [31, 33, 34, 36],
            ],
        ],
        [
            [
                [40, 42, 45, 48],
                [37, 39, 42, 44],
                [34, 36, 39, 41],
                [31, 33, 36, 38],
            ],
            [
                [45, 48, 51, 54],
                [42, 44, 47, 50],
                [39, 41, 44, 47],
                [36, 38, 41, 43],
            ],
        ],
        [
            [
                [44, 48, 52, 56],
                [42, 46, 49, 53],
                [40, 43, 47, 51],
                [38, 41, 45, 48],
            ],
            [
                [47, 51, 55, 59],
                [45, 49, 52, 56],
                [43, 46, 50, 54],
                [40, 44, 48, 51],
            ],
        ],
        [
            [
                [49, 54, 59, 64],
                [48, 53, 58, 63],
                [47, 52, 56, 61],
                [46, 50, 55, 60],
            ],
            [
                [49, 54, 59, 64],
                [48, 53, 58, 63],
                [47, 52, 56, 61],
                [46, 50, 55, 60],
            ],
        ],
    ],
];
var getAgeIndex = function (age) {
    if (age <= 44) {
        return 0;
    }
    if (age >= 45 && age <= 49) {
        return 1;
    }
    if (age >= 50 && age <= 54) {
        return 2;
    }
    if (age >= 55 && age <= 59) {
        return 3;
    }
    if (age >= 60 && age <= 64) {
        return 4;
    }
    if (age >= 65 && age <= 69) {
        return 5;
    }
    if (age >= 70 && age <= 74) {
        return 6;
    }
    if (age >= 75 && age <= 79) {
        return 7;
    }
    if (age >= 80 && age <= 84) {
        return 8;
    }
    return 9;
};
var getBloodPressureIndex = function (bloodPressure) {
    if (bloodPressure === 'bloodPressure1') {
        return 3;
    }
    if (bloodPressure === 'bloodPressure2') {
        return 2;
    }
    if (bloodPressure === 'bloodPressure3') {
        return 1;
    }
    return 0;
};
var getCholesterolIndex = function (cholesterol) {
    if (cholesterol === 'cholesterol1') {
        return 0;
    }
    if (cholesterol === 'cholesterol2') {
        return 1;
    }
    if (cholesterol === 'cholesterol3') {
        return 2;
    }
    return 3;
};
var calculateScore = function () {
    var _a, _b;
    var genderIndex = ((_a = inputs.gender) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === 'gender2' ? 0 : 1;
    var ageIndex = getAgeIndex(inputs.age.currentPoints);
    var smokingIndex = ((_b = inputs.smoking) === null || _b === void 0 ? void 0 : _b.currentIdentifier) === 'smoking1' ? 0 : 1;
    var bloodPressureIndex = getBloodPressureIndex(inputs.bloodPressure.currentIdentifier);
    var cholesterolIndex = getCholesterolIndex(inputs.cholesterol.currentIdentifier);
    return scoreMatrix[genderIndex][ageIndex][smokingIndex][bloodPressureIndex][cholesterolIndex];
};
var calculatePoints = function () {
    var _a;
    if (!isAnswerAllVisible()) {
        var scoreRisk = calculateScore();
        var vascularScore = 0;
        if (((_a = inputs.gender) === null || _a === void 0 ? void 0 : _a.currentIdentifier) === 'gender1') {
            vascularScore = Math.log(scoreRisk / 0.2462) / 0.0634;
        }
        else {
            vascularScore = Math.log(scoreRisk / 0.0942) / 0.0774;
        }
        return helpers_1.returnToolScoreObject({
            resultById: 'result',
            title: [Math.round(vascularScore)],
            subtitle: [scoreRisk]
        });
    }
    return helpers_1.returnToolScoreObject({
        resultById: 'answerAll'
    });
};
var isAgeValid = function () {
    return helpers_1.numberInLimits({ input: inputs.age, min: 40, max: 89 });
};
var isAgeVisible = function () {
    return helpers_1.isAnswered(inputs.gender);
};
var isSmokingVisible = function () {
    return helpers_1.isAnswered(inputs.age) && isAgeValid();
};
var isBloodPressureVisible = function () {
    return helpers_1.isAnswered(inputs.smoking);
};
var isCholesterolVisible = function () {
    return helpers_1.isAnswered(inputs.bloodPressure);
};
var isAnswerAllVisible = function () {
    return !helpers_1.isAnswered(inputs.cholesterol);
};
var returnVisibleQuestions = function () {
    visibleQuestions.age = isAgeVisible();
    visibleQuestions.smoking = isSmokingVisible();
    visibleQuestions.bloodPressure = isBloodPressureVisible();
    visibleQuestions.cholesterol = isCholesterolVisible();
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_toolScore = function () {
    return calculatePoints();
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return !isAnswerAllVisible();
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return __assign(__assign({}, result), { exportResultsEnabled: isExportResultsEnabled(), visibleQuestions: ut_visibleQuestions(), visibleSections: ut_visibleSections() });
});
