"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};


var visibleQuestions = {
    clinicalSignsDVT: true,
    pulmonaryEmbolismDiagnosis: true,
    heartRate: true,
    immobilization: true,
    objectivelyDiagnosed: true,
    hemoptysis: true,
    malignancyWithTreatment: true
};
var visibleSections = {
    patientInfo: true
};
var inputs = {
    clinicalSignsDVT: null,
    pulmonaryEmbolismDiagnosis: null,
    heartRate: null,
    immobilization: null,
    objectivelyDiagnosed: null,
    hemoptysis: null,
    malignancyWithTreatment: null
};
var calculatePoints = function () {
    var result = 0;
    result =
        Number(inputs.clinicalSignsDVT.currentPoints) +
            Number(inputs.pulmonaryEmbolismDiagnosis.currentPoints) +
            Number(inputs.heartRate.currentPoints) +
            Number(inputs.immobilization.currentPoints) +
            Number(inputs.objectivelyDiagnosed.currentPoints) +
            Number(inputs.hemoptysis.currentPoints) +
            Number(inputs.malignancyWithTreatment.currentPoints);
    var score = helpers_1.formatCalculationResult(result, 1);
    return helpers_1.returnToolScoreObject({ number: score, range: score });
};
var returnVisibleQuestions = function () {
    return visibleQuestions;
};
var returnVisibleSections = function () {
    return visibleSections;
};
var ut_visibleQuestions = function () {
    return returnVisibleQuestions();
};
var ut_visibleSections = function () {
    return returnVisibleSections();
};
var ut_toolScore = function () {
    return calculatePoints();
};
var ut_exportResultsEnabled = function () {
    return isExportResultsEnabled();
};
var isExportResultsEnabled = function () {
    return true;
};
exports["default"] = (function (props) {
    Object.keys(props).forEach(function (propName) {
        inputs[propName] = props[propName];
    });
    var result = calculatePoints();
    return __assign(__assign({ exportResultsEnabled: isExportResultsEnabled() }, result), { visibleQuestions: ut_visibleQuestions(), visibleSections: ut_visibleSections() });
});
